<?php
/**
 * @package
 * @subpackage
 * @author Nick Loeve <nick@basesoft.com>
 * @since 27/03/2007
 * @copyright 2006 BaseSoft B.V.
 * $Id$
 */
$noValidate = true;
$site_homedir = './';
define('NO_BROWSER_CHECK', true);
require_once('scripts/i-w/default/init.php');

$sxml = simplexml_load_string(file_get_contents(SITE_HOMEDIR.'scripts/elc/bots/WEEEBlackboxAccountant.wsdl'));

?>
<html>
<head>
<title>WEEEBlackbox Soap Server</title>
</head>
<style>

body, table, td, th, caption {
	font-family: sans-serif, Verdana, Arial, Helvetica;
	font-size: 10pt;
	text-align: left;
	vertical-align: top;
}

body {
	background: #ffffff;
}

pre {
	margin-top: 0;
	margin-bottom: 0;
	padding: 0.5em;
	font-family: monospace, "Courier New";
	color: #000000;
	font-size: 10pt;
	overflow: auto;
	background: #eeeeee;
}

div.docblock {
	padding: 10px;
	margin: 10px;
}

h2 {
	background-color: #7a5ada;
	padding-top: 0.4em;
	padding-bottom: 0.4em;
	padding-left: 1.0em;
	padding-right: 1.0em;
	color: white;
	text-align: left;
	clear: both;
	font-size: 12pt;
}

h1 {
	background-color: #7a5ada;
	padding-top: 0.4em;
	padding-bottom: 0.4em;
	padding-left: 1.0em;
	padding-right: 1.0em;
	color: white;
	text-align: left;
	clear: both;
	font-size: 14pt;
}

.tableinfo {
	padding-left: 1.0em;
	padding-right: 1.0em;
	padding-top: 0.2em;
	padding-bottom: 0.2em;
	font-size: 0.75em;
	background: #ddddff;
	font-weight: bold;
	font-family: sans-serif, Verdana, Arial, Helvetica;
	vertical-align: top;
}

.ntable {
	padding: 0em;
	margin-top: 0.5em;
	margin-bottom: 0.5em;
}

.infohead {
	font-size: 0.80em;
	font-family: sans-serif, Verdana, Arial, Helvetica;
	/*	padding: 0.25em; */
	padding-top: 0.2em;
	padding-bottom: 0.2em;
	padding-left: 1.0em;
	padding-right: 1.0em;
	margin-left: 1.0em;
	color: #ffffff;
	background-color: #7a5ada;
	font-weight: bold;
}

caption {
font-weight: bold;
font-size: 11pt;
}

table.args {
	border: 1px outset #aaa;
	min-width: 500px;
	margin: 10px;
}

tr.tr_0 {
	background-color: #fff;
}

tr.tr_1 {
	background-color: #f4f4f4;
}

.type {
	color: #555;
}

.doc {
	color: #333;
}

p {
margin: 5px;
}

</style>
<body>
<?php


function printArgsTable($argType, $methodName, $caption) {
	global $sxml;

	$inputs = $sxml->xpath(sprintf("//wsdl:operation[@name='%s']/wsdl:$argType", $methodName));
	$inputAttrs = $inputs[0]->attributes();
	$inputMessage = substr($inputAttrs['message'], 4); // strip "tns:"
	$xpath = sprintf('//wsdl:message[@name="%s"]/wsdl:part', $inputMessage);

	printTable($caption, $xpath);
}

function printTable($caption, $xpath) {

	global $sxml;

	$inputParts = $sxml->xpath($xpath);

	echo "<table class='args'>";
	echo $caption ? "<caption>$caption</caption>" : '';
	echo '<tr><th style="width: 30%;">Name</th><th >Type</th></tr>';
	foreach ($inputParts as $i => $inputPart) {
		$attrs = $inputPart->attributes();

		$type =  $attrs['type'];
		$name = $attrs['name'];
		if (substr($type, 0, 4) == 'tns:') {
			$type = substr($type, 4);
			$stype = '<a href="#type:'.$type.'">'.$type.'</a>';
		}
		else {
			$stype = '<i class="type">'.$type.'</i>';
		}

		$tr_i = $i % 2;
		echo "<tr class=\"tr_$tr_i\">";

		echo "<td>".$name."</td>";
		echo "<td>".$stype;

		printDocumentation($xpath.sprintf("/../*[@name='%s']/wsdl:documentation", $name));
		printDocumentation($xpath.sprintf("/../*[@name='%s']//xsd:documentation", $name));

		if (substr($attrs['type'], 0, 4) == 'tns:') {
			printTable(null, sprintf("//xsd:complexType[@name='%s']//xsd:element", $type));
		}
		echo '</td>';

		echo "</tr>";
	}
	echo "</table>";
}

function printDocumentation($xpath) {
	//echo "$xpath\n";

	echo '<div class="doc">';

	global $sxml;
	$docs = $sxml->xpath($xpath);
	if($docs && count($docs) > 0) {
		foreach ($docs as $doc) {
			$childs= $doc->children();
			foreach ($childs as $child) {
				echo $child->asXml();
			}
		}
	}

	echo '</div>';
}

// wsdl global doc
printDocumentation('/wsdl:definitions/wsdl:documentation');

// methods
echo '<div class="docblock">';
echo '<h1>Methods</h1>';
foreach($sxml->xpath('//wsdl:portType//wsdl:operation') as $operation)
{
	echo '<div class="docblock">';

	$attrs = $operation->attributes();
	$name = $attrs['name'];
	echo '<h2>'.$name.'</h2>';

	printDocumentation(sprintf("//wsdl:operation[@name='%s']/wsdl:documentation", $name));

	printArgsTable('input', $name, 'Input Arguments');
	printArgsTable('output', $name, 'Return Values');

	echo '</div>';

}
echo '</div>';

// types
echo '<div class="docblock">';
echo '<h1>Types</h1>';
foreach($sxml->xpath('//xsd:complexType') as $operation)
{
	echo '<div class="docblock">';

	$attrs = $operation->attributes();
	$name = $attrs['name'];
	echo '<h2><a name="type:'.$name.'">'.$name.'</a></h2>';

	printDocumentation(sprintf("//xsd:complexType[@name='%s']/xsd:annotation/xsd:documentation", $name));
	printTable("Parts", sprintf("//xsd:complexType[@name='%s']//xsd:element", $name));


	echo '</div>';

}
echo '</div>';



echo '</body></html>';
?>