<?php
/*
 * @date Nov 30, 2007
 * @author Nicoleta Militaru <nicoleta@basesoft.com>
 * @version $Id$
 * @copyright 2006 BaseSoft B.V.s
 */
 
 class AdminIP extends AbstractObject
{
	public $id;
	public $ip_address;
	public $ip_identificatie;
		
	function set($id=null)
	{
		$id || $id = $this->id;
		$sql = "SELECT IP_ID, IP_ADDRESS,IP_IDENTIFICATIE
			FROM TBL_ADMIN_IP 
			WHERE IP_ID = ?";
		$q = $this->db->query($sql);
		$q->bind_values($id);
		$q->execute();
		if(!($r = $q->fetch()))
			return false;
		$this->ip_address = $r->IP_ADDRESS;
		$this->ip_identificatie = $r->IP_IDENTIFICATIE;
		return true;
	}
	function getOverview($id=null)
	{
		$sql = "SELECT '' as CHECKBOX, IP_ID AS ID, IP_ADDRESS,IP_IDENTIFICATIE as DESCRIPTION
			FROM TBL_ADMIN_IP ";
		if($id != null)
			$sql .= " WHERE IP_ID = ?";
		$sql .= " ORDER BY IP_ID";
		$q = $this->db->query($sql);
		if($id != null)
			$q->bind_values($id);
		$q->execute();
		return $q;
	}
	function insert($graceful=false)
	{
		return parent::insert($graceful);
	}
	
	function update($id=null)
	{
		$this->id = isset($id)?$id:$this->id;
		return parent::update();
	}
	function delete($id=null)
	{
		$id = isset($id)?$id:$this->id;
		$sql = "DELETE FROM TBL_ADMIN_IP WHERE IP_ID=?";
		$q = $this->db->query($sql);
		$q->bind_values($id);
		$q->execute();
		return true;
	}
	function _initObjectMaps()
	{
		$this->objectmap['dbtable'] = 'TBL_ADMIN_IP';
		$this->objectmap['primary']['id'] = 'IP_ID';
		$this->objectmap['properties']['ip_address'] = 'IP_ADDRESS';
		$this->objectmap['properties']['ip_identificatie'] = 'IP_IDENTIFICATIE';
	}
}
?>