<?php
require_once(IWARE.'AbstractObject.php');
/**
 * @author Chris Wesseling <chris.wesseling@xs4all.nl>
 * @package ELC
 * @version $Id$
 */
class CRSOGLAccount extends AbstractObject
{
	var $crso;
	var $declaration_type;
	var $gl_account;

	/**
	 * Returns G/L Accountcodes.
	 * if no param is given.. Returns them all for this crso
	 * @param Array $aDtypes Array of DeclarationTypes... Check only those types
	 * @return Array DeclarationTypeId=>'G/L Account No.'
	 */
	function getAccounts($aDtypes=null)
	{
		$typeids = $rv = array();
		$sql = 'SELECT DECLARATION_TYPE_ID as `k`,
				GL_ACCOUNT as `v`
			FROM TBL_CRSO_GLACCOUNT
			WHERE CRSO_RELATION_ID = ?';

		if ( is_array($aDtypes) )
			foreach ( $aDtypes as $dtype )
				$typeids[] = (int) $dtype->id;
		if ( !empty($typeids) )
			$sql .= ' AND DECLARATION_TYPE_ID IN ('.implode(',', $typeids).')';

		$q = $this->db->query($sql);
		$q->bind_values($this->crso->relation->id);
		$q->execute();
		while ( $r = $q->fetch() )
			$rv[$r->k] = $r->v;
		return $rv;
	}

	/**#@+
	 * @access private
	 */
	function _initObjectMaps()
	{
		$this->objectmap['dbtable'] = 'TBL_CRSO_GLACCOUNT';
		$this->objectmap['updatetype'] = 'REPLACE';
		$this->objectmap['primary']['crso->relation->id'] = 'CRSO_RELATION_ID';
		$this->objectmap['primary']['declaration_type->id'] = 'DECLARATION_TYPE_ID';
		$this->objectmap['properties']['gl_account'] = 'GL_ACCOUNT';
	}
	/**#@-*/
}
?>
