<?php
require_once(IWARE.'AbstractObject.php');
/**
 * @package WEEE
 * @subpackage CRSOParticipant
 * @since 30-nov-2006
 * @author Marten Koedam <marten@dalines.net>
 * @version $Id$
 * @copyright 2006 BaseSoft B.V.
 */
class CRSOParticipant extends AbstractObject
{
	var $crso;
	var $participant;
	var $producer_reg_no;

	function set($crso_id=null,$participant_id=null)
	{
		$crso_id || $crso_id = $this->crso->relation->id;
		$participant_id || $participant_id = $this->participant->relation->id;

		$sql = "SELECT PRODUCER_REG_NO
			FROM TBL_CRSO_PARTICIPANT
			WHERE CRSO_RELATION_ID = ?
				AND PARTICIPANT_RELATION_ID = ?";
		$q = $this->db->query($sql);
		$q->bind_values($crso_id,$participant_id);
		$q->execute();
		if(!($r = $q->fetch()))
			return false;

		require_once(ELC_CLASSES.'CRSO.php');
		require_once(ELC_CLASSES.'Participant.php');
		$this->crso = new CRSO($this->db,array('relation'=>new Relation($this->db,$crso_id)));
		$this->participant = new Participant($this->db,array('relation'=>new Relation($this->db,$participant_id)));
		$this->producer_reg_no = $r->PRODUCER_REG_NO;

		return $this->complete = true;
	}

	function hasCorrectPRN($prn='')
	{
		if($prn == '')
			$prn = (isset($this->producer_reg_no))?$this->producer_reg_no:false;
		if(!$prn)
			return false;
		//this is from XSD Schema - Producer Registration V2.0.xsd
		$pattern = '/^((WEE\/)[A-Z]{2}[0-9]{4}[A-Z]{2})?$/';
		if(preg_match($pattern,$prn) == 0)
			return false;
		return true;

	}

	function _initObjectMaps()
	{
		$this->objectmap['dbtable'] = 'TBL_CRSO_PARTICIPANT';
		$this->objectmap['primary']['crso->relation->id'] = 'CRSO_RELATION_ID';
		$this->objectmap['primary']['participant->relation->id'] = 'PARTICIPANT_RELATION_ID';
		$this->objectmap['properties']['producer_reg_no'] = 'PRODUCER_REG_NO';
		$this->objectmap['inserttype'] = 'REPLACE';
	}
}
?>
