<?php
require_once(IWARE.'AbstractObject.php');
/**
 * @author Marten Koedam <marten@basesoft.com>
 * @author Martijn van den Broek <martijn@basesoft.com>
 * @package I-Ware
 * @version $Id$
 */
class CRSOParticipantDocument extends AbstractObject
{
	/**
	 * @var CRSO
	 */
	var $crso;
	/**
	 * @var Participant
	 */
	var $participant;
	/**
	 * @var Document
	 */
	var $document;
	/**
	 * @access private
	 */

	function getDocuments()
	{
		$sql = "SELECT d.DOCUMENT_ID
			FROM TBL_DOCUMENT d
				INNER JOIN TBL_CRSO_PARTICIPANT_DOCUMENT cpd ON d.DOCUMENT_ID=cpd.DOCUMENT_ID
			WHERE cpd.PARTICIPANT_RELATION_ID=?
			AND cpd.CRSO_RELATION_ID=?";

		$q = $this->db->query($sql);
		$q->bind_values($this->participant->relation->id, $this->crso->relation->id);
		$q->execute();

		require_once(ELC_CLASSES.'Document.php');

		$rv = array();
		while ($row = $q->fetch())
		{
			$d = new ELCDocument($this->db);
			$d->set($row->DOCUMENT_ID);
			$rv[] = &$d;
		}

		return $rv;
	}

	function _initObjectMaps()
	{
		$this->objectmap['dbtable'] = 'TBL_CRSO_PARTICIPANT_DOCUMENT';
		$this->objectmap['primary']['crso->relation->id'] = 'CRSO_RELATION_ID';
		$this->objectmap['primary']['participant->relation->id'] = 'PARTICIPANT_RELATION_ID';
		$this->objectmap['primary']['document->id'] = 'DOCUMENT_ID';
	}
}
?>
