<?php
require_once(IWARE.'AbstractObject.php');
/**
 * @author Marten Koedam <marten@basesoft.com>
 * @package ELC
 * @version $Id$
 */
class CRSOPublicDocument extends AbstractObject
{
	/**
	 *
	 */
	var $document;
	/**
	 *
	 */
	var $public_document;
	/**
	 *
	 */
	var $crso;
	/**
	 *
	 */
	function set($crso_id='',$public_document_id='')
	{
		$crso_id || $crso_id = $this->crso->relation->id;
		$public_document_id || $public_document_id = $this->public_document->id;

		$sql = "SELECT DOCUMENT_ID
			FROM TBL_CRSO_PUBLIC_DOCUMENT
			WHERE CRSO_RELATION_ID = ?
				AND PUBLIC_DOCUMENT_ID = ?";
		$q = $this->db->query($sql);
		$q->bind_values($crso_id,$public_document_id);
		$q->execute();
		if(!($r = $q->fetch()))
			return false;

		require_once(ELC_CLASSES.'CRSO.php');
		require_once(ELC_CLASSES.'Document.php');
		require_once(ELC_CLASSES.'PublicDocument.php');

		$this->crso = new CRSO($this->db, array('relation'=>new Relation($this->db,$crso_id)));
		$this->document = new Document($this->db,$r->DOCUMENT_ID);
		$this->public_document = new PublicDocument($this->db,$public_document_id);

		return $this->complete = true;
	}
	/**
	 *
	 */
	function getOverview($crso_id='')
	{
		$crso_id || $crso_id = $this->crso->relation->id;
		$sql = "SELECT '' as CHECKBOX, PD.PUBLIC_DOCUMENT_ID, PD.`NAME` as PUBLIC_DOCUMENT_NAME,
				IFNULL(D.`NAME`, '') as DOCUMENT_NAME, '' as UPLOAD
			FROM TBL_PUBLIC_DOCUMENT as PD
			LEFT JOIN TBL_CRSO_PUBLIC_DOCUMENT as CPD
				ON PD.PUBLIC_DOCUMENT_ID = CPD.PUBLIC_DOCUMENT_ID
					AND CPD.CRSO_RELATION_ID = ?
			LEFT JOIN TBL_DOCUMENT as D
				USING(DOCUMENT_ID)
			ORDER BY PD.`NAME`";
		$q = $this->db->query($sql);
		$q->bind_values($crso_id);
		$q->execute();
		return $q;
	}
	/**
	 *
	 */
	function getPublicOverview($crso_id='')
	{
		$crso_id || $crso_id = $this->crso->relation->id;
		$sql = "SELECT D.DOCUMENT_ID, PD.`NAME` as PUBLIC_DOCUMENT_NAME,
				IFNULL(D.`NAME`, '') as DOCUMENT_NAME
			FROM TBL_PUBLIC_DOCUMENT as PD
			INNER JOIN TBL_CRSO_PUBLIC_DOCUMENT as CPD
				ON PD.PUBLIC_DOCUMENT_ID = CPD.PUBLIC_DOCUMENT_ID
					AND CPD.CRSO_RELATION_ID = ?
			INNER JOIN TBL_DOCUMENT as D
				USING(DOCUMENT_ID)
			ORDER BY PD.`NAME`";
		$q = $this->db->query($sql);
		$q->bind_values($crso_id);
		$q->execute();
		return $q;
	}
	/**
	 *
	 */
	function delete($crso_id='',$public_document_id='')
	{
		$crso_id || $crso_id = $this->crso->relation->id;
		$public_document_id || $public_document_id = $this->public_document->id;

		$this->set($crso_id,$public_document_id);

		$this->db->begin();

		$sql = "DELETE FROM TBL_CRSO_PUBLIC_DOCUMENT
			WHERE CRSO_RELATION_ID = ?
				AND PUBLIC_DOCUMENT_ID = ?";
		$q1 = $this->db->query($sql);
		$q1->bind_values($crso_id,$public_document_id);
		if(!$q1->execute())
		{
			$this->db->rollback();
			return false;
		}

		if(!$this->document->delete())
		{
			$this->db->rollback();
			return false;
		}

		$this->db->commit();
		return true;
	}
	/**#@+
	 * @access private
	 */
	function _initObjectMaps()
	{
		$this->objectmap['dbtable'] = 'TBL_CRSO_PUBLIC_DOCUMENT';
		$this->objectmap['primary']['public_document->id'] = 'PUBLIC_DOCUMENT_ID';
		$this->objectmap['primary']['crso->relation->id'] = 'CRSO_RELATION_ID';
		$this->objectmap['properties']['document->id'] = 'DOCUMENT_ID';
	}
	/**#@-*/
}
?>
