<?php
require_once(IWARE.'AbstractObject.php');
/**
 * @package
 * @subpackage
 * @since 2-jul-2007
 * @author Marten Koedam <marten@dalines.net>
 * @version $Id$
 * @copyright 2007 BaseSoft B.V.
 */
class CRSOSupportDocument extends AbstractObject
{
	public $crso;
	public $document;
	public $title;
	/**
	 *
	 */
	public function getDocumentsForCRSO($crso_id=null)
	{
		$crso_id || $crso_id = $this->crso->relation->id;
		$sql = "SELECT CSD.`TITLE` as DocumentTitle, CSD.DOCUMENT_ID as DocumentId, D.`NAME` as DocumentName
			FROM TBL_CRSO_SUPPORT_DOCUMENT as CSD
			INNER JOIN TBL_DOCUMENT as D
				ON CSD.DOCUMENT_ID = D.DOCUMENT_ID
			WHERE CRSO_RELATION_ID = ?
			ORDER BY DocumentTitle";
		$q = $this->db->query($sql);
		$q->bind_values($crso_id);
		$q->execute();
		return $q;
	}

	public function getOverview($crso_ids)
	{
		$sql = "SELECT CRSO_RELATION_ID, DOCUMENT_ID, R.`NAME` as CRSO_NAME, CSD.`TITLE` as DocumentTitle, '' as Remove
			FROM TBL_CRSO_SUPPORT_DOCUMENT as CSD
			INNER JOIN TBL_RELATION as R
				ON CSD.CRSO_RELATION_ID = R.RELATION_ID
			WHERE CRSO_RELATION_ID IN (".implode(',', $crso_ids).")
			ORDER BY CRSO_NAME, DocumentTitle";
		$q = $this->db->query($sql);
		$q->execute();
		return $q;
	}

	public function delete($crso_id=null,$document_id=null)
	{
		$crso_id || $crso_id = $this->crso->relation->id;
		$document_id || $document_id = $this->document->id;

		$sql = "DELETE FROM TBL_CRSO_SUPPORT_DOCUMENT
			WHERE CRSO_RELATION_ID = ?
				AND DOCUMENT_ID = ?";
		$q = $this->db->query($sql);
		$q->bind_values($crso_id,$document_id);
		return $q->execute();
	}

	/**
	 * @access private
	 */
	function _initObjectMaps()
	{
		$this->objectmap['dbtable'] = 'TBL_CRSO_SUPPORT_DOCUMENT';
		$this->objectmap['primary']['crso->relation->id'] = 'CRSO_RELATION_ID';
		$this->objectmap['primary']['document->id'] = 'DOCUMENT_ID';
		$this->objectmap['properties']['title'] = 'TITLE';
	}
}
?>
