<?php
require_once(ELC_CLASSES.'WEEECountry.php');
/**
 * @author Marten Koedam <marten@basesoft.com>
 * @package I-Ware
 * @version $Id$
 */
class Country
{
	private $instance;

	function Country(IWDatabase $db, $preset=null, $set=false)
	{
		if(!$this->setRelationInstance($db,$preset,$set))
			$this->instance = new WEEECountry($db,$preset,$set);
	}

	private function setRelationInstance($db,$preset,$set)
	{
		if(!isset($_SESSION['session_group_group_id']) || $_SESSION['session_group_group_id']!=GROUP_PARTICIPANT)
			return false;
		$map = $this->getCountryRelationMap();
		if(!isset($map[$_SESSION['selected_participant_id']]))
			return false;

		$fname = 'WEEECountry'.$map[$_SESSION['selected_participant_id']];
		if(!file_exists(ELC_CLASSES.'relation/'.$fname.'.php'))
			return false;

		require_once(ELC_CLASSES.'relation/'.$fname.'.php');
		$this->instance = new $fname($db,$preset,$set);
		return true;
	}


	private function getCountryRelationMap()
	{
		return array(
			284=>'Glamox',
			133=>'Osram'
			);
	}

	function __call($func,$args)
	{
		return call_user_func_array(array($this->instance, $func),$args);
	}

	public function __get($name)
	{
		return $this->instance->$name;
	}

	public function __set($name,$value)
	{
		$this->instance->$name = $value;
	}

	public function __isset($name)
	{
		return isset($this->instance->$name);
	}
	public function __unset($name)
	{
		unset($this->instance->$name);
	}
}
/**#@+
 * Country Settings
 */
define('HasDeclByCategory',					pow(2,  0));
define('HasDeclByBrand',					pow(2,  1));
define('HasDeclOfWeight',					pow(2,  2));
define('HasProvisionalPerMonth',			pow(2,  3));
define('HasDocumentUpload',					pow(2,  4));
define('HasRegNumberAsProducer',			pow(2,  5));
define('HasCrsoProvisionalDetails',			pow(2,  6));
define('HasParticipantOneCrso', 			pow(2,  7));
define('HasCrsoDeclarationDetails',			pow(2,  8));
define('HasRefundInternalVAT',				pow(2,  9));
define('HasCrsoRefundDetails',				pow(2, 10));
define('HasRefundRequest',					pow(2, 11));
define('HasSubrogation',					pow(2, 12));
define('HasDeclarationComponent',			pow(2, 13));
define('HasCrsoOneExportDay',				pow(2, 14));
define('HasOneInvoice',						pow(2, 15)); // Merged Debit/Credit #329
define('HasPopSupplyChain',					pow(2, 16));
define('HasCreditViaProducer',				pow(2, 17));
define('HasDeclarationDimension',			pow(2, 18));
define('HasPoeAdditionalDocuments', 		pow(2, 19));
define('HasParticipantAgeingAccess', 		pow(2, 20)); // Ageing access for participants #1990
define('HasProofOfPaymentMultiline', 		pow(2, 21)); // # pop multiline refactor #2021
define('HasCRSORefundConfirmations', 		pow(2, 22)); // # CRSO Confirmations of Refunds #2137
define('HasAnnualConfirmationDisabled', 	pow(2, 23));
define('HasSendInvoicesAsAttachment', 		pow(2, 24)); // send emails with uploaded documents # 2181
define('HasGenericReportByParticipant', 	pow(2, 25)); // extra group by participant for generic reports
define('HasDeEarReporting', 				pow(2, 26)); // german ear reporting
define('HasWeightAsBasisForAmount', 		pow(2, 27)); // Weight as basis for amounts, Poland luminaires (#2458)
define('HasRequiredPoEDocumentUploadEU', 	pow(2, 28)); // Obliged export documents in EU (#2494)
define('HasDeclOfWeightWithDecimals', 		pow(2, 29)); // Weight including Decimals (#2502)
define('HasOptionalRefundImporterVAT', 		pow(2, 30)); // optional refund importer vat #2556
define('HasOmitExportOnOnlyWeightChanges', 	pow(2, 31)); // no invoicing when just weight changes (#2631), mutually exclusive with HasWeightAsBasisForAmount
define('HasParticipantCannotEditCompany', 	pow(2, 32)); // participants cannot edit their company info, crso must do it
define('HasCrsoParticipantLogin',			pow(2, 33)); // crso can login as participant when the user has it enabled in user details


// country settings column has type BIGINT, max value is 18446744073709551615. So max pow is 63


/**#@-*/
/**#@+
 * Region Defines
 */
define('REGION_EU',1);
/**#@-*/
?>
