<?php
require_once(IWARE.'AbstractObject.php');
/**
 * @package WEEE
 * @subpackage Country
 * @since 23-nov-2006
 * @author Marten Koedam <marten@dalines.net>
 * @version $Id$
 * @copyright 2006 BaseSoft B.V.
 */
class CountryProduct extends AbstractObject
{
	var $country;
	var $product;
	var $settings;

	function set($country_id=null,$product_id=null)
	{
		$country_id || $country_id = $this->country->id;
		$product_id || $product_id = $this->product->id;

		$sql = "SELECT `SETTINGS`
			FROM TBL_COUNTRY_PRODUCT
			WHERE COUNTRY_ID = ?
				AND PRODUCT_ID = ?";
		$q = $this->db->query($sql);
		$q->bind_values($country_id,$product_id);
		$q->execute();
		if(!($r = $q->fetch()))
			return false;

		require_once(ELC_CLASSES.'Product.php');
		require_once(ELC_CLASSES.'Country.php');
		$this->product = new Product($this->db,$product_id);
		$this->country = new Country($this->db,$country_id);
		$this->settings = (float) $r->SETTINGS;
		return $this->complete = true;
	}

	function validateUpdate()
	{
		$sql = "SELECT COUNT(PD.QUANTITY) as PDS
			FROM TBL_PROVISIONAL_DECLARATION as PD
			INNER JOIN TBL_CRSO as C
				ON PD.CRSO_RELATION_ID = C.CRSO_RELATION_ID
			INNER JOIN TBL_CRSO_PRODUCT as CP
				ON PD.CRSO_RELATION_ID = CP.CRSO_RELATION_ID
					AND PD.PRODUCT_ID = CP.PRODUCT_ID
			INNER JOIN TBL_RELATION as R
				ON C.CRSO_RELATION_ID = R.RELATION_ID
			INNER JOIN TBL_ADDRESS as A
				USING(ADDRESS_ID)
			WHERE A.COUNTRY_ID = ?
				AND CP.PRODUCT_ID = ?";
		$q = $this->db->query($sql);
		$q->bind_values($this->country->id,$this->product->id);
		$q->execute();
		$r = $q->fetch();
		if($r->PDS>0)
			return false;
		return true;
	}

	function _initObjectMaps()
	{
		$this->objectmap['dbtable'] = 'TBL_COUNTRY_PRODUCT';
		$this->objectmap['primary']['country->id'] = 'COUNTRY_ID';
		$this->objectmap['primary']['product->id'] = 'PRODUCT_ID';
		$this->objectmap['properties']['settings'] = 'SETTINGS';
	}
}
?>
