<?php
require_once(ELC_CLASSES.'ELCExporter.php');
require_once(ELC_CLASSES.'Declaration.php');
/**
 * @package
 * @subpackage
 * @author Nick Loeve <nick@basesoft.com>
 * @since 24/10/2006
 * @copyright 2006 BaseSoft B.V.
 * $Id$
 */
class ELCExporter_Declarations extends ELCExporter
{
	//this is used to create invoice line indexes per crso
	static protected $invoice_numbers;
    static protected $colsForInvoice = array(
			"INVOICE_LINE_INDEX", "`YEAR`", "THIS IS RUNTIME SPECIFIC", "CRSO_RELATION_ID", "DECLARATION_ID",
                        "DECLARATION_LINE_INDEX", "PRODUCT_ID",
			"JOURNAL_TEMPLATE", "CUSTOMER_NO", "CUSTOMER_NAME", "POSTING_DATE", "DOCUMENT_DATE",
			"EXTERNAL_DOCUMENT_NO", "CURRENCY_CODE", "`TYPE`", "GL_ACCOUNT_NO", "DESCRIPTION",
			"QUANTITY", "UNIT_COST", "LINE_AMOUNT_EXCL_VAT", "TOTAL_AMOUNT_EXCL_VAT",
			"TOTAL_AMOUNT_INCL_VAT", "TOTAL_VAT_AMOUNT", "NAVISION_VAT_CODE", "VAT_EXTENDED_TEXT",
			"DIMENSION_CODE_1", "DIMENSION_CODE_2", "DIMENSION_CODE_3", "DIMENSION_CODE_4",
			"DIMENSION_CODE_5", "DIMENSION_CODE_6", "DIMENSION_CODE_7", "DIMENSION_CODE_8", "TARIFF_NO",
			"NET_WEIGHT", "TRANSACTION_TYPE", "EXIT_POINT", "TRANSPORT_METHOD", "DECL_WEIGHT",
			"DECL_PRODUCT_CATEGORY", "DECL_BRAND", "DECL_MONTH", "DECL_YEAR", "DECL_TYPE",
			"DECL_TOTAL", "ORIGINAL_INVOICE", "BILL_TO_CUSTOMER_NO", "PRODUCT_DESCRIPTION", "HASH_TOTAL"
	);


	// {{{ protected function prepareInvoiceLines($crso_id)
	protected function prepareInvoiceLines($crso_id)
	{
		self::$invoice_numbers = array(); //need to refresh per crso

		$this->db->begin();
		$sql = "
			SELECT dl.DECLARATION_ID as DECLARATION_ID,
					IF(ISNULL(dd.DECLARATION_DEBIT_ID),
						f_elcBuildInvoiceNoForExport(d.CRSO_RELATION_ID,dc.`YEAR`,dc.DECLARATION_CREDIT_ID,TRUE,FALSE),
						f_elcBuildInvoiceNoForExport(d.CRSO_RELATION_ID,dd.`YEAR`,dd.DECLARATION_DEBIT_ID,FALSE,FALSE)) as INVOICE_NUMBER,
				dc.DECLARATION_CREDIT_ID as DECLARATION_CREDIT_ID,
				dd.DECLARATION_DEBIT_ID as DECLARATION_DEBIT_ID,
				'".(currentDate()->format('Y'))."' as `YEAR`,
				d.CRSO_RELATION_ID as CRSO_RELATION_ID,
				dl.LINE_INDEX as DECLARATION_LINE_INDEX,
				IF(ISNULL(dd.DECLARATION_DEBIT_ID),
					RTRIM(CONCAT('C', d.CRSO_RELATION_ID, SUBSTRING(dc.`YEAR`, -2),dc.DECLARATION_CREDIT_ID,'  ')),
					RTRIM(CONCAT('I', d.CRSO_RELATION_ID, SUBSTRING(dd.`YEAR`, -2),dd.DECLARATION_DEBIT_ID, '  '))) as INVOICE_LINE_INDEX, -- see value processor
				d.PRODUCT_ID as PRODUCT_ID,
				CONCAT(IF(ISNULL(dd.DECLARATION_DEBIT_ID),'C','I'), d.CRSO_RELATION_ID) as JOURNAL_TEMPLATE,
				CONCAT(cac.CODE,
					LPAD(d.CRSO_RELATION_ID, 8, 0),
					LPAD(d.PARTICIPANT_RELATION_ID, 8, 0)
				) as CUSTOMER_NO,
				dl.CREATED as POSTING_DATE, -- created act as a last update, since REPLACE statements are used
				'".(currentDate()->format('Y-m-d H:i:s'))."' as DOCUMENT_DATE,
				'G/L Account' as `TYPE`,
				CONCAT(dl.DECLARATION_ID, ';', dl.STATUS) as GL_ACCOUNT_NO, -- see value processor
				CONCAT(
					'1/', d.MONTH,'/',d.YEAR,' - ',
					DAYOFMONTH(LAST_DAY(CONCAT(d.YEAR, '-', d.MONTH,'-1'))),'/',d.MONTH,'/',d.YEAR
				) as DESCRIPTION,
				IF(ISNULL(dd.DECLARATION_DEBIT_ID),
					IF(dl.STATUS = 64,
						ABS(dl.QUANTITY),
						-(ABS(dl.QUANTITY))
					),
					IF(dl.STATUS = 64,
						-(ABS(dl.QUANTITY)),
						ABS(dl.QUANTITY)
					)
				) as QUANTITY,
				f_elcProductFee(d.PRODUCT_ID, d.CRSO_RELATION_ID, dl.PRODUCT_CATEGORY_ID, CONCAT(d.YEAR, '-', d.MONTH, '-01 00:00:00')) as UNIT_COST,
				IF(ISNULL(dd.DECLARATION_DEBIT_ID),
					IF(dl.STATUS = 64,
						ABS(
							(IF(f_elcUseQuantityColumn(d.CRSO_RELATION_ID, d.PRODUCT_ID), dl.QUANTITY, dl.WEIGHT) *
								f_elcProductFee(d.PRODUCT_ID, d.CRSO_RELATION_ID, dl.PRODUCT_CATEGORY_ID, CONCAT(d.YEAR, '-', d.MONTH, '-01 00:00:00')))),
						-(ABS(
							(IF(f_elcUseQuantityColumn(d.CRSO_RELATION_ID, d.PRODUCT_ID), dl.QUANTITY, dl.WEIGHT) *
								f_elcProductFee(d.PRODUCT_ID, d.CRSO_RELATION_ID, dl.PRODUCT_CATEGORY_ID, CONCAT(d.YEAR, '-', d.MONTH, '-01 00:00:00')))))
					),
					IF(dl.STATUS = 64,
						-(ABS(
							(IF(f_elcUseQuantityColumn(d.CRSO_RELATION_ID, d.PRODUCT_ID), dl.QUANTITY, dl.WEIGHT) *
								f_elcProductFee(d.PRODUCT_ID, d.CRSO_RELATION_ID, dl.PRODUCT_CATEGORY_ID, CONCAT(d.YEAR, '-', d.MONTH, '-01 00:00:00'))))),
						ABS(
							(IF(f_elcUseQuantityColumn(d.CRSO_RELATION_ID, d.PRODUCT_ID), dl.QUANTITY, dl.WEIGHT) *
								f_elcProductFee(d.PRODUCT_ID, d.CRSO_RELATION_ID, dl.PRODUCT_CATEGORY_ID, CONCAT(d.YEAR, '-', d.MONTH, '-01 00:00:00'))))

					)
				) as LINE_AMOUNT_EXCL_VAT,
				(IF(f_elcUseQuantityColumn(d.CRSO_RELATION_ID, d.PRODUCT_ID), dl.QUANTITY, dl.WEIGHT) * f_elcProductFee(d.PRODUCT_ID, d.CRSO_RELATION_ID, dl.PRODUCT_CATEGORY_ID, CONCAT(d.YEAR, '-', d.MONTH, '-01 00:00:00'))) as EXPORTED_AMOUNT,
				IF(ISNULL(dd.DECLARATION_DEBIT_ID), f_elcGetDeclarationCreditTotalAmount(d.CRSO_RELATION_ID, dc.DECLARATION_CREDIT_ID, dc.`YEAR`), f_elcGetDeclarationDebitTotalAmount(d.CRSO_RELATION_ID, dd.DECLARATION_DEBIT_ID, dd.`YEAR`)) as TOTAL_AMOUNT_EXCL_VAT,
				IFNULL(dl.WEIGHT, '') as NET_WEIGHT,
				IFNULL(dl.WEIGHT, '') as DECL_WEIGHT,
				IFNULL(pc.`NAME`, '') as DECL_PRODUCT_CATEGORY,
				IFNULL(b.NAME, '') as DECL_BRAND,
				d.`MONTH` as DECL_MONTH,
				d.`YEAR` as DECL_YEAR,
				dl.STATUS as DECL_TYPE,
				SUM(dl.QUANTITY) as DECL_TOTAL,
				IF(ISNULL(dd.DECLARATION_DEBIT_ID),
					f_elcBuildInvoiceNoForInterfaces(dd2.CRSO_RELATION_ID , dd2.`YEAR`, dd2.DECLARATION_DEBIT_ID, FALSE, FALSE),
					'') as ORIGINAL_INVOICE,
				CONCAT(cac.CODE,
					LPAD(d.CRSO_RELATION_ID, 8, 0),
					LPAD(d.PARTICIPANT_RELATION_ID, 8, 0)
				) as BILL_TO_CUSTOMER_NO,
				p.`NAME` as PRODUCT_DESCRIPTION,
				MD5(CONCAT(

					IF(ISNULL(dd.DECLARATION_DEBIT_ID),
						f_elcBuildInvoiceNoForInterfaces(d.CRSO_RELATION_ID,dc.`YEAR`,dc.DECLARATION_CREDIT_ID,TRUE,FALSE),
						f_elcBuildInvoiceNoForInterfaces(d.CRSO_RELATION_ID,dd.`YEAR`,dd.DECLARATION_DEBIT_ID,FALSE,FALSE)
					 ),
					CONCAT(cac.CODE,
						LPAD(d.CRSO_RELATION_ID, 8, 0),
						LPAD(d.PARTICIPANT_RELATION_ID, 8, 0)
					),
					REPLACE(IF(ISNULL(dd.DECLARATION_DEBIT_ID), f_elcGetDeclarationCreditTotalAmount(d.CRSO_RELATION_ID, dc.DECLARATION_CREDIT_ID, dc.`YEAR`), f_elcGetDeclarationDebitTotalAmount(d.CRSO_RELATION_ID, dd.DECLARATION_DEBIT_ID, dd.`YEAR`)), '.', ',')
				)) AS HASH_TOTAL
			FROM TBL_DECLARATION as d
			INNER JOIN TBL_RELATION as cr
				ON cr.RELATION_ID = d.CRSO_RELATION_ID
			INNER JOIN TBL_ADDRESS as ca
				ON cr.ADDRESS_ID = ca.ADDRESS_ID
			INNER JOIN TBL_COUNTRY as cac
				ON cac.COUNTRY_ID = ca.COUNTRY_ID
			INNER JOIN TBL_DECLARATION_SET_LINE AS dsl
				ON d.DECLARATION_ID = dsl.DECLARATION_ID
			LEFT JOIN TBL_DECLARATION_DEBIT as dd
				ON dsl.DECLARATION_SET_ID = dd.DECLARATION_SET_ID
			LEFT JOIN TBL_DECLARATION_CREDIT as dc
				ON dsl.DECLARATION_SET_ID = dc.DECLARATION_SET_ID
			INNER JOIN TBL_DECLARATION_LINE as dl
				ON dl.DECLARATION_ID = d.DECLARATION_ID
					 AND dl.STATUS != ?
			LEFT JOIN TBL_PRODUCT_CATEGORY as pc
				ON dl.PRODUCT_CATEGORY_ID = pc.PRODUCT_CATEGORY_ID
			INNER JOIN TBL_PRODUCT as p
				ON d.PRODUCT_ID = p.PRODUCT_ID
			LEFT JOIN TBL_BRAND as b
				ON b.BRAND_ID = dl.BRAND_ID
			LEFT JOIN TBL_DECLARATION_SET_LINE AS dsl2
				ON d.PARENT_DECLARATION_ID = dsl2.DECLARATION_ID
			LEFT JOIN TBL_DECLARATION_DEBIT as dd2
				ON dsl2.DECLARATION_SET_ID = dd2.DECLARATION_SET_ID
			WHERE d.IS_EXPORTED = ? -- Ready for export done by Declaration::_exportDeclarationsForCRSO or _triggerForfeit
				AND d.CRSO_RELATION_ID = ?
				AND (ISNULL(dd.DECLARATION_DEBIT_ID) XOR ISNULL(dc.DECLARATION_CREDIT_ID))
			GROUP BY dl.DECLARATION_ID, dl.LINE_INDEX
			ORDER BY d.PARTICIPANT_RELATION_ID, d.PRODUCT_ID, dl.LINE_INDEX
		";
		$bind_values = array(DECLARATION_OPEN, DECLARATION_EXPORT_PENDING, $crso_id);
		$q = $this->query($sql, $bind_values);


		while ($row = $q->fetch())
		{
			// save the exported amount into db
			$_sql = "UPDATE TBL_DECLARATION_LINE SET EXPORTED_AMOUNT=? WHERE DECLARATION_ID=? AND LINE_INDEX=?";
			$_vals = array(str_replace(',','.',$row->EXPORTED_AMOUNT), $row->DECLARATION_ID, $row->DECLARATION_LINE_INDEX );
			$this->query($_sql, $_vals);

			//get em into invoice lines
			$this->insertInvoiceLine($row);
		}

		$this->updateDeclarationExportStatus($crso_id);
		$this->db->commit();
	}
	// }}}


	protected function doExport($crso_id)
	{
		$this->db->begin();

		$this->query("UPDATE TBL_DECLARATION_CREDIT_LINE SET IS_EXPORTED = 1 WHERE CRSO_RELATION_ID = ? AND IS_EXPORTED = 0", array($crso_id));
		$this->query("UPDATE TBL_DECLARATION_DEBIT_LINE SET IS_EXPORTED = 1 WHERE CRSO_RELATION_ID = ? AND IS_EXPORTED = 0", array($crso_id));
		$this->db->commit();
	}

	protected function insertInvoiceLine($row)
	{
		self::$colsForInvoice[2] = "DECLARATION_".($row->JOURNAL_TEMPLATE[0] == 'C' ? 'CREDIT' : 'DEBIT')."_ID";
                $sql = "INSERT INTO TBL_DECLARATION_".($row->JOURNAL_TEMPLATE[0] == 'C' ? 'CREDIT' : 'DEBIT')."_LINE (";
		$columns = "";
		$bindValues = "";
		$values = array();
		foreach(self::$colsForInvoice as $col)
		{
			$columns .= $col.", ";
			$bindValues .= "?, ";
			$col = str_replace('`', '', $col);
			if(isset($row->{$col}))
			{
				if($col == 'GL_ACCOUNT_NO')
					$values[] = $this->processGLAccount($row->GL_ACCOUNT_NO);
				else if ($col == 'INVOICE_LINE_INDEX')
					$values[] = $this->processInvoiceLineNumber($row->INVOICE_LINE_INDEX);
				else if ($col == 'DECL_TYPE')
				{
					$trans = Declaration::translateStatus($this->langIf, $row->DECL_TYPE);
					$values[] = $trans[0];
				}
				else
					$values[] = $row->{$col};
			}
			else
				$values[] = null;
		}
		$sql .= substr($columns, 0, -2).") VALUES (".substr($bindValues, 0, -2).")";
		//debug('TMP SQL: '.$sql);
		//debug('VALUES: '.print_r($values,true));
		$q = $this->query($sql, $values);
		//echo 'invoice_numbers: '.sizeof(self::$invoice_numbers)."\n";
		//echo 'invoideline'."\n";

	}

	protected function processGLAccount($args)
	{
		list ($declaration_id, $status) = explode(';', $args);
		$handle = '';

		require_once(ELC_CLASSES.'Declaration.php');

		$d = new Declaration($this->db);
		return $d->getGlAccount($declaration_id, $status);
	}

	protected function processInvoiceLineNumber($invoice_id)
	{
		if(!isset(self::$invoice_numbers[$invoice_id]))
			return self::$invoice_numbers[$invoice_id] = 1;
		return ++self::$invoice_numbers[$invoice_id];
	}

	private function updateDeclarationExportStatus($crso_id)
	{
		$sql = "SELECT d.DECLARATION_ID
			FROM TBL_DECLARATION as d
			INNER JOIN TBL_DECLARATION_SET_LINE as dsl
				ON d.DECLARATION_ID = dsl.DECLARATION_ID
			LEFT JOIN TBL_DECLARATION_DEBIT as dd
				ON dsl.DECLARATION_SET_ID = dd.DECLARATION_SET_ID
			LEFT JOIN TBL_DECLARATION_CREDIT as dc
				ON dsl.DECLARATION_SET_ID = dc.DECLARATION_SET_ID
			WHERE d.CRSO_RELATION_ID = ?
				AND IS_EXPORTED = ?
				AND (ISNULL(dd.DECLARATION_DEBIT_ID) XOR ISNULL(dc.DECLARATION_CREDIT_ID))";
		$q = $this->query($sql,array($crso_id,DECLARATION_EXPORT_PENDING));
		$decl = '';
		while($r = $q->fetch())
			$decl .= $r->DECLARATION_ID.',';

		if(!$decl)
			return;

		$d = currentDate();
		$exportDate = $d->getYear().'-'.$d->getMonth().'-'.$d->getDay();
		$sql = "UPDATE TBL_DECLARATION
			SET IS_EXPORTED = ?, EXPORT_DATE = ?
			WHERE IS_EXPORTED = ? AND CRSO_RELATION_ID = ?
				AND DECLARATION_ID IN (".substr($decl,0,-1).")";
		$vals = array(DECLARATION_EXPORT_EXPORTED, $exportDate, DECLARATION_EXPORT_PENDING, $crso_id);
		$this->query($sql, $vals);
	}
}
?>
