<?php
require_once(IWARE.'AbstractObject.php');
require_once(ELC_CLASSES.'Country.php');
require_once(ELC_CLASSES.'Operator.php');
/**
 * @author Marten Koedam <marten@basesoft.com>
 * @package I-Ware
 * @version $Id$
 */
class OperatorCountry extends AbstractObject
{
	/**
	 * @param int $operator_id
	 */
	function getCountriesByOperator($operator_id='')
	{
		$operator_id || $operator_id = $this->operator->id;
		$sql = "SELECT COUNTRY_ID
			FROM TBL_OPERATOR_COUNTRY
			WHERE RELATION_ID = ?";
		$q = $this->db->query($sql);
		$q->bind_values($operator_id);
		$q->execute();
		return $q;
	}
	/**
	 *
	 */
	function deleteByOperator($operator_id='')
	{
		$operator_id || $operator_id = $this->operator->id;
		$sql = "DELETE FROM TBL_OPERATOR_COUNTRY
			WHERE RELATION_ID = ?";
		$q = $this->db->query($sql);
		$q->bind_values($operator_id);
		return $q->execute();
	}
	/**
	 *
	 */
	function _initObjectMaps()
	{
		$this->objectmap['dbtable'] = 'TBL_OPERATOR_COUNTRY';
		$this->objectmap['properties']['operator->id'] = 'RELATION_ID';
		$this->objectmap['properties']['country->id'] = 'COUNTRY_ID';
	}
}
?>
