<?php
require_once(IWARE.'AbstractObject.php');
/**
 * Example: Lamps, Refrigerators, Tv's
 *
 * @author Marten Koedam <marten@basesoft.com>
 * @package ELC
 * @subpackage Product
 * @version $Id$
 */
class Product extends AbstractObject
{
	var $id;
	var $name;
	var $company_id;
	/**
	 * @param int $id
	 */
	function set($id='')
	{
		$id || $id = $this->id;
		$sql = "SELECT COMPANY_ID, NAME
			FROM TBL_PRODUCT
			WHERE PRODUCT_ID = ?";
		$q = $this->db->query($sql);
		$q->bind_values($id);
		$q->execute();
		if(!($r = $q->fetch()))
			return false;

		$this->id = $id;
		$this->name = $r->NAME;
		$this->company_id = $r->COMPANY_ID;
		return $this->complete = true;
	}
	/**
	 *
	 */
	function get()
	{
		$sql = "SELECT PRODUCT_ID, NAME
			FROM TBL_PRODUCT
			WHERE COMPANY_ID = ?";
		$q = $this->db->query($sql);
		$q->bind_values($_SESSION['session_user_company_id']);
		$q->execute();
		return $q;
	}

	function getOverview()
	{
		return $this->getProducts();
	}

	function getProducts()
	{
		$sql = "SELECT PRODUCT_ID, `NAME` as PRODUCT_NAME
			FROM TBL_PRODUCT
			ORDER BY PRODUCT_NAME";
		$q = $this->db->query($sql);
		$q->execute();
		return $q;
	}

	/**
	 *
	 */
	function _initObjectMaps()
	{
		$this->objectmap['dbtable'] = 'TBL_PRODUCT';
		$this->objectmap['primary']['id'] = 'PRODUCT_ID';
		$this->objectmap['properties']['company_id'] = 'COMPANY_ID';
		$this->objectmap['properties']['name'] = 'NAME';
	}
}
?>
