<?php
require_once(IWARE.'AbstractObject.php');
require_once(ELC_CLASSES.'Product.php');
require_once(ELC_CLASSES.'CRSO.php');
/**
 * @package WEEE
 * @subpackage ProductComponent
 * @since 27-nov-2006
 * @author Marten Koedam <marten@dalines.net>
 * @version $Id$
 * @copyright 2006 BaseSoft B.V.
 */
class ProductComponent extends AbstractObject
{
	var $id;
	var $product;
	var $crso;
	var $name;

	function set($id=null)
	{
		$id || $id = $this->id;

		$sql = "SELECT PRODUCT_ID, CRSO_RELATION_ID, `NAME`
			FROM TBL_PRODUCT_COMPONENT
			WHERE COMPONENT_ID = ?";
		$q = $this->db->query($sql);
		$q->bind_values($id);
		$q->execute();
		if(!$r = $q->fetch())
			return false;

		$this->id = $id;
		$this->product = new Product($this->db,$r->PRODUCT_ID);
		$this->crso = new CRSO($this->db,array('relation'=>new Relation($this->db,$r->CRSO_RELATION_ID)));
		$this->name = $r->NAME;

		return $this->complete = true;
	}

	function getByProductCRSO($crso_id=null,$product_id=null)
	{
		$crso_id || $crso_id = $this->crso->relation->id;
		$product_id || $product_id = $this->product->id;

		$sql = "SELECT COMPONENT_ID, `NAME` as COMPONENT_NAME
			FROM TBL_PRODUCT_COMPONENT
			WHERE CRSO_RELATION_ID = ?
				AND PRODUCT_ID = ?";
		$q = $this->db->query($sql);
		$q->bind_values($crso_id,$product_id);
		$q->execute();
		return $q;
	}

	function _initObjectMaps()
	{
		$this->objectmap['dbtable'] = 'TBL_PRODUCT_COMPONENT';
		$this->objectmap['primary']['id'] = 'COMPONENT_ID';
		$this->objectmap['properties']['product->id'] = 'PRODUCT_ID';
		$this->objectmap['properties']['crso->relation->id'] = 'CRSO_RELATION_ID';
		$this->objectmap['properties']['name'] = 'NAME';
	}
}
?>
