<?php
require_once(IWARE.'AbstractObject.php');
require_once(ELC_CLASSES.'ProofOfPayment.php');
require_once(ELC_CLASSES.'RefundExport.php');
require_once(ELC_CLASSES.'CRSO.php');
require_once(ELC_CLASSES.'Participant.php');
/**
 * Object keeping track of how much POP has been used in RefundRequests
 * @author Nick Loeve <nick@basesoft.com>
 * @package ELC
 * @version $Id$
 */
class ProofOfPaymentExportQuantity extends AbstractObject
{
    var $proof_of_payment;
    var $refund_export;
    var $crso;
    var $participant;
    var $quantity;

    function set($pop_id=null, $re_id=null)
    {
        $pop_id || $pop_id = $this->proof_of_payment->id;
        $pop_id = (int) $pop_id;

        $re_id || $re_id = $this->refund_export->id;
        $re_id = (int) $re_id;

        $sql = "
				SELECT * FROM TBL_PROOF_OF_PAYMENT_EXPORT_QUANTITY
				WHERE REFUND_EXPORT_ID=? AND PROOF_OF_PAYMENT_ID=?
					";
		$q = $this->db->query($sql);
		$q->bind_values($re_id, $pop_id);
		if(!$q->execute() || !($r = $q->fetch()))
			return false;

        $this->refund_export = new RefundExport($this->db, array('id' => $r->{'REFUND_EXPORT_ID'}));
        $this->proof_of_payment = new ProofOfPayment($this->db, array('id' => $r->{'PROOF_OF_PAYMENT_ID'}));
        $this->crso = new CRSO($this->db, array('relation' => new Relation($this->db, array('id' => $r->{'CRSO_RELATION_ID'}))));
        $this->participant = new Participant($this->db, array('relation' => new Relation($this->db, array('id' => $r->{'PARTICIPANT_RELATION_ID'}))));
        $this->quantity = $r->{'QUANTITY'};
        return $this->complete = true;
    }
    /**#@+
     * @access private
     */
    function _initObjectMaps()
    {
        $this->objectmap['dbtable'] = 'TBL_PROOF_OF_PAYMENT_EXPORT_QUANTITY';
        $this->objectmap['primary']['refund_export->id'] = 'REFUND_EXPORT_ID';
        $this->objectmap['primary']['proof_of_payment->id'] = 'PROOF_OF_PAYMENT_ID';
        $this->objectmap['properties']['crso->relation->id'] = 'CRSO_RELATION_ID';
        $this->objectmap['properties']['participant->relation->id'] = 'PARTICIPANT_RELATION_ID';
        $this->objectmap['properties']['quantity'] = 'QUANTITY';
    }

    /**#@-*/
}
?>