<?php
/**
 * @package
 * @subpackage
 * @since 9-okt-2006
 * @author Marten Koedam <marten@dalines.net>
 * @version $Id$
 * @copyright 2006 BaseSoft B.V.
 */
class ProvisionalDeclarationHistory extends AbstractObject
{
	var $year;
	var $month;
	var $crso;
	var $participant;
	var $trust;
	var $brand;
	var $product_category;
	var $dimension;
	var $quantity;
	var $weight;
	var $user;
	var $change_date;
	var $product;
	var $lines = array();

	function setProps($props=array())
	{
		foreach($props as $prop => $value)
			$this->$prop = $value;
	}

	function addLine($line)
	{
		$props = array();
		$defprops = array('year','crso','participant','user', 'product');
		$lineprops = array('brand','product_category','dimension', 'quantity','weight','weight_dec','month');
		foreach($defprops as $prop)
			$props[$prop] = $this->$prop;
		foreach($lineprops as $prop)
			isset($line->$prop) && $props[$prop] = $line->$prop;
		$line = new ProvisionalDeclarationHistory($this->db,$props);
		$this->lines[] = $line;
	}

	function insertLines()
	{
		foreach($this->lines as $line)
			$line->insert();
	}

	function insert($graceful=false)
	{
		$this->change_date = date('Y-m-d H:i:s');
		return parent::insert($graceful);
	}

	function _initObjectMaps()
	{
		$this->objectmap['dbtable'] = 'TBL_PROVISIONAL_DECLARATION_HISTORY';
		$this->objectmap['properties']['year'] = 'YEAR';
		$this->objectmap['properties']['month'] = 'MONTH';
		$this->objectmap['properties']['crso->relation->id'] = 'CRSO_RELATION_ID';
		$this->objectmap['properties']['participant->relation->id'] = 'PARTICIPANT_RELATION_ID';
		$this->objectmap['properties']['trust->id'] = 'TRUST_ID';
		$this->objectmap['properties']['brand->id'] = 'BRAND_ID';
		$this->objectmap['properties']['product->id'] = 'PRODUCT_ID';
		$this->objectmap['properties']['product_category->id'] = 'PRODUCT_CATEGORY_ID';
		$this->objectmap['properties']['dimension->id'] = 'CPD_ID';
		$this->objectmap['properties']['quantity'] = 'QUANTITY';
		$this->objectmap['properties']['weight'] = 'WEIGHT';
		$this->objectmap['properties']['weight_dec'] = 'WEIGHT_DEC';
		$this->objectmap['properties']['user->id'] = 'USER_ID';
		$this->objectmap['properties']['change_date'] = 'CHANGE_DATE';
	}
}
?>