<?php
require_once(IWARE.'AbstractObject.php');
/**
 * For the management of the different types of public documents
 * These could have been just defines...
 * And this whole public document/crso thing was just a waste of time anyways...
 * @author Marten Koedam <marten@basesoft.com>
 * @package ELC
 * @subpackage Document
 * @copyright 2006, BaseSoft B.V.
 * @version $Id$
 */
class PublicDocument extends AbstractObject
{
	/**
	 * @var int $id
	 */
	var $id;
	/**
	 * @var string $name
	 */
	var $name;
	/**
	 * Sets the public document by its ID
	 */
	function set($id=null)
	{
		$id || $id = $this->id;
		$id = (int) $id;

		$sql = "SELECT `NAME`
			FROM TBL_PUBLIC_DOCUMENT
			WHERE PUBLIC_DOCUMENT_ID = ?";
		$q = $this->db->query($sql);
		$q->bind_values($id);
		$q->execute();
		if(!($r = $q->fetch()))
			return false;
		$this->id = $id;
		$this->name = $r->NAME;
		return $this->complete = true;
	}
	/**
	 * Gets all the public documents
	 * @return ResultSet $q
	 */
	function get()
	{
		$sql = "SELECT PUBLIC_DOCUMENT_ID, `NAME` as DOCUMENT_NAME
			FROM TBL_PUBLIC_DOCUMENT
			ORDER BY `NAME`";
		$q = $this->db->query($sql);
		$q->execute();
		return $q;
	}
	/**
	 * Gets an overview of all the public documents and how many CRSO uses them
	 * After 6 months they still are not using this!!! (2006-sept-08)
	 * @return ResultSet
	 */
	function getOverview()
	{
		$sql = "SELECT PD.PUBLIC_DOCUMENT_ID, PD.`NAME` as DOCUMENT_NAME,
				COUNT(CPD.CRSO_RELATION_ID) as CRSOS
			FROM TBL_PUBLIC_DOCUMENT as PD
			LEFT JOIN TBL_CRSO_PUBLIC_DOCUMENT as CPD
				USING(PUBLIC_DOCUMENT_ID)
			GROUP BY PD.PUBLIC_DOCUMENT_ID
			ORDER BY PD.`NAME`";
		$q = $this->db->query($sql);
		$q->execute();
		return $q;
	}
	/**#@+
	 * @access private
	 */
	/**
	 * Initializes the objectmaps used in AbstractObject
	 */
	function _initObjectMaps()
	{
		$this->objectmap['dbtable'] = 'TBL_PUBLIC_DOCUMENT';
		$this->objectmap['primary']['id'] = 'PUBLIC_DOCUMENT_ID';
		$this->objectmap['properties']['name'] = 'NAME';
	}
	/**#@-*/
}
?>
