<?php
require_once(IWARE.'AbstractObject.php');
/**
 * @package
 * @subpackage
 * @author Nick Loeve <nick@basesoft.com>
 * @since 06/02/2007
 * @copyright 2006 BaseSoft B.V.
 * $Id$
 */

class RefundRequestAdditionalDocument extends AbstractObject
{
	public $document;
	public $refund_request;
	public $invoice_number;
	public $invoice_date;

	public static function removeDocument($db, $id)
	{
		$q = $db->query('DELETE FROM TBL_REFUND_REQUEST_ADDITIONAL_DOCUMENT WHERE DOCUMENT_ID = ?');
		$q->bind_values($id);
		$q->execute();

		$q = $db->query('DELETE FROM TBL_USER_DOCUMENT_DOWNLOAD WHERE DOCUMENT_ID = ?');
		$q->bind_values($id);
		$q->execute();

		$q = $db->query('DELETE FROM TBL_RELATION_DOCUMENT WHERE DOCUMENT_ID = ?');
		$q->bind_values($id);
		$q->execute();

		$q = $db->query('DELETE FROM TBL_DOCUMENT WHERE DOCUMENT_ID = ?');
		$q->bind_values($id);
		$q->execute();
	}

	public static function getDocumentLines($db, $rr_id)
	{
		$q = $db->query("SELECT INVOICE_NO, DATE_FORMAT(INVOICE_DATE, '%d-%m-%Y') AS INVOICE_DATE, DOCUMENT_ID FROM TBL_REFUND_REQUEST_ADDITIONAL_DOCUMENT WHERE REFUND_REQUEST_ID = ?");
		$q->bind_values($rr_id);
		$q->execute();

		$lines = array();
		while($r = $q->fetch())
			$lines[] = array('INVOICE_NO' => $r->INVOICE_NO, 'INVOICE_DATE' => $r->INVOICE_DATE,'INVOICE_DOCUMENT' => $r->DOCUMENT_ID, 'DELETE' => '');
		return $lines;
	}


	function getLines($rr_id)
	{
		$sql = "SELECT INVOICE_NO, DATE_FORMAT(INVOICE_DATE, '%d-%m-%Y') AS INVOICE_DATE, DOCUMENT_ID FROM TBL_REFUND_REQUEST_ADDITIONAL_DOCUMENT WHERE REFUND_REQUEST_ID = ?";
		$q = $this->db->query($sql);
		$q->bind_values($rr_id);
		$q->execute();
		return $q;
	}

	function _initObjectMaps()
    {
        $this->objectmap['dbtable'] = 'TBL_REFUND_REQUEST_ADDITIONAL_DOCUMENT';
        $this->objectmap['primary']['document->id'] = 'DOCUMENT_ID';
        $this->objectmap['properties']['refund_request->id'] = 'REFUND_REQUEST_ID';
        $this->objectmap['properties']['invoice_number'] = 'INVOICE_NO';
        $this->objectmap['properties']['invoice_date'] = 'INVOICE_DATE';
    }
}
?>