<?php
/**
 * RefundRequestController
 *
 * @package PACKAGE
 * @subpackage SUBPACKAGE
 * @since Dec 8, 2006
 * @author Martijn van den Broek <martijn@xs4all.nl>
 * @version $Id$
 * @copyright 2007 BaseSoft B.V.
 */

require_once(ELC_CLASSES.'WEEEController.php');
require_once(ELC_CLASSES.'CRSOParticipantProduct.php');
require_once(ELC_CLASSES.'Country.php');
require_once(ELC_CLASSES.'RelationUser.php');
require_once(ELC_CLASSES.'RefundRequest.php');
require_once(ELC_CLASSES.'ProofOfPayment.php');
require_once(ELC_CLASSES.'CRSOVATBlock.php');
require_once(ELC_CLASSES.'RelationDocument.php');

class RefundRequestController extends WEEEController
{
	public function isGeneralManager()
	{
		return $this->cpp->general_manager &&
				$this->cpp->general_manager->id == $_SESSION['session_user_id'] &&
		        $this->cpp->general_manager_authorized == GENERAL_MANAGER_AUTHORIZED;
	}

	public function checkRefundSettings()
	{
		if (!$this->cpp->authorize_refund_request_eu ||
			!$this->cpp->authorize_refund_request_non_eu ||
			!$this->cpp->authorize_proof_of_payment)
		{
			throw new RefundRequestSettingsException('You must set refund settings.');
		}
	}
}

/**
 * Exceptions
 */
class RefundRequestSettingsException extends WEEEException {};
?>
