<?php
require_once(IWARE.'AbstractObject.php');
/**
 * @author Marten Koedam <marten@basesoft.com>
 * @package ELC
 * @copyright 2006, BaseSoft B.V.
 * @subpackage Relation
 * @version $Id$
 */
class RelationInvoice extends AbstractObject
{
	/**
	 * @var Relation $relation
	 */
	var $relation;
	/**
	 * @var InfoPerson $info_person
	 */
	var $info_person;
	/**
	 * @var Address $address
	 */
	var $address;
	/**
	 * @var string $name
	 */
	var $name;
	/**
	 * Sets a relation invoice by a relation_id
	 * @param int $relation_id
	 * @return bool
	 */
	function set($relation_id='')
	{
		$relation_id || $relation_id = $this->relation->id;
		$sql = "SELECT INFO_PERSON_ID, ADDRESS_ID, `NAME`
			FROM TBL_RELATION_INVOICE
			WHERE RELATION_ID = ?";
		$q = $this->db->query($sql);
		$q->bind_values($relation_id);
		$q->execute();
		if(!($r = $q->fetch()))
			return false;


		require_once(IWARE.'InfoPerson.php');
		require_once(IWARE.'address.php');
		require_once(ELC_CLASSES.'Relation.php');

		$this->relation = new Relation($this->db,$relation_id);
		$this->info_person = new InfoPerson($this->db,$r->INFO_PERSON_ID);
		$this->address = new Address($this->db,array('address_id'=>$r->ADDRESS_ID));
		$this->name = $r->NAME;
		return $this->complete = true;
	}
	/**
	 * Intializes the objectmaps for AbstractObject
	 * @access protected
	 */
	function _initObjectMaps()
	{
		$this->objectmap['dbtable'] = 'TBL_RELATION_INVOICE';
		$this->objectmap['primary']['relation->id'] = 'RELATION_ID';
		$this->objectmap['properties']['info_person->id'] = 'INFO_PERSON_ID';
		$this->objectmap['properties']['address->address_id'] = 'ADDRESS_ID';
		$this->objectmap['properties']['name'] = 'NAME';
	}
}
?>
