<?php
require_once(ELC_CLASSES.'WEEEInterfaceHandler.php');
/**
 * @package
 * @subpackage
 * @since 09-07-2010
 * @author Nicoleta Militaru <nicoleta@basesoft.com>
 * @version $Id$
 * @copyright 2010 BaseSoft B.V.
 */
class WEEEAccountantInterfaceHandler extends WEEEInterfaceHandler
{
	protected function __construct($universe)
	{
		if($_SESSION['session_group_group_id']!=GROUP_ACCOUNTANT)
		{
			require_once(IWARE_SCRIPTS.'PermissionDenied.php');
			exit();
		}
		$this->universe = $universe;
	}
	public function InterfaceExportDownloadAction()
	{
		define('HIDE_PRODUCT_SELECT', 'turu');
		$this->instantiateInterfaceFactory('InterfaceExportDownload');
	}

	public function InterfaceImporterAction()
	{
		define('HIDE_PRODUCT_SELECT', 'turu');
		$this->setScriptId(64475);
		$this->instantiateInterfaceFactory(182);
	}

	public function InterfaceRequestDebitCreditIdAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/accountant/InterfaceRequestDebitCreditId.php');
		$this->instantiateInterfaceFactory('InterfaceRequestDebitCreditId');
	}

	public function InterfaceEmailTranslatorAction()
	{
		$this->func_input_filter = array($this, 'InterfaceEmailTranslatorActionFilter');

		$this->setScriptHeader('<script type="text/javascript" src="/'.SITE_PATH.'includes/tiny_mce/tiny_mce.js"></script>');
		define('HIDE_PRODUCT_SELECT', 'turu');
		$this->instantiateInterfaceFactory('InterfaceEmailTranslator');
	}

	public function InterfaceEmailTranslatorActionFilter()
	{
	// make a copy of the thing we wanna filter
		$skip_html = false;
		if (isset($_POST['message']['html']))
		{
			$skip_html = true;
			$message_html = $_POST['message']['html'];
			$message_subject = $_POST['message']['subject'];
			unset($_POST['message']['html']);
			unset($_REQUEST['message']['html']);
			unset($_POST['message']['subject']);
			unset($_REQUEST['message']['subject']);
		}

		// do normal filtering
		$_GET = sanitize_array_recursive($_GET);
		$_POST = sanitize_array_recursive($_POST);
		$_REQUEST = sanitize_array_recursive($_REQUEST);

		// now lets put it back!
		if ($skip_html)
		{
			$_REQUEST['message']['html'] = $message_html;
			$_POST['message']['html'] = $message_html;
			$_REQUEST['message']['subject'] = $message_subject;
			$_POST['message']['subject'] = $message_subject;
		}
	}

	public function InterfacePublicUserOverviewAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/accountant/InterfacePublicUserOverview.php');
		$this->instantiateInterfaceFactory('InterfacePublicUserOverview');
	}

	public function InterfaceCountryOverviewAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/accountant/InterfaceCountryOverview.php');
		$this->instantiateInterfaceFactory('InterfaceCountryOverview');
	}

	public function InterfaceCRSOOverviewAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/accountant/InterfaceCRSOOverview.php');
		$this->instantiateInterfaceFactory('InterfaceCRSOOverview');
	}

	public function InterfaceReviewRefundExportsAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/accountant/InterfaceReviewRefundExports.php');
		$this->instantiateInterfaceFactory('InterfaceReviewRefundExports');
	}

	public function InterfaceCRSOProductManagementAction()
	{
		define('HIDE_PRODUCT_SELECT','tuut');
		$this->instantiateInterfaceFactory('InterfaceCRSOProductManagement');
	}

	public function InterfaceCRSOSettingsAction()
	{
		$this->instantiateInterfaceFactory(103);
	}

	public function InterfaceActivityReportAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/accountant/InterfaceActivityReport.php');
		$this->instantiateInterfaceFactory(143);
	}

	public function InterfacePaymentAuthorisationOverviewAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/accountant/InterfacePaymentAuthorisationOverview.php');
		$settings = array('classPrefix'=>'InterfaceAuthorisationOverviewPayment', 'appPath'=>'elc/common/');
		$this->instantiateInterfaceFactory(125,$settings);
	}

	public function InterfaceFAQManagementAction()
	{
		$this->func_input_filter = array($this, 'InterfaceFAQManagementActionFilter');

		$this->setProductSwitchLocation('/scripts/elc/accountant/InterfaceFAQManagement.php');
		$this->setScriptHeader('<script type="text/javascript" src="/'.SITE_PATH.'includes/tiny_mce/tiny_mce.js"></script>');
		$this->instantiateInterfaceFactory('InterfaceFAQManagement');
	}

	public function InterfaceFAQManagementActionFilter()
	{
		// make a copy of the thing we wanna filter
		$skip_html = false;
		$answer = false;
		if (isset($_POST['faq']['handle']))
		{
			$skip_html = true;
			$faq_handle = $_POST['faq']['handle'];
			unset($_POST['faq']['handle']);
			unset($_REQUEST['faq']['handle']);
			$faq_quest = $_POST['faq_lang']['question_text'];
			unset($_POST['faq_lang']['question_text']);
			unset($_REQUEST['faq_lang']['question_text']);
			if(isset($_POST['faq_lang']['answer_text']))
			{
				$answer = true;
				$faq_answer = $_POST['faq_lang']['answer_text'];
				unset($_POST['faq_lang']['answer_text']);
				unset($_REQUEST['faq_lang']['answer_text']);
			}
		}

		// do normal filtering
		$_GET = sanitize_array_recursive($_GET);
		$_POST = sanitize_array_recursive($_POST);
		$_REQUEST = sanitize_array_recursive($_REQUEST);

		// now lets put it back!
		if ($skip_html)
		{
			$_REQUEST['faq']['handle'] = $faq_handle;
			$_POST['faq']['handle'] = $faq_handle;
			$_REQUEST['faq_lang']['question_text'] = $faq_quest;
			$_POST['faq_lang']['question_text'] = $faq_quest;
			if($answer)
			{
				$_REQUEST['faq_lang']['answer_text'] = $faq_answer;
				$_POST['faq_lang']['answer_text'] = $faq_answer;
			}
		}
	}

	public function InterfaceCountryLegalNoticeAction()
	{
		$this->setScriptHeader('<script type="text/javascript" src="/'.SITE_PATH.'includes/tiny_mce/tiny_mce.js"></script>');
		$this->instantiateInterfaceFactory('InterfaceCountryLegalNotice');
	}

	public function InterfaceAnnualConfirmationOverviewAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/accountant/InterfaceAnnualConfirmationOverview.php');
		$this->instantiateInterfaceFactory(160);
	}

	public function InterfaceProductCategoryOverviewAction()
	{
		$this->instantiateInterfaceFactory(135);
	}

	public function InterfacePoPConfirmationsAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/accountant/InterfacePoPConfirmations.php');
		$this->instantiateInterfaceFactory(164);
	}

	/**#@+
	 * Lists
	 */
	public function InterfaceDocumentAccessListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/accountant/InterfaceDocumentAccessList.php');
		$this->setScriptId(64340);
		$settings = array('lists'=>array('DocumentAccessList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceOperatorDeclarationStatusAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/accountant/InterfaceOperatorDeclarationStatus.php');
		$this->setScriptId(64311);
		$settings = array('lists'=>array('DeclarationStatusList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceDeclarationListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/accountant/InterfaceDeclarationList.php');
		$this->setScriptId(64316);
		$settings = array('lists'=>array('DeclarationList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceProvDeclCmpListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/accountant/InterfaceProvDeclCmpList.php');
		$this->setScriptId(64312);
		$settings = array('lists'=>array('ProvDeclCmpList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}
	public function InterfaceProvDeclDataListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/accountant/InterfaceProvDeclDataList.php');
		$this->setScriptId(64325);
		$settings = array('lists'=>array('ProvDeclDataList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceImportVsPutOnMarketListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/accountant/InterfaceImportVsPutOnMarketList.php');
		$this->setScriptId(64380);
		$settings = array('lists'=>array('ImportVsPutOnMarketList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceDeclarationExportListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/accountant/InterfaceDeclarationExportList.php');
		$this->setScriptId(64314);
		$settings = array('lists'=>array('DeclarationExportList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceProvDeclChangeListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/accountant/InterfaceProvDeclChangeList.php');
		$this->setScriptId(64317);
		$settings = array('lists'=>array('ProvDeclChangeList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceTrustListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/accountant/InterfaceTrustList.php');
		$this->setScriptId(64319);
		$settings = array('lists'=>array('SubrogationTrusteeList','SubrogationSubrogatorList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceRefundRequestListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/accountant/InterfaceRefundRequestList.php');
		$this->setScriptId(64313);
		$settings = array('lists'=>array('RefundRequestList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfacePoPAndRRCmpListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/accountant/InterfacePoPAndRRCmpList.php');
		$this->setScriptId(64315);
		$settings = array('lists'=>array('PoPAndRRCmpList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceImporterListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/accountant/InterfaceImporterList.php');
		$this->setScriptId(64321);
		$settings = array('lists'=>array('NonParticipantImporterList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfacePoEDocumentListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/accountant/InterfacePoEDocumentList.php');
		$this->setScriptId(64600);
		$settings = array('lists'=>array('PoEDocumentList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceRefundOverviewAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/accountant/InterfaceRefundOverview.php');
		$this->setScriptId(64322);
		$settings = array('lists'=>array('RefundOverviewList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceRefundExportListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/accountant/InterfaceRefundExportList.php');
		$this->setScriptId(64323);
		$settings = array('lists'=>array('RefundExportList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfacePoPListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/accountant/InterfacePoPList.php');
		$this->setScriptId(64324);
		$settings = array('lists'=>array('PoPList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceVirtualStockListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/accountant/InterfaceVirtualStockList.php');
		$this->setScriptId(64326);
		$settings = array('lists'=>array('VirtualStockList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfacePoPDetailsListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/accountant/InterfacePoPDetailsList.php');
		$this->setScriptId(64327);
		$settings = array('lists'=>array('PoPDetailsList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfacePoEDetailsListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/accountant/InterfacePoEDetailsList.php');
		$this->setScriptId(64328);
		$settings = array('lists'=>array('PoEDetailsList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceReminderOverviewListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/accountant/InterfaceReminderOverviewList.php');
		$this->setScriptId(64360);
		$settings = array('lists'=>array('ReminderOverviewList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceAnnualConfirmationListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/accountant/InterfaceAnnualConfirmationList.php');
		$this->setScriptId(64318);
		$settings = array('lists'=>array('AnnualConfirmationList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}
	public function InterfaceOperatorSummaryListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/accountant/InterfaceOperatorSummaryList.php');
		$this->setScriptId(64390);
		$settings = array('lists'=>array('OperatorSummaryList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

        public function InterfaceCustomerBalanceReportAction()
        {
            define('HIDE_PRODUCT_SELECT', 'turu');
            $this->setScriptId(64396);
            $settings = array('lists' => array('AgeingCustomerBalanceList'));
            $this->instantiateInterfaceFactory(138,$settings);
        }

        public function InterfaceAgeingAlarmReportAction()
        {
            define('HIDE_PRODUCT_SELECT', 'turu');
            $this->setScriptId(64397);
            $settings = array('lists' => array('AgeingAlarmList'));
            $this->instantiateInterfaceFactory(138,$settings);
        }

	/**#@-*/
	/**#@+
	 * CustomQuery
	 */
	public function InterfaceCQCRSOSettingsAction()	{
		$this->setProductSwitchLocation('/scripts/elc/accountant/InterfaceCQCRSOSettings.php');
		$this->CustomQuery('WEEECustomQueryCRSOProductOverview',64352);
	}
	public function InterfaceCQDeclarationAction()	{
		$this->setProductSwitchLocation('/scripts/elc/accountant/InterfaceCQDeclaration.php');
		$this->CustomQuery('WEEECustomQueryDeclarationOverview',64353);
	}
	public function InterfaceCQMasterdataHashOverviewAction()	{
		$this->setProductSwitchLocation('/scripts/elc/accountant/InterfaceCQMasterdataHashOverview.php');
		$this->CustomQuery('WEEECustomQueryMasterDataHash',64355);
	}
	/**
	 *
	 */
	public function InterfaceCQUserOverviewAction() {

		$script = sprintf('<script type="text/javascript">
			<!--
				function switchUserStatus(user_id)
				{
					var status = $(\'status_\'+user_id).value;
					var warn = "%s";
					if(status==1)
						warn = "%s";

					var jsParams = new Array();
					jsParams[\'user_id\'] = user_id;

					MessageBox.prototype.Question(\'%s\',warn, function(){
						changeImage(user_id,status);
						changeButton(user_id,status);
						jsbroker.call(\'switchUserStatus\',jsParams,function(){});
						$(\'status_\'+user_id).value = (status==1)?0:1;
					});
				}

				function changeImage(user_id,status)
				{
					var img = (status==1)?\'false\':\'true\';
					$(\'img_status_\'+user_id).src = \'/%simages/i-w/\'+img+\'.gif\';
				}

				function changeButton(user_id,status)
				{
					var msg = \'%s\';
					if(status==1)
						msg = \'%s\';
					$(\'btn_status_\'+user_id).value = msg;
				}
			-->
			</script>',
			jstr('MessageBoxContent: Change User to Active'),
			jstr('MessageBoxContent: Change User to Inactive'),
			jstr('MessageBoxTitle: Change User Status'),
			SITE_PATH,
			jstr('Deactivate User'),
			jstr('Activate User')
			);

		$this->CustomQuery('WEEECustomQueryUserOverview','',$script);
	}
	/**
	 *
	 */
	public function InterfaceCQParticipantOverviewAction()	{
		$this->setProductSwitchLocation('/scripts/elc/accountant/InterfaceCQParticipantOverview.php');
		$script = sprintf('
			<script type="text/javascript">
			<!--
				function doLogin(loginname)
				{
					MessageBox.prototype.Question(
					\'%s\',
					\'%s\', function(){
						document.location.href = "/%sscripts/elc/public/DoLogin.php?loginname="+loginname;
					});
				}
			-->
			</script>',
			jstr('Login as AdminUser confirm title'),
			jstr('Login as AdminUser confirm'),
			SITE_PATH
			);
		$this->CustomQuery('WEEECustomQueryParticipantOverview',64351,$script);
	}

	public function InterfaceCQRefundImporterStatusAction()	{

		$script = sprintf('
			<script type="text/javascript">
			<!--
				function markAsResolved(rr_id)
				{
					var jsParams = new Array();
					jsParams[\'rr_id\'] = rr_id;

					MessageBox.prototype.Question(
					\'%s\',
					\'%s\', function() {
							jsbroker.call(\'refundImporterMarkAsResolved\',jsParams,function(){
								$(\'custom_query_form\').submit();
							});
						}
					)
				}
			-->
			</script>',
			jstr('Mark Refund Importer Status As Resolved Title'),
			jstr('Mark Refund Importer Status As Resolved Content')
			);

		$this->setProductSwitchLocation('/scripts/elc/accountant/InterfaceCQRefundImporterStatus.php');
		$this->CustomQuery('WEEECustomQueryRefundImporterStatus',64357,$script);
	}

	public function InterfaceCQRefundExportAction()	{
		$this->setProductSwitchLocation('/scripts/elc/accountant/InterfaceCQRefundExport.php');
		$this->CustomQuery('WEEECustomQueryRefundExportOverview',64354);
	}

	public function InterfaceCQDeclarationExportAction()	{
		$this->setProductSwitchLocation('/scripts/elc/accountant/InterfaceCQDeclarationExport.php');
		$this->CustomQuery('WEEECustomQueryDeclarationExport',64358);
	}

	public function InterfaceCustomQueryAction()
	{
		$this->CustomQuery('WEEECustomQuery',64359);
	}

	protected function CustomQuery($query,$script_id,$script_header='')
	{
		$this->setScriptId($script_id);
		$settings = array('cq'=>array($query));
		$this->setScriptHeader('<script type="text/javascript" src="'.REL_IWARE_INCLUDES.'IWCustomQueryFactory.js"></script>'.$script_header);
		$this->setExtraStyle('filtertable');
		$this->instantiateInterfaceFactory(162,$settings);
	}
	public function InterfaceEAProducerRegistrationListAction()
	{
		define('HIDE_PRODUCT_SELECT', 1);
                $this->setProductSwitchLocation('/scripts/elc/accountant/InterfaceEAProducerRegistrationList.php');
		$this->setScriptId(64486);
		$settings = array('lists'=>array('EAProducerRegistrationList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}
	public function InterfaceEAReportSettingsListAction()
	{
		define('HIDE_PRODUCT_SELECT', 1);
                $this->setProductSwitchLocation('/scripts/elc/accountant/InterfaceEAReportSettingsList.php');
		$this->setScriptId(64488);
		$settings = array('lists'=>array('EAReportSettingsList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}
	public function InterfaceEAReportDataListAction()
	{
		define('HIDE_PRODUCT_SELECT', 1);
                $this->setProductSwitchLocation('/scripts/elc/accountant/InterfaceEAReportDataList.php');
		$this->setScriptId(64494);
		$settings = array('lists'=>array('EAReportDataList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}
	public function InterfaceEAReportsOverviewListAction()
	{
		define('HIDE_PRODUCT_SELECT', 1);
                $this->setProductSwitchLocation('/scripts/elc/accountant/InterfaceEAReportsOverviewList.php');
		$this->setScriptId(64489);
		$settings = array('lists'=>array('EAReportsOverviewList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}
	public function InterfaceEAPRReportListAction()
	{
		define('HIDE_PRODUCT_SELECT', 1);
                $this->setProductSwitchLocation('/scripts/elc/accountant/InterfaceEAPRReportList.php');
		$this->setScriptId(64491);
		$settings = array('lists'=>array('EAPRReportList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}
	public function InterfaceEAActualsReportListAction()
	{
		define('HIDE_PRODUCT_SELECT', 1);
                $this->setProductSwitchLocation('/scripts/elc/accountant/InterfaceEAActualsReportList.php');
		$this->setScriptId(64492);
		$settings = array('lists'=>array('EAActualsReportList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}
	public function InterfaceEAWeightsB2BListAction()
	{
		define('HIDE_PRODUCT_SELECT', 1);
                $this->setProductSwitchLocation('/scripts/elc/accountant/InterfaceEAWeightsB2BList.php');
		$this->setScriptId(64497);
		$settings = array('lists'=>array('EAWeightsB2BList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}
	public function InterfaceUKXMLPreparationAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/accountant/InterfaceUKXMLPreparation.php');
		$this->instantiateInterfaceFactory('InterfaceUKXMLPreparation');
	}
	public function InterfaceCrsoEADataAction()
	{
		define('HIDE_PRODUCT_SELECT', 1);
                $this->setProductSwitchLocation('/scripts/elc/accountant/InterfaceCrsoEAData.php');
		$this->instantiateInterfaceFactory('InterfaceCrsoEAData');
	}
	/**#@-*/

        public function InterfaceElcInspectorAction()
	{
		$this->setScriptHeader('<script type="text/javascript" src="/'.SITE_PATH.'includes/i-w/NavigationNode.js"></script>');
		$this->setExtraStyle('navigation_node');
		$this->instantiateInterfaceFactory('InterfaceElcInspector');
	}

	/* EAR */

	public function InterfaceDeEARDeclarationListAction()
	{

		$this->setScriptId(MenuDeEarReportingAccountant);

		global $langIf;
		setPageTitlePostfix('- ' .$langIf->gettext('Declaration'));

		$settings = array('lists'=>array('DeEARDeclarationList'));
		$this->instantiateInterfaceFactory(138,$settings);

	}

	public function InterfaceDeEARExportListAction()
	{

		global $langIf;
		setPageTitlePostfix('- ' .$langIf->gettext('Export'));

		$this->setScriptId(MenuDeEarReportingAccountant);
		$settings = array('lists'=>array('DeEARExportList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceDeEARNetResultListAction()
	{

		$this->setScriptId(MenuDeEarReportingAccountant);

		global $langIf;
		setPageTitlePostfix('- ' .$langIf->gettext('Net Result'));

		$settings = array('lists'=>array('DeEARNetResultList'));
		$this->instantiateInterfaceFactory(138,$settings);

	}


}
?>
