<?php
require_once(ELC_CLASSES.'WEEEInterfaceHandler.php');
/**
 * @package
 * @subpackage
 * @since 19-mrt-2007
 * @author Marten Koedam <marten@dalines.net>
 * @version $Id$
 * @copyright 2007 BaseSoft B.V.
 */
class WEEECrsoInterfaceHandler extends WEEEInterfaceHandler
{
	protected function __construct($universe)
	{
		if($_SESSION['session_group_group_id']!=GROUP_CRSO)
		{
			require_once(IWARE_SCRIPTS.'PermissionDenied.php');
			exit();
		}

		// Check for Remote Viewer activity.
		// Note, if any of the CRSO users is part of a Remote Viewer session, the Keep Alive is disabled for all.
		require_once(ELC_CLASSES.'RemoteViewer.php');
		$rv = new RemoteViewer(IWRegistry::registry('db'));
		if($rv->crsoHasActiveConnection($_SESSION['crso_relation_id'])) {
			if(!defined('NO_KEEP_ALIVE'))
				define('NO_KEEP_ALIVE', true);
		}

		$this->universe = $universe;
	}
	public function InterfaceUKXMLPreparationAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/crso/InterfaceUKXMLPreparation.php');
		$this->instantiateInterfaceFactory('InterfaceUKXMLPreparation');
	}
	public function InterfaceCrsoEADataAction()
	{
		define('HIDE_PRODUCT_SELECT', 1);
		$this->setProductSwitchLocation('/scripts/elc/crso/InterfaceCrsoEAData.php');
		$this->instantiateInterfaceFactory('InterfaceCrsoEAData');
	}
	public function InterfaceRegistrationsOverviewAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/crso/InterfaceRegistrationsOverview.php?PRODUCER_EXPORTER='.(isset($_REQUEST['PRODUCER_EXPORTER']) ? (int)$_REQUEST['PRODUCER_EXPORTER'] : 1));
		if(isset($_REQUEST['PRODUCER_EXPORTER'])&& $_REQUEST['PRODUCER_EXPORTER']==1)
			$this->setScriptId(61210); 		// Add the right script id
		else
			$this->setScriptId(61211); 		// Add the right script id

		$settings = array('lists'=>array('ParticipantRegistrationList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfacePublicWebsiteAction()
	{
		define('HIDE_PRODUCT_SELECT', 'turu');
		$this->instantiateInterfaceFactory('InterfacePublicWebsite');
	}

	public function InterfaceBrandManagementAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/crso/InterfaceBrandManagement.php');
		$this->instantiateInterfaceFactory('InterfaceBrandManagement');
	}

	public function InterfaceEmailTranslatorAction()
	{
		$this->setScriptHeader('<script type="text/javascript" src="/'.SITE_PATH.'includes/tiny_mce/tiny_mce.js"></script>');
		define('HIDE_PRODUCT_SELECT', 'turu');
		$this->instantiateInterfaceFactory('InterfaceEmailTranslator');
	}

	public function InterfaceCountrySettingsOverviewAction() {
		define('HIDE_PRODUCT_SELECT', 'turu');
		$this->instantiateInterfaceFactory('InterfaceCountrySettingsOverview');
	}

	public function InterfaceBrandsOverviewAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/crso/InterfaceBrandsOverview.php');
		$this->setScriptId(61230);
		$settings = array('lists'=>array('BrandOverviewList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceProductFeeOverviewAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/crso/InterfaceProductFeeOverview.php');
		$this->setScriptId(61321);
		$this->instantiateInterfaceFactory(68);
	}

	public function InterfaceProductCategoryTranslateAction()
	{
		$this->setScriptId(61390);
		$this->instantiateInterfaceFactory(51);
	}

	public function InterfaceProductCategoryOverviewAction()
	{
		$this->instantiateInterfaceFactory(135);
	}

	public function InterfaceTrustOverviewAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/crso/InterfaceTrustOverview.php');
		$this->instantiateInterfaceFactory(99);
	}

	public function InterfaceCRSOSettingsAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/crso/InterfaceCRSOSettings.php');
		$this->instantiateInterfaceFactory(151);
	}
	/**#@+
	 * Lists
	 */
	public function InterfaceVATBlockAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/crso/InterfaceVATBlock.php');
		$settings = array('lists'=>array('BrandOverviewList'));
		$this->instantiateInterfaceFactory('InterfaceVATBlock',$settings);
	}

	public function InterfaceCRSODeclarationStatusAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/crso/InterfaceCRSODeclarationStatus.php');
		$this->setScriptId(61111);
		$settings = array('lists'=>array('DeclarationStatusList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceAnnualConfirmationListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/crso/InterfaceAnnualConfirmationList.php');
		$this->setScriptId(61115);
		$settings = array('lists'=>array('AnnualConfirmationList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceImportVsPutOnMarketListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/crso/InterfaceImportVsPutOnMarketList.php');
		$this->setScriptId(61116);
		$settings = array('lists'=>array('ImportVsPutOnMarketList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceDeclarationExportListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/crso/InterfaceDeclarationExportList.php');
		$this->setScriptId(61112);
		$settings = array('lists'=>array('DeclarationExportList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceResubmitDeviationListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/crso/InterfaceResubmitDeviationList.php');
		$this->setScriptId(61119);
		$settings = array('lists'=>array('ResubmitDeviationList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceProvDeclCmpListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/crso/InterfaceProvDeclCmpList.php');
		$this->setScriptId(61113);
		$settings = array('lists'=>array('ProvDeclCmpList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceProvDeclDataListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/crso/InterfaceProvDeclDataList.php');
		$this->setScriptId(61118);
		$settings = array('lists'=>array('ProvDeclDataList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}
	public function InterfaceProvDeclChangeListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/crso/InterfaceProvDeclChangeList.php');
		$this->setScriptId(61114);
		$settings = array('lists'=>array('ProvDeclChangeList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceRefundExportListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/crso/InterfaceRefundExportList.php');
		$this->setScriptId(61133);
		$settings = array('lists'=>array('RefundExportList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}
	public function InterfaceRefundOverviewAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/crso/InterfaceRefundOverview.php');
		$this->setScriptId(61132);
		$settings = array('lists'=>array('RefundOverviewList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceDocumentAccessListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/crso/InterfaceDocumentAccessList.php');
		$this->setScriptId(61140);
		$settings = array('lists'=>array('DocumentAccessList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceReminderOverviewListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/crso/InterfaceReminderOverviewList.php');
		$this->setScriptId(61150);
		$settings = array('lists'=>array('ReminderOverviewList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceLatePaymentOverviewListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/crso/InterfaceLatePaymentOverviewList.php');
		$this->setScriptId(61160);
		$settings = array('lists'=>array('LatePaymentOverviewList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceGuaranteeOverviewListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/crso/InterfaceGuaranteeOverviewList.php');
		$this->setScriptId(61170);
		$settings = array('lists'=>array('GuaranteeOverviewList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceImporterListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/crso/InterfaceImporterList.php');
		$this->setScriptId(61131);
		$settings = array('lists'=>array('NonParticipantImporterList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfacePoEDocumentListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/crso/InterfacePoEDocumentList.php');
		$this->setScriptId(61500);
		$settings = array('lists'=>array('PoEDocumentList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfacePoPListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/crso/InterfacePoPList.php');
		$this->setScriptId(61510);
		$settings = array('lists'=>array('PoPList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfacePoPDetailsListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/crso/InterfacePoPDetailsList.php');
		$this->setScriptId(61530);
		$settings = array('lists'=>array('PoPDetailsList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfacePoEDetailsListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/crso/InterfacePoEDetailsList.php');
		$this->setScriptId(61540);
		$settings = array('lists'=>array('PoEDetailsList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceVirtualStockListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/crso/InterfaceVirtualStockList.php');
		$this->setScriptId(61520);
		$settings = array('lists'=>array('VirtualStockList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceEAProducerRegistrationListAction()
	{
		define('HIDE_PRODUCT_SELECT', 1);
		$this->setProductSwitchLocation('/scripts/elc/crso/InterfaceEAProducerRegistrationList.php');
		$this->setScriptId(61410);
		$settings = array('lists'=>array('EAProducerRegistrationList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}
	public function InterfaceEAReportSettingsListAction()
	{
		define('HIDE_PRODUCT_SELECT', 1);
		$this->setProductSwitchLocation('/scripts/elc/crso/InterfaceEAReportSettingsList.php');
		$this->setScriptId(61420);
		$settings = array('lists'=>array('EAReportSettingsList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceEAReportDataListAction()
	{
		define('HIDE_PRODUCT_SELECT', 1);
		$this->setProductSwitchLocation('/scripts/elc/crso/InterfaceEAReportDataList.php');
		$this->setScriptId(61426);
		$settings = array('lists'=>array('EAReportDataList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}
	public function InterfacePoPAndRRCmpListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/crso/InterfacePoPAndRRCmpList.php');
		$this->setScriptId(61134);
		$settings = array('lists'=>array('PoPAndRRCmpList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfacePaymentAuthorisationOverviewAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/crso/InterfacePaymentAuthorisationOverview.php');
		$settings = array('classPrefix'=>'InterfaceAuthorisationOverviewPayment', 'appPath'=>'elc/common/');
		$this->instantiateInterfaceFactory(125,$settings);
	}

    public function InterfaceCustomerBalanceAction()
	{
		define('HIDE_PRODUCT_SELECT', 'turu');
		$this->setScriptId(61181);
		$settings = array('lists'=>array('AgeingCustomerBalanceList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

    public function InterfaceAgeingAlarmReportAction()
	{
		define('HIDE_PRODUCT_SELECT', 'turu');
		$this->setScriptId(61182);
		$settings = array('lists'=>array('AgeingAlarmList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceCQDeclarationGenericReportAction() {
		define('HIDE_PRODUCT_SELECT', 'turu');
		$this->CustomQuery('WEEECustomQueryDeclarationGenericReport',61117);
	}

	public function InterfaceCQRefundGenericReportAction() {
		define('HIDE_PRODUCT_SELECT', 'turu');
		$this->CustomQuery('WEEECustomQueryRefundGenericReport',61135);
	}

	public function InterfaceCQDeclarationYearOverviewAction() {
		define('HIDE_PRODUCT_SELECT', 'turu');
		$this->CustomQuery('WEEECustomQueryDeclarationYearOverview',61121);
	}

	public function InterfaceCQRefundYearOverviewAction() {
		define('HIDE_PRODUCT_SELECT', 'turu');
		$this->CustomQuery('WEEECustomQueryRefundYearOverview',61143);
	}


	/**#@-*/

	protected function CustomQuery($query,$script_id,$script_header='')
	{
		$this->setScriptId($script_id);
		$settings = array('cq'=>array($query));
		$this->setScriptHeader('<script type="text/javascript" src="'.REL_IWARE_INCLUDES.'IWCustomQueryFactory.js"></script>'.$script_header);
		$this->setExtraStyle('filtertable');
		$this->instantiateInterfaceFactory(162,$settings);
	}
	public function InterfaceEAReportsOverviewListAction()
	{
		define('HIDE_PRODUCT_SELECT', 1);
                $this->setProductSwitchLocation('/scripts/elc/crso/InterfaceEAReportsOverviewList.php');
		$this->setScriptId(61425);
		$settings = array('lists'=>array('EAReportsOverviewList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}
	public function InterfaceEAPRReportListAction()
	{
		define('HIDE_PRODUCT_SELECT', 1);
                $this->setProductSwitchLocation('/scripts/elc/crso/InterfaceEAPRReportList.php');
		$this->setScriptId(61430);
		$settings = array('lists'=>array('EAPRReportList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}
	public function InterfaceEAActualsReportListAction()
	{
		define('HIDE_PRODUCT_SELECT', 1);
                $this->setProductSwitchLocation('/scripts/elc/crso/InterfaceEAActualsReportList.php');
		$this->setScriptId(61431);
		$settings = array('lists'=>array('EAActualsReportList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}
	public function InterfaceEAWeightsB2BListAction()
	{
		define('HIDE_PRODUCT_SELECT', 1);
                $this->setProductSwitchLocation('/scripts/elc/crso/InterfaceEAWeightsB2BList.php');
		$this->setScriptId(61442);
		$settings = array('lists'=>array('EAWeightsB2BList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceTicketFormAction()
	{
		$this->func_input_filter = array($this, 'InterfaceNoFiltering');
		$this->setScriptId(61362);
		$this->instantiateInterfaceFactory(189);
	}

	public function InterfaceTicketDetailsAction()
	{
		$this->func_input_filter = array($this, 'InterfaceNoFiltering');
		$this->setScriptId(61361);
		$this->instantiateInterfaceFactory(188);
	}

	/* EAR */

	public function InterfaceDeEARDeclarationListAction()
	{

		$this->setScriptId(61270);

		global $langIf;
		setPageTitlePostfix('- ' .$langIf->gettext('Declaration'));

		$settings = array('lists'=>array('DeEARDeclarationList'));
		$this->instantiateInterfaceFactory(138,$settings);

	}

	public function InterfaceDeEARExportListAction()
	{

		global $langIf;
		setPageTitlePostfix('- ' .$langIf->gettext('Export'));

		$this->setScriptId(61270);
		$settings = array('lists'=>array('DeEARExportList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceDeEARNetResultListAction()
	{

		global $langIf;
		setPageTitlePostfix('- ' .$langIf->gettext('Net Result'));

		$this->setScriptId(61270);
		$settings = array('lists'=>array('DeEARNetResultList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	/* Authorities report */

	public function InterfaceAuthoritiesPoMListAction()
	{

		$this->setScriptId(61274);

		global $langIf;
		setPageTitlePostfix('- ' .$langIf->gettext('Declaration'));

		$settings = array('lists'=>array('DeEARDeclarationList'));
		$this->instantiateInterfaceFactory(138,$settings);

	}

	public function InterfaceAuthoritiesPoEListAction()
	{

		global $langIf;
		setPageTitlePostfix('- ' .$langIf->gettext('Export'));

		$this->setScriptId(61274);
		$settings = array('lists'=>array('DeEARExportList'));
		$this->instantiateInterfaceFactory(138,$settings);

	}

	public function InterfaceAuthoritiesNetResultListAction()
	{
		global $langIf;
		setPageTitlePostfix('- ' .$langIf->gettext('Net Result'));

		$this->setScriptId(61274);
		$settings = array('lists'=>array('DeEARNetResultList'));
		$this->instantiateInterfaceFactory(138,$settings);

	}

	public function InterfaceDimensionManagementAction() {

		$this->setScriptId(61392);
		$this->instantiateInterfaceFactory('InterfaceDimensionManagement');
	}

	public function InterfaceWasteReportingListAction()
	{
		define('HIDE_PRODUCT_SELECT', 1);
		$this->setProductSwitchLocation('/scripts/elc/crso/InterfaceWasteReportingList.php');
		$this->setScriptId(61620);
		$settings = array('lists'=>array('WasteReportingList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

}
?>
