<?php
require_once(ELC_CLASSES.'WEEEInterfaceHandler.php');
/**
 * TODO: merge this with the sysadmin one! v2.0
 * @package
 * @subpackage
 * @since 19-mrt-2007
 * @author Marten Koedam <marten@dalines.net>
 * @version $Id$
 * @copyright 2007 BaseSoft B.V.
 */
class WEEEOperatorInterfaceHandler extends WEEEInterfaceHandler
{
	protected function __construct($universe)
	{
		if($_SESSION['session_group_group_id']!=GROUP_SYSADMIN)
		{
			require_once(IWARE_SCRIPTS.'PermissionDenied.php');
			exit();
		}
		$this->universe = $universe;
	}
	public function InterfaceExportDownloadAction()
	{
		define('HIDE_PRODUCT_SELECT', 'turu');
		$this->instantiateInterfaceFactory('InterfaceExportDownload');
	}

	public function InterfaceImporterAction()
	{
		define('HIDE_PRODUCT_SELECT', 'turu');
		$this->setScriptId(63475);
		$this->instantiateInterfaceFactory(182);
	}

	public function InterfaceRequestDebitCreditIdAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/operator/InterfaceRequestDebitCreditId.php');
		$this->instantiateInterfaceFactory('InterfaceRequestDebitCreditId');
	}

	public function InterfaceEmailTranslatorAction()
	{
		$this->func_input_filter = array($this, 'InterfaceEmailTranslatorActionFilter');

		$this->setScriptHeader('<script type="text/javascript" src="/'.SITE_PATH.'includes/tiny_mce/tiny_mce.js"></script>');
		define('HIDE_PRODUCT_SELECT', 'turu');
		$this->instantiateInterfaceFactory('InterfaceEmailTranslator');
	}

	public function InterfaceEmailTranslatorActionFilter()
	{
	// make a copy of the thing we wanna filter
		$skip_html = false;
		if (isset($_POST['message']['html']))
		{
			$skip_html = true;
			$message_html = $_POST['message']['html'];
			$message_subject = $_POST['message']['subject'];
			unset($_POST['message']['html']);
			unset($_REQUEST['message']['html']);
			unset($_POST['message']['subject']);
			unset($_REQUEST['message']['subject']);
		}

		// do normal filtering
		$_GET = sanitize_array_recursive($_GET);
		$_POST = sanitize_array_recursive($_POST);
		$_REQUEST = sanitize_array_recursive($_REQUEST);

		// now lets put it back!
		if ($skip_html)
		{
			$_REQUEST['message']['html'] = $message_html;
			$_POST['message']['html'] = $message_html;
			$_REQUEST['message']['subject'] = $message_subject;
			$_POST['message']['subject'] = $message_subject;
		}
	}

	public function InterfacePublicUserOverviewAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/operator/InterfacePublicUserOverview.php');
		$this->instantiateInterfaceFactory('InterfacePublicUserOverview');
	}

	public function InterfaceCountryOverviewAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/operator/InterfaceCountryOverview.php');
		$this->instantiateInterfaceFactory('InterfaceCountryOverview');
	}

	public function InterfaceCRSOOverviewAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/operator/InterfaceCRSOOverview.php');
		$this->instantiateInterfaceFactory('InterfaceCRSOOverview');
	}

	public function InterfaceReviewRefundExportsAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/operator/InterfaceReviewRefundExports.php');
		$this->instantiateInterfaceFactory('InterfaceReviewRefundExports');
	}

	public function InterfaceCRSOProductManagementAction()
	{
		define('HIDE_PRODUCT_SELECT','tuut');
		$this->instantiateInterfaceFactory('InterfaceCRSOProductManagement');
	}

	public function InterfaceCRSOSettingsAction()
	{
		$this->instantiateInterfaceFactory(103);
	}

	public function InterfaceActivityReportAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/operator/InterfaceActivityReport.php');
		$this->instantiateInterfaceFactory(143);
	}

	public function InterfacePaymentAuthorisationOverviewAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/operator/InterfacePaymentAuthorisationOverview.php');
		$settings = array('classPrefix'=>'InterfaceAuthorisationOverviewPayment', 'appPath'=>'elc/common/');
		$this->instantiateInterfaceFactory(125,$settings);
	}

	public function InterfaceFAQManagementAction()
	{
		$this->func_input_filter = array($this, 'InterfaceFAQManagementActionFilter');

		$this->setProductSwitchLocation('/scripts/elc/operator/InterfaceFAQManagement.php');
		$this->setScriptHeader('<script type="text/javascript" src="/'.SITE_PATH.'includes/tiny_mce/tiny_mce.js"></script>');
		$this->instantiateInterfaceFactory('InterfaceFAQManagement');
	}

	public function InterfaceFAQManagementActionFilter()
	{
		// make a copy of the thing we wanna filter
		$skip_html = false;
		$answer = false;
		if (isset($_POST['faq']['handle']))
		{
			$skip_html = true;
			$faq_handle = $_POST['faq']['handle'];
			unset($_POST['faq']['handle']);
			unset($_REQUEST['faq']['handle']);
			$faq_quest = $_POST['faq_lang']['question_text'];
			unset($_POST['faq_lang']['question_text']);
			unset($_REQUEST['faq_lang']['question_text']);
			if(isset($_POST['faq_lang']['answer_text']))
			{
				$answer = true;
				$faq_answer = $_POST['faq_lang']['answer_text'];
				unset($_POST['faq_lang']['answer_text']);
				unset($_REQUEST['faq_lang']['answer_text']);
			}
		}

		// do normal filtering
		$_GET = sanitize_array_recursive($_GET);
		$_POST = sanitize_array_recursive($_POST);
		$_REQUEST = sanitize_array_recursive($_REQUEST);

		// now lets put it back!
		if ($skip_html)
		{
			$_REQUEST['faq']['handle'] = $faq_handle;
			$_POST['faq']['handle'] = $faq_handle;
			$_REQUEST['faq_lang']['question_text'] = $faq_quest;
			$_POST['faq_lang']['question_text'] = $faq_quest;
			if($answer)
			{
				$_REQUEST['faq_lang']['answer_text'] = $faq_answer;
				$_POST['faq_lang']['answer_text'] = $faq_answer;
			}
		}
	}

	public function InterfaceCountryLegalNoticeAction()
	{
		$this->setScriptHeader('<script type="text/javascript" src="/'.SITE_PATH.'includes/tiny_mce/tiny_mce.js"></script>');
		$this->instantiateInterfaceFactory('InterfaceCountryLegalNotice');
	}

	public function InterfaceAnnualConfirmationOverviewAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/operator/InterfaceAnnualConfirmationOverview.php');
		$this->instantiateInterfaceFactory(160);
	}

	public function InterfaceProductCategoryOverviewAction()
	{
		$this->instantiateInterfaceFactory(135);
	}

	public function InterfacePoPConfirmationsAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/operator/InterfacePoPConfirmations.php');
		$this->instantiateInterfaceFactory(164);
	}

	/**#@+
	 * Lists
	 */
	public function InterfaceDocumentAccessListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/operator/InterfaceDocumentAccessList.php');
		$this->setScriptId(63340);
		$settings = array('lists'=>array('DocumentAccessList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceOperatorDeclarationStatusAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/operator/InterfaceOperatorDeclarationStatus.php');
		$this->setScriptId(63311);
		$settings = array('lists'=>array('DeclarationStatusList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceDeclarationListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/operator/InterfaceDeclarationList.php');
		$this->setScriptId(63316);
		$settings = array('lists'=>array('DeclarationList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceProvDeclCmpListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/operator/InterfaceProvDeclCmpList.php');
		$this->setScriptId(63312);
		$settings = array('lists'=>array('ProvDeclCmpList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}
	public function InterfaceProvDeclDataListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/operator/InterfaceProvDeclDataList.php');
		$this->setScriptId(63325);
		$settings = array('lists'=>array('ProvDeclDataList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceImportVsPutOnMarketListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/operator/InterfaceImportVsPutOnMarketList.php');
		$this->setScriptId(63380);
		$settings = array('lists'=>array('ImportVsPutOnMarketList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceDeclarationExportListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/operator/InterfaceDeclarationExportList.php');
		$this->setScriptId(63314);
		$settings = array('lists'=>array('DeclarationExportList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceProvDeclChangeListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/operator/InterfaceProvDeclChangeList.php');
		$this->setScriptId(63317);
		$settings = array('lists'=>array('ProvDeclChangeList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceTrustListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/operator/InterfaceTrustList.php');
		$this->setScriptId(63319);
		$settings = array('lists'=>array('SubrogationTrusteeList','SubrogationSubrogatorList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceRefundRequestListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/operator/InterfaceRefundRequestList.php');
		$this->setScriptId(63313);
		$settings = array('lists'=>array('RefundRequestList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfacePoPAndRRCmpListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/operator/InterfacePoPAndRRCmpList.php');
		$this->setScriptId(63315);
		$settings = array('lists'=>array('PoPAndRRCmpList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceImporterListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/operator/InterfaceImporterList.php');
		$this->setScriptId(63321);
		$settings = array('lists'=>array('NonParticipantImporterList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceRefundOverviewAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/operator/InterfaceRefundOverview.php');
		$this->setScriptId(63322);
		$settings = array('lists'=>array('RefundOverviewList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceRefundExportListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/operator/InterfaceRefundExportList.php');
		$this->setScriptId(63323);
		$settings = array('lists'=>array('RefundExportList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfacePoPListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/operator/InterfacePoPList.php');
		$this->setScriptId(63324);
		$settings = array('lists'=>array('PoPList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceReminderOverviewListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/operator/InterfaceReminderOverviewList.php');
		$this->setScriptId(63360);
		$settings = array('lists'=>array('ReminderOverviewList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceAnnualConfirmationListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/operator/InterfaceAnnualConfirmationList.php');
		$this->setScriptId(63318);
		$settings = array('lists'=>array('AnnualConfirmationList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}
	public function InterfaceOperatorSummaryListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/operator/InterfaceOperatorSummaryList.php');
		$this->setScriptId(63390);
		$settings = array('lists'=>array('OperatorSummaryList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

        public function InterfaceCustomerBalanceReportAction()
        {
            define('HIDE_PRODUCT_SELECT', 'turu');
            $this->setScriptId(63396);
            $settings = array('lists' => array('AgeingCustomerBalanceList'));
            $this->instantiateInterfaceFactory(138,$settings);
        }

        public function InterfaceAgeingAlarmReportAction()
        {
            define('HIDE_PRODUCT_SELECT', 'turu');
            $this->setScriptId(63397);
            $settings = array('lists' => array('AgeingAlarmList'));
            $this->instantiateInterfaceFactory(138,$settings);
        }

	/**#@-*/
	/**#@+
	 * CustomQuery
	 */
	public function InterfaceCQCRSOSettingsAction()	{
		$this->setProductSwitchLocation('/scripts/elc/operator/InterfaceCQCRSOSettings.php');
		$this->CustomQuery('WEEECustomQueryCRSOProductOverview',63352);
	}
	public function InterfaceCQDeclarationAction()	{
		$this->setProductSwitchLocation('/scripts/elc/operator/InterfaceCQDeclaration.php');
		$this->CustomQuery('WEEECustomQueryDeclarationOverview',63353);
	}
	public function InterfaceCQMasterdataHashOverviewAction()	{
		$this->setProductSwitchLocation('/scripts/elc/operator/InterfaceCQMasterdataHashOverview.php');
		$this->CustomQuery('WEEECustomQueryMasterDataHash',63355);
	}
	public function InterfaceCQDeclarationGenericReportAction() {
		define('HIDE_PRODUCT_SELECT', 'turu');
		$this->CustomQuery('WEEECustomQueryDeclarationGenericReport',63500);
	}
	public function InterfaceCQRefundGenericReportAction() {
		define('HIDE_PRODUCT_SELECT', 'turu');
		$this->CustomQuery('WEEECustomQueryRefundGenericReport',63501);
	}
	/**
	 *
	 */
	public function InterfaceCQUserOverviewAction() {

		$script = sprintf('<script type="text/javascript">
			<!--
				function switchUserStatus(user_id)
				{
					var status = $(\'status_\'+user_id).value;
					var warn = "%s";
					if(status==1)
						warn = "%s";

					var jsParams = new Array();
					jsParams[\'user_id\'] = user_id;

					MessageBox.prototype.Question(\'%s\',warn, function(){
						changeImage(user_id,status);
						changeButton(user_id,status);
						jsbroker.call(\'switchUserStatus\',jsParams,function(){});
						$(\'status_\'+user_id).value = (status==1)?0:1;
					});
				}

				function changeImage(user_id,status)
				{
					var img = (status==1)?\'false\':\'true\';
					$(\'img_status_\'+user_id).src = \'/%simages/i-w/\'+img+\'.gif\';
				}

				function changeButton(user_id,status)
				{
					var msg = \'%s\';
					if(status==1)
						msg = \'%s\';
					$(\'btn_status_\'+user_id).value = msg;
				}
			-->
			</script>',
			jstr('MessageBoxContent: Change User to Active'),
			jstr('MessageBoxContent: Change User to Inactive'),
			jstr('MessageBoxTitle: Change User Status'),
			SITE_PATH,
			jstr('Deactivate User'),
			jstr('Activate User')
			);

		$this->CustomQuery('WEEECustomQueryUserOverview','',$script);
	}
	/**
	 *
	 */
	public function InterfaceCQParticipantOverviewAction()	{
		$this->setProductSwitchLocation('/scripts/elc/operator/InterfaceCQParticipantOverview.php');
		$script = sprintf('
			<script type="text/javascript">
			<!--
				function doLogin(loginname)
				{
					MessageBox.prototype.Question(
					\'%s\',
					\'%s\', function(){
						document.location.href = "/%sscripts/elc/public/DoLogin.php?loginname="+loginname;
					});
				}
			-->
			</script>',
			jstr('Login as AdminUser confirm title'),
			jstr('Login as AdminUser confirm'),
			SITE_PATH
			);
		$this->CustomQuery('WEEECustomQueryParticipantOverview',63351,$script);
	}

	public function InterfaceCQRefundImporterStatusAction()	{

		$script = sprintf('
			<script type="text/javascript">
			<!--
				function markAsResolved(rr_id)
				{
					var jsParams = new Array();
					jsParams[\'rr_id\'] = rr_id;

					MessageBox.prototype.Question(
					\'%s\',
					\'%s\', function() {
							jsbroker.call(\'refundImporterMarkAsResolved\',jsParams,function(){
								$(\'custom_query_form\').submit();
							});
						}
					)
				}
			-->
			</script>',
			jstr('Mark Refund Importer Status As Resolved Title'),
			jstr('Mark Refund Importer Status As Resolved Content')
			);

		$this->setProductSwitchLocation('/scripts/elc/operator/InterfaceCQRefundImporterStatus.php');
		$this->CustomQuery('WEEECustomQueryRefundImporterStatus',63357,$script);
	}

	public function InterfaceCQRefundExportAction()	{
		$this->setProductSwitchLocation('/scripts/elc/operator/InterfaceCQRefundExport.php');
		$this->CustomQuery('WEEECustomQueryRefundExportOverview',63354);
	}

	public function InterfaceCQDeclarationExportAction()	{
		$this->setProductSwitchLocation('/scripts/elc/operator/InterfaceCQDeclarationExport.php');
		$this->CustomQuery('WEEECustomQueryDeclarationExport',63358);
	}

	public function InterfaceCustomQueryAction()
	{
		$this->CustomQuery('WEEECustomQuery',63359);
	}

	protected function CustomQuery($query,$script_id,$script_header='')
	{
		$this->setScriptId($script_id);
		$settings = array('cq'=>array($query));
		$this->setScriptHeader('<script type="text/javascript" src="'.REL_IWARE_INCLUDES.'IWCustomQueryFactory.js"></script>'.$script_header);
		$this->setExtraStyle('filtertable');
		$this->instantiateInterfaceFactory(162,$settings);
	}
	public function InterfaceEAProducerRegistrationListAction()
	{
		define('HIDE_PRODUCT_SELECT', 1);
                $this->setProductSwitchLocation('/scripts/elc/operator/InterfaceEAProducerRegistrationList.php');
		$this->setScriptId(63486);
		$settings = array('lists'=>array('EAProducerRegistrationList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}
	public function InterfaceEAReportSettingsListAction()
	{
		define('HIDE_PRODUCT_SELECT', 1);
                $this->setProductSwitchLocation('/scripts/elc/operator/InterfaceEAReportSettingsList.php');
		$this->setScriptId(63488);
		$settings = array('lists'=>array('EAReportSettingsList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}
	public function InterfaceEAReportDataListAction()
	{
		define('HIDE_PRODUCT_SELECT', 1);
                $this->setProductSwitchLocation('/scripts/elc/operator/InterfaceEAReportDataList.php');
		$this->setScriptId(63494);
		$settings = array('lists'=>array('EAReportDataList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}
	public function InterfaceEAReportsOverviewListAction()
	{
		define('HIDE_PRODUCT_SELECT', 1);
                $this->setProductSwitchLocation('/scripts/elc/operator/InterfaceEAReportsOverviewList.php');
		$this->setScriptId(63489);
		$settings = array('lists'=>array('EAReportsOverviewList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}
	public function InterfaceEAPRReportListAction()
	{
		define('HIDE_PRODUCT_SELECT', 1);
                $this->setProductSwitchLocation('/scripts/elc/operator/InterfaceEAPRReportList.php');
		$this->setScriptId(63491);
		$settings = array('lists'=>array('EAPRReportList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}
	public function InterfaceEAActualsReportListAction()
	{
		define('HIDE_PRODUCT_SELECT', 1);
                $this->setProductSwitchLocation('/scripts/elc/operator/InterfaceEAActualsReportList.php');
		$this->setScriptId(63492);
		$settings = array('lists'=>array('EAActualsReportList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}
	public function InterfaceEAWeightsB2BListAction()
	{
		define('HIDE_PRODUCT_SELECT', 1);
                $this->setProductSwitchLocation('/scripts/elc/operator/InterfaceEAWeightsB2BList.php');
		$this->setScriptId(63497);
		$settings = array('lists'=>array('EAWeightsB2BList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}
	public function InterfaceUKXMLPreparationAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/operator/InterfaceUKXMLPreparation.php');
		$this->instantiateInterfaceFactory('InterfaceUKXMLPreparation');
	}
	public function InterfaceCrsoEADataAction()
	{
		define('HIDE_PRODUCT_SELECT', 1);
                $this->setProductSwitchLocation('/scripts/elc/operator/InterfaceCrsoEAData.php');
		$this->instantiateInterfaceFactory('InterfaceCrsoEAData');
	}
	/**#@-*/

        public function InterfaceElcInspectorAction()
	{
		$this->setScriptHeader('<script type="text/javascript" src="/'.SITE_PATH.'includes/i-w/NavigationNode.js"></script>');
		$this->setExtraStyle('navigation_node');
		$this->instantiateInterfaceFactory('InterfaceElcInspector');
	}
}
?>
