<?php
require_once(ELC_CLASSES.'WEEEInterfaceHandler.php');
/**
 * @package
 * @subpackage
 * @since 19-mrt-2007
 * @author Marten Koedam <marten@dalines.net>
 * @version $Id$
 * @copyright 2007 BaseSoft B.V.
 */
class WEEEParticipantInterfaceHandler extends WEEEInterfaceHandler
{
	protected function __construct($universe)
	{
		if(empty($_SESSION['participant_ids']))
		{
			require_once(IWARE_SCRIPTS.'PermissionDenied.php');
			exit();
		}

		$this->universe = $universe;
	}

	public function InterfaceUKXMLPreparationAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/participant/InterfaceUKXMLPreparation.php');
		define('SKIP_UK_XML_CHECK',true); // prevent endless redirect
		define('NO_VERIFY_PARTICIPANT_CHANGE_PRODUCER', true);
		$this->instantiateInterfaceFactory('InterfaceUKXMLPreparation');
	}
	public function InterfaceAnnualConfirmationAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/participant/InterfaceAnnualConfirmation.php');
		$this->instantiateInterfaceFactory('InterfaceAnnualConfirmation');
	}

	public function InterfaceChangeRequestAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/participant/InterfaceChangeRequest.php');
		$this->instantiateInterfaceFactory('InterfaceChangeRequest');
	}

	public function InterfaceRefundSettingsAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/participant/InterfaceRefundSettings.php');
		$this->instantiateInterfaceFactory('InterfaceRefundSettings');
	}

	public function InterfaceRegistrationOverviewAction()
	{
		define('HIDE_PRODUCT_SELECT', 'turu');
		$this->instantiateInterfaceFactory('InterfaceRegistrationOverview');
	}

	public function InterfaceRelationOverviewAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/participant/InterfaceRelationOverview.php');
		$this->instantiateInterfaceFactory('InterfaceRelationOverview');
	}

	public function InterfacePaymentConfirmationAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/participant/InterfacePaymentConfirmation.php');
		$this->instantiateInterfaceFactory('InterfacePaymentConfirmation');
	}

	public function InterfaceExportOverviewAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/participant/InterfaceExportOverview.php');
		$this->instantiateInterfaceFactory('InterfaceExportOverview');
	}

	public function InterfacePaymentOverviewAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/participant/InterfacePaymentOverview.php');
		$this->instantiateInterfaceFactory('InterfacePaymentOverview');
	}

	public function InterfaceRefundProcessStatusAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/participant/InterfaceRefundProcessStatus.php');
		$this->instantiateInterfaceFactory('InterfaceRefundProcessStatus');
	}

	public function InterfaceDeclarationOverviewAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/participant/InterfaceDeclarationOverview.php');
		$this->instantiateInterfaceFactory('InterfaceDeclarationOverview');
	}

	public function InterfaceParticipantNewCRSORegistrationAction()
	{
		$this->skipChecks = array('crsoid');
		$this->setScriptId(62414);
		$settings = array(
			'classPrefix'=>'InterfaceParticipantNewCRSORegistration',
			'appPath'=>'elc/participant/');

		define('SHOW_LANGUAGE_SELECT', 'turu');

		$product_id = isset($_REQUEST['product']['id'])?$_REQUEST['product']['id']:$_SESSION['selected_product_id'];

		require_once(ELC_CLASSES . 'CRSO.php');
		require_once(ELC_CLASSES . 'Country.php');
		require_once(ELC_CLASSES . 'Product.php');
		$crso = new CRSO(IWRegistry::registry('db'), array('relation' => new Relation(IWRegistry::registry('db'), (int)$_REQUEST['crso']['id'])));
		$crso->relation->set();
		$crso->relation->address->set();
		$country = new Country(IWRegistry::registry('db'), $crso->relation->address->country_id, true);
		$product = new Product(IWRegistry::registry('db'),(int)$product_id,true);

		$this->setHeader('<img src="/'.SITE_PATH.'images/elc/elc/logo.gif" align="middle" /> <span class="large">'.$crso->relation->name.' - '.$product->name.' ('. $country->name.')</span><br clear="all" /><br />');
		$this->instantiateInterfaceFactory(34,$settings);
	}

	public function InterfaceUserNewParticipantRegistrationAction()
	{
		$this->setScriptId(62416);
		$this->skipChecks = array('crsoid');
		$settings = array(
			'classPrefix'=>'InterfaceUserNewParticipantRegistration',
			'appPath'=>'elc/participant/');
		define('SHOW_LANGUAGE_SELECT', 'turu');

		require_once(ELC_CLASSES . 'CRSO.php');
		require_once(ELC_CLASSES . 'Country.php');
		$crso = new CRSO(IWRegistry::registry('db'), array('relation' => new Relation(IWRegistry::registry('db'), (int)$_REQUEST['crso']['id'])));
		$crso->relation->set();
		$crso->relation->address->set();
		$country = new Country(IWRegistry::registry('db'), $crso->relation->address->country_id, true);
		$this->setHeader('<img src="/'.SITE_PATH.'images/elc/elc/logo.gif" align="middle" /> <span class="large">'.$crso->relation->name.' ('. $country->name.')</span><br clear="all" /><br />');

		$this->instantiateInterfaceFactory(34,$settings);
	}

	public function InterfaceApplyAtParticipantAction()
	{
		$this->skipChecks = array('participantid','crsoid');
		$this->setScriptId(62412);
		$this->setExtraStyle('navigation_node');
		$this->setScriptHeader('<script type="text/javascript" src="/'.SITE_PATH.'includes/i-w/NavigationNode.js"></script>');
		$this->instantiateInterfaceFactory(81);
	}

	public function InterfaceTrustDetailAction()
	{
		$this->setScriptId(62429);
		$this->instantiateInterfaceFactory(90);
	}

	public function InterfaceSubrogationDetailAction()
	{
		$this->setScriptId(62424);
		$this->instantiateInterfaceFactory(90);
	}

	public function InterfaceSubrogationApplicationAction()
	{
		$this->skipChecks = array('trusteeid');
		$this->instantiateInterfaceFactory('InterfaceSubrogationApplication');
	}


	public function InterfaceTrustOverviewAction()
	{
		$this->instantiateInterfaceFactory(89);
	}

	public function InterfaceProvisionalDeclarationAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/participant/InterfaceProvisionalDeclaration.php');
		$this->instantiateInterfaceFactory(147);
	}

	public function InterfaceProvideProducerDataAction()
	{
		require_once(ELC_CLASSES . 'CRSO.php');
		require_once(ELC_CLASSES . 'Country.php');

		define('NO_VERIFY_PARTICIPANT_CHANGE_PRODUCER',true); // Prevent endless redirect

		$ru = new RelationUser(IWRegistry::registry('db'));
		// Check for admin status on this Participant
		$ru->set($_SESSION['session_user_id'],$_SESSION['selected_participant_id']);

		$script_id = 62571;

		if(!$ru->is_admin)
		{
			require_once(XHTML_HEADER);
		?>
		<script type="text/javascript"><!--
		addEvent(window,'load',function(){
			<?=jsMessageBox(MSG_BOX_INFO, IWRegistry::registry('langIf')->getText('Provide Producer Data'), IWRegistry::registry('langIf')->getText('The Admin user needs to provide data before continuing is possible')); ?>
		});
	--></script>
		<?php
			require_once(XHTML_FOOTER);
			exit();
		}
		if(isset($_REQUEST['finish']))
		{
			require_once(XHTML_HEADER);
		?>
		<script type="text/javascript"><!--
		addEvent(window,'load',function(){
			<?=jsMessageBox(MSG_BOX_INFO, IWRegistry::registry('langIf')->getText('Thank you'), IWRegistry::registry('langIf')->getText('Your application was completed succesfully.','function(){document.location.href=\'/'.SITE_PATH.'\';}')); ?>
		});
	--></script>
		<?php
			require_once(XHTML_FOOTER);
			exit();
		}

		$settings = array(
			'classPrefix'=>'InterfaceProvideProducerData',
			'appPath'=>'elc/participant/'); // Get the right interface
		$this->instantiateInterfaceFactory(34,$settings);
	}

	public function InterfaceBrandManagementAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/participant/InterfaceBrandManagement.php');
		$this->instantiateInterfaceFactory(154);
	}

	public function InterfaceParticipantUserOverviewAction()
	{
		define('HIDE_PRODUCT_SELECT', 1);
		$this->instantiateInterfaceFactory('InterfaceParticipantUserOverview');
	}

	public function InterfaceDeclarationIndexAction()
	{
		define('HIDE_PRODUCT_SELECT', 1);
		$this->instantiateInterfaceFactory('InterfaceDeclarationIndex');
	}

	public function InterfaceExportConfirmationOverviewAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/participant/InterfaceExportConfirmationOverview.php');
		if (isset($_REQUEST['process']) && $_REQUEST['process'] == 'print')
			self::$outputCall = 'getPrintInterface';
		$this->setScriptId(62540);
		$settings = array('classPrefix'=>'InterfaceConfirmationOverviewExport', 'appPath'=>'elc/common/');
		$this->instantiateInterfaceFactory(125,$settings);
	}

	/**#@+
	 * Lists
	 */
	public function InterfaceDeclarationListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/participant/InterfaceDeclarationList.php');
		$this->setScriptId(62211);
		$settings = array('lists'=>array('DeclarationList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceRefundExportListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/participant/InterfaceRefundExportList.php');
		$this->setScriptId(62212);
		$settings = array('lists'=>array('RefundExportList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceProvDeclCmpListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/participant/InterfaceProvDeclCmpList.php');
		$this->setScriptId(62213);
		$settings = array('lists'=>array('ProvDeclCmpList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceProvDeclChangeListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/participant/InterfaceProvDeclChangeList.php');
		$this->setScriptId(62214);
		$settings = array('lists'=>array('ProvDeclChangeList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceTrustListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/participant/InterfaceTrustList.php');
		$this->setScriptId(62215);
		$settings = array('lists'=>array('SubrogationTrusteeList','SubrogationSubrogatorList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}
	public function InterfaceNonParticipantInvoicesListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/participant/InterfaceNonParticipantInvoicesList.php');
		$this->setScriptId(62218);
		$settings = array('lists'=>array('NonParticipantInvoicesList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceRefundExportDocumentListAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/participant/InterfaceRefundExportDocumentList.php');
		$this->setScriptId(62216);
		$settings = array('lists'=>array('RefundConfirmationDocumentList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceReminderOverviewListAction()
	{
		define('HIDE_PRODUCT_SELECT',true);
		$this->setScriptId(62217);
		$settings = array('lists'=>array('ReminderOverviewList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceAgeingBalanceListAction()
	{
		define('HIDE_PRODUCT_SELECT',true);
		$this->setScriptId(62221);
		$settings = array('lists'=>array('AgeingCustomerBalanceList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceLatePaymentOverviewListAction()
	{
		define('HIDE_PRODUCT_SELECT',true);
		$this->setScriptId(62219);
		$settings = array('lists'=>array('LatePaymentOverviewList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceGuaranteeOverviewListAction()
	{
		define('HIDE_PRODUCT_SELECT',true);
		$this->setScriptId(62220);
		$settings = array('lists'=>array('GuaranteeOverviewList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceRefundOverviewAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/participant/InterfaceRefundOverview.php');
		$this->setScriptId(62128);
		$settings = array('lists'=>array('RefundOverviewList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceRefundConfirmationAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/participant/InterfaceRefundConfirmation.php');
		$this->setScriptId(62129);
		$this->instantiateInterfaceFactory('InterfaceRefundConfirmation');
	}

	public function InterfacePaymentFormAction()
	{
		if (isset($_REQUEST['process']) && $_REQUEST['process'] == 'print')
			self::$outputCall = 'getPrintInterface';
		$this->instantiateInterfaceFactory('InterfacePaymentForm');
	}

	/**#@-*/

	public function InterfaceWasteReportingListAction()
	{
		define('HIDE_PRODUCT_SELECT', 1);
		$this->setProductSwitchLocation('/scripts/elc/crso/InterfaceWasteReportingList.php');
		$this->setScriptId(62610);
		$settings = array('lists'=>array('WasteReportingList'));
		$this->instantiateInterfaceFactory(138,$settings);
	}

}
?>
