<?php
require_once(ELC_CLASSES.'WEEEInterfaceHandler.php');
/**
 * @package
 * @subpackage
 * @since 19-mrt-2007
 * @author Marten Koedam <marten@dalines.net>
 * @version $Id$
 * @copyright 2007 BaseSoft B.V.
 */

class WEEEPublicInterfaceHandler extends WEEEInterfaceHandler
{
	public function InterfaceParticipantRegistrationAction()
	{
		define('SHOW_LANGUAGE_SELECT', 'turu');
		define('HIDE_PRODUCT_SELECT', 'turu');

		$settings = array('classPrefix'=>'InterfaceParticipantRegistration', 'appPath'=>'elc/public/');
		$this->instantiateInterfaceFactory(34,$settings);

		require_once(ELC_CLASSES . 'CRSO.php');
		require_once(ELC_CLASSES . 'Country.php');
		require_once(ELC_CLASSES . 'Product.php');

		$crso_id = $this->ifObject->crso_id;

		$crso = new CRSO(IWRegistry::registry('db'), array('relation' => new Relation(IWRegistry::registry('db'), $crso_id)));
		$crso->relation->set();
		$crso->relation->address->set();
		$country = new Country(IWRegistry::registry('db'), $crso->relation->address->country_id, true);

		if (!empty($crso->relation->logo_url))
			$logo = $crso->relation->logo_url;
		else
			$logo = '/'.SITE_PATH.'images/elc/elc/logo.gif';

		$product = new Product(IWRegistry::registry('db'),$_SESSION['selected_product_id'],true);
		$this->setHeader('<img src="'.$logo.'" align="middle" /> <span class="large">'.$crso->relation->name.' - '.$product->name.' ('. $country->name.')</span><br clear="all" /><br />');
	}

	public function InterfaceUserProfileAction()
	{
		// Public user: ticket #
		if($_SESSION['session_user_id']===1) {
			require_once(IWARE_SCRIPTS.'PermissionDenied.php');
			exit();
		}
		define('NO_VERIFY_LAST_LOGIN','turu');
		define('NO_PASSWORD_EXPIRES','turu');
		// Check, cuz it can already be defined if Remote Viewer is on in the participant universe.
		defined('NO_VERIFY_MULTIPLE_PARTICIPANTS') || define('NO_VERIFY_MULTIPLE_PARTICIPANTS', true);
		define('SKIP_UK_XML_CHECK','turu');

		ob_start();
		if(isset($_REQUEST['first_time_login']))
		{
		?>
		<script type="text/javascript"><!--
			addEvent(window,'load',function(){
				<?=jsMessageBox(MSG_BOX_INFO, IWRegistry::registry('langIf')->getText('First Time Login'), IWRegistry::registry('langIf')->getText('This is your first login. Please change your password')); ?>
			});
		--></script>
		<?php
		}

		if(isset($_REQUEST['password_expired']))
		{
			if ($_SESSION['login_type'] == LOGIN_TOKEN)
				$popup_code = jsMessageBox(MSG_BOX_INFO, IWRegistry::registry('langIf')->getText('Set lost password'), IWRegistry::registry('langIf')->getText('Please set a new password'));
			else
				$popup_code = jsMessageBox(MSG_BOX_INFO, IWRegistry::registry('langIf')->getText('Password expired'), IWRegistry::registry('langIf')->getText('Your password has expired. Please change your password'));
		?>
		<script type="text/javascript"><!--
			addEvent(window,'load',function(){
				<?=$popup_code?>
			});
		--></script>
		<?php
		}

		if(isset($_REQUEST['multi_participant']))
		{
		?>
		<script type="text/javascript"><!--
			addEvent(window,'load',function(){
				<?=jsMessageBox(MSG_BOX_INFO, IWRegistry::registry('langIf')->getText('Multi Participant'), IWRegistry::registry('langIf')->getText('Multi-participant user. Please select one')); ?>
			});
		--></script>
		<?php
		}

		if(isset($_REQUEST['confirm']))
		{
			if(function_exists('apc_store'))
			{
				$lookup = 'SFMenu'.$_SESSION['session_user_id'].'_'.
					(isset($_SESSION['selected_participant_id'])?$_SESSION['selected_participant_id']:0).'_'.
					(isset($_SESSION['selected_product_id'])?$_SESSION['selected_product_id']:0).APC_SUFFIX;
				apc_delete($lookup);
			}
			session_destroy();
			session_regenerate_id(true); // regenerate session ID and delete session data

			?>
			<script type="text/javascript"><!--
				addEvent(window,'load',function(){
					<?=jsMessageBox(MSG_BOX_INFO, IWRegistry::registry('langIf')->getText('Password Change'), IWRegistry::registry('langIf')->getText('Your password has been changed. Please relogin with the new password.'), 'function(){document.location.href="/'.SITE_PATH.'";}'); ?>
				});
			--></script>
			<?php
		}

		// script for the password strength checker
		?>
		<script type="text/javascript" src="/<?php echo SITE_PATH; ?>includes/i-w/password_strength.js"></script>
		<?php
		// end of password strength checker script

		$scriptHeader = ob_get_clean();
		$this->setScriptHeader($scriptHeader);
		$this->instantiateInterfaceFactory('InterfaceUserProfile');
	}

	public function InterfaceNotificationDetailsAction()
	{
		$this->func_input_filter = array($this, 'InterfaceNotificationDetailsActionFilter');

		$this->setScriptHeader('<script type="text/javascript" src="/'.SITE_PATH.'includes/tiny_mce/tiny_mce.js"></script>');
		$this->setExtraStyle('notifications');
		$this->instantiateInterfaceFactory('InterfaceNotificationDetails');
	}

	public function InterfaceNotificationDetailsActionFilter()
	{
		//use <b> instead of <strong> and <i> instead of <em>
		$clean = array('<strong>','</strong>','<em>','</em>');
		$cleanwith = array('<b>','</b>','<i>','</i>');

		$replace = array('<br />','<b>','</b>','<i>','</i>','<ul>','</ul>',
						 '<li>','</li>','<ol>','</ol>','<u>','</u>');
		$with = array('[br /]','[b]','[/b]','[i]','[/i]','[ul]','[/ul]',
					  '[li]','[/li]','[ol]','[/ol]','[u]','[/u]');

		if (isset($_POST['reply']['message']))
		{
			$_POST['reply']['message'] = str_replace($clean,$cleanwith,$_POST['reply']['message']);
			$_REQUEST['reply']['message'] = str_replace($clean,$cleanwith,$_REQUEST['reply']['message']);

			$_POST['reply']['message'] = str_replace($replace,$with,$_POST['reply']['message']);
			$_REQUEST['reply']['message'] = str_replace($replace,$with,$_REQUEST['reply']['message']);
		}

		if (isset($_POST['forward']['message']))
		{
			$_POST['forward']['message'] = str_replace($clean,$cleanwith,$_POST['forward']['message']);
			$_REQUEST['forward']['message'] = str_replace($clean,$cleanwith,$_REQUEST['forward']['message']);

			$_POST['forward']['message'] = str_replace($replace,$with,$_POST['forward']['message']);
			$_REQUEST['forward']['message'] = str_replace($replace,$with,$_REQUEST['forward']['message']);
		}

		// do normal filtering
		$_GET = sanitize_array_recursive($_GET);
		$_POST = sanitize_array_recursive($_POST);
		$_REQUEST = sanitize_array_recursive($_REQUEST);

		// now lets put it back!
		if (isset($_POST['reply']['message']))
		{
			$_POST['reply']['message'] = str_replace($with,$replace,$_POST['reply']['message']);
			$_REQUEST['reply']['message'] = str_replace($with,$replace,$_REQUEST['reply']['message']);
		}

		if (isset($_POST['forward']['message']))
		{
			$_POST['forward']['message'] = str_replace($with,$replace,$_POST['forward']['message']);
			$_REQUEST['forward']['message'] = str_replace($with,$replace,$_REQUEST['forward']['message']);
		}
	}

	public function InterfaceNotificationHelpdeskAction()
	{
		$this->func_input_filter = array($this, 'InterfaceNotificationHelpdeskActionFilter');

		$this->setScriptHeader('<script type="text/javascript" src="/'.SITE_PATH.'includes/tiny_mce/tiny_mce.js"></script>');
		$this->setExtraStyle('notifications');
		$this->instantiateInterfaceFactory('InterfaceNotificationHelpdesk');
	}

	public function InterfaceNotificationHelpdeskActionFilter()
	{
		//use <b> instead of <strong> and <i> instead of <em>
		$clean = array('<strong>','</strong>','<em>','</em>');
		$cleanwith = array('<b>','</b>','<i>','</i>');

		$replace = array('<br />','<b>','</b>','<em>','</em>','<ul>','</ul>',
						 '<li>','</li>','<ol>','</ol>','<u>','</u>');
		$with = array('[br /]','[b]','[/b]','[i]','[/i]','[ul]','[/ul]',
					  '[li]','[/li]','[ol]','[/ol]','[u]','[/u]');

		if (isset($_POST['helpdesk']['message']))
		{
			$_POST['helpdesk']['message'] = str_replace($clean,$cleanwith,$_POST['helpdesk']['message']);
			$_REQUEST['helpdesk']['message'] = str_replace($clean,$cleanwith,$_REQUEST['helpdesk']['message']);

			$_POST['helpdesk']['message'] = str_replace($replace,$with,$_POST['helpdesk']['message']);
			$_REQUEST['helpdesk']['message'] = str_replace($replace,$with,$_REQUEST['helpdesk']['message']);
		}
		// do normal filtering
		$_GET = sanitize_array_recursive($_GET);
		$_POST = sanitize_array_recursive($_POST);
		$_REQUEST = sanitize_array_recursive($_REQUEST);

		// now lets put it back!
		if (isset($_POST['helpdesk']['message']))
		{
			$_POST['helpdesk']['message'] = str_replace($with,$replace,$_POST['helpdesk']['message']);
			$_REQUEST['helpdesk']['message'] = str_replace($with,$replace,$_REQUEST['helpdesk']['message']);
		}
	}

	public function InterfaceNotificationComposeAction()
	{
		$this->func_input_filter = array($this, 'InterfaceNotificationComposeActionFilter');

		$this->setScriptHeader('<script type="text/javascript" src="/'.SITE_PATH.'includes/tiny_mce/tiny_mce.js"></script>');
		$this->setExtraStyle('notifications');
		$this->instantiateInterfaceFactory('InterfaceNotificationCompose');
	}

	public function InterfaceNotificationComposeActionFilter()
	{
		//use <b> instead of <strong> and <i> instead of <em>
		$clean = array('<strong>','</strong>','<em>','</em>', '<pre>', '</pre>', '<p>', '</p>');
		$cleanwith = array('<b>','</b>','<i>','</i>', '', '', '', '');

		$replace = array('<br />','<b>','</b>','<i>','</i>','<ul>','</ul>',
						 '<li>','</li>','<ol>','</ol>','<u>','</u>');
		$with = array('[br /]','[b]','[/b]','[i]','[/i]','[ul]','[/ul]',
					  '[li]','[/li]','[ol]','[/ol]','[u]','[/u]');

		if (isset($_POST['compose']['message']))
		{
			$_POST['compose']['message'] = str_replace($clean,$cleanwith,$_POST['compose']['message']);
			$_REQUEST['compose']['message'] = str_replace($clean,$cleanwith,$_REQUEST['compose']['message']);

			$_POST['compose']['message'] = str_replace($replace,$with,$_POST['compose']['message']);
			$_REQUEST['compose']['message'] = str_replace($replace,$with,$_REQUEST['compose']['message']);
		}
		// do normal filtering
		$_GET = sanitize_array_recursive($_GET);
		$_POST = sanitize_array_recursive($_POST);
		$_REQUEST = sanitize_array_recursive($_REQUEST);

		// now lets put it back!
		if (isset($_POST['compose']['message']))
		{
			$_POST['compose']['message'] = str_replace($with,$replace,$_POST['compose']['message']);
			$_REQUEST['compose']['message'] = str_replace($with,$replace,$_REQUEST['compose']['message']);
		}
	}

	public function InterfaceNotificationInboxAction()
	{
		$this->setProductSwitchLocation('/scripts/elc/public/InterfaceNotificationInbox.php');
		$this->instantiateInterfaceFactory('InterfaceNotificationInbox');
	}

	public function InterfaceRefundEmailAuthorizeAction()
	{
		define('HIDE_PRODUCT_SELECT',true);
		$this->instantiateInterfaceFactory('InterfaceRefundEmailAuthorize');
	}

	public function InterfaceParticipantsOverviewAction()
	{
		define('HIDE_PRODUCT_SELECT', true);
		$this->instantiateInterfaceFactory('InterfaceParticipantsOverview');
	}

	public function InterfaceBrandsOverviewAction()
	{
		define('HIDE_PRODUCT_SELECT', true);
		$this->instantiateInterfaceFactory('InterfaceBrandsOverview');
	}
}
?>
