<?php
require_once(ELC_CLASSES.'WEEEInterfaceHandler.php');
/**
 * @package
 * @subpackage
 * @since 19-mrt-2007
 * @author Marten Koedam <marten@dalines.net>
 * @version $Id$
 * @copyright 2007 BaseSoft B.V.
 */
class WEEESysadminInterfaceHandler extends WEEEInterfaceHandler
{
	protected function __construct($universe)
	{
		if($_SESSION['session_group_group_id']!=GROUP_SYSADMIN)
		{
			require_once(IWARE_SCRIPTS.'PermissionDenied.php');
			exit();
		}
		$this->universe = $universe;
	}

	public function InterfaceFAQManagementAction()
	{
		$this->func_input_filter = array($this, 'InterfaceFAQManagementActionFilter');

		$this->setScriptHeader('<script type="text/javascript" src="/'.SITE_PATH.'includes/tiny_mce/tiny_mce.js"></script>');
		$this->instantiateInterfaceFactory('InterfaceFAQManagement');
	}

	public function InterfaceFAQManagementActionFilter()
	{
		// make a copy of the thing we wanna filter
		$skip_html = false;
		$answer = false;
		if (isset($_POST['faq']['handle']))
		{
			$skip_html = true;
			$faq_handle = $_POST['faq']['handle'];
			unset($_POST['faq']['handle']);
			unset($_REQUEST['faq']['handle']);
			$faq_quest = $_POST['faq_lang']['question_text'];
			unset($_POST['faq_lang']['question_text']);
			unset($_REQUEST['faq_lang']['question_text']);
			if(isset($_POST['faq_lang']['answer_text']))
			{
				$answer = true;
				$faq_answer = $_POST['faq_lang']['answer_text'];
				unset($_POST['faq_lang']['answer_text']);
				unset($_REQUEST['faq_lang']['answer_text']);
			}
		}

		// do normal filtering
		$_GET = sanitize_array_recursive($_GET);
		$_POST = sanitize_array_recursive($_POST);
		$_REQUEST = sanitize_array_recursive($_REQUEST);

		// now lets put it back!
		if ($skip_html)
		{
			$_REQUEST['faq']['handle'] = $faq_handle;
			$_POST['faq']['handle'] = $faq_handle;
			$_REQUEST['faq_lang']['question_text'] = $faq_quest;
			$_POST['faq_lang']['question_text'] = $faq_quest;
			if($answer)
			{
				$_REQUEST['faq_lang']['answer_text'] = $faq_answer;
				$_POST['faq_lang']['answer_text'] = $faq_answer;
			}
		}
	}

	public function InterfaceScheduleOverviewAction()
	{
		$settings = array('lists'=>array('ScheduleOverviewList'));
		$this->instantiateInterfaceFactory(138,$settings); // LIST
	}

	public function InterfaceEmailTranslatorAction()
	{
		$this->func_input_filter = array($this, 'InterfaceEmailTranslatorActionFilter');

		$this->setScriptHeader('<script type="text/javascript" src="/'.SITE_PATH.'includes/tiny_mce/tiny_mce.js"></script>');
		$this->instantiateInterfaceFactory('InterfaceEmailTranslator');
	}
	public function InterfaceEmailTranslatorActionFilter()
	{
		// make a copy of the thing we wanna filter
		$skip_html = false;
		if (isset($_POST['message']['html']))
		{
			$skip_html = true;
			$message_html = $_POST['message']['html'];
			$message_subject = $_POST['message']['subject'];
			unset($_POST['message']['html']);
			unset($_REQUEST['message']['html']);
			unset($_POST['message']['subject']);
			unset($_REQUEST['message']['subject']);
		}

		// do normal filtering
		$_GET = sanitize_array_recursive($_GET);
		$_POST = sanitize_array_recursive($_POST);
		$_REQUEST = sanitize_array_recursive($_REQUEST);

		// now lets put it back!
		if ($skip_html)
		{
			$_REQUEST['message']['html'] = $message_html;
			$_POST['message']['html'] = $message_html;
			$_REQUEST['message']['subject'] = $message_subject;
			$_POST['message']['subject'] = $message_subject;
		}
	}

	public function InterfaceElcInspectorAction()
	{
		$this->setScriptHeader('<script type="text/javascript" src="/'.SITE_PATH.'includes/i-w/NavigationNode.js"></script>');
		$this->setExtraStyle('navigation_node');
		$this->instantiateInterfaceFactory('InterfaceElcInspector');
	}

	public function InterfaceListGeneratorAction()
	{
		$this->setScriptId(69390);
		$settings = array('lists'=>array(
			'BrandOverviewList',
			'DeclarationStatusList',
			'ProvDeclCmpList',
			'RefundRequestList',
			'DeclarationExportList',
			'PoPAndRRCmpList',
			'RefundOverviewList',
			'NonParticipantImporterList',
			'ParticipantRegistrationList',
			'ScheduleOverviewList',
			'DeclarationList',
			'RefundExportList',
			'PoPList',
			'PoPDetailsList',
			'PoEDetailsList',
			'PoEDocumentList',
			'DocumentAccessList',
			'ProvDeclChangeList',
			'AnnualConfirmationList',
			'QuarterlyDeclarationConfirmationList',
			'QuarterlyRefundConfirmationList',
			'SubrogationTrusteeList',
			'SubrogationSubrogatorList',
			'ResubmitDeviationList',
			'ReminderOverviewList',
			'RefundConfirmationDocumentList',
			'OperatorSummaryList',
			'NonParticipantInvoicesList',
			'ImportVsPutOnMarketList',
			'OperatorSummaryList',
			'LatePaymentOverviewList',
			'GuaranteeOverviewList',
            'AgeingCustomerBalanceList',
            'AgeingAlarmList',
			'EAProducerRegistrationList',
			'EAReportSettingsList',
			'DeEARDeclarationList',
			'DeEARExportList',
			'DeEARNetResultList',
			'VirtualStockList'
		));
		$this->instantiateInterfaceFactory(138,$settings);
	}

	public function InterfaceDynamicReportAction()
	{
		$this->func_input_filter = array($this, 'InterfaceDynamicReportActionFilter');
		$this->instantiateInterfaceFactory(176);
	}

	public function InterfaceDynamicReportActionFilter()
	{
		$dr = $drf = array();
		if (isset($_POST['dr']))
		{
			$dr = $_POST['dr'];
			unset($_POST['dr']);
			unset($_REQUEST['dr']);
		}
		if(isset($_POST['drf']))
		{
			$drf = $_POST['drf'];
			unset($_POST['drf']);
			unset($_REQUEST['drf']);
		}

		// do normal filtering
		$_GET = sanitize_array_recursive($_GET);
		$_POST = sanitize_array_recursive($_POST);
		$_REQUEST = sanitize_array_recursive($_REQUEST);

		if(count($dr))
			$_REQUEST['dr'] = $_POST['dr'] = $dr;
		if(count($drf))
			$_REQUEST['drf'] = $_POST['drf'] = $drf;
	}

	public function InterfaceCustomQueryAction()
	{
		$this->CustomQuery('WEEECustomQuery',69370);
	}

	protected function CustomQuery($query,$script_id,$script_header='')
	{
		$this->setScriptId($script_id);
		$settings = array('cq'=>array($query));
		$this->setScriptHeader('<script type="text/javascript" src="'.REL_IWARE_INCLUDES.'IWCustomQueryFactory.js"></script>'.$script_header);
		$this->setExtraStyle('filtertable');
		$this->instantiateInterfaceFactory(162,$settings);
	}

	public function InterfaceDimensionManagementAction() {

		$this->setScriptId(69105);
		$this->instantiateInterfaceFactory('InterfaceDimensionManagement');
	}


}

?>
