<?php
require_once(ELC_CLASSES.'WEEECountry.php');
class WEEECountryNorwayEU extends WEEECountry
{
	function set($id='')
	{
		$id || $id = $this->id;
		if(!parent::set($id))
			return false;
		if($id == $this->getNorwayId())
			$this->region_id = REGION_EU;
		return true;
	}

	function selectByRegion($region_id,$return='q')
	{
		$sql = "SELECT COUNTRY_ID, `NAME`, `CODE`
			FROM TBL_COUNTRY
			WHERE REGION_ID = ?
			ORDER BY `CODE`, `NAME`";
		$q = $this->db->query($sql);
		$q->bind_values($region_id);
		$q->execute();
		if($return=='q')
			return $q;
		$rv = array();
		while($r = $q->fetch())
			$rv[$r->COUNTRY_ID] = $r->NAME;

		if(REGION_EU==$region_id)
			return $this->addNorwayToEU($rv);
		return $rv;
	}

	function fillInterfaceItem($interface_item, $selected_country_id)
	{
    	$q = $this->select();
    	$interface_item->firstOption = array('value'=>'','text'=>'- '.$interface_item->langIf->getText('Select Country').' -');
    	$group_eu = array();
    	$group_world = array();

    	$addToEU = $this->getNorwayId();

    	while ($row = $q->fetch())
    	{
    		$option = array('text'=>$row->NAME, 'value'=>$row->COUNTRY_ID,
				'selected'=>($row->COUNTRY_ID == $selected_country_id) ? 'selected' : false);
			if ($row->REGION_ID == REGION_EU )
				$group_eu[] = $option;
			elseif($row->COUNTRY_ID == $addToEU)
				$group_eu[] = $option;
			else
				$group_world[] = $option;
    	}

    	$interface_item->optgroups[] = array($interface_item->langIf->getText('Europe'), $group_eu);
    	$interface_item->optgroups[] = array($interface_item->langIf->getText('World'), $group_world);

	}

	private function addNorwayToEU($rv)
	{
		$rv[$this->getNorwayId()] = 'Norway';
		return $rv;
	}

	private function getNorwayId()
	{
		$sql = "SELECT COUNTRY_ID,`NAME`
			FROM TBL_COUNTRY
			WHERE `NAME` = ?";
		$q = $this->db->query($sql);
		$q->bind_values('Norway');
		$q->execute();
		$r = $q->fetch();
		return $r->COUNTRY_ID;
	}
}
?>
