<?php
/**
 * Created by PhpStorm.
 * User: marten
 * Date: 25/1/17
 * Time: 10:13
 */

class WasteReport extends AbstractObject {
	var $id;
	var $crso;
	var $participant;
	var $year;
	var $month;
	var $weight;

	function set($crso_id=null,$participant_id=null, $year=null, $month=null) {
		$crso_id || $crso_id = $this->crso->relation->id;
		$participant_id || $participant_id = $this->participant->relation->id;
		$year || $year = $this->year;
		$month || $month = $this->month;

		$sql = "SELECT CRSO_RELATION_ID, PARTICIPANT_RELATION_ID, `YEAR`, `MONTH`, WEIGHT, CREATED
			FROM TBL_WASTE_REPORT
			WHERE CRSO_RELATION_ID = ?
				AND PARTICIPANT_RELATION_ID = ?
				AND `YEAR` = ?
				AND `MONTH` = ?";
		$q = $this->db->query($sql);
		$q->bind_values(array($crso_id, $participant_id, $year, $month));
		$q->execute();
		if(!($r = $q->fetch()))
			return false;

		require_once(ELC_CLASSES.'CRSO.php');
		require_once(ELC_CLASSES.'Participant.php');
		$this->crso = new CRSO($this->db,array('relation'=>new Relation($this->db,$r->CRSO_RELATION_ID)));
		$this->participant = new Participant($this->db,array('relation'=>new Relation($this->db,$r->PARTICIPANT_RELATION_ID)));
		$this->year = $r->YEAR;
		$this->month = $r->MONTH;
		$this->weight = $r->WEIGHT;
		$this->created = $r->CREATED;

		return $this->complete = true;
	}

	function _initObjectMaps() {
		$this->objectmap['dbtable'] = 'TBL_WASTE_REPORT';
		$this->objectmap['primary']['crso->relation->id'] = 'CRSO_RELATION_ID';
		$this->objectmap['primary']['participant->relation->id'] = 'PARTICIPANT_RELATION_ID';
		$this->objectmap['primary']['year'] = 'YEAR';
		$this->objectmap['primary']['month'] = 'MONTH';
		$this->objectmap['properties']['weight'] = 'WEIGHT'; // in KG
		$this->objectmap['properties']['created'] = 'CREATED';
	}

}