<?php
/**
 * @author Nicoleta Militaru <nicoleta@basesoft.com>
 **/

class UKCRSOSupplier extends AbstractObject
{
	var $id;
	var $crso_id;
	var $type;
	var $approval_no;
	var $name;
	var $last_update;

	function set($dl_id='')
	{
		$dl_id || $dl_id = $this->id;

		$sql = " SELECT SUPPLIER_ID,`TYPE`,APPROVAL_NO,NAME,ACTIVE,CRSO_RELATION_ID,LAST_UPDATE
				FROM TBL_UK_CRSO_DATA_SUPPLIER
				WHERE SUPPLIER_ID = ? ";
		$q = $this->db->query($sql);
		$q->bind_values($dl_id);
		$q->execute();
		if(!($r = $q->fetch()))
			return false;
		$this->id = $r->SUPPLIER_ID;
		$this->crso_id = $r->CRSO_RELATION_ID;
		$this->type = $r->TYPE;
		$this->approval_no = $r->APPROVAL_NO;
		$this->name = $r->NAME;
		$this->active = $r->ACTIVE;
		$this->last_update = $r->LAST_UPDATE;
		return $this->complete = true;
	}

	function selectOverview($crso_id, $check_active=true)
	{
		$crso_id || $crso_id = $this->id;
		$sql = "SELECT `TYPE`,NAME,APPROVAL_NO, ACTIVE, SUPPLIER_ID
					FROM TBL_UK_CRSO_DATA_SUPPLIER
				WHERE CRSO_RELATION_ID = ?";
		if($check_active == true)
		  $sql = $sql." AND ACTIVE=1";
		$q = $this->db->query($sql);
		$q->bind_values($crso_id);
		$q->execute();
		return $q;
	}

	function setSuppliers($crso_id, $suppliers)
	{
		foreach($suppliers as $type=>$key){
			$sql = "SELECT SUPPLIER_ID
						FROM TBL_UK_CRSO_DATA_SUPPLIER
					WHERE CRSO_RELATION_ID=? AND `TYPE`=?";
			$qq = $this->db->query($sql);
			$qq->bind_values($crso_id,$type);
			$qq->execute();
			$count = 0;
			while($r=$qq->fetch()){
				if(!array_key_exists($count, $key)) break;
				$sql = "UPDATE TBL_UK_CRSO_DATA_SUPPLIER SET APPROVAL_NO=?, NAME=?, ACTIVE=?
						WHERE SUPPLIER_ID=?";
				$q = $this->db->query($sql);
				$q->bind_values($key[$count]['approval_no'], $key[$count]['name'], $key[$count]['active'], $r->SUPPLIER_ID);
				$q->execute();
				$count++;
			}

			for($i=$count;$i<count($key);$i++){
				$sql = "INSERT INTO TBL_UK_CRSO_DATA_SUPPLIER
						(CRSO_RELATION_ID,`TYPE`,APPROVAL_NO, NAME, `ACTIVE`)
						VALUES (?,?,?,?,?)";
				$q = $this->db->query($sql);
				$q->bind_values($crso_id,$type,$key[$i]['approval_no'], $key[$i]['name'], $key[$i]['active']);
				$q->execute();
			}

		}
	}

	function _initObjectMaps()
	{
		$this->objectmap['dbtable'] = 'TBL_UK_DATA_SUPPLIER';
		$this->objectmap['primary']['id'] = 'SUPPLIER_ID';
		$this->objectmap['properties']['crso_id'] = 'CRSO_RELATION_ID';
		$this->objectmap['properties']['type'] = 'TYPE';
		$this->objectmap['properties']['name'] = 'NAME';
		$this->objectmap['properties']['active'] = 'ACTIVE';
		$this->objectmap['properties']['approval_no'] = 'APPROVAL_NO';
		$this->objectmap['properties']['last_update'] = 'LAST_UPDATE';
	}
}
?>
