<?php
/**
 * Created on Dec 12, 2007
 *
 * @author Nicoleta Militaru <nicoleta@basesoft.com>
 **/

require_once(ELC_CLASSES.'CRSO.php');
require_once(ELC_CLASSES.'Participant.php');
require_once(ELC_CLASSES.'CRSOParticipant.php');

//business type
define('BUSINESS_COMPANY',1);
define('BUSINESS_PARTNERSHIP',2);

//Producer Registartion Scheme statuses
define('REG_NEW',1);
define('REG_MOD',2);
define('I_EXCLUDED_SETTINGS',3);
define('A_EXCLUDED_SETTINGS',4);
define('I_EXCLUDED_DATA_INCORRECT',5);
define('A_EXCLUDED_DATA_INCORRECT',6);
define('I_EXPORTED',7);
define('A_EXPORTED',8);
define('REG_ACCEPTED',9);

//WEEE Actuals Scheme
define('EXCLUDED_NO_PRN',1);
define('READY',2);
define('EXCLUDED_SETTINGS',3);
define('EXCLUDED_DATA_INCORRECT',4);
define('EXPORTED',5);
//WE DON'T USE THIS STATUS ANYMORE, if all ok, status READY will be used
define('WEEE_ACCEPTED',6);

define('SELLING_TECHNIQUE_DIRECT', 1);
define('SELLING_TECHNIQUE_INDIRECT', 2);
define('SELLING_TECHNIQUE_BOTH', 3);

define('PLACED_ON_MARKET_LARGE', 1);
define('PLACED_ON_MARKET_SMALL', 2);

define('OBLIGATION_TYPE_B2B', 1);
define('OBLIGATION_TYPE_B2C', 2);
define('OBLIGATION_TYPE_BOTH', 3);

class UKRegistrationData extends AbstractObject
{
	var $crso;
	var $participant;
	var $trading_name;
	var $turnover;
	var $selling_technique;
	var $cease_to_exist_date;
	var $placed_on_market;

	var $cfn = array();

	var $logo;
	var $business_type;
	var $business = array();
	var $ar = array();

	var $pr_status;
	var $weee_status;
	var $created;
	var $last_update;
	var $last_exported_pr;
	var $last_exported_weee;

	function set($crso_id='',$participant_id='')
	{

		//$crso_id || $crso_id = $this->crso->relation->id;
		//$participant_id || $participant_id = $this->participant->relation->id;
		if($crso_id == '')
			$crso_id = (isset($this->crso->relation->id))?$this->crso->relation->id:false;
		if($participant_id == '')
			$participant_id = (isset($this->participant->relation->id))?$this->participant->relation->id:false;

		$sql = " SELECT CRSO_RELATION_ID,PARTICIPANT_RELATION_ID,TRADING_NAME,ANNUAL_TURNOVER,
					SELLING_TECHNIQUE,CEASE_TO_EXIST_DATE,PLACED_ON_MARKET, OBLIGATION_TYPE,
					LOGO,CFN_TITLE,CFN_FORENAME,CFN_SURNAME,
					CFN_PHONE,CFN_MOBILE,CFN_FAX,CFN_EMAIL,CFN_BUILDING_NO,CFN_BUILDING,CFN_STREET,CFN_LOCALITY,CFN_CITY,
					CFN_COUNTRY,CFN_POSTAL_CODE,CFN_ADMINISTRATIVE_AREA,BUSINESS_TYPE,
					BUSINESS_NAME,BUSINESS_NUMBER,BUSINESS_PERSON_TITLE,BUSINESS_PERSON_FORENAME,BUSINESS_PERSON_SURNAME,
					BUSINESS_PHONE,BUSINESS_MOBILE,BUSINESS_FAX,BUSINESS_EMAIL,BUSINESS_BUILDING_NO,
					BUSINESS_BUILDING,BUSINESS_STREET,BUSINESS_LOCALITY,BUSINESS_CITY,BUSINESS_COUNTRY,
					BUSINESS_POSTAL_CODE,BUSINESS_ADMINISTRATIVE_AREA,
					AR_NAME,AR_TITLE,AR_FORENAME,AR_SURNAME,
					AR_PHONE,AR_MOBILE,AR_FAX,AR_EMAIL,AR_BUILDING_NO,
					AR_BUILDING,AR_STREET,AR_LOCALITY,AR_CITY,AR_COUNTRY,
					AR_POSTAL_CODE,AR_ADMINISTRATIVE_AREA,
					PR_STATUS,WEEE_STATUS,VAT_REGISTERED,CREATED,LAST_UPDATE,LAST_EXPORTED_PR,LAST_EXPORTED_WEEE
				FROM TBL_UK_REGISTRATION_DATA
				WHERE CRSO_RELATION_ID = ?
					AND PARTICIPANT_RELATION_ID = ?	";
		$q = $this->db->query($sql);
		$q->bind_values($crso_id,$participant_id);
		$q->execute();
		if(!($r = $q->fetch()))
			return false;

		$this->crso = new CRSO($this->db,array('relation'=> new Relation($this->db,$r->CRSO_RELATION_ID)));
		$this->participant = new Participant($this->db,array('relation'=> new Relation($this->db,$r->PARTICIPANT_RELATION_ID)));
		$this->trading_name = $r->TRADING_NAME;
		$this->turnover = $r->ANNUAL_TURNOVER;
		$this->selling_technique = $r->SELLING_TECHNIQUE;
		$this->obligation_type = $r->OBLIGATION_TYPE;
		$this->cease_to_exist_date = $r->CEASE_TO_EXIST_DATE;
		$this->placed_on_market = $r->PLACED_ON_MARKET;
		$this->logo = $r->LOGO;

		$this->business_type = $r->BUSINESS_TYPE;

		$this->cfn = array(
			'title'=>$r->CFN_TITLE,
			'forename'=>$r->CFN_FORENAME,
			'surname'=>$r->CFN_SURNAME,
			'phone_landline'=>$r->CFN_PHONE,
			'phone_mobile'=>$r->CFN_MOBILE,
			'fax'=>$r->CFN_FAX,
			'email'=>$r->CFN_EMAIL,
			'address'=>array(
						'building_number'=>$r->CFN_BUILDING_NO,
						'flatbuilding'=>$r->CFN_BUILDING,
						'street'=>$r->CFN_STREET,
						'locality'=>$r->CFN_LOCALITY,
						'town'=>$r->CFN_CITY,
						'country'=>$r->CFN_COUNTRY,
						'postcode'=>$r->CFN_POSTAL_CODE,
						'admin_area'=>$r->CFN_ADMINISTRATIVE_AREA
						)
			);

		$this->business = array(
			'name'=>$r->BUSINESS_NAME,
			'number'=>$r->BUSINESS_NUMBER,
			'title'=>$r->BUSINESS_PERSON_TITLE,
			'forename'=>$r->BUSINESS_PERSON_FORENAME,
			'surname'=>$r->BUSINESS_PERSON_SURNAME,
			'phone_landline'=>$r->BUSINESS_PHONE,
			'phone_mobile'=>$r->BUSINESS_MOBILE,
			'fax'=>$r->BUSINESS_FAX,
			'email'=>$r->BUSINESS_EMAIL,
			'address'=>array(
						'building_number'=>$r->BUSINESS_BUILDING_NO,
						'flatbuilding'=>$r->BUSINESS_BUILDING,
						'street'=>$r->BUSINESS_STREET,
						'locality'=>$r->BUSINESS_LOCALITY,
						'town'=>$r->BUSINESS_CITY,
						'country'=>$r->BUSINESS_COUNTRY,
						'postcode'=>$r->BUSINESS_POSTAL_CODE,
						'admin_area'=>$r->BUSINESS_ADMINISTRATIVE_AREA
						)
			);
		$this->ar = array(
			'name'=>$r->AR_NAME,
			'title'=>$r->AR_TITLE,
			'forename'=>$r->AR_FORENAME,
			'surname'=>$r->AR_SURNAME,
			'phone_landline'=>$r->AR_PHONE,
			'phone_mobile'=>$r->AR_MOBILE,
			'fax'=>$r->AR_FAX,
			'email'=>$r->AR_EMAIL,
			'address'=>array(
				'building_number'=>$r->AR_BUILDING_NO,
				'flatbuilding'=>$r->AR_BUILDING,
				'street'=>$r->AR_STREET,
				'locality'=>$r->AR_LOCALITY,
				'town'=>$r->AR_CITY,
				'country'=>$r->AR_COUNTRY,
				'postcode'=>$r->AR_POSTAL_CODE,
				'admin_area'=>$r->AR_ADMINISTRATIVE_AREA
			)
		);
		$this->pr_status = $r->PR_STATUS;
		$this->weee_status = $r->WEEE_STATUS;
		$this->vat_registered = $r->VAT_REGISTERED;
		$this->created = $r->CREATED;
		$this->last_update = $r->LAST_UPDATE;
		$this->last_exported_pr = $r->LAST_EXPORTED_PR;
		$this->last_exported_weee = $r->LAST_EXPORTED_WEEE;

		return $this->complete = true;
	}

	function _getLastUpdate($crso_id='',$participant_id='')
	{
		if($crso_id == '')
			$crso_id = (isset($this->crso->relation->id))?$this->crso->relation->id:false;
		if($participant_id == '')
			$participant_id = (isset($this->participant->relation->id))?$this->participant->relation->id:false;
		$sql = "SELECT LAST_UPDATE FROM TBL_UK_REGISTRATION_DATA WHERE
				CRSO_RELATION_ID = ? AND PARTICIPANT_RELATION_ID = ?";
		$q = $this->db->query($sql);
		$q->bind_values($crso_id,$participant_id);
		$q->execute();
		if(!($r = $q->fetch()))
			return false;
		return $r->LAST_UPDATE;
	}

	function insert()
	{
		$this->created = date('Y-m-d H:i:s');
		unset($this->last_update);
		$this->pr_status = REG_NEW;
		$this->weee_status = EXCLUDED_NO_PRN;
		return parent::insert();
	}

	function update()
	{
		$la = $this->last_update;
		unset($this->last_update);
		$a = parent::update();
		$this->last_update = $this->_getLastUpdate();

		if($la != $this->last_update)
			$this->_updatePRStatusMod();

		return $a;
	}

	function childUpdate($date)
	{
		$la = $this->last_update;
		$this->last_update = $date;
		$a = parent::update();

		if($la != $this->last_update)
			$this->_updatePRStatusMod();

		return $a;
	}

	public function getAllPRExported($crso)
	{
		$sql = "SELECT PARTICIPANT_RELATION_ID
				FROM TBL_UK_REGISTRATION_DATA
				WHERE
					CRSO_RELATION_ID = ? AND PR_STATUS IN (?,?) ";
		$q = $this->db->query($sql);
		$q->bind_values($crso,I_EXPORTED,A_EXPORTED);
		$q->execute();
		return $q;
	}
	public function getAllWeeeExported($crso)
	{
		$sql = "SELECT PARTICIPANT_RELATION_ID
				FROM TBL_UK_REGISTRATION_DATA
				WHERE
					CRSO_RELATION_ID = ? AND WEEE_STATUS = ? ";
		$q = $this->db->query($sql);
		$q->bind_values($crso,EXPORTED);
		$q->execute();
		return $q;
	}

	function setLastExportPR($date)
	{
		if(!isset($this->crso->relation->id) || !isset($this->participant->relation->id))
			return;
		//DONT LET LAST_UPDATE COLUMN CHANGE !!!
		$la = $this->last_update;
		$sql = "UPDATE TBL_UK_REGISTRATION_DATA SET LAST_EXPORTED_PR = ? WHERE
				CRSO_RELATION_ID = ? AND PARTICIPANT_RELATION_ID = ? ";
		$q = $this->db->query($sql);
		$q->bind_values($date,$this->crso->relation->id,$this->participant->relation->id);
		$q->execute();

		$sql = "UPDATE TBL_UK_REGISTRATION_DATA SET LAST_UPDATE = ? WHERE
				CRSO_RELATION_ID = ? AND PARTICIPANT_RELATION_ID = ? ";
		$q = $this->db->query($sql);
		$q->bind_values($la,$this->crso->relation->id,$this->participant->relation->id);
		$q->execute();

		$this->last_exported_pr = $date;
	}
	function setLastExportWeee($date)
	{
		if(!isset($this->crso->relation->id) || !isset($this->participant->relation->id))
			return;
		//DONT LET LAST_UPDATE COLUMN CHANGE !!!
		$la = $this->last_update;
		$sql = "UPDATE TBL_UK_REGISTRATION_DATA SET LAST_EXPORTED_WEEE = ? WHERE
				CRSO_RELATION_ID = ? AND PARTICIPANT_RELATION_ID = ? ";
		$q = $this->db->query($sql);
		$q->bind_values($date,$this->crso->relation->id,$this->participant->relation->id);
		$q->execute();

		$sql = "UPDATE TBL_UK_REGISTRATION_DATA SET LAST_UPDATE = ? WHERE
				CRSO_RELATION_ID = ? AND PARTICIPANT_RELATION_ID = ? ";
		$q = $this->db->query($sql);
		$q->bind_values($la,$this->crso->relation->id,$this->participant->relation->id);
		$q->execute();

		$this->last_exported_weee = $date;
	}

	function _executeUpdatePRStatus($new_pr)
	{
		//DONT LET LAST_UPDATE COLUMN CHANGE !!!
		$la = $this->last_update;
		$sql = "UPDATE TBL_UK_REGISTRATION_DATA SET PR_STATUS = ? WHERE
				CRSO_RELATION_ID = ? AND PARTICIPANT_RELATION_ID = ? ";
		$q = $this->db->query($sql);
		$q->bind_values($new_pr,$this->crso->relation->id,$this->participant->relation->id);
		$q->execute();

		$sql = "UPDATE TBL_UK_REGISTRATION_DATA SET LAST_UPDATE = ? WHERE
				CRSO_RELATION_ID = ? AND PARTICIPANT_RELATION_ID = ? ";
		$q = $this->db->query($sql);
		$q->bind_values($la,$this->crso->relation->id,$this->participant->relation->id);
		$q->execute();

		$this->pr_status = $new_pr;
	}
	function _updatePRStatusMod()
	{
		switch ($this->pr_status)
		{
			case REG_ACCEPTED:
				$new_pr = REG_MOD;
				break;
			default:
				$new_pr = $this->pr_status;
		}
		$this->_executeUpdatePRStatus($new_pr);
	}
	public function updatePRStatusSettingsInclude()
	{
		if(!isset($this->crso->relation->id) || !isset($this->participant->relation->id))
			return;
		switch ($this->pr_status)
		{
			case A_EXCLUDED_SETTINGS:
				if($this->last_exported_pr < $this->last_update)
					$new_pr = REG_MOD;
				else
					$new_pr = REG_ACCEPTED;
				break;
			case I_EXCLUDED_SETTINGS:
				$new_pr = REG_NEW;
				break;
			default:
				$new_pr = $this->pr_status;
			}

		$this->_executeUpdatePRStatus($new_pr);
		info('UK Producer '.$this->participant->relation->id.' included by settings');
	}

	public function updatePRStatusSettingsExclude()
	{
		if(!isset($this->crso->relation->id) || !isset($this->participant->relation->id))
			return;
		switch ($this->pr_status)
		{
			case REG_NEW:
			case I_EXCLUDED_DATA_INCORRECT:
				$new_pr = I_EXCLUDED_SETTINGS;
				break;
			case REG_ACCEPTED:
			case REG_MOD:
			case A_EXCLUDED_DATA_INCORRECT:
				$new_pr = A_EXCLUDED_SETTINGS;
				break;
			default:
				$new_pr = $this->pr_status;
			}

		$this->_executeUpdatePRStatus($new_pr);
		info('UK Producer '.$this->participant->relation->id.' excluded by settings');
	}

	public function updatePRStatusDataIncorrect()
	{
		if(!isset($this->crso->relation->id) || !isset($this->participant->relation->id))
			return;
		switch ($this->pr_status)
		{
			case REG_NEW:
			case I_EXPORTED:
				$new_pr = I_EXCLUDED_DATA_INCORRECT;
				break;
			case REG_MOD:
			case A_EXPORTED:
				$new_pr = A_EXCLUDED_DATA_INCORRECT;
				break;
			default:
				$new_pr = $this->pr_status;
			}

		$this->_executeUpdatePRStatus($new_pr);
	}

	public function updatePRStatusDataCorrect()
	{
		if(!isset($this->crso->relation->id) || !isset($this->participant->relation->id))
			return;
		switch ($this->pr_status)
		{
			case I_EXCLUDED_DATA_INCORRECT:
				$new_pr = REG_NEW;
				break;
			case A_EXCLUDED_DATA_INCORRECT:
				$new_pr = REG_MOD;
				break;
			default:
				$new_pr = $this->pr_status;
			}

		$this->_executeUpdatePRStatus($new_pr);
	}
	public function updatePRStatusAccepted()
	{
		if(!isset($this->crso->relation->id) || !isset($this->participant->relation->id))
			return;
		switch ($this->pr_status)
		{
			case I_EXPORTED:
			case A_EXPORTED:
				if($this->last_exported_pr < $this->last_update)
					$new_pr = REG_MOD;
				else
					$new_pr = REG_ACCEPTED;
				break;
			default:
				$new_pr = $this->pr_status;
			}

		$this->_executeUpdatePRStatus($new_pr);
	}
	public function updatePRStatusRejected()
	{
		if(!isset($this->crso->relation->id) || !isset($this->participant->relation->id))
			return;
		switch ($this->pr_status)
		{
			case I_EXPORTED:
				$new_pr = REG_NEW;
				break;
			case A_EXPORTED:
				$new_pr = REG_MOD;
				break;
			default:
				$new_pr = $this->pr_status;
			}

		$this->_executeUpdatePRStatus($new_pr);
	}
	public function updatePRStatusExported()
	{
		if(!isset($this->crso->relation->id) || !isset($this->participant->relation->id))
			return;
		switch ($this->pr_status)
		{
			case REG_NEW:
				$new_pr = I_EXPORTED;
				break;
			case REG_MOD:
				$new_pr = A_EXPORTED;
				break;
			default:
				$new_pr = $this->pr_status;
			}

		$this->_executeUpdatePRStatus($new_pr);
	}

	public function updateVATRegistered($v)
    {
        if(!isset($this->crso->relation->id) || !isset($this->participant->relation->id))
            return;
        $newpr = $this->pr_status;
        if($this->pr_status == REG_ACCEPTED)
            $newpr = REG_MOD;
        $sql = "UPDATE TBL_UK_REGISTRATION_DATA SET VAT_REGISTERED = ?, PR_STATUS = ?  WHERE
                CRSO_RELATION_ID = ? AND PARTICIPANT_RELATION_ID = ? ";
        $q = $this->db->query($sql);
        $q->bind_values($v,$newpr,$this->crso->relation->id,$this->participant->relation->id);
        $q->execute();
        info('UK Producer '.$this->participant->relation->id.' vat_registered set to '.$v);
    }

	function _executeUpdateWEEEStatus($new_weee)
	{
		//DONT LET LAST_UPDATE CHANGE !!!
		$la = $this->last_update;
		$sql = "UPDATE TBL_UK_REGISTRATION_DATA SET WEEE_STATUS = ? WHERE
				CRSO_RELATION_ID = ? AND PARTICIPANT_RELATION_ID = ? ";
		$q = $this->db->query($sql);
		$q->bind_values($new_weee,$this->crso->relation->id,$this->participant->relation->id);
		$q->execute();

		$sql = "UPDATE TBL_UK_REGISTRATION_DATA SET LAST_UPDATE = ? WHERE
				CRSO_RELATION_ID = ? AND PARTICIPANT_RELATION_ID = ? ";
		$q = $this->db->query($sql);
		$q->bind_values($la,$this->crso->relation->id,$this->participant->relation->id);
		$q->execute();

		$this->weee_status = $new_weee;
	}
	public function updateWEEEStatusPRNProvided()
	{
		if(!isset($this->crso->relation->id) || !isset($this->participant->relation->id))
			return;
		switch ($this->weee_status)
		{
			case EXCLUDED_NO_PRN:
				$cp = new CRSOParticipant($this->db);
				$cp->set($this->crso->relation->id,$this->participant->relation->id);
				if($cp->hasCorrectPRN())
					$new_pr = READY;
				else
					$new_pr = EXCLUDED_NO_PRN;
				break;
			default:
				$new_pr = $this->weee_status;
			}

		$this->_executeUpdateWEEEStatus($new_pr);
	}
	public function updateWEEEStatusSettingsInclude()
	{
		if(!isset($this->crso->relation->id) || !isset($this->participant->relation->id))
			return;
		switch ($this->weee_status)
		{
			case EXCLUDED_SETTINGS:
				$cp = new CRSOParticipant($this->db);
				$cp->set($this->crso->relation->id,$this->participant->relation->id);
				if($cp->hasCorrectPRN())
					$new_pr = READY;
				else
					$new_pr = EXCLUDED_NO_PRN;
				break;
			default:
				$new_pr = $this->weee_status;
			}

		$this->_executeUpdateWEEEStatus($new_pr);
	}

	public function updateWEEEStatusSettingsExclude()
	{
		if(!isset($this->crso->relation->id) || !isset($this->participant->relation->id))
			return;
		switch ($this->weee_status)
		{
			case EXPORTED:
				$new_pr = $this->weee_status;
				break;
			default:
				$new_pr = EXCLUDED_SETTINGS;
			}

		$this->_executeUpdateWEEEStatus($new_pr);
	}

	public function updateWEEEStatusDataIncorrect()
	{
		if(!isset($this->crso->relation->id) || !isset($this->participant->relation->id))
			return;
		switch ($this->weee_status)
		{
			case READY:
			case EXCLUDED_NO_PRN:
			case EXPORTED:
				$new_pr = EXCLUDED_DATA_INCORRECT;
				break;
			default:
				$new_pr = $this->weee_status;
			}

		$this->_executeUpdateWEEEStatus($new_pr);
	}

	public function updateWEEEStatusDataCorrect()
	{
		if(!isset($this->crso->relation->id) || !isset($this->participant->relation->id))
			return;
		switch ($this->weee_status)
		{
			case EXCLUDED_DATA_INCORRECT:
				$cp = new CRSOParticipant($this->db);
				$cp->set($this->crso->relation->id,$this->participant->relation->id);
				if($cp->hasCorrectPRN())
					$new_pr = READY;
				else
					$new_pr = EXCLUDED_NO_PRN;
				break;
			default:
				$new_pr = $this->weee_status;
			}

		$this->_executeUpdateWEEEStatus($new_pr);
	}
	public function updateWEEEStatusAccepted()
	{
		if(!isset($this->crso->relation->id) || !isset($this->participant->relation->id))
			return;
		switch ($this->weee_status)
		{
			case EXPORTED:
				//$new_pr = WEEE_ACCEPTED;
				$new_pr = READY;
				break;
			default:
				$new_pr = $this->weee_status;
			}

		$this->_executeUpdateWEEEStatus($new_pr);
	}
	public function updateWEEEStatusRejected()
	{
		if(!isset($this->crso->relation->id) || !isset($this->participant->relation->id))
			return;
		switch ($this->weee_status)
		{
			case EXPORTED:
				$new_pr = READY;
				break;
			default:
				$new_pr = $this->weee_status;
			}

		$this->_executeUpdateWEEEStatus($new_pr);
	}
	public function updateWEEEStatusExported()
	{
		if(!isset($this->crso->relation->id) || !isset($this->participant->relation->id))
			return;
		switch ($this->weee_status)
		{
			case READY:
				$new_pr = EXPORTED;
				break;
			default:
				$new_pr = $this->weee_status;
			}

		$this->_executeUpdateWEEEStatus($new_pr);
	}

	static public function translatePRStatus($langIf,$status)
	{
		switch($status)
		{
			case REG_NEW:
				return array($langIf->getText('New Registration'), 'status_late');
			case REG_MOD:
				return array($langIf->getText('Registration data changed'), 'status_late');
			case I_EXCLUDED_SETTINGS:
				return array($langIf->getText('Excluded - settings (I)'), 'status_forfeit');
			case A_EXCLUDED_SETTINGS:
				return array($langIf->getText('Excluded - settings (A)'), 'status_forfeit');
			case I_EXCLUDED_DATA_INCORRECT:
				return array($langIf->getText('Excluded - data incorrect (I)'), 'status_forfeit');
			case A_EXCLUDED_DATA_INCORRECT:
				return array($langIf->getText('Excluded - data incorrect (A)'), 'status_forfeit');
			case I_EXPORTED:
				return array($langIf->getText('Exported NEW'), 'status_declared');
			case A_EXPORTED:
				return array($langIf->getText('Exported MOD'), 'status_declared');
			case REG_ACCEPTED:
				return array($langIf->getText('Data Accepted'), 'status_verified');
		}
	}

	static public function translateWEEEStatus($langIf,$status)
	{
		switch($status)
		{
			case EXCLUDED_NO_PRN:
				return array($langIf->getText('Excluded - NO Reg No'), 'status_forfeit');
			case READY:
				return array($langIf->getText('Good for export'), 'status_late');
			case EXCLUDED_SETTINGS:
				return array($langIf->getText('Excluded - settings'), 'status_forfeit');
			case EXCLUDED_DATA_INCORRECT:
				return array($langIf->getText('Excluded - data incorrect'), 'status_forfeit');
			case EXPORTED:
				return array($langIf->getText('Exported'), 'status_declared');
			case WEEE_ACCEPTED:
				return array($langIf->getText('Data Accepted'), 'status_verified');
		}
	}

	public function getDataSetPR($crso_id)
	{
		$sql = " (SELECT UK.PARTICIPANT_RELATION_ID,CP.PRODUCER_REG_NO AS PRN,
					TRADING_NAME,ANNUAL_TURNOVER,LOGO,CFN_TITLE,CFN_FORENAME,CFN_SURNAME,CFN_PHONE,
					CFN_MOBILE,CFN_FAX,CFN_EMAIL,CFN_BUILDING_NO,CFN_BUILDING,CFN_STREET,CFN_LOCALITY,CFN_CITY,
					CFN_COUNTRY,CFN_POSTAL_CODE,CFN_ADMINISTRATIVE_AREA,BUSINESS_TYPE,BUSINESS_NAME,
					BUSINESS_NUMBER,BUSINESS_PERSON_TITLE,BUSINESS_PERSON_FORENAME,BUSINESS_PERSON_SURNAME,
					BUSINESS_PHONE,BUSINESS_MOBILE,BUSINESS_FAX,BUSINESS_EMAIL,BUSINESS_BUILDING_NO,
					BUSINESS_BUILDING,BUSINESS_STREET,BUSINESS_LOCALITY,BUSINESS_CITY,BUSINESS_COUNTRY,
					BUSINESS_POSTAL_CODE,BUSINESS_ADMINISTRATIVE_AREA,PR_STATUS,VAT_REGISTERED,

					-- v3 fields
					PLACED_ON_MARKET, SELLING_TECHNIQUE, CEASE_TO_EXIST_DATE, OBLIGATION_TYPE,
					AR_NAME, AR_TITLE, AR_FORENAME, AR_SURNAME, AR_PHONE, AR_MOBILE, AR_FAX, AR_EMAIL, AR_BUILDING_NO,
					AR_BUILDING, AR_STREET, AR_LOCALITY, AR_CITY, AR_COUNTRY, AR_POSTAL_CODE, AR_ADMINISTRATIVE_AREA


				FROM TBL_UK_REGISTRATION_DATA UK
				INNER JOIN TBL_CRSO_PARTICIPANT CP
					ON UK.CRSO_RELATION_ID = CP.CRSO_RELATION_ID
					AND UK.PARTICIPANT_RELATION_ID = CP.PARTICIPANT_RELATION_ID
					AND CP.PRODUCER_REG_NO REGEXP '^((WEE\/)[A-Z]{2}[0-9]{4}[A-Z]{2})?$'
				WHERE UK.CRSO_RELATION_ID = ?
					AND PR_STATUS=2)
				UNION
				(SELECT UK.PARTICIPANT_RELATION_ID,CP.PRODUCER_REG_NO AS PRN,
					TRADING_NAME,ANNUAL_TURNOVER,LOGO,CFN_TITLE,CFN_FORENAME,CFN_SURNAME,CFN_PHONE,
					CFN_MOBILE,CFN_FAX,CFN_EMAIL,CFN_BUILDING_NO,CFN_BUILDING,CFN_STREET,CFN_LOCALITY,CFN_CITY,
					CFN_COUNTRY,CFN_POSTAL_CODE,CFN_ADMINISTRATIVE_AREA,BUSINESS_TYPE,BUSINESS_NAME,
					BUSINESS_NUMBER,BUSINESS_PERSON_TITLE,BUSINESS_PERSON_FORENAME,BUSINESS_PERSON_SURNAME,
					BUSINESS_PHONE,BUSINESS_MOBILE,BUSINESS_FAX,BUSINESS_EMAIL,BUSINESS_BUILDING_NO,
					BUSINESS_BUILDING,BUSINESS_STREET,BUSINESS_LOCALITY,BUSINESS_CITY,BUSINESS_COUNTRY,
					BUSINESS_POSTAL_CODE,BUSINESS_ADMINISTRATIVE_AREA,PR_STATUS,VAT_REGISTERED,

					-- v3 fields
					PLACED_ON_MARKET, SELLING_TECHNIQUE, CEASE_TO_EXIST_DATE, OBLIGATION_TYPE,
					AR_NAME, AR_TITLE, AR_FORENAME, AR_SURNAME, AR_PHONE, AR_MOBILE, AR_FAX, AR_EMAIL, AR_BUILDING_NO,
					AR_BUILDING, AR_STREET, AR_LOCALITY, AR_CITY, AR_COUNTRY, AR_POSTAL_CODE, AR_ADMINISTRATIVE_AREA

				FROM TBL_UK_REGISTRATION_DATA UK
				INNER JOIN TBL_CRSO_PARTICIPANT CP
					ON UK.CRSO_RELATION_ID = CP.CRSO_RELATION_ID
					AND UK.PARTICIPANT_RELATION_ID = CP.PARTICIPANT_RELATION_ID
				WHERE UK.CRSO_RELATION_ID = ?
					AND PR_STATUS=1)
				";
		$q = $this->db->query($sql);
		$q->bind_values($crso_id,$crso_id);
		$q->execute();
		return $q;
	}
	public function getDataSetWeee($crso_id, $year, $quarter, $per_year=false)
	{
		$current = false;
		if($per_year == true)
			$current = true;
		else{
			$rep =  "
				SELECT MAX(UKR.REPORT_ID) AS REPORT_ID
				FROM TBL_UK_REPORTS UKR
				WHERE UKR.CRSO_RELATION_ID = ?
				AND UKR.YEAR = ? AND UKR.QUARTER = ?
				AND UKR.STATUS=2";
			$qr = $this->db->query($rep);
			$qr->bind_values($crso_id, $year, $quarter);
			$qr->execute();
			$rid = $qr->fetch()->REPORT_ID;
			if(!$rid)
				$current = true;
		}
		// if there are no exports for this quarter, get current dataset
		if($current == true){
			$sql = "SELECT UK.PARTICIPANT_RELATION_ID, UK.TRADING_NAME, UK.BUSINESS_NAME, UK.OBLIGATION_TYPE,
					CP.PRODUCER_REG_NO as PRN, UK.WEEE_STATUS, UK.PR_STATUS, UK.VAT_REGISTERED, UK.CREATED
					FROM TBL_UK_REGISTRATION_DATA UK
					INNER JOIN TBL_CRSO_PARTICIPANT CP
						ON UK.CRSO_RELATION_ID = CP.CRSO_RELATION_ID
						AND UK.PARTICIPANT_RELATION_ID = CP.PARTICIPANT_RELATION_ID
					WHERE UK.CRSO_RELATION_ID = ?";
			$q = $this->db->query($sql);
			$q->bind_values($crso_id);
		}
		// else get same dataset as for the last report exported for this quarter
		// (keep those statuses except for the ones for producers excluded because of no PRN, which will use current statuses)
		else {
			$sql = "SELECT UK.PARTICIPANT_RELATION_ID, UKREG.TRADING_NAME, UKREG.BUSINESS_NAME,
					CP.PRODUCER_REG_NO as PRN, UKREG.OBLIGATION_TYPE,
					IF(UK.WEEE_STATUS = 1, UKREG.WEEE_STATUS, UK.WEEE_STATUS) AS WEEE_STATUS, UK.VAT_REGISTERED,
					UK.PR_STATUS, UKREG.CREATED
					FROM TBL_UK_REPORT_DATA UK
					INNER JOIN TBL_UK_REGISTRATION_DATA UKREG
						ON UKREG.CRSO_RELATION_ID = UK.CRSO_RELATION_ID
						AND UKREG.PARTICIPANT_RELATION_ID = UK.PARTICIPANT_RELATION_ID
					INNER JOIN TBL_CRSO_PARTICIPANT CP
						ON UK.CRSO_RELATION_ID = CP.CRSO_RELATION_ID
						AND UK.PARTICIPANT_RELATION_ID = CP.PARTICIPANT_RELATION_ID
					WHERE UK.CRSO_RELATION_ID = ?
					AND UK.REPORT_ID=?";
			$q = $this->db->query($sql);
			$q->bind_values($crso_id, $rid);
		}
		$q->execute();
		return $q;
	}

	public function hasRegistrationData($crso_id='',$participant_id='')
	{
		if($crso_id == '')
			$crso_id = (isset($this->crso->relation->id))?$this->crso->relation->id:false;
		if($participant_id == '')
			$participant_id = (isset($this->participant->relation->id))?$this->participant->relation->id:false;

		$sql = " SELECT PARTICIPANT_RELATION_ID FROM TBL_UK_REGISTRATION_DATA
				WHERE CRSO_RELATION_ID = ?
					AND PARTICIPANT_RELATION_ID = ?	";
		$q = $this->db->query($sql);
		$q->bind_values($crso_id,$participant_id);
		$q->execute();
		if(!($r = $q->fetch()))
			return false;
		return true;
	}
	public function hasPreviousWeeeExports($year, $crso_id='',$participant_id='')
	{
		if($crso_id == '')
			$crso_id = (isset($this->crso->relation->id))?$this->crso->relation->id:false;
		if($participant_id == '')
			$participant_id = (isset($this->participant->relation->id))?$this->participant->relation->id:false;

		$sql = " SELECT LAST_EXPORTED_WEEE
				FROM TBL_UK_REGISTRATION_DATA
				WHERE CRSO_RELATION_ID = ?
					AND PARTICIPANT_RELATION_ID = ?
					AND YEAR(LAST_EXPORTED_WEEE) = ?";
		$q = $this->db->query($sql);
		$q->bind_values($crso_id,$participant_id, $year);
		$q->execute();
		if(!($r = $q->fetch()))
			return false;
		if(!isset($r->LAST_EXPORTED_WEEE) || $r->LAST_EXPORTED_WEEE == '')
			return False;
		return true;
	}

	function hasPRDataForExport($crso_id)
	{
		$sql = " SELECT PARTICIPANT_RELATION_ID
				FROM TBL_UK_REGISTRATION_DATA
				WHERE CRSO_RELATION_ID = ? AND PR_STATUS IN (1,2)";
		$q = $this->db->query($sql);
		$q->bind_values($crso_id);
		$q->execute();
		if(!($r = $q->fetch()))
			return false;
		return true;
	}

	function getDataSetNotReportedPr($crso_id)
	{
		$sql = " SELECT PARTICIPANT_RELATION_ID,PR_STATUS,WEEE_STATUS, VAT_REGISTERED
				FROM TBL_UK_REGISTRATION_DATA
				WHERE CRSO_RELATION_ID = ? AND PR_STATUS NOT IN (1,2)";
		$q = $this->db->query($sql);
		$q->bind_values($crso_id);
		$q->execute();
		return $q;
	}

	function _initObjectMaps()
	{
		$this->objectmap['dbtable'] = 'TBL_UK_REGISTRATION_DATA';
		$this->objectmap['primary']['crso->relation->id'] = 'CRSO_RELATION_ID';
		$this->objectmap['primary']['participant->relation->id'] = 'PARTICIPANT_RELATION_ID';
		$this->objectmap['properties']['trading_name'] = 'TRADING_NAME';
		$this->objectmap['properties']['turnover'] = 'ANNUAL_TURNOVER';
		$this->objectmap['properties']['selling_technique'] = 'SELLING_TECHNIQUE';
		$this->objectmap['properties']['obligation_type'] = 'OBLIGATION_TYPE';
		$this->objectmap['properties']['cease_to_exist_date'] = 'CEASE_TO_EXIST_DATE';
		$this->objectmap['properties']['placed_on_market'] = 'PLACED_ON_MARKET';
		$this->objectmap['properties']['logo'] = 'LOGO';
		$this->objectmap['properties']['business_type'] = 'BUSINESS_TYPE';

		$this->objectmap['properties']['cfn[\'title\']'] = 'CFN_TITLE';
		$this->objectmap['properties']['cfn[\'forename\']'] = 'CFN_FORENAME';
		$this->objectmap['properties']['cfn[\'surname\']'] = 'CFN_SURNAME';
		$this->objectmap['properties']['cfn[\'phone_landline\']'] = 'CFN_PHONE';
		$this->objectmap['properties']['cfn[\'phone_mobile\']'] = 'CFN_MOBILE';
		$this->objectmap['properties']['cfn[\'fax\']'] = 'CFN_FAX';
		$this->objectmap['properties']['cfn[\'email\']'] = 'CFN_EMAIL';
		$this->objectmap['properties']['cfn[\'address\'][\'building_number\']'] = 'CFN_BUILDING_NO';
		$this->objectmap['properties']['cfn[\'address\'][\'flatbuilding\']'] = 'CFN_BUILDING';
		$this->objectmap['properties']['cfn[\'address\'][\'street\']'] = 'CFN_STREET';
		$this->objectmap['properties']['cfn[\'address\'][\'locality\']'] = 'CFN_LOCALITY';
		$this->objectmap['properties']['cfn[\'address\'][\'town\']'] = 'CFN_CITY';
		$this->objectmap['properties']['cfn[\'address\'][\'country\']'] = 'CFN_COUNTRY';
		$this->objectmap['properties']['cfn[\'address\'][\'postcode\']'] = 'CFN_POSTAL_CODE';
		$this->objectmap['properties']['cfn[\'address\'][\'admin_area\']'] = 'CFN_ADMINISTRATIVE_AREA';

		$this->objectmap['properties']['business[\'name\']'] = 'BUSINESS_NAME';
		$this->objectmap['properties']['business[\'number\']'] = 'BUSINESS_NUMBER';
		$this->objectmap['properties']['business[\'title\']'] = 'BUSINESS_PERSON_TITLE';
		$this->objectmap['properties']['business[\'forename\']'] = 'BUSINESS_PERSON_FORENAME';
		$this->objectmap['properties']['business[\'surname\']'] = 'BUSINESS_PERSON_SURNAME';
		$this->objectmap['properties']['business[\'phone_landline\']'] = 'BUSINESS_PHONE';
		$this->objectmap['properties']['business[\'phone_mobile\']'] = 'BUSINESS_MOBILE';
		$this->objectmap['properties']['business[\'fax\']'] = 'BUSINESS_FAX';
		$this->objectmap['properties']['business[\'email\']'] = 'BUSINESS_EMAIL';
		$this->objectmap['properties']['business[\'address\'][\'building_number\']'] = 'BUSINESS_BUILDING_NO';
		$this->objectmap['properties']['business[\'address\'][\'flatbuilding\']'] = 'BUSINESS_BUILDING';
		$this->objectmap['properties']['business[\'address\'][\'street\']'] = 'BUSINESS_STREET';
		$this->objectmap['properties']['business[\'address\'][\'locality\']'] = 'BUSINESS_LOCALITY';
		$this->objectmap['properties']['business[\'address\'][\'town\']'] = 'BUSINESS_CITY';
		$this->objectmap['properties']['business[\'address\'][\'country\']'] = 'BUSINESS_COUNTRY';
		$this->objectmap['properties']['business[\'address\'][\'postcode\']'] = 'BUSINESS_POSTAL_CODE';
		$this->objectmap['properties']['business[\'address\'][\'admin_area\']'] = 'BUSINESS_ADMINISTRATIVE_AREA';

		$this->objectmap['properties']['ar[\'name\']'] = 'AR_NAME';
		$this->objectmap['properties']['ar[\'title\']'] = 'AR_TITLE';
		$this->objectmap['properties']['ar[\'forename\']'] = 'AR_FORENAME';
		$this->objectmap['properties']['ar[\'surname\']'] = 'AR_SURNAME';
		$this->objectmap['properties']['ar[\'phone_landline\']'] = 'AR_PHONE';
		$this->objectmap['properties']['ar[\'phone_mobile\']'] = 'AR_MOBILE';
		$this->objectmap['properties']['ar[\'fax\']'] = 'AR_FAX';
		$this->objectmap['properties']['ar[\'email\']'] = 'AR_EMAIL';
		$this->objectmap['properties']['ar[\'address\'][\'building_number\']'] = 'AR_BUILDING_NO';
		$this->objectmap['properties']['ar[\'address\'][\'flatbuilding\']'] = 'AR_BUILDING';
		$this->objectmap['properties']['ar[\'address\'][\'street\']'] = 'AR_STREET';
		$this->objectmap['properties']['ar[\'address\'][\'locality\']'] = 'AR_LOCALITY';
		$this->objectmap['properties']['ar[\'address\'][\'town\']'] = 'AR_CITY';
		$this->objectmap['properties']['ar[\'address\'][\'country\']'] = 'AR_COUNTRY';
		$this->objectmap['properties']['ar[\'address\'][\'postcode\']'] = 'AR_POSTAL_CODE';
		$this->objectmap['properties']['ar[\'address\'][\'admin_area\']'] = 'AR_ADMINISTRATIVE_AREA';

		$this->objectmap['properties']['pr_status'] = 'PR_STATUS';
		$this->objectmap['properties']['weee_status'] = 'WEEE_STATUS';
		$this->objectmap['properties']['vat_registered'] = 'VAT_REGISTERED';
		$this->objectmap['properties']['created'] = 'CREATED';
		$this->objectmap['properties']['last_update'] = 'LAST_UPDATE';
		$this->objectmap['properties']['last_exported_pr'] = 'LAST_EXPORTED_PR';
		$this->objectmap['properties']['last_exported_weee'] = 'LAST_EXPORTED_WEEE';
	}
}
?>