<?php
/**
 * Created on May 6, 2008
 *
 * @author Nicoleta Militaru <nicoleta@basesoft.com>
 **/

require_once(ELC_CLASSES.'uk/uk_define.php');
require_once(ELC_CLASSES.'uk/UKReport.php');

class UKReportData extends AbstractObject
{
	var $id;
	var $report_id;
	var $crso_id;
	var $participant_id;
	var $pr_status;
	var $weee_year;

	function set($report_data_id='')
	{
		$report_data_id || $report_data_id = $this->id;

		$sql = " SELECT REPORT_DATA_ID,REPORT_ID,CRSO_RELATION_ID,PARTICIPANT_RELATION_ID,PR_STATUS,WEEE_STATUS,
		          VAT_REGISTERED
				FROM TBL_UK_REPORT_DATA
				WHERE REPORT_DATA_ID = ? ";
		$q = $this->db->query($sql);
		$q->bind_values($report_data_id);
		$q->execute();
		if(!($r = $q->fetch()))
			return false;
		$this->id = $r->REPORT_DATA_ID;
		$this->report_id = $r->REPORT_ID;
		$this->crso_id = $r->CRSO_RELATION_ID;
		$this->participant_id = $r->PARTICIPANT_RELATION_ID;
		$this->pr_status = $r->PR_STATUS;
		$this->weee_status = $r->WEEE_STATUS;
		$this->vat_registered = $r->VAT_REGISTERED;
		return $this->complete = true;

	}

	function insertReportDataLine($product_id, $obligation_type, $tonnage)
	{
		if(!isset($this->id))
			return;
		$sql = " INSERT INTO TBL_UK_REPORT_DATA_LINE (REPORT_DATA_ID,PRODUCT_ID,OBLIGATION_TYPE,TONNAGE)
					VALUES(?,?,?,?)";
		$q = $this->db->query($sql);
		$q->bind_values($this->id,$product_id,$obligation_type,$tonnage);
		$q->execute();
	}

	function getFirstExportedParticipants($report_id)
	{
		$rep = new UKReport($thsi->db);
		if(!$rep->set($report_id))
			return null;
		$quarter = $rep->quarter;
		if($quarter == 1)
			return null;
		$sql = "(SELECT PARTICIPANT_RELATION_ID FROM TBL_UK_REPORT_DATA WHERE REPORT_ID=? AND WEEE_STATUS = 2
				AND PARTICIPANT_RELATION_ID IN
				(SELECT PARTICIPANT_RELATION_ID FROM TBL_UK_REPORT_DATA WHERE REPORT_ID=? AND WEEE_STATUS = 1))
				UNION
				(SELECT PARTICIPANT_RELATION_ID FROM TBL_UK_REPORT_DATA WHERE REPORT_ID=? AND WEEE_STATUS = 2
				AND PARTICIPANT_RELATION_ID NOT IN
				(SELECT PARTICIPANT_RELATION_ID FROM TBL_UK_REPORT_DATA WHERE REPORT_ID=?))";
		$q = $this->db->query($sql);
		$q->bind_values($report_id,$report_id,$report_id-1,$report_id,$report_id-1);
		$q->execute();
		return $q;
	}

	function _initObjectMaps()
	{
		$this->objectmap['dbtable'] = 'TBL_UK_REPORT_DATA';
		$this->objectmap['primary']['id'] = 'REPORT_DATA_ID';
		$this->objectmap['properties']['report_id'] = 'REPORT_ID';
		$this->objectmap['properties']['crso_id'] = 'CRSO_RELATION_ID';
		$this->objectmap['properties']['participant_id'] = 'PARTICIPANT_RELATION_ID';
		$this->objectmap['properties']['pr_status'] = 'PR_STATUS';
		$this->objectmap['properties']['weee_status'] = 'WEEE_STATUS';
		$this->objectmap['properties']['vat_registered'] = 'VAT_REGISTERED';
	}
}
?>
