<?php
require_once(IWARE.'AbstractObject.php');
/**
 *
 * @author Marten Koedam <marten@basesoft.com>
 * @package I-Ware
 * @subpackage FAQ
 * @version $Id$
 */
class FAQ extends AbstractObject
{
	/**
	 *
	 */
	var $id;
	/**
	 * @var FAQSection $section
	 */
	var $section;
	/**
	 *
	 */
	var $position;
	/**
	 *
	 */
	var $handle;
	/**
	 * @var FAQLang $lang
	 */
	var $lang;
	/**
	 *
	 */
	function set($id=null,$language_id='',$fill=true)
	{
		$id || $id = $this->id;
		$id = (int) $id;

		$sql = "SELECT FAQ_SECTION_ID, POSITION, HANDLE
			FROM TBL_FAQ
			WHERE FAQ_ID = ?";
		$q = $this->db->query($sql);
		$q->bind_values($id);
		if(!$q->execute(true))
			return false;
		if(!($r = $q->fetch()))
			return false;

		require_once(IWARE.'FAQSection.php');
		$this->id = $id;
		$this->section = new FAQSection($this->db,$r->FAQ_SECTION_ID);
		$this->position = $r->POSITION;
		$this->handle = $r->HANDLE;

		if($fill)
		{
			$this->section->set('','',false);
			$language = $language_id?new nLanguage($this->db,$language_id):$this->section->default_language;
			$this->lang = new FAQLang($this->db,array('language'=>$language,'faq'=>$this));
			if(!$this->lang->set())
			{
				$this->lang->language = $this->section->default_language;
				$this->lang->set();
			}
		}

		return $this->complete = true;
	}
	/**
	 *
	 */
	function insert()
	{
		$this->position = $this->_getNextPosition();
		parent::insert();
	}
	/**#@+
	 * @access private
	 */
	/**
	 *
	 */
	function _initObjectMaps()
	{
		$this->objectmap['dbtable'] = 'TBL_FAQ';
		$this->objectmap['primary']['id'] = 'FAQ_ID';
		$this->objectmap['properties']['section->id'] = 'FAQ_SECTION_ID';
		$this->objectmap['properties']['position'] = 'POSITION';
		$this->objectmap['properties']['handle'] = 'HANDLE';
	}
	/**
	 *
	 */
	function _getNextPosition($section_id=null)
	{
		$section_id || $section_id = $this->section->id;
		$sql = "SELECT MAX(`POSITION`) as `POS`
			FROM TBL_FAQ
			WHERE FAQ_SECTION_ID = ?";
		$q = $this->db->query($sql);
		$q->bind_values($section_id);
		$q->execute();
		if(!($r = $q->fetch()))
			return 1;
		return ((int) $r->{'POS'})+1;
	}
	/**#@-*/
}
/**
 * @author Marten Koedam <marten@basesoft.com>
 * @package I-Ware
 */
class FAQLang extends AbstractObject
{
	/**
	 * @var FAQ $faq
	 */
	var $faq;
	/**
	 * @var nLanguage $language
	 */
	var $language;
	/**
	 *
	 */
	var $question_text;
	/**
	 *
	 */
	var $answer_text;
	/**
	 *
	 */
	function set($faq_id=null,$language_id=null)
	{
		$faq_id || $faq_id = $this->faq->id;
		$language_id || $language_id = $this->language->id;

		$sql = "SELECT QUESTION_TEXT, ANSWER_TEXT
			FROM TBL_FAQ_LANG
			WHERE FAQ_ID = ?
				AND LANGUAGE_ID = ?";
		$q = $this->db->query($sql);
		$q->bind_values($faq_id,$language_id);
		if(!$q->execute(true))
			return false;
		if(!($r = $q->fetch()))
			return false;

		$this->faq = new FAQ($this->db,$faq_id);
		$this->language = new nLanguage($this->db,$language_id);
		$this->question_text = $r->QUESTION_TEXT;
		$this->answer_text = $r->ANSWER_TEXT;

		return $this->complete = true;
	}
	/**#@+
	 * @access private
	 */
	function _initObjectMaps()
	{
		$this->objectmap['dbtable'] = 'TBL_FAQ_LANG';
		$this->objectmap['primary']['faq->id'] = 'FAQ_ID';
		$this->objectmap['primary']['language->id'] = 'LANGUAGE_ID';
		$this->objectmap['properties']['question_text'] = 'QUESTION_TEXT';
		$this->objectmap['properties']['answer_text'] = 'ANSWER_TEXT';
	}
}
?>
