<?php
/**
 * @package I-Ware
 * @since 02-08-2006
 * @author Nick Loeve <nick@basesoft.com>
 * @version $Id$
 * @copyright 2006 BaseSoft B.V.
 * @todo DOCUMENTATION!!!
 */

/**
 * This class provides a limited subset of base functionality available to all I-Ware charts
 * @package I-Ware
 * @subpackage Chart
 * @author Nick Loeve <nick@basesoft.com>
 * @version $Id$ - 2/08/2006
 */
class IWChart
{
	var $dataSet;
	var $chartObj;

	/**
	 * Does nothing... yet!
	 */
	function IWChart()
	{
		/**
		 * This is a special file, required by the chart extensions (don't play with it)
		 */
		require_once(IWARE.'phpchartdir.php');
	}

	function setSize($width, $height)
	{
		$this->chartObj->setSize($width, $height);
	}

	function setBackgroundColor($color, $borderColor=Transparent, $borderRaised=0)
	{
		$this->chartObj->setBackground($color, $borderColor, $borderRaised);
	}

	function addTitle($text, $font="", $fontSize=12, $fontColor=Transparent)
	{
		$this->chartObj->addTitle($text, $font, $fontSize, $fontColor);
	}

	function addLegend($x, $y, $flowVertical=1, $font="", $fontSize=10)
	{
		$this->chartObj->addLegend($x, $y, $flowVertical, $font, $fontSize);
	}

	function addText($x, $y, $text, $font="", $fontSize=8, $fontColor=TextColor, $alignment=TopLeft, $angle=0, $vertical=0)
	{
		$this->chartObj->addText($x, $y, $text, $font, $fontSize, $fontColor, $alignment, $angle, $vertical);
	}

	function setLicenseCode($code)
	{
		setLicenseCode($code);
	}

	function setBorder($color)
	{
		$this->chartObj->setBorder($color);
	}

	function setDefaultFonts($normal, $bold="", $italic="", $boldItalic="")
	{
		$this->chartObj->setDefaultFonts($normal, $bold, $italic, $boldItalic);
	}

	function setNumberFormat($thousandSeparator="~", $decimalPointChar=".", $signChar="-")
	{
		$this->chartObj->setNumberFormat($thousandSeparator, $decimalPointChar, $signChar);
	}

	function setMonthNames($names=array("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Nov", "Dec"))
	{
		$this->chartObj->setMonthNames($names);
	}

	function setWeekDayNames($names=array('Sun', 'Mon', 'Tues', 'Wed', 'Thur', 'Fri', 'Sat', 'Sun'))
	{
		$this->chartObj->setWeekDayNames($names);
	}

	function makeChart($filename)
	{
		$this->chartObj->makeChart($filename);
	}

	function makeChartToString($format=PNG)
	{
		return $this->chartObj->makeChart2($format);
	}
}

/**
 * Basic Bar chart
 * @package I-Ware
 * @subpackage Chart
 * @author Nick Loeve <nick@basesoft.com>
 * @version $Id$ - 2/08/2006
 */
class IWBarChart extends IWChart
{
	var $dataLayer;

	function IWBarChart($width, $height, $backgroundColor=0xffffff)
	{
		parent::IWChart();
		$this->chartObj = new XYChart($width, $height, $backgroundColor);
		$this->dataLayer = false;
	}

	function assertDataLayer()
	{
		if(!$this->dataLayer)
			$this->dataLayer = $this->chartObj->addBarLayer2(Side, IWCHART_3D_DEPTH);
	}

	function addDataSet($data, $color=-1, $name="")
	{
		$this->assertDataLayer();
		$this->dataLayer->addDataSet($data, $color, $name);
	}

	function setPlotArea($x, $y, $width, $height, $bgColor=Transparent, $altBgColor=-1, $edgeColor=-1, $hGridColor=0xC0C0C0, $vGridColor=Transparent)
	{
		$this->chartObj->setPlotArea($x, $y, $width, $height, $bgColor, $altBgColor, $edgeColor, $hGridColor, $vGridColor);
	}

	function swapXY()
	{
		$this->chartObj->swapXY();
	}

	function setAxisTitle($axis='x', $title)
	{
		if($axis != 'x' && $axis != 'y')
			$axis = 'x';
		$axis = $axis.'Axis';
		$this->chartObj->$axis->setTitle($title);
	}

	function setAxisLabels($axis, $labels)
	{
		if($axis != 'x' && $axis != 'y')
			$axis = 'x';
		$axis = $axis.'Axis';
		$this->chartObj->$axis->setLabels($labels);
	}
}

define('IWCHART_3D_DEPTH', 0);
?>