<?php
/**
 * @package
 * @subpackage
 * @author Nick Loeve <nick@basesoft.com>
 * @since 02/01/2007
 * @copyright 2006 BaseSoft B.V.
 * $Id$
 */

define('DATE_FORMAT_ISO_EXTENDED', DateTime::ISO8601);
define('DATE_FORMAT_UNIXTIME', 'U');

class IWDateTime extends DateTime
{
	public function __construct($datetime=null)
	{
		parent::__construct($datetime);
	}

	public function getTime()
	{
		return $this->format('U');
	}

	public function before($when)
	{
		if (self::compare($this,$when) == -1) {
            return true;
        } else {
            return false;
        }
	}
	public function getYear()
	{
		return (int)$this->format('Y');
	}
	public function getMonth()
	{
		return (int)$this->format('m');
	}
	public function getDay()
	{
		return (int)$this->format('d');
	}
	public function getHour()
	{
		return (int)$this->format('H');
	}
	public function getMinute()
	{
		return (int)$this->format('i');
	}

	public static function compare(DateTime $d1, DateTime $d2)
	{
		$date1 = (int)$d1->format('U');
		$date2 = (int)$d2->format('U');
		if($date1 > $date2)
		{
			return 1;
		}
		else if($date1 < $date2)
		{
			return -1;
		}
		return 0;
	}
}
?>