<?php
/**
 * InfoPerson (nuskool)
 *
 * Refurbished InfoPerson.
 * Contains info for peronh.
 * Can be related to a Relation or a User
 *
 * NB.. All db functions return false on error.
 * CHECK THESE returnvalues, or face the concequences..
 *
 * @author Chris Wesseling <chris@basesoft.com>
 * @version $Id$
 * @since 22-05-2005
 * @package I-Ware
 */
class InfoPerson
{
	/**
	 * @var Database Edit or IntercleanDB
	 */
	var $db;
	/**
	 * @var int INFO_PERSON_ID
	 */
	var $id=null;
	/**
	 * @var int INFOTYPE_ID
	 */
	var $type_id;
	/**
	 * @var string INFO_PERSON_FIRST_NAME
	 */
	var $first_name;
	/**
	 * @var string INFO_PERSON_MIDDLE_NAME
	 */
	var $middle_name;
	/**
	 * @var string INFO_PERSON_LAST_NAME
	 */
	var $last_name;
	/**
	 * @var string INFO_PERSON_TITLE
	 */
	var $title;
	/**
	 * @var string INFO_PERSON_SEX
	 */
	var $sex;
	/**
	 * @var string INFO_PERSON_TELHOUSE
	 */
	var $telhouse;
	/**
	 * @var string INFO_PERSON_TELWORK
	 */
	var $telwork;
	/**
	 * @var string INFO_PERSON_MOBILE
	 */
	var $mobile;
	/**
	 * @var string INFO_PERSON_EMAIL
	 */
	var $email;
	/**
	 * @var string INFO_PERSON_PHOTO
	 */
	var $photo;
	/**
	 * @var string INFO_PERSON_OTHER_INFO
	 */
	var $other;
	/**
	 *
	 */
	var $fax;
	/**
	 *
	 */
	var $department;

	/**
	 *
	 */
	var $position;
	/**
	 * @var Relation Relation based on RELATION_ID
	 */
	var $relation;
	/**
	 * @var int COMPANY_ID
	 */
	var $company_id;
	/**
	 * @var int LANGUAGE_ID
	 */
	var $language_id;
	/**
	 * @var int ADDRESS_ID
	 */
	var $address_id;
	/**
	 * Constuctor
	 * @param Database $db (EDIT or INTERCLEAN_DB)
	 * @param mixed int (id) or array(property=>value)
	 * @param bool $set set() the object?
	 */
	function InfoPerson(&$db, $preset=null, $set=false)
	{
		$this->complete = false;
		$this->db = $db;
		$this->preset($preset);
		if ( $set )
			$this->set();
	}
	/**
	 *
	 */
	function preset($preset=null)
	{
		if ( is_numeric($preset) )
			$this->id = (int) $preset;
		elseif ( is_array($preset) )
			foreach ( $preset as $p=>$v )
				$this->$p = $v;
	}

	/**
	 * Get object properties from db
	 * @param int $id INFO_PERSON_ID (default= $this->id)
	 * @return bool False on error
	 */
	function set($id=null)
	{
		$id || $id = $this->id;
		if ( !is_numeric($id) )
			throw new Exception('id not numeric: '.$id);

		$sql = "SELECT INFOTYPE_ID, INFO_PERSON_FIRST_NAME, INFO_PERSON_MIDDLE_NAME, INFO_PERSON_LAST_NAME, INFO_PERSON_DEPARTMENT, INFO_PERSON_TITLE, INFO_PERSON_POSITION, INFO_PERSON_FAX, INFO_PERSON_SEX, INFO_PERSON_TELHOUSE, INFO_PERSON_TELWORK, INFO_PERSON_MOBILE, INFO_PERSON_EMAIL, INFO_PERSON_BACKUPEMAIL, INFO_PERSON_PHOTO, INFO_PERSON_OTHER_INFO, COMPANY_ID, LANGUAGE_ID, ADDRESS_ID
			FROM TBL_INFO_PERSON
			WHERE INFO_PERSON_ID = ?";

		$q = $this->db->query($sql);
		$q->bind_values($id);

		if ( !$q->execute(true) )//don't die, trigger notice
			return !trigger_error(substr('InfoPerson::set() : Query error: '.$q->exception->toString(), 0, 1024));

		//require_once(IWARE.'relation.php');

		$r = $q->fetch();
		$this->type_id = $r->INFOTYPE_ID;
		$this->first_name = $r->INFO_PERSON_FIRST_NAME;
		$this->middle_name = $r->INFO_PERSON_MIDDLE_NAME;
		$this->last_name = $r->INFO_PERSON_LAST_NAME;
		$this->sex = $r->INFO_PERSON_SEX;
		$this->telhouse = $r->INFO_PERSON_TELHOUSE;
		$this->telwork = $r->INFO_PERSON_TELWORK;
		$this->mobile = $r->INFO_PERSON_MOBILE;
		$this->email = $r->INFO_PERSON_EMAIL;
		$this->backup_email = $r->INFO_PERSON_BACKUPEMAIL;
		$this->photo = $r->INFO_PERSON_PHOTO;
		$this->other = $r->INFO_PERSON_OTHER_INFO;
		$this->department = $r->INFO_PERSON_DEPARTMENT;
		$this->title = $r->INFO_PERSON_TITLE;
		$this->position = $r->INFO_PERSON_POSITION;
		$this->fax = $r->INFO_PERSON_FAX;
		//$this->relation = new Relation($this->db, $r->RELATION_ID);
		$this->company_id = $r->COMPANY_ID;
		$this->language_id = $r->LANGUAGE_ID;
		$this->address_id = $r->ADDRESS_ID;
		$this->id = $id;

		return $this->complete = true;
	}
	function isComplete()
	{
		return $this->complete;
	}

	/**
	 * Insert new tuple in DB
	 * @return int RELATION_ID
	 */
	function insert()
	{
		$sql = 'INSERT INTO TBL_INFO_PERSON ';

		$fields = '';
		$values = $props = array();
		$props['type_id'] = 'INFOTYPE_ID';
		$props['first_name'] = 'INFO_PERSON_FIRST_NAME';
		$props['middle_name'] = 'INFO_PERSON_MIDDLE_NAME';
		$props['last_name'] = 'INFO_PERSON_LAST_NAME';
		$props['sex'] = 'INFO_PERSON_SEX';
		$props['telhouse'] = 'INFO_PERSON_TELHOUSE';
		$props['telwork'] = 'INFO_PERSON_TELWORK';
		$props['mobile'] = 'INFO_PERSON_MOBILE';
		$props['email'] = 'INFO_PERSON_EMAIL';
		$props['photo'] = 'INFO_PERSON_PHOTO';
		$props['other'] = 'INFO_PERSON_OTHER_INFO';
		$props['department'] = 'INFO_PERSON_DEPARTMENT';
		$props['fax'] = 'INFO_PERSON_FAX';
		$props['title'] = 'INFO_PERSON_TITLE';
		$props['position'] = 'INFO_PERSON_POSITION';
		$props['backup_email'] = 'INFO_PERSON_BACKUPEMAIL';
		$props['company_id'] = 'COMPANY_ID';
		$props['language_id'] = 'LANGUAGE_ID';
		$props['address_id'] = 'ADDRESS_ID';
		foreach ( $props as $p=>$f )
			if ( isset($this->$p) )
			{
				if ( is_bool($this->$p) )
					$values[] = $this->$p?1:0;
				else
					$values[] = $this->$p;
				$fields .= $f.', ';
			}
		if ( isset($this->relation) )
		{
			$fields .= 'RELATION_ID, ';
			$values[] = $this->relation->id;
		}

		if ( !$fields )
			return !trigger_error('InfoPerson::insert() : no properties set');

		$sql .= '('.substr($fields, 0, -2).') VALUES ('.substr(str_repeat('?, ', count($values)), 0, -2).')';

		$q = $this->db->query($sql);
		$q->bind_values($values);

		if ( !$q->execute(true) )//don't die, trigger notice
			return !trigger_error(substr('InfoPerson::insert() : Query error: '.$q->exception->toString(), 0, 1024), E_USER_ERROR);

		return $this->id = $q->lastId();
	}
	/**
	 * Update DB tuple
	 * Updates all properties that are 'set'. Leaves 'unset' values intact.
	 * @return bool
	 */
	function update()
	{
		if ( empty($this->id) )
			return !trigger_error('InfoPerson::update() : missing id');

		$sql = 'UPDATE TBL_INFO_PERSON SET ';

		$fields = '';
		$values = $props = array();
		$props['type_id'] = 'INFOTYPE_ID';
		$props['first_name'] = 'INFO_PERSON_FIRST_NAME';
		$props['middle_name'] = 'INFO_PERSON_MIDDLE_NAME';
		$props['last_name'] = 'INFO_PERSON_LAST_NAME';
		$props['sex'] = 'INFO_PERSON_SEX';
		$props['telhouse'] = 'INFO_PERSON_TELHOUSE';
		$props['telwork'] = 'INFO_PERSON_TELWORK';
		$props['mobile'] = 'INFO_PERSON_MOBILE';
		$props['email'] = 'INFO_PERSON_EMAIL';
		$props['photo'] = 'INFO_PERSON_PHOTO';
		$props['other'] = 'INFO_PERSON_OTHER_INFO';
		$props['fax'] = 'INFO_PERSON_FAX';
		$props['department'] = 'INFO_PERSON_DEPARTMENT';
		$props['title'] = 'INFO_PERSON_TITLE';
		$props['position'] = 'INFO_PERSON_POSITION';
		$props['backup_email'] = 'INFO_PERSON_BACKUPEMAIL';
		$props['company_id'] = 'COMPANY_ID';
		$props['language_id'] = 'LANGUAGE_ID';
		$props['address_id'] = 'ADDRESS_ID';
		foreach ( $props as $p=>$f )
			if ( isset($this->$p) )
			{
				if ( is_bool($this->$p) )
					$values[] = $this->$p?1:0;
				else
					$values[] = $this->$p;
				$sql .= $f.'= ?, ';
			}
		if ( isset($this->relation) )
		{
			$sql .= 'RELATION_ID = ?, ';
			$values[] = $this->relation->id;
		}

		if ( empty($values) )
			return !trigger_error('InfoPerson::update() : no properties set');

		$sql = substr($sql, 0, -2).' WHERE INFO_PERSON_ID = ?';
		$values[] = $this->id;

		$q = $this->db->query($sql);
		$q->bind_values($values);

		return $q->execute();
	}

	/**
	 * Get all InfoPeople for a certain relation_id.
	 * @static
	 * @param int $relation_id
	 * @return array of InfoPerson 's (INFO_PERSON_ID=>InfoPerson)
	 */
	function getByRelationId($relation_id)
	{
		$rv = array();
		if ( !is_numeric($relation_id) )
			return !trigger_error('InfoPerson::getByRelationId() : id not numeric');
		$sql = "SELECT INFO_PERSON_ID, INFOTYPE_ID, INFO_PERSON_FAX, INFO_PERSON_FIRST_NAME, INFO_PERSON_MIDDLE_NAME, INFO_PERSON_LAST_NAME, INFO_PERSON_DEPARTMENT,INFO_PERSON_TITLE,INFO_PERSON_POSITION, INFO_PERSON_SEX, INFO_PERSON_TELHOUSE, INFO_PERSON_TELWORK, INFO_PERSON_MOBILE, INFO_PERSON_EMAIL, INFO_PERSON_PHOTO, INFO_PERSON_OTHER_INFO, COMPANY_ID, LANGUAGE_ID, ADDRESS_ID
			FROM TBL_INFO_PERSON
			WHERE RELATION_ID = ?";

		$q = $this->db->query($sql);
		$q->bind_values($relation_id);

		if ( !$q->execute(true) )//don't die, trigger notice
			return !trigger_error(substr('InfoPerson::getByRelationId() : Query error: '.$q->exception->toString(), 0, 1024));

		require_once(IWARE.'relation.php');

		while ( $r = $q->fetch() )
		{
			$rv[$r->INFO_PERSON_ID] = new InfoPerson($this->db);
			$rv[$r->INFO_PERSON_ID]->id = $r->INFO_PERSON_ID;
			$rv[$r->INFO_PERSON_ID]->type_id = $r->INFOTYPE_ID;
			$rv[$r->INFO_PERSON_ID]->first_name = $r->INFO_PERSON_FIRST_NAME;
			$rv[$r->INFO_PERSON_ID]->middle_name = $r->INFO_PERSON_MIDDLE_NAME;
			$rv[$r->INFO_PERSON_ID]->last_name = $r->INFO_PERSON_LAST_NAME;
		//	$rv[$r->INFO_PERSON_ID]->title = $r->INFO_PERSON_TITLE;
			$rv[$r->INFO_PERSON_ID]->sex = $r->INFO_PERSON_SEX;
			$rv[$r->INFO_PERSON_ID]->telhouse = $r->INFO_PERSON_TELHOUSE;
			$rv[$r->INFO_PERSON_ID]->telwork = $r->INFO_PERSON_TELWORK;
			$rv[$r->INFO_PERSON_ID]->mobile = $r->INFO_PERSON_MOBILE;
			$rv[$r->INFO_PERSON_ID]->email = $r->INFO_PERSON_EMAIL;
			$rv[$r->INFO_PERSON_ID]->photo = $r->INFO_PERSON_PHOTO;
			$rv[$r->INFO_PERSON_ID]->department = $r->INFO_PERSON_DEPARTMENT;
			$rv[$r->INFO_PERSON_ID]->title = $r->INFO_PERSON_TITLE;
			$rv[$r->INFO_PERSON_ID]->position = $r->INFO_PERSON_POSITION;
			$rv[$r->INFO_PERSON_ID]->fzx = $r->INFO_PERSON_FAX;
			$rv[$r->INFO_PERSON_ID]->other = $r->INFO_PERSON_OTHER_INFO;
			$rv[$r->INFO_PERSON_ID]->relation = new Relation($this->db, $relation_id);
			$rv[$r->INFO_PERSON_ID]->company_id = $r->COMPANY_ID;
			$rv[$r->INFO_PERSON_ID]->language_id = $r->LANGUAGE_ID;
			$rv[$r->INFO_PERSON_ID]->address_id = $r->ADDRESS_ID;
		}

		return $rv;
	}
	/**
	 * @param string $name INFOTYPE_NAME
	 * @return int (false on error)
	 */
	function getInfoTypeIdByName($name)
	{
		$sql = "SELECT INFOTYPE_ID FROM TBL_INFOTYPE WHERE INFOTYPE_NAME=?";
		$q = $this->db->query($sql);
		$q->bind_values($name);

		if ( !$q->execute(true) )
			return !trigger_error(substr('InfoPerson::getInfoTypeIdByName() : Query error: '.$q->exception->toString(), 0, 1024));

		$r = $q->fetch();
		return $r->INFOTYPE_ID;
	}

	/**
	 * @param mixed $id
	 * @return ResultSet $q
	 */
	function selectPeopleByInfoTypeId($id,$exclude='')
	{
		$id = is_string($id)?$this->getInfoTypeIdByName($id):$id;
		$sql = "SELECT INFO_PERSON_ID, CONCAT( IFNULL(INFO_PERSON_FIRST_NAME,''), ' ',
					IFNULL(INFO_PERSON_MIDDLE_NAME,''),
					' ', IFNULL(INFO_PERSON_LAST_NAME,'') ) as NAME
			FROM TBL_INFO_PERSON
			WHERE INFOTYPE_ID = ?
				AND COMPANY_ID = ? ";
		if($exclude)
			$sql .= 'AND INFO_PERSON_ID NOT IN( '.implode(',',$exclude).' ) ';
		$sql .= "ORDER BY NAME";
		$q = $this->db->query($sql);
		$q->bind_values(array($id, $_SESSION['session_user_company_id']));
		$q->execute();
		return $q;
	}
	/**
	 *
	 */
	function delete($id='')
	{
		$id || $id = $this->id;
		if(!$this->complete)
			$this->set($id);
		$this->deleteAddress();
		$sql = "DELETE FROM TBL_INFO_PERSON
			WHERE INFO_PERSON_ID = ?";
		$q = $this->db->query($sql);
		$q->bind_values(array($id));
		return $q->execute(true);
	}
	/**
	 *
	 */
	function deleteAddress($address_id='')
	{
		$address_id || $address_id = $this->address_id;
		if(!is_numeric($address_id))
			return;
		require_once(IWARE.'address.php');
		$address = new Address($this->db);
		return $address->Remove($address_id);
	}

	function getFullName()
	{
		return trim($this->first_name.' '.$this->middle_name.' '.$this->last_name);
	}

	/**
	 * @todo Finish making InfoPerson an AbstractObject
	 */

	function setProperties($props)
	{
		return $this->preset($props);
	}
}



/**
 * Code below defines the available infotypes. This only happens once per script.
 */
function defineInfoTypes()
{
	$db = IWRegistry::registry('db');

	$sql = "SELECT * FROM TBL_INFOTYPE";
	$q = $db->query($sql);
	$q->execute();

	while ($row = $q->fetchAssoc())
		define( 'INFOTYPE_'. strtoupper(str_replace(' ', '_', $row['INFOTYPE_NAME'])), $row['INFOTYPE_ID'] );
}

if (!defined('__INFO_TYPES_DEFINED__')) {
	defineInfoTypes();
	define('__INFO_TYPES_DEFINED__', 1);
}

?>
