<?php
/**
 * PHP Broker
 * PHP side of the JS/PHP Ajax Broker pair
 * @author Marten Koedam <marten@basesoft.com>
 * @author Martijn van den Broek <martijn@basesoft.com>
 * @author Chris Wesseling <chris@basesoft.com>
 * @copyright Copyright 2005, BaseSoft b.v.
 * @package I-Ware
 * @subpackage JsPhp
 * @since 25 july 2005
 * @version $Id$
 */
class PhpBroker
{
	/**
	 * @var Array $methods
	 */
	var $methods = array();

	var $classes = array();
	/**
	 * Constructor
	 */
	function PhpBroker()
	{
	}
	/**
	 * Adds a method that the user is allowed to use
	 * @param string $method
	 * @param string $file
	 */
	function addMethod($method,$file)
	{
		$this->methods[$method] = $file;
	}

	function addClass($class, $file)
	{
		$this->classes[$class] = $file;
	}

		/**
	 * Execute the call
	 * @return string JavaScript
	 */
	function execute()
	{
		global $callId;
		if(isset($_POST['donotunserialize'])) {
			$params = $_POST['params'];
			$_REQUEST['params'] = $_POST['params'] = $params;
			$method = $_POST['method'];
			$callId = $_POST['callId'];
		} else {
			$params = mb_unserialize($_POST['params']);

			$_REQUEST['params'] = $_POST['params'] = $params;

			// extract data from params
			$method = $params['method'];

			// nasty! wtf is this

			$callId = $params['callId'];
			// from here $params are the params that to go to the call
			$params = $params['params'];
		}


		// init class
		$class = null;

		// check if we have a dot, if so we want to call a method on a class!
		if (strpos($method, '.') === false)
		{
			// we are calling a method (old method)
			if(!isset($this->methods[$method]))
				throw new IWException(sprintf('Method [%s] is not available', $method));

			$file = $this->methods[$method];
		}
		else
		{
			// we are staticly calling a method on a class
			list($class, $method) = explode('.', $method);

			if(!isset($this->classes[$class]))
				throw new IWException(sprintf('Class [%s] is not available', $class));

			$file = $this->classes[$class];
		}

		// include the file
		if(!file_exists($file))
			throw new IWException(sprintf('File [%s] for method [%s] not available', $file, $method));
		include_once($file);

		if ($class)
		{
			if (!method_exists($class, $method))
				throw new IWException(sprintf('Method [%s] does not exist in class [%s]', $method, $class));

			// let the base class (or extended by the user) do sanitizing
			$params = call_user_func(array($class, 'sanitize_params'), $method, $params);

			// lets empty all crap that the user isnt suppose to touch anymore
			$_POST = array();
			$_GET = array();
			$_POST = array();

			// call static without eval
			$rv = call_user_func(array($class, $method), $params);
		}
		else
		{
			//
			// Deprecated old way of calling rpc !
			//

			debug('WARNING: deprecated way of calling JS-RPC to method '.$method);

			// to be sure we filter all incomming crap although no one should touch this
			$_POST = sanitize_array_recursive($_POST);
			$_REQUEST = sanitize_array_recursive($_REQUEST);
			$_GET = sanitize_array_recursive($_GET);

			// save parms in this for backwards compatibility
			$this->params = sanitize_array_recursive($params);

			// The method doesnt exists
			if(!function_exists($method))
				throw new IWException(sprintf('Method [%s] does not exist', $method));

			// save the callid for methods that think they need it
			$this->callId = $callId;

			// Execute the method
			eval('$rv = '.$method.'($this);');
		}

		//-- return the command and give the unique value back to eval() so we know its all is ok (fix for firefox)
		return '(typeof jsbroker != \'undefined\') && jsbroker.execute('.$callId.', \''.jsescape(mb_serialize($rv), "'").'\'); __RPC_RESULT__ = "__RPC_SUCCESS__"; ';
	}
}
?>
