<?php
require_once(IWARE.'AbstractObject.php');
/**
 * @author Marten Koedam <marten@basesoft.com>
 * @package I-Ware
 * @version $Id$
 */
class RelationType extends AbstractObject
{
	/**
	 * @var int $id
	 */
	var $id;
	/**
	 * @var string $name
	 */
	var $name = '';

	function _initObjectMaps()
	{
		$this->objectmap['dbtable'] = 'TBL_RELATION_TYPE';
		$this->objectmap['primary']['id'] = 'RELATION_TYPE_ID';
		$this->objectmap['properties']['name'] = 'RELATION_NAME';
	}
}
/**
 * Code below defines the available relationtypes. This only happens once per script.
 */
function defineRelationTypes()
{
	$db = IWRegistry::registry('db');

	$sql = "SELECT * FROM TBL_RELATION_TYPE";
	$q = $db->query($sql);
	$q->execute();

	while ($row = $q->fetchAssoc())
		define( 'RELATION_'. strtoupper(str_replace(' ', '_', $row['RELATION_NAME'])), $row['RELATION_TYPE_ID'] );
}

if (!defined('__RELATION_TYPES_DEFINED__')) {
	defineRelationTypes();
	define('__RELATION_TYPES_DEFINED__', 1);
}

?>
