<?php
require_once(IWARE.'AbstractObject.php');
/**
 * @author Marten Koedam <marten@basesoft.com>
 * @package I-Ware
 * @version $Id$
 */
class Translator extends AbstractObject
{
	function getByUserId($user_id='')
	{
		$user_id || $user_id = $this->user->id;
		$sql = "SELECT T.LANGUAGE_ID, LANGUAGE
			FROM TBL_TRANSLATOR as T
			INNER JOIN TBL_LANGUAGE as L
				USING( LANGUAGE_ID )
			WHERE USER_ID = ?";
		$q = $this->db->query($sql);
		$q->bind_values($user_id);
		$q->execute(true);
		return $q;
	}

	function deleteByUser($user_id='')
	{
		$user_id || $user_id = $this->user->id;
		$sql = "DELETE FROM TBL_TRANSLATOR
			WHERE USER_ID = ?";
		$q = $this->db->query($sql);
		$q->bind_values($user_id);
		return $q->execute();
	}
	/**
	 *
	 */
	function _initObjectMaps()
	{
		$this->objectmap['dbtable'] = 'TBL_TRANSLATOR';
		$this->objectmap['primary']['user->id'] = 'USER_ID';
		$this->objectmap['primary']['language->id'] = 'LANGUAGE_ID';
	}
}
?>