<?php
/**
 * @package I-Ware
 */
Class Address {

	var $address_id;
	var $address_street_name;
	var $address_street_number;
	var $address_zipcode;
	var $city_name;
	var $country_id;
 	var $db;
	var $target_db = 0;

	function Address($db,$preset=null,$set=false)
	{
		$this->db = $db;
		$this->target_db = $db;
		$this->clear();


		if ( is_numeric($preset) )
			$this->id = (int) $preset;
		elseif ( is_array($preset) )
			foreach ( $preset as $p=>$v )
				$this->$p = $v;
		if ( $set )
			$this->set();
	}

	function set($address_id='')
	{
		$address_id || $address_id = $this->address_id;
		$sql = "SELECT * FROM TBL_ADDRESS WHERE ADDRESS_ID = ?";
		$ex = $this->db->query($sql);
		$ex->bind_values(array($address_id));
		if ($ex->execute())
		{
			if ($row = $ex->fetch())
			{
				$this->address_id = $row->{"ADDRESS_ID"};
				$this->address_street_name = $row->{"ADDRESS_STREET_NAME"};
				$this->address_street_number = $row->{"ADDRESS_STREET_NUMBER"};
				$this->address_zipcode = $row->{"ADDRESS_ZIPCODE"};
				$this->city_name = $row->{"CITY_NAME"};
				$this->country_id = $row->{"COUNTRY_ID"};
			}
			else
				return false;
		}
		else
			return false;
	}

	function insert()
	{
		return $this->address_id = $this->addNew();
	}

	Function addNew()
	{
		$sql = "INSERT INTO TBL_ADDRESS (ADDRESS_STREET_NAME, ADDRESS_STREET_NUMBER, ADDRESS_ZIPCODE, CITY_NAME, COUNTRY_ID) ";
		$sql .= "VALUES (?, ?, ?, ?, ?) ";
		$ex = $this->target_db->query($sql);
		$ex->bind_values(array($this->address_street_name, $this->address_street_number, $this->address_zipcode, $this->city_name, $this->country_id));
		if ($ex->execute()) { return $ex->lastid(); }
	else { return false; }
	}

	function copyAddress ($address_id, $copyMode = CP_COPY_NEW)
	{
		$this->set($address_id);

		if ($this->country_id > 0)
		{
			require_once(IWARE."country.php");
			$country = new Country($this->db);
			$country->target_db = $this->target_db;
			$this->country_id = $country->copyCountry($this->country_id, $copyMode);
		}

		if ($copyMode == CP_COPY_NEW)
		{
			$sql = "INSERT INTO TBL_ADDRESS (ADDRESS_STREET_NAME, ADDRESS_STREET_NUMBER, ADDRESS_ZIPCODE, CITY_NAME, COUNTRY_ID) ";
			$sql .= "VALUES (?, ?, ?, ?, ?) ";
			$ex = $this->target_db->query($sql);
			$ex->bind_values(array($this->address_street_name, $this->address_street_number, $this->address_zipcode, $this->city_name, $this->country_id));
		}
		else
		{
			$sql = "SELECT ADDRESS_ID FROM TBL_ADDRESS WHERE ADDRESS_ID=?";
			$ex = $this->target_db->query($sql);
			$ex->bind_values(array($address_id));
			if ($ex->execute() && $ex->rows() > 0)
			{
			}
			else
			{
				$sql = "INSERT INTO TBL_ADDRESS (ADDRESS_ID, ADDRESS_STREET_NAME, ADDRESS_STREET_NUMBER, ADDRESS_ZIPCODE, CITY_NAME, COUNTRY_ID) ";
				$sql .= "VALUES (?, ?, ?, ?, ?, ?) ";
				$ex = $this->target_db->query($sql);
				$ex->bind_values(array($this->address_id, $this->address_street_name, $this->address_street_number, $this->address_zipcode, $this->city_name, $this->country_id));
			}
		}
		if ($ex->execute())
		{
			if ($copyMode == CP_COPY_NEW)
				$this->address_id = $ex->lastid();
			return $this->address_id;
		}
			else return false;
	}

	Function Update($address_id='')
	{
		$address_id || $address_id = $this->address_id;

	$sql = "UPDATE TBL_ADDRESS SET ADDRESS_STREET_NAME = ?,";
	$sql .= " ADDRESS_STREET_NUMBER = ?, ADDRESS_ZIPCODE = ?,";
	$sql .= " CITY_NAME = ?, COUNTRY_ID = ? WHERE ADDRESS_ID = ? ";

	$ex = $this->db->query($sql);
 	$ex->bind_values(array($this->address_street_name,$this->address_street_number,
							$this->address_zipcode, $this->city_name, $this->country_id, $address_id));

	if ($ex->execute()) { return 1; }
	else { return -1; }

	}

	Function Remove($address_id)
	{
		$sql = "DELETE FROM TBL_ADDRESS WHERE ADDRESS_ID = ?";
		$ex = $this->db->query($sql);
		$ex->bind_values(array($address_id));
		if ($ex->execute()) { return 1; }
		else { return -1; }

	}

	function delete($address_id='')
	{
		$address_id || $address_id = $this->address_id;
		return $this->Remove($address_id);
	}

	Function Clear()
	{
	$this->address_id = 0;
	$this->address_street_name = "";
	$this->address_street_number = "";
	$this->address_zipcode = "";
	$this->city_name = "";
	$this->country_id = 0;
	}

	Function fetch()
	{
		$sql = "SELECT * FROM TBL_ADDRESS";
		$ex = $this->db->query($sql);
		if ( $ex->execute() ) { return $ex; }
		else { return false; }
	}

	Function Return_Max_ID()
	{
	$ex = $this->fetch();
	return $ex->lastid();
	}

	/**
	 * @todo Finish making Address an AbstractObject
	 */
	function setProperties($props)
	{
		return $this->_preset($props);
	}

	function _preset($props)
	{
		foreach ( $props as $prop=>$val )
			$this->$prop = $val;
	}
}

?>
