<?php
/**
 * Exception
 * @author Marten Koedam <marten@basesoft.com>
 * @author Chris Wesseling <chris_nospam@basesoft.com>
 * @copyright Copyright 2004, BaseSoft b.v.
 * @package I-Ware
 */

if (!defined('DB_OK')) // FIXME
{
	define('DB_OK',                         1);
	define('DB_ERROR',                     -1);
	define('DB_ERROR_SYNTAX',              -2);
	define('DB_ERROR_CONSTRAINT',          -3);
	define('DB_ERROR_NOT_FOUND',           -4);
	define('DB_ERROR_ALREADY_EXISTS',      -5);
	define('DB_ERROR_UNSUPPORTED',         -6);
	define('DB_ERROR_MISMATCH',            -7);
	define('DB_ERROR_INVALID',             -8);
	define('DB_ERROR_NOT_CAPABLE',         -9);
	define('DB_ERROR_TRUNCATED',          -10);
	define('DB_ERROR_INVALID_NUMBER',     -11);
	define('DB_ERROR_INVALID_DATE',       -12);
	define('DB_ERROR_DIVZERO',            -13);
	define('DB_ERROR_NODBSELECTED',       -14);
	define('DB_ERROR_CANNOT_CREATE',      -15);
	define('DB_ERROR_CANNOT_DELETE',      -16);
	define('DB_ERROR_CANNOT_DROP',        -17);
	define('DB_ERROR_NOSUCHTABLE',        -18);
	define('DB_ERROR_NOSUCHFIELD',        -19);
	define('DB_ERROR_NEED_MORE_DATA',     -20);
	define('DB_ERROR_NOT_LOCKED',         -21);
	define('DB_ERROR_VALUE_COUNT_ON_ROW', -22);
	define('DB_ERROR_INVALID_DSN',        -23);
	define('DB_ERROR_CONNECT_FAILED',     -24);
	define('DB_ERROR_EXTENSION_NOT_FOUND',-25);
	define('DB_ERROR_ACCESS_VIOLATION',   -26);
	define('DB_ERROR_NOSUCHDB',           -27);
	define('DB_ERROR_CONSTRAINT_NOT_NULL',-29);
}


/**
 * Deprecated, use real exceptions
 */
class DatabaseException
{
	/**
	 * @var int $errorCode One of the DB_ERROR constants.
	 */
	var $errorCode;
	/**
	 * @var mixed (my guesss is it is probably an int) but that depends on the dbdriver Native (DBMS) error code
	 */
	var $nativeError;
	/**
	 * @var string Native (DBMS) error message
	 */
	var $nativeMsg = '';
	function DatabaseException( $error_code, $native_error, $native_err_msg )
	{
		$this->errorCode = $error_code;
		$this->nativeError = $native_error;
		$this->nativeMsg = $native_err_msg;
	}

	function toString()
	{
		return $this->nativeMsg;
	}
}

?>