<?php
/**
 * @package I-Ware
 */
Class Language_Country
{
	var $db;
	var $altDbArray = array();
	var $company_id = 0;
	var $language_id = 0;
	var $country_id = 0;
	var $language_modifier = 0;
	var $language_country_order = 0;
	var $language_country_id = 0;
	var $language_country_code = "";
	var $lcm_array = array();

	function Language_Country ($db, $company_id)
	{
		$this->db = $db;
		$this->company_id = $company_id;
	}

	function setAltDB($db_array = array())
	{
		$this->altDbArray = $db_array;
	}

	function clear()
	{
		$this->language_id = 0;
		$this->country_id = 0;
		$this->language_modifier = 0;
		$this->language_country_order = 0;
		$this->language_country_id = 0;
		$this->language_country_code = "";
		$this->language_name = "";
		$this->lcm_array = array();
		return true;
	}

	function set($language_id, $country_id, $language_modifier)
	{
		$sql = "SELECT * FROM TBL_LANGUAGE_COUNTRY ";
		$sql .= "WHERE LANGUAGE_ID=? AND COUNTRY_ID=? ";
		$sql .= "AND LANGUAGE_MODIFIER=? AND COMPANY_ID=? ";
		$ex = $this->db->query($sql);
		$ex->bind_values(array($language_id, $country_id, $language_modifier, $this->company_id));
		if ($ex->execute() && $row = $ex->fetch())
		{
			$this->language_id = $row->{"LANGUAGE_ID"};
			$this->country_id = $row->{"COUNTRY_ID"};
			$this->language_modifier = $row->{"LANGUAGE_MODIFIER"};
			$this->language_country_order = $row->{"LANGUAGE_COUNTRY_ORDER"};
			$this->language_country_id = $row->{"LANGUAGE_COUNTRY_ID"};
			$this->language_country_code = $row->{"LANGUAGE_COUNTRY_CODE"};
			$this->language_name = $row->{"LANGUAGE_NAME"};
			return true;
		}
		else
			$this->clear();
		return false;
	}

	function setById($country_language_id)
	{
		$sql = "SELECT * FROM TBL_LANGUAGE_COUNTRY ";
		$sql .= "WHERE LANGUAGE_COUNTRY_ID=? ";
		$ex = $this->db->query($sql);
		$ex->bind_values(array($country_language_id));
		//addEvent(__LINE__,"language Country",$ex->tmp_sql);
		if ($ex->execute() && $row = $ex->fetch())
		{
			$this->language_id = $row->{"LANGUAGE_ID"};
			$this->country_id = $row->{"COUNTRY_ID"};
			$this->language_modifier = $row->{"LANGUAGE_MODIFIER"};
			$this->language_country_order = $row->{"LANGUAGE_COUNTRY_ORDER"};
			$this->language_country_id = $row->{"LANGUAGE_COUNTRY_ID"};
			$this->language_country_code = $row->{"LANGUAGE_COUNTRY_CODE"};
			$this->language_name = $row->{"LANGUAGE_NAME"};
			return true;
		}
		else
			$this->clear();
		$ex->tmp_sql;
		return false;
	}

	function setByCode($country_language_code)
	{
		$sql = "SELECT * FROM TBL_LANGUAGE_COUNTRY ";
		$sql .= "WHERE LANGUAGE_COUNTRY_CODE=? ";
		$ex = $this->db->query($sql);
		$ex->bind_values(array($country_language_code));
		if ($ex->execute() && $row = $ex->fetch())
		{
			$this->language_id = $row->{"LANGUAGE_ID"};
			$this->country_id = $row->{"COUNTRY_ID"};
			$this->language_modifier = $row->{"LANGUAGE_MODIFIER"};
			$this->language_country_order = $row->{"LANGUAGE_COUNTRY_ORDER"};
			$this->language_country_id = $row->{"LANGUAGE_COUNTRY_ID"};
			$this->language_country_code = $row->{"LANGUAGE_COUNTRY_CODE"};
			$this->language_name = $row->{"LANGUAGE_NAME"};
			return true;
		}
		else
			$this->clear();
		$ex->tmp_sql;
		return false;
	}

	function add()
	{
		$sql = "INSERT INTO TBL_LANGUAGE_COUNTRY ";
		$sql .= "(LANGUAGE_ID, COUNTRY_ID, LANGUAGE_MODIFIER, COMPANY_ID, ";
		$sql .= "LANGUAGE_COUNTRY_ORDER, LANGUAGE_COUNTRY_ID, LANGUAGE_COUNTRY_CODE, LANGUAGE_NAME) ";
		$sql .= " VALUES (?, ?, ?, ?, ?, ?, ?, ?) ";
		$ex = $this->db->query($sql);
		$ex->bind_values(array($this->language_id, $this->country_id, $this->language_modifier,
							$this->company_id, $this->language_country_order,
							$this->language_country_id, $this->language_country_code, $this->language_name));
		if ($ex->execute())
		{
			foreach ($this->altDbArray as $db)
			{
				$ex = $db->query($sql);
				$ex->bind_values(array($this->language_id, $this->country_id, $this->language_modifier,
							$this->company_id, $this->language_country_order,
							$this->language_country_id, $this->language_country_code, $this->language_name));
				$ex->execute();
			}
			return true;
		}
		return false;
	}

	function update($language_country_id)
	{
		$sql = "UPDATE TBL_LANGUAGE_COUNTRY ";
		$sql .= "SET LANGUAGE_COUNTRY_ORDER=?, LANGUAGE_COUNTRY_ID=?, LANGUAGE_COUNTRY_CODE=?, ";
		$sql .= "LANGUAGE_ID=?, COUNTRY_ID=?, LANGUAGE_MODIFIER=?, COMPANY_ID=?, LANGUAGE_NAME = ?";
		$sql .= "WHERE LANGUAGE_COUNTRY_ID=? ";
		$ex = $this->db->query($sql);
		$ex->bind_values (array($this->language_country_order, $this->language_country_id,
							$this->language_country_code, $this->language_id, $this->country_id,
							$this->language_modifier, $this->company_id, $this->language_name, $language_country_id));
		if ($ex->execute())
		{
			foreach ($this->altDbArray as $db)
			{
				$ex = $db->query($sql);
				$ex->bind_values (array($this->language_country_order, $this->language_country_id,
							$this->language_country_code, $this->language_id, $this->country_id,
							$this->language_modifier, $this->company_id, $this->language_name, $language_country_id));
				$ex->execute();
			}
			return true;
		}
		return false;
	}

	function delete($language_country_id)
	{
		$sql = "DELETE FROM TBL_LANGUAGE_COUNTRY ";
		$sql .= "WHERE LANGUAGE_COUNTRY_ID=? ";
		$ex = $this->db->query($sql);
		$ex->bind_values (array($language_country_id));
		if ($ex->execute())
		{
			foreach ($this->altDbArray as $db)
			{
				$ex = $db->query($sql);
				$ex->bind_values (array($language_country_id));
				$ex->execute();
			}
			return true;
		}
		return false;
	}

	function setByLanguage($language_id)
	{
		$sql = "SELECT * FROM TBL_LANGUAGE_COUNTRY ";
		$sql .= "WHERE LANGUAGE_ID=? AND COMPANY_ID=? ";
		$sql .= "ORDER BY LANGUAGE_COUNTRY_CODE";
		$ex = $this->db->query($sql);
		$ex->bind_values(array($language_id, $this->company_id));
		if ($ex->execute())
		{
			$rs = $q->fetchAll();
			if(count($rs))
			{
				foreach($rs as $row)
				{
					$this->language_id = $row->{"LANGUAGE_ID"};
					$this->country_id = $row->{"COUNTRY_ID"};
					$this->language_modifier = $row->{"LANGUAGE_MODIFIER"};
					$this->language_country_order = $row->{"LANGUAGE_COUNTRY_ORDER"};
					$this->language_country_id = $row->{"LANGUAGE_COUNTRY_ID"};
					$this->language_country_code = $row->{"LANGUAGE_COUNTRY_CODE"};
					$this->language_name = $row->{"LANGUAGE_NAME"};
					$this->lcm_array[] = $this;
				}
				return true;
			}
			else
				$this->clear();
		}
		else
			$this->clear();
		return false;
	}

	function setByCountry($country_id, $modifier = "")
	{
		$sql = "SELECT * FROM TBL_LANGUAGE_COUNTRY ";
		$sql .= "WHERE COUNTRY_ID=? AND COMPANY_ID=? ";
		if ($modifier != "")
			$sql .= "AND LANGUAGE_MODIFIER='".$modifier."' ";
		$sql .= "ORDER BY LANGUAGE_COUNTRY_CODE";
		$ex = $this->db->query($sql);
		$ex->bind_values(array($country_id, $this->company_id));
		if ($ex->execute() && $row = $ex->fetch())
		{
			do
			{
				$this->language_id = $row->{"LANGUAGE_ID"};
				$this->country_id = $row->{"COUNTRY_ID"};
				$this->language_modifier = $row->{"LANGUAGE_MODIFIER"};
				$this->language_country_order = $row->{"LANGUAGE_COUNTRY_ORDER"};
				$this->language_country_id = $row->{"LANGUAGE_COUNTRY_ID"};
				$this->language_country_code = $row->{"LANGUAGE_COUNTRY_CODE"};
				$this->language_name = $row->{"LANGUAGE_NAME"};
				$this->lcm_array[] = $this;
			} while ($row = $ex->fetch());
			return true;
		}
		else
			$this->clear();
		return false;
	}

	function setByCompany($company_id)
	{
		$sql = "SELECT * FROM TBL_LANGUAGE_COUNTRY ";
		$sql .= "WHERE COMPANY_ID=? ";
		$sql .= "ORDER BY LANGUAGE_COUNTRY_CODE";
		$ex = $this->db->query($sql);
		$ex->bind_values(array($company_id));
		if ($ex->execute() && $row = $ex->fetch())
		{
			do
			{
				$this->language_id = $row->{"LANGUAGE_ID"};
				$this->country_id = $row->{"COUNTRY_ID"};
				$this->language_modifier = $row->{"LANGUAGE_MODIFIER"};
				$this->language_country_order = $row->{"LANGUAGE_COUNTRY_ORDER"};
				$this->language_country_id = $row->{"LANGUAGE_COUNTRY_ID"};
				$this->language_country_code = $row->{"LANGUAGE_COUNTRY_CODE"};
				$this->language_name = $row->{"LANGUAGE_NAME"};
				$this->lcm_array[] = $this;
			}while ($row = $ex->fetch());
			return true;
		}
		else
			$this->clear();
		return false;
	}

	function setLanguageByCompany($company_id)
	{
		$sql = "SELECT LANGUAGE_COUNTRY_ID AS LANGUAGE_ID FROM TBL_LANGUAGE_COUNTRY ";
		$sql .= "WHERE COMPANY_ID=? ";
		$sql .= "ORDER BY LANGUAGE_COUNTRY_CODE";
		$ex = $this->db->query($sql);
		$ex->bind_values(array($company_id));
		if ($ex->execute() && $ex->rows() > 0)
			return $ex;
		else
			$this->clear();
		return false;
	}


	function setByModifier($language_modifier)
	{
		$sql = "SELECT * FROM TBL_LANGUAGE_COUNTRY ";
		$sql .= "WHERE LANGUAGE_MODIFIER=? AND COMPANY_ID=? ";
		$sql .= "ORDER BY LANGUAGE_COUNTRY_CODE";
		$ex = $this->db->query($sql);
		$ex->bind_values(array($language_modifier, $this->company_id));
		if ($ex->execute() && $row = $ex->fetch())
		{
			do
			{
				$this->language_id = $row->{"LANGUAGE_ID"};
				$this->country_id = $row->{"COUNTRY_ID"};
				$this->language_modifier = $row->{"LANGUAGE_MODIFIER"};
				$this->language_country_order = $row->{"LANGUAGE_COUNTRY_ORDER"};
				$this->language_country_id = $row->{"LANGUAGE_COUNTRY_ID"};
				$this->language_country_code = $row->{"LANGUAGE_COUNTRY_CODE"};
				$this->language_name = $row->{"LANGUAGE_NAME"};
				$this->lcm_array[] = $this;
			}while ($row = $ex->fetch());
			return true;
		}
		else
			$this->clear();
		return false;
	}

	function setCharset()
	{
		$sql = "SELECT * FROM TBL_LANGUAGE WHERE LANGUAGE_ID = ".$this->language_id;
		$ex = $this->db->query($sql);
		if ($ex->execute())
			{
				if ($tbl = $ex->fetch())
					{
						return $tbl->{"LANGUAGE_CHARSET"};
					}
			}
		else
			return -1;
	}

	function setAcceptCharset($charset)
	{
		switch(strtoupper($charset))
		{
			case "SHIFT_JIS":
			case "BIG5":
			case "WINDOWS-1251":
			case "GB2312":
			case "ISO-8859-2":
			case "EUC-KR":// 2004-07-DECEMBER
			case "UNICODE":// 2004-07-DECEMBER
				return "accept-charset='UTF-16'";
			break;
			default:
				return "accept-charset='UTF-16'";

		}

	}
}
?>
