<?php
/**
 * @package I-Ware
 * @author MBasszje Dabo
 */
	/*
	 |----------------------------------------------------------------------------
	 |Author : Mbassa DABO
	 |----------------------------------------------------------------------------
	 |Purpose : Check and validate the login of the user.
	 |			If the login process is succed, then the user is redirected
	 |			to the rigth part of the site if not an error login message is
	 |			is shown.
	 |---------------------------------------------------------------------------
	 |Global varial :
	 |
	 |	- loginname : The user name of the user
	 |	- password : The pasword submited by the user.
	 |---------------------------------------------------------------------------
	 |Last Modified : 06/02/2002
	 |
	 |----------------------------------------------------------------------------
	 */

class Login
{
	var $loginname;
	var $password;
	var $action;
	var $db;
	var $target_db;
	var $return_status = false;

	function Login($db, $loginname, $password, $return_status = false)
	{
		global $action, $crypt;

		$this->loginname	=	$loginname;
		$this->password		=	$password;
		$this->action		= 	$_REQUEST['action'];
		$this->db 			= 	$db;
		$this->target_db 	= 	$db;
		$this->return_status =  $return_status;
	 }

	function ProcessForm()
	{
		// Check the submitted information
		// return value :
		//	-1. :  no user name
		//  -2. :  no passord
		//	-3. : login information incorrect
		//	$user_id. : login  OK

		global  $site, $crypt;

		if(!$this->loginname)
		{
			return -1;
		}
		if(!$this->password)
		{
			return -2;
		}

		/// !!!!!!!!!!!!!!!!!!!!!! Crypt the password //////////////////////
		$current_user_info = $this->GetUserLoginInfo();
		if(!$current_user_info["USER_ID"] > -1)
		{
			return -3;
		}
		else
		{
			//  should be an array
			 return  $current_user_info;
		}
	}

	function ProcessLogin()
	{
		// this function
		// return 1 if login success
		// return false if not
		global $action;
		global $crypt;		// instance of the object Crypter
		global $thisDoc;
		global $session_user_id;
		global  $_SESSION;

		$site_path = substr(ereg_replace('/', '\\', dirname($thisDoc)), 0, strlen(ereg_replace('/', '\\', dirname($thisDoc)))-12);
		if (isset($HTTP_HOST))
			$redirect = "http://".$HTTP_HOST."/".SITE_PATH;
		else
			$redirect = "http://".SITE_SERVER.SITE_PATH;

		if($this->action == "login")
		{

			$login_status = $this->ProcessForm(); // return an assoc array
			if( $login_status["USER_NAME"] == "BASEADMIN" )
			{
				if( ! $this->checkIp())
					$login_status = -7;
			}
			if(gettype($login_status) == "array")
			{
				$_SESSION['filter'] = array();
				// Get and set the environnement variables
				$userid  =  $login_status["USER_ID"];
				if($userid > 0)
					{
					$_SESSION["session_group_group_id"] =  $this->GetgroupID($userid);
					//////////////////////////////  Application Visibility  ////////////
					$application_id = $login_status["APPLICATION_ID"];
					$company_id = $login_status["COMPANY_ID"];
					$_SESSION["session_user_app_visible"] =	$this->GetUserApplicationVisibility($company_id,$application_id);
					$_SESSION["session_group_company_id"] = $this->GetGroupCompanyID($company_id, $_SESSION["session_group_group_id"]);
				}
				else
				{
					$_SESSION["session_group_group_id"] = 0;
					//////////////////////////////  Application Visibility  ////////////
					$application_id = 10;
					$company_id = 0;
					$_SESSION["session_user_app_visible"] =	1;
					$_SESSION["session_group_company_id"] = 0;
				}
				if($_SESSION["session_group_group_id"] > 0)
				{
				    $_SESSION["session_group_group_name"] =	$this->GetUserGroupName($userid);
				}
				else
				{
					$_SESSION["session_group_group_name"] = "";
				}
				if (( $login_status["USER_NAME"] != "BASEADMIN" ) && $this->checkDoubleLogin($company_id, $userid))
				{
					$login_status = -6;
				}
				else
				{
					//2. Set variables
					$_SESSION["show_language_update"] = "yes";
					$_SESSION["show_message_update"] = "no";
					if( is_file( "../../classes/i-w/user_preferences.php" ))
						require_once( "../../classes/i-w/user_preferences.php" );
					$prefs = new user_preferences( $this->db, $login_status["USER_ID"], $login_status["COMPANY_ID"] );
					$_SESSION["user_style_color"] = 'geel_';//$prefs->getColor();
					$_SESSION["user_style_color"] = '';
					$_SESSION["refreshTop"] = "no";
					$_SESSION["session_user_id"] = $login_status["USER_ID"];
					$_SESSION["session_user_language_id"] = $login_status["LANGUAGE_ID"];
					$_SESSION["session_user_name"] = $login_status["USER_NAME"];
					$_SESSION["session_user_application_id"] = $login_status["APPLICATION_ID"];
					$_SESSION["session_user_company_id"] = $login_status["COMPANY_ID"];
					$_SESSION["session_user_company_name"] = $this->getCompany($login_status["COMPANY_ID"]);

				//	$this->setApplicationOptions();
					/*
					//Set the application options (e.g. path / server etc)
					$appOptions = $this->getApplicationOptions($application_id);
//					print_R($appOptions);
					if ($appOptions)
					{
						$servername = $appOptions->getXml("app_server");
						$virtual_root = $appOptions->getXml("app_root");
						if ($virtual_root == "1")
							$virtual_root = "";
						$path = $appOptions->getXml("app_path");
						if ($path == "1")
							$path = "";
						$_SESSION["Session_Application_Server"] = $servername;
						$_SESSION["Session_Application_Virtual_Root"] = $virtual_root;
						$_SESSION["Session_Application_Path"] = addslashes($path);
						$redirect = "/".addslashes($path);
					}
					*/

					$_SESSION["Session_Application_Server"] = SITE_SERVER;
					$_SESSION["Session_Application_Virtual_Root"] = SITE_HOMEDIR;
					$_SESSION["Session_Application_Path"] = SITE_PATH;
					$redirect = "/" . SITE_PATH;


					// 2. Set the sessions
					$_SESSION["session_site_path"] = $site_path;
					global $site_title;
					//DELETED: goto report
					global $language_id;

					$_SESSION["session_site_title"] = $site_title;
					$_SESSION["session_encryption_key"] = ENCRYPTION_KEY;
					$_SESSION["session_no_access_page"] = NO_ACCESS_PAGE;
					$_SESSION["session_logout_page"] = str_replace("\\", "/", $_SESSION["Session_Application_Path"]).LOGOUT_PAGE;

					if($this->StoreLoginInfoToTBlLogin($userid))
					{
						global $loginname;
						if( $this->return_status )
							return 1;
			            echo "<script language='JavaScript'>\n";
						echo "//if( parent && parent.name == 'firstframe' )\n";
						echo "//\tparent.location.href = '".$redirect."index.php';\n";
						echo "//else\n";
			    	    echo "\ttop.location.href = '".$redirect."index.php';\n";
			            echo "</script>";
						exit();
					}
					else
					{
						$login_status = -5;
					}
				}
			}
			if( $this->return_status )
				return $login_status;

			if (gettype($login_status) != "array" )
			{
				//Error terror!!
				switch($login_status)
				{
				case -1:
				$direction = $redirect.LOGOUT_PAGE."?errnr=-1";
				break;
				case -2:
					$direction = $redirect.LOGOUT_PAGE."?errnr=-2";
				break;
				case -3:
					$direction = $redirect.LOGOUT_PAGE."?errnr=-3";
				break;
				case -4;
					$direction = $redirect.LOGOUT_PAGE."?errnr=-4";
				break;
				case -5:
					$direction = $redirect.LOGOUT_PAGE."?errnr=-5";
				break;
				case -6:
					$direction = $redirect.LOGOUT_PAGE."?errnr=-6";
				break;
				case -7:
					$direction = $redirect.LOGOUT_PAGE."?errnr=-7";
				break;
				}

				unset($_COOKIE[session_name()]);
				session_destroy();
	            echo "<script language='JavaScript'>";
	    	    echo "window.location.href = '".$direction."';";
	            echo "</script>";
			}
		}
		elseif($this->action=="logout")
		{
			// destroy the session and redirect the user (step 6)
			// destroy the session, remove the information in the database.
			unset($_COOKIE[session_name()]);
			session_destroy();
			$session_destructed =  $this->closeSession();
			$direction = PATH_LOGOUT_PAGE;
			header("Location:  $direction");
		}
		elseif ($this->action == "")
		{


		}
	}

	function getCompany( $company_id )
	{
		$sql = "SELECT COMPANY_NAME FROM TBL_COMPANY WHERE COMPANY_ID = ".$company_id;
		$ex = $this->db->query( $sql );
		if( $ex->execute())
		{
			if( $row = $ex->fetch())
				return $row->{"COMPANY_NAME"};
		}
		else
			return false;
	}

	function getApplicationOptions($application_id)
	{
	global $xml;

	$sql = "SELECT APPLICATION_OPTIONS FROM TBL_APPLICATION WHERE APPLICATION_ID = ".$application_id;
	$ex = $this->db->query($sql);
		if($ex->execute())
			{
			if ($row = $ex->fetch ())
				{
				if(!$xml->xmldoc = xmldoc($row->{"APPLICATION_OPTIONS"})) {
				  echo "Error while parsing the document\n";
				  exit;
					}
				}
			$xml->rootnode = $xml->xmldoc->root();
			return $xml;
			}
		else
			{
			return false;
			}
	}

	function setApplicationOptions($application_id)
{
	//Set the application options (e.g. path / server etc)
	$appOptions = $this->getApplicationOptions($application_id);
	if ($appOptions)
	{
		$servername = $appOptions->getXml("app_server");
		$virtual_root = $appOptions->getXml("app_root");
		if ($virtual_root == "1")
			$virtual_root = "";
		$path = $appOptions->getXml("app_path");
		if ($path == "1")
			$path = "";
		$_SESSION["Session_Application_Server"] = $servername;
		$_SESSION["Session_Application_Virtual_Root"] = $virtual_root;
		$_SESSION["Session_Application_Path"] = addslashes($path);
		$redirect = "/".addslashes($path);
	}

	}




	function GetUserApplicationVisibility($company_id, $application_id)
	{
		return 1;
		/*
		 |------------------------------------------------------------------------
		 | Purpose : Extract user_application_visible field from the table
		 |			 tbl_user_application. The value of thisfield determines
		 |			 wether or not an application if visible for a user.
		 |-----------------------------------------------------------------------
		 | Inputs :
		 |			- $db_obj : (object) valid database object  connection
		 |			- $user_id :(integer) user id
		 |-----------------------------------------------------------------------
		 | Outputs :
		 |			 -	$user_app_visible if an application is visible to the user
		 |			 -  False if the given application is not visible to the user
		 |------------------------------------------------------------------------
		*/
	global $crypt;


		$sql = "SELECT COMP_APP_VISIBLE FROM  TBL_COMP_APP INNER JOIN ";
		$sql .= "TBL_APPLICATION ON TBL_COMP_APP.APPLICATION_ID=TBL_APPLICATION.APPLICATION_ID ";
		$sql .= "WHERE COMPANY_ID=$company_id AND TBL_APPLICATION.APPLICATION_ID=$application_id";

		$q = $this->db->query($sql);
		if ($q->execute ())
			{
			while ($tbl = $q->fetch ())
				{
				$user_app_visible= $tbl->{"COMP_APP_VISIBLE"};
				}
			$q->free();
			return  1;//$crypt->decrypt($user_app_visible);
			}
		else
			{
			return FALSE;
			}
		}

	function  GetUserLoginInfo()
	{
		/*
**	20-08-2004 :: Not currently being used? -> Login is using this :P
		** Supervisor is removed

		 |----------------------------------------------------------
		 | Purpose :
		 |				Check and validate the login of the user
		 |				Return  $user_id if success
		 |				Return -4 if user unknown or -3 if password is wrong
		 |----------------------------------------------------------
		*/
	global $crypt, $dba_driver;
	$sql = "SELECT USER_ID, USER_NAME, TBL_USER.INFO_PERSON_ID AS INFO_PERSON_ID, LANGUAGE_ID, APPLICATION_ID, TBL_INFO_PERSON.COMPANY_ID AS COMPANY_ID,USER_PASSWORD ";
	$sql .= "FROM TBL_USER, TBL_INFO_PERSON WHERE BINARY USER_NAME=? AND TBL_INFO_PERSON.INFO_PERSON_ID = TBL_USER.INFO_PERSON_ID ";
	$sql .= "AND USER_ACTIVE= ? ";

	$q = $this->db->query($sql);
	$q->bind_values(array($this->loginname, 1));
		if ($q->execute ())
		{
			$User_info = array("USER_ID"=>'',
								"USER_NAME"=>'',
								"INFO_PERSON_ID"=>'',
								"LANGUAGE_ID"=>'',
								"APPLICATION_ID"=>'',
								"USER_PASSWORD"=>'',
								"COMPANY_ID"=>'');

			if ($tbl = $q->fetch ())
				{
						$User_info["USER_ID"] = $tbl->{'USER_ID'};
						$User_info["USER_NAME"] = $tbl->{'USER_NAME'};
						$User_info["INFO_PERSON_ID"] = $tbl->{'INFO_PERSON_ID'};
						$User_info["LANGUAGE_ID"] = $tbl->{'LANGUAGE_ID'};
						$User_info["APPLICATION_ID"] = $tbl->{'APPLICATION_ID'};
						$User_info["COMPANY_ID"] = $tbl->{'COMPANY_ID'};
						if($tbl->{'USER_PASSWORD'} == sha1($this->password))
							{
								$User_info["USER_PASSWORD"] = ''; //$decrypted_password; // FIXME . we can't decrypt
							}
						else
							{
						// unset the array
								$User_info["USER_ID"] = "";
								return -3;
							}
				}
			else
				return -4;

			return $User_info;
			}
		else
			return  -4;
	}

	function GetGroupCompanyID($company_id, $group_id)
	{
		$sql = "SELECT GROUP_COMPANY_ID FROM TBL_GROUP_COMPANY WHERE GROUP_ID=";
		$sql .= $group_id." AND COMPANY_ID=".$company_id;

		$q_st = $this->db->query($sql);
		if(!$q_st)
			{
			return FALSE;
			}
		if($t = $q_st->execute())
			{
			$group_id = 0;
			while ($tbl = $q_st->fetch ())
				{
				$group_id = $tbl->{"GROUP_COMPANY_ID"};
				}
			$q_st->free();
			return $group_id;
		}
	}


	function GetGroupID($user_id)
	{
			/*
			 |-------------------------------------------------------------------------
			 | Author : Mbassa DABO
			 |--------------------------------------------------------------------------
			 | Purpose :  Get the group id where the user passed by refence belongs.
			 |--------------------------------------------------------------------------
			 | Variables :
			 |			 -	$user_id : (integer)  id of a user
			 |			 -  (object) $db :  valide  dabase object connection.
			 |--------------------------------------------------------------------------
			 | Return value :
			 |					(integer) $group_id : if the user has a group
			 |							  FALSE :  if no group is found.
			 |---------------------------------------------------------------------------
			 | Last modified :  23/01/2002
			 |----------------------------------------------------------------------------
			 */
			if(!$user_id)
			{
				return FALSE;
			}
			$sql = "SELECT TBL_GROUP.GROUP_ID AS GROUP_ID FROM TBL_GROUP INNER JOIN TBL_GROUP_USER ON ";
			$sql .= "TBL_GROUP_USER.GROUP_ID=TBL_GROUP.GROUP_ID WHERE USER_ID=$user_id";

			$q_st = $this->db->query($sql);
			if(!$q_st)
			{
				return FALSE;
			}
			if($t = $q_st->execute())
			{
				$group_id = 0;
				while ($tbl = $q_st->fetch ())
				{
					$group_id = $tbl->{"GROUP_ID"};
				}
				$q_st->free();
				return $group_id;
			}
	}

	function GetUserGroupName($user_id)
	{
		// Get the groupname for the user $user_id passed by reference;
		// $user :  The id of the user logoon ot the site
		// $sql :  valide  $ql query

		$sql = "SELECT GROUP_NAME FROM TBL_GROUP INNER JOIN TBL_GROUP_USER ON ";
		$sql .= "TBL_GROUP.GROUP_ID=TBL_GROUP_USER.GROUP_ID WHERE USER_ID=$user_id";


		if(!$user_id)
		{
			return FALSE;
		}
		if(!$sql)
		{
			return FALSE;
		}
		$sq = $this->db->query($sql);

		if(!$sq)
		{
			return FALSE;
		}
		if($sq->execute())
		{
			$group = "";
			while ($tbl = $sq->fetch ())
			{
				$group  = $tbl->{"GROUP_NAME"};
			}
			$sq->free();
			return $group;
		}

	}



	function checkLogin()
	{
		/*
		 |----------------------------------------------------------
		 | Purpose :
		 |				Check and validate the login of the user
		 |				Return  $user_id if success
		 |				Return 0 if user unbknow
		 |----------------------------------------------------------
		*/
		$sql = "SELECT USER_ID FROM TBL_USER WHERE BINARY USER_NAME='".$this->loginname."' and USER_PASSWORD='".$this->password."'";
		$sql = $sql . " and USER_ACTIVE='TRUE'";

		$q = $this->db->query($sql);
		$user_id = 0;
		if ($q->execute ())
		{

			while ($tbl = $q->fetch ())
			{
				$user_id = $tbl->{$q->field ($i)};
				$i++;
			}
			return $user_id;
		}
		else
		{
			return FALSE;
			// Query failed
			//echo "ERROR : [$sql]<br>";
		}
	}

	function checkSession($ID)
	{
		// Check and return the user id from the give session (ID)
		// return the user id if succses
		// else return 0
		$sql = "SELECT USER_ID FROM TBL_LOGIN WHERE LOGIN_SESSION_ID='".$ID."'";

		$q = $this->db->query($sql);

		$user_id = 0;
		if($q->execute())
		{
			while ($tbl = $q->fetch ())
			{
				$user_id = $tbl->{$q->field (1)};
			}
		}
		return  $user_id;
	}


	function GetSession($user_id)
	{
		// Get the sesssion id from the user_id.
		// return a session id if exists.
		$sql = "SELECT LOGIN_SESSION_ID FROM TBL_LOGIN WHERE USER_ID=$user_id";

		$session_id  = 0;
		$qs = $this->db->query($sql);

		if($qs->execute())
		{
			while ($tbl = $qs->fetch ())
			{
				$session_id = $tbl->{"LOGIN_SESSION_ID"};
			}
		}
		return $session_id;
	}

	function closeSession()
	{
		session_start();
		$name_sess = session_id();
		$header = new headerClass();
//		$sql = "DELETE FROM TBL_LOGIN WHERE LOGIN_SESSION_ID='$name_sess'";
		$sql = "DELETE FROM TBL_LOGIN WHERE USER_ID='".$_SESSION["session_user_id"]."'";
		$q = $this->db->query($sql);
		if($q->execute())
		{
			// Session is removed properly
			$q->commit();

			// unset all the attached values
			$_SESSION["publishArray"] = array();
			unset($name_sess);
/*			foreach( $_SESSION as $key => $val )
				unset( $_SESSION[$key] );*/
			$_SESSION = array();
			$header->deleteTmp();
			session_unset();
			// Finally, destroy the session.
			session_destroy();

			return 1;
		}
		else
		{
			// Session not removed from the TBL_LOGIN
			return 0;
		}
	}


	function GetUserData ($Selected, $Table, $Data)
	{

		global $db;
		$NumDatas = 0;
		while (each ($Data))
		{
    		$NumDatas++;
		}
		if ((!$Selected)|($NumDatas<1))
		{
    		return FALSE;
		}
		reset ($Data);
		$Sql = "SELECT $Selected FROM $Table ";
		if ($NumDatas>0)
		{
    		$Sql.= "WHERE ";
			$Counter = 1;
			while (list ($Key, $Value) = each ($Data))
			{
      			$Sql .= $Key."='".$Value."' ";
				if ($Counter<$NumDatas)
				{
         			$Sql .= "AND ";
				}
				$Counter++;
     		}
		}
		$sq = $db->query($Sql);
		if(!$sq)
		{
			return FALSE;
		}
		if($sq->execute())
		{
			$i = 0;
			$y = 1;
			$return_data = array();
			while ($tbl = $sq->fetch ())
			{
				$return_data[$i++] = $tbl->{$sq->field ($y)};
				$y++;
			}
		}

		// close the connection
		$sq->free();
		return $return_data;
  }


	function StoreLoginInfoToTBlLogin($userid)
	{
//		global $session_user_id;  // store in the active session.
								 // set to an integer if a valid session exists
		global $REMOTE_ADDR;
		global $PHPSESSID;
		if(!$userid > -1)
		{
			return false;
		}
		$is_user_in_table = $this->GetSession($userid);

		$ipnr = $REMOTE_ADDR;
//		$current_date = date('d-m-Y H:i:s');
//		$current_date = time();
		$current_date =  date("Y-m-d H:i:s");
//		session_start();
		$sess_id = session_id();
		if($is_user_in_table)
		{
			// make an update
			$sql = "UPDATE TBL_LOGIN SET LOGIN_IP_ADDRESS='$ipnr', LOGIN_DATE='$current_date', LOGIN_SESSION_ID='$sess_id' where USER_ID='$userid'";
			///////////////// Tomorrow /////////////////////////////////
		}
		else
		{
			$sql = "INSERT INTO TBL_LOGIN (USER_ID, LOGIN_IP_ADDRESS, LOGIN_DATE, LOGIN_SESSION_ID) VALUES ($userid,'$ipnr', '$current_date','$sess_id')";
		}

//		echo $sql;
//		exit;

		$sq = $this->db->query($sql);
		if($sq->execute())
		{
			return 1;
		}
		else
		{
			exit ($sql);
			return false;
		}
	}

	function CheckSessionAndUser()
	{
		/*
		//-------------------------------------------------------------------------------------
		// Author: Mbassa DABO
		//--------------------------------------------------------------------------------------
		// Pupose:
		//     	Get the user id of the loggon user via his session id.
		//--------------------------------------------------------------------------------------
		// Inputs : $db: valide database object connection.
		//--------------------------------------------------------------------------------------
		// Return :
		//			$user_id  : if it is found
		//			FALSE : if no user_id is found
		//---------------------------------------------------------------------------------------
		// Last modified : 22-03-2002
		//----------------------------------------------------------------------------------------
		*/
		global $PHPSESSID;

		$ID =  $PHPSESSID;
		if(!$ID)
		{
			return FALSE;
		}
		else
		{
			// Check if there is an user_id attache with the given session id
			$session_id =  trim($ID);
			$user_id  = $this->checkSession($session_id);
			if(!$user_id)
			{
				return FALSE;
			}
			return $user_id;
		}
	}

	function ExtractUserIdfromSessID()
	{
		/*
		|-----------------------------------------------------------
		|	Author : Mbassa DABO
		|----------------------------------------------------------
		| Purpose :	Used when switchin beetween applications
		|----------------------------------------------------------
		| Output : - user_id if exists
		|		   - 0 if not.
		|
		|------------------------------------------------------------
		|
		*/

		global $REMOTE_ADDR;

		$ipnr = $REMOTE_ADDR;
		global $crypt, $PHPSESSID;
		$current_session = $PHPSESSID;

		$sql = "SELECT USER_NAME,USER_PASSWORD FROM TBL_USER INNER JOIN TBL_LOGIN ON ";
		$sql .= "TBL_USER.USER_ID=TBL_LOGIN.USER_ID WHERE LOGIN_SESSION_ID='$current_session' ";
		$sql .= "AND LOGIN_IP_ADDRESS='$ipnr'";
		$sq = $this->db->query($sql);

			if(!$sq)
			{
				return FALSE;
			}
			if($sq->execute())
			{
				$user_id = 0;
				while ($tbl = $sq->fetch ())
				{
					$this->loginname = $tbl->{$sq->field (1)};
					$this->password = ''; // $crypt->decrypt($tbl->{$sq->field (2)}); // FIXME . we can't decrypt password
				}
				$sq->free();
				if($this->loginname && $this->password)
				{
					return 1;
				}
				else
				{
					return FALSE;
				}
			}
			else
			{
				return  FALSE;
			}
	}
	/**
	 * Checks to see wether or not a user of a certain company is already logged in.
	 * If the company is part of the switch ( please move to I-Admin and Database )
	 * then the user cannot re-login if it is still logged in.
	 * @todo move to database
	 * @param int $company_id
	 * @param int $user_id
	 * @return boolean
	 */
	function checkDoubleLogin($company_id, $user_id)
	{
		if ($user_id > 0)
		{
			$sql = "SELECT COMPANY_NAME FROM TBL_COMPANY WHERE COMPANY_ID=$company_id";
			$ex = $this->db->query($sql);
			if ($ex->execute())
			{
				if ($row = $ex->fetch())
				{
					switch ($row->{"COMPANY_NAME"})
					{
						case "Braatsel";
						case "Tnt" :
						case "Sr" :
						case "Fme":
						case "Nieuwenhuys":
						case "Beercoo":
						//case "Gca":
						case "Ancora":
							$sql = "SELECT UNIX_TIMESTAMP( LOGIN_DATE ) as DT FROM TBL_LOGIN WHERE USER_ID=$user_id";
							$ex = $this->db->query($sql);
							if ($ex->execute())
							{
								if ($row = $ex->fetch())
								{
									/*if( is_file( "../../../classes/i-w/date_conversion.php" ))
										require_once(IWARE."date_conversion.php" );
									else
										require_once( "../../classes/i-w/date_conversion.php" );
									$dc = new date_Conversion();*/
									;
									$login_time = $row->{"DT"};
									if( $login_time < ( date( "U" ) - 1800 ))
										return false;
									else
										return true;
								}
								else
									return false;
							}
							else
								return false;
						break;
						default:
							return false;
					}
				}
				else
					return true;
			}
		}
		else
			return false;
	}

	function getCompanyByLogin($login_id)
	{
		$sql = "SELECT COMPANY_ID FROM TBL_MAILLIST ";
		$sql .= "INNER JOIN TBL_MAILLIST_RELATION ON TBL_MAILLIST.MAILLIST_ID = TBL_MAILLIST_RELATION.MAILLIST_ID ";
		$sql .= "INNER JOIN TBL_PARTICIPANT ON TBL_MAILLIST_RELATION.RELATION_ID = TBL_PARTICIPANT.RELATION_ID ";
		$sql .= "INNER JOIN TBL_LOGIN ON TBL_LOGIN.USER_ID = TBL_PARTICIPANT.PARTICIPANT_ID AND TBL_LOGIN.LOGIN_ID = ? ";
		$ex = $this->db->query($sql);
		$ex->bind_values (array($login_id));
		if ($ex->execute())
		{
			if ($row = $ex->fetch())
			{
				return $row->{"COMPANY_ID"};
			}
		}

		return false;
	}

	function CloneLogin($old_participant, $new_participant, $copyMode, $source_publish_id)
	{

		$login_array = array();
		$old_login_array = array();
		$sql = "SELECT LOGIN_ID FROM TBL_LOG_PUBLISH WHERE PARTICIPANT_ID=? AND PUBLISH_ID=?";
		$ex = $this->db->query($sql);
		$ex->bind_values (array($old_participant, $source_publish_id));
		if ($ex->execute())
		{
			while ($row = $ex->fetch())
				$old_login_array[] = $row->{"LOGIN_ID"};
		}
		if (sizeof($old_login_array) > 0)
			$sql = "SELECT * FROM TBL_LOGIN WHERE LOGIN_ID IN (".implode(",", $old_login_array).")";
		else
			$sql = "SELECT * FROM TBL_LOGIN WHERE USER_ID = $old_participant";
		$ex = $this->db->query($sql);
		if (! $ex->execute())
			return false;

			if ($copyMode == CP_CARBON_COPY || $copyMode == CP_PUBLISH_TO_HISTORY)
			{
				$sql = "INSERT INTO TBL_LOGIN (LOGIN_ID,USER_ID,LOGIN_SESSION_ID,LOGIN_IP_ADDRESS,LOGIN_DATE)
					VALUES (?,?,?,?,?)";
			}
			else
			{
				$sql = "INSERT INTO TBL_LOGIN (USER_ID,LOGIN_SESSION_ID,LOGIN_IP_ADDRESS,LOGIN_DATE)
					VALUES (?,?,?,?)";
			}
			$ins_ex = $this->target_db->query($sql);

		$i = 0;
		while($row = $ex->fetch())
		{
			$sql_test = "SELECT LOGIN_ID FROM TBL_LOGIN WHERE LOGIN_ID=".$row->{"LOGIN_ID"};
			$ex_test = $this->target_db->query($sql_test);
			$rs = $ex_test->fetchAll();
			if ($ex_test->execute() && count($rs) == 0)
			{
				$login_id = $row->{"LOGIN_ID"};
				$user_id = $new_participant;
				$login_session_id = $row->{"LOGIN_SESSION_ID"};
				$login_ip_address = $row->{"LOGIN_IP_ADDRESS"};
				$login_date =  $row->{"LOGIN_DATE"};
				if ($copyMode == CP_CARBON_COPY || $copyMode == CP_PUBLISH_TO_HISTORY)
					$ins_ex->bind_values(array($login_id,$user_id,$login_session_id,$login_ip_address, $login_date));
				else
					$ins_ex->bind_values(array($user_id,$login_session_id,$login_ip_address, $login_date));
				$ins_ex->execute();
				$login_array[$i][0] = $login_id;
				$login_array[$i][1] = $ins_ex->lastId();
				$login_array[$i][2] = $old_participant;
				$login_array[$i][3] = $new_participant;
				$i++;
			}
		}
		return $login_array;
	}

	function remoteLogoutUser( $user_id )
	{
		$sql = "DELETE FROM TBL_LOGIN WHERE USER_ID = ?";
		$ex = $this->db->query( $sql );
		$ex->bind_values( array( $user_id ));
		if( $ex->execute())
			return true;
		return false;
	}

	function userIsLoggedIn( $user_id )
	{
		$sql = "SELECT USER_ID FROM TBL_LOGIN WHERE USER_ID = ?";
				$ex = $this->db->query( $sql );
		$ex->bind_values( array( $user_id ));
		if( $ex->execute())
		{
			if( $r = $ex->fetch())
				return true;
		}
		return false;
	}

	function checkIp()
	{
		global $dba_conn_string_iware, $dba_user_iware, $dba_password_iware;

		// LOCAL IP, HAS ACCESS ?
		if( substr( $_SERVER['REMOTE_ADDR'], 0, 7 ) == "192.168" || $_SERVER['REMOTE_ADDR'] == "127.0.0.1" )
			return true;

		$db = new Database($dba_conn_string_iware, $dba_user_iware, $dba_password_iware, 1 );
		$sql = "SELECT IP_ADDRESS FROM TBL_ADMIN_IP WHERE IP_ADDRESS = ?";
		$ex = $db->query( $sql );
		$ex->bind_values( array( $_SERVER['REMOTE_ADDR'] ));
//		exit( $ex->tmp_sql );
		if( ! $ex->execute())
			return false;
		if( !($r = $ex->fetch()))
			return false;
		return true;
	}
}

?>
