<?php
require_once(IWARE.'AbstractObject.php');
/**
 * @author Marten Koedam <marten@basesoft.com>
 * @package I-Ware
 * @version $Id$
 */
class nLanguage extends AbstractObject
{
	/**
	 * @var int $id
	 */
	var $id;
	/**
	 * @var string $name
	 */
	var $name = '';
	/**
	 * @var string $charset
	 */
	var $charset = '';
	/**
	 * @var string $code
	 */
	var $code = '';
	/**
	 * @var string $locale
	 */
	var $locale = '';
	/**
	 * Selects for an option array for a select box
	 * @return string $rv
	 */
	function select($selected='',$status=false)
	{
		$rv = '';
		$sql = "SELECT LANGUAGE_ID, LANGUAGE,
				IF(LANGUAGE_ID=".$selected.",' selected=\"selected\"','') as SELECTED
			FROM TBL_LANGUAGE ";
		if($status!==false)
			$sql .= " WHERE LANGUAGE_STATUS & '".$status."' ";
		$sql .= " ORDER BY LANGUAGE";
		$q = $this->db->query($sql);
		$q->execute();
		while($r = $q->fetch())
			$rv .= '<option value="'.$r->LANGUAGE_ID.'"'.$r->SELECTED.'>'.$r->LANGUAGE.'</option>'."\n";
		return $rv;
	}
	/**
	 *
	 */
	function get()
	{
		$sql = "SELECT LANGUAGE_ID, LANGUAGE
			FROM TBL_LANGUAGE
			ORDER BY LANGUAGE";
		$q = $this->db->query($sql);
		$q->execute();
		return $q;
	}
	/**
	 *
	 */
	function getByStatus($status)
	{
		$sql = "SELECT LANGUAGE_ID, LANGUAGE
			FROM TBL_LANGUAGE
			WHERE LANGUAGE_STATUS & ?
			ORDER BY LANGUAGE";
		$q = $this->db->query($sql);
		$q->bind_values($status);
		$q->execute();
		return $q;
	}

	function getEditable()
	{
		// Admins can edit all languages (sysadmin in ELC)
		if ($_SESSION['session_group_group_name'] == 'sysadmin' || $_SESSION['session_group_group_name'] == 'operator')
			return $this->get();

		$sql = "SELECT l.LANGUAGE_ID, l.LANGUAGE
			FROM TBL_LANGUAGE l
			INNER JOIN TBL_TRANSLATOR t ON l.LANGUAGE_ID = t.LANGUAGE_ID
			WHERE t.USER_ID=?
			ORDER BY LANGUAGE";
		$q = $this->db->query($sql);
		$q->bind_values($_SESSION['session_user_id']);
		$q->execute();
		return $q;
	}

	function getLanguageNames($language_ids)
	{
		$language_ids = (array)$language_ids;
		$sql = "SELECT LANGUAGE_ID, LANGUAGE
			FROM TBL_LANGUAGE
			WHERE LANGUAGE_ID IN ( ".implode(',',$language_ids)." )
			ORDER BY LANGUAGE";
		$q = $this->db->query($sql);
		$q->execute();
		return $q;
	}

	function _initObjectMaps()
	{
		$this->objectmap['dbtable'] = 'TBL_LANGUAGE';
		$this->objectmap['primary']['id'] = 'LANGUAGE_ID';
		$this->objectmap['properties']['name'] = 'LANGUAGE';
		$this->objectmap['properties']['charset'] = 'LANGUAGE_CHARSET';
		$this->objectmap['properties']['code'] = 'LANGUAGE_CODE';
		$this->objectmap['properties']['locale'] = 'LANGUAGE_LOCALE';
	}
}

define('LANGUAGE_STATUS_ENABLED',1);
define('LANGUAGE_STATUS_SELECTABLE',2);

/**

CREATE TABLE `TBL_LANGUAGE` (
	`LANGUAGE_ID` int(11) NOT NULL default '0',
	`LANGUAGE` varchar(50) default NULL,
	`LANGUAGE_CHARSET` varchar(255) default 'iso-8859-1',
	`LANGUAGE_CODE` varchar(255) default NULL,
	`LANGUAGE_LOCALE` varchar(255) default NULL,
	PRIMARY KEY  (`LANGUAGE_ID`)
);

*/
?>
