<?php
/**
 * @package I-Ware
 */
class Script
	{

	var $db;
	var $db_iware;

	var $script_id;
	var $script_parent_id;
	var $script_position = 0;
	var $script_path = "";
	var $script_menuitem = 0;
	var	$application_id = 0;

	var $group_company_id;
	var $access;
	var $permissions;

	function Script($db, $script_id, $script_parent_id, $group_company_id)
	{
		global $db_iware;

		if ( !isset($db_iware) || !$db_iware )
		{
			global $dba_conn_string_iware;
			global $dba_user_iware;
			global $dba_password_iware;
			$db_iware = new Database ($dba_conn_string_iware, $dba_user_iware, $dba_password_iware, 1);
		}

		$this->db_iware = $db_iware;
		$this->db = $db;
		$this->script_id = $script_id;
		$this->script_parent_id = $script_parent_id;
		$this->group_company_id = $group_company_id;
		$this->access = 0;
		$this->permissions = array(
				"READ"		=> 1,
				"WRITE"		=> 2,
				"CHANGE"	=> 4,
				"DELETE"	=> 8
				);
	}

	function check()
		{
		global $_SESSION;
		global $_SERVER;

		if( ! isset( $_SESSION["session_user_id"] ))
			header( 'Location: http://'.SITE_SERVER.SITE_PATH.'scripts/i-w/no_access.php?top=true' );

		if (! isset($this->script_id))
			return false;
		if (! isset($this->script_parent_id))
			return false;

		$logout_page = '<br /><br /><a href="http://'.SITE_SERVER.SITE_PATH.'scripts/i-w/logout.php">Logout</a>';

		$sql = "SELECT SCRIPT_ID FROM TBL_SCRIPT WHERE SCRIPT_ID = ?
				AND SCRIPT_PARENT_ID = ?";
		$ex = $this->db_iware->query($sql);
		$ex->bind_values(array($this->script_id, $this->script_parent_id));
		$ex->execute();
		$rs = $ex->fetchAll();
		if (count($rs) != 1)
			return false;

		$db_privileges =& $GLOBALS['db_privileges'];

		$sql = "SELECT SCRIPT_GROUP_ACCESS FROM TBL_SCRIPT_GROUP WHERE GROUP_COMPANY_ID=?
				 AND TBL_SCRIPT_GROUP.SCRIPT_ID=? ";

		$ex = $db_privileges->query($sql);
		$ex->bind_values(array($this->group_company_id, $this->script_id));

		if ($ex->execute())
			{
			$tbl = $ex->fetch();

			$this->access = $tbl->{"SCRIPT_GROUP_ACCESS"};

			if ($this->access > 0)
				{
				$match = true;
				if ( $match )
					return true;
				else
					require( SITE_HOMEDIR.SITE_PATH.'scripts/i-w/PermissionDenied.php' );
				}
			else
				{
				//$direction = "http://".$_SESSION['Session_Application_Server'].$_SESSION['Session_Application_Path'].$_SESSION['session_no_access_page'];
				$no_access = defined('NO_ACCESS_PAGE') ? NO_ACCESS_PAGE : '';
				$direction = "http://".SITE_SERVER.SITE_PATH.$no_access;
//				header("Location: $direction");
					require( SITE_HOMEDIR.SITE_PATH.'scripts/i-w/PermissionDenied.php' );
				}
			}
		else
			require( SITE_HOMEDIR.SITE_PATH.'scripts/i-w/PermissionDenied.php' );
		}

	function checkReturn( $script_id )
	{
		$db_privileges =& $GLOBALS['db_privileges'];
		$this->setScript( $script_id );
		$sql = "SELECT SCRIPT_GROUP_ACCESS FROM TBL_SCRIPT_GROUP WHERE GROUP_COMPANY_ID=?
				 AND TBL_SCRIPT_GROUP.SCRIPT_ID=? ";
		$ex = $db_privileges->query($sql);
		$ex->bind_values(array($this->group_company_id, $this->script_id));
		$ex->execute();

		if( $row = $ex->fetch())
		{
			if( $row->{"SCRIPT_GROUP_ACCESS"} > 0 )
				return true;
		}
		return false;
	}

	function getAccessLevel ($rights)
		{
//		return ($this->access & $this->permissions[$rights]);
		return (($this->access & $this->permissions[$rights]) == $this->permissions[$rights]);
		}

	//function

	function getAccessLevelScript ($rights, $value)
		{
		return (($value & $this->permissions[$rights]) == $this->permissions[$rights]);
		}

	function getAllScripts($script_parent_id = 0, $ordered = false)
		{
			$sql = "SELECT * FROM TBL_SCRIPT WHERE";
			if ($script_parent_id != 0)
				 $sql .=  " SCRIPT_PARENT_ID = $script_parent_id AND ";

			$sql .= " 1=1 "; // dummy code

			if ($ordered)
				$sql .= " ORDER BY SCRIPT_ID";

			$ex = $this->db_iware->query($sql);

			if ($ex->execute())
				return $ex;
			else
				return false;
		}


	function setScript($script_id)
	{
		$sql = "SELECT * FROM TBL_SCRIPT WHERE SCRIPT_ID = ?";
		$ex = $this->db_iware->query($sql);
		$ex->bind_values($script_id);
		$ex->execute();
		if ($row = $ex->fetch())
		{
			$this->script_parent_id = $row->{"SCRIPT_PARENT_ID"};
			$this->script_position = $row->{"SCRIPT_POSITION"};
			$this->script_path = $row->{"SCRIPT_PATH"};
			$this->menuitem = $row->{"SCRIPT_MENUITEM"};
			$this->application_id = $row->{"APPLICATION_ID"};
		}
	}

	function getCheckBoxPermission($script_id, $script_access )
	{
		$read = "";
		$write = "";
		$change = "";
		$delete = "";

		$this->access = $script_access;

		if ($this->getAccessLevel("READ"))
			$read = "CHECKED";
		if ($this->getAccessLevel("WRITE"))
			$write = "CHECKED";
		if ($this->getAccessLevel("CHANGE"))
			$change = "CHECKED";
		if ($this->getAccessLevel("DELETE"))
			$delete = "CHECKED";

		$output = "";
		$output .= "
			<td class=\"antwoordform\" align=\"middle\"><input type=\"checkbox\" name=\"read$script_id\" value=\"1\" $read style=\"border:0\">\n
			</td><td class=\"antwoordform\" align=\"middle\"><input type=\"checkbox\" name=\"write$script_id\" value=\"1\" $write style=\"border:0\" > \n
			</td><td class=\"antwoordform\" align=\"middle\"><input type=\"checkbox\" name=\"change$script_id\" value=\"1\" $change style=\"border:0\" >\n
			</td><td class=\"antwoordform\" align=\"middle\"><input type=\"checkbox\" name=\"delete$script_id\" value=\"1\" $delete style=\"border:0\" >\n
			</td><td class=\"antwoordform\" align=\"middle\">&nbsp;</td>";

		return $output;
	}

	function getNewPermission($read,$write,$change, $delete)
	{
		$accessLevel = 0;
		if ($read)
			$accessLevel += $this->permissions["READ"];
		if ($write)
			$accessLevel += $this->permissions["WRITE"];
		if ($change)
			$accessLevel += $this->permissions["CHANGE"];
		if ($delete)
			$accessLevel += $this->permissions["DELETE"];

		return $accessLevel;
	}
}
?>
