/**
 * WEEE.Dashboard
 * This class extends the IWARE.Dashboard
 *
 * @package IWARE
 * @subpackage Dashboard
 * @since May 10, 2007
 * @author Martijn van den Broek <mjbroek@gmail.com>
 * @version $Id$
 * @copyright 2007 BaseSoft B.V.
 */

/**
 * Define group ids. Widgets themself can define if they belong to specific groups
 */
var WEEE_GROUP_PUBLIC = 1;
var WEEE_GROUP_OPERATOR = 2;
var WEEE_GROUP_CRSO = 3;
var WEEE_GROUP_PARTICIPANT = 4;
var WEEE_GROUP_SYSADMIN = 5;

var WEEE_DASHBOARD_PATH = '/includes/elc/Dashboard/'
var WEEE_WIDGETS_PATH = WEEE_DASHBOARD_PATH + 'Widgets/';

WEEE.Dashboard = function(dashboard_container, current_universe)
{
	dumpln('WEEE.Dashboard() - current_universe: '+current_universe);

	// we want to include elc specific widgets
 	this.includes = this.includes.concat([
		WEEE_WIDGETS_PATH + 'LastLoginsWidget.js',
 		/*
		WEEE_WIDGETS_PATH + 'ChartWidget.js',
		WEEE_WIDGETS_PATH + 'DeclarationQuantityWidget.js',
		WEEE_WIDGETS_PATH + 'DocumentViewsWidget.js',
		WEEE_WIDGETS_PATH + 'EuropeWidget.js',
		WEEE_WIDGETS_PATH + 'InvoicedVSOutstandingWidget.js',
		WEEE_WIDGETS_PATH + 'RefundChartWidget.js',
		WEEE_WIDGETS_PATH + 'CalendarWidget.js',
		*/

		WEEE_WIDGETS_PATH + 'WEEE.DataPilotWidget.js',
		WEEE_WIDGETS_PATH + 'NotificationsWidget.js',
		WEEE_WIDGETS_PATH + 'ChartWidget.js',
		WEEE_WIDGETS_PATH + 'InvoicedVSOutstandingWidget.js'
	]);

 	// define which widgets for which universes (no universes means all universe)
 	var aWidgets = [
 		{ className: 'WEEE.LastLoginsWidget', universes: [WEEE_GROUP_OPERATOR, WEEE_GROUP_SYSADMIN] },
 		{ className: 'WEEE.DataPilotWidget' },
 		{ className: 'WEEE.NotificationsWidget', universes: [WEEE_GROUP_PARTICIPANT, WEEE_GROUP_CRSO] },

 		{ className: 'WEEE.InvoicedVSOutstandingWidget', universes: [WEEE_GROUP_PARTICIPANT, WEEE_GROUP_CRSO] }

 		/*
		'WEEE.EuropeWidget',
		'WEEE.InvoicedVSOutstandingWidget',
		'WEEE.DocumentViewsWidget',
		'WEEE.RefundChartWidget',
		'WEEE.DeclarationQuantityWidget',
		'WEEE.CalendarWidget',
		*/
 	];

 	// make an array of all widgets we want to register
 	var widgets = [];
 	for (var i=aWidgets.count()-1; i>0; i--)
 	{
 		if (typeof aWidgets[i].universes == 'undefined' || aWidgets[i].universes.in_array(current_universe))
			widgets.push(aWidgets[i].className);
		else
 			dumpln('WEEE.Dashboard() - Not registrating widget '+aWidgets[i].className+' because it not for this universe');
 	}

 	// and register them
 	this.registerWidgets = this.registerWidgets.concat(widgets);

	// now call super
	WEEE.Dashboard.superclass.constructor.call(this, dashboard_container);
}

YAHOO.extend(WEEE.Dashboard, IWARE.Dashboard,
{
	// WEEE.Dasboard prototype
});
