

/**
 * @extends IWARE.AbstractWidget
 */
WEEE.ChartWidget = function() { }

YAHOO.extend(WEEE.ChartWidget, IWARE.AbstractWidget,
{

	title: 'Abstract Chart Widget',
	description: 'A base class for showing charts',

	lang_handles: [
		'CRSO',
		'Product',
		'Period'
	],

	handle: '',

	settingsClass: IWARE.WidgetSettings,

	includes: [
		'/includes/i-w/json.js'
	],

	init: function()
	{
		WEEE.ChartWidget.superclass.init.call(this);

		var onchange = hitch(this, 'refresh');

		this.settings.addRow(langIf.getText('CRSO'), this.settings.makeSelect('crso[id]', [], 'DashboardHandler.getCRSOs', onchange));
		this.settings.addRow(langIf.getText('Product'), this.settings.makeSelect('product[id]', [], 'DashboardHandler.getProducts', onchange));
		this.settings.addRow(langIf.getText('Period'), this.settings.makeSelect('month', [], 'DashboardHandler.getLastMonths', onchange));
	},

	/**
	 * @final
	 */
	setBody: function(nNode)
	{
		this.img = document.createElement('IMG');
		nNode.appendChild(this.img);

		this.refresh();
	},

	refresh: function()
	{
		var settings = this.settings.getFormValues();
		var src = '/scripts/elc/bots/DashboardChart.php?handle='+this.handle+'&settings='+(serialize(settings).URLEncode());
		this.img.src = src;
	}

} );
