

WEEE.NotificationsWidget = function() {
	WEEE.NotificationsWidget.superclass.constructor.call(this);
}

YAHOO.extend(WEEE.NotificationsWidget, IWARE.TableWidget,
{
	title: 'Notifications Widget',
	description: 'Showing the last unread notifications',
	rpcCall: 'DashboardHandler.getNotifications',

	tableCssClass: 'NotificationsList',

	includes: [
		'/includes/elc/Dashboard/Widgets/NotificationsWidget.css'
	],

	hideColumns: [
		'NOTIFICATION_ID',
		'STATUS',
		'SUBJECT'
	],

	settingsClass: IWARE.WidgetSettings,

	lang_handles: [
		'Sender'
	],

	init: function()
	{
		WEEE.NotificationsWidget.superclass.init.call(this);

		// add a settings row with two empty td's
		var tr = this.settings.addRow('', '');
		var td1 = tr.cells[0];
		var td2 = tr.cells[1];

		// read / unread checkboxes:
		['read', 'unread'].forEach(function(el, i, a)
		{
			var chk = document.createElement('input');
			chk.type = 'checkbox';
			chk.name = chk.id = 'show_'+el;
			td1.appendChild(chk);

			// hook onchange event to reload table data
			addEvent(chk, 'change', hitch(this, 'fetchData'));

			var lbl = document.createElement('label');
			lbl.htmlFor = chk.id;
			lbl.innerHTML = 'Show '+el +'&nbsp'; // fixme: translate this
			td1.appendChild(lbl);

			td1.appendChild(document.createElement('br'));
		}, this);

		// limit select
		var lbl = document.createElement('label');
		lbl.innerHTML = 'Limit' +'&nbsp'; // fixme: translations
		td2.appendChild(lbl);

		var sel = document.createElement('select');
		sel.name = 'limit';
		td2.appendChild(sel);

		sel.options.add(new Option('5', '5'));
		sel.options.add(new Option('10', '10'));
		sel.options.add(new Option('20', '20'));

		// hook onchange event to reload table data
		addEvent(sel, 'change', hitch(this, 'fetchData'));
	},

	rowProcessors: [
		// rowProcessor that changes classname of a TR when the status is unread
		function(nTr, aRow)
		{
			if (aRow['STATUS'] & 1) // status unread
				nTr.className += ' unread';
		}
	],

	valueProcessors: {
		'SENDER': function(sData, aRow)
		{
			var div = document.createElement('div');

			var a = document.createElement('A');
			a.innerHTML = aRow['SUBJECT']
			a.href = '/scripts/elc/public/InterfaceNotificationDetails.php?notification[id]='+aRow['NOTIFICATION_ID'];
			div.appendChild(a);

			div.appendChild(document.createElement('BR'));

			var span = document.createElement('span');
			span.innerHTML = langIf.getText('Sender')+': '+aRow['SENDER'];
			div.appendChild(span);

			return div;
		}
	}
});
