<?php

	/**
	 * RPC call to send a notification
	 * @see /iqelc/interfaces/participant/InterfaceParticipantUserRegistration.php
	 */
	function sendNotification(&$broker)
	{
		global $db, $langIf;
		$params = &$broker->params;

		if (empty($params['sender_id']))
			return "Error: no map[sender] set";

		if (empty($params['message']))
			return "Error: no map[message] set";

		if (empty($params['subject']))
			return "Error: no map[subject] set";

		if (!is_array($params['recipients']))
			return "Error: no recipients found";

	 	$recipients = array();
	 	require_once(ELC_CLASSES.'Notification.php');
	 	require_once(ELC_CLASSES.'Relation.php');
	 	require_once(ELC_CLASSES.'User.php');

	 	foreach ($params['recipients'] as $recipient)
	 	{
	 		$r = array();

	 		if (isset($recipient['recipient_id']))
	 			$r['recipient'] = new Relation($db, $recipient['recipient_id']);

	 		if (isset($recipient['user_id']))
	 			$r['user'] = new ElcUser($db, $recipient['user_id']);

	 		if (isset($recipient['callback']))
	 			$r['callback'] = $recipient['callback'];

	 		$recipients[] = $r;
	 	}

	 	Notification::send($db,
	 		array('subject'=>$params['subject'],
	 			'sender'=>new Relation($db, $params['sender_id']),
	 			'message'=>$params['message']),
	 		$recipients
	 	);

	 	return 'success';
	}

?>
