<?php
require_once(ELC_CLASSES.'Notification.php');
class NotificationHandler extends IWAbstractRPC {

	static function loadData() {

		$n = new Notification(IWRegistry::registry('db'));
		switch($_SESSION['session_group_group_id']) {

			case GROUP_PARTICIPANT:
				$relation_ids = $_SESSION['participant_ids'];
			break;
			case GROUP_CRSO:
				$relation_ids = array($_SESSION['crso_relation_id']);
			break;
			case GROUP_ACCOUNTANT:
				$relation_ids = array($_SESSION['accountant_relation_id']);
			break;
			case GROUP_SYSADMIN:
			default:
				return array();
			break;
		}
		$rv = array();
		$q = $n->select($_SESSION['session_user_id'], $relation_ids, NOTIFICATION_STATUS_UNREAD, null, null, $_SESSION['selected_product_id']);
		while($r = $q->fetch()) {
			$user = null;
			$relation = new Relation(IWRegistry::registry('db'), $r->SENDER_ID, true);
			if($r->SENDER_USER_ID) {
				$user = new ELCUser(IWRegistry::registry('db'), $r->SENDER_USER_ID, true);
				$user->info_person->set();
			}

			$rv[] = array(
				'id'=> $r->NOTIFICATION_ID,
				'from'=>$relation->name.($user?sprintf(' (%s)', $user->info_person->last_name):''),
				'subject'=>$r->SUBJECT
			);
		}
		return $rv;
	}
}

?>