<?php

	function requestGeneralManager(&$broker)
	{
		$params = $broker->params;
		global $db, $langIf;

		if(!isset($_SESSION['participant_ids'][$params['participant_id']]))
			return array();

		require_once(ELC_CLASSES.'CRSOParticipantProduct.php');
		require_once(ELC_CLASSES.'Relation.php');
		require_once(ELC_CLASSES.'User.php');
		require_once(ELC_CLASSES.'Product.php');

		$participant = new Participant($db, array('relation'=>new Relation($db, $params['participant_id'], true)));
		$crso = new CRSO($db, array('relation'=>new Relation($db, $params['crso_id'], true)));
		$user = new ELCUser($db, $params['user_id'], true);

		$cp = new CRSOParticipantProduct($db, array('crso'=>$crso, 'participant'=>$participant));
		$cp->general_manager = &$user;
		$cp->general_manager_authorized = GENERAL_MANAGER_REQUEST;
		$cp->product = new Product($db,$_SESSION['selected_product_id']);
		$cp->update();

		require_once(ELC_CLASSES.'Notification.php');
 		Notification::send($db,
 		array('subject'=>$langIf->getText('Notification: Request General Manager'),
 			'sender'=>$participant->relation,
 			'message'=>$langIf->getText('Notification: Participant `{PARTICIPANT}` requests `{USER}` to be a GM',
						null,  array('PARTICIPANT'=>$participant->relation->name, 'USER'=>$user->name))),
 		array(
 			array('recipient'=>$crso->relation,
 				'callback'=>sprintf("go('/".SITE_PATH."scripts/elc/crso/InterfaceRegistrantUserDetails.php?user[id]=%s&participant[id]=%s')", $user->id, $participant->relation->id)
 		)));

                log_elc_event(sprintf('Participant requested General Manager for user id [%s]', $params['user_id']),
                    $_SESSION['session_user_id'], $_SESSION['selected_product_id'], $params['crso_id'], $params['participant_id']
                );
	}

?>
