<?php
/**
 * @package
 * @subpackage
 * @since 19-sep-2007
 * @author Marten Koedam <marten@dalines.net>
 * @version $Id$
 * @copyright 2007 BaseSoft B.V.
 */
function switchUserStatus(&$broker)
{
	$params = $broker->params;
	// Validate if logged in user is Operator/Sysadmin

	if(!in_array($_SESSION['session_group_group_id'],array(GROUP_SYSADMIN)))
		throw new IWUserException('Permission Denied');

	// Validate that the user_id supplied is a CRSO or Participant

	$sql = "SELECT GROUP_ID FROM TBL_GROUP_USER WHERE USER_ID = ?
		AND GROUP_ID IN(".implode(',',array(GROUP_PARTICIPANT,GROUP_CRSO)).")";
	$q = IWRegistry::registry('db')->query($sql);
	$q->bind_values($params['user_id']);
	$q->execute();
	$rows = $q->fetchAll();
	if(!count($rows))
		throw new IWUserException('Permission Denied');

	// Change status.
	$sql = "UPDATE TBL_USER SET USER_ACTIVE = IF(USER_ACTIVE=1,0,1) WHERE USER_ID = ?";
	$q = IWRegistry::registry('db')->query($sql);
	$q->bind_values($params['user_id']);
	$q->execute();
	return array();
}

?>
