
/**
 * Fixme; example
 */

IWARE.AsyncIncluder = function(aFiles)
{
	this.debug = true;
	this.onInclude = new YAHOO.util.CustomEvent("onInclude", this);

	// if no files have to be included we can fire the event directly
	if (typeof aFiles == 'undefined' || aFiles.count() == 0)
		throw 'AsyncIncluder: Nothing to include, event can never be fired'

	// loop files and load
	aFiles.forEach(function(src, i, a)
	{
		// include file
		this._include(src);
	}, this);

};

IWARE.AsyncIncluder.prototype =
{
	/**
	 * Event fired when all scripts have loaded
	 * @public
	 */
	onInclude: null,

	/**
	 * Counter for loading scripts
	 * @private
	 */
	_includeCounter: 0,

	/**
	 * Stack which defines the include order
	 */
	_jsExecutionStack: [],

	/**
	 * Adds a script to the document body, calls _onScriptLoad when finished loading
	 * @private
	 */
	_include: function(src)
	{
		// adding some random stuff so the file wont get loaded from cache
		// fixme: could be made smarter with ? and &
		src = src + '?rand='+Math.random();

		// add the script to the head
		var head = document.getElementsByTagName('head')[0];

		if (src.match(/\.js/i))
		{
			this.debug && dumpln('AsyncInclude: including javascript: '+src);

			// only scripts can have an onload
			this._includeCounter++;

			// reserve a place in the execution stack so we know the order of execution
			this._jsExecutionStack[src] = '';

			var oReq = AjaxObject.prototype.getXMLHTTP(); // borrow ajax' function
			oReq.onreadystatechange = hitch(this, '_onReadyStateChange', oReq, src);
			oReq.open("POST", src, true);
			oReq.send('');

		}
		else if (src.match(/\.css/i))
		{
			this.debug && dumpln('AsyncInclude: including stylesheet: '+src);

			// CSS Include
			var script = document.createElement('link');
			script.rel = 'stylesheet';
			script.type = 'text/css';
			script.href = src;

			head.appendChild(script);
		}
	},

	_onReadyStateChange: function(oReq, src)
	{
		if (oReq.readyState == 4)
		{
			// we got the source, save it in the execution stack
			this._jsExecutionStack[src] = oReq.responseText;

			// that was one file less to download
			this._includeCounter--;

			// if all the files are downloaded we can execute them in the order of the stack
			if (this._includeCounter == 0)
			{
				this._jsExecutionStack.forEach(function(code, src, a)
				{
					this.debug && dumpln('AsyncIncluder: executing source for '+src);
					//alert('AsyncIncluder: executing source for '+src);
					try {
						eval(code);
					}
					catch(e) {
						MessageBox.prototype.Critical('Error', 'AsyncIncluder::_onReadyStateChange() error with include of of '+src+': \n\n'+ print_r(e));
						throw e
					}

					// remove the code from the stack to free memory
					this._jsExecutionStack[src] = '';

				}, this);

				// after all files are executed fire the event
				this.onInclude.fire(this);
			}
		}
	}

}

