/**
 * ColumnResizer
 * Makes the columns of any htmltable resizeble
 * @see ColumnResizer.prototype.init()
 * @author Chris Wesseling <chris@basesoft.com>
 * @version $Id$
 */
function ColumnResizer(c, l)
{
	this.cell = c;
	this.lever = l;

	this.resize = function (e)
	{
		switch ( e.type )
		{
			case 'mousemove':
				this.cell.width = this.cell.resizerWidth + e.clientX - this.cell.resizerX;
			break;
			case 'mouseup':
				removeEvent(document.body, 'mousemove', this.listener);
				removeEvent(document.body, 'mouseup', this.listener);
			break;
		}
	}
}
/**
 * This is what you're looking for....
 * <code>
 * 		ColumnResizer.prototype.init(document.getElementById('myFirstResizableTable'));
 * 	</code>
 */
ColumnResizer.prototype.init = function(t)
{
	for ( i=0; i < t.tHead.rows[0].cells.length; i++ )
	{
		var cell = t.tHead.rows[0].cells[i];
		var lever = document.createElement('div');
		lever.innerHTML = '&nbsp;';
		//lever.style.backgroundColor = 'red'; //for debugging
		lever.style.height = '100%';
		lever.style.width = '5px';
		lever.style.display = 'inline';
		lever.style.overflow = 'hidden';
		lever.style.cursor = 'e-resize';
		if ( typeof lever.style.cssFloat != 'undefined' )
			lever.style.cssFloat = 'right';
		else
			lever.style.styleFloat = 'right';
		lever.style.position = 'relative';
		lever.style.left = 3;
		cell.insertBefore(lever, cell.firstChild);
		addEvent(lever, 'mousedown', function (e)
					{
						this.parentNode.resizerX = e.clientX;
						this.parentNode.resizerWidth = this.parentNode.offsetWidth;

						var resizer = new ColumnResizer(this.parentNode, this);
						resizer.listener = hitch(resizer, 'resize');
						addEvent(document.body, 'mousemove', resizer.listener);
						addEvent(document.body, 'mouseup', resizer.listener);
					}
				);
	}
}
