/**
 * EventHandler
 * @author Martijn van den Broek <martijn at basesoft dot com>
 * @version $Id$
 */

function EventHandler() {}

EventHandler.prototype = {

	_debug: true,
	_events: new Array(),

	/**
	 * @param string sEvent Event Name
	 * @param function fEvent
	 */
	addEvent: function(sEvent, fEvent)
	{
		if (typeof this._events[sEvent] == 'undefined')
			this._events[sEvent] = new Array();

		this._events[sEvent].push(fEvent);
		this._debug && dumpln('EventHandler::addEvent() - added event for ' + sEvent);
	},

	/**
	 * @param string sEvent Name of the Event
	 * @param array Params
	 */
	triggerEvent: function(sEvent, aParams)
	{
		if (typeof aParams == 'undefined')
			aParams = new Array();

		this._debug && dumpln('EventHandler::triggerEvent() - received trigger for ' + sEvent);

		if (typeof this._events[sEvent] != 'undefined')
		{
			this._debug && dumpln('EventHandler::triggerEvent() - executing event..');

			for (var i=0; i<this._events[sEvent].length; i++)
				this._events[sEvent][i].apply(window, aParams);
		}
	}
}

var eventHandler = new EventHandler();

