/**
 * IWARE.DataPilotSelector
 * fixme: doc
 */
IWARE.DataPilotSelector = function(nNode)
{
	// associative array with containers of fields
	// check below how it is filled
	this._containers = [];

	var table = document.createElement('TABLE');
	table.style.borderCollapse = 'separate';
	table.style.borderSpacing = '10px'
	table.style.width = '96%';
	table.style.margin = '2%'
	nNode.appendChild(table);

	// thead
	var thead = document.createElement('thead');
	table.appendChild(thead);
	var td = document.createElement('td');
	thead.appendChild(td);
	td.colSpan = 3;
	td.innerHTML = 'DataPilot Selector Intro text';

	// tbody
	var tbody = document.createElement('tbody');
	table.appendChild(tbody);

	// Page Fields (filters)
	var trPageFields = document.createElement('TR');
	tbody.appendChild(trPageFields);

	var tdPageFields = document.createElement('TD');
	trPageFields.appendChild(tdPageFields);
	tdPageFields.colSpan = 2;
	tdPageFields.style.height = '50px';
	this._containers['page_fields'] = tdPageFields;

	// Colmns available
	var tdColumnList = document.createElement('TD');
	trPageFields.appendChild(tdColumnList);
	tdColumnList.rowSpan = 3;
	tdColumnList.style.width = '30px';
	this._containers['column_list'] = tdColumnList;

	// Column fields
	var trColumnFields = document.createElement('TR');
	tbody.appendChild(trColumnFields);

	var tdEmpty = document.createElement('TD');
	trColumnFields.appendChild(tdEmpty);

	var tdColumnFields = document.createElement('TD');
	trColumnFields.appendChild(tdColumnFields);
	tdColumnFields.style.height = '30px';
	this._containers['column_fields'] = tdColumnFields;

	// Row & Data TR
	var trRowDataFields = document.createElement('TR');
	tbody.appendChild(trRowDataFields);

	// Row fields
	var tdRowFields = document.createElement('TD');
	trRowDataFields.appendChild(tdRowFields);
	tdRowFields.style.height = '170px'; // height of the pilotchart
	tdRowFields.style.width = '80px';
	this._containers['row_fields'] = tdRowFields;

	// Data fields
	var tdDataFields = document.createElement('TD');
	trRowDataFields.appendChild(tdDataFields);
	this._containers['data_fields'] = tdDataFields;


	// make all the containers a droptarget
	this._containers.forEach(function(nTableCell, sFieldTitle, a)
	{
		this._makeDragTarget(sFieldTitle, nTableCell);
	}, this);
}


IWARE.DataPilotSelector.prototype =
{
	/**
	 * @private
	 * @param {String} sName
	 * @param {Node} nNode
	 */
	_makeDragTarget: function(sName, nNode)
	{
		nNode.className = 'DataPilotSelectorTarget';

		// append a div as a title
		var p = document.createElement('p');
		p.innerHTML = sName;
		p.style.fontWeight = 'bold';
		nNode.appendChild(p);

		// make it an drag n drop target
		nNode.id = YAHOO.util.Dom.generateId();
		new YAHOO.util.DDTarget(nNode.id);
	},

	/**
	 * Trashes and adds fields
	 * @param Array fields
	 */
	setFields: function(fields)
	{
		this.removeFields();

		dumpln('setting fields: '+print_r(fields));

		fields.forEach(function(field, i, a)
		{
			var div = document.createElement('DIV');
			this._containers['column_list'].appendChild(div);
			div.id = YAHOO.util.Dom.generateId();
			div.className = 'DataPilotSelectorField';

			// add a span title
			var span = document.createElement('span');
			span.name = 'fieldtitle';
			span.innerHTML = field;
			div.appendChild(span);

			// add an select for the aggregate function
			var nSelect = document.createElement('select')
			nSelect.style.display = 'none' // we hide it till it comes into a field where we use it
			nSelect.style.marginLeft = '5px'
			nSelect.options.add(new Option('Sum', 0)) // FIXME: defines?
			nSelect.options.add(new Option('Average', 1))
			nSelect.name = 'aggregate'
			div.appendChild(nSelect);

			// store the handle in the div (dont wanna use innthtml), we need that later
			div.DP_FIELD_HANDLE = field

			new YAHOO.util.DDProxy(div);
			var ddfield = new IWARE.DataPilotSelectorDDField(div.id);

			ddfield.myOnDragDrop.subscribe(function(type, args, me)
			{
				var srcEl = args[0];
				var destEl = args[1];

				// check if the destination element is the DataField target
				// then we have to show the select asking the user how to aggregate the data
				nSelect.style.display = (destEl == me._containers['dataFields']) ? '' : 'none'

			}, this);

			/*

			ddfield.onStartDrag.subscribe(function(type, args, me) {
				me._containers.forEach(function(nTableCell, sFieldTitle, a) {
					nTableCell.style.border = '1px solid #00f';
				});
			}, this);

			ddfield.onEndDrag.subscribe(function(type, args, me)
			{
				me._containers.forEach(function(nTableCell, sFieldTitle, a)
				{
					nTableCell.style.border = '1px solid #000';
				});
			}, this);

			*/

		}, this);
	},

	/**
	 * Removes _all_ fields from the PilotChart
	 */
	removeFields: function()
	{
		this._containers.forEach(function(nTableCell, sFieldTitle, a)
		{
			//dumpln(nTableCell.childNodes.length);
			for (var i=nTableCell.childNodes.length-1; i>0; i--)
			{
				var child = nTableCell.childNodes[i];

				if (child.className == 'DataPilotSelectorField')
				{
					// fixme: clean up ddproxy
					removeNode(child);
				}
			}
		}, this);
	},

	/**
	 * Returns the current state of the PilotSelector
	 * @return Array
	 */
	getArray: function()
	{
		var rv = [];

		// loop tru all the containers and get the container name in
		this._containers.forEach(function(nTableCell, sContainerName, a)
		{
			// reserve a place in the list
			if (typeof rv[sContainerName] == 'undefined')
				rv[sContainerName] = [];

			for (var i=0; i<nTableCell.childNodes.length; i++)
			{
				var child = nTableCell.childNodes[i];
				if (child.className == 'DataPilotSelectorField')
				{
					// ignore the fields in columnlist
					if (sContainerName == 'column_list')
						continue;

					// pageFields have to be submitted as an associative array because they contain values per field
					// here we probably return them as empty as before they are send to the server they will be filled.
					if (sContainerName == 'page_fields')
					{
						rv[sContainerName][child.DP_FIELD_HANDLE] = []; // empty for now.. they can be filled by selects later
					}
					else // the other containers are normal arrays
					{
						var field = null;

						// datafields contain a aggregate select
						if (sContainerName == 'data_fields')
						{
							// find the first element called 'aggregate' in this div
							var sel = YAHOO.util.Dom.getElementsBy( function(){ return true }, 'select', child)[0];
							field = []
							field['field'] = child.DP_FIELD_HANDLE;
							field['aggregate'] = sel.value;
						}
						else
							field = child.DP_FIELD_HANDLE;

						rv[sContainerName].push(field);
					}
				}
			}
		});


		dumpln('getArray: '+print_r(rv) );
		return rv;
	}
}


/**
 *
 */
var Dom = YAHOO.util.Dom;
var Event = YAHOO.util.Event;
var DDM = YAHOO.util.DragDropMgr;

IWARE.DataPilotSelectorDDField = function(id, sGroup, config)
{
    IWARE.DataPilotSelectorDDField.superclass.constructor.call(this, id, sGroup, config);

    this.logger = this.logger || YAHOO;
    var el = this.getDragEl();
    Dom.setStyle(el, "opacity", 0.67); // The proxy is slightly transparent

    this.goingUp = false;
    this.lastY = 0;

	this.onStartDrag = new YAHOO.util.CustomEvent("onStartDrag", this);
	this.onEndDrag = new YAHOO.util.CustomEvent("onEndDrag", this);
	this.myOnDragDrop = new YAHOO.util.CustomEvent("myOnDragDrop", this); // renamed event not to interfere with function
};


YAHOO.extend(IWARE.DataPilotSelectorDDField, YAHOO.util.DDProxy, {

    startDrag: function(x, y) {
        this.logger.log(this.id + " startDrag");

		this.onStartDrag.fire();

        // make the proxy look like the source element
        var dragEl = this.getDragEl();
        var clickEl = this.getEl();
        Dom.setStyle(clickEl, "visibility", "hidden");

        //dragEl.innerHTML = clickEl.innerHTML;

        Dom.setStyle(dragEl, "color", Dom.getStyle(clickEl, "color"));
        Dom.setStyle(dragEl, "backgroundColor", Dom.getStyle(clickEl, "backgroundColor"));
        Dom.setStyle(dragEl, "border", "2px solid gray");
    },

    endDrag: function(e) {

        var srcEl = this.getEl();
        var proxy = this.getDragEl();

		this.onEndDrag.fire();

        // Show the proxy element and animate it to the src element's location
        Dom.setStyle(proxy, "visibility", "");
        var a = new YAHOO.util.Motion(
            proxy, {
                points: {
                    to: Dom.getXY(srcEl)
                }
            },
            0.2,
            YAHOO.util.Easing.easeOut
        )
        var proxyid = proxy.id;
        var thisid = this.id;

        // Hide the proxy and show the source element when finished with the animation
        a.onComplete.subscribe(function() {
                Dom.setStyle(proxyid, "visibility", "hidden");
                Dom.setStyle(thisid, "visibility", "");
            });
        a.animate();
    },

    onDragDrop: function(e, id) {

        // If there is one drop interaction, the li was dropped either on the list,
        // or it was dropped on the current location of the source element.
        //if (DDM.interactionInfo.drop.length === 1)
        //{
            // The position of the cursor at the time of the drop (YAHOO.util.Point)
            var pt = DDM.interactionInfo.point;

            // The region occupied by the source element at the time of the drop
            var region = DDM.interactionInfo.sourceRegion;

            // Check to see if we are over the source element's location.  We will
            // append to the bottom of the list once we are sure it was a drop in
            // the negative space (the area of the list without any list items)
            if (!region.intersect(pt)) {
                var destEl = Dom.get(id);
                var destDD = DDM.getDDById(id);

                if (destEl.className == 'DataPilotSelectorTarget')
                {
	                destEl.appendChild(this.getEl());
	                destDD.isEmpty = false;
	                DDM.refreshCache();

					destEl.style.border = '1px solid #000';
					this.myOnDragDrop.fire(this.getEl(), destEl);
				}
            }

        //}
    },

    onDrag: function(e) {

        // Keep track of the direction of the drag for use during onDragOver
        var y = Event.getPageY(e);

        if (y < this.lastY) {
            this.goingUp = true;
        } else if (y > this.lastY) {
            this.goingUp = false;
        }

        this.lastY = y;
    },

    onDragOver: function(e, id) {

        var srcEl = this.getEl();
        var destEl = Dom.get(id);

		// show a blue border for targets when we are over them
		if (destEl.nodeName.toLowerCase() == "div" && destEl.className == "DataPilotSelectorTarget")
			destEl.style.border = '1px solid #00f';

        // We are only concerned with list items, we ignore the dragover
        // notifications for the list.
        if (destEl.nodeName.toLowerCase() == "div" && destEl.className == "DataPilotSelectorField" ) {
            var orig_p = srcEl.parentNode;
            var p = destEl.parentNode;

            if (this.goingUp) {
                p.insertBefore(srcEl, destEl); // insert above
            } else {
                p.insertBefore(srcEl, destEl.nextSibling); // insert below
            }

            DDM.refreshCache();
        }
    },

	onDragOut: function(e, id)
	{
        var srcEl = this.getEl();
        var destEl = Dom.get(id);

		destEl.style.border = '1px solid #000';
	}
});
