/**
 * IWARE.DataPilotWizard
 */
IWARE.DataPilotWizard = function()
{
	IWARE.DataPilotWizard.superclass.constructor.call(this);

	/**
	 * Boolean deciding if fields have to be reloaded:
	 *  - when the wizard is loaded the first time
	 *  - when the select changes
	 */
	this._getNewFields = true;

	/**
	 * Page 0: select datasource
	 */
	var div = document.createElement('DIV');
	div.style.paddingTop = '50px';
	div.style.paddingLeft = '10px';

	// span
	var span = document.createElement('SPAN');
	span.innerHTML = langIf.getText('Select DataSource') + '&nbsp';
	div.appendChild(span);

	// select
	this.selectDataSource = document.createElement('select');
	div.appendChild(this.selectDataSource);
	this.pages.push(div);

	// fill datasources from RPC call
	jsbroker.call('DataPilotHandler.sources', [], function(sources) {
		sources.forEach(function(value, key, a)
		{
			this.selectDataSource.options.add(new Option(value, key));
		}, this);
	}, this);

	// when the select changes value we want to get new datasources next time the pilotselector is shown
	addEvent(this.selectDataSource, 'change', function() {
		this._getNewFields = true;
	}, true);


	/**
	 * Page 1: DataPilot
	 */
	var div = document.createElement('DIV');
	this.pilotSelector = new IWARE.DataPilotSelector(div);
	this.pages.push(div);

	/**
	 * Page 2: Table / Graph
	 */
	var div = document.createElement('DIV');
	div.style.paddingTop = '50px';
	div.style.paddingLeft = '10px';

	var span = document.createElement('span');
	span.innerHTML = 'Select the DisplayType for your DataPilot'
	div.appendChild(span);
	div.appendChild(document.createElement('br'));

	var rd = document.createElement('input');
	rd.type = 'radio';
	rd.name = 'pilot_display_type';
	rd.style.marginLeft = '10px'
	rd.value = 'graph'
	rd.checked = true;
	rd.id = YAHOO.util.Dom.generateId();
	div.appendChild(rd);

	var lbl = document.createElement('label');
	lbl.htmlFor = rd.id;
	lbl.innerHTML = langIf.getText('PilotTable as Graph');
	div.appendChild(lbl);

	div.appendChild(document.createElement('br'));

	var rd = document.createElement('input');
	rd.type = 'radio';
	rd.style.marginLeft = '10px'
	rd.name = 'pilot_display_type';
	rd.value = 'table'
	rd.id = YAHOO.util.Dom.generateId();
	div.appendChild(rd);

	var lbl = document.createElement('label');
	lbl.htmlFor = rd.id;
	lbl.innerHTML = langIf.getText('PilotTable as Table');
	div.appendChild(lbl);

	this.pages.push(div);

	/**
	 * onPageFlip
	 */
	// we want to know when the page changes so we can update the page
	this.onPageFlip.subscribe(function(type, args, me)
	{
		var pageId = args[0]; // first arg is pageId

		switch (pageId)
		{
			case 1: // pilotselector view

				this._getNewFields && jsbroker.call('DataPilotHandler.sourceFields', this.selectDataSource.value, function(fields) {
					this.pilotSelector.setFields(fields);
				}, this);

				this._getNewFields = false;

			break;
		}
	});
}

YAHOO.extend(IWARE.DataPilotWizard, IWARE.WizardDialog, {

	/**
	 * Returns the selection in the form of an array
	 */
	getSelection: function()
	{
		return this.pilotSelector.getArray()
	},

	/**
	 * Returns the source selected by the user
	 */
	getSource: function()
	{
		return this.selectDataSource.value
	}


});
