
/**
 * IWARE.WizardDialog extends YAHOO.widget.Dialog
 * fixme: documentation
 */
IWARE.WizardDialog = function(config)
{
	// wizard container
	var div = document.createElement('FORM');
	document.body.appendChild(div);

	var config =
	{
		width : "500px",
		height : "400px",
		fixedcenter : true,
		visible : false,
		constraintoviewport : true
	};

	// pages
	this.pages = []

	// event fired for every pageflip
	this.onPageFlip = new YAHOO.util.CustomEvent("onPageFlip", this);

	// event fired after finish
	this.onFinish = new YAHOO.util.CustomEvent("onFinish", this);

	IWARE.WizardDialog.superclass.constructor.call(this, div, config);
}

YAHOO.extend(IWARE.WizardDialog, YAHOO.widget.Dialog,
{
	debug: true,

	render: function()
	{
		/**
		 * Header
		 */
		var div = document.createElement('DIV');
		div.innerHTML = 'IWARE Wizard';
		this.appendToHeader(div);

		/**
		 * Buttons
		 */

		var divButtons = document.createElement('div');

		this.btnCancel = new YAHOO.widget.Button({
			type: "button",
			label: langIf.getText('Cancel'),
			container: divButtons
        });

		this.btnPrev = new YAHOO.widget.Button({
			type: "button",
			label: langIf.getText('Previous'),
			container: divButtons
        });

		this.btnNext = new YAHOO.widget.Button({
			type: "button",
			label: langIf.getText('Next'),
			container: divButtons
        });

		this.btnFinish = new YAHOO.widget.Button({
			type: "button",
			label: langIf.getText('Finish'),
			container: divButtons
        });
		this.btnFinish.get('element').style.display = 'none';
		this.btnFinish.addListener('click', hitch(this, 'finish'));


		this.appendToFooter(divButtons);


		/**
		 * Body
		 */
		this.divBody = document.createElement('DIV');
		this.appendToBody(this.divBody);

		// append pages and hide all
		for (var i=0; i<this.pages.count(); i++)
		{
			//console.debug(this.pages[i])
			this.divBody.appendChild(this.pages[i]);
			this.pages[i].style.display = 'none';
		}

		IWARE.WizardDialog.superclass.render.call(this);

		// now make sure the body never gets bigger than the height of the dialog.
		var space = this.header.offsetHeight + this.footer.offsetHeight + 10;
		this.body.style.height = (this.element.offsetHeight - space) + 'px';
		this.body.style.overflow = 'auto';
	},

	show: function()
	{
		this._flipPage(0); // switch from nothing to page 0
		IWARE.WizardDialog.superclass.show.call(this);
	},

	_flipPage: function(pageId)
	{
		this.debug && dumpln('_flipPage to pageId: ' +pageId)

		this.btnNext.removeListener('click');
		this.btnNext.addListener('click', hitch(this, '_flipPage', pageId+1));

		this.btnPrev.removeListener('click');
		this.btnPrev.addListener('click', hitch(this, '_flipPage', pageId-1));

		// show the page we want
		for (var i=0; i<this.pages.count(); i++) {
			this.pages[i].style.display = (i == pageId) ? '' : 'none';
		}

		// hide the Prev button on the firstpage
		this.btnPrev.get('element').style.display = (pageId == 0) ? 'none' : '';

		// hide the Next button on the last page
		this.btnNext.get('element').style.display = (pageId == this.pages.count()-1) ? 'none' : '';

		// show the Finish button only on the last page
		this.btnFinish.get('element').style.display = (pageId == this.pages.count()-1) ? '' : 'none';


		// fire event
		this.onPageFlip.fire(pageId);
	},

	/**
	 * Called when the user presses the finish button
	 * @protected
	 */
	finish: function()
	{
		this.onFinish.fire()
		this.hide()
	}
});
