
if(typeof BASESOFT == 'undefined') {
	BASESOFT = {};
}

BASESOFT.RemoteViewer = {};

(function(){
	/**
	 *
	 */
	BASESOFT.RemoteViewer.Observer = function(path) {
		path = path ? path : '/';
		jsbroker.addPhpBroker(path+'scripts/i-w/bots/PhpBroker.php');
	};

	BASESOFT.RemoteViewer.Observer.prototype = {
		// Interval for polling in milliseconds.
		POLLING_INTERVAL: 12000,

		id: null,
		window: null,
		timeoutId: false,

		/**
		 * Start viewing with the provided ID.
		 */
		startViewing: function(id) {
			this.id = id;
			this.loadData();
		},
		/**
		 * Loads the data from the server with an RPC call, on successful retrieval
		 * set a timeout to load the next "screenshot"
		 */
		loadData: function() {

			if(this.timeoutId) {
				clearTimeout(this.timeoutId);
			}

			jsbroker.call('RemoteViewerHandler.loadData', this.id, function(result) {
				if(typeof result != 'undefined' && result) {
					document.body.innerHTML = result;
				} else {
					document.body.innerHTML = '<div style="padding: 100px auto; width:100%; text-align:center;">Waiting for participant action...<br /><img src="/images/i-w/rel_interstitial_loading.gif" alt="loading" /></div>';
				}

				// Add a curtain for clicky catching.
				var curtain = document.body.appendChild( document.createElement('div') );
				curtain.id = "curtain";
				document.body.onkeypress = curtain.onkeypress = curtain.onclick = function(){ alert('View only'); return false; };
				document.body.onscroll = function() {

					var el = document.getElementById('curtain');
					var ScrollTop = document.body.scrollTop;
					if (ScrollTop == 0)
					{
						if (window.pageYOffset)
							ScrollTop = window.pageYOffset;
						else
							ScrollTop = (document.body.parentElement) ? document.body.parentElement.scrollTop : 0;
					}
					el.style.top = ScrollTop + "px";

				};

				this.timeoutId = setTimeout((function(scope){
					return (function(){
						scope.loadData();
					});
				})(this), this.POLLING_INTERVAL);

			}, this);

		}

	};
	/**
	 * For the participant, to capture the documents body innerHTML and send it to the server.
	 */
	BASESOFT.RemoteViewer.Client = function(path) {
		path = path ? path : '/';
		jsbroker.addPhpBroker(path+'scripts/i-w/bots/PhpBroker.php');
	};

	BASESOFT.RemoteViewer.Client.prototype = {

		SAVE_INTERVAL: 12000,
		timeoutId: false,

		saveData: function() {

			if(this.timeoutId) {
				clearTimeout(this.timeoutId);
			}

			var form, inputs, input, j;
			var forms = document.getElementsByTagName('form');
			for(var i = 0; i < forms.length; i++) {

				form = forms[i];
				inputs = form.getElementsByTagName('input');
				for(j = 0; j < inputs.length; j++) {

					input = inputs[j];
					input.setAttribute('value', input.value);
				}
				inputs = form.getElementsByTagName('select');
				for(j = 0; j < inputs.length; j++) {

					input = inputs[j];
					if(input.selectedIndex >= 0 )
						input.options[input.selectedIndex].setAttribute('selected', 'selected');
				}
			}


			jsbroker.call('RemoteViewerHandler.saveData', document.body.innerHTML, function(result) {

				this.timeoutId = setTimeout((function(scope){
					return (function(){
						scope.saveData();
					});
				})(this), this.SAVE_INTERVAL);

			}, this, false);

		}
	};

})();
