/**
 * This is a AJAX Object
 * @copyright Copyright 2005, BaseSoft b.v.
 * @package I-Ware
 * @subpackage Includes
 * @since 22 july 2005
 * @version $Id$
 */
/**
 * Contructor
 * @param string queryString
 */
function AjaxObject(queryString)
{
	this.setQueryString(queryString);
	this.postBody = null;
}
/**
 * Get a new instance of the XmlHttp object
 */
AjaxObject.prototype.getXMLHTTP = function()
{
	var rv = null;
	try	{
		rv = new ActiveXObject("Msxml2.XMLHTTP");
	} catch(e) {
		try	{
			rv = new ActiveXObject("Microsoft.XMLHTTP");
		} catch(oc)	{
			rv = null;
		}
	}
	// NOT IE and one of the following: Opera 7.6 or higher, Mozilla FireFox, Apple Safari
  	if(!rv && typeof XMLHttpRequest != "undefined")
		rv = new XMLHttpRequest();
	return rv;
}
/**
 * Set or overwrite the querystring
 * @param string queryString
 */
AjaxObject.prototype.setQueryString = function(queryString)
{
	this.queryString = queryString;
}
/**
 * @param mixed params
 * @param Array formValues (optional)
 */
AjaxObject.prototype.callPage = function(params, formValues, doserialize)
{
	doserialize = (typeof doserialize != 'undefined') ? doserialize : true;
	var _xmlHttp = null;
	if ( params ) // Create URLencoded post string
	{
		var data = 'params=';
		data += doserialize ? serialize(params).URLEncode() : params;
		if(!doserialize) {
			data += '&donotunserialize=true';
		}

		if (typeof script_id != 'undefined')
			data += '&script_id='+script_id.URLEncode();
		if (typeof script_parent_id != 'undefined')
			data += '&script_parent_id='+script_parent_id.URLEncode();
		if (typeof lang_script_name != 'undefined')
			data += '&lang_script_name='+lang_script_name.URLEncode();

		this.postBody = data;
	}
	if(formValues instanceof Array)
	{
		formValues.forEach(function(element, index, array)
		{
			this.postBody = this.postBody + "&" + element[0] + "=" + String(element[1]).URLEncode();
		}, this);
	}
	if(_xmlHttp && _xmlHttp.readyState!=0 ) // The event is still open, abort it
		_xmlHttp.abort();

	method = 'POST';
	// Create new instance of xmlhttp object
	if(_xmlHttp=this.getXMLHTTP())
	{
		// Open the querystring
		_xmlHttp.open(method, this.queryString, true);

		// Make callback function
		_xmlHttp.onreadystatechange = function()
		{
			if(_xmlHttp.readyState == 4 && _xmlHttp.responseText ) //-- 4 means loaded
			{
				//-- eval works different in IE and mozilla, so we need a check
				if (typeof Browser != 'undefined' && Browser.isMSIE)
					eval( _xmlHttp.responseText );
				else
				{
					var val = eval( _xmlHttp.responseText );
					if( val != '__RPC_SUCCESS__' )
						throw 'Syntax Error';
				}
			}
      	};
		// Set the content type
		_xmlHttp.setRequestHeader(
            'Content-Type',
            'application/x-www-form-urlencoded; charset=UTF-8'
        );

		// Add the length of the postbody
		/*
		_xmlHttp.setRequestHeader(
            'Content-Length',
            this.postBody.length
        );
        */
		// Send the postBody
		_xmlHttp.send( this.postBody );
	}
}