
/**********************************
 *  Global javascript functions   *
 **********************************

/**
 * This adds a method to the array object.
 * It checks if a value exists in the array, returns true if found, false if not.
 */
/*
Array.prototype.inArray = function (value)
{
	var i;
	for (i=0; i < this.length; i++) {
		if (this[i] === value) {
			return true;
		}
	}
	return false;
};*/


/**
 * Sets a Cookie with the given name and value.
 *
 * name       Name of the cookie
 * value      Value of the cookie
 * [expires]  Expiration date of the cookie (default: end of current session)
 * [path]     Path where the cookie is valid (default: path of calling document)
 * [domain]   Domain where the cookie is valid
 *              (default: domain of calling document)
 * [secure]   Boolean value indicating if the cookie transmission requires a
 *              secure transmission
 */
function setCookie(name, value, expires, path, domain, secure)
{
    document.cookie = name + "=" + escape(value) +
        ((expires) ? "; expires=" + expires.toGMTString() : "") +
        ((path) ? "; path=" + path : "") +
        ((domain) ? "; domain=" + domain : "") +
        ((secure) ? "; secure" : "");
}

/**
 * Gets the value of the specified cookie.
 *
 * name  Name of the desired cookie.
 *
 * Returns a string containing value of specified cookie,
 *   or null if cookie does not exist.
 */
function getCookie(name)
{
    var dc = document.cookie;
    var prefix = name + "=";
    var begin = dc.indexOf("; " + prefix);
    if (begin == -1)
    {
        begin = dc.indexOf(prefix);
        if (begin != 0) return null;
    }
    else
    {
        begin += 2;
    }
    var end = document.cookie.indexOf(";", begin);
    if (end == -1)
    {
        end = dc.length;
    }
    return unescape(dc.substring(begin + prefix.length, end));
}

/**
 * Deletes the specified cookie.
 *
 * name      name of the cookie
 * [path]    path of the cookie (must be same as path used to create cookie)
 * [domain]  domain of the cookie (must be same as domain used to create cookie)
 */
function deleteCookie(name, path, domain)
{
    if (getCookie(name))
    {
        document.cookie = name + "=" +
            ((path) ? "; path=" + path : "") +
            ((domain) ? "; domain=" + domain : "") +
            "; expires=Thu, 01-Jan-70 00:00:01 GMT";
    }
}

/**
 * The include_once() statement includes and evaluates the specified file during the execution of the script.
 */
function include_once( src )
{
    if (src.substr(0, 7) != 'http://')
    	src = 'http://' + document.domain + src;

    var found = false;
    var head = document.getElementsByTagName('head').item(0);
    for (var i in head.childNodes)
    {
    	var node = head.childNodes[i];
    	if (node.tagName == 'SCRIPT' )
    	{
		    if (node.src == src)
		    	found = true;
    	}
    }

	if (!found)
	{
	    script = document.createElement('script');
	    script.src = src;
	    script.defer = true; // Inline executable function is deferred.
	    void(head.appendChild(script));
	}
	//else
		//alert( 'include_once() - Already included: ' + src );

    return true;
}

function reloadTree(languageId)
{
	if( typeof( parent.frames.code ) != 'undefined' && typeof( parent.frames.code.refreshTree ) != 'undefined' )
		parent.frames.code.refreshTree('',languageId);
}

