/**
 * default.js
 * @version $Id$
 * @package Form
*/

function implode(args){
	var line = '';
	for (var i = 0; i < args.length; i++) {
		line += args[i] + ', ';
	}
	return line;
}

// It seems IE8 with developer tools also has a console.. but its not totally compatible with firebugs
// temporary move it to env and we'll use it in the fallback console to just write strings to.
if (window.console && YAHOO.util.Event.isIE) {
	var ie_console = window.console;
	window.console = {
		debug: function(){
			ie_console.log(implode(arguments));
		},
		info: function(){
			ie_console.info(implode(arguments));
		},
		error: function(){
			ie_console.error(implode(arguments));
		},
		warn: function(){
			ie_console.warn(implode(arguments));
		},
		timeEnd: function(){
		},
		time: function(){
		},
		trace: function() {},
		assert: function() {}
	};
}

// Fallback console
if (typeof window.console == 'undefined') {

	var println = function()  {
		// enable this to write to yui console
		//YAHOO.log(line, 'console');
	};

	window.console =  {
		debug: println,
		info: println,
		error: println,
		warn: println,
		time: function() {},
		timeEnd: function() {},
		trace: function() {},
		assert: function() {}
	};
}


/**
 * Constants
 * maybe move this to const.php
 */
var UNDEFINED;

// messages
var E_ERROR   = 1;
var E_WARNING = 2;
var E_PARSE   = 4;
var E_NOTICE  = 8;

// applications
var IWARE_ID      = 1000;
var INTERCLEAN_ID = 30;

// yahoo namespacing
YAHOO.namespace("WEEE");
WEEE = YAHOO.WEEE;
YAHOO.namespace("IWARE");
IWARE = YAHOO.IWARE;


/**
 * Browser
 * To get info about the current browser
 * example:
 * <code>var x = (Browser.isMSIE) ? 'blegh' : 'wee'; </code>
 */
function _Browser()
{
	this.isMSIE = (navigator.appName == "Microsoft Internet Explorer");
	this.isMSIE7 = this.isMSIE && (navigator.userAgent.indexOf('MSIE 7') != -1);
	this.isMSIE6 = this.isMSIE && (navigator.userAgent.indexOf('MSIE 6') != -1);
	this.isMSIE5 = this.isMSIE && (navigator.userAgent.indexOf('MSIE 5') != -1);
	this.isMSIE5_0 = this.isMSIE && (navigator.userAgent.indexOf('MSIE 5.0') != -1);
	this.isGecko = navigator.userAgent.indexOf('Gecko') != -1;
	this.isSafari = navigator.userAgent.indexOf('Safari') != -1;
	this.isMac = navigator.userAgent.indexOf('Mac') != -1;
} var Browser = new _Browser();


/**
 * Sets a Cookie with the given name and value.
 *
 * name       Name of the cookie
 * value      Value of the cookie
 * [expires]  Expiration date of the cookie (default: end of current session)
 * [path]     Path where the cookie is valid (default: path of calling document)
 * [domain]   Domain where the cookie is valid
 *              (default: domain of calling document)
 * [secure]   Boolean value indicating if the cookie transmission requires a
 *              secure transmission
 */
function setCookie(name, value, expires, path, domain, secure)
{
    document.cookie = name + "=" + escape(value) +
        ((expires) ? "; expires=" + expires.toGMTString() : "") +
        ((path) ? "; path=" + path : "; path=/") +
        ((domain) ? "; domain=" + domain : "") +
        ((secure) ? "; secure" : "");
}

/**
 * Gets the value of the specified cookie.
 *
 * name  Name of the desired cookie.
 *
 * Returns a string containing value of specified cookie,
 *   or null if cookie does not exist.
 */
function getCookie(name)
{
    var dc = document.cookie;
    var prefix = name + "=";
    var begin = dc.indexOf("; " + prefix);
    if (begin == -1)
    {
        begin = dc.indexOf(prefix);
        if (begin != 0) return null;
    }
    else
        begin += 2;

    var end = document.cookie.indexOf(";", begin);
    if (end == -1)
        end = dc.length;

    var value = unescape(dc.substring(begin + prefix.length, end));

    if (parseInt(value, 10) == value)
    	value = parseInt(value, 10);

    return value;
}

/**
 * Deletes the specified cookie.
 *
 * name      name of the cookie
 * [path]    path of the cookie (must be same as path used to create cookie)
 * [domain]  domain of the cookie (must be same as domain used to create cookie)
 */
function deleteCookie(name, path, domain)
{
    if (getCookie(name))
    {
        document.cookie = name + "=" +
            ((path) ? "; path=" + path : "") +
            ((domain) ? "; domain=" + domain : "") +
            "; expires=Thu, 01-Jan-70 00:00:01 GMT";
    }
}

/**
 * The include_once() statement includes and evaluates the specified file during the execution of the script.
 * FIXME: support for https
 */
function include_once( src )
{
    if (src.substr(0, 7) != 'http://')
    	src = 'http://' + document.domain + src;

    var found = false;
    var head = document.getElementsByTagName('head').item(0);
    for (var i in head.childNodes)
    {
    	var node = head.childNodes[i];
    	if (node.tagName == 'SCRIPT' )
    	{
		    if (node.src == src)
		    	found = true;
    	}
    }

	if (!found)
	{
	    script = document.createElement('script');
	    script.src = src;
	    script.defer = true; // Inline executable function is deferred.
	    void(head.appendChild(script));
	}
	//else
		//alert( 'include_once() - Already included: ' + src );

    return true;
}

/******************
 * FORM FUNCTIONS
 */

/**
 * Sets selected options in a <select> by value
 * @param mixed string | element elSelect (get with document.getElementById or getElementByName[0])
 * @param mixed array | string value(s) to select
 */
function Select_setSelectedValue( elSelect, strValue )
{
	//dumpln('setting '+elSelect+' to value ' +strValue);
	if (typeof elSelect == 'string')
	{
		var name = elSelect;
		elSelect = document.getElementById(name);
		if ( ! elSelect )
			elSelect = document.getElementsByName(name)[0];
	}

	SelectController.prototype.getController(elSelect).setSelectedByValue(strValue);
}

/**
 * Selectes all options in a select
 * @param string | element elSelect (get with document.getElementById or getElementByName[0])
 * @param bool selected
 */
function Select_selectAll(elSelect, selected, asc)
{
	asc = asc ? asc : false;

	if (typeof selected == 'undefined')
		selected = true;

	if (typeof elSelect == 'string')
	{
		elSelect = document.getElementById(elSelect);
		if ( ! elSelect )
			elSelect = document.getElementsByName(elSelect)[0];
	}

	if (!elSelect || elSelect.tagName != 'SELECT')
		alert('Select_selectAll() - Not a valid <select>: ' + elSelect);

	if (asc)
	{
		for (var i=elSelect.options.length-1; i>=0; i--)
		{
			var option = elSelect.options[i];
			option.selected = selected;
		}
	}
	else
	{
		for (var i=0; i<elSelect.options.length; i++)
		{
			var option = elSelect.options[i];
			option.selected = selected;
		}
	}
}

/**
 * Clears a <select> from all options
 * @param string | element elSelect (get with document.getElementById)
 */
function Select_ClearOptions(sel,offset)
{
	offset = offset?offset:0;
	if (!sel || sel.tagName != 'SELECT')
		alert('Select_selectAll() - Not a valid <select>: ' + elSelect);

	for (var i=sel.options.length-1; i>=offset; i--)
		sel.remove(i);
}

/**
 *
 */
function Select_CopyOptions(sel1,sel2)
{
	for(var i = 0; i < sel1.options.length; i++)
		sel2.options.add(new Option(sel1.options[i].innerHTML, sel1.options[i].value) );
}

/**
 * Sets the selected value for a radiobutton group
 * @param string name of the radio
 * @param string value to search for
 */
function Radio_setSelectedValue( strName, strValue )
{
	var els = document.getElementsByName(strName);

	for (var i=0; i <els.length; i++)
	{
		var el = els[i];

		if (el.tagName == 'INPUT' && el.type == 'radio')
			el.checked = (el.value == strValue);
	}
}

/**
 * Sets the selected value for a radiobutton group
 * @param string name of the radio
 * @return string selected value
 */
function Radio_getSelectedValue( strName )
{
	els = document.getElementsByName(strName);

	for (var i=0; i <els.length; i++)
	{
		var el = els[i];

		if (el.tagName == 'INPUT' && el.type == 'radio' && el.checked)
			return el.value;
	}

	return false;
}

function Radio_getNodesByName(sName, doc)
{
	if (typeof doc == 'undefined')
		doc = document;

	var rv = new Array();

	var rds = doc.getElementsByTagName('input');
	for (var i=0; i<rds.length; i++)
	{
		if (rds[i].type == 'radio' && rds[i].name == sName )
			rv.push(rds[i]);
	}

	return rv;
}

/**
 *
 */
function nl2br( str )
{
	return str.replace( /\n/, "<br />"  );
}
/**
 * A more functional typeof
 * @param Object o
 * @return String
 */
function getObjectType(o)
{
	var rv = typeof o;
	try
	{
		switch ( rv )
		{
			case 'string':
			case 'boolean':
			case 'number':
				rv = rv.substr(0,1).toUpperCase()+rv.substr(1); //ucFirst builtins
			break;
			case 'object':
			case 'function':
				switch ( o.constructor )
				{
					case String:
						rv = 'String';
					break;
					case Boolean:
						rv = 'Boolean';
					break;
					case Number:
						rv = 'Number';
					break;
					case Array:
						rv = 'Array';
					break;
					case RegExp:
						rv = 'RegExp';
					break;
					case Function:
						rv = 'Function';
					break;
					default:
						var m = o.constructor.toString().match(/function\s*([^( ]+)\(/);
						if ( m )
							rv = m[1];
						else
							rv = rv.substr(0,1).toUpperCase()+rv.substr(1); //ucFirst
					break;
				}
			break;
		}
	}
	finally
	{
		return rv;
	}
}

/**
 * Generates a storable representation of a value
 * @param mixed param
 * @todo float support
 */
function serialize(param)
{
	ArrayP.set('rv','');
	result = '';
	if(param instanceof Array) // Array serialisation
	{
		// a:number-of-members:{members}
		ArrayP.set('rv','a:'+param.sizeof()+':{' );
		param.forEach(
			function(element,index,array)
			{
				result = ArrayP.get('rv');
				// Serialize the index and the element
				result += serialize(index)+serialize(element);
				ArrayP.set('rv',result);
			}
		);
		result = ArrayP.get('rv')+'}';
	}
	else if(typeof param == 'boolean')
	{
		result += 'b:'+(param?1:0)+';';
	}
	else if(param == parseInt(param))
		result += 'i:'+param+';';
	else if((param instanceof String) ||( typeof param == 'string')) // String serialisation s:string-length:"string";
		result += 's:'+param.length+':"'+param+'";';
	else if(typeof param == 'number')
		result += 'd:'+param+';'; // i:number;
	else if(typeof param == 'object') // Object serialisation
	{
		name = getObjectType(param); // Get the name of the object type
		// O:object-type-name-length:"object-type-name":{members}
		var curr = 'O:'+name.length+':"'+name+'":';
		var tmp = '';
		var cnt = 0;
		for(i in param)
		{
			if(typeof eval('param.'+i)!= 'function')
			{
				// Serialize the index and the param.index
				tmp += serialize(i)+serialize(eval('param.'+i));
				cnt++;
			}
		}
		result = curr+cnt+':{'+tmp+"}";
	}
	else if(param == null )
		result += 'N;';
	else if(isNaN(param)) // String serialisation s:string-length:"string";
		result += 's:'+param.length+':"'+param+'";';
	else
		result += 'N;';
	return result;
}
/**
 * @param string param
 * @todo Object unserialize check for unknown classes
 * WARNING! Workaround for slowlyness: Put your big vars first in the
 * array or object to get them serialized asap.
 */
function unserialize(param)
{
	if ( typeof param == 'string' || param instanceof String ) //create an object, that gets passed by reference.
		var param = {str:param, //String to be unserialized
			ptr:0}; //String position where we are.

	var rv = null;
	while(chr = param.str.substr(param.ptr,1)) //chr = char@param.ptr
	{
		//cycle characters and advance ptr to ending ; or }
		switch(chr)
		{
			case 'O': // Object unserialize
//				O:8:"JsBroker":4:{s:8:"nextCall";i:0;s:5:"calls";a:0:{}s:4:"ajax";O:10:"AjaxObject":1:{s:11:"queryString";s:42:"/interclean/scripts/i-w/bots/PhpBroker.php";}}
				// Get the classname
				// Get the name length "O:--length--:"
				var size = new String();
				var colonCnt = 0;
				while(cnt = param.str.substr(++param.ptr, 1))
				{
					if(cnt==':')
					{
						colonCnt++;
						continue;
					}
					else if(colonCnt==1)//grow (string) size
						size += cnt;
					else //counted 2
						break;
				}
				//Got the classname
				param.ptr++; //skip "
				size = parseInt(size, 10); //convert length to base10 integer
				eval('rv = new '+param.str.substr(param.ptr,size)+'();');

				param.ptr+=size;//skip size

				// Extract the number of properties. "O:--classname.size--:classname:numproperty:{props...}"
				//                                                                  ^
				size = new String(); //num atributes
				colonCnt = 0;
				while(cnt = param.str.substr(++param.ptr,1))
				{
					if(cnt==':')
					{
						colonCnt++;
						continue;
					}
					else if(colonCnt==1)
						size += cnt;
					else
						break;
				}
				size = parseInt(size,10);
				// Get the content and unserialize individual members
				// "O:--classname.size--:classname:numproperty:{props...}"
				//                                             ^
				param.ptr++;
				while(size--)
				{
					var key = unserialize(param); //Attribute name
					param.ptr++;
					var value = unserialize(param); //Attribute value
					param.ptr++;
					eval('rv.'+key+' = value;');
				}
				return rv;
			break;
			case 'a': // Array unserialize
				// Extract the size of the array. "a:--size--:"
				var size = new String();
				var colonCnt = 0;
				while(cnt = param.str.substr(++param.ptr, 1))
				{
					if(cnt==':')
					{
						colonCnt++;
						continue;
					}
					else if(colonCnt==1)//grow (string) size
						size += cnt;
					else //counted 2
						break;
				}
				param.ptr++;
				size = parseInt(size, 10); //convert length to base10 integer
				var rv = new Array();

				if(size==0)
					return rv;
				// Get the content and unserialize individual members
				while(size--)
				{
					var key = unserialize(param);
					param.ptr++;
					var value = unserialize(param);
					param.ptr++;
					rv[key]=value;
				}
				return rv; // Return the array
			break;
			case 'b': //bool
				// "b:1;"
				param.ptr+=2;
				rv = (param.str.substr(param.ptr,1)==1);
				param.ptr++;
				// "b:1;"
				//     ^
				return rv;
			break;
			case 'i': // Int unserialize
				// "i:12344567;"
				param.ptr+=2;
				//get the first integer base 10
				rv = parseInt(param.str.substr(param.ptr),10);
				param.ptr += rv.toString().length;
				// "i:12345678;"
				//            ^
				return rv;
			break;
			case 'd': // Double/float unserialize
				param.ptr+=2;
				//get the first Float
				rv = parseFloat(param.str.substr(param.ptr));
				//set ptr after Float at the ;
				while ( (param.ptr < param.str.length) && param.str.substr(param.ptr,1) != ';' )
					param.ptr++;
				return rv;
			break;
			case 's': // String unserialize
				var size = new String();
				var colonCnt = 0;
				while(cnt = param.str.substr(++param.ptr, 1))
				{
					if(cnt==':')
					{
						colonCnt++;
						continue;
					}
					else if(colonCnt==1)//grow (string) size
						size += cnt;
					else //counted 2
						break;
				}
				param.ptr++;
				size = parseInt(size, 10); //convert length to base10 integer
				// Return the string
				rv = param.str.substr(param.ptr, size);
				param.ptr+=size+1;
				return rv;
			break;
			case 'N':
				param.ptr++;
				return null;
			break;
			case ';':
			case '}':
				param.ptr++;
			break;
			default:
				throw '<pre>serialize() - Unexpected character - ' + param.str+'\n'+'-'.repeat(param.ptr)+'^</pre>';
				param.ptr++; //prevent endless loop
			break;
		}
	}
	return rv;
}
/**
 * Print Recursive
 * @param mixed param
 * @param string lvl Current Indent Level
 * @return string result;
 */
function print_r(param,lvl)
{
	lvl = isset(lvl)?lvl:'';
	ArrayP.set('rv','');

	result = '';
	var current = lvl;
	if(param instanceof Array) // Recursive printing of Arrays
	{
		ArrayP.set('rv','Array ('+"\n");
		ArrayP.set('lvl',lvl+"\t");
		param.forEach(
			function (element,index,array)
			{
				result = ArrayP.get('rv');
				lvl = ArrayP.get('lvl');
				result += lvl+'['+index+'] => '+print_r(element,lvl)+"\n";
				ArrayP.set('rv',result);
			}
			);
		ArrayP.set('lvl',current);
		result = ArrayP.get('rv')+current+')'+"\n";
	}
	else if(param instanceof String)
		result += '('+typeof(param)+') '+param.toString().replace( /\n/gi, "\n"+lvl ) // Other types
	else if(param == null) // Recursive printing of Objects
	{
		result += '(null)';
	}
	else if(typeof param == 'object') // Recursive printing of Objects
	{
		result = "Object (\n";
		ArrayP.set('lvl',lvl+"\t");
		for(i in param)
			result += lvl+"\t"+'['+i+'] => '+print_r(eval('param.'+i+';'),lvl+"\t")+"\n";
		ArrayP.set('lvl',current);
		result += current+")";
	}
	else if(typeof param == 'undefined') // Undefined variable
		result += 'Undefined Variable';
	else
		result += '('+typeof(param)+') '+param.toString().replace( /\n/gi, "\n"+lvl ) // Other types
	return result;
}
/**
 * Checks wether or not a param isset or not
 * @param mixed param
 * @return bool
 */
function isset(param)
{
	return (typeof param != 'undefined')
}
/**
 * @param mixed param
 */
function eat(param)
{
	return delete param;
}
/**
 * @param mixed param
 */
function unset(param)
{
	return delete param;
}
/**
 * @param mixed param
 */
function empty(param)
{

}
/**
 * @param string param
 */
function echo(param)
{
	document.write(param);
}


/**
 * Adapts an IE to the w3 DOM Event interface.
 * KeyEvents (for which there is no w3 interface yet) are
 * adapted to the Mozilla interface, which is the most useful. (see addEvent)
 */
/*
function IEEventAdaptor(e)
{
	this.e = e;

	this.target = this.e.srcElement;
	this.type = e.type;
	this.altKey = e.altKey;
	this.ctrlKey = e.ctrlKey;
	this.shiftKey = e.shiftKey;
	this.metaKey = e.metaKey;
	this.keyCode = e.keyCode;
	this.charCode = (e.type == 'keypress'?e.keyCode:0);
}
IEEventAdaptor.prototype =
{
	preventDefault: function()
	{
		this.e.returnValue = false;
	},
	stopPropagation: function()
	{
		this.e.cancelBubble = true;
	}
}
var __attachedFns = [];
function __createDecoupledFn(idx)
{
	return function(evt) {
		var obj = __attachedFns[idx].obj;
		obj.___fn = __attachedFns[idx].fn;
		switch ( evt.type )
		{
			case 'keydown':
				if ( evt.keyCode != 8 && //backspace
					evt.keyCode != 9 && //tab
					evt.keyCode != 13 && //enter
					(!( evt.keyCode >= 112 && evt.keyCode <= 123 )) && //Fn
					(!( evt.keyCode >= 37 && evt.keyCode <= 40 )) && //Arrow
					evt.keyCode != 91 && //windows
					evt.keyCode != 93 //menu
				)
					break; //catch printable on press
			case 'keypress':
				var result = obj.___fn( new IEEventAdaptor(evt) );
			break;
			default:
				var result = obj.___fn( evt );
		}
		obj.___fn = null;
		return result;
	}
}
*/

/**
 * Adds an event to an object
 * @param object
 * @param name event
 * @param handler callback
 *
 * example: <code>AddEvent(window, "load", myOnLoad );</code>
 * or: <code>addEvent(myButton, "click", function() { alert('hello'); } ); </code>
 */
/*
function addEvent(obj, type, fn)
{
	if (obj.addEventListener)
		obj.addEventListener(type, fn, false);
	else if ( obj.attachEvent )
	{
		var idx = __attachedFns.count?__attachedFns.count():__attachedFns.length;
		__attachedFns[idx] = { obj:obj, type:type, fn:fn };
		var dfn = __attachedFns[idx].dfn = __createDecoupledFn(idx);
		obj.attachEvent("on" + type, dfn);
		if ( type == 'keypress' )
			obj.attachEvent( 'onkeydown', dfn );
	}
}
*/

// lets use yahoo event listener instead
function addEvent(obj, type, fn)
{
	YAHOO.util.Event.addListener(obj, type, fn);
}

/**
 * @depricated use addEvent()
 */
AddEvent = addEvent;

/**
 * Same as above, but removes an event
 * @param object
 * @param name event
 * @param handler callback
 */
/*
function removeEvent(obj, type, fn)
{
	if (obj.removeEventListener)
		obj.removeEventListener(type, fn, false);
	else if ( obj.detachEvent )
	{
		for (var i=0; i<(__attachedFns.count?__attachedFns.count():__attachedFns.length); i++)
		{
			var data = __attachedFns[i];
			if (data.obj == obj && data.type == type && data.fn == fn)
			{
				obj.detachEvent("on" + data.type, data.dfn);
				data.obj = null;
			}
		}
	}
}
*/

function removeEvent(obj, type, fn)
{
	YAHOO.util.Event.removeListener(obj, type, fn);
}

/**
 * @depricated use removeEvent()
 */
RemoveEvent = removeEvent;


/**
 * IE Hover Fix
 */
function fixIEPseudoClass(el, pseudoClass)
{
	if (Browser.isMSIE)
	{
		addEvent(el, 'mouseover', function()
		{
			this.className+=" ie_hover";
		});

		addEvent(el, 'mouseout', function()
		{
			this.className=this.className.replace(new RegExp(" ie_hover\\b"), "");
		});
	}
}



/**
 * Displays the 'exceptionText' element.
 * @param string e 'Exception text' (optional)
 */
function showException(eTxt)
{
	e=e?e:'';
	if (MessageBox)
		MessageBox.prototype.Critical('Exception', eTxt);
	else
		alert('Exception: ' + eTxt);
}

/**
 * Removes a node and all its childs
 * @param node
 */
function removeNode(node)
{
	if (!node.parentNode)
		return;

	node.parentNode.removeChild(node);
}

/**
 * Removes all childs from a node
 * @param node
 */
function removeChildNodes(node)
{
	while ( node.hasChildNodes() )
		node.removeChild(node.firstChild)
}

/**
 * This function makes it possible to hitch a callback to an object witout making an instance.
 * The 'this' in that callback will be the object this.
 * Example: <code>jsbroker.call( 'Wizard_LoadPage', params, hitch(this, '_updatePage')  );</code>
 * @param object
 * @param string method
 */
function hitch(obj, meth)
{
	if (!obj[meth])
		throw new Error("hitch() - Method '" + meth + "' does not exist on object '" + obj + "'");

	if (arguments.length > 2)
	{
		var hitchArgs = new Array();
		for (var i = 2; i < arguments.length; i++)
			hitchArgs.push( arguments[i] );

		return function() { return obj[meth].apply(obj, hitchArgs); };
	}
	else
		return function() { return obj[meth].apply(obj, arguments); };
}

/**
 * Prints a variable to the debug window
 */
if ( typeof debug == 'undefined' )
function debug(msg) //only define if not already defined (like in JSUnit...)
{
	if ( typeof jsbroker != 'undefined' )
		jsbroker.handleError('debug', {responseText:msg} );
	else
	{
		if ( confirm(print_r(msg)) )
			return ;
		while(true);//create endless loop, so firefox will ask you to end it.
	}
}


/**
 * @param newElement The node being inserted.
 * @param targetElement The node after which newElement is inserted
 */
function insertAfter(newElement, targetElement)
{
	if (targetElement.nodeType != 1)
		throw "insertAfter() - targetElement is not an element node";

	var parentNode = targetElement.parentNode;
	if (!parentNode)
		throw "insertAfter() - targetElement does not have a parent";

	if (parentNode.lastChild == targetElement)
		return parentNode.appendChild(newElement);
	else
	{
		var parentNode = targetElement.nextSibling.parentNode;
		var sibling = targetElement.nextSibling;
		return parentNode.insertBefore( newElement, sibling );
	}
}

/**
 * Dump functions
 */
function dump(str)
{
	if(typeof console != 'undefined')
		console.debug(str);
}


function dumpln(str)
{
	dump(str + "\n");
}

function cleardump()
{
	for (var i=0; i<50; i++)
		dump("\n");
}


/**
 * Short function for document.location.href
 */
function go(dest, doc)
{
	if (typeof doc == 'undefined')
		doc = window.document;

	doc.location.href = dest;
}

/**
 * Adds a CSS Class from a node
 */
function addCssClass(nNode, sClassName)
{
	if (nNode.className.length == 0)
		nNode.className = sClassName;
	else
	{
		var reg = new RegExp("\\b" + sClassName + "\\b");
		if (!nNode.className.match(reg))
			nNode.className += ' ' + sClassName;
	}
}

/**
 * Removes a CSS Class from a node
 */
function removeCssClass(nNode, sClassName)
{
	if (nNode.nodeType == 1)
		nNode.className = nNode.className.replace(new RegExp(" ?\\b" + sClassName + "\\b"), "");
}

/**
 * Replaces a CSS class in a node
 */
function replaceCssClass(nNode, sSearchName, sReplaceName)
{
	removeCssClass(nNode, sSearchName);
	addCssClass(nNode, sReplaceName);
}

/**
 * Display functions
 */
function displayNode(nNode, bDisplay)
{
	if (typeof bDisplay == 'undefined')
		bDisplay = true;

	//bDisplay = parseInt(bDisplay);

	nNode.style.display = bDisplay ? '' : 'none';
}
/**
 * @param nNode
 * @return bool displayed
 */
function toggleDisplay(nNode)
{
	nNode.style.display = (nNode.style.display == '') ? 'none' : '';
	return (nNode.style.display != 'none');
}

/**
 * Short function for document.createElement
 * @return nNode
 */
function createEl(sName, nParent)
{
	if (typeof nParent == 'undefined')
		nParent = document;

	return nParent.createElement(sName);
}
mk=createEl;

/**
 * Short function for document.getElementById
 * @return nNode
 */
function getElById(sId, nParent)
{
	if (typeof nParent == 'undefined')
		nParent = document;

	return nParent.getElementById(sId);
}
$=getElById;
/**
 * Short function for document.getElementsByName
 * @return array<nNode>
 */
function getElsByName(sName, nParent)
{
	if (typeof nParent == 'undefined')
		nParent = document;

	var rv = [];

	//this does a reloop to put it in our customized array object
	var els = nParent.getElementsByName(sName);
	for ( var i=0 ; i < els.length ; i++)
		rv.push(els[i]);
	return rv;
}
$$s=getElsByName;


/**
 * getElByName
 * @return nNode
 */
function getElByName(sName, nParent)
{
	if (typeof nParent == 'undefined')
		nParent = document;

	var els = getElsByName(sName, nParent);

	if (els.length == 0)
		throw "getElByName() - No such element: " + sName;
	else
		return els[0];
}
$$=getElByName;
/**
 * @param node nNode
 * @param sTagname optional UpperCase!! tagname
 */
function getNextElementSibling(nNode, sTagname)
{
	sTagname=sTagname?sTagname:false;
	var rv = nNode;
	while ( rv = rv.nextSibling )
	{
		if ( rv.nodeType != 1 ) //ELEMENT_NODE
			continue;
		if ( ! sTagname )
			break;
		if ( rv.tagName == sTagname )
			break;
	}
	rv=rv?rv:false;
	return rv;
}

/**
 * Returns the label associated with the radio
 * @param Node nRadio
 * @return Node nLabel
 */
function getLabelByRadio(nRadio)
{
	var labels = document.getElementsByTagName('LABEL');
	for (var i=0; i<labels.length; i++) {
		if (labels[i].htmlFor == nRadio.id)
			return labels[i];
	}
	return false;
}

/**
 *
 */
function disableFormNodes(nNode, bDisabled)
{
	if (typeof bDisabled == 'undefined')
		bDisabled = true;

	var nodes = nNode.getElementsByTagName('input');
	for (var i=0; i<nodes.length; i++)
		nodes[i].disabled = bDisabled;

	var nodes = nNode.getElementsByTagName('select');
	for (var i=0; i<nodes.length; i++)
		nodes[i].disabled = bDisabled;
}

/**
 * function for UTF-8 encoding
 */
function utf8_encode(string) {
  	string = string.replace(/\r\n/g,"\n");
	var utftext = "";

	for (var n = 0; n < string.length; n++) {
		var c = string.charCodeAt(n);
   		if (c < 128) {
			utftext += String.fromCharCode(c);
 		} else if((c > 127) && (c < 2048)) {
  			utftext += String.fromCharCode((c >> 6) | 192);
  			utftext += String.fromCharCode((c & 63) | 128);
 		} else {
  			utftext += String.fromCharCode((c >> 12) | 224);
  			utftext += String.fromCharCode(((c >> 6) & 63) | 128);
 			utftext += String.fromCharCode((c & 63) | 128);
 		}
 	}
	return utftext;
}

/**
 * function for UTF-8 decoding
 */
function utf8_decode(utftext) {
	var string = "";
 	var i = 0;
 	var c = c1 = c2 = 0;

  	while ( i < utftext.length ) {
  		 c = utftext.charCodeAt(i);
   		if (c < 128) {
    		string += String.fromCharCode(c);
    		i++;
  		} else if((c > 191) && (c < 224)) {
 			c2 = utftext.charCodeAt(i+1);
    		string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
    		i += 2;
  		} else {
 			c2 = utftext.charCodeAt(i+1);
    		c3 = utftext.charCodeAt(i+2);
    		string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
   			i += 3;
 		}
	}
	return string;
}

/**
 * Applies thousand seperators to the given number
 */
function number_format (number, decimals, dec_point, thousands_sep) {
    // Formats a number with grouped thousands
    //
    // version: 906.1806
    // discuss at: http://phpjs.org/functions/number_format
    var n = number, prec = decimals;

    var toFixedFix = function (n,prec) {
        var k = Math.pow(10,prec);
        return (Math.round(n*k)/k).toString();
    };

    n = !isFinite(+n) ? 0 : +n;
    prec = !isFinite(+prec) ? 0 : Math.abs(prec);
    var sep = (typeof thousands_sep === 'undefined') ? ',' : thousands_sep;
    var dec = (typeof dec_point === 'undefined') ? '.' : dec_point;

    var s = (prec > 0) ? toFixedFix(n, prec) : toFixedFix(Math.round(n), prec); //fix for IE parseFloat(0.55).toFixed(0) = 0;

    var abs = toFixedFix(Math.abs(n), prec);
    var _, i;

    if (abs >= 1000) {
        _ = abs.split(/\D/);
        i = _[0].length % 3 || 3;

        _[0] = s.slice(0,i + (n < 0)) +
              _[0].slice(i).replace(/(\d{3})/g, sep+'$1');
        s = _.join(dec);
    } else {
        s = s.replace('.', dec);
    }

    var decPos = s.indexOf(dec);
    if (prec >= 1 && decPos !== -1 && (s.length-decPos-1) < prec) {
        s += new Array(prec-(s.length-decPos-1)).join(0)+'0';
    }
    else if (prec >= 1 && decPos === -1) {
        s += dec+new Array(prec).join(0)+'0';
    }
    return s;
}