/**
 * ClientSide InterfaceFactory functions
 * @author Chris Wesseling <chris@basesoft.com>
 * @author Marten Koedam <marten@basesoft.com>
 * @todo Disable loadblock while loading or somthing like that.
 * @version $Id$
 */
function interfaceHandler(path)
{
	this.path = path;
	this.staleBlocks = new Array();
	this.tinyMCEs = new Array();

	jsbroker.addPhpBroker(this.path+'scripts/i-w/bots/PhpBroker.php');
}

interfaceHandler.prototype.toggleBlock = function(blockId, dontSave)
{
	var state;
	if ( state = this.toggleElement('ifB_'+blockId) )
		if ( this.staleBlocks[blockId] )
			this.loadBlock(new Array(new String(blockId)), this.staleBlocks[blockId]);

	if ( typeof dontSave != 'undefined' ) //see EasterEgg
		return;

	/*var head = document.getElementsByTagName('head').item(0);
	var src = this.path+'scripts/i-w/interface/toggleBlock.php?id='+blockId+'&open='+open;
	var script = document.createElement('script');
	script.src = src;
	script.defer = true; // Inline executable function is deferred.
	void(head.appendChild(script));*/

	// AJAX

	var params = new Array();
	params['id']=blockId;
	params['open'] = state;
	jsbroker.call('toggleBlock', params);
}
interfaceHandler.prototype.loadBlock = function(blockIds, params)
{
	// extract postParams from params if its not an array already
	var postParams = (params instanceof Array) ? params : params.parseRequestURI();

	postParams['blockIds'] = new Array();
	for ( var i=0; i < blockIds.length; i++ )
	{
		//get Table
		el = document.getElementById('ifB_'+blockIds[i]);
		if (!el)
			throw 'interfaceHandler::loadBlock() - block ['+blockIds[i]+'] not found in document';

		// trigger event unloadblock
		eventHandler.triggerEvent('unloadblock', new Array(blockIds[i], el));

		// Check if table is not empty
		if ( !el.tBodies.length || (Browser.isMSIE && !el.tBodies[0].rows.length ))
			el.appendChild(document.createElement('tbody')); // Create new TBody
		// Copy style
		var style = el.tBodies[0].style.display;
		// remove the full tBody
		el.removeChild(el.tBodies[0]);
		// Create a new tBody
		el.appendChild(document.createElement('tbody'));
		// Add org. style.
		el.tBodies[0].style.display = style;
		var rel = document.createElement('tr');
		var del = document.createElement('td');
		del.innerHTML = '<strong>Loading...</strong>';
		rel.appendChild(del);
		el.tBodies[0].appendChild(rel);
		if ( el.tBodies[0].style.display != 'none' )
		{
			postParams['blockIds'].push(blockIds[i]);
			this.staleBlocks[blockIds[i]] = false;
		}
		else
			this.staleBlocks[blockIds[i]] = params;
	}
	if ( !postParams['blockIds'].length )
		return;
	// AJAX
	jsbroker.call('loadBlock',postParams,ifHandler.buildBlock);
}
/**
 *
 */
interfaceHandler.prototype.buildBlock = function(params)
{
	var keys = params.array_keys();
	for(var i=0;i<params.sizeof();i++)
	{
		var elId = 'ifB_'+keys[i];

		if(params[keys[i]]['prescript'])
			eval(params[keys[i]]['prescript']);

		document.getElementById(elId).parentNode.innerHTML = params[keys[i]]['xhtml'];

		if(params[keys[i]]['postscript'])
			eval(params[keys[i]]['postscript']);
	}
}
/**
 * @param ifId int The interface Id you want to load
 * @param params mixed the params for the rpc call
 * @param requestValues Array (optional) Any request vars that you would like to attach to the Ajax call
 */
interfaceHandler.prototype.loadInterface = function(ifId, params, requestValues)
{
	params["ifId"] = ifId;
	if(typeof requestValues != 'undefined')
		jsbroker.callAndAttachRequestVars(requestValues, 'loadInterface', params, ifHandler.buildInterface);
	else
		jsbroker.call('loadInterface', params, ifHandler.buildInterface);
}

interfaceHandler.prototype.buildInterface = function(params)
{
	dumpln(print_r(params));
	el = $(params['targetId']);
	if(el.tagName.toLowerCase() == 'table')
		el = el.tBodies[0].rows[0].cells[0];

	el.innerHTML = params['xhtml'];
	if(params['postscript'])
		eval(params['postscript']);
}

/**
 * Toggles element visibility
 * @return true if new state is visible
 */
interfaceHandler.prototype.toggleElement = function(elId)
{
	var el = document.getElementById(elId);
	if ( !el.tBodies.length )
	{
		el.appendChild(document.createElement('tbody'));
		el.tBodies[0].style.display = 'none';
	}
	else if(Browser.isMSIE && !el.tBodies[0].rows.length ) // UGLY IE fix
		el.tBodies[0].style.display = 'none';
	var style = el.tBodies[0].style;
	if ( style.display == 'none' )
		style.display = '';
	else
		style.display = 'none';
	return (style.display != 'none');
}
/**#@+
 * @deprecated Use FancySelectController
 */
interfaceHandler.prototype.moveLeft = function(id)
{
	FancySelectController.prototype.getController(id).moveLeft();
}
interfaceHandler.prototype.moveRight = function(id)
{
	FancySelectController.prototype.getController(id).moveRight();
}
interfaceHandler.prototype.moveAllLeft = function(id)
{
	FancySelectController.prototype.getController(id).moveAllLeft();
}
interfaceHandler.prototype.moveAllRight = function(id)
{
	FancySelectController.prototype.getController(id).moveAllRight();
}
/**#@-#/;
/**#@+
 * Used for IF_ITEM_FANCY_SELECT
interfaceHandler.prototype.moveOption = function(el)
{
	if ( /_options$/.test(el.parentNode.id) )
	{
		targetSel = document.getElementById(el.parentNode.id.replace(/_options$/, '_selected'));
		var hiddenOpt = document.createElement('input');
		hiddenOpt.type = 'hidden';
		hiddenOpt.value = el.value;
		hiddenOpt.name = el.parentNode.id.replace(/_options$/, '[]');
		targetSel.parentNode.appendChild(hiddenOpt);
	}
	else
	{
		targetSel = document.getElementById(el.parentNode.id.replace(/_selected$/, '_options'));
		var hiddens = document.getElementsByName(el.parentNode.id.replace(/_selected$/, '[]'));
		for ( var i=0 ; i < hiddens.length ; i++ )
			if ( hiddens[i].value == el.value )
				hiddens[i].parentNode.removeChild(hiddens[i]);
	}

	if (document.all)
		targetSel.options.appendChild(el, targetSel); // IE
	else
		targetSel.options.add(el);               // firefox
}
 */

interfaceHandler.prototype.moveUp = function(id, postfix)
{
	if ( typeof postfix == 'undefined' )
		postfix = '_selected';
	fromObject = document.getElementById(id+postfix);
    for ( var i=0; i<fromObject.options.length;i++)
        if ( fromObject.options[i].selected )
		{
			el = fromObject.options[i];
			if ( el.previousSibling )
				el.parentNode.insertBefore(el, el.previousSibling);
		}
}
interfaceHandler.prototype.moveDown = function(id)
{
	fromObject = document.getElementById(id+'_selected');
    for ( var i=fromObject.options.length-1; i>=0 ;i--)
        if ( fromObject.options[i].selected )
		{
			el = fromObject.options[i];
			if ( el.nextSibling )
				el.parentNode.insertBefore(el.nextSibling, el);
		}
}
interfaceHandler.prototype.deleteOption = function(object) {
    object.parentNode.removeChild(object);
}
/**#@-*/; //ECMA sees this as new RegExp('**#@-*'), hence the ;

interfaceHandler.prototype.makeHidden = function(el,elName)
{
	for(var i=0;i<el.options.length;i++)
	{
		var hiddenOpt = document.createElement('input');
		hiddenOpt.type = 'hidden';
		hiddenOpt.value = el.options[i].value;
		hiddenOpt.name = elName;
		el.parentNode.appendChild(hiddenOpt);
	}
	return true;
}

interfaceHandler.prototype.nextFieldName = function(string)
{
	if ( !string.match(/\[\d+\]/) )//if contains [#] return [#++]
		return string;
	var matches = /(.*?\[)(\d+)(\].*)/.exec(string);
	return matches[1]+(parseInt(matches[2])+1)+matches[3];
}
interfaceHandler.prototype.duplicateLastTableRow = function(tableElement)
{
	var lastRow = tableElement.tBodies[0].lastChild;
	while ( lastRow.nodeType != 1 ) //moz lastChild is a textNode
		lastRow = lastRow.previousSibling;
	var newRow = lastRow.cloneNode(true); //deep clone
	var focusReceiver = this._fixRowNodes(newRow);
	tableElement.tBodies[0].appendChild(newRow);
	this.reclassifyRows(tableElement);
	return focusReceiver;
}
interfaceHandler.prototype.reclassifyRows = function(tableElement)
{
	if ( !tableElement.tBodies[0].rows[0].className.match(/\d+$/) )
		return;

	var rowCount = tableElement.tBodies[0].rows.length;
	var rowClass = tableElement.tBodies[0].rows[0].className.replace(/\d+$/, '');
	var rowClassOffset = parseInt(tableElement.tBodies[0].rows[0].className.replace(/.*(\d+)$/, '$1'),10);

	for ( var i=0; i < rowCount; i++ )
		tableElement.tBodies[0].rows[i].className = rowClass+((i+rowClassOffset)%2);
}
/**
 * @return mixed false or object : the first HTMLInputElement.type == 'text' in the row
 */
interfaceHandler.prototype._fixRowNodes = function(tableRowElement)
{
	var focusReceiver = false;
	var Cell = tableRowElement.childNodes.item(0);
	do
	{
		if ( Cell.nodeType != 1 ) //skip moz textNode
			continue;
		//search for <input> or <select>
		if ( Cell.hasChildNodes() )
		{
			/**
			 * @FIXME: this for loops only loops through the childnodes, better would be to
			 *         use .nextSibling but for some reason the these siblings are never found.
			 */
			for (var i=0; i<Cell.childNodes.length; i++)
			{
				var Node = Cell.childNodes.item(i);

				if ( Node.nodeType != 1 ) //noElementNode
					continue;

				if ( Node.tagName.toLowerCase() == 'input' )
				{
					tempname = this.nextFieldName(Node.name);
					attr = new Array();
					attr['value'] = Node.value;
					attr['name'] = tempname;
					attr['type'] = Node.type;
					attr['class'] = Node.className;
					attr['disabled'] = Node.disabled;
					attr['size'] = Node.size;

					attr['behaviour'] = (Node.getAttribute('behaviour') != null) ? this.nextFieldName(Node.getAttribute('behaviour')) : '';

					if (Node.readonly) {
						attr['readonly'] = true;
					}

					// if we see a text field, lets not copy its value
					if (attr['type'] == 'text')
						attr['value'] = '';

					// ie cant copy the onclick directly
					attr['onclick'] = (Node.getAttribute('onclick') != null) ? Node.getAttribute('onclick') : '';
					attr['onclick'] = attr['onclick'].toString().replace(/\s*function anonymous\(\)\s*\{/m, '');
					attr['onclick'] = attr['onclick'].toString().replace(/}$/m, '');

					// ie cant copy the onchange directly
					attr['onchange'] = (Node.getAttribute('onchange') != null) ? Node.getAttribute('onchange') : '';
					attr['onchange'] = attr['onchange'].toString().replace(/\s*function anonymous\(\)\s*\{/m, '');
					attr['onchange'] = attr['onchange'].toString().replace(/}$/m, '');

					// create the tag as a string.. this is to avoid some ie wierdness
					var str = '<input type="'+attr['type']+'" '+(attr['disabled']?'disabled="disabled"':'')+' name="'+attr['name']+'" value="'+attr['value']+'" \
						behaviour="'+attr['behaviour']+'"  '+(attr['size']?'size="'+attr['size']+'"':'')+' onclick="'+attr['onclick']+'" onchange="'+attr['onchange']+'" \
						class="'+attr['class']+'" ';

					// only set readonly if true.. empty value for readonly still makes it readonly
					if (attr['readonly'])
						str += ' readonly="readonly" ';

					// close the tag
					str += ' />';

					var pn = Node.parentNode;
					removeNode(Node);
					pn.innerHTML = str+pn.innerHTML;

					if ( Node.type != 'button' )
						Node.value = Node.defaultValue;
					if ( !focusReceiver && Node.type == 'text' )
						focusReceiver = Node;
				}

				if ( Node.tagName.toLowerCase() == 'select' )
				{
					//Node.name = this.nextFieldName(Node.name);
					var options = new Array();
					for (var i=0; i<Node.options.length; i++)
						options[Node.options[i].value] = Node.options[i].innerHTML;

					attr = [];
					attr.push('name="'+ this.nextFieldName(Node.name) +'"');
					if ( Browser.isMSIE )
						attr.push('id="'+ this.nextFieldName(Node.name) +'"');
					attr.push('behaviour="'+((Node.getAttribute('behaviour') != null) ? Node.getAttribute('behaviour') : '')+'"');

					new Array('onclick', 'onchange').forEach(function(el, i, ar)
					{
						var onE = (Node.getAttribute(el) != null) ? Node.getAttribute(el) : '';
						if (!onE)
							return;
						onE = onE.toString().replace(/\s*function anonymous\(\)\s*\{/m, '');
						onE = onE.toString().replace(/}$/m, '');
						attr.push(el+'="'+onE+'"');
					});

					var str = '<select '+attr.join(' ')+'>';
					options.forEach(function(html, value, array) {
						str += '<option value="'+value+'">'+html+'</option>';
					});

					str += '</select>';
					var pn = Node.parentNode;
					removeNode(Node);
					pn.innerHTML = str+pn.innerHTML;
				}

				if ( Node.tagName.toLowerCase() == 'a' )
					Node.id = this.nextFieldName(Node.id);

				// filter FormBehaviour error classes and DIV's
				if ( Node.tagName.toLowerCase() == 'div' && Node.className == 'error' )
					removeNode(Node);

				if ( Node.className.indexOf('error') != -1 )
					removeCssClass(Node, 'error');
			}
		}
	} while ( Cell = Cell.nextSibling );

	return focusReceiver;
}
var ifRowControlClicked = 0;
interfaceHandler.prototype.duplicateParentsLastRow = function(tableMember, rowCount, setFocus)
{
	var setFocus = (typeof setFocus != 'undefined')?setFocus:true;
	var rowCount = rowCount?rowCount:1;
	if ( tableMember.nodeType != 1 || tableMember.tagName.toLowerCase() != 'table' ) //noTable
		return this.duplicateParentsLastRow(tableMember.parentNode, rowCount, setFocus);
	do
	{
		var focusReceiver = this.duplicateLastTableRow(tableMember); //tableMember == tableElement
		setFocus && focusReceiver && this.setFieldFocus(focusReceiver);
	} while ( --rowCount )
	return true;
}
interfaceHandler.prototype.removeParentRow = function(rowMember, evenLastOne)
{
	if ( typeof evenLastOne == 'undefined' )
		evenLastOne = false;
	if ( rowMember.nodeType != 1 || rowMember.tagName.toLowerCase() != 'tr' ) //rowMember == rowElement
		return this.removeParentRow(rowMember.parentNode, evenLastOne);
	var tableBodyElement = rowMember.parentNode;
	if ( evenLastOne || (rowMember.parentNode.rows.length > 1) )
		rowMember.parentNode.removeChild(rowMember); //harakiri

	this.reclassifyRows(tableBodyElement.parentNode);
	return true;
}
interfaceHandler.prototype.goCell = function(el, direction)
{
	direction = direction?direction:'';
	switch ( direction )
	{
		case 'up':
			direction = 'previous';
		break;
		case 'down':
		default:
			direction = 'next';
	}
	var elCell = el;
	while ( (elCell.nodeType != 1) || (elCell.tagName.toLowerCase() != 'td') )
		elCell = elCell.parentNode;
	var elRow = elCell;
	while ( (elRow.nodeType != 1) || (elRow.tagName.toLowerCase() != 'tr') )
		elRow = elRow.parentNode;
	var cellIndex = 0;
	while ( elRow.cells[cellIndex] != elCell )
		cellIndex++;

	var focusreceiver = false;
	while ( elRow = elRow[direction+'Sibling'] )
	{
 		if ( (elRow.nodeType != 1) || (elRow.tagName.toLowerCase() != 'tr') )
			continue; //not a row
		if ( cellIndex >= elRow.cells.length )
			continue; //to short

		elCell = elRow.cells[cellIndex];
		if ( !elCell.hasChildNodes )
			continue; //not a parent
		focusreceiver = elCell.firstChild;
		do
		{
			//if ( ! focusreceiver.focus )
 			if ( (focusreceiver.nodeType != 1) || (focusreceiver.tagName != el.tagName) )
				continue;
			focusreceiver.focus();
			return true;
		}
		while ( focusreceiver = focusreceiver.nextSibling )

	}
	//dropped over the edge
	return false;
}
interfaceHandler.prototype.isFocusReceiver = function(el)
{
	if ( ((typeof el.nodeType != 'undefined') && el.nodeType != 1) || ! (new Array('INPUT', 'SELECT', 'TEXTAREA', 'BUTTON').in_array(el.tagName)) )
		return false;
	return el.focus;
}
interfaceHandler.prototype.handleMovement = function(el, e)
{
	if ( typeof e == 'undefined' ) //we're a direct eventlistener
	{
		var e = el;
		var el = this;
	}
	if ( ! interfaceHandler.prototype.isFocusReceiver(el) )
		el = e.target;

	switch ( e.keyCode )
	{
		case 9: //tab
			if ( !e.shiftKey )
			{
				if ( ifHandler.goCell(el) )
				{
					e.preventDefault();
					return false;
				}
			}
			else
			{
				if ( ifHandler.goCell(el, "up") )
				{
					e.preventDefault();
					return false;
				}
			}
		case 38: //up
			if ( ifHandler.goCell(el, "up") )
			{
				e.preventDefault();
				return false;
			}
		case 13: //enter
		case 40: //down
			if ( ifHandler.goCell(el) )
			{
				e.preventDefault();
				return false;
			}
	}
}
/**
 * Returns true if el is in the last row of it's parents tbody
 * @param Object el
 * @param int offset (default: 0) offset from the lastrow. (ie. 1 checks 1 row above the real last row)
 * @return bool
 */
interfaceHandler.prototype.isInLastRow = function(el, offset)
{
	while ( (el.nodeType != 1) || (el.tagName.toLowerCase() != 'tr') )
		el = el.parentNode;
	var elBody = el;
	while ( (elBody.nodeType != 1) || (elBody.tagName.toLowerCase() != 'tbody') )
		elBody = elBody.parentNode;
	return elBody.rows[elBody.rows.length-(1+offset)] == el;
}
/**
 * Sets the focus to the field and selects all text (if available)
 * @param Object el
 */
interfaceHandler.prototype.setFieldFocus = function(el)
{
	try	{
		el.select();
		el.focus();}
	catch(e){}
}
/**
 * Set selected options of <select> element by value
 * @param selectElement
 * @param mixed string|int|array
 * @todo make it accept array's as value, for use with multiselect..
 */
interfaceHandler.prototype.setSelectedOptions = function(el, value)
{
	if ( typeof el == 'string' )
		el = document.getElementById(el);

	for ( var i=0; i < el.options.length; i++ )
		el.options[i].selected = ( el.options[i].value == value );
}
/**
 * Set the several parts of a IF_ITEM_DATE to a certain time
 * @param string interface Itemname (without [day|month|year ...])
 * @param int stamp UnixTimestamp
 */
interfaceHandler.prototype.setDate = function(itemName, stamp)
{
	var date = new Date(stamp * 1000);
	//round to the number of minutes options.. -1 (not counting the '-' option)
	var min = date.getMinutes();
	var steps = document.getElementsByName(itemName+'[minute]').length!=0?document.getElementsByName(itemName+'[minute]')[0].options.length - 1:60;
	var deltaS = ((-1*min)+((Math.round(min*steps/60))/steps*60))*60;

	date = new Date((stamp+deltaS)*1000);

	var parts = new Array();
	parts['[day]'] = date.getDate();
	parts['[month]'] = date.getMonth()+1;
	parts['[year]'] = date.getFullYear();
	parts['[hour]'] = date.getHours();
	parts['[minute]'] = date.getMinutes();

	for ( var part in parts )
		(document.getElementsByName(itemName+part).length != 0 ) && this.setSelectedOptions(document.getElementsByName(itemName+part)[0], parts[part]);
}
/**
 * @param string url Url of the page to be opened
 * @param string name Name of the window.
 * @param string opt Comma seperated string of all options that are enabled/disabled
 */
interfaceHandler.prototype.popup = function(url,name,opt)
{
	opt = opt ? opt : '';
	name = name ? name : 'new';
	window.open(url,name,opt);
}


interfaceHandler.prototype.addTinyMCEForItem = function(itemId)
{
	var el = getElById('ifI_' + itemId);
	if (!el)
		throw "Cannot add TinyMCE: field for itemid ("+itemId+") does not exists";

	var tiny_mce_id = tinyMCE.addMCEControl(el);
	this.tinyMCEs[itemId] = tiny_mce_id;

	dumpln('added tinymce: ' + tiny_mce_id);
}

interfaceHandler.prototype.removeTinyMCEForItem = function(itemId)
{
	dumpln("trying to remove tinymce for item " + itemId);

	if (typeof this.tinyMCEs[itemId] != 'undefined')
	{
		var tiny_mce_id = this.tinyMCEs[itemId];
		dumpln("found tinymce id: " + tiny_mce_id);

		tinyMCE.removeMCEControl(tiny_mce_id);
		delete this.tinyMCEs[itemId];

		dumpln("removed " + tiny_mce_id);
	}
	else
		dumpln("no removing needed");
}

/**
 * Attach a callback for form value changes
 * @param string formId The id fo the form to watch
 * @param function callback The callback to perform when a value changes
 * @param Array onlyForIds Only attach callback to elements with these ids (optional)
 */
interfaceHandler.prototype.watchFormOnChange = function(formId, callback, onlyForIds)
{
	var fe = $(formId);
	for(var i = 0; i < fe.elements.length; i++)
	{
		if(typeof onlyForIds != 'undefined' && !onlyForIds.in_array(fe.elements[i].id))
			continue;
		switch(fe.elements[i].tagName.toLowerCase())
		{
			case 'input':
				if(fe.elements[i].type.toLowerCase() == 'text' || fe.elements[i].type.toLowerCase() == 'password')
					addEvent(fe.elements[i], 'change', callback);
				if(fe.elements[i].type.toLowerCase() == 'radio' || fe.elements[i].type.toLowerCase() == 'checkbox')
					addEvent(fe.elements[i], 'click', callback);
				break;
			case 'textarea':
				addEvent(fe.elements[i], 'change', callback);
				break;
			case 'select':
				addEvent(fe.elements[i], 'change', callback);
				break;
			default:
				break;
		}
	}
}


