
function LanguageInterface()
{
	this._trs = new Array();
	//this.debug = true;
}

LanguageInterface.prototype.addText = function(handle, translation)
{
	this._trs[handle] = translation;

	// add the handle ot the admin interface so it can be translated
	if (typeof langAdmin != 'undefined' && langAdmin.pageHandles)
		langAdmin.pageHandles.push(handle);
}

LanguageInterface.prototype.getText = function(handle)
{
	if (typeof this._trs[handle] != 'undefined')
		return this._trs[handle];
	else
	{
		dumpln('LangIf Warning: `'+handle+'` was never retrieved serverside');
		return handle;
	}
}

LanguageInterface.prototype.setTexts = function(arr)
{
	arr.forEach( function(element, index, array) {
		this.addText(index, element);
	}, this);
}

/**
 * @param array<Handles>
 */
LanguageInterface.prototype.translateHandles = function(arr)
{
	var event = new YAHOO.util.CustomEvent("onTranslate");

	this.debug && dumpln('LanguageInterface: Retrieveing handles: '+print_r(arr));
	jsbroker.call('LangIfRPC.getText', arr, function(params) {
		params.forEach(function(translation, handle, array) {
			langIf.addText(handle, translation);
		}, this);

		event.fire(params);
		this.debug && dumpln('LanguageInterface: Translations received, firing event');
	}, this);

	return event;
}

/**
 * Asynchronous translate function
 * Give an array of Nodes where the key is the TranslationHandle
 * @param array[TranslationHandle]<nNode>
 */
LanguageInterface.prototype.translateNodes = function(arr)
{
	// add the handle ot the admin interface so it can be translated
	if (typeof langAdmin != 'undefined')
	{
		arr.array_keys().forEach(function(el, i, a) {
			langAdmin.pageHandles.push(el);
		});
	}

	// try to translate and save into nodes
	jsbroker.call('LangIfRPC.getText', arr.array_keys(), function(params) {
		params.forEach(function(el, i, array)
		{
			if (arr[i])
			{
				if (arr[i].tagName == 'INPUT')
					arr[i].value = el;
				else
					arr[i].innerHTML = el;
			}

		}, this);
	});
}

langIf = new LanguageInterface();
