<?php
/**
 * Packagepath constants
 * @author Chris Wesseling <chris.wesseling@xs4all.nl>
 * @package I-Ware
 * @version $Id: packages.php 202 2005-02-16 15:59:05Z Chris Wesseling $
 */
/**#@+
 * Absolute server path to class.
 * Convention:
 * 	PACKAGENAME without - = absolute path to classes in package
 * 	PACKAGENAME_SUBPACKAGENAME without - = absolute path to files in subpackage
 */
define('COMPOSITIONS', SITE_HOMEDIR.SITE_PATH.'compositions/');
define('CUSTOM', SITE_HOMEDIR.SITE_PATH.'classes/custom/');
define('IMAGES', SITE_HOMEDIR.SITE_PATH.'images/');
define('INTERCLEAN', SITE_HOMEDIR.SITE_PATH.'classes/interclean/');
define('INTERCLEAN_INCLUDES', SITE_HOMEDIR.SITE_PATH.'includes/interclean/');
define('INTERCLEAN_SCRIPTS', SITE_HOMEDIR.SITE_PATH.'scripts/interclean/');
define('INTERFACES', SITE_HOMEDIR.SITE_PATH.'interfaces/');
define('INTERFACE_OBJ', SITE_HOMEDIR.SITE_PATH.'classes/interface/');
define('ISURVEY', SITE_HOMEDIR.SITE_PATH.'classes/i-q/');
define('ISURVEY_CHART', SITE_HOMEDIR.SITE_PATH.'classes/nchart/');
define('ISURVEY_OLD_CHART', SITE_HOMEDIR.SITE_PATH.'classes/chart/');
define('ISURVEY_PUBLISH', SITE_HOMEDIR.SITE_PATH.'classes/publish/');
define('IWARE', SITE_HOMEDIR.SITE_PATH.'classes/i-w/');
define('IADMIN', SITE_HOMEDIR.SITE_PATH.'classes/i-a/');
define('IWARE_INCLUDES', SITE_HOMEDIR.SITE_PATH.'includes/i-w/');
define('IWARE_SCRIPTS', SITE_HOMEDIR.SITE_PATH.'scripts/i-w/');
define('IWARE_LISTS', SITE_HOMEDIR.SITE_PATH.'lists/i-w/');
define('IWARE_SCRIPTS_DEFAULT', IWARE_SCRIPTS.'default/');
define('MENUIMAGES', SITE_HOMEDIR.SITE_PATH.'menu-images/');
define('STONES', SITE_HOMEDIR.SITE_PATH.'classes/stone/');
define('LISTS', SITE_HOMEDIR.SITE_PATH.'lists/');
define('TASKS', SITE_HOMEDIR.SITE_PATH.'tasks/');
define('TEMPLATES', SITE_HOMEDIR.SITE_PATH.'templates/');
define('TEMPLATES_SQ', SITE_HOMEDIR.SITE_PATH.'templates/sq/');

define('UNITEDINVESTORS', SITE_HOMEDIR.SITE_PATH.'classes/unitedinvestors/');
define('UNITEDINVESTORS_SCRIPTS', SITE_HOMEDIR.SITE_PATH.'scripts/unitedinvestors/');
define('UNITEDINVESTORS_INCLUDES', SITE_HOMEDIR.SITE_PATH.'includes/unitedinvestors/');

/**
 * ELC packages
 */

define('ELC_CLASSES', SITE_HOMEDIR.SITE_PATH.'classes/elc/');
define('ELC_SCRIPTS', SITE_HOMEDIR.SITE_PATH.'scripts/elc/');
define('ELC_INCLUDES', SITE_HOMEDIR.SITE_PATH.'includes/elc/');
define('ELC_INTERFACES', SITE_HOMEDIR.SITE_PATH.'interfaces/elc/');
define('ELC_LISTS', SITE_HOMEDIR.SITE_PATH.'lists/elc/');


//END ELC packages


define('IQADMIN', SITE_HOMEDIR.SITE_PATH.'classes/i-a/');

define('STYLESHEETS', SITE_HOMEDIR.SITE_PATH.'stylesheets/');
define('WIZARDS', SITE_HOMEDIR.SITE_PATH.'wizards/');

define('CLIENT', SITE_HOMEDIR.SITE_PATH.'klant/'.(isset($_SESSION['session_user_company_name'])?$_SESSION['session_user_company_name'].'/':''));
define('CLIENT_REPORTS', CLIENT . 'reports/');
define('CLIENT_STYLESHEETS', CLIENT . 'stylesheets/');


/**#@-*/
/**#@+
 * Relative path to entity.
 * Convention:
 * 		REL_{entity}
 */
define('REL_IMAGES', '/'.SITE_PATH.'images/');
define('REL_MENU_IMAGES', '/'.SITE_PATH.'menu-images/');
define('REL_STYLESHEETS', '/'.SITE_PATH.'stylesheets/');
define('REL_IWARE_INCLUDES', '/'.SITE_PATH.'includes/i-w/');
define('REL_IWARE_SCRIPTS', '/'.SITE_PATH.'scripts/i-w/');
define('REL_CLIENT', '/'.SITE_PATH.'klant/'.(isset($_SESSION['session_user_company_name'])?$_SESSION['session_user_company_name'].'/':''));
define('REL_CLIENT_STYLESHEETS', CLIENT.'stylesheets/');
define('REL_INTERCLEAN_INCLUDES', '/'.SITE_PATH.'includes/interclean/');
/**#@-*/
?>
