
/**********************************************************
 *  functions needed for checking the password strength   *
 *  based on http://www.passwordmeter.com/                *
 **********************************************************/

String.prototype.strReverse = function() {
	var newstring = "";
	for (var s=0; s < this.length; s++) {
		newstring = this.charAt(s) + newstring;
	}
	return newstring;
};

function chkPass(pwd) {
	if (pwd.length == 0)
		return 0;

	// Simultaneous variable declaration and value assignment aren't supported in IE apparently
	// so I'm forced to assign the same value individually per var to support a crappy browser *sigh*
	var nScore=0, nLength=0, nAlphaUC=0, nAlphaLC=0, nNumber=0, nSymbol=0, nMidChar=0, nRequirements=0, nAlphasOnly=0, nNumbersOnly=0, nUnqChar=0, nRepChar=0, nRepInc=0, nConsecAlphaUC=0, nConsecAlphaLC=0, nConsecNumber=0, nConsecSymbol=0, nConsecCharType=0, nSeqAlpha=0, nSeqNumber=0, nSeqSymbol=0, nSeqChar=0, nReqChar=0, nMultConsecCharType=0;
	var nMultRepChar=1, nMultConsecSymbol=1;
	var nMultMidChar=2, nMultRequirements=2, nMultConsecAlphaUC=2, nMultConsecAlphaLC=2, nMultConsecNumber=2;
	var nReqCharType=3, nMultAlphaUC=3, nMultAlphaLC=3, nMultSeqAlpha=3, nMultSeqNumber=3, nMultSeqSymbol=3;
	var nMultLength=4, nMultNumber=4;
	var nMultSymbol=6;
	var nTmpAlphaUC="", nTmpAlphaLC="", nTmpNumber="", nTmpSymbol="";
	var sAlphas = "abcdefghijklmnopqrstuvwxyz";
	var sNumerics = "01234567890";
	var sSymbols = ")!@#$%^&*()";
	var sComplexity = "Too Short";
	var sStandards = "Below";
	var nMinPwdLen = 8;
	if (document.all) { var nd = 0; } else { var nd = 1; }
	nScore = parseInt(pwd.length * nMultLength);
	nLength = pwd.length;
	var arrPwd = pwd.replace(/\s+/g,"").split(/\s*/);
	var arrPwdLen = arrPwd.length;

	/* Loop through password to check for Symbol, Numeric, Lowercase and Uppercase pattern matches */
	for (var a=0; a < arrPwdLen; a++) {
		if (arrPwd[a].match(/[A-Z]/g)) {
			if (nTmpAlphaUC !== "") { if ((nTmpAlphaUC + 1) == a) { nConsecAlphaUC++; nConsecCharType++; } }
			nTmpAlphaUC = a;
			nAlphaUC++;
		}
		else if (arrPwd[a].match(/[a-z]/g)) {
			if (nTmpAlphaLC !== "") { if ((nTmpAlphaLC + 1) == a) { nConsecAlphaLC++; nConsecCharType++; } }
			nTmpAlphaLC = a;
			nAlphaLC++;
		}
		else if (arrPwd[a].match(/[0-9]/g)) {
			if (a > 0 && a < (arrPwdLen - 1)) { nMidChar++; }
			if (nTmpNumber !== "") { if ((nTmpNumber + 1) == a) { nConsecNumber++; nConsecCharType++; } }
			nTmpNumber = a;
			nNumber++;
		}
		else if (arrPwd[a].match(/[^a-zA-Z0-9_]/g)) {
			if (a > 0 && a < (arrPwdLen - 1)) { nMidChar++; }
			if (nTmpSymbol !== "") { if ((nTmpSymbol + 1) == a) { nConsecSymbol++; nConsecCharType++; } }
			nTmpSymbol = a;
			nSymbol++;
		}
		/* Internal loop through password to check for repeat characters */
		var bCharExists = false;
		for (var b=0; b < arrPwdLen; b++) {
			if (arrPwd[a] == arrPwd[b] && a != b) { /* repeat character exists */
				bCharExists = true;
				/*
				Calculate icrement deduction based on proximity to identical characters
				Deduction is incremented each time a new match is discovered
				Deduction amount is based on total password length divided by the
				difference of distance between currently selected match
				*/
				nRepInc += Math.abs(arrPwdLen/(b-a));
			}
		}
		if (bCharExists) {
			nRepChar++;
			nUnqChar = arrPwdLen-nRepChar;
			nRepInc = (nUnqChar) ? Math.ceil(nRepInc/nUnqChar) : Math.ceil(nRepInc);
		}
	}

	/* Check for sequential alpha string patterns (forward and reverse) */
	for (var s=0; s < 23; s++) {
		var sFwd = sAlphas.substring(s,parseInt(s+3));
		var sRev = sFwd.strReverse();
		if (pwd.toLowerCase().indexOf(sFwd) != -1 || pwd.toLowerCase().indexOf(sRev) != -1) { nSeqAlpha++; nSeqChar++;}
	}

	/* Check for sequential numeric string patterns (forward and reverse) */
	for (var s=0; s < 8; s++) {
		var sFwd = sNumerics.substring(s,parseInt(s+3));
		var sRev = sFwd.strReverse();
		if (pwd.toLowerCase().indexOf(sFwd) != -1 || pwd.toLowerCase().indexOf(sRev) != -1) { nSeqNumber++; nSeqChar++;}
	}

	/* Check for sequential symbol string patterns (forward and reverse) */
	for (var s=0; s < 8; s++) {
		var sFwd = sSymbols.substring(s,parseInt(s+3));
		var sRev = sFwd.strReverse();
		if (pwd.toLowerCase().indexOf(sFwd) != -1 || pwd.toLowerCase().indexOf(sRev) != -1) { nSeqSymbol++; nSeqChar++;}
	}

	/* Modify overall score value based on usage vs requirements */

	/* General point assignment */
	if (nAlphaUC > 0 && nAlphaUC < nLength) {
		nScore = parseInt(nScore + ((nLength - nAlphaUC) * 2));
	}
	if (nAlphaLC > 0 && nAlphaLC < nLength) {
		nScore = parseInt(nScore + ((nLength - nAlphaLC) * 2));
	}
	if (nNumber > 0 && nNumber < nLength) {
		nScore = parseInt(nScore + (nNumber * nMultNumber));
	}
	if (nSymbol > 0) {
		nScore = parseInt(nScore + (nSymbol * nMultSymbol));
	}
	if (nMidChar > 0) {
		nScore = parseInt(nScore + (nMidChar * nMultMidChar));
	}

	/* Point deductions for poor practices */
	if ((nAlphaLC > 0 || nAlphaUC > 0) && nSymbol === 0 && nNumber === 0) {  // Only Letters
		nScore = parseInt(nScore - nLength);
		nAlphasOnly = nLength;
	}
	if (nAlphaLC === 0 && nAlphaUC === 0 && nSymbol === 0 && nNumber > 0) {  // Only Numbers
		nScore = parseInt(nScore - nLength);
		nNumbersOnly = nLength;
	}
	if (nRepChar > 0) {  // Same character exists more than once
		nScore = parseInt(nScore - nRepInc);
	}
	if (nConsecAlphaUC > 0) {  // Consecutive Uppercase Letters exist
		nScore = parseInt(nScore - (nConsecAlphaUC * nMultConsecAlphaUC));
	}
	if (nConsecAlphaLC > 0) {  // Consecutive Lowercase Letters exist
		nScore = parseInt(nScore - (nConsecAlphaLC * nMultConsecAlphaLC));
	}
	if (nConsecNumber > 0) {  // Consecutive Numbers exist
		nScore = parseInt(nScore - (nConsecNumber * nMultConsecNumber));
	}
	if (nSeqAlpha > 0) {  // Sequential alpha strings exist (3 characters or more)
		nScore = parseInt(nScore - (nSeqAlpha * nMultSeqAlpha));
	}
	if (nSeqNumber > 0) {  // Sequential numeric strings exist (3 characters or more)
		nScore = parseInt(nScore - (nSeqNumber * nMultSeqNumber));
	}
	if (nSeqSymbol > 0) {  // Sequential symbol strings exist (3 characters or more)
		nScore = parseInt(nScore - (nSeqSymbol * nMultSeqSymbol));
	}

	/* Determine if mandatory requirements have been met */
	nRequirements = nReqChar;
	if (pwd.length >= nMinPwdLen) { var nMinReqChars = 3; } else { var nMinReqChars = 4; }
	if (nRequirements > nMinReqChars) {  // One or more required characters exist
		nScore = parseInt(nScore + (nRequirements * 2));
		sRequirements = "+ " + parseInt(nRequirements * 2);
	}

	if (nScore > 100) { nScore = 100; } else if (nScore < 0) { nScore = 0; }

	return nScore;
}

function checkPass(password) {
	var ps = chkPass(password);

	var sComplexity;
	var cc;
	if (ps >= 0 && ps < 20) {
		sComplexity = langIf.getText("Very weak");
		cc="red";
	} else if (ps >= 20 && ps < 40) {
		sComplexity = langIf.getText("Weak");
		cc="orange";
	} else if (ps >= 40 && ps < 60) {
		sComplexity = langIf.getText("Good");
		cc="#5be071";
	} else if (ps >= 60 && ps < 80) {
		sComplexity = langIf.getText("Strong");
		cc="green";
	} else if (ps >= 80 && ps <= 100) {
		sComplexity = langIf.getText("Very strong");
		cc="blue";
	}

	$('pwd-strength').style.backgroundColor = cc;
	$('pwd-strength').style.width = ps + "px";
	$('pwd-strength-complexity').innerHTML = " " + ps + "% - " + sComplexity;
}
