<?php
	/**
	 * @copyright Copyright 2004, BaseSoft b.v.
	 * @author Martijn van den Broek <martijn@basesoft.com>
	 * @version $Id$
	 * @package I-Ware
	 * @subpackage rpc
	 */
	/**
	 * RPC Functions
	 */
	function AutoComplete(&$broker)
	{
		$params = $broker->params;

		if (function_exists($params['source']))
			return $params['source']($params);
		else
			return array();
	}
	/**
	 *
	 */
	function dictionary($params)
	{
		$word = $params['word'];

		$output = array();
		exec("egrep \"^".addslashes($word)."\" /usr/share/dict/words", $output);
		return array_slice($output, 0, $params['maxWords']);
	}
	/**
	 *
	 */
	function ScriptIds($params)
	{
		$word = $params['word'];
		$sql = "SELECT DISTINCT( SCRIPT_ID )
			FROM TBL_SCRIPT
			WHERE SCRIPT_ID LIKE '".$word."%'
				AND APPLICATION_ID = ?
			ORDER BY SCRIPT_ID
			LIMIT 0, ".$params['maxWords'];
		$q = IWRegistry::registry('db')->query($sql);
		$q->bind_values(array(APPLICATION_ID));
		$q->execute();
		$arr = array();
		while($r = $q->fetch())
			$arr[] = $r->SCRIPT_ID;
		return $arr;
	}
	/**#@+
	 * @package UnitedInvestors
	 */
	/**
	 *
	 */
	function BankNames($params)
	{
		global $db;
		require_once(IWARE.'relation.php');
		$sql = "SELECT RELATION_NAME
			FROM TBL_RELATION
			WHERE RELATION_TYPE_ID = ?
				AND RELATION_NAME LIKE '".addslashes($params['word'])."%'
			ORDER BY RELATION_NAME
			LIMIT 0, ".$params['maxWords'];
		$q = $db->query($sql);
		$q->bind_values(array(RELATION_TYPE_BANK));
		$q->execute();
		$arr = array();
		while($r = $q->fetch())
			$arr[] = $r->RELATION_NAME;
		return $arr;
	}
	/**
	 *
	 */
	function FundNames($params)
	{
		global $db;
		$arr = array();
		require_once(UNITEDINVESTORS.'UnitedInvestorsFund.php');
		$fund = new UnitedInvestorsFund($db);
		$q = $fund->selectAutoComplete(addslashes($params['word']),$params['maxWords']);
		while($r = $q->fetch())
			$arr[] = $r->FUND_NAME;
		return $arr;
	}
	/**
	 *
	 */
	function FundAbbrs($params)
	{
		global $db;
		$arr = array();
		require_once(UNITEDINVESTORS.'UnitedInvestorsFund.php');
		$fund = new UnitedInvestorsFund($db);
		$q = $fund->selectAutoComplete(addslashes($params['word']),$params['maxWords'],'ABBR');
		while($r = $q->fetch())
			$arr[] = $r->FUND_ABBR;
		return $arr;
	}
	/**#@-*/
?>
