<?php
/**
 * @package I-Ware
 * @subpackage rpc
 */
/**
 * @author Chris Wesseling <chris@basesoft.com>
 * @author Marten Koedam <marten@basesoft.com>
 * @param mixed string or array with handles
 * @return mixed string translation or array with key as handle, translation as value
 */
function loadBlock(&$broker)
{
	global $db_edit, $langIf;

	$params = $broker->params;
	$search = array("\n","\r","\t",'\\','\'');
	$replace = array('','','','\\\\','\\\'');

	$noValidate = true;
	$script_parent_id = 0;
	require_once(INTERFACE_OBJ.'InterfaceFactory.php');
	$_REQUEST = $params;

	$rv = array();
	$if = InterFaceFactory::createInterfaceFactory((int)$params['interface_id'], IWRegistry::registry('db'), $db_edit, $langIf);
	foreach ( $params['blockIds'] as $id )
	{
		//$block =& $if->if_objBlock($id);
		$block = &$if->blocks[(int)$id];
		//$block->parent =& $if;
		//$block->load();
		list($xhtml, $Functions, $Execute) = $block->getXHTMLBlock(null, true); //default classes, no scripts
		//$rv[$id]['xhtml'] = str_replace($search,$replace,$xhtml);
		$rv[$id]['xhtml'] = $xhtml;
		echo $Functions;
		echo 'document.postscript_'.$broker->callId.'_'.$id.' = function(){'."\n".$Execute."\n".'return true; };'."\n";
		$rv[$id]['postscript'] = 'document.postscript_'.$broker->callId.'_'.$id.'();';
	}
	return $rv;
}

function toggleBlock(&$broker)
{
	global $db_edit, $langIf;

	$params = $broker->params;

	require_once(INTERFACE_OBJ.'InterfaceFactory.php');
	$if = new InterfaceFactory(IWRegistry::registry('db'),$db_edit,$langIf);
	$if->toggleBlock((int)$params['id'], ($params['open'] == 'true'));
	return '';
}

/**
 * Use this function to load an interface via an rpc call.
 * Note the postscript functionality - if you define a getDynamicJSBehaviours method
 * in your InterfaceFactory subclass, then you can get JS behaviours to execute once
 * the inline interface has been loaded
 *
 * @todo FIXME - accessing the $interface->fb directly is not good form
 */
function loadInterface(&$broker)
{
	global $db_edit, $langIf;

	$params = $broker->params;

	$settings = array();
	if(isset($params['settings']))
		$settings = $params['settings'];
	if(isset($settings['targetId'])&&isset($params['targetId']))
		$settings['targetId'] = 'return "'.$params['targetId'].'";';

	//debug(print_r($_REQUEST, true));

	require_once(INTERFACE_OBJ.'InterfaceFactory.php');
	$interface = &InterfaceFactory::createInterfaceFactory((int)$params['ifId'], IWRegistry::registry('db'), $db_edit, $langIf,$settings);
	$interface->setJsSplit(true);
	$interface->processInput($thrownException);
	list($xhtml, $Functions, $Execute) = $interface->getXHTMLInterface(array(), true);
	echo $Functions;
	echo 'document.postscript_'.$broker->callId.'_'.$params['ifId'].' = function(){'."\n".$Execute."\n".'return true; };'."\n";
	$rv = array(
				'xhtml' => "\t\t".str_replace("\n", "\n\t\t", $xhtml),
				'targetId' => $params['targetId'],
				'postscript' => 'document.postscript_'.$broker->callId.'_'.$params['ifId'].'();'."\n".$interface->fb->getJavaScriptFailuresInline().(method_exists($interface, 'getDynamicJSBehaviours') ? $interface->getDynamicJSBehaviours() : '')
				);
	return $rv;
}
?>
