<?php
/**
 * @package I-Ware
 * @subpackage rpc
 */
/**
 * RPC Method to get message text for the given EventID and infoTypes
 * @param int EventID
 * @param int|array<int> InfoTypes
 */
function GetMessageByInfoTypes(&$broker)
{
	$params    = $broker->params;
	$eventId   = $params['eventId'];
	$dests = $params['infoTypes'];

	require_once( IWARE . 'message_handler.php');

	global $db, $db_edit;
	$event_handler = new MessageHandler($db, $db_edit);

	$event = new MessageEvent($eventId);

	return $event_handler->getMessageByInfoTypes($dests, $event, MESSAGE_EMAIL);
}

/**
 *
 */
function getMessage(&$broker)
{
	$params = $broker->params;
	$language_id = $params['language_id'];
	$message_id = $params['message_id'];

	//$content_type = (!empty($params['content_type'])) ?
		//$params['content_type'] : 'text/plain';

	require_once(IWARE . 'message_handler.php');

	global $db;
	$m = new Message($db);
	if (!$m->set($message_id, $language_id))
		return false;

	$retval = array();
	$retval['SUBJECT'] = $m->getSubject($language_id);
	$retval['CONTENT'] = $m->getHtml($language_id);

	return $retval;

}

?>
