<?php

$site_title = 'WEEE Blackbox';

define('SITE_TITLE',$site_title);
define('APP_PATH','elc/');
define('SESSION_HANDLER', true);

if(!defined('MAIL_FROM'))
	define('MAIL_FROM', 'weeeblackbox@mail-test.basesoft.com');

/**
 * HTML
 */
define('LOGOUT_PAGE', 'scripts/i-w/loginscreen.php');
define('XHTML_HEADER', SITE_HOMEDIR.SITE_PATH.'scripts/elc/default/xhtml_header.php');
define('XHTML_FOOTER', SITE_HOMEDIR.SITE_PATH.'scripts/elc/default/xhtml_footer.php');

define('PRINT_HEADER', SITE_HOMEDIR.SITE_PATH.'scripts/elc/default/print_header.php');
define('PRINT_FOOTER', SITE_HOMEDIR.SITE_PATH.'scripts/elc/default/print_footer.php');

/**
 * Database
 */
if (!defined('LANGIF_DB'))
	define('LANGIF_DB', 'IQ_ELC');

/**
 * Define used for Iware classes that be extended in the application class directory.
 * These classes can be created with a static create() function. Document, Suckerfishmenu, etc
 */
define('CLASS_PREFIX', 'ELC');

/**
 * Directories
 */
define('DOCUMENT_REPOSITORY', WRITABLE.'documents/');
define('ELC_EXPORT_PATH', WRITABLE.'exports/');
//define('UK_EXPORT_PATH', WRITABLE.'uk_exports/');
define('ELC_INVOICES_IMPORT_PATH', WRITABLE.'imports/invoices/');
define('ELC_REMINDERS_IMPORT_PATH', WRITABLE.'imports/reminders/');
define('ELC_GUARANTEE_LATE_IMPORT_PATH',WRITABLE.'imports/late_guarantee/');
define('ELC_AGEING_IMPORT_PATH', WRITABLE.'imports/ageing/');

if(!defined('APC_SUFFIX'))
	define('APC_SUFFIX', $site_identifier);

/**
 * Salt for hash of refund request confirmation document
 */
define('CONFIRM_PROOF_OF_EXPORT_SALT', 'proofofexportsalt');
define('CONFIRM_PROOF_OF_PAYMENT_SALT', 'proofofpaymentsalt');

if (defined('TEST_SITE') && TEST_SITE)
{
	!defined('SNAPSHOT_SAVE_PATH') && define('SNAPSHOT_SAVE_PATH', WRITABLE.'snapshots/');
	define('DATETIME_FILE', WRITABLE.'date.txt');
	$fp = fopen(DATETIME_FILE,'r');
	$__dt = fread($fp,1024);
	fclose($fp);
	define('SITE_EXTRA_IDENTITY', $_SERVER['SERVER_NAME'].': '.$__dt);

	if (!defined('VAT_CHECKER_URL_VIES'))
		define('VAT_CHECKER_URL_VIES', 'http://'.SITE_SERVER.SITE_PATH.'tests/phpunit/i-w/FormbehaviourVatHelper.php?VAT=%s&MS=%s&Lang=EN');

	if(!defined('VAT_CHECKER_HTTP_AUTH_USER'))
	{
		define('VAT_CHECKER_HTTP_AUTH_USER', 'testrunner');
		define('VAT_CHECKER_HTTP_AUTH_PASSWORD', 'StiEhoA3');
	}

	if (!defined('SELENIUM_UPLOAD_FILE'))
		define('SELENIUM_UPLOAD_FILE', DATETIME_FILE);

	if (!defined('SELENIUM_UPLOAD_EA_IMAGE')) {
		define('SELENIUM_UPLOAD_EA_IMAGE', dirname(__FILE__).'/../../../related/uk_xml/images/10294_AEDLogo1and2.jpg');
	}
}

/**
 * SMTP_SERVERS is a (semicolon?) separated string of smtp servers used by the
 * phpmailer class. Here we fallback to mail.basesoft. com if no SMTP servers
 * are specified
 */
if (!defined('SMTP_SERVERS'))
	define('SMTP_SERVERS', 'localhost');

/**
 * WEB_SERVERS is a semicolon seperated string of internal ip
 * addresses of all webservers running the same instance of the current
 * application. Here it defaults back to the local webserver ip
 */
if (!defined('WEB_SERVERS'))
	define('WEB_SERVERS', (isset($_SERVER['SERVER_ADDR']) ? 'http://'.$_SERVER['SERVER_ADDR'] : '127.0.0.1' ));
/**
 *  WSDL  - could be already defined for php unit
 */
!defined('SOAP_WSDL_URL') && define('SOAP_WSDL_URL', 'http://'.SITE_SERVER.SITE_PATH.'scripts/elc/bots/WEEEBlackbox.wsdl.php');
!defined('SOAP_WSDL_ACCOUNTANT_URL') && define('SOAP_WSDL_ACCOUNTANT_URL', 'http://'.SITE_SERVER.SITE_PATH.'scripts/elc/bots/WEEEBlackboxAccountant.wsdl.php');
/**
 * Other defines
 */
define('NO_ACCESS_PAGE', 'scripts/i-w/no_access.php');
define('WEEE_APPLICATION_START_YEAR', 2006);

$class_dir		=	SITE_HOMEDIR.SITE_PATH.'classes/i-w/';
$root_dir		=	SITE_HOMEDIR;
$data_dir       =   SITE_HOMEDIR.SITE_PATH.'data/i-w/';
$image_dir      =   SITE_HOMEDIR.SITE_PATH.'images/graph/';

if (!defined('MAX_PRODUCT_FEE_VALUE'))
	define('MAX_PRODUCT_FEE_VALUE', 999.9999999);

/**
 * How many seconds must a user wait until he can request a new password
 */
if (!defined('NEW_PASSWORD_REQUEST_TIMEOUT'))
	define('NEW_PASSWORD_REQUEST_TIMEOUT', 600);

/**
 * Expiry period for passwords, in days (use 0 for non expiring passwords)
 */
if (!defined('PASSWORD_EXPIRES_SYSADMIN'))
	define('PASSWORD_EXPIRES_SYSADMIN', 0);
if (!defined('PASSWORD_EXPIRES_ACCOUNTANT'))
	define('PASSWORD_EXPIRES_ACCOUNTANT', 0);
if (!defined('PASSWORD_EXPIRES_CRSO'))
	define('PASSWORD_EXPIRES_CRSO', 0);
if (!defined('PASSWORD_EXPIRES_PARTICIPANT'))
	define('PASSWORD_EXPIRES_PARTICIPANT', 0);
if (!defined('PASSWORD_EXPIRES_PUBLIC'))
	define('PASSWORD_EXPIRES_PUBLIC', 90);

/**
 * Minimum password lenghts
 */
if (!defined('PASSWORD_LENGTH_SYSADMIN'))
	define('PASSWORD_LENGTH_SYSADMIN', 12);
if (!defined('PASSWORD_LENGTH_ACCOUNTANT'))
	define('PASSWORD_LENGTH_ACCOUNTANT', 12);
if (!defined('PASSWORD_LENGTH_CRSO'))
	define('PASSWORD_LENGTH_CRSO', 12);
if (!defined('PASSWORD_LENGTH_PARTICIPANT'))
	define('PASSWORD_LENGTH_PARTICIPANT', 8);
if (!defined('PASSWORD_LENGTH_PUBLIC'))
	define('PASSWORD_LENGTH_PUBLIC', 8);

/**
 * How many days the token is valid if it's not used. it can't be used after it's expired
 */
if (!defined('LOGIN_TOKEN_LIFETIME'))
	define('LOGIN_TOKEN_LIFETIME', 7);

/**
 * login types
 */
define('LOGIN_FAILED', -1);	// the default value when the session is being built
define('LOGIN_NORMAL', 0);	// when normal login is performed, with user and password
define('LOGIN_SWITCH', 1);	// when sysadmins or operators log as other users, without password
define('LOGIN_TOKEN', 2);	// when users login in via an url sent in the email. no password required, works only one time

?>
