
<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
require_once(ELC_CLASSES.'uk/UKCRSOSupplier.php');
require_once(ELC_CLASSES.'uk/UKCRSODataLine.php');
/**
 *
 * @package
 * @subpackage Interface
 * @since 14-12-2010
 * @copyright 2010 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceCrsoEASuppliers extends InterfaceFactory
{
    /**
     * interface[id] = 202
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceCrsoEASuppliers(&$db, &$db_app, &$langIf)
    {
        parent::InterfaceFactory($db, $db_app, $langIf);
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';

        if($_SESSION['session_group_group_id'] != GROUP_CRSO)
        	throw new InterfacePermissionException('Unauthorized Access');

        $this->model['supplier'] = new UKCRSOSupplier($this->db);
		$this->model['crso'] = new CRSO($this->db,array('relation'=>new Relation($this->db,$_SESSION['crso_relation_id'])));

		$this->suppliers = array();
		$q = $this->model['supplier']->selectOverview($this->model['crso']->relation->id, false);
		while($r = $q->fetch())
			$this->suppliers[$r->TYPE][] = array('approval_no'=>$r->APPROVAL_NO, 'name'=>$r->NAME, 'active'=>$r->ACTIVE);
	}
    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {
    	if(isset($_POST['process']))
        	if($_POST['process'] == 'save'){
 				/*$s_atf = $_POST['supplierAE'];
 				$pattern = '/^((WEE\/)[A-Z]{2}[0-9]{4}[A-Z]{2})(\/ATF)?$/';
 				foreach($s_atf as $v){
 					if(preg_match($pattern,$v['approval_no']) == 0)
 				}*/
        		$this->model['supplier']->setSuppliers($this->model['crso']->relation->id,
        										 		array(AE=>$_POST['supplierAE'], ATF=>$_POST['supplierATF']));
        	}
    }
}
/**
 * @package
 * @subpackage Interface
 * @since 14-12-2010
 * @copyright 2010 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceCrsoEASuppliersItem extends InterfaceItem
{

    /**
     * item[1595] = supplierATF[0][approval_no]
     * item[1596] = supplierATF[0][name]
     * item[1598] = supplierAE[0][approval_no]
     * item[1599] = supplierAE[0][name]
     */
    function getItemValue()
    {
    }

    /**
     * item[1605] = supplierAE[0][active]
     */
    function getActiveItemValue()
    {
        $this->options = array(array('text'=> 'Yes', 'value'=> 1), array('text'=> 'No', 'value'=> 0));
    }

	function getRowControlValues($type){
		if($type == AE){
  			$field_name = 'supplierAE';
  			$addb = 'rowControlButtonAddLine_554';
  			$remb = 'ifI_1600_RC_RB';
  		}
  		else if($type == ATF){
  				$field_name = 'supplierATF';
  				$addb = 'rowControlButtonAddLine_555';
  				$remb = 'ifI_1597_RC_RB';
  		}
  		else
  			return;
  		if (isset($_POST[$field_name]))
			$lines = $_POST[$field_name];
		else
		{
			if(!isset($this->if_obj->suppliers[$type]))
				return;
			$lines = array();
			$i = 0;
			foreach ($this->if_obj->suppliers[$type] as $v)
			{
				$fields = array('approval_no', 'name', 'active');

				foreach ($fields as $field) {
					$lines[$i][$field] = $v[$field];
				}

				$i++;
			}
		}

		if (!empty($lines))
		{
			$this->postscript = exportArrayToJS($lines, 'supplier_lines').'

				var intlinenumber = 0;
				supplier_lines.forEach(function(line, linenumber, lines)
				{
					line.forEach(function(item, itemname, a)
					{
						el = $$(\''.$field_name.'[\'+intlinenumber+\'][\'+itemname+\']\');
						el.value = item || "";

						// cannot remove suppliers
						b = $$(\''.$remb.'[\'+intlinenumber+\']\');
						b.style.display = "none";

						var span = el.parentNode.getElementsByTagName("span")[0];
						if (span) {

							var value = item;

							span.innerHTML = value;
						}

					});

					ifHandler.duplicateParentsLastRow(el, 1);
					intlinenumber++;
				});

				// remove last row
				el = $$(\''.$field_name.'[\'+intlinenumber+\'][approval_no]\');
				ifHandler.removeParentRow(el, false);
			';
		}
  }

    /**
     * item[1597] =
     */
    function getATFSupplier()
    {
    	$this->getRowControlValues(ATF);
    }

    /**
     * item[1600] =
     */
    function getAESupplier()
    {
    	$this->getRowControlValues(AE);
    }

    /**
     * item[1601] =
     */
    function getButtons()
    {
		$this->_BarButtons = 0;
    	$this->_addCustomButton($this->langIf->getText('Save'), 'button',
			array('onclick'=>'if(fb.validate($(\'interface_form\'))){ $(\'interface_form\').submit();}')
		);
    }

}

/**
 * CALLBACK[getItemValue]
 * item[1595] = {
 *     [handle] = Item: AATFApprovalNo
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 1
 *
 * item[1596] = {
 *     [handle] = Item: FacilityName
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 1
 *
 * item[1598] = {
 *     [handle] = Item: AEApprovalNo
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 1
 *
 * item[1599] = {
 *     [handle] = Item: OperatorName
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 1
 *
 * CALLBACK[getATFSupplier]
 * item[1597] = {
 *     [handle] = Item: ATFRC
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getAESupplier]
 * item[1600] = {
 *     [handle] = Item: AERC
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getButtons]
 * item[1601] = {
 *     [handle] = Item: ButtonBar
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 */
?>
