<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
require_once(IWARE.'IWCustomQueryFactory.php');
/**
 *
 * @package
 * @subpackage Interface
 * @since 05-01-2007
 * @copyright 2007 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceCustomQuery extends InterfaceFactory
{
	/**
     * interface[id] = 162
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceCustomQuery(&$db, &$db_app, &$langIf, $settings=array())
    {
        parent::InterfaceFactory($db, $db_app, $langIf);
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';
        $this->model['hidden'] = '';
        $this->model['save'] = true;

        if(isset($_REQUEST['report']['id']))
        {
        	require_once(ELC_LISTS.'CustomQuery/WEEECustomQueryDynamicQuery.php');
        	$this->model['hidden'] = '<input type="hidden" name="report[id]" value="'.$_REQUEST['report']['id'].'" />';
        	$settings['cq'] = new WEEECustomQueryDynamicQuery($_REQUEST['report']['id']);
        	$this->model['save'] = false;

        }
        elseif(isset($settings['cq']))
        {
		    $settings['cq'] = array_pop($settings['cq']);
	        if(is_string($settings['cq']))
	        {
	        	require_once(ELC_LISTS.'CustomQuery/'.$settings['cq'].'.php');
	        	$settings['cq'] = new $settings['cq']();
	        }
        }
        else
        	throw new InterfacePermissionException('Unauthorized access');
        $this->model['CustomQuery'] = new IWCustomQueryFactory(null,$settings['cq'],true);
        $this->model['CustomQuery']->loadSettings($this->db_app);
    }

    function getInterfaceHeader()
    {
    	$rv = '';

    	$cqfd = new IWCustomQueryFilterDisplay($this->model['CustomQuery']);
    	$rv .= '<script type="text/javascript"><!--
					'.$cqfd->getProperties().'
					var CQF = new IWCustomQueryFactory(properties);
					'.$cqfd->getSelectedFilters().'
				--></script>';
    	$rv .= $cqfd->display($this->model['hidden']).'<br /><br />';
    	$rv .= parent::getInterfaceHeader();
    	return $rv;
    }

    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {

    }
}
/**
 * @package
 * @subpackage Interface
 * @since 05-01-2007
 * @copyright 2007 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceCustomQueryItem extends InterfaceItem
{
    /**
     * item[1182] =
     */
    function getCustomQueryResult()
    {
    	$ds = $this->if_obj->model['CustomQuery']->getDataSet($this->db_app,true);
    	$ds1 = $this->if_obj->model['CustomQuery']->getRowCount($this->db_app);
		$this->postscript = '';
		$this->i = 0;

		$tables = '';

		$tables .= $this->if_obj->model['CustomQuery']->tfDescription();

		if(is_array($ds))
			foreach($ds as $label => $query)
			{
				$this->if_obj->model['CustomQuery']->resetInternals();
				$tables .= $this->displayTable($query,$label,$ds1[$label]);
			}
		else
			$tables .= $this->displayTable($ds,'',$ds1);
		$this->text = $tables;
    }

	protected function displayTable($query,$label,$max)
	{
		$cq = $this->if_obj->model['CustomQuery'];
		$cqfd = new IWCustomQueryFilterDisplay($cq);
		$gblabel = $cq->getGroupByLabel();
		//$numrows = $query->rows();
		$postscript = '';
		//if(!$numrows)
		//	return '';
		$table = $gblabel?'<div style="padding-bottom: 2px; margin-bottom: 5px; border-bottom: 1px solid #CCC;">
				<span style="font-size: 10pt; font-weight: bold; padding-right: 25px;">'.$gblabel.': '.$label.'</span> ('.$max.' matches)</div>':'';
		$table .= $gblabel?$cqfd->renderPaging($max,$label):$cqfd->renderPaging($max,'default');
		$tf = new TableFactory($query,$this->langIf);
		$tf->id = $cq->getHandle().$this->i++;
		if($tfProc = $cq->tfValueProcessor())
			$tf->setValueProcessor(TF_ALL,$tfProc);
		if($hiddenCols = $cq->tfHideColumns())
			$tf->hideColumns($hiddenCols);
		if($rowProc = $cq->tfRowProcessor())
			$tf->setRowProcessor($rowProc);
		if($columnModi = $cq->tfColumnModifier())
			$tf->columnModifier($columnModi);
		if($footerProc = $cq->tfFooterProcessor())
			$tf->setFooterProcessor($footerProc);

		if(isset($_POST['export']))
		{
			$label = $label?$label:'default';

			if($_POST['export']['group']==md5($label))
				$cq->exportQuery($tf,$_POST['export']['format']);
			return '';
		}
		elseif($cq->tfAllowSorting())
		{
			$tf->setTHProcessor(TF_ALL,array($cqfd,'tfHeaderProcessor'));
			$tbl = $tf->getXHTMLTable('Professional',2);
		}
		elseif($sort = $cq->tfSortingHat())
		{
			$tf->setSortingFunctions($sort);
			list($tbl,$postscript) = $tf->getXHTMLTable('Professional',2,'row',true);
		}
		else
    		$tbl = $tf->getXHTMLTable('Professional',2);
		$table .= $tbl;
		if(count($tf->ds) && $cq->getShowExportFunctions())
		{
			$label = $label?$label:'default';
			$table .= sprintf('<div style="width: %s; margin: -4px auto; text-align: center;"><strong style="font-weight: bold !important;">%s:</strong><br />
				<a href="javascript:CQF.doExport(\'csv\',\'%s\');">%s</a> | <a href="javascript:CQF.doExport(\'xml\',\'%s\');">%s</a></div>',
					'100%',
					$this->langIf->getText('Download in other formats'),
					md5($label),
					$this->langIf->getText('Comma-delimited Text'),
					md5($label),
					$this->langIf->getText('XML-format')
				);
		}
		$table .= '<br /><br />' . $cq->tfGetExtraInfo();
		$this->postscript .= $postscript;
		return $table;
	}

    /**
     * item[1183] =
     */
    function getButtons()
    {
    	$this->_BarButtons = 0;
    	$this->text = '<span class="warning" style="float: left;">Filters with a * are required</span>';
    }

}

/**
 * CALLBACK[getCustomQueryResult]
 * item[1182] = {
 *     [handle] = Item: CustomQueryResult
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getButtons]
 * item[1183] = {
 *     [handle] = Item: ButtonBar
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 */
?>
