<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
require_once(IWARE.'IWCustomQueryDynamicQuery.php');

define('BLOCK_DEFINE_QUERY',470);
define('BLOCK_BUTTON_BAR',473);
define('BLOCK_FILTER_OVERVIEW',471);
define('BLOCK_ADD_FILTER',472);
/**
 *
 * @package
 * @subpackage Interface
 * @since 06-09-2007
 * @copyright 2007 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceDynamicReport extends InterfaceFactory
{
    /**
     * interface[id] = 176
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceDynamicReport(&$db, &$db_app, &$langIf)
    {
        parent::InterfaceFactory($db, $db_app, $langIf);
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';

        $this->model['dr'] = new IWCustomQueryDynamicQuery($this->db_app);
        $this->model['drf'] = new IWCustomQueryDynamicQueryFilter($this->db_app);
        if(isset($_REQUEST['report']['id']))
        {
        	$this->hiddenFields[] = array('name'=>'report[id]','value'=>$_REQUEST['report']['id']);
        	$this->model['dr']->set($_REQUEST['report']['id']);

	        if(isset($_REQUEST['drf']['index']))
        		$this->model['drf']->set($_REQUEST['report']['id'],$_REQUEST['drf']['index']);

	        $this->script = "
				function loadDynamicReportFilter(filterIndex)
				{
					var params = new Array();
			        params['report'] = new Array();
					params['report']['id'] = getElByName('report[id]').value;
					params['drf'] = new Array();
					params['drf']['index'] = filterIndex;
			        params['interface_id'] = 176; // you MUST supply this
			        ifHandler.loadBlock( new Array(new String(".BLOCK_ADD_FILTER.")), params );
				}

				function deleteDynamicReport()
				{
					$$('process').value = 'delete';
					$('interface_form').submit();
				}

				function deleteFilter()
				{
					$$('process').value = 'deletefilter';
					$('interface_form').submit();
				}

				function saveFilter()
				{
					$$('process').value = 'savefilter';
					$('interface_form').submit();
				}

				function exportToPhp()
				{
					$$('process').value = 'exporttophp';
					$('interface_form').submit();
				}
			";
        }
    }

    function _filter($q)
    {
    	$rv = parent::_filter($q);

    	if(!$this->model['dr']->isComplete())
    	{
    		unset($rv[176][BLOCK_ADD_FILTER],$rv[176][BLOCK_FILTER_OVERVIEW]);
    	}

    	return $rv;
    }

    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {
        if(!isset($_POST['process']))
        	return;

        $string = isset($_POST['report']['id'])?'report[id]='.$_POST['report']['id']:'';
        if($_POST['process'] == 'save')
        {
        	$this->model['dr']->setProperties($_POST['dr']);
        	if(!empty($_POST['report']['id']))
        		$this->model['dr']->update();
        	else
        		$this->model['dr']->insert();
        }
        elseif($_POST['process'] == 'delete')
        {
        	$this->model['dr']->delete();
        	$string = '';
        }
        elseif($_POST['process'] == 'savefilter')
        {
        	$this->model['drf']->setProperties($_POST['drf']);
        	$this->model['drf']->dynamic_query = $this->model['dr'];
        	$this->model['drf']->required = isset($_POST['drf']['required'])?'Yes':'No';
        	$this->model['drf']->insert();
        	$string .= '&drf[index]='.$this->model['drf']->index;
        }
        elseif($_POST['process'] == 'deletefilter')
        {
        	$this->model['drf']->index = $_POST['drf']['index'];
        	$this->model['drf']->dynamic_query = $this->model['dr'];
        	$this->model['drf']->delete();
        }
        elseif($_POST['process'] == 'exporttophp')
        {
        	$this->model['dr']->exportToPhp();
        }
        header('Location: InterfaceDynamicReport.php?'.$string);
        exit();
    }
}
/**
 * @package
 * @subpackage Interface
 * @since 06-09-2007
 * @copyright 2007 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceDynamicReportItem extends InterfaceItem
{

    /**
     * item[1361] =
     */
    function getReportOverview()
    {
    	$ds = $this->if_obj->model['dr']->getOverview();
    	$tf = new TableFactory($ds,IWRegistry::registry('langIf'));
    	$tf->setValueProcessor(TF_ALL,array($this,'tfValueProcessorReportOverview'));
    	if($_SESSION['session_group_group_id']!=GROUP_SYSADMIN)
			$tf->hideColumn('DYNAMIC_REPORT_ID');
    	$this->text = $tf->getXHTMLTable('Professional',2);
    }

    function tfValueProcessorReportOverview($args)
    {
    	switch($args['head'])
    	{
    		case 'DYNAMIC_REPORT_ID':
    			return sprintf('<a href="InterfaceDynamicReport.php?report[id]=%s">%s</a>',
    				$args['row']['DYNAMIC_REPORT_ID'],
    				$args['value']);
    		break;
    		case 'Report':
    			return sprintf('<a href="InterfaceCustomQuery.php?report[id]=%s">%s</a>',
    				$args['row']['DYNAMIC_REPORT_ID'],
    				$args['value']);
    		break;
    	}
    	return $args['value'];
    }

    /**
     * item[1375] =
     */
    function getQueryHelp()
    {
    	$this->twoCols = true;

    }

    /**
     * item[1369] = dr[name]
     */
    function getQueryName()
    {
    	$this->properties['value'] = $this->if_obj->model['dr']->name;
    }

    /**
     * item[1362] = dr[query]
     */
    function getQueryDefinition()
    {
    	$this->value = $this->if_obj->model['dr']->query;
    	$this->properties['cols'] = 80;
    	$this->properties['rows'] = 12;
    }

    /**
     * item[1367] = dr[where]
     */
    function getWhere()
    {
    	$this->value = $this->if_obj->model['dr']->where;
    	$this->properties['cols'] = 80;
    	$this->properties['rows'] = 2;
    }

    /**
     * item[1368] = dr[description]
     */
    function getDescription()
    {
    	$this->value = $this->if_obj->model['dr']->description;
    	$this->properties['cols'] = 80;
    	$this->properties['rows'] = 2;
    }

    /**
     * item[1373] = dr[order_by]
     */
    function getOrderBy()
    {
    	$this->value = $this->if_obj->model['dr']->order_by;
    	$this->properties['cols'] = 80;
    	$this->properties['rows'] = 2;
    }

    /**
     * item[1374] = dr[group_by]
     */
    function getGroupBy()
    {
    	$this->value = $this->if_obj->model['dr']->group_by;
    	$this->properties['cols'] = 80;
    	$this->properties['rows'] = 2;
    }

    /**
     * item[1363] =
     */
    function getFilterOverview()
    {
    	if(!$this->if_obj->model['dr']->isComplete())
    		return;
    	$ds = $this->if_obj->model['dr']->getFilterOverview();
    	$tf = new TableFactory($ds,IWRegistry::registry('langIf'));
    	$tf->setValueProcessor(TF_ALL,array($this,'tfValueProcessorFilters'));
    	$this->text = $tf->getXHTMLTable('Professional',2);
    }

	function tfValueProcessorFilters($args)
	{
		switch($args['head'])
		{
			case 'FILTER_INDEX':
				return sprintf('<a href="javascript:loadDynamicReportFilter(%s);">%s</a>',
					$args['value'],
					$args['value']
					);
			break;
		}
		return $args['value'];
	}

    /**
     * item[1376] =
     */
    function getFilterHelp()
    {
    	$this->twoCols = true;
    	$this->text = "
			To define a new filter please note the following:<br /><br />
			<em>You have to select two fields, one called <strong>`VAL`</strong> and one called <strong>`DISP`</strong>.</em>
			<br /><br />
			";
    }

    /**
     * item[1364] = drf[displayname]
     */
    function getDisplayName()
    {
    	$this->properties['value'] = $this->if_obj->model['drf']->displayname;
       	if($this->if_obj->model['drf']->isComplete())
       		$this->hiddenFields[] = array('name'=>'drf[index]','value'=>$_REQUEST['drf']['index']);
    }

	/**
     * item[1370] = drf[fieldname]
     */
    function getFieldName()
    {
    	$this->properties['value'] = $this->if_obj->model['drf']->fieldname;
    }

    /**
     * item[1371] = drf[table_alias]
     */
    function getTableAlias()
    {
    	$this->properties['value'] = $this->if_obj->model['drf']->table_alias;
    }

    /**
     * item[1365] = drf[query]
     */
    function getFilterQuery()
    {
    	$this->value = $this->if_obj->model['drf']->query;
    	$this->properties['cols'] = 80;
    	$this->properties['rows'] = 8;
    }

    /**
     * item[1372] =
     */
    function getFilterButtons()
    {
    	$this->_BarButtons = BUTTON_DELETE;
    	$this->_ButtonOptions[BUTTON_DELETE]['onclick'] = 'deleteFilter();';
    	$this->_addCustomButton($this->langIf->getText('Save Filter'),'button',array('onclick'=>'saveFilter();'));

    	$this->twoCols = true;
    }

    /**
     * item[1366] =
     */
    function getButtons()
    {
    	$this->_BarButtons = BUTTON_SAVE;
    	if($this->if_obj->model['dr']->isComplete())
    		$this->_BarButtons += BUTTON_DELETE;
    	$this->_addCustomButton($this->langIf->getText('New Query'),'button',array('onclick'=>'document.location.href=\'InterfaceDynamicReport.php\''));

    	$this->_addCustomButton($this->langIf->getText('Export to .php'),'button',array('onclick'=>'exportToPhp();'));

    	$this->_ButtonOptions[BUTTON_DELETE]['onclick'] = 'deleteDynamicReport();';
    }

	function getRequiredField()
	{
		$this->properties['value'] = 'Yes';
		if($this->if_obj->model['drf']->required=='Yes')
			$this->properties['checked'] = 'checked';
	}
}

/**
 * CALLBACK[getReportOverview]
 * item[1361] = {
 *     [handle] = Item: ReportSelection
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getQueryDefinition]
 * item[1362] = {
 *     [handle] = Item: Query Definition
 *     [behaviour] = required
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 1
 *
 * CALLBACK[getFilterOverview]
 * item[1363] = {
 *     [handle] = Item: FilterOverview
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getFilterName]
 * item[1364] = {
 *     [handle] = Item: FilterName
 *     [behaviour] = alphanumeric
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getFilterQuery]
 * item[1365] = {
 *     [handle] = Item: FilterQuery
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getButtons]
 * item[1366] = {
 *     [handle] = Item: ButtonBar
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 */
?>