<?php
require_once(INTERFACE_OBJ."InterfaceFactory.php");
require_once(IWARE . 'group.php');
require_once(ELC_CLASSES.'RefundRequest.php');
require_once(ELC_CLASSES.'Participant.php');
require_once(ELC_CLASSES.'CRSO.php');
require_once(ELC_CLASSES.'CRSOParticipantProduct.php');
require_once(ELC_CLASSES.'Country.php');
require_once(ELC_CLASSES.'Product.php');
require_once(ELC_CLASSES.'RelationDocument.php');
require_once(ELC_CLASSES.'CRSOParticipantProduct.php');
require_once(ELC_CLASSES.'RelationUser.php');
require_once(ELC_CLASSES.'FormBehaviourPlugins.php');
require_once(ELC_CLASSES.'RefundRequestAdditionalDocument.php');
require_once(ELC_CLASSES.'ProofOfExportController.php');

define('BlockExportForm', 173);
define('BlockExportDocumentsExtra', 418);

/**
 * @package ELC
 * @subpackage Interface
 * @author
 * @copyright (2005) BaseSoft B.V.
 * @version $Id$
 */
class InterfaceExportForm extends InterfaceFactory
{
	var $unsetblocks = array();
	var $lastAdditionalDocumentIndex = 0;
	function InterfaceExportForm($db, $db_app, $langIf, $settings=array())
	{
		$this->FirstColWidth = 25;
		$this->delimiter = '<br />';
		parent::InterfaceFactory($db, $db_app, $langIf);
		isset($settings['block_callbacks']) && $this->block_callbacks = $settings['block_callbacks'];
		$this->model['emailtoimporterinteface'] = isset($settings['emailtoimporterinteface'])?true:false;
		$this->fb->clearValues();

		validatePOSTLength();

		$refund_id = isset($_REQUEST['refund']['id'])?(int)$_REQUEST['refund']['id']:null;
		$product_id = $_SESSION['selected_product_id'];
		$this->model['hide_cancel_button'] = false;



		/**
		 * some crsos can see refund details
		 */
 		if($_SESSION['session_group_group_id']==GROUP_CRSO) {


			$this->model['rr'] = new RefundRequest($this->db_app, $refund_id, true);
			$this->_hideInputs = true;
			$this->model['hide_cancel_button'] = true;

			$this->model['rr']->participant->relation->set();
			$this->model['rr']->participant->relation->address->set();
			$country = new Country($this->db_app, $this->model['rr']->participant->relation->address->country_id, true);
			$this->model['rr']->participant->relation->address->country = $country;

			// crso
			$this->model['rr']->crso->relation->set();
			$this->model['rr']->crso->relation->address->set();
			$country = new Country($this->db_app, $this->model['rr']->crso->relation->address->country_id, true);
			$this->model['country'] = $country;
			$this->model['rr']->crso->relation->address->country = $country;


			// check if rui has refund retails
        	$ru = new RelationUser($db_app);
        	if(!$ru->hasClearance(CRSOClearanceRefundDetails, $_SESSION['session_user_id'], $_SESSION['crso_relation_id']))
        		throw new InterfacePermissionException('['.$_SESSION['session_user_id'].'] tried to access crso admin interface without correct clearance: CRSOClearanceRefundDetails');

			// check if the current crso is linked to this poe
			if ($this->model['rr']->crso->relation->id != $_SESSION['crso_relation_id']) {
				throw new InterfacePermissionException('['.$_SESSION['session_user_id'].'] is not linked to this PoE');
			}


			return;

 		} else if($_SESSION['session_group_group_id']==GROUP_ACCOUNTANT) {

			$this->model['rr'] = new RefundRequest($this->db_app, $refund_id, true);
			$this->_hideInputs = true;
			$this->model['hide_cancel_button'] = true;

			$this->model['rr']->participant->relation->set();
			$this->model['rr']->participant->relation->address->set();
			$country = new Country($this->db_app, $this->model['rr']->participant->relation->address->country_id, true);
			$this->model['rr']->participant->relation->address->country = $country;

			// crso
			$this->model['rr']->crso->relation->set();
			$this->model['rr']->crso->relation->address->set();
			$country = new Country($this->db_app, $this->model['rr']->crso->relation->address->country_id, true);
			$this->model['country'] = $country;
			$this->model['rr']->crso->relation->address->country = $country;


			// check if any of the crsos is linked to the poe

			require_once(ELC_CLASSES.'AccountantCRSO.php');
			$crso = new AccountantCRSO($this->db);
			$q = $crso->getAccountantCRSOs($_SESSION['accountant_relation_id'], $_SESSION['selected_product_id']);
			while ($rs = $q->fetch()) {
				$crso_ids[] = (int) $rs->CRSO_RELATION_ID;
			}


			if (!in_array($this->model['rr']->crso->relation->id, $crso_ids)) {
				throw new InterfacePermissionException('['.$_SESSION['session_user_id'].'] is not linked to this PoE');
			}


			return;
		}


		/**
		 * Here we receive settings (from email2importer) which passes a fully
		 * checked rr object. So if we receive this we can just use this one and
		 * return.
		 */
		if(isset($settings['rr']))
		{
			$this->model['rr'] = $settings['rr'];

			$_SESSION['selected_product_id'] = $this->model['rr']->product->id;
			$this->_hideInputs = true;
			$this->model['hide_cancel_button'] = true;
			$this->model['country'] = $this->model['rr']->crso->relation->address->country;
			return;
		}

		if($refund_id)
		{
			$rr = new RefundRequest($this->db_app,$refund_id,true);
			if(!$rr->isComplete())
				throw new InterfacePermissionException('Incorrect Refund Request Provided');

			if(!isset($_SESSION['participant_ids'][$rr->participant->relation->id]))
				throw new InterfacePermissionException('Incorrect Participant Linked to Refund Request');
		}

		$cpp = new CRSOParticipantProduct($this->db_app, array('product' => new Product($this->db_app, $product_id)));

		$crso = new CRSO($this->db_app);
		$participant = new Participant($this->db_app);
		//see if we get passed a participant
		if(isset($_REQUEST['participant']['id']))
		{
			if(!$participant->set((int)$_REQUEST['participant']['id']))
				throw new IWException('Invalid Participant Id Provided');
		}
		elseif(!$participant->set((int)$_SESSION['selected_participant_id']))
			throw new IWException('Unexpected participant id in session');
		$cpp->participant = $participant;


		//see if we have a crso
		if(isset($_REQUEST['crso']['id']))
			if(!$crso->set((int)$_REQUEST['crso']['id']))
				throw new IWException('Invalid CRSO Id Provided');
		$cpp->crso = $crso;

		//create a poe controller
		$this->model['controller'] = ProofOfExportController::instance($cpp, new ELCUser($this->db_app, $_SESSION['session_user_id']), $this->fb);

		//lets get the rr object
		try
		{
			$this->model['rr'] = $this->model['controller']->getPoE(
				(isset($refund_id) ? (int)$refund_id : null),
				(isset($_REQUEST['refund']) ? $_REQUEST['refund'] : null),
				(isset($_REQUEST['line']) ? $_REQUEST['line'] : null),
				(isset($_REQUEST['refund']['export_country']['id']) ? $_REQUEST['refund']['export_country']['id'] : null),
				(isset($_REQUEST['additional_documents']) ? $_REQUEST['additional_documents'] : null)
			);
		}
		catch(ProofOfExportException $e)
   		{
   			info($e->getMessage());
   			throw new InterfacePermissionException($e->getMessage());
   		}
   		catch(WEEEAuthenticateException $e)
   		{
   			throw new InterfacePermissionException($e->getMessage());
   		}
   		catch(RefundRequestSettingsException $e)
   		{
   			header_message('elc_no_refund_settings');
   		}
   		catch(WEEEClearanceException $e)
                {
                    if($this->model['controller']->isGeneralManager())
                            $this->_hideInputs = true;
                }

        if ($refund_id)
	        {
			// workaround for date format
			$this->model['rr']->refund_export_date = $this->_formatDate($this->model['rr']->refund_export_date);
			// if the status is not editable, hide the inputs
			if ($this->model['rr']->status != REFUND_REQUEST_PENDING && $this->model['rr']->status != REFUND_REQUEST_REJECTED)
				$this->_hideInputs = true;
			//add the id for later
			$this->hiddenFields[] = array('name'=>'refund[id]', 'value'=>(int)$refund_id);
                }
                else
                {
                        $this->model['rr']->participant = $cpp->participant;
                        $this->model['rr']->crso = $cpp->crso;
                        $this->model['rr']->product = $cpp->product;
                }

		// Check rights
		switch($_SESSION['session_group_group_id'])
		{
			case GROUP_PARTICIPANT:
				break;
			default:
				throw new InterfacePermissionException('No Permission for non-Participant users');
		}

		//STUFF FOR INTERFACE DISPLAY
		// participant
		$this->model['rr']->participant->relation->set();
		$this->model['rr']->participant->relation->address->set();
		$country = new Country($this->db_app, $this->model['rr']->participant->relation->address->country_id, true);
		$this->model['rr']->participant->relation->address->country = $country;

		// crso
		$this->model['rr']->crso->relation->set();
		$this->model['rr']->crso->relation->address->set();
		$country = new Country($this->db_app, $this->model['rr']->crso->relation->address->country_id, true);
		$this->model['country'] = $country;
		$this->model['rr']->crso->relation->address->country = $country;

		//producer
                if (isset($_REQUEST['line']))
                {
                    if ($country->has(HasCreditViaProducer,$_SESSION['selected_product_id']))
                        $this->model['selectedProducerId'] = (int)$_REQUEST['producer']['id'];
                }
                else if($refund_id)
		    $this->model['selectedProducerId'] = $this->model['rr']->lines[1]->producer_relation->id;

		// page title
		setPageTitlePostfix("(".$this->model['rr']->participant->relation->name.")");

		// rr
		$this->model['cp'] = $cpp;

		//set behaviours
		$this->model['controller']->registerExportFormBehaviours();
	}

	function init($if_id)
	{
		parent::init($if_id);

		$this->hiddenFields[] = array('name'=>'crso[id]', 'value'=>$this->model['rr']->crso->relation->id);
		$this->hiddenFields[] = array('name'=>'participant[id]', 'value'=>$this->model['rr']->participant->relation->id);

		$this->lastAdditionalDocumentIndex = count($this->model['rr']->additional_documents);
		$this->script = "

			var lastAdditionalDocumentIndex = ".$this->lastAdditionalDocumentIndex.";
			function postProcessNewLine()
			{
				var tableElement = getTableElement(\$\$('additional_documents['+lastAdditionalDocumentIndex+'][invoice_no]'));
				var lastChild = tableElement.tBodies[0].lastChild.previousSibling;
				if(lastChild.nodeType!= 1)
					lastChild = lastChild.previousSibling;
				lastChild.style.display = '';
				lastAdditionalDocumentIndex++;
			}

			function getTableElement(tableMember)
			{
				if ( tableMember.nodeType != 1 || tableMember.tagName.toLowerCase() != 'table' )
					return getTableElement(tableMember.parentNode);
				return tableMember;
			}

						";
	}

	function _filter($q)
	{
		$rv = parent::_filter($q);
		$items = array (
			'eu' => array(
				880, // ImporterCompanyName
				867, // ImporterEmail
				869 // ImporterVAT
			),
			'non-eu' => array(
				877, // IdentificationNumber
				878, // Office
				868, // ExportDocument
				879 // ComodityCode
			)
		);

		if(!$this->model['country']->has(HasCreditViaProducer,$_SESSION['selected_product_id']))
			unset($rv[$this->id][271][1201],$rv[$this->id][271][1202]);

		if(!$this->model['country']->has(HasPoeAdditionalDocuments,$_SESSION['selected_product_id']))
			unset($rv[$this->id][BlockExportDocumentsExtra]);

		if (!is_object($this->model['rr']->export_country))
		{
			$tmp = array_merge($items['eu'], $items['non-eu']);

			foreach ($tmp as $item)
				unset($rv[$this->id][173][$item]);
			return $rv;
		}

		// This country requires UPLOAD of PoE documents for EU countries too.
		// DO this only AFTER previous loop, as we dont want to clutter the interface.
		if($this->model['country']->has(HasRequiredPoEDocumentUploadEU,$_SESSION['selected_product_id'])) {
			$items['non-eu'] = array(
				877, // IdentificationNumber
				878, // Office
				879 // ComodityCode
			);
		}

		$c = $this->model['rr']->export_country;
		$c->set();
		foreach ($items[($c->region_id != REGION_EU) ? 'eu' : 'non-eu' ] as $item)
			unset($rv[$this->id][BlockExportForm][$item]);

		foreach($this->unsetblocks as $blockId)
			unset($rv[$this->id][$blockId]);

		return $rv;
	}

    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {
    	$invalid = $this->langIf->getText('Please correct the form errors');
    	$noDocument = $this->langIf->getText('No Documents attached');
        if(isset($_POST['process']))
        {
        	if($_POST['process']=='save' || $_POST['process'] == 'save_and_next')
        	{
                        // see if allowed to modify by checking hideInputs
                        if ($this->_hideInputs)
                        {
                                info(sprintf('RefundRequest::processInput() - Not allowed to modify [%s]', $this->model['rr']->id ));
                                exit('You Dont Have Permission To View This Page');
                        }

				//document upload bullshit
        		$item = new InterfaceItem($this->db,$this->db_app,$this->langIf);

        		// see if document is uploaded, then make a relation document and save it
        		$document = $item->getDocument('refund[export_document]',868, true);

        		//additional documents
                        $additional_documents = array();
                        if(isset($_POST['additional_documents']))
                        {
                            foreach($_POST['additional_documents'] as $index => $posted_doc)
                            {
                                    $new_doc = false;
                                    if(empty($posted_doc['invoice_no']))//empty first lines, means no docs
                                            continue;
                                    if(isset($posted_doc['invoice_document']))
                                    {
                                            $new_doc = Document::createDocument($this->db_app);
                                                    $new_doc->set($posted_doc['invoice_document']);
                                    }
                                    $it = new InterfaceItem($this->db,$this->db_app,$this->langIf);
                                            $new_doc || $new_doc = $it->getDocument('additional_documents['.$index.'][invoice_document]', false);
                                    $add_doc = new RefundRequestAdditionalDocument($this->db_app);
                                    $add_doc->document = $new_doc;
                                    $add_doc->invoice_number = $posted_doc['invoice_no'];
                                    $add_doc->invoice_date = $this->_formatDate($posted_doc['invoice_date']);
                                    $additional_documents[] = $add_doc;
                            }
			}


			//plus make refund line objects
			$lines = $_POST['line'];
        		if ($this->model['country']->has(HasCreditViaProducer,$_SESSION['selected_product_id']))
        		{
        			foreach($lines as $lineindex => $line)
        				$lines[$lineindex]['producer_relation']['id'] = (int)$_POST['producer']['id'];
        		}

        		$rrLines = array();
        		foreach($lines as $line)
			    $rrLines[] = RefundRequestLine::fromInterfaceRefundLine($this->db_app, $line);

        		try
        		{
        			$country = new Country($this->db_app, $_REQUEST['refund']['export_country'], true);

        			if ($country->region_id == REGION_EU)
        			{
        				$this->model['controller']->proofOfExportEu(
        					isset($_REQUEST['refund']['id']) ? (int)$_REQUEST['refund']['id'] : null,
        					$rrLines,
        					$this->_formatDate($_REQUEST['refund']['refund_export_date']),
        					$country,
        					$_REQUEST['refund']['importer_email'],
        					$_REQUEST['refund']['importer_vat_no'],
        					$_REQUEST['refund']['importer_company_name'],
        					count($additional_documents) ? $additional_documents : null,
        					$document
        					);
        			}
        			else
        			{
        				$this->model['controller']->proofOfExportNonEu(
        					isset($_REQUEST['refund']['id']) ? (int)$_REQUEST['refund']['id'] : null,
        					$rrLines,
        					$this->_formatDate($_REQUEST['refund']['refund_export_date']),
        					$country,
        					isset($_REQUEST['refund']['identification_no']) ? $_REQUEST['refund']['identification_no'] : null,
        					isset($_REQUEST['refund']['office']) ? $_REQUEST['refund']['office'] : null,
        					isset($_REQUEST['refund']['commodity_code']) ? $_REQUEST['refund']['commodity_code'] : null,
        					$document,
        					count($additional_documents) ? $additional_documents : null
        					);
        			}
        		}
        		catch(FormBehaviourException $e)
                        {
                                // We caught a formbehaviour exception. That means it contains failures,
                                // add those to the Interface-FB so it will display the errors in JS
                                $this->fb->setFailures($e->getFailures());
                                $thrownException .= $invalid;

                                //stupid hack for date format
                                //$this->model['rr']->refund_export_date = $this->_formatDate($this->model['rr']->refund_export_date);
                                $this->init($this->id);
                                return;
                        }
                        catch (WEEEException $e)
                        {
                                $thrownException = $e->getMessage();

                                //stupid hack for date format
                                //$this->model['rr']->refund_export_date = $this->_formatDate($this->model['rr']->refund_export_date);
                                $this->init($this->id);
                                return;
                        }


                        log_elc_event(sprintf('Participant added/edited PoE [%s]', empty($_POST['refund']['id']) ? '' : $_POST['refund']['id']),
                            $_SESSION['session_user_id'], $_SESSION['selected_product_id'],
                            $this->model['rr']->crso->relation->id, $this->model['rr']->participant->relation->id
                        );


        		// Make a new registration or go to overview?
        		if ($_REQUEST['process'] == 'save_and_next')
        			header(sprintf('Location: InterfaceExportForm.php?crso[id]=%s&participant[id]=%s',
        				$this->model['rr']->crso->relation->id,
        				$this->model['rr']->participant->relation->id));
        		else
        			header('Location: InterfaceExportOverview.php');

        		die();
        	}
        	elseif($_POST['process']=='delete')
        	{
        		$this->model['rr']->delete();
        		header('Location: InterfaceExportOverview.php');
        		die();
        	}
        }


    }

	function _formatDate($date)
	{
		$pieces = explode('-',$date);
		if (sizeof($pieces) != 3)
			return '';
		debug('Refund export date: '.$pieces[2].'-'.$pieces[1].'-'.$pieces[0]);
		return $pieces[2].'-'.$pieces[1].'-'.$pieces[0];
	}

	/**
	 *
	 */
	function getInterfaceHeader()
	{
		// declare a function to fill brands
		$this->script .= "
			function fillBrands(selProducer)
			{
				participant_id = selProducer.value;

				var reg = /line\[(\d)\]\[producer_relation\]\[id\]/;
				line_index = selProducer.name.match(reg)[1];

				var params = new Array();
				params['crso_id'] = ".((int)$this->model['rr']->crso->relation->id).";
				params['participant_id'] = participant_id;
				jsbroker.call('getParticipantBrands', params, function(brands)
				{
					var sel = $$('line['+line_index+'][brand][id]');
					Select_ClearOptions(sel);

					brands.forEach(function(el, i, ar)
					{
						var opt = new Option(el, i);
						sel.options.add(opt);
					});
				});
			}

			function refillBrands(selProducer)
			{
				participant_id = selProducer.value;
				tbl = $('ifB_271');

				var rowCount = tbl.tBodies[0].rows.length;

				var params = new Array();
				params['crso_id'] = ".((int)$this->model['rr']->crso->relation->id).";
				params['participant_id'] = participant_id;

				jsbroker.call('getParticipantBrands', params, function(brands)
				{
					for(var i=0;i<rowCount;i++)
					{
						var sel = $$('line['+i+'][brand][id]');
						Select_ClearOptions(sel);

						brands.forEach(function(el, i, ar)
						{
							var opt = new Option(el, i);
							sel.options.add(opt);
						});
					}
				});
			}
		";

		// Make an ajax call to check the virtual stock.
		$this->script .= sprintf("
			function checkVirtualStock(el)
			{
				var line_index = el.name.match(/[(\d)]/)[0];

				var args = new Array();
				var producer_id = null;
				%s
				args['producer_id'] = producer_id;
				args['participant_id'] = %s;
				args['crso_id'] = %s;
				args['quantity'] = getQuantity(line_index);
				args['line_index'] = line_index;
				jsbroker.call('getVirtualStock',args,function(params){
					placeVirtualStock(params);
				});
			}

			function getQuantity(line_index)
			{
				%s
			}

			function placeVirtualStock(params)
			{
				var label = (params['status']=='success')?'%s':'%s';
				%s;
			}
			function addRow() {
				var ch_table = $('ifB_267').tBodies[0].rows[0].cells[0].firstChild;
				ifHandler.duplicateParentsLastRow(ch_table);
			}
			",
			($this->model['country']->has(HasRefundInternalVAT,$_SESSION['selected_product_id'])?"producer_id = \$\$('line['+line_index+'][producer_relation][id]').value;":''),
			$this->model['rr']->participant->relation->id,
			$this->model['rr']->crso->relation->id,
			($this->model['country']->has(HasRefundInternalVAT,$_SESSION['selected_product_id'])?
				"return \$\$('line['+line_index+'][quantity]').value;":
				"
				var quantity = 0;
				for(var i=0;i<100;i++){
					if(!\$\$('line['+i+'][quantity]'))
						break;
					quantity += \$\$('line['+i+'][quantity]').value
				}
				return quantity;"),
			$this->langIf->getText('sufficient vstock'),
			$this->langIf->getText('insufficient vstock'),
			($this->model['country']->has(HasRefundInternalVAT,$_SESSION['selected_product_id'])?
				"\$\$('line['+params['line_index']+'][img]').value=label;\$\$('line['+params['line_index']+'][img]').size=label.length;":
				"\$('total[img]').value = label;")
			);

		// now call parent so the script above is included
		$rv = parent::getInterfaceHeader();
		//$p = new RefundRequest($this->db_app);

		// and add a pretty table
		$rv .= '
			<table class="formHeader" width="100%">
				<tr>
					<td width="25%">'.$this->langIf->getText('DATE').'</td>
					<td width="25%"><strong style="font-size: 10pt !important">'.Form_Date::makePretty(date('Y-m-d')).'</strong></td>
					<td width="50%"></td>
				</tr>
				<tr>
					<td colspan="3"><br /></td>
				</tr>
				<tr>
					<td colspan="2">'.$this->model['rr']->participant->relation->name.'</td>
					<td>'.$this->model['rr']->crso->relation->name.'</td>
				</tr>
				<tr>
					<td colspan="2">'.$this->model['rr']->participant->relation->address->address_street_name.'</td>
					<td>'.$this->model['rr']->crso->relation->address->address_street_name.'</td>
				</tr>
				<tr>
					<td colspan="2">'.$this->model['rr']->participant->relation->address->city_name.', '.$this->model['rr']->participant->relation->address->country->name.'</td>
					<td>'.$this->model['rr']->crso->relation->address->city_name.', '.$this->model['country']->name.'</td>
				</tr>
				<tr>
					<td colspan="2"></td>
					<td>'.$this->model['rr']->crso->relation->address->address_zipcode.', '.$this->model['rr']->crso->relation->email.'</td>
				</tr>
				<tr>
					<td>'.$this->langIf->getText('VAT Number').'</td>
					<td>'.$this->model['rr']->participant->relation->vat_no.'</td>
					<td></td>
				</tr>
				<tr>
					<td>'.$this->langIf->getText('Bank Account Number').'</td>
					<td>'.$this->model['rr']->participant->relation->bank_account_number.'</td>
					<td></td>
				</tr>
			</table>
			<br />
			';
		require_once(ELC_CLASSES.'CRSOProduct.php');
		$cp = new CRSOProduct($this->db_app);
		$cp->set($this->model['rr']->crso->relation->id, $_SESSION['selected_product_id']);
		$rday = "<div style='text-align: right; margin-bottom:8px;'><span class='cut-off-date'>".$this->langIf->getText('Upcoming export date').
				": ".$cp->getNextCutOffDateRefund()."</span></div>";
		return $rv.$rday;
	}

	function getInterfaceFooter()
	{
		$rv = parent::getInterfaceFooter();
		$rv .= '** '.$this->langIf->getText('This is merely an indication');
		return $rv;
	}
}

class InterfaceExportFormItem extends InterfaceItem
{
	var $selectedProducerId = false;
    /**
     * item[866] = refund[export_country][id]
     */
    function getExportCountry()
    {
    	$county = new Country($this->db_app);
    	$county->fillInterfaceItem($this, ($this->if_obj->model['rr']->export_country?$this->if_obj->model['rr']->export_country->id:false));

		$this->script = "
			function getUrl(sel)
			{
				var url = '&interface_id=".$this->if_obj->id."&refund[export_country][id]='+sel.value;
				url += '&crso[id]=".$this->if_obj->model['rr']->crso->relation->id."';
				url += '&participant[id]=".$this->if_obj->model['rr']->participant->relation->id."';
				return url;
			}
		";
		$this->properties['onchange'] = "ifHandler.loadBlock([".BlockExportForm."], getUrl(this));";
    }

    /**
     * item[867] = refund[importer_email]
     */
    function getItemValue()
    {

    	foreach (array('importer_company_name', 'importer_vat_no', 'importer_email', 'identification_no', 'office', 'commodity_code') as $item)
    	{
    		if ($this->name == 'refund['.$item.']') {
    			$this->properties['value'] = $this->if_obj->model['rr']->$item;
    			return;
    		}
    	}

    	switch ($this->name)
    	{
    		case 'refund[refund_export_date]':
    			$this->properties['value'] = $this->if_obj->model['rr']->refund_export_date;
    		break;
    	}
    }

    /**
     * item[868] = refund[export_document]
     */
    function getExportDocument()
    {
    	if (is_object($this->if_obj->model['rr']->export_document))
    		$_REQUEST['Documents'][$this->id] = (int) $this->if_obj->model['rr']->export_document->id;
    }

	function getExportDetails()
	{
		$ds = $this->if_obj->model['rr']->getFormLines();

		require_once(IWARE.'TableFactoryColumnPlugin.php');
		$tf = new TableFactoryColumnPlugin(false,$this->langIf,$this->db,$this->db_app);
		$tf->setData($ds, 'tbRefundRequestLines',false,true);

		$c = $this->if_obj->model['country'];//new Country($this->db_app,$this->if_obj->model['rr']->crso->getCountry(),true);

		// Check which columns have to be hidden, for what country
		$hideCols = array('VIRTUAL_STOCK');

		if($this->if_obj->model['emailtoimporterinteface'])
			$hideCols[] = 'VIRTUAL_STOCK';
		if(!$c->has(HasDeclByCategory,$_SESSION['selected_product_id']))
			$hideCols[] = 'PRODUCT_CATEGORY';
		if(!$c->has(HasDeclByBrand,$_SESSION['selected_product_id']))
			$hideCols[] = 'BRAND';
		if(!$c->has(HasDeclOfWeight,$_SESSION['selected_product_id']))
			$hideCols[] = 'WEIGHT';
		if(!$c->has(HasDeclOfWeightWithDecimals,$_SESSION['selected_product_id']))
			$hideCols[] = 'WEIGHT_DEC';
		if(!$c->has(HasRefundInternalVAT,$_SESSION['selected_product_id']))
		{
			$hideCols[] = 'PRODUCER_RELATION_ID';
			$hideCols[] = 'VIRTUAL_STOCK';

		}
		if($c->has(HasCreditViaProducer,$_SESSION['selected_product_id']))
		{
			$hideCols[] = 'PRODUCER_RELATION_ID';
			$hideCols[] = 'PRODUCER_RELATION';
			$hideCols[] = 'VIRTUAL_STOCK';
		}

		$multiLine = (bool) (sizeof($hideCols));

		$tf->setTHProcessor('PRODUCER_RELATION', array($this, 'tfHeadProcessor'));

		if (!$this->if_obj->_hideInputs)
		{
			$tf->setValueProcessor(array('VIRTUAL_STOCK','PRODUCER_RELATION', 'PRODUCER_RELATION_VAT_NO', 'BRAND', 'WEIGHT', 'WEIGHT_DEC', 'PRODUCT_CATEGORY', 'QUANTITY', 'DELETE'),
				array($this, 'tfValueProcessor'));

			if ($multiLine)
				$this->text = '<div style="text-align: right; padding-top: 2px;">
					<input onclick="addRow();" type="button" value="'.
						$this->langIf->getText('Add Line').'" /></div>';
		}
		else
		{
			$tf->setValueProcessor(array('PRODUCER_RELATION', 'PRODUCER_RELATION_VAT_NO','BRAND','PRODUCT_CATEGORY'),
				array($this, 'tfValueProcessorNoInput'));
			$tf->setValueProcessor(array('QUANTITY'),
				array($this, 'tfValueProcessorQuantityNoDecimals'));
			$hideCols[] = 'DELETE';
			$this->text = '';
		}

		$tf->hideColumns($hideCols);
		$this->text = $tf->getXHTMLTable('Professional',2).$this->text;
	}

	function tfHeadProcessor($args)
	{
		if ($this->if_obj->model['country']->has(HasRefundInternalVAT,$_SESSION['selected_product_id']))
			$args['head'] = 'PRODUCER_RELATION';
		else
			$args['head'] = 'PRODUCER_RELATION_VAT_NO';
	}

	function tfValueProcessor($args)
	{
		$name = '';
		$c = $this->if_obj->model['country'];
		switch ($args['head'])
		{
			case 'PRODUCER_RELATION':
			case 'PRODUCER_RELATION_VAT_NO':
				// Check country settings of CRSO and show a select or textfield
				if ($c->has(HasRefundInternalVAT,$_SESSION['selected_product_id']))
				{
					$args['value'] = (array)$args['value'];

					$sel = new Form_Select('line['.$args['i'].'][producer_relation][id]');
					$sel->addOption('- '.$this->langIf->getText('Select Producer').' -', '');
					$sel->setBehaviour('required');

					$cp = new CRSOParticipantProduct($this->db_app);
					$q = $cp->getCRSOParticipants($this->if_obj->model['rr']->crso->relation->id,'q', PARTICIPANT_PRODUCER,$_SESSION['selected_product_id']);
					while($r = $q->fetch())
					{
						if($r->PARTICIPANT_RELATION_ID==$this->if_obj->model['rr']->participant->relation->id)
							continue;

						$name = (mb_strlen($r->PARTICIPANT_NAME)>35)?mb_substr($r->PARTICIPANT_NAME,0,35).'...':$r->PARTICIPANT_NAME;
						$sel->addOption($name, $r->PARTICIPANT_RELATION_ID, ($r->PARTICIPANT_RELATION_ID == (isset($args['value']['id'])?$args['value']['id']:false) ));
					}

					if ($c->has(HasDeclByBrand,$_SESSION['selected_product_id']))
						$sel->onchange("fillBrands(this);");
					return $sel->getHtml();
				}
				else
				{
					if(is_object($args['value']))
						$args['value']->set();
					$value = is_object($args['value']) ? $args['value']->vat_no : '';


					$txt = new Form_Text('line['.$args['i'].'][producer_vat_no]', $value);
					$txt->setBehaviour('required;vat');
					$txt->setClass('');
					return $txt->getHtml();
				}
			break;

			case 'QUANTITY':
				$name = 'line['.$args['i'].'][quantity]';
			case 'WEIGHT':
				$name || $name = 'line['.$args['i'].'][weight]';
				$txt = new Form_Text($name, $args['value']);
				$txt->setClass('');
				$txt->setBehaviour('required;integer');
				return $txt->getHtml();
			break;
			case 'WEIGHT_DEC':
				$name = 'line['.$args['i'].'][weight_dec]';
				$txt = new Form_Text($name, $args['value']);
				$txt->setClass('');
				$txt->setBehaviour('required;elc_declaration_weight_dec');
				return $txt->getHtml();
			break;
			case 'BRAND':
				require_once(ELC_CLASSES.'Brand.php');

				$sel = new Form_Select('line['.$args['i'].'][brand][id]');
				$sel->setBehaviour('required');

				if (isset($this->if_obj->model['rr']->participant->relation->id))
				{
					require_once(ELC_CLASSES.'ParticipantBrand.php');
					$pb = new ParticipantBrand($this->db_app);

					$args['row']['PRODUCER_RELATION'] = (array)$args['row']['PRODUCER_RELATION'];

					if (is_array($args['row']['PRODUCER_RELATION']) && isset($args['row']['PRODUCER_RELATION']['id']))
					{
						$producer_id = $args['row']['PRODUCER_RELATION']['id'];
						$q = $pb->getBrands($producer_id,
							$this->if_obj->model['rr']->crso->relation->id, $_SESSION['selected_product_id']);

						while ($row = $q->fetch())
							$sel->addOption($row->NAME, $row->BRAND_ID, $row->BRAND_ID == $args['value']);
					}
				}
				else
					$sel->addOption(' - ' . $this->langIf->getText('Select Producer').' - ', '');

				return $sel->getHtml();
			break;
			case 'VIRTUAL_STOCK':
				return '<input type="text" size="'.(mb_strlen($this->langIf->getText('insufficient vstock'))).'" class="noborder" disabled="disabled" onclick="return false;" name="line['.$args['i'].'][img]" value="'.$this->langIf->getText('insufficient vstock').'" /> **';
			break;
			case 'PRODUCT_CATEGORY':
				require_once(ELC_CLASSES.'ProductCategory.php');
				$pc = new ProductCategory($this->db_app);

				$sel = new Form_Select('line['.$args['i'].'][product_category][id]');
				$sel->setBehaviour('required');

				$date = currentDate();
				$year = $date->getYear();

				$q = $pc->selectOverview(array($_SESSION['selected_product_id']),$this->if_obj->model['rr']->crso->relation->id, $year);

				while($row=$q->fetch())
					$sel->addOption($row->CATEGORY_NAME, $row->PRODUCT_CATEGORY_ID, $row->PRODUCT_CATEGORY_ID == $args['value']);
				return $sel->getHtml();
			break;
			case 'DELETE':
				$btn = new Form_Button('', $this->langIf->getText('Delete'), 'button');
				$btn->onclick("ifHandler.removeParentRow(this.parentNode.parentNode);");
				$btn->setID('delete_button_'.$args['i']);
				return $btn->getHtml();
			break;
		}
	}

    function tfValueProcessorQuantityNoDecimals($args)
    {
    	$args['extra'] .= sprintf(' sort_val="%s" ', $args['value']);
    	return locale_nf($args['value'], 0);
    }

	function tfValueProcessorNoInput($args)
	{
		switch ($args['head'])
		{
			case 'PRODUCER_RELATION':
			case 'PRODUCER_RELATION_VAT_NO':

				if (!is_object($args['value']))
					return '';

				$c = $this->if_obj->model['rr']->crso->relation->address->country;
				if ($c->has(HasRefundInternalVAT,$_SESSION['selected_product_id']))
				{
					$rel = $args['value'];
					$rel->set();
					return sprintf('%s (%s)',$rel->name, $rel->vat_no);
				}
				else
					return $args['value']->vat_no;
			break;
			case 'BRAND':
				if(!is_numeric($args['value']))
					return '';
				require_once(ELC_CLASSES.'Brand.php');
				$b = new Brand(IWRegistry::registry('db'),$args['value'],true);
				return $b->name;
			break;
			case 'PRODUCT_CATEGORY':
				if(!is_numeric($args['value']))
					return '';
				require_once(ELC_CLASSES.'ProductCategory.php');
				$pc = new ProductCategory(IWRegistry::registry('db'),$args['value'],true);
				return $pc->name;
			break;
		}
	}

	function getButtons()
	{
		if(!$this->if_obj->model['country']->has(HasRefundInternalVAT,$_SESSION['selected_product_id']))
			$this->text = "<span id=\"total[img]\"></span>";
		if (!$this->if_obj->_hideInputs)
		{
	      	if(!$this->if_obj->model['rr']->id || !$this->if_obj->model['rr']->isDeletable())
	     	 	$this->_BarButtons = BUTTON_SAVE+BUTTON_CANCEL;

			$this->_addCustomButton($this->langIf->getText('Save and Next Registration'), 'submit',
				array('onclick'=>"$$('process').value='save_and_next';"));

			$this->_ButtonOptions[BUTTON_DELETE] = array('onclick'=>jsMessageBox(MSG_BOX_QUEST,
				$this->langIf->getText('Delete Warning'),
				$this->langIf->getText('Delete RefundRequest Confirmation'),
					"function(){\$\$('process').value='delete';\$('interface_form').submit();}"));
		}
		elseif($this->if_obj->model['hide_cancel_button'])
			$this->_BarButtons = 0;
		else
			$this->_BarButtons = BUTTON_CANCEL;

    	$this->_ButtonOptions[BUTTON_CANCEL] = array('onclick'=>"history.back();");
	}

	function getGlobalProducer()
	{
		$this->options = array(array('text'=>'- '.$this->langIf->getText('Select Producer').' -','value'=>''));

		$cp = new CRSOParticipantProduct($this->db_app);
		$q = $cp->getCRSOParticipants($this->if_obj->model['rr']->crso->relation->id,'q', PARTICIPANT_PRODUCER,$_SESSION['selected_product_id']);
		$selectedProducerId = isset($this->if_obj->model['selectedProducerId'])?$this->if_obj->model['selectedProducerId']:false;
		while($r = $q->fetch())
		{
			if($r->PARTICIPANT_RELATION_ID==$this->if_obj->model['rr']->participant->relation->id)
				continue;
			$name = (mb_strlen($r->PARTICIPANT_NAME)>35)?mb_substr($r->PARTICIPANT_NAME,0,35).'...':$r->PARTICIPANT_NAME;
			$this->options[] = array('text'=>$name,'value'=>$r->PARTICIPANT_RELATION_ID,'selected'=>($selectedProducerId==$r->PARTICIPANT_RELATION_ID?'selected':false));
		//	$sel->addOption($name, $r->PARTICIPANT_RELATION_ID, ($r->PARTICIPANT_RELATION_ID == (isset($args['value']['id'])?$args['value']['id']:false) ));
		}
		if ($this->if_obj->model['country']->has(HasDeclByBrand,$_SESSION['selected_product_id']))
			$this->properties['onchange'] = ("refillBrands(this);");
	}

	function get2colTxt()
	{
		$this->twoCols = true;
	}

	function getTextTwoCols()
	{
		$this->twoCols = true;
	}


	function getExportDocumentsExtra()
	{
		$ds = array_merge($this->if_obj->model['rr']->getAdditionalDocumentFormLines(),
		array(
				array(
			'INVOICE_NO' => '',
			'INVOICE_DATE' => '',
			'INVOICE_DOCUMENT' => '',
			'DELETE' => 'nodelete'
				)
			));

		$tf = new TableFactory($ds,$this->langIf);
		$tf->id = "additionalDocuments";
		$tf->setValueProcessor(array('INVOICE_NO'), array($this, 'tfGetAdditionalDocumentInvoiceNumber'));
		$tf->setValueProcessor(array('INVOICE_DATE'), array($this, 'tfGetAdditionalDocumentInvoiceDate'));
		$tf->setValueProcessor(array('INVOICE_DOCUMENT'), array($this, 'tfGetAdditionalDocument'));
		$tf->setValueProcessor(array('DELETE'), array($this, 'tfGetAdditionalDocumentDelete'));
		$tf->setRowProcessor(array($this,'tfRowProcessor'));
		$this->text = '<br /><span style="font-weight: bold;">* '.$this->langIf->getText('All fields are required for addtional documents').'</span><br /><br />'.$tf->getXHTMLTable('Professional',2).'<div style="text-align: right; padding-top: 2px;">
					<input onclick="ifHandler.duplicateParentsLastRow($(\'additionalDocuments\'));postProcessNewLine();" type="button" id="addLineAdditionalDocs" value="'.
						$this->langIf->getText('Add Line').'" /></div>';;

	}

	function tfGetAdditionalDocumentDelete($args)
	{
		$btn = new Form_Button('', $this->langIf->getText('Delete'), 'button');
		$btn->onclick("ifHandler.removeParentRow(this.parentNode.parentNode);");
		$btn->setID('delete_button_'.$args['i']);
		return $btn->getHtml();
	}

	function tfGetAdditionalDocument($args)
	{
		if($args['value'])
		{
			$name = $this->langIf->getText('Download');
			return sprintf('<input type="hidden" name="additional_documents['.$args['i'].'][invoice_document]" value="'.$args['value'].'" /><a href="/%sscripts/i-w/document/download.php?Document[id]=%d">%s</a>',SITE_PATH,$args['value'],$name);
		}
		return '<input type="file" behaviour="required(additional_documents['.$args['i'].'][invoice_date],true)" name="additional_documents['.$args['i'].'][invoice_document]" /><br /><div><a href="javascript:alert(\''.$this->langIf->getText("Each file to upload must be 500KB or lower in size. When scanning a document, please scan to a JPEG file, with as lower resolution as possible.").'\');">'.$this->langIf->getText('Max Filesize 500KB').'</a></div>';
	}

	function tfGetAdditionalDocumentInvoiceNumber($args)
	{
		return '<input type="text" behaviour="required(additional_documents['.$args['i'].'][invoice_document],true)" name="additional_documents['.$args['i'].'][invoice_no]" value="'.$args['value'].'" '.($args['row']['INVOICE_DOCUMENT'] ? 'readonly="true" class="disabled" ' : '').'/>';
	}

	function tfGetAdditionalDocumentInvoiceDate($args)
	{
		return '<input type="text" behaviour="required(additional_documents['.$args['i'].'][invoice_no],true);date" name="additional_documents['.$args['i'].'][invoice_date]" value="'.$args['value'].'" '.($args['row']['INVOICE_DOCUMENT'] ? 'readonly="true" class="disabled" ' : '').'/>';
	}

	function tfRowProcessor(&$params)
	{
		if($params['row']['DELETE'] === 'nodelete')
			$params['attr']['style'] = 'display:none;';
		return true;
	}
	/**#@-*/
}

/**
 * CALLBACK[getExportCountry]
 * item[866] = {
 *     [handle] = Item: ExportCountry
 *     [behaviour] = required
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * CALLBACK[getItemValue]
 * item[871] = {
 *     [handle] = Item: ExportDate
 *     [behaviour] = required;date
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * item[880] = {
 *     [handle] = Item: ImporterCompanyName
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * item[867] = {
 *     [handle] = Item: ImporterEmail
 *     [behaviour] = required;email
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * item[869] = {
 *     [handle] = Item: ImporterVAT
 *     [behaviour] = required;vat
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * item[877] = {
 *     [handle] = Item: IdentificationNumber
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * item[878] = {
 *     [handle] = Item: Office
 *     [behaviour] = required
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * item[879] = {
 *     [handle] = Item: ComodityCode
 *     [behaviour] = required
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * CALLBACK[getExportDocument]
 * item[868] = {
 *     [handle] = Item: ExportDocument
 *     [behaviour] = required
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * CALLBACK[getTextTwoCols]
 * item[882] = {
 *     [handle] = Item: Spacer1
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * item[881] = {
 *     [handle] = Item: Spacer2
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * item[872] = {
 *     [handle] = Item: Spacer3
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getExportDetails]
 * item[865] = {
 *     [handle] = Item: ExportDetails
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getButtons]
 * item[645] = {
 *     [handle] = Item: ButtonBar
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 */
