<?php
require_once(IWARE.'group.php');
require_once(IWARE.'InfoPerson.php');
require_once(ELC_CLASSES.'User.php');
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
/**
 *
 * @package ELC
 * @subpackage Interface
 * @author Nick Loeve <nick@basesoft.com>
 * @since 26-06-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceInfoPersonDetails extends InterfaceFactory
{
    /**
     * interface[id] = 129
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceInfoPersonDetails(&$db, &$db_app, &$langIf, $settings=array())
    {
        // for ajax call
		if (!$settings && (isset($_REQUEST['user']['id']) || isset($_REQUEST['person']['id'])) )
		{
			switch ($_SESSION['session_group_group_id'])
			{
				case GROUP_SYSADMIN:
					if(isset($_REQUEST['edit']) && $_REQUEST['edit'])
						$settings['_hideInputs'] = 'return false;';
					else
						$settings['_hideInputs'] = 'return true;';
					break;
				default:
					$settings['_hideInputs'] = 'return true;';
					break;
			}
			if(isset($_REQUEST['person']['id']))
				$settings['person'] = 'return new InfoPerson($this->db_app,'.((int)$_REQUEST['person']['id']).');';
			else
			{
				$user = new ELCUser($db_app, (int)$_REQUEST['user']['id']);
				$user->set();
				$settings['person'] = 'return new InfoPerson($this->db_app,'.$user->info_person->id.');';
			}
		}

        parent::InterfaceFactory($db, $db_app, $langIf, $settings);
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';
    }
    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {
        if(isset($_REQUEST['process']) && $_REQUEST['process'] == 'ajaxpersonsave')
		{
	        $invalid = $this->langIf->getText('Please correct the form errors');

	        $person = new InfoPerson($this->db_app, $this->person->id);
	        $person->set();
	        $person->setProperties($_REQUEST['person']);
	        $this->person =& $person;

	        if(!$this->fb->validate())
	        {
		        $this->init($this->id);
	        	return $thrownException .= $invalid;
	        }
	        $person->update();
	        $this->init($this->id);
		}
    }

    function getDynamicJSBehaviours()
	{
		return 'ifHandler.watchFormOnChange("interface_form", function(){ $("ajaxpersonstatus").innerHTML = "'.$this->langIf->getText('form details have been changed but are not saved...').'";}, ["ifI_962", "ifI_955", "ifI_956", "ifI_957", "ifI_958", "ifI_963", "ifI_959", "ifI_960", "ifI_961", "ifI_964"])';
	}
}
/**
 * @package ELC
 * @subpackage Interface
 * @author Nick Loeve <nick@basesoft.com>
 * @since 26-06-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceInfoPersonDetailsItem extends InterfaceItem
{

    /**
     * item[962] = person[title]
     * item[955] = person[first_name]
     * item[956] = person[middle_name]
     * item[957] = person[last_name]
     * item[959] = person[email]
     * item[960] = person[department]
     * item[961] = person[position]
     */
    function getItem()
    {
    	if(isset($this->if_obj->person) && !$this->if_obj->person->complete)
		{
			$this->if_obj->person->set();
		}
		$person = (array)$this->if_obj->person;
		$name = str_replace('[','[\'',str_replace(']','\']',$this->name));
		eval('$this->properties[\'value\'] = isset($'.$name.')?$'.$name.':\'\';');
    }

    /**
     * item[958] = person[telhouse]
     * item[963] = person[fax]
     */
    function getPhoneFaxValue()
    {
    	$person = (array)$this->if_obj->person;
		$name = str_replace('[','[\'',str_replace(']','\']',$this->name));
		eval('$this->properties[\'value\'] = isset($'.$name.')?$'.$name.':\'+\';');
    }

    /**
     * item[964] = person[language_id]
     */
    function getLanguageDropdown()
    {
    	require_once(IWARE.'nLanguage.php');
		$lang = new nLanguage($this->db_app);
		$q = $lang->get();
		$this->options = array(array('value'=>'','text'=>'- '.$this->langIf->getText('Select language').' -'));
		$i = 1;
		while($r = $q->fetch())
		{
			$this->options[$i] = array('text'=>$r->LANGUAGE,'value'=>$r->LANGUAGE_ID);
			if(isset($this->if_obj->person->language_id)&& $this->if_obj->person->language_id==$r->LANGUAGE_ID)
				$this->options[$i]['selected'] = 'selected';
			$i++;
		}
    }

    /**
     * item[967] =
     */
    function getButtons()
    {
    	$this->_BarButtons = 0;

    	switch ($_SESSION['session_group_group_id'])
		{
			case GROUP_SYSADMIN:
				if(!$this->if_obj->_hideInputs)
				{
			    	$this->_CustomButtons[] = '<div id="ajaxpersonstatus" style="color: red; display: inline;"></div>&nbsp;&nbsp;';
					$this->_addCustomButton($this->langIf->getText("View"), "button", array(
							'onclick' => "\$('interface_form_process').value = 'ajaxedit'; var params = []; params['ifId'] = ".$this->if_obj->id."; params['targetId'] = 'ifI_841_2'; jsbroker.callAndAttachRequestVars([['edit', '0'], ['user[id]', '".$_REQUEST['user']['id']."']], 'loadInterface', params, ifHandler.buildInterface);"
							));
					$this->_addCustomButton("Save", "button", array(
							'onclick' => " \$('ajaxpersonstatus').innerHTML = '".$this->langIf->getText('saving form details...')."'; \$('interface_form_process').value = 'ajaxpersonsave'; var params = []; params['ifId'] = ".$this->if_obj->id."; params['targetId'] = 'ifI_841_2'; jsbroker.callAndSubmitForm('interface_form', 'loadInterface', params, ifHandler.buildInterface);"
							));
					$this->_addCustomButton((int)$_REQUEST['user']['id'], "hidden", array(
							'name' => 'user[id]'
							));
					$this->_addCustomButton(1, "hidden", array(
							'name' => 'edit'
							));
				}
				else
				{
					$this->_addCustomButton($this->langIf->getText("Edit"), "button", array(
						'onclick' => "\$('interface_form_process').value = 'ajaxedit'; var params = []; params['ifId'] = ".$this->if_obj->id."; params['targetId'] = 'ifI_841_2'; jsbroker.callAndAttachRequestVars([['edit', '1'], ['user[id]', '".$_REQUEST['user']['id']."']], 'loadInterface', params, ifHandler.buildInterface);"
						));
				}
				break;
		}
    }

}

/**
 * CALLBACK[getItem]
 * item[962] = {
 *     [handle] = Item: InfoPersonTitle
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * item[955] = {
 *     [handle] = Item: InfoPersonFirstName
 *     [behaviour] = required
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * item[956] = {
 *     [handle] = Item: InfoPersonMiddleName
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * item[957] = {
 *     [handle] = Item: InfoPersonLastName
 *     [behaviour] = required
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * item[959] = {
 *     [handle] = Item: InfoPersonEmail
 *     [behaviour] = required;email
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * item[960] = {
 *     [handle] = Item: InfoPersonDepartment
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * item[961] = {
 *     [handle] = Item: InfoPersonPosition
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * CALLBACK[getPhoneFaxValue]
 * item[958] = {
 *     [handle] = Item: InfoPersonPhone
 *     [behaviour] = required;phone
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * item[963] = {
 *     [handle] = Item: InfoPersonFax
 *     [behaviour] = phone
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getLanguageDropdown]
 * item[964] = {
 *     [handle] = Item: InfoPersonLanguage
 *     [behaviour] = required
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getButtons]
 * item[967] = {
 *     [handle] = Item: InfoPersonButtons
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 */
?>