<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
require_once(ELC_CLASSES.'ELCListBuilder.php');
/**
 *
 * @package ELC
 * @subpackage Interface
 * @since 12-07-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceListGenerator extends InterfaceFactory
{
	var $listHandle = false;
    /**
     * interface[id] = 138
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceListGenerator(&$db, &$db_app, &$langIf, $settings = array())
    {
        parent::InterfaceFactory($db, $db_app, $langIf);
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';

        $this->model['list'] = new ELCListBuilder($this->db_app,$this->langIf);
        $list =& $this->model['list'];

       	if(isset($settings['lists']))
       	{
       		foreach($settings['lists'] as $handle)
       			$list->registerList($list->createList($handle));
       		if(sizeof($settings['lists'])==1)
       			$this->listHandle = array_pop($settings['lists']);
       		elseif(isset($_REQUEST['listHandle'])&&in_array($_REQUEST['listHandle'],$settings['lists']))
       			$this->listHandle = $_REQUEST['listHandle'];
       		elseif(isset($_REQUEST['listHandle'])&&!in_array($_REQUEST['listHandle'],$settings['lists']))
       			throw new InterfacePermissionException('Invalid List Specified');
       	}
       	elseif(isset($_REQUEST['listHandle']))
       	{
       		$this->listHandle = $_REQUEST['listHandle'];
       		$list->registerList($list->createList($this->listHandle));
       	}

       	$this->_process = isset($_REQUEST['process'])?$_REQUEST['process']:'';
       	if($this->listHandle)
       		$this->hiddenFields[] = array('name'=>'listHandle','value'=>$this->listHandle);


       	preg_match('/\/scripts\/(.*)\/(.*)\/(Interface[\w]+)\.php/', $_SERVER['REQUEST_URI'],$matches);

        $this->script = "
		    function _LoadFilters()
		    {
		        var params = new Array();
		        params['listHandle'] = getElByName('listHandle').value;
		        params['interface_id'] = 138; // you MUST supply this
		        ifHandler.loadBlock( new Array(332,333,334), params );
		    }

			function printPreview()
			{
				var nwin = new NewWindow(800, 600);
				nwin.setSource('".(isset($matches[0])?$matches[0]:'/')."');
				nwin.setName('winPrint');
				nwin.setScrollbars(true);
				var win = nwin.open(); // returns a window object

				var frm = $('interface_form');
				frm.target='winPrint';
				frm.process.value='print';
				frm.submit();

				// restore
				frm.target='_self';
				frm.process.value='save';
			}

			function exportView(type)
			{
				var frm = $('interface_form');
				frm.process.value='export'+type;
				frm.submit();
			}
			";
    }

	function _filter($q)
    {
    	$rv = parent::_filter($q);
    	if($this->_process=='print')
    	{
    		unset($rv[$this->id][331],$rv[$this->id][334]);
    		return $rv;
    	}

    	$lists = $this->model['list']->getLists();
  		if(sizeof($lists)<2)
    		unset($rv[$this->id][331]);
    	return $rv;
    }

    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {
        if(!isset($_POST['process']))
        	return;
        $type = false;
        switch($_POST['process'])
        {
        	case 'exportxml':
        		$type = LIST_BUTTON_XML_EXPORT;
        	case 'exportcsv':
        		$type || $type = LIST_BUTTON_CSV_EXPORT;
        		$l =& $this->model['list'];
        		$l->registerList($l->createList($this->listHandle,$type));
        		$list =& $l->getList($this->listHandle);
    			//$list->setShowType($type);
    			$rv = $list->showExport();
        	break;
        }
    }
}
/**
 * @package ELC
 * @subpackage Interface
 * @since 12-07-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceListGeneratorItem extends InterfaceItem
{

    /**
     * item[1004] = list[handle]
     */
    function getListSelection()
    {
    	$this->options = array(array('text'=>'-'.$this->langIf->getText('Select list').' -','value'=>''));
    	$lists = $this->if_obj->model['list']->getLists();
    	ksort($lists);
    	foreach($lists as $listTitle=>$bitBucket)
    		$this->options[] = array('text'=>$this->langIf->getText($listTitle),'value'=>$listTitle);
    	$this->properties['onchange'] = "_LoadFilters();";
    }

    /**
     * item[1005] =
     */
    function getFilterSelection()
    {
    	if(!$this->if_obj->listHandle)
    		return;
    	$list =& $this->if_obj->model['list']->getList($this->if_obj->listHandle);
    	$this->text = ($this->if_obj->_process == 'print')?$list->getSelectedFilters():$list->getFilters('_LoadOverview');
    	$this->script = "
			document._LoadOverview = function(params)
		    {
		        params = params?params:new Array();
				if(typeof document.getElementsByName('listHandle')[0] != 'undefined')
		        	params['listHandle'] = getElByName('listHandle').value;
			";

		$fields = $list->getFilterFields();
		foreach($fields as $fieldName)
		{
			$this->script .= "
				if(typeof document.getElementsByName('".$fieldName."')[0] != 'undefined')
					params['".$fieldName."'] = document.getElementsByName('".$fieldName."')[0].value;\n";
		}
		$this->script .= "
		        params['interface_id'] = 138; // you MUST supply this
		        ifHandler.loadBlock( new Array(332,333,334), params );
		    }
			";
    }

	/**
     * item[1006] =
     */
    function getOverview()
    {
    	if(!$this->if_obj->listHandle)
    		return;

    	$list =& $this->if_obj->model['list']->getList($this->if_obj->listHandle);
    	$ds = $list->getDataSet();
    	$sql = isset($ds->tmp_sql)?$ds->tmp_sql:'';
		$tf = new TableFactory($ds, $this->langIf);
		$tf->id = $list->handle; // Add the handle as ID for Xpath/Selenium purposes
		$tf->hideColumns($list->getHiddenColumns());
		$headerProc = $list->tfHeaderProc();
		foreach($headerProc as $callback=>$columns)
			$tf->setTHProcessor($columns, array($list,$callback));
		$processor = $list->getProcessColumns();
		foreach($processor as $callback=>$columns)
			$tf->setValueProcessor($columns,array($list,$callback));

		$tf->setEmptyText($list->setEmptyText());
		$tf->columnModifier($list->getColumnModifier());
		$tf->setFooterProcessor(array($list,'tfFooter'));
                $tf->collapseColumns($list->getCollapseColumns());
		if($sort = $list->tfSortingHat())
		{
			$tf->setSortingFunctions($sort);
			list($this->text,$this->postscript) = $tf->getXHTMLTable('Professional',2,'row',true);
		}
		else
    		$this->text = $tf->getXHTMLTable('Professional',2);
    	$this->postscript .= $list->getPostScript();
    	//$this->text .= $sql;
    }

    function getButtons()
    {
    	$this->_BarButtons = 0;

    	if($this->if_obj->listHandle)
    	{
	    	$list =& $this->if_obj->model['list']->getList($this->if_obj->listHandle);
	    	if($btn = $list->getButtons())
	    	{
	    		foreach($btn as $button => $options)
	    		{
					$this->_addCustomButton($this->langIf->getText($button),'button',$options);
	    		}
	    	}
	    	if($txt = $list->getButtonBarText())
	    	{
	    		$this->text = '<span style="text-align:right;">'.$txt.'</span>';
	    	}
    	}
    	$this->_addCustomButton($this->langIf->getText('Print Preview'),'button',array('onclick'=>'printPreview();'));

    }
}

/**
 * CALLBACK[getListSelection]
 * item[1004] = {
 *     [handle] = Item: SelectList
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getFilterSelection]
 * item[1005] = {
 *     [handle] = Item: FilterSelection
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 */
?>
