<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
/**
 *
 * @package ELC
 * @subpackage Interface
 * @author Nick Loeve <nick@basesoft.com>
 * @since 29-06-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceNotificationCompose extends InterfaceFactory
{
    /**
     * interface[id] = 133
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceNotificationCompose(&$db, &$db_app, &$langIf)
    {
        parent::InterfaceFactory($db, $db_app, $langIf);
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';

        if(!isset($_REQUEST['compose']['relation']))
        {
        	header('Location: InterfaceNotificationInbox.php?');
        	exit();
        }
        //get current users fullname
    	require_once(ELC_CLASSES.'User.php');
    	$this->user = new ELCUser($this->db_app);
    	$this->user->set($_SESSION['session_user_id']);

    	//check that we should be able to send to this relation
    	require_once(IWARE.'group.php'); // this defines group types
		$possibleRecipients = array('PARTICIPANT' => array(), 'CRSO' => array(), 'ACCOUNTANT' => array());
		switch($_SESSION['session_group_group_id'])
		{
			case GROUP_PARTICIPANT:
				//can send to noone
				break;
			case GROUP_CRSO:
				//can send to their participants
				$this->_getRecipientsForCRSO($possibleRecipients, $_SESSION['crso_relation_id']);
				break;
			case GROUP_ACCOUNTANT:
				//can send to their CRSO's and participants
				$this->_getRecipientsForAccountant($possibleRecipients, $_SESSION['accountant_relation_id']);
				break;
			case GROUP_SYSADMIN:
				//can send to everyone
				$this->_getRecipientsForSysadmin($possibleRecipients);
				break;
		}

		//get the relation name we are sending to
    	require_once(ELC_CLASSES.'Relation.php');
    	$this->rel = new Relation($this->db_app);

		$check = false;
		$values = array();
		if($_REQUEST['compose']['relation'] == 'allp')
			foreach($possibleRecipients['PARTICIPANT'] as $ids)
				$values[] = $ids['id'];
		else
		if($_REQUEST['compose']['relation'] == 'allc')
			foreach($possibleRecipients['CRSO'] as $ids)
				$values[] = $ids['id'];
		else
		if($_REQUEST['compose']['relation'] == 'allo')
			foreach($possibleRecipients['ACCOUNTANT'] as $ids)
				$values[] = $ids['id'];
		else
		if($_REQUEST['compose']['relation'] == 'everybody')
		{
			foreach($possibleRecipients['ACCOUNTANT'] as $ids)
				$values[] = $ids['id'];
			foreach($possibleRecipients['CRSO'] as $ids)
				$values[] = $ids['id'];
			foreach($possibleRecipients['PARTICIPANT'] as $ids)
				$values[] = $ids['id'];
		}
		else
			$check = true;

		if(!$check)
			$_REQUEST['compose']['relation'] = implode(";",$values);
		else
		{
			$this->rel->set((int)$_REQUEST['compose']['relation']);
			if(!count($possibleRecipients) ||
					(false === array_search(array('name' => $this->rel->name, 'id' => $this->rel->id), $possibleRecipients['PARTICIPANT']) &&
				 	 false === array_search(array('name' => $this->rel->name, 'id' => $this->rel->id), $possibleRecipients['CRSO']) &&
					 false === array_search(array('name' => $this->rel->name, 'id' => $this->rel->id), $possibleRecipients['ACCOUNTANT'])))
			{
				header('Location: InterfaceNotificationInbox.php?');
				exit();
			}
		}
		$this->hiddenFields[] = array('name' => 'compose[relation]', 'value' => $_REQUEST['compose']['relation']);
		if(isset($_REQUEST['all_part']) && ($_SESSION['session_group_group_id']==GROUP_ACCOUNTANT ||
					$_SESSION['session_group_group_id']==GROUP_SYSADMIN))
			$this->hiddenFields[] = array('name' => 'all_part', 'value' => $_REQUEST['all_part']);
		if(isset($_REQUEST['all_crso']) && $_SESSION['session_group_group_id']==GROUP_SYSADMIN)
			$this->hiddenFields[] = array('name' => 'all_crso', 'value' => $_REQUEST['all_crso']);
    }
    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {
    	$notSendingEmptyMessage = $this->langIf->getText('Cannot sent an empty message');
        if(isset($_REQUEST['process']) && $_REQUEST['process'] == 'save')
    	{
    		if(empty($_REQUEST['compose']['message']))
    			return $thrownException .= $notSendingEmptyMessage;
    		$invalid = $this->langIf->getText('Please correct the form errors');
    		if(!$this->fb->validate())
    			return $thrownException .= $invalid;

    		require_once(ELC_CLASSES.'Notification.php');
			$message = array('subject'=> $_REQUEST['compose']['subject'],
					'user'=> new ELCUser($this->db_app, $_SESSION['session_user_id']),
					'message'=> $_REQUEST['compose']['message'],
					'product'=> new Product($this->db_app, $_SESSION['selected_product_id'])
				);

			if(isset($_REQUEST['compose']['sender']) && $_REQUEST['compose']['sender'] != 0)
					$message['sender'] = new Relation($this->db_app, (int)$_REQUEST['compose']['sender']);

			if($_SESSION['session_group_group_id'] == GROUP_SYSADMIN
			   && isset($_REQUEST['all_part']) && isset($_REQUEST['all_crso'])
			   && ($_REQUEST['all_part'] == "true" || $_REQUEST['all_crso'] == "true"))
			{
				$sql = "SELECT RELATION_ID FROM TBL_ACCOUNTANT WHERE RELATION_ID = ?";
				$q = $this->db->query($sql);
				$q->bind_values($_REQUEST['compose']['relation']);
				$q->execute();
				$rr = $q->fetchAll();
				if(count($rr) == 0)
				{
					unset($possibleRecipients);
					$this->_getRecipientsForCRSO($possibleRecipients, (int)$_REQUEST['compose']['relation']);
					if(!$possibleRecipients)
    				{
						header('Location: InterfaceNotificationInbox.php?');
						exit();
					}
					$ids = array();
					foreach($possibleRecipients['PARTICIPANT'] as $k)
						$ids[] = $k['id'];
					$_REQUEST['compose']['relation'] = implode(";",$ids);
				}
				else
				{
					unset($possibleRecipients);
					$this->_getRecipientsForAccountant($possibleRecipients, (int)$_REQUEST['compose']['relation']);
					if(!$possibleRecipients)
    				{
						header('Location: InterfaceNotificationInbox.php?');
						exit();
					}
					$ids = array();
					if($_REQUEST['all_part'] == "true")
						foreach($possibleRecipients['PARTICIPANT'] as $k)
							$ids[] = $k['id'];
					if($_REQUEST['all_crso'] == "true")
						foreach($possibleRecipients['CRSO'] as $k)
							$ids[] = $k['id'];
					$_REQUEST['compose']['relation'] = implode(";",$ids);
				}
			}
			$rels = explode(";",$_REQUEST['compose']['relation']);
			$recs = array();
			foreach($rels as $rel)
				$recs[] = array('recipient'=> new Relation($this->db_app, (int)$rel));
			Notification::send(
				$this->db_app,
				$message,
				$recs
				);

			//redirect to inbox
			header('Location: InterfaceNotificationInbox.php?notification_sent=1');
			exit();
    	}
    }

    function _getRecipientsForCRSO(&$possibleRecipients, $cId)
	{
		require_once(ELC_CLASSES.'CRSOParticipantProduct.php');
		$cp = new CRSOParticipantProduct($this->db_app);
		$q = $cp->getCRSOParticipants($cId, 'q', false, $_SESSION['selected_product_id']);
		while($r = $q->fetch())
		{
			$possibleRecipients['PARTICIPANT'][] = array('name' => $r->{'PARTICIPANT_NAME'}, 'id' => $r->{'PARTICIPANT_RELATION_ID'});
		}
	}

	function _getRecipientsForAccountant(&$possibleRecipients, $accountant_id)
	{
		require_once(ELC_CLASSES.'AccountantCRSO.php');
		$ac = new AccountantCRSO($this->db_app);
		$q = $ac->getAccountantCRSOs($accountant_id);
		while($r = $q->fetch())
		{
			if($_SESSION['session_group_group_id'] == GROUP_SYSADMIN)
				$this->_getRecipientsForCRSO($possibleRecipients, $r->CRSO_RELATION_ID);
			$possibleRecipients['CRSO'][] = array('name' => $r->NAME, 'id' => $r->CRSO_RELATION_ID);
		}
	}

	function _getRecipientsForSysadmin(&$possibleRecipients)
	{
		$sql = "SELECT A.RELATION_ID, R.NAME FROM TBL_ACCOUNTANT A
				INNER JOIN TBL_RELATION as R
					ON A.RELATION_ID = R.RELATION_ID";
		$q = $this->db->query($sql);
		$q->execute();

		while($r = $q->fetch())
		{
			$this->_getRecipientsForAccountant($possibleRecipients, $r->RELATION_ID);
			$possibleRecipients['ACCOUNTANT'][] = array('name' => $r->NAME, 'id' => $r->RELATION_ID);
		}
	}
}
/**
 * @package ELC
 * @subpackage Interface
 * @since 29-06-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceNotificationComposeItem extends InterfaceItem
{

    /**
     * item[977] = compose[subject]
     */
    function getSubject()
    {
    	$this->properties['size'] = 100;
    	$this->value = isset($_REQUEST['compose']['subject']) ? $_REQUEST['compose']['subject'] : '';
    }

    /**
     * item[978] = compose[message]
     */
    function getMessage()
    {
    	$this->twoCols = true;
    	$this->properties['style'] = 'width: 100%; height: 200px;';
		$this->is_tiny_mce = true;
		$this->tiny_mce_settings['theme_advanced_buttons1'] = "bold,italic,underline,separator,bullist,numlist,separator,undo,redo,link,unlink";
		$this->tiny_mce_settings['theme_advanced_buttons2'] = '';
		$this->tiny_mce_settings['theme_advanced_buttons3'] = '';
		$this->value = isset($_REQUEST['compose']['message']) ? $_REQUEST['compose']['message'] : '';
    }

    /**
     * item[979] =
     */
    function getButtons()
    {
    	$this->twoCols = true;
    	$this->_BarButtons = 0;
    	$sel = new Form_Select('compose[sender]');
		$sel->addOption($this->langIf->getText('Yourself'), '0');
		foreach($_SESSION['session_user_relations'] as $relation)
			$sel->addOption($relation['name'], $relation['id']);
		isset($_REQUEST['compose']['sender']) && $sel->setSelectedValue((int)$_REQUEST['compose']['sender']);
		$this->_CustomButtons[] = $this->langIf->getText('Send as').': '.$sel->getHtml().'&nbsp;';
    	$this->_addCustomButton($this->langIf->getText('Send'));
    }

}

/**
 * CALLBACK[getSubject]
 * item[977] = {
 *     [handle] = Item: NotificationComposeSubject
 *     [behaviour] = required
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getMessage]
 * item[978] = {
 *     [handle] = Item: NotificationComposeMessage
 *     [behaviour] = required
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 1
 *
 * CALLBACK[getButtons]
 * item[979] = {
 *     [handle] = Item: NotificationComposeButtons
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 */
?>
