<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
require_once(ELC_CLASSES.'Participant.php');
require_once(ELC_CLASSES.'CRSOParticipantProduct.php');
require_once(ELC_CLASSES.'Brand.php');
require_once(ELC_CLASSES.'ParticipantBrand.php');
/**
 *
 * @package ELC
 * @subpackage Interface
 * @since 12-07-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceParticipantBrandOverview extends InterfaceFactory
{
    /**
     * interface[id] = 137
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceParticipantBrandOverview(&$db, &$db_app, &$langIf)
    {
        parent::InterfaceFactory($db, $db_app, $langIf);
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';

        $this->script = "
			function _LoadOverview()
		    {
		        var params = new Array();
		        params['brand_id'] = getElByName('brand[id]').value;
		        params['participant_id'] = getElByName('participant[id]').value;
		        params['interface_id'] = 137; // you MUST supply this
		        ifHandler.loadBlock( new Array(new String('330')), params );
		    }
		";
    }
    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {

    }
}
/**
 * @package ELC
 * @subpackage Interface
 * @since 12-07-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceParticipantBrandOverviewItem extends InterfaceItem
{

    /**
     * item[1001] = participant[id]
     */
    function getParticipantSelect()
    {
    	$this->options = array(array('text'=>'- '.$this->langIf->getText('Select Participant').' -','value'=>''));
    	$cp = new CRSOParticipantProduct($this->db_app);
    	$q = $cp->getCRSOParticipants($_SESSION['crso_relation_id'],'q',false,$_SESSION['selected_product_id']);
    	while($r = $q->fetch())
    		$this->options[] = array('text'=>$r->PARTICIPANT_NAME,'value'=>$r->PARTICIPANT_RELATION_ID);
    	 $this->properties['onchange'] = "_LoadOverview();";
    }

    /**
     * item[1002] = brand[id]
     */
    function getBrandSelect()
    {
    	$this->options = array(array('text'=>'- '.$this->langIf->getText('Select Brand').' -','value'=>''));
    	$brand = new Brand($this->db_app);
    	$q = $brand->getByCRSO($_SESSION['crso_relation_id']);
    	while($r = $q->fetch())
    		$this->options[] = array('text'=>$r->NAME,'value'=>$r->BRAND_ID);
    	 $this->properties['onchange'] = "_LoadOverview();";
    }

    /**
     * item[1003] =
     */
    function getBrandOverview()
    {
    	require_once(IWARE.'TableFactoryColumnPlugin.php');
    	$part = isset($_REQUEST['participant_id'])?(int)$_REQUEST['participant_id']:false;
    	$brand = isset($_REQUEST['brand_id'])?(int)$_REQUEST['brand_id']:false;

    	$pb = new ParticipantBrand($this->db_app);

    	$ds = $pb->selectOverview($_SESSION['crso_relation_id'],$part,$brand);
    	$tf = new TableFactoryColumnPlugin(false,$this->langIf,$this->db,$this->db_app);
		$tf->setData($ds, 'ParticipantBrandOverview',false,true);

		//$help = ($this->parent->title != '') ? getHelp($this->langIf, $this->parent->title, array('title'=>$this->parent->title, 'top'=>'0px')) : '';
		//$tf->setCaption($help.'<img src="/'.SITE_PATH.'images/block_arrow.png" /> '.$this->langIf->getText('Participant Brand Overview'), false);

		$tf->collapseColumns(array('PARTICIPANT_NAME','VAT_NO'));
		$this->text = $tf->getXHTMLTable('Professional',2);
    }

}

/**
 * CALLBACK[getParticipantSelect]
 * item[1001] = {
 *     [handle] = Item: ParticipantSelect
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * CALLBACK[getBrandSelect]
 * item[1002] = {
 *     [handle] = Item: BrandSelect
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getBrandOverview]
 * item[1003] = {
 *     [handle] = Item: BrandOverview
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 */
?>
