<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
require_once(ELC_CLASSES.'CRSO.php');
require_once(ELC_CLASSES.'Participant.php');
/**
 *
 * @package ELC
 * @subpackage Interface
 * @author Nick Loeve <nick@basesoft.com>
 * @since 28-06-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceProvisionalDeclarationDetails extends InterfaceFactory
{
    /**
     * interface[id] = 130
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceProvisionalDeclarationDetails(&$db, &$db_app, &$langIf, $settings=array())
    {
        // for ajax call
		if (!$settings && isset($_REQUEST['participant']['id']) && isset($_REQUEST['crso']['id']))
		{
			$settings['crso'] = 'return new CRSO($this->db_app,array(\'relation\'=> new Relation($this->db_app,'.$_REQUEST['crso']['id'].')));';
			$settings['participant'] = 'return new Participant($this->db_app,array(\'relation\'=> new Relation($this->db_app,'.$_REQUEST['participant']['id'].')));';
		}
        parent::InterfaceFactory($db, $db_app, $langIf, $settings);
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';
    }
    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {

    }
}
/**
 * @package ELC
 * @subpackage Interface
 * @author Nick Loeve <nick@basesoft.com>
 * @since 28-06-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceProvisionalDeclarationDetailsItem extends InterfaceItem
{

   /**
     * item[970] =
     */
    function getProvDecYear()
    {
    	$date = currentDate();
    	$year = isset($_REQUEST['year']) ? (int)$_REQUEST['year'] : (int)$date->getYear();

    	if(!$this->if_obj->crso->complete)
    	{
    		$this->if_obj->crso->set();
    		$this->if_obj->crso->relation->set();
    		$this->if_obj->participant->set();
    		$this->if_obj->participant->relation->set();
    	}

    	$thisYear = (int)$date->getYear();
    	$this->text = 'Change Year: ';
    	$sel = new Form_Select('year');
    	for($i = $thisYear - 2; $i < ($thisYear + 3); $i++)
    		$sel->addOption($i);
    	$sel->setSelectedValue($year);
    	$sel->onChange("\$('ajaxstatus').innerHTML = '".$this->langIf->getText("Loading...")."'; params = []; params['targetId'] = 'ifI_841'; ifHandler.loadInterface(130, params, [['year', this.options[this.selectedIndex].value],['crso[id]', '".$this->if_obj->crso->relation->id."'],['participant[id]', '".$this->if_obj->participant->relation->id."']]);");
    	$this->text .= $sel->getHtml().'&nbsp;&nbsp;<div id="ajaxstatus" style="display: inline; color: red"></div>';
    }


    /**
     * item[969] =
     */
    function getProvDecDetails()
    {
    	$date = currentDate();
    	$year = isset($_REQUEST['year']) ? (int)$_REQUEST['year'] : (int)$date->getYear();

    	$this->width = '100%';
    	if(!$this->if_obj->crso->complete)
    	{
    		$this->if_obj->crso->set();
    		$this->if_obj->crso->relation->set();
    		$this->if_obj->participant->set();
    		$this->if_obj->participant->relation->set();
    	}

    	require_once(ELC_CLASSES.'Country.php');
		require_once(ELC_CLASSES.'ProvisionalDeclaration.php');
		$country = new Country($this->db_app);
		$country->set($this->if_obj->crso->getCountry());

    	$ds = array();
		$prov = new ProvisionalDeclaration($this->db_app);
		$isAggregate = false;


		if ($country->settings & HasProvisionalPerMonth)
		{
			$prov->set(
						$this->if_obj->crso->relation->id,
						$this->if_obj->participant->relation->id,
						$year,
						NULL,
						$_SESSION['selected_product_id']);
			$lines = $prov->getLines();
		}
		else
		{
			$isAggregate = true;
			$lines =& $prov->getAggregateLinesByYear(
						$this->if_obj->crso->relation->id,
						$this->if_obj->participant->relation->id,
						$year,
						NULL,
						$_SESSION['selected_product_id']);
		}

		foreach($lines as $i => $content)
		{
			if(!$isAggregate)
				$ds[$i]['MONTH'] = $content->month;
			if($country->has(HasDeclByCategory,$_SESSION['selected_product_id']))
			{
				$content->product_category->set();
				$ds[$i]['PRODUCT_CATEGORY'] = $content->product_category->name;
			}
			if($country->has(HasDeclByBrand,$_SESSION['selected_product_id']))
			{
				$content->brand->set();
				$ds[$i]['BRAND'] = $content->brand->name;
			}
			if($country->has(HasDeclarationDimension,$_SESSION['selected_product_id']))
			{
				$content->dimension->set();
				$ds[$i]['CPD_ID'] = $content->dimension->name;
			}
			$ds[$i]['QUANTITY'] = $content->quantity;
			if($country->has(HasDeclOfWeightWithDecimals,$_SESSION['selected_product_id']))
				$ds[$i]['WEIGHT_DEC'] = $content->weight_dec;
			if($country->has(HasDeclOfWeight,$_SESSION['selected_product_id']))
				$ds[$i]['WEIGHT'] = $content->weight;
		}


		$tf = new TableFactory($ds,$this->langIf);
		$tf->id = "ProvisionalDeclarationDetails";
		$tf->setEmptyText($this->langIf->getText('No declaration lines found'));
		$tf->setCaption($this->langIf->getText('Details for {YEAR}', null, array('YEAR' => $year)), false);
		$tf->setValueProcessor(array('QUANTITY','WEIGHT','WEIGHT_DEC', 'MONTH'), array($this, 'tfValueProcessor'));
		$tf->setTHProcessor(array('QUANTITY','WEIGHT', 'WEIGHT_DEC'), array($this,'tfTHProcessor'));
		$tf->columnModifier(array('QUANTITY'=>'style="text-align:right;"','WEIGHT'=>'style="text-align:right;"','WEIGHT_DEC'=>'style="text-align:right;"'));

		$tf->setSortingFunctions(array(
			'PRODUCT_CATEGORY'=>"'String'",
			'BRAND'=>"'String'",
			'WEIGHT'=>"'SortVal'",
			'WEIGHT_DEC'=>"'SortVal'",
			'QUANTITY'=>"'SortVal'",
			'MONTH'=>"'SortVal'"
			));

		list($this->text,$this->postscript) = $tf->getXHTMLTable('Professional',2,'row',true);
    }

    function tfTHProcessor($params)
    {
    	switch ($params['head'])
    	{
			case 'WEIGHT_DEC':
    		case 'WEIGHT':
    		case 'QUANTITY':
    			return ' class="th-right"';
    		break;
    	}
    }

    function tfValueProcessor($params)
    {
    	switch ($params['head'])
    	{
			case 'WEIGHT_DEC':
				$params['extra'] .= sprintf(' sort_val="%s" ', $params['value']);
    			return locale_nf($params['value'], 3);
    		case 'WEIGHT':
    		case 'QUANTITY':
    			$params['extra'] .= sprintf(' sort_val="%s" ', $params['value']);
    			return locale_nf($params['value']);
    		break;
    		case 'MONTH':
    			$params['extra'] = sprintf(' sort_val="%s" ', $params['value']);
				return strftime('%B', mktime(1, 1, 1, $params['value'], 1) );
			break;
    	}
    }
}

/**
 * CALLBACK[getProvDecYear]
 * item[970] = {
 *     [handle] = Item: ProvDecYear
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getProvDecDetails]
 * item[969] = {
 *     [handle] = Item: ProvDecDetails
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 */
?>
