<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
/**
 *
 * @package ELC
 * @subpackage Interface
 * @since 08-06-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceRegistrantUserDetails extends InterfaceFactory
{
    /**
     * interface[id] = 122
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceRegistrantUserDetails(&$db, &$db_app, &$langIf)
    {
        parent::InterfaceFactory($db, $db_app, $langIf);
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';

        $this->_hideInputs = true;

		$this->FirstColWidth = 25;
		$this->delimiter = '<br />';
		if(isset($_POST['process']))
			$this->_setValues = true;
		parent::InterfaceFactory($db, $db_app, $langIf);

		require_once(IWARE.'InfoPerson.php');
		require_once(IWARE.'group.php');
		require_once(IWARE.'GroupUser.php');
		require_once(ELC_CLASSES.'CRSO.php');
		require_once(ELC_CLASSES.'User.php');
		require_once(ELC_CLASSES.'RelationUser.php');

		$this->user = new ELCUser($this->db_app);
		if(isset($_REQUEST['user']['id']))
		{
			$this->hiddenFields[] = array('name'=>'user[id]', 'value'=>$_REQUEST['user']['id']);
			$this->user->set($_REQUEST['user']['id']);
			$this->user->info_person->set();

			$this->model['user'] = $this->user;
		}

		$title = $this->user->name;

		if (isset($_REQUEST['participant']))
		{
			require_once(ELC_CLASSES.'Participant.php');
			$participant = new Participant($db_app, array('relation'=> new Relation($db_app, $_REQUEST['participant']['id'])));
			$participant->relation->set();
			$this->model['participant'] = &$participant;
			$this->hiddenFields[] = array('name'=>'participant[id]', 'value'=>$participant->relation->id);

			$title .= ' / '.$participant->relation->name;
		}

		setPageTitlePostfix('('.$title.')');
    }
    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {

    	$trs = array (
    		'gm_authorized_title'=>'Notification: Request General Manager Authorized',
    		'gm_authorized_msg'=>'Notification: Request to be general manager for User `{USER}` at Participant `{PARTICIPANT}` is authorized.',
    		'gm_denied_title'=>'Notification: Request General Manager Denied',
    		'gm_denied_msg'=>'Notification: Request to be general manager for User `{USER}` at Participant `{PARTICIPANT}` is denied.'
    	);

		if (isset($_REQUEST['process']))
		{
			if (isset($this->model['participant']))
			{
				// TODO: check if allowed to modify !
				require_once(ELC_CLASSES.'CRSOParticipantProduct.php');
				require_once(ELC_CLASSES.'Notification.php');
				$cp = CRSOParticipantProduct::createByIds($this->db_app, $this->model['participant']->relation->id, $_SESSION['crso_relation_id'], $_SESSION['selected_product_id']);
				$cp->participant->relation->set();
				$cp->crso->relation->set();

				switch ($_REQUEST['process'])
				{
					case 'general_manager_authorize':
						info(sprintf('[Refund Request] General manager (%i) for participant (%s) authorized',$this->model['user']->id,$this->model['participant']->relation->id));
						$cp->general_manager_authorized = GENERAL_MANAGER_AUTHORIZED;
						$cp->update();

				 		Notification::send($this->db_app,
				 		array('subject'=>$this->langIf->getText($trs['gm_authorized_title']),
				 			'sender'=>$this->model['participant']->relation,
				 			'message'=>$this->langIf->getText($trs['gm_authorized_msg'],
										null,  array(
											'PARTICIPANT'=>$cp->participant->relation->name,
											'USER'=>$this->model['user']->info_person->getFullName()))),
				 		array(
				 			array('recipient'=>$cp->participant->relation)
				 		));
					break;

					case 'general_manager_deny':
						info(sprintf('[Refund Request] General manager (%i) for participant (%s) denied',$this->model['user']->id,$this->model['participant']->relation->id));

						$cp->general_manager_authorized = DB_NULL;
						$cp->general_manager->id = DB_NULL;
						$cp->update();



				 		Notification::send($this->db_app,
				 		array('subject'=>$this->langIf->getText($trs['gm_denied_title']),
				 			'sender'=>$this->model['participant']->relation,
				 			'message'=>$this->langIf->getText($trs['gm_denied_msg'],
										null,  array('PARTICIPANT'=>$cp->participant->relation->name,
											'USER'=>$this->model['user']->info_person->getFullName()))),
				 		array(
				 			array('recipient'=>$cp->participant->relation)
				 		));
					break;
				}

				header(sprintf('location: InterfaceRegistrantUserDetails.php?user[id]=%s&participant[id]=%s', $_REQUEST['user']['id'], $cp->participant->relation->id));
				die();
			}
		}
    }


    function _filter($arr)
    {
    	$arr = parent::_filter($arr);

    	// hide confirm password fields
		if ($this->_hideInputs)
			unset($arr[$this->id][289][919], $arr[$this->id][289][918]);

		return $arr;
    }
}
/**
 * @package ELC
 * @subpackage Interface
 * @since 08-06-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceRegistrantUserDetailsItem extends InterfaceItem
{

    /**
     * item[906] = person[first_name]
     * item[907] = person[department]
     * item[908] = person[middle_name]
     * item[910] = person[last_name]
     * item[912] = person[title]
     * item[913] = person[email]
     * item[914] = person[position]
     * item[916] = user[name]
     * item[920] = user[active]
     * item[921] = user[default_page]
     * item[922] = relation_user[is_admin]
     */
	/**
	 *
	 */
	function getItemValue()
	{
		if(isset($_REQUEST['user']['id']))
		{
			if(!isset($this->parent->parent->userInfo))
			{
				$this->hiddenFields = array(array('name'=>'user[id]','value'=>$_REQUEST['user']['id']));
				$user = $this->parent->parent->user;

				$this->hiddenFields[] = array('name'=>'person[id]','value'=>$user->info_person->id);

				$this->parent->parent->person = (array) $user->info_person;
				$this->parent->parent->user = (array) $user;
				$this->parent->parent->userInfo = true;

				// set the RelationUser so the admin check is done properly
				if ($_SESSION['session_group_group_id'] == GROUP_CRSO)
				{
					$ru = new RelationUser($this->db_app,array('user'=>$user, 'relation'=>new Relation($this->db_app,$_REQUEST['participant']['id'])));
					$ru->set();
					$this->parent->parent->relation_user = (array) $ru;
				}
			}
			if($this->name == 'user[name]'&&isset($_REQUEST['user']['id']))
			{
				$this->properties['style'] = 'border: 0px; background-color: transparent;';
				$this->properties['readonly'] = 'readonly';
			}

			$name = str_replace('[','[\'',str_replace(']','\']',$this->name));
			eval('$this->properties[\'value\'] = isset($this->parent->parent->'.$name.')?$this->parent->parent->'.$name.':\'\';');
			if($this->type_id==IF_ITEM_CHECKBOX&& $this->properties['value'])
				$this->properties['checked'] = 'checked';
		}
	}

	function getPassword()
	{
		// DEPRECATED ! WE STORE PASSWORDS AS A HASH . we can't retrieve them
		$this->properties['value'] = ''; // FIXME . we can't retrieve password
		info('Calling deprecated getPassword(). (from InterfaceRegistrantUserDetails.php)');
	}

	function getPhoneFaxValue()
	{
		$this->getItemValue();
		if(!isset($this->properties['value'])||$this->properties['value'] == '')
			$this->properties['value'] = '+';
	}
	/**
	 *
	 */
	function getLanguageSelect()
	{
		require_once(IWARE.'nLanguage.php');
		$lang = new nLanguage($this->db_app);
		$q = $lang->get();
		$this->options = array(array('value'=>'','text'=>'- '.$this->langIf->getText('Select language').' -'));
		$i = 1;
		while($r = $q->fetch())
		{
			$this->options[$i] = array('text'=>$r->LANGUAGE,'value'=>$r->LANGUAGE_ID);
			if(!isset($this->parent->parent->userInfo))
			{
				if($r->LANGUAGE_ID == $_SESSION['session_user_language_id'])
					$this->options[$i]['selected'] = 'selected';
			}
			elseif(isset($this->parent->parent->person['language_id'])&& $this->parent->parent->person['language_id']==$r->LANGUAGE_ID)
				$this->options[$i]['selected'] = 'selected';
			$i++;
		}
	}
	/**
	 *
	 */
	function getSpacer()
	{
		$this->twoCols = true;
	}
	/**
	 *
	 */
	function getButtons()
	{
		$this->_BarButtons = 0;

		//$this->_addCustomButton('Send Password'); FIXME

		if (isset($this->if_obj->model['participant']))
		{
			require_once(ELC_CLASSES.'CRSOParticipantProduct.php');
			$cp = CRSOParticipantProduct::createByIds($this->db_app, $this->if_obj->model['participant']->relation->id, $_SESSION['crso_relation_id'],$_SESSION['selected_product_id']);
			$cp->set(null,null,$_SESSION['selected_product_id']);

			if ($cp->general_manager)
			{
				if ($cp->general_manager_authorized == GENERAL_MANAGER_REQUEST)
				{
					$this->_addCustomButton($this->langIf->getText('Authorize Request General Manager'), 'submit', array('onclick'=>"$('interface_form').process.value='general_manager_authorize';"));
					$this->_addCustomButton($this->langIf->getText('Deny Request General Manager'), 'submit', array('onclick'=>"$('interface_form').process.value='general_manager_deny';"));
				}
			}
		}
		else
		{
			$this->parent->hide();
		}
	}

    /**
     * item[918] =
     */
	function get2colTxt()
	{
		$this->twoCols = true;
	}

}

/**
 * CALLBACK[getItemValue]
 * item[906] = {
 *     [handle] = Item: FirstName
 *     [behaviour] = required
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * item[907] = {
 *     [handle] = Item: Department
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * item[908] = {
 *     [handle] = Item: MiddleName
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * item[910] = {
 *     [handle] = Item: LastName
 *     [behaviour] = required
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * item[912] = {
 *     [handle] = Item: Title
 *     [behaviour] = required
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * item[913] = {
 *     [handle] = Item: PersonEmail
 *     [behaviour] = required;email
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * item[914] = {
 *     [handle] = Item: PersonPosition
 *     [behaviour] = required
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * item[916] = {
 *     [handle] = Item: UserName
 *     [behaviour] = required
 *     [help] = 1
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * item[920] = {
 *     [handle] = Item: UserActive
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * item[921] = {
 *     [handle] = Item: UserDefaultPage
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * item[922] = {
 *     [handle] = Item: IsAdminUser
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * CALLBACK[getPhoneFaxValue]
 * item[909] = {
 *     [handle] = Item: Phone
 *     [behaviour] = required;phone
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * item[911] = {
 *     [handle] = Item: FaxNumber
 *     [behaviour] = required;phone
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getLanguageSelect]
 * item[915] = {
 *     [handle] = Item: PersonLanguageId
 *     [behaviour] = required
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getPassword]
 * item[917] = {
 *     [handle] = Item: UserPassword
 *     [behaviour] = required;password(user[password2])
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * item[919] = {
 *     [handle] = Item: UserPassword Confirm
 *     [behaviour] = required
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[get2colTxt]
 * item[918] = {
 *     [handle] = Item: Spacer PasswordConfirm
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * CALLBACK[getSpacer]
 * item[923] = {
 *     [handle] = Item: Spacer
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getButtons]
 * item[924] = {
 *     [handle] = Item: ButtonBar
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 */
?>
