
<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
/**
 *
 * @package
 * @subpackage Interface
 * @since 08-05-2010
 * @copyright 2010 BaseSoft B.V.
 * @version $Id$
 */
require_once(ELC_CLASSES.'uk/UKRegistrationData.php');

class InterfaceUKWeightsComparison extends InterfaceFactory
{
    /**
     * interface[id] = 185
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceUKWeightsComparison(&$db, &$db_app, &$langIf)
    {
        parent::InterfaceFactory($db, $db_app, $langIf);
        $this->FirstColWidth = 15;
        $this->delimiter = '<br />';

        $date =& currentDate();
        $this->model['year'] = isset($_REQUEST['year']) ? (int)$_REQUEST['year']:$date->getYear();

        // TODO: fix this
        $this->model['crso_id'] = 163;
       	$this->model['participant_id'] = !empty($_REQUEST['participant']['id']) ? (int)$_REQUEST['participant']['id']:null;
       	$this->model['product_id'] = !empty($_REQUEST['product']['id']) ? (int)$_REQUEST['product']['id']:null;
       	$this->model['dimension'] = !empty($_REQUEST['dimension']) ? (int)$_REQUEST['dimension']:null;
       	$this->model['quarter'] = !empty($_REQUEST['quarter']) ? (int)$_REQUEST['quarter']:null;

       	$this->script = sprintf("
       		function showPopup(url){
       			mywindow = window.open(url, 'id','toolbar=0,scrollbars=1,location=0,statusbar=0,menubar=0,resizable=1,width=1100,height=600');
				mywindow.moveTo(100,50);
       		}
       		function print_preview()
			{

				var nwin = new NewWindow(800, 600);
				nwin.setSource('%s');
				nwin.setName('winPrint');
				nwin.setScrollbars(true);
				var win = nwin.open(); // returns a window object

				var frm = $('interface_form');
				frm.target='winPrint';
				frm.process.value='print';
				frm.submit();

				// restore
				frm.target='_self';
				frm.process.value='save';
			}
       	", sprintf('%s?year=%s&participant[id]=%s&product_id=%s&dimension=%s&quarter=%s',
       		$_SERVER['PHP_SELF'],
       		$this->model['year'],
       		$this->model['participant_id'],
       		$this->model['product_id'],
       		$this->model['dimension'],
       		$this->model['quarter']
       	));

       	$this->_process = isset($_REQUEST['process']) ? $_REQUEST['process'] : null;

       	$popup = !empty($_REQUEST['popup']) ? (int)$_REQUEST['popup']:null;
       	if($popup != null){
       		$text = sprintf("Date: %s <br />", $date->format("d-m-Y H:i:s"));
       		$dbh = IWRegistry::registry('db');
       		$only_changed = true;
       		if($this->model['quarter'] == null || $this->model['quarter'] == ''){
		    	$stmt = $dbh->prepare("CALL sp_ukWeightsYearlyOverview(?,?,?,?,?,?)");
		    	$stmt->bind_values($this->model['crso_id'],
		    					   $this->model['year'],
		    					   null,null, null, $only_changed);
	    	}
	    	else{
	    		$stmt = $dbh->prepare("CALL sp_ukWeightsQuarterlyOverview(?,?,?,?,?,?,?)");
		    	$stmt->bind_values($this->model['crso_id'],
		    					   $this->model['year'],
		    					   $this->model['quarter'],
		    					   null,null, null, $only_changed);

	    	}
	    	$stmt->execute();

	    	$this->__totals = array();
    		$this->__totalsLabel = $this->langIf->getText('Totals');
	    	$t = new TableFactory($stmt);
	    	$t->setEmptyText($this->langIf->getText('No producers with changes'));
	    	$t->setThProcessor(TF_ALL, array($this, '_thProcessor'));
    		$t->setValueProcessor(TF_ALL, array($this, '_tfValueProcessor'));
    		$t->setFooterProcessor(array($this,'tfFooter'));

	    	$text .= $t->getXHTMLTable('').'<br />';
			echo $text;
			die();
       	}
    }
	function _thProcessor($args) {
		switch ($this->model['quarter']) {
			case 1:
				switch($args['head']){
					case 'M1_weight':
						$args['headerText'] = $this->langIf->getText('Jan. weight');
						break;
					case 'M2_weight':
						$args['headerText'] = $this->langIf->getText('Feb. weight');
						break;
					case 'M3_weight':
						$args['headerText'] = $this->langIf->getText('Mar. weight');
						break;
					default:
						$args['headerText'] = $this->langIf->getText($args['head']);
				}
				break;
			case 2:
				switch($args['head']){
					case 'M1_weight':
						$args['headerText'] = $this->langIf->getText('Apr. weight');
						break;
					case 'M2_weight':
						$args['headerText'] = $this->langIf->getText('May weight');
						break;
					case 'M3_weight':
						$args['headerText'] = $this->langIf->getText('Jun. weight');
						break;
					default:
						$args['headerText'] = $this->langIf->getText($args['head']);
				}
				break;
			case 3:
				switch($args['head']){
					case 'M1_weight':
						$args['headerText'] = $this->langIf->getText('Jul. weight');
						break;
					case 'M2_weight':
						$args['headerText'] = $this->langIf->getText('Aug. weight');
						break;
					case 'M3_weight':
						$args['headerText'] = $this->langIf->getText('Sep. weight');
						break;
					default:
						$args['headerText'] = $this->langIf->getText($args['head']);
				}
				break;
			case 4:
				switch($args['head']){
					case 'M1_weight':
						$args['headerText'] = $this->langIf->getText('Oct. weight');
						break;
					case 'M2_weight':
						$args['headerText'] = $this->langIf->getText('Nov. weight');
						break;
					case 'M3_weight':
						$args['headerText'] = $this->langIf->getText('Dec. weight');
						break;
					default:
						$args['headerText'] = $this->langIf->getText($args['head']);
				}
				break;
			default:
				$args['headerText'] = $this->langIf->getText($args['head']);
		}
	}

	function _tfValueProcessor($args) {
		$v = $args['value'];
		if($args['head'] != "relation_id" && $args['head'] != "Producer"){
			$args['extra'] .= 'style="text-align: right; width: 75px;"';
			if($v == '')
				$v = ' - ';
			else {
				if(strpos($v, '_')===false){
					$this->__totals[$args['head']] = isset($this->__totals[$args['head']])?$this->__totals[$args['head']]+$v:$v;
					$v = locale_nf($v,3);
				}
				else {
					$s = explode("_", $v);
					if($s[0] == 'E'){
						list($v,$cls) = UKRegistrationData::translateWEEEStatus($this->langIf, $s[1]);
						return sprintf('<span class="%s">%s</span>',$cls,$v);
					}
					if($s[0] == 'B'){
						$this->__totals[$args['head']] = isset($this->__totals[$args['head']])?$this->__totals[$args['head']]+$s[1]:$s[1];
						return sprintf('<span class="status_forfeit">%s</span>',$s[1]);
					}
				}
			}
		}

		return $v;
	}

	function tfFooter()
	{
		$rv['relation_id'] = sprintf('<span style="font-weight: bold;">%s</span>', $this->langIf->getText($this->__totalsLabel));
		$rv['Producer'] = '';

		if ($this->model['quarter'] == null || $this->model['quarter'] == ''){
			for($i = 1; $i <= 4; $i++) {
				$rv['Q'.$i.'_weight']=isset($this->__totals['Q'.$i.'_weight'])?'<div style="text-align: right; font-weight: bold;">'.locale_nf($this->__totals['Q'.$i.'_weight'],3).'</div>':'';
				$rv['Q'.$i.'_difference']=isset($this->__totals['Q'.$i.'_difference'])?'<div style="text-align: right; font-weight: bold;">'.locale_nf($this->__totals['Q'.$i.'_difference'],3).'</div>':'';
			}
		}
		else {
			if ($this->model['quarter'] == 4)
				$rv['B2B_from_Jan_to_Sep']=isset($this->__totals['B2B_from_Jan_to_Sep'])?'<div style="text-align: right; font-weight: bold;">'.locale_nf($this->__totals['B2B_from_Jan_to_Sep'],3).'</div>':'';
			for($i = 1; $i <= 3; $i++) {
				$rv['M'.$i.'_weight']=isset($this->__totals['M'.$i.'_weight'])?'<div style="text-align: right; font-weight: bold;">'.locale_nf($this->__totals['M'.$i.'_weight'],3).'</div>':'';
			}
			$rv['Q_reported']=isset($this->__totals['Q_reported'])?'<div style="text-align: right; font-weight: bold;">'.locale_nf($this->__totals['Q_reported'],3).'</div>':'';
			$rv['Difference']=isset($this->__totals['Difference'])?'<div style="text-align: right; font-weight: bold;">'.locale_nf($this->__totals['Difference'],3).'</div>':'';
		}
		return $rv;
	}
    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {
    }

    function getInterfaceHeader()
    {
    	$rv = parent::getInterfaceHeader();

		$rv .= '<div style="font-size: 120%;">
			<span style="font-weight: bold;">'.$this->langIf->getText('Exception Product Lamps and Luminaires').'</span><br />
			'.$this->langIf->getText('Exception Lamps and Luminaries Description').'
			<br /><br />
			<span style="font-weight: bold;">'.$this->langIf->getText('Exception B2B').'</span><br />
			'.$this->langIf->getText('Exception B2B Description').'
			</div><br />
		';

		return $rv;
    }
}
/**
 * @package
 * @subpackage Interface
 * @since 08-05-2010
 * @copyright 2010 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceUKWeightsComparisonItem extends InterfaceItem
{
    /**
     * item[1496] = year
     */
    function getYearSelect()
    {
    	require_once(ELC_CLASSES.'uk/uk_define.php');
    	$this->options = array();

    	$date =& currentDate();
        $year = $date->getYear();
    	// this overview only makes sense after the changes for actuals report
    	// (based on declaration period, only report NonHH in Q4 as sum of all year etc)
    	for($i=START_YEAR_ACTUALS_ON_DECLARATION_PERIOD; $i<=$year; $i++)
			$this->options[] = array('value'=>$i,'text'=>$i,'selected'=>($i==$this->if_obj->model['year']?'selected':false));

		preg_match('/\/scripts\/(.*)\/(.*)\/([\w]+)\.php/', $_SERVER['REQUEST_URI'],$matches);
		$this->properties['onchange'] = sprintf("go('%s?crso[id]=%s&year='+this.value+'&participant[id]=%s&product[id]=%s&dimension=%s&quarter=%s');",
    		$matches[0], $this->if_obj->model['crso_id'], $this->if_obj->model['participant_id'],
    		$this->if_obj->model['product_id'], $this->if_obj->model['dimension'], $this->if_obj->model['quarter']);
    }

	function getSpacer()
	{
		$this->twoCols = true;
	}

    /**
     * item[1497] = participant[id]
     */
    function getParticipantSelect()
    {
    	$this->options = array(array('value'=>'', 'text'=>'- '.$this->langIf->getText('Select Participant').' -'));

		// Get all producers that are not excluded from weee actuals report
    	$sql = " SELECT UK.PARTICIPANT_RELATION_ID,R.NAME
				FROM TBL_UK_REGISTRATION_DATA UK
				INNER JOIN TBL_RELATION R
					ON UK.PARTICIPANT_RELATION_ID = R.RELATION_ID
				WHERE UK.CRSO_RELATION_ID = ?
					AND UK.WEEE_STATUS in (2,5)
				ORDER BY R.NAME";

		$q = $this->db->query($sql);
		$q->bind_values($this->if_obj->model['crso_id']);
		$q->execute();
    	while($r = $q->fetch()) {
    		$selected = ($this->if_obj->model['participant_id'] == $r->PARTICIPANT_RELATION_ID)?'selected':'';
    		$this->options[] = array(
				'value'=>$r->PARTICIPANT_RELATION_ID,
				'text'=>((mb_strlen($r->NAME) > 20 ) ? mb_substr($r->NAME, 0, 20)."..." : $r->NAME),
				'selected'=>$selected);
    	}

    	preg_match('/\/scripts\/(.*)\/(.*)\/([\w]+)\.php/', $_SERVER['REQUEST_URI'],$matches);
    	$this->properties['onchange'] = sprintf("go('%s?year=%s&participant[id]='+this.value);", $matches[0], $this->if_obj->model['year']);
    	$this->properties['onchange'] = sprintf("go('%s?crso[id]=%s&year=%s&participant[id]='+this.value+'&product[id]=%s&dimension=%s&quarter=%s');",
    		$matches[0], $this->if_obj->model['crso_id'], $this->if_obj->model['year'],
    		$this->if_obj->model['product_id'], $this->if_obj->model['dimension'], $this->if_obj->model['quarter']);
    }

    /**
     * item[1498] = product[id]
     */
    function getProductSelect()
    {
    	$this->options = array(array('value'=>'', 'text'=>'- '.$this->langIf->getText('Select Product').' -'));

    	require_once(ELC_CLASSES.'Product.php');
		$p = new Product($this->db);
		$q = $p->getProducts();

    	while($r = $q->fetch()) {
    		$selected = ($this->if_obj->model['product_id'] == $r->PRODUCT_ID)?'selected':'';
    		$this->options[] = array(
				'value'=>$r->PRODUCT_ID,
				'text'=>$r->PRODUCT_NAME,
				'selected'=>$selected);
    	}

    	preg_match('/\/scripts\/(.*)\/(.*)\/([\w]+)\.php/', $_SERVER['REQUEST_URI'],$matches);
    	$this->properties['onchange'] = sprintf("go('%s?crso[id]=%s&year=%s&participant[id]=%s&product[id]='+this.value+'&dimension=%s&quarter=%s');",
    		$matches[0], $this->if_obj->model['crso_id'], $this->if_obj->model['year'], $this->if_obj->model['participant_id'],
    		$this->if_obj->model['dimension'], $this->if_obj->model['quarter']);
    }

    /**
     * item[1499] = dimension
     */
    function getDimensionSelect()
    {
    	$this->options = array(array('value'=>'', 'text'=>'- '.$this->langIf->getText('Select Dimension').' -'));

    	$this->options[] = array(
			'value'=>1,
			'text'=>"B2C",
			'selected'=>($this->if_obj->model['dimension'] == 1)?'selected':'');
    	$this->options[] = array(
			'value'=>2,
			'text'=>"B2B",
			'selected'=>($this->if_obj->model['dimension'] == 2)?'selected':'');

    	preg_match('/\/scripts\/(.*)\/(.*)\/([\w]+)\.php/', $_SERVER['REQUEST_URI'],$matches);
    	$this->properties['onchange'] = sprintf("go('%s?crso[id]=%s&year=%s&participant[id]=%s&product[id]=%s&dimension='+this.value+'&quarter=%s');",
    		$matches[0], $this->if_obj->model['crso_id'], $this->if_obj->model['year'], $this->if_obj->model['participant_id'],
    		$this->if_obj->model['product_id'], $this->if_obj->model['quarter']);
    }

    /**
     * item[1500] = quarter
     */
    function getQuarterSelect()
    {
    	$this->options = array(array('value'=>'', 'text'=>'- '.$this->langIf->getText('Select Quarter').' -'));

    	for($i = 1; $i <= 4; $i++) {
    		$selected = ($this->if_obj->model['quarter'] == $i)?'selected':'';
    		$this->options[] = array(
				'value'=>$i,
				'text'=>sprintf("Quarter %s", $i),
				'selected'=>$selected);
    	}

    	preg_match('/\/scripts\/(.*)\/(.*)\/([\w]+)\.php/', $_SERVER['REQUEST_URI'],$matches);
    	$this->properties['onchange'] = sprintf("go('%s?crso[id]=%s&year=%s&participant[id]=%s&product[id]=%s&dimension=%s&quarter='+this.value);",
    		$matches[0], $this->if_obj->model['crso_id'], $this->if_obj->model['year'], $this->if_obj->model['participant_id'],
    		$this->if_obj->model['product_id'], $this->if_obj->model['dimension']);
    }

    /**
     * item[1501] =
     */
    function getResults()
    {
    	$dbh = IWRegistry::registry('db');
    	$only_changed = false;
    	if($this->if_obj->model['quarter'] == null|| $this->if_obj->model['quarter'] == ''){
    		$stmt = $dbh->prepare("CALL sp_ukWeightsYearlyOverview(?,?,?,?,?,?)");
	    	$stmt->bind_values($this->if_obj->model['crso_id'],
	    					   $this->if_obj->model['year'],
	    					   $this->if_obj->model['participant_id'],
	    					   $this->if_obj->model['product_id'],
	    					   $this->if_obj->model['dimension'], $only_changed);
    		$sort = array(
    			'relation_id' => "'Int'",
				'Producer' => "'String'",
	    		'Q1_weight' => "'Float'",
		    	'Q1_difference' => "'Float'",
		    	'Q2_weight' => "'Float'",
		    	'Q2_difference' => "'Float'",
		    	'Q3_weight' => "'Float'",
		    	'Q3_difference' => "'Float'",
		    	'Q4_weight' => "'Float'",
	    		'Q4_difference' => "'Float'"
	    	);
    	}
    	else{
    		$stmt = $dbh->prepare("CALL sp_ukWeightsQuarterlyOverview(?,?,?,?,?,?,?)");
	    	$stmt->bind_values($this->if_obj->model['crso_id'],
	    					   $this->if_obj->model['year'],
	    					   $this->if_obj->model['quarter'],
	    					   $this->if_obj->model['participant_id'],
	    					   $this->if_obj->model['product_id'],
	    					   $this->if_obj->model['dimension'], $only_changed);
	    	$sort = array(
    			'relation_id' => "'Int'",
				'Producer' => "'String'",
    			'B2B_from_Jan_to_Sep' => "'Float'",
    			'M1_weight' => "'Float'",
    			'M2_weight' => "'Float'",
    			'M3_weight' => "'Float'",
    			'Q_reported' => "'Float'"
    		);
    	}
    	$stmt->execute();

    	$this->if_obj->__totals = array();
    	$this->if_obj->__totalsLabel = $this->langIf->getText('Totals');
    	$t = new TableFactory($stmt);
    	$t->setThProcessor(TF_ALL, array($this->if_obj, '_thProcessor'));
    	$t->setValueProcessor(TF_ALL, array($this, '_tfValueProcessor'));
    	$t->setFooterProcessor(array($this->if_obj,'tfFooter'));
   		$t->setSortingFunctions($sort);
    	$this->text .= $t->getXHTMLTable('').'<br />';
    }

    function _tfValueProcessor($args) {
    	$v = $this->if_obj->_tfValueProcessor($args);
    	// on top of the if_obj's value processor, we add arrows imgs to values for making the differences more obviouse
		for($i = 1; $i <= 4; $i++) {
	    	$col_d = sprintf("Q%s_difference", $i);
			if($args['head'] == $col_d){
	    		if($args['row'][$col_d] != '' && $args['row'][$col_d] < 0)
	    			return sprintf('<img src="/images/i-w/if_arrow_down.gif"> %s', $v);
	    		if($args['row'][$col_d] != '' && $args['row'][$col_d] > 0)
	    			return sprintf('<img src="/images/i-w/if_arrow_up.gif"> %s', $v);
	    		break;
			}
		}
    	if($args['head'] == "Difference"){
    		if($args['row']["Difference"] != '' && $args['row']["Difference"] < 0)
    			return sprintf('<img src="/images/i-w/if_arrow_down.gif"> %s', $v);
    		if($args['row']["Difference"] != '' && $args['row']["Difference"] > 0)
    			return sprintf('<img src="/images/i-w/if_arrow_up.gif"> %s', $v);
		}
    	return $v;
	}

    function getButtons()
   {
		$this->_BarButtons = 0;
		if($this->if_obj->_process =='print')
			return;

	    $this->_addCustomButton($this->langIf->getText('Print Preview'),'button',array('onclick'=>'print_preview();'));

		$this->_CustomButtons[] = '<div style="float:left"><span class="status_declared"> '.
				$this->langIf->getText('View popup with all producers that have changes between declared weight and reported weight').
				':</span></div>';

		preg_match('/\/scripts\/(.*)\/(.*)\/([\w]+)\.php/', $_SERVER['REQUEST_URI'],$matches);
    	$url = sprintf("%s?popup=1&crso[id]=%s&year=%s&participant[id]=%s&product[id]=%s&dimension=%s&quarter=%s",
    		$matches[0], $this->if_obj->model['crso_id'], $this->if_obj->model['year'], $this->if_obj->model['participant_id'],
    		$this->if_obj->model['product_id'], $this->if_obj->model['dimension'], $this->if_obj->model['quarter']);
		$this->_addCustomButton($this->langIf->getText('Show producers with changes'),'button',
								array('onclick'=>sprintf('showPopup("%s")', $url)));
   }

}

/**
 * CALLBACK[getCRSOSelect]
 * item[1495] = {
 *     [handle] = Item: CRSO Select
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * CALLBACK[getYearSelect]
 * item[1496] = {
 *     [handle] = Item: Year Select
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 1
 *
 * CALLBACK[getParticipantSelect]
 * item[1497] = {
 *     [handle] = Item: Participant Select
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * CALLBACK[getProductSelect]
 * item[1498] = {
 *     [handle] = Item: Product Select
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * CALLBACK[getDimensionSelect]
 * item[1499] = {
 *     [handle] = Item: Dimension Select
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * CALLBACK[getQuarterSelect]
 * item[1500] = {
 *     [handle] = Item: Quarter Select
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getResults]
 * item[1501] = {
 *     [handle] = Item: Results
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 */
?>
