<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
require_once(ELC_CLASSES.'FormBehaviourPlugins.php');
require_once(ELC_CLASSES.'uk/UKRegistrationData.php');
require_once(ELC_CLASSES.'uk/UKSicCode.php');
require_once(ELC_CLASSES.'uk/UKPartnerName.php');
require_once(ELC_CLASSES.'CRSO.php');
require_once(ELC_CLASSES.'Participant.php');
require_once(ELC_CLASSES.'CRSOParticipantProduct.php');
require_once(ELC_CLASSES.'WEEECountry.php');

require_once(ELC_CLASSES.'uk/uk_define.php');

define('HIDE_PRODUCT_SELECT', 1);

// REDEFINE WHEN WE ACTUALLY KNOW THEM
define('UK_B2B_CATEGORY_ID', 50);
define('UK_B2C_CATEGORY_ID', 49);

/**
 *
 * @package
 * @subpackage Interface
 * @since 21-02-2007
 * @copyright 2007 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceUKXMLPreparation extends InterfaceFactory
{
    /**
     * interface[id] = 165
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceUKXMLPreparation(&$db, &$db_app, &$langIf)
    {
        parent::InterfaceFactory($db, $db_app, $langIf);
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';

        $country = new WEEECountry($this->db);
        $country->set('826');
        $q = $country->selectCRSOs();
        $crsos = array();
        while($r = $q->fetch())
                $crsos[] = $r->CRSO_RELATION_ID;


        $participants = array();
        foreach($crsos as $key=>$cr)
        {
                $part = new Participant($this->db);
                $q = $part->selectByCRSO($cr);
                while($r = $q->fetch())
                        $participants[$r->PARTICIPANT_ID] = $cr;
        }

        switch ($_SESSION['session_group_group_id'])
        {
                case GROUP_PARTICIPANT:
                        if(!in_array($_SESSION['selected_participant_id'], array_keys($participants)))
                                throw new InterfacePermissionException('Permission denied');
                        $this->model['participant_id'] = $_SESSION['selected_participant_id'];
                        $this->model['crso_id'] = $participants[$_SESSION['selected_participant_id']];
                        break;
                case GROUP_CRSO: //FIXME
                        if(!in_array($_SESSION['crso_relation_id'], $crsos))
                                throw new InterfacePermissionException('Permission denied');
                        $this->model['participant_id'] = $_REQUEST['participant']['id'];
                        $this->model['crso_id'] = $_SESSION['crso_relation_id'];
                        break;
                case GROUP_SYSADMIN:
                        $this->model['participant_id'] = $_REQUEST['participant']['id'];
                        $this->model['crso_id'] = $_REQUEST['crso']['id'];
                        break;
                default:
                        $this->model['participant_id'] = $_REQUEST['participant']['id'];
                        $this->model['crso_id'] = $_REQUEST['crso']['id'];

        }

        validatePOSTLength();

        $this->fb->addPlugin('ukphone', 'FormBehaviourPluginUkGovContactChannel');
        $this->fb->addPlugin('ukpostcode', 'FormBehaviourPluginUkGovPostCode');
        $this->fb->addPlugin('uklogoupload', 'FormBehaviourPluginUkLogoUpload');
		$this->fb->addPlugin('ukcountry', 'FormBehaviourPluginUkCountry');
		$this->fb->addPlugin('nonukcountry', 'FormBehaviourPluginNonUkCountry');

        $this->model['reg_data'] = new UKRegistrationData($this->db);
        $this->model['reg_data']->set($this->model['crso_id'],$this->model['participant_id']);

        $this->model['sic'] = new UKSicCode($this->db);
        $this->model['partner'] = new UKPartnerName($this->db);

        $this->first = true;
        $this->_hideInputs = false;
        if($this->model['reg_data']->hasRegistrationData($this->model['crso_id'],$this->model['participant_id']))
        {
                        $this->first = false;
                        if(!isset($_REQUEST['process']))
                                $this->_hideInputs = true;
                        if(isset($_POST['process']) && $_POST['process'] != 'edit')
                                $this->_hideInputs = true;
        }
        //if(!$this->_hideInputs){
        $this->script = "

        var BUSINESS = 489;
        var AUTHORIZED_REPRESENTATIVE = 561;

        addEvent(window,'load', function()
        {
                var tables = [
                        getElById('ifB_'+BUSINESS)
                        ];
                if($('rowControlButtonAddLine_489') != null)
                        $('rowControlButtonAddLine_489').click();";

        if(!isset($this->model['reg_data']->business_type) || $this->model['reg_data']->business_type != BUSINESS_PARTNERSHIP)
            $this->script .= "
                for (var i=0; i<tables.length; i++)
                {
                        try {
                                disableFormNodes(tables[i], true);
                                displayNode(tables[i], false);
                        } catch (e) {}
                }
                ";
        //this is so we show the section again if they submitted wrong
        if(isset($_POST['producer']['business_type']) && $_POST['producer']['business_type'] == BUSINESS_PARTNERSHIP)
        {
                $this->script .= "
                                $('ifRadioproducer[business_type]2').click();
                                ";
        }
        else if(isset($_POST['producer']['business_type']) && $_POST['producer']['business_type'] == BUSINESS_COMPANY)
        {
                $this->script .= "
                                $('ifRadioproducer[business_type]1').click();
                                ";
        }

		if(empty($_POST['has_authorized_representative'])) {
			$hasAR = empty($this->model['reg_data']->ar['name']) ? '1' : '2';
		} else {
			$hasAR = ($_POST['has_authorized_representative'] == 1) ? '1' : '2';
		}


		$this->script .= "
			changeHasAuthorizedRepresentative(".$hasAR.");
			";


        $q = $this->model['sic']->getOverview($this->model['crso_id'],$this->model['participant_id']);
        $count = count($q->fetchAll())-1;
        if($count > 0)
                $this->script .="
                        countsic(".$count.");
                        ";
        $q = $this->model['partner']->getOverview($this->model['crso_id'],$this->model['participant_id']);
        $count = count($q->fetchAll())-1;
        if($count > 1)
                $this->script .="
                        countpartner(".$count.");
                        ";
        $this->script .= "
                if(document.getElementsByName('producer[business_type]')[0].value == 2)
                        changeBusiness(2);
				if(document.getElementsByName('ar[name]')[0].value != '') {
					changeAuthorizedRepresentative(2);
				}
                if(document.getElementsByName('same_logo')[0] != null &&
                        document.getElementsByName('same_logo')[0].value == 1)
                {
                        $('id_logo').disabled=true;
                        fb.removeBehaviour($('id_logo'), '');
                }
        });
        function countsic(no)
        {
                if($('rowControlButtonAddLine_419') != null)
                        for (var i=0; i<no; i++)
                                $('rowControlButtonAddLine_419').click();
        }
        function countpartner(no)
        {
                if($('rowControlButtonAddLine_489') != null)
                        for (var i=0; i<no-1; i++)
                                $('rowControlButtonAddLine_489').click();
        }
        function changeBusiness(rVal)
        {
                var el = getElById('ifB_'+BUSINESS);
                if(rVal==2)
                {
                        disableFormNodes(el, false);
                        displayNode(el, true);
                }
                else
                {
                        disableFormNodes(el, true);
                        displayNode(el, false);
                }
        }
        function changeHasAuthorizedRepresentative(rVal) {
			var el = getElById('ifB_'+AUTHORIZED_REPRESENTATIVE);
			disableFormNodes(el, rVal!=2);
			displayNode(el, rVal==2);
        }

        function ExcludeProducer()
        {
                ".jsMessageBox(MSG_BOX_INFO,
                $this->langIf->getText('Type in your reason'),
                '<div align=center style=\'padding-top:10px;\'>'.
                $this->langIf->getText('Please type a reason that will be sent in a notification to this producer').'
                        <textarea onblur="messageText = this.value;" id=id_other name=other cols=45 rows=3></textarea></div>',
                'function(){set_message()}').
                "
        }
        var messageText = '';
        function set_message()
        {
                if(document.getElementById('id_o') == undefined)
                {
                        var elem = document.createElement('input');
                        elem.type = 'hidden';
                        elem.name = 'reason';
                        elem.id = 'id_o';
                        elem.value = messageText;
                        document.getElementById('interface_form').appendChild(elem);
                }
                else document.getElementById('id_o').value = messageText;
                $('interface_form').process.value='exclude';
                $('interface_form').submit();
        }

		function addBrand(el)
		{
			var o = document.createElement('option');
			o.innerHTML = el.value;
			o.value = 'new_'+el.value;
			FancySelectController.prototype.getController('brands[]').addOption(o);
		}
        ";
        //}
        $this->sic_codes = $this->_getSicCodes();
        $this->partners = $this->_getPartners();
    }


    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {
		if(!isset($_REQUEST['process']))
			return;


		if($_SESSION['session_group_group_id'] == GROUP_PARTICIPANT && !$this->first) {


			throw new IWException('participant cannot change data');
		}

		if(isset($_POST['process']) && $_POST['process'] == 'edit')
		{
			$this->_hideInputs = false;
			return;
		}

		if(isset($_POST['process']) && $_POST['process'] == 'include')
		{
			if($_SESSION['session_group_group_id'] == GROUP_PARTICIPANT)
				return;
			$this->model['reg_data']->updatePRStatusDataCorrect();
			parent::init(165);
			return;
		}

		if (isset($_POST['process']) && $_POST['process'] == 'exclude') {
			if ($_SESSION['session_group_group_id'] == GROUP_PARTICIPANT
				|| $this->model['reg_data']->pr_status == REG_ACCEPTED
			)
				return;

			//send notification
			require_once(ELC_CLASSES . 'Notification.php');
			$final_body = $this->langIf->getText('Please correct your EA Registration data
					and after, reply to this notification.') . '<br />';

			if (isset($_POST['reason']) && !empty($_POST['reason'])) {
				$final_body .= "<br /><b>" . $this->langIf->getText('Message from sender:') . "</b><br />";
				$final_body .= str_replace("\n", "<br />", $_POST['reason']) . "<br />";
			}

			//if we use this, the producer cannot reply to this notification (because the input is sanitized)
			//$final_body .= " &nbsp;<br /><a href='../participant/InterfaceUKXMLPreparation.php'> "
			//          . $this->langIf->getText('view details') ." </a>  <br />";
			$message = array('subject' => $this->langIf->getText('EA Registration data rejected'),
				'user' => new ELCUser($this->db_app, $_SESSION['session_user_id']),
				'message' => $final_body,
				'product' => new Product($this->db_app, $_SESSION['selected_product_id'])
			);
			Notification::send(
				$this->db_app,
				$message,
				array(array('recipient' => new Relation($this->db_app, $this->model['participant_id'])))
			);

			$this->model['reg_data']->updatePRStatusDataIncorrect();
			parent::init(165);
			return;
		}

		$this->_setValues = true;

        if($_POST['producer']['business_type'] == BUSINESS_PARTNERSHIP) {
			foreach($_POST['partnername'] as $key => $partner)
			{
					if($key == 0)//this is set via IQ ADMIN
							continue;
					//if they submit more than two then it is required to be something
					$this->fb->register('partnername['.$key.']', 'required;length(1,70)');
			}
		}
        else
                $this->fb->unregister('partnername[0]');

		// THE AR-key IS NOT ACTUALLY THE AUTHORIZED REPRESENTATIVE DUE TO AN EA MESS UP!!!
		if($_POST['has_authorized_representative'] == 1) {
			$this->fb->unregister('ar[name]');
			$this->fb->unregister('ar[title]');
			$this->fb->unregister('ar[forename]');
			$this->fb->unregister('ar[surname]');
			$this->fb->unregister('ar[phone_landline]');
			$this->fb->unregister('ar[email]');
			$this->fb->unregister('ar[address][building_number]');
			$this->fb->unregister('ar[address][postcode]');
			$this->fb->unregister('ar[address][country]');

			$this->fb->register('business[address][country]', 'required;length(1,30)');
		} else {
			$this->fb->register('business[address][country]', 'required;length(1,30);ukcountry');
		}

		if(substr($_POST['business']['address']['country'], 0, 4) == 'UK -') {
			$this->fb->register('business[address][postcode]', 'required;ukpostcode');
		} else {
			$this->fb->register('business[address][postcode]', 'required;length(1,35)');
		}

		if(substr($_POST['cfn']['address']['country'], 0, 4) == 'UK -') {
			$this->fb->register('cfn[address][postcode]', 'required;ukpostcode');
		} else {
			$this->fb->register('cfn[address][postcode]', 'required;length(1,35)');
		}

		if(!$this->fb->validate())
			return $thrownException .= $this->langIf->getText('Please correct the form errors');

		if(($_POST['producer']['business_type'] == 2) && count($_POST['partnername'])<2)
			return $thrownException .= $this->langIf->getText('Please specify at least 2 Partners');

		$this->db->begin();

		//in case business_type changes from partneship to company -> delete partners
		if($this->model['reg_data']->business_type == BUSINESS_PARTNERSHIP
		&& $_POST['producer']['business_type'] == BUSINESS_COMPANY)
		{
			$this->model['partner']->crso = $this->model['reg_data']->crso;
			$this->model['partner']->participant = $this->model['reg_data']->participant;
			$this->model['partner']->deletePartners($this->partners);
		}

		$this->model['reg_data']->crso = new CRSO($this->db_app,array('relation'=>new Relation($this->db_app,$this->model['crso_id'])));
		$this->model['reg_data']->participant = new Participant($this->db_app,array('relation'=>new Relation($this->db_app,$this->model['participant_id'])));
		$this->model['reg_data']->trading_name = $_POST['producer']['trading_name'];
		$this->model['reg_data']->turnover = $_POST['producer']['annual_turnover'];

		// BRAND management

		$pb = new ParticipantBrand($this->db_app);
		$pb->participant = $this->model['reg_data']->participant;
		$brands = $pb->getAllParticipantBrands($this->model['participant_id'],$this->model['reg_data']->crso->relation->id);
		$deactivate = array_keys($brands);

		if(isset($_POST['brands']))
		{
			foreach($_POST['brands'] as $brand_id)
			{
				if(is_numeric($brand_id))
				{
					$pb->brand = new Brand($this->db_app, $brand_id);
					$pb->active = 1;
					$pb->objectmap['inserttype'] = 'REPLACE';
					$pb->insert();
					$pb->objectmap['inserttype'] = 'INSERT';
					$deactivate = array_diff($deactivate, array($brand_id));
					continue;
				}
				// Make sure a brand instance is available on $pb.
				$pb->brand = new Brand($this->db_app);
				$brandName = substr($brand_id,4);
				if(!$pb->brand->setByNameByCRSO($brandName,$this->model['reg_data']->crso->relation->id,$_SESSION['selected_product_id']))
				{
					$pb->brand->id = '';
					$pb->brand->name = $brandName;
					$pb->brand->active = 0;
					$pb->brand->crso = $this->model['reg_data']->crso;
					$pb->brand->product = new Product($this->db_app,$_SESSION['selected_product_id']);
					$pb->brand->insert();
					$pb->brand->setByNameByCRSO($brandName,$this->model['reg_data']->crso->relation->id,$_SESSION['selected_product_id']); // EE!!!
				}
				$deactivate = array_diff($deactivate, array($pb->brand->id));
				$pb->active = 1;
				$pb->insert();
			}
			if(sizeof($deactivate) > 0) {
				$pb->deactivateBrands($this->model['participant_id'], $deactivate);
			}
		}

	    $this->model['reg_data']->business_type = $_POST['producer']['business_type'];
	    $this->model['reg_data']->business = $_POST['business'];
		$this->model['reg_data']->selling_technique = $_POST['producer']['selling_technique'];
		$this->model['reg_data']->obligation_type = $_POST['producer']['obligation_type'];
		$this->model['reg_data']->placed_on_market = $_POST['producer']['placed_on_market'];
		$this->model['reg_data']->cease_to_exist_date = empty($_POST['producer']['cease_to_exist_date']) ? DB_NULL : reindex_date($_POST['producer']['cease_to_exist_date'], 'DD-MM-YYYY', 'YYYY-MM-DD');
		$this->model['reg_data']->ar = ($_POST['has_authorized_representative'] == 1) ? array() : $_POST['ar'];
	    $this->model['reg_data']->cfn = $_POST['cfn'];

	    if($this->first) {
	       	$this->model['reg_data']->vat_registered = 1; // default true, CRSO can change it
			$this->model['reg_data']->insert();
	    } else {
			$this->model['reg_data']->update();
		}

		if(isset($_POST['producer']['sic_code']) && !empty($_POST['producer']['sic_code']))
		{
			$this->model['sic']->crso = $this->model['reg_data']->crso;
			$this->model['sic']->participant = $this->model['reg_data']->participant;

			$count = count($this->sic_codes)-1;
			$post = count($_POST['producer']['sic_code'])-1;
			foreach($_POST['producer']['sic_code'] as $key => $sicCode)
			{
				if(!empty($sicCode))
				{
					$this->model['sic']->sic_code =  $sicCode;
					if($key <= $count)
					{
						$this->model['sic']->setID($this->sic_codes[$key]);
						$this->model['sic']->update();
					}
					else
						$this->model['sic']->insert();
				}
			}
			//see if there were some codes deleted
			if($post < $count)
			{
				$diff = array_diff($this->_getSicCodes(),$_POST['producer']['sic_code']);
				$this->model['sic']->deleteCodes($diff);
			}
		}

    	if($this->model['reg_data']->business_type == BUSINESS_PARTNERSHIP)
       	{
			$this->model['partner']->crso = $this->model['reg_data']->crso;
			$this->model['partner']->participant = $this->model['reg_data']->participant;

			$count = count($this->partners)-1;
			$post = count($_POST['partnername'])-1;
			foreach($_POST['partnername'] as $key => $partner)
			{
				if(!empty($partner))
				{
					$this->model['partner']->partner_name =  $partner;
					if($key <= $count)
					{
						$this->model['partner']->setID($this->partners[$key]);
						$this->model['partner']->update();
					}
					else
						$this->model['partner']->insert();
				}
			}
			//see if there were some partner names deleted
			if($post < $count)
			{
				$diff = array_diff($this->_getPartners(),$_POST['partnername']);
				$this->model['partner']->deletePartners($diff);
			}
       	}
      	$this->db->commit();

	   	$this->sic_codes = $this->_getSicCodes();
	   	$this->partners = $this->_getPartners();

	   	$this->_hideInputs = true;
	   	parent::init(165);
	   	if($this->first)
			header('Location: /'.SITE_PATH);
	   //else
		//	$this->_hideInputs = true;

    }

    function _getSicCodes()
    {
		$q = $this->model['sic']->getOverview($this->model['crso_id'],$this->model['participant_id']);
		$ret = array();
		while($r = $q->fetch())
			$ret[] = $r->SIC_CODE;
		return $ret;
    }
    function _getPartners()
    {
		$q = $this->model['partner']->getOverview($this->model['crso_id'],$this->model['participant_id']);
		$ret = array();
		while($r = $q->fetch())
			$ret[] = $r->PARTNER_NAME;
		return $ret;
    }
}
/**
 * @package
 * @subpackage Interface
 * @since 21-02-2007
 * @copyright 2007 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceUKXMLPreparationItem extends InterfaceItem
{

    /**
	 *
     */
    function getItemValue()
    {
		if(isset($this->if_obj->model['reg_data']))
		{
			if($this->name == 'producer[annual_turnover]')
				return $this->properties['value'] = $this->if_obj->model['reg_data']->turnover;
			if($this->name == 'producer[trading_name]')
				return $this->properties['value'] = $this->if_obj->model['reg_data']->trading_name;
			$name = str_replace('[','[\'',str_replace(']','\']',$this->name));
			eval('$this->properties[\'value\'] = isset($this->if_obj->model[\'reg_data\']->'.$name.')?$this->if_obj->model[\'reg_data\']->'.$name.':\'\';');

			if($this->name == 'producer[cease_to_exist_date]') {
				$strdate = $this->if_obj->model['reg_data']->cease_to_exist_date;
				if ($strdate == '' || $strdate == DB_NULL) {// date can be empty
					return;
				}
				$date = createDate($strdate, 'YYYY-MM-DD');
				$this->properties['value'] = reindex_date($strdate, 'YYYY-MM-DD', 'DD-MM-YYYY');
			}


		}
		if(isset($this->if_obj->model['sic']))
	{
			if(!$this->if_obj->_hideInputs)
			{
				$this->postscript = "
					addEvent(window,'load',function(){
					";
				foreach($this->if_obj->sic_codes as $key=>$value)
					$this->postscript .= "
						document.getElementsByName('producer[sic_code][".$key."]')[0].value = '".$value."';
					";
				$this->postscript .= "});";
			}
			else
			{
				if($this->name == 'producer[sic_code][0]')
					return $this->properties['value'] = implode("; ",$this->if_obj->sic_codes);
			}
		}

		if(isset($this->if_obj->model['partner']))
		{
			if(!$this->if_obj->_hideInputs)
			{
				$this->postscript .= "
					addEvent(window,'load',function(){
					";
				foreach($this->if_obj->partners as $key=>$value)
					$this->postscript .= "
						document.getElementsByName('partnername[".$key."]')[0].value = '".$value."';
					";
				$this->postscript .= "});";
			}
			else
			{
				if($this->name == 'partnername[0]')
					return $this->properties['value'] = implode("; ",$this->if_obj->partners);
			}
	}
	}

	/**
     * item[1206] =
     */
    function getObligationType() {
		$this->_hideInput = false;
		$this->columncount = 1;

		$o1 = array('text'=>$this->langIf->getText('ObligationTypeB2b'),'value'=>OBLIGATION_TYPE_B2B);
		$o2 = array('text'=>$this->langIf->getText('ObligationTypeB2c'),'value'=>OBLIGATION_TYPE_B2C);
		$o3 = array('text'=>$this->langIf->getText('ObligationTypeBoth'),'value'=>OBLIGATION_TYPE_BOTH);

		if(isset($this->if_obj->model['reg_data']->obligation_type)) {
			${ 'o'.(int)$this->if_obj->model['reg_data']->obligation_type }['checked'] = 'return true';
		}

		$this->options = array($o1, $o2, $o3);

		if($this->if_obj->_hideInputs)
			$this->properties['disabled'] = 'disabled';
    }

    /**
     * item[1209] = producer[business_type]
     */
    function getBusinessType()
    {
		$this->_hideInput = false;
		$this->columncount = 1;

		$b1 = array('text'=>$this->langIf->getText('BusinessIsCompany'),'value'=>1, 'onclick'=>'changeBusiness(this.value);');
		$b2 = array('text'=>$this->langIf->getText('BusinessIsPartnership'),'value'=>2, 'onclick'=>'changeBusiness(this.value);');
		if(isset($this->if_obj->model['reg_data']))
		{
			if($this->if_obj->model['reg_data']->business_type == BUSINESS_COMPANY)
				$b1['checked']= 'return true';
			if($this->if_obj->model['reg_data']->business_type == BUSINESS_PARTNERSHIP)
				$b2['checked'] = 'return true';
		}
		$this->options = array($b1,$b2);

		if($this->if_obj->_hideInputs)
			$this->properties['disabled'] = 'disabled';
    }

	function getHasAuthorizedRepresentative() {
		$this->_hideInput = false;
		$this->columncount = 1;

		$this->options = array(
			array('text'=>$this->langIf->getText('NoAuthorizedRepresentative'), 'value'=>1, 'onclick'=>'changeHasAuthorizedRepresentative(this.value);'),
			array('text'=>$this->langIf->getText('HasAuthorizedRepresentative'), 'value'=>2, 'onclick'=>'changeHasAuthorizedRepresentative(this.value);')
		);

		// TODO, check if ar['name'] is not empty to select the proper value.
		if(!empty($this->if_obj->model['reg_data']->ar['name'])) {
			$this->options[1]['checked'] = 'return true';
		} else {
			$this->options[0]['checked'] = 'return true';
		}

		if($this->if_obj->_hideInputs) {
			$this->properties['disabled'] = 'disabled';
		}
	}

	/**
	 *
	 */
	function getSellingTechnique() {
		$this->_hideInput = false;
		$this->columncount = 1;

		$this->options = array(
			array('text'=>$this->langIf->getText('DirectSellingToEndUser'), 'value'=>SELLING_TECHNIQUE_DIRECT),
			array('text'=>$this->langIf->getText('IndirectSellingToEndUser'), 'value'=>SELLING_TECHNIQUE_INDIRECT),
			array('text'=>$this->langIf->getText('Both'), 'value'=>SELLING_TECHNIQUE_BOTH)
		);
		if(isset($this->if_obj->model['reg_data']->selling_technique)) {
			$val = ((int) $this->if_obj->model['reg_data']->selling_technique )-1;
			$this->options[$val]['checked'] = 'return true';
		}

		if($this->if_obj->_hideInputs) {
			$this->properties['disabled'] = 'disabled';
		}

	}

	/**
	 * @return bool|void
	 */
	function getPlacedOnMarket() {
		$this->_hideInput = false;
		$this->columncount = 1;

		$this->options = array(
			array('text'=>$this->langIf->getText('MoreThanOrEqualTo5TEEE'), 'value'=>PLACED_ON_MARKET_LARGE),
			array('text'=>$this->langIf->getText('LessThan5TEEE'), 'value'=>PLACED_ON_MARKET_SMALL)
		);
		if(isset($this->if_obj->model['reg_data']->placed_on_market)) {
			$val = ((int)$this->if_obj->model['reg_data']->placed_on_market)-1;
			$this->options[$val]['checked'] = 'return true';
		}

		if($this->if_obj->_hideInputs) {
			$this->properties['disabled'] = 'disabled';
		}
	}

	function getLogoValue()
	{
		$this->twoCols = true;
		$this->_hideInput = true;
		$this->text = '';
		return false;

		if($this->if_obj->_hideInputs)
			if(isset($this->if_obj->model['reg_data']) && !empty($this->if_obj->model['reg_data']->logo))
			{
				$this->text = "<div align=left>".$this->langIf->getText('Item: Logo URL').": &nbsp;&nbsp;".
					$this->if_obj->model['reg_data']->logo."</div>";
				return;
			}

		$text = '<table>';
		if(isset($this->if_obj->model['reg_data']) && !empty($this->if_obj->model['reg_data']->logo))
			$text .= '<tr><td>&nbsp;</td>
				<td>
				<input type="radio" checked="" style="vertical-align: middle;"
                   onclick="$(\'id_logo\').disabled=true;
							fb.removeBehaviour($(\'id_logo\'), \'\');"
                   id="rdKeepFileYes860"
				   class="Checkbox"
				   name="same_logo"
				   value="1"/>
				<label for "rdKeepFileYes860">'.$this->langIf->getText('Keep current file').':'.
				$this->if_obj->model['reg_data']->logo.'
				</label><br>
                <input type="radio" style="vertical-align: middle;"
					onclick="$(\'id_logo\').disabled = false;
							fb.setBehaviour($(\'id_logo\'), \'\');"
					id="rdKeepFileNo860"
					class="Checkbox"
					name="same_logo"
					value="2"/>
				<label for "rdKeepFileNo860">'.$this->langIf->getText('Upload new file').'</label>
				</td></tr>';
		$text .= '
			<tr><td>'.$this->langIf->getText('Item: Logo URL').'<span class="required">*</span></td>
			<td><input type=file id="id_logo" name="producer[logo_url]" value="" size=30 ></td></tr>';
		$text .= '</table>';
		$this->text = $text;
	}

    /**
     * item[1225] =
     * item[1228] =
     * item[1243] =
     * item[1246] =
     */
    function get2colTxt()
    {
	$this->twoCols = true;
    }

    /**
     * item[1227] = business[billing_address]
     * item[1245] = business[billing_address]
     */
    function getBillingAddress()
    {
	$this->options = array(array('text'=>'','value'=>1));
    }

	function getEEEProfile()
	{

	}

	function tfValProc($args)
	{
		/*switch($args['head'])
		{
			case 'Weight':
				return '<input type="hidden" name="'.$args['row']['ObligationType'].'[weight]" value="'.$args['value'].'" />'.number_format($args['value'],2,'.','');
			break;
		}*/
		return $args['value'];
	}

	function getExplanation()
	{
		$this->twoCols = true;
		$this->text = $this->langIf->getText('UK XML EXPORT EXPLANATION');
	}

	function getButtons()
	{
		if(isset($_REQUEST['crso']['id']))
			$this->_addCustomButton((int)$_REQUEST['crso']['id'], "hidden", array('name' => 'crso[id]'));
		if(isset($_REQUEST['participant']['id']))
			$this->_addCustomButton((int)$_REQUEST['participant']['id'], "hidden", array('name' => 'participant[id]'));
		if(!$this->if_obj->_hideInputs)
		{
			$this->_BarButtons = '';
			$this->_addCustomButton($this->langIf->getText("Save"), "button", array(
						'onclick' => " if(fb.validate($('interface_form')))
										{ $('interface_form').process.value='save';
										$('interface_form').submit(); } "
						));
		}
		else
		{
			$this->_BarButtons = '';
			if($this->if_obj->model['reg_data']->pr_status == I_EXCLUDED_DATA_INCORRECT
					|| $this->if_obj->model['reg_data']->pr_status == A_EXCLUDED_DATA_INCORRECT)
			{
				if($_SESSION['session_group_group_id'] != GROUP_PARTICIPANT)
					$this->_CustomButtons[] = '<span class="error" style="padding-right: 20px;" >'.$this->langIf->getText('This producer is excluded from Reg Report because of data incorrect').'</span>';
				else
					$this->_CustomButtons[] = '<span class="error" style="padding-right: 20px;" >'.$this->langIf->getText('This data is incorrect and was rejected').'</span>';
			}

			// #2630 : participants cannot edit company details
			if($_SESSION['session_group_group_id'] != GROUP_PARTICIPANT) {
				$this->_addCustomButton($this->langIf->getText("Edit"), "button", array(
					'onclick' => "$('interface_form').process.value='edit'; $('interface_form').submit(); "
					//'onclick' => "window.location = 'InterfaceUKXMLPreparation.php?participant[id]=".$this->if_obj->model['participant_id'].
					//"&crso[id]=".$this->if_obj->model['crso_id']."&process=edit';"
				));
			}

			if($_SESSION['session_group_group_id'] != GROUP_PARTICIPANT
					&& $this->if_obj->model['reg_data']->pr_status != REG_ACCEPTED)
			{
				if($this->if_obj->model['reg_data']->pr_status == I_EXCLUDED_DATA_INCORRECT
					|| $this->if_obj->model['reg_data']->pr_status == A_EXCLUDED_DATA_INCORRECT)
					$this->_addCustomButton($this->langIf->getText("Include - Data correct"), "button", array(
							'onclick' => "$('interface_form').process.value='include'; $('interface_form').submit(); "));
				else
					$this->_addCustomButton($this->langIf->getText("Exclude from Reg Report - Data incorrect"), "button", array(
						'onclick' => "ExcludeProducer();"));
			}
		}
	}

	function getBrandFancySelect()
	{
		if(!$this->if_obj->model['reg_data'])
			return;

		$this->fancyHeaders = array(0=>$this->langIf->getText('Available Brands'),1=>'',2=>$this->langIf->getText('Your Selected Brands'));

		$props = array('class'=>'button');
		$this->fancybuttons = array('right'=>$props, 'left'=>$props, 'allRight'=>$props, 'allLeft'=>$props);//, 'up'=>$props, 'down'=>$props);

		$this->properties['size'] = 8;
		$this->properties['style'] = 'width: 50ex;';

		$used = $names = $this->options = $this->selectedoptions = array();

		$pb = new ParticipantBrand($this->db_app);
		$brands = $pb->getAllParticipantBrands($this->if_obj->model['participant_id'], $this->if_obj->model['crso_id'], true);

		if($this->if_obj->_hideInputs) {
			$this->_hideInput = true;
			$this->properties['value'] = $brands;
			return;
		}

		foreach($brands as $id => $value) {
			$this->selectedoptions[] = array('style'=>(in_array($id, $used)?'background-color: #66F; color:#FFF':''),'value'=>$id,'text'=>$value);
		}
		// Available Brands
		$b = new Brand($this->db_app);
		$q = $b->getByCRSO($this->if_obj->model['crso_id'],$_SESSION['selected_product_id']);
		while($r=$q->fetch())
		{
			if(!$r->ACTIVE)
				continue;
			if(in_array($r->BRAND_ID,$used))
				continue;
			$this->options[] = array('text'=>$r->NAME,'value'=>$r->BRAND_ID);
		}
	}

	function getNewBrand()
	{
		if($this->if_obj->_hideInputs) {
			$this->_hideInput = true;
			return;
		}

		$this->text = '<div style="float:right;text-align: right; padding-right: 55px;">
				<input type="text" style="width: 50ex;" id="newbrandinput" />
				<input type="button" class="button" id="addBrandButton" onclick="addBrand(document.getElementById(\'newbrandinput\'));" value="'.$this->langIf->getText('Add New Brand').'" />
			</div><div style="clear:both;">';
	}

}
?>
