<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
require_once(IWARE.'group.php');
require_once(ELC_CLASSES.'User.php');
require_once(ELC_CLASSES.'RelationUser.php');
require_once(ELC_CLASSES.'FormBehaviourPlugins.php');
/**
 *
 * @package ELC
 * @subpackage Interface
 * @author Nick Loeve <nick@basesoft.com>
 * @since 23-06-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceUserDetails extends InterfaceFactory
{
    /**
     * interface[id] = 128
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceUserDetails(&$db, &$db_app, &$langIf, $settings=array())
    {
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';

        // for ajax call
		if (!$settings && isset($_REQUEST['user']['id']) )
		{
			switch ($_SESSION['session_group_group_id'])
			{
				case GROUP_SYSADMIN:
					if(isset($_REQUEST['edit']) && $_REQUEST['edit'])
						$settings['_hideInputs'] = 'return false;';
					else
						$settings['_hideInputs'] = 'return true;';
					break;
					break;
				default:
					$settings['_hideInputs'] = 'return true;';
					break;
			}
			$settings['elcUser'] = 'return new ELCUser($this->db_app,'.$_REQUEST['user']['id'].');';
		}

        parent::InterfaceFactory($db, $db_app, $langIf, $settings);

        //add the elc specific form behaviour plugins
        $this->fb->addPlugin('elc_username_unique', 'FormBehaviourPluginUsernameUnique');
        $this->fb->addPlugin('elc_password_strong', 'FormBehaviourPluginPasswordStrong');
    }

   	function init($id)
	{
		$this->id = $id;
		parent::init($id);
	}

	/**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {
        if(isset($_REQUEST['process']) && $_REQUEST['process'] == 'ajaxusersave')
		{
	        if($this->elcUser->name == $_REQUEST['user']['name'])
	        	$this->fb->unregister('user[name]'); //we are not changing the name, so dont validate unique
	        $invalid = $this->langIf->getText('Please correct the form errors');

	        $user = new ELCUser($this->db_app,(int)$_REQUEST['user']['id']);
	        $user->set();
	        $user->setProperties($_REQUEST['user']);
	        $user->setPassword($_REQUEST['user']['password']);
	        $this->elcUser =& $user;

	        if(!$this->fb->validate())
	        {
		        $this->init($this->id);
	        	return $thrownException .= $invalid;
	        }
	        $user->update();
	        $this->init($this->id);
		}
    }

    function getDynamicJSBehaviours()
	{
		return 'ifHandler.watchFormOnChange("interface_form", function(){ $("ajaxuserstatus").innerHTML = "'.$this->langIf->getText('form details have been changed but are not saved...').'";}, ["ifI_951", "user_password", "ifRadiouser[active]1", "ifRadiouser[active]0"])';
	}
}
/**
 * @package ELC
 * @subpackage Interface
 * @author Nick Loeve <nick@basesoft.com>
 * @since 23-06-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceUserDetailsItem extends InterfaceItem
{
    /**
     * item[951] = user[name]
     */
    function getUsername()
    {
    	if(isset($this->if_obj->elcUser) && !$this->if_obj->elcUser->complete)
		{
			$this->if_obj->elcUser->set();
		}
    	if(isset($this->if_obj->elcUser))
    		$this->properties['value'] = $this->if_obj->elcUser->name;
    }

    /**
     * item[952] = user[password]
     */
    function getPassword()
    {
    	$this->properties['id'] = 'user_password';
    	if(isset($this->if_obj->elcUser))
    		$this->properties['value'] = ''; //$this->if_obj->elcUser->getPassword(); // FIXME . We don't show back the password
    }

    /**
     * item[953] = user[active]
     */
    function getUserActive()
    {
    	$this->options = array();
		$this->options[1] = array('value'=>1,'text'=>$this->langIf->getText('Yes'));
		$this->options[0] = array('value'=>0,'text'=>$this->langIf->getText('No'));

		if ($this->if_obj->elcUser->active)
		{
			$this->options[1]['checked'] = 'checked';
			$this->options[1]['selected'] = 'selected';
		}
		else
		{
			$this->options[0]['checked'] = 'checked';
			$this->options[0]['selected'] = 'selected';
		}
    }

 	/**
     * item[968] =
     */
    function getFiller()
    {
    	$this->text = '';
    }

    /**
     * item[954] =
     */
    function getButtons()
    {
    	$this->_BarButtons = 0;
    	$this->width = '100%';

    	switch ($_SESSION['session_group_group_id'])
		{
			case GROUP_SYSADMIN:
				if(!$this->if_obj->_hideInputs)
    			{
			    	$this->_CustomButtons[] = '<div id="ajaxuserstatus" style="color: red; display: inline;"></div>&nbsp;&nbsp;';
			    	$this->_addCustomButton($this->langIf->getText("View"), "button", array(
							'onclick' => "\$('interface_form_process').value = 'ajaxedit'; var params = []; params['ifId'] = ".$this->if_obj->id."; params['targetId'] = 'ifI_841'; jsbroker.callAndAttachRequestVars([['edit', '0'], ['user[id]', '".$_REQUEST['user']['id']."']".(isset($_REQUEST['participant']['id']) && isset($_REQUEST['crso']['id']) ? ", ['participant[id]', '".$_REQUEST['participant']['id']."'], ['crso[id]', '".$_REQUEST['crso']['id']."']" : "").(isset($_REQUEST['relation']['id']) ? ", ['relation[id]', '".$_REQUEST['relation']['id']."']" : "")."], 'loadInterface', params, ifHandler.buildInterface);"
							));
			    	$this->_addCustomButton('Show Password', 'button',
			    			array(
								'onclick' => "MessageBox.prototype.Information('".$this->langIf->getText("Item: UserPassword")."', '".$this->langIf->getText("Item: UserPassword").": ' + \$('user_password').value);"
			    			));
					$this->_addCustomButton("Save", "button", array(
							'onclick' => " \$('ajaxuserstatus').innerHTML = '".$this->langIf->getText('saving form details...')."'; \$('interface_form_process').value = 'ajaxusersave'; var params = []; params['ifId'] = ".$this->if_obj->id."; params['targetId'] = 'ifI_841'; jsbroker.callAndSubmitForm('interface_form', 'loadInterface', params, ifHandler.buildInterface);"
							));
					$this->_addCustomButton($_REQUEST['user']['id'], "hidden", array(
							'name' => 'user[id]'
							));
					$this->_addCustomButton(1, "hidden", array(
							'name' => 'edit'
							));
    			}
    			else
    			{
    				$this->_addCustomButton($this->langIf->getText("Edit"), "button", array(
						'onclick' => "\$('interface_form_process').value = 'ajaxedit'; var params = []; params['ifId'] = ".$this->if_obj->id."; params['targetId'] = 'ifI_841'; jsbroker.callAndAttachRequestVars([['edit', '1'], ['user[id]', '".$_REQUEST['user']['id']."']".(isset($_REQUEST['participant']['id']) && isset($_REQUEST['crso']['id']) ? ", ['participant[id]', '".$_REQUEST['participant']['id']."'], ['crso[id]', '".$_REQUEST['crso']['id']."']" : "").(isset($_REQUEST['relation']['id']) ? ", ['relation[id]', '".$_REQUEST['relation']['id']."']" : "")."], 'loadInterface', params, ifHandler.buildInterface);"
						));
    			}
				break;
		}
    }

	/**
     * item[966] = 129
     */
    function getInfoPerson()
    {
    }

	function getIsGeneralManager()
	{
		$this->_hideInput = true;
		if(isset($_REQUEST['participant']['id']) && isset($_REQUEST['crso']['id']))
		{
			$sql = "
						SELECT IF(ISNULL(cp.GENERAL_MANAGER_ID) OR ISNULL(cp.GENERAL_MANAGER_AUTHORIZED) OR (cp.GENERAL_MANAGER_AUTHORIZED < 2),
									0,
									1)
						as IS_GENERAL_MANAGER
						FROM TBL_USER as u
						LEFT JOIN TBL_CRSO_PARTICIPANT_PRODUCT as cp
							ON u.USER_ID = cp.GENERAL_MANAGER_ID
						WHERE u.USER_ID = ? AND
							cp.CRSO_RELATION_ID = ? AND
							cp.PARTICIPANT_RELATION_ID = ?
					";
			$q = $this->db_app->query($sql);
			$q->bind_values($this->if_obj->elcUser->id, (int)$_REQUEST['crso']['id'], (int)$_REQUEST['participant']['id']);
			$q->execute();
			if($r = $q->fetch())
				$this->properties['value'] = $r->{'IS_GENERAL_MANAGER'};
			else
				$this->properties['value'] = '';
			$this->hiddenFields[] = array('name'=>'participant[id]','value'=>$_REQUEST['participant']['id']);
			$this->hiddenFields[] = array('name'=>'crso[id]','value'=>$_REQUEST['crso']['id']);
		}
		else
		{
			$this->properties['value'] = false;
		}
	}

	function getIsAdminUser()
	{
		$this->_hideInput = true;
		$ru = new RelationUser($this->db_app);
		if($ru->validateAdmin($this->if_obj->elcUser->id, isset($_REQUEST['participant']['id']) ? (int)$_REQUEST['participant']['id'] : (int)$_REQUEST['relation']['id'], false))
			$this->properties['value'] = 1;
		else
			$this->properties['value'] = 0;
		$this->hiddenFields[] = array('name'=>'relation[id]','value'=>isset($_REQUEST['participant']['id']) ? (int)$_REQUEST['participant']['id'] : (int)$_REQUEST['relation']['id']);
	}
}

/**
 * CALLBACK[getUsername]
 * item[951] = {
 *     [handle] = Item: Username
 *     [behaviour] = required;elc_username_unique
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * CALLBACK[getPassword]
 * item[952] = {
 *     [handle] = Item: UserPassword
 *     [behaviour] = required;elc_password_strong
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getUserActive]
 * item[953] = {
 *     [handle] = Item: UserActive
 *     [behaviour] = required
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * CALLBACK[getFiller]
 * item[1007] = {
 *     [handle] = Item: filler
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 1
 *
 * CALLBACK[getIsGeneralManager]
 * item[998] = {
 *     [handle] = Item: IsGeneralManager
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * CALLBACK[getIsAdminUser]
 * item[1008] = {
 *     [handle] = Item: IsAdminUser
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getButtons]
 * item[954] = {
 *     [handle] = Item: UserDetailsButtons
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 */
?>
