<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
require_once(ELC_CLASSES.'Brand.php');
/**
 *
 * @package WEEE
 * @subpackage Interface
 * @since 02-11-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceBrandManagement extends InterfaceFactory
{
    /**
     * interface[id] = 153
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceBrandManagement(&$db, &$db_app, &$langIf)
    {
    	//for CRSO only admin users can access this interface
    	if($_SESSION['session_group_group_id'] == GROUP_CRSO)
        {
        	$ru = new RelationUser($db_app);
        	if(!$ru->hasClearance(CRSOClearanceMaintenance, $_SESSION['session_user_id'],$_SESSION['crso_relation_id']))
        		throw new InterfacePermissionException('['.$_SESSION['session_user_id'].'] tried to access crso admin interface without correct clearance: CRSOClearanceMaintenance');
        }
    	parent::InterfaceFactory($db, $db_app, $langIf);
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';

        $crso = new CRSO($this->db_app,array('relation'=>new Relation($this->db_app,$_SESSION['crso_relation_id'])));
        $this->model['brand'] = new Brand($this->db_app,array('crso'=>$crso));
    }
    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {
        if(!isset($_POST['process']))
        	return;

        if($_POST['process']=='save')
        {
        	foreach($_POST['brand'] as $id => $opts)
        		$this->fb->register(sprintf('brand[%s][name]',$id),'required;brand');

        	if(!$this->fb->validate())
	        	return $thrownException .= $this->langIf->getText('Please correct the form errors');

        	foreach($_POST['brand'] as $id => $opts)
        	{
        		$brand = new Brand($this->db_app,$id);
        		$brand->name = $opts['name'];
        		$brand->active = isset($opts['active']);
        		$brand->update();
        	}
        	$this->init($this->id);
        }
    }
}
/**
 * @package WEEE
 * @subpackage Interface
 * @since 02-11-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceBrandManagementItem extends InterfaceItem
{

    /**
     * item[1131] =
     */
    function getBrandOverview()
    {
    	$q = $this->if_obj->model['brand']->getOverview(null,$_SESSION['selected_product_id']);
    	$tf = new TableFactory($q,$this->langIf);
    	$tf->setValueProcessor(TF_ALL,array($this,'tfValueProcessor'));
    	$tf->hideColumns(array('BRAND_ID'));
    	$this->text = $tf->getXHTMLTable('Professional',2);
    }

	function tfValueProcessor($args)
	{
		$id = $args['row']['BRAND_ID'];
		switch($args['head'])
		{
			case 'BRAND_NAME':
				return sprintf('<input type="text" name="brand[%s][name]" value="%s" behaviour="required;brand" />',$id,$args['value']);
			break;
			case 'ACTIVE':
				return sprintf('<input type="checkbox" name="brand[%s][active]" value="1" %s />',$id,($args['value']?'checked="checked"':''));
			break;
			default:
				return $args['value'];
		}
	}

    /**
     * item[1132] =
     */
    function getButtons()
    {
    	$this->_BarButtons = BUTTON_SAVE;
    }

}

/**
 * CALLBACK[getBrandOverview]
 * item[1131] = {
 *     [handle] = Item: BrandOverview
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getButtons]
 * item[1132] = {
 *     [handle] = Item: ButtonBar
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 */
?>