<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
require_once(ELC_CLASSES.'Relation.php');
/**
 *
 * @package ELC
 * @subpackage Interface
 * @since 07-04-2006
 * @author Marten Koedam <marten@basesoft.com>
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceCRSODeclarationStatus extends InterfaceFactory
{
    /**
     * interface[id] = 94
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceCRSODeclarationStatus(&$db, &$db_app, &$langIf)
    {
        parent::InterfaceFactory($db, $db_app, $langIf);
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';

		$crso = new Relation($this->db_app,$_SESSION['crso_relation_id'],true);
		setPageTitlePostfix('('.$crso->name.')');
    }
    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {
    }
}
/**
 * @package ELC
 * @subpackage Interface
 * @since 07-04-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceCRSODeclarationStatusItem extends InterfaceItem
{

    /**
     * item[798] = participant[id]
     */
    function getParticipantSelect()
    {
		require_once(ELC_CLASSES.'CRSOParticipantProduct.php');
		require_once(ELC_CLASSES.'Participant.php');
		$p = new Participant($this->db_app);
		$q = $p->selectOverview($_SESSION['crso_relation_id']);
		$this->options = array(array('text'=>'- '.$this->langIf->getText('Select participant').' -','value'=>''));
		while($r = $q->fetch())
			$this->options[] = array('text'=>$r->PARTICIPANT_NAME,'value'=>$r->PARTICIPANT_RELATION_ID, 'selected'=>(isset($_REQUEST['participant']['id'])&& $_REQUEST['participant']['id'] == $r->PARTICIPANT_RELATION_ID));
    }

    /**
     * item[799] = period
     */
    function getPeriodSelect()
    {
		$this->options = array(array('text'=>'- '.$this->langIf->getText('Select period').' -','value'=>''));
		for($i=1;$i<=12;$i++)
			$this->options[] = array('text'=>strftime('%B', mktime(0, 0, 0, $i, 1)),'value'=>$i, 'selected'=>(isset($_REQUEST['period'])&& $_REQUEST['period']==$i));
    }

    /**
     * item[800] =
     */
    function getButtons()
    {
		$this->_BarButtons = 0;
		$this->_addCustomButton($this->langIf->getText('Apply Filter'),'submit');
    }

    /**
     * item[801] = 93 // Interface
     */
    function getDeclarationStatusInterface()
    {
		$this->settings['crso']['id']=$_SESSION['crso_relation_id'];

		if(isset($_REQUEST['participant']['id']))
			$this->settings['participant'] = $_REQUEST['participant'];

		if(isset($_REQUEST['period']))
			$this->settings['period'] = $_REQUEST['period'];
    }

}

/**
 * CALLBACK[getParticipantSelect]
 * item[798] = {
 *     [handle] = Item: ParticipantSelect
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * CALLBACK[getPeriodSelect]
 * item[799] = {
 *     [handle] = Item: PeriodSelect
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getButtons]
 * item[800] = {
 *     [handle] = Item: ButtonBar
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getDeclarationStatusInterface]
 * item[801] = {
 *     [handle] = Item: DeclarationStatusOverview
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 */
?>
