<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
require_once(ELC_CLASSES.'CRSO.php');
require_once(ELC_CLASSES.'CRSOProduct.php');
/**
 *
 * @package ELC
 * @subpackage Interface
 * @since 27-10-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceCRSOSettings extends InterfaceFactory
{
    /**
     * interface[id] = 151
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceCRSOSettings(&$db, &$db_app, &$langIf)
    {
    //	for CRSO only users with CRSOClearanceMaintenance can access this interface
    	if($_SESSION['session_group_group_id'] == GROUP_CRSO)
        {
        	$ru = new RelationUser($db_app);
        	if(!$ru->hasClearance(CRSOClearanceMaintenance, $_SESSION['session_user_id'],$_SESSION['crso_relation_id']))
        		throw new InterfacePermissionException('['.$_SESSION['session_user_id'].'] tried to access crso admin interface without correct clearance: CRSOClearanceMaintenance');
        }

    	parent::InterfaceFactory($db, $db_app, $langIf);
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';

        $this->model['cp'] = new CRSOProduct($this->db_app);
        $this->model['cp']->set($_SESSION['crso_relation_id'],$_SESSION['selected_product_id']);
    }

    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {
        if(isset($_POST['process']))
        {
        	if($_POST['process']=='save')
        	{
        		$cp = new CRSOProduct($this->db_app,$_POST['crso']);
				$cp->crso = $this->model['cp']->crso;
        		$cp->product = $this->model['cp']->product;
        		$cp->update();
        		header('Location: InterfaceCRSOSettings.php');
        		exit();
        	}
        }
    }
}
/**
 * @package
 * @subpackage Interface
 * @since 27-10-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceCRSOSettingsItem extends InterfaceItem
{

    /**
     * item[1114] =
     */
    function getProvDeclDeviation()
    {
    	$this->properties['value'] = $this->if_obj->model['cp']->prov_decl_deviation_trigger_percentage;
    }

    function getResubmitPercentage() {
    	$this->properties['value'] = $this->if_obj->model['cp']->resubmit_deviation_trigger_percentage;
    }

	/**
	 * item[1573] = crso[ac_cut_off_month]
	*/
	function getACCutOffMonth()
	{
		$this->options = array(array('value'=>null,'text'=>' - '.$this->langIf->getText('Month Select').' - '));
		for($i=1; $i<=12; $i++)
			$this->options[] = array('value'=>$i,'text'=>strftime('%B', mktime(1, 1, 1, $i, 1)),
									'selected'=>($i==$this->if_obj->model['cp']->ac_cut_off_month?'selected':false));
	}

	/**
     * item[1574] =
     */
    function getACCutOffDay()
    {
		$this->text = $this->langIf->getText('Annual Closure cut-off day will be set as maximum day between
			declaration export day and refund export day');
    }

    function getSettingsText() {
    	$sql = "SELECT p.`NAME` as PRODUCT_NAME,
			DATE(r.CREATED) as CREATED, FORFEIT_START_DATE,FORFEIT_DAY as DECLARATION_EXPORT_DAY,REFUND_START_DATE,
			REFUND_EXPORT_DAY,DECLARATION_REMINDER_DAY
			FROM TBL_CRSO_PRODUCT as cp
			INNER JOIN TBL_RELATION as r
				ON cp.CRSO_RELATION_ID = r.RELATION_ID
			INNER JOIN TBL_PRODUCT as p
				ON cp.PRODUCT_ID = p.PRODUCT_ID
			WHERE cp.CRSO_RELATION_ID = ?";

    	$q = $this->if_obj->db->query($sql);
    	$q->bind_values($_SESSION['crso_relation_id']);
    	$q->execute();

    	$tf = new TableFactory($q, $this->langIf);

    	$this->text = $tf->getXHTMLTable('professional', 2);

    }

    /**
     * item[1113] =
     */
    function getButtons()
    {
    	$this->_BarButtons = BUTTON_SAVE;
    }

}

/**
 * CALLBACK[getProvDeclDeviation]
 * item[1114] = {
 *     [handle] = Item: Prov. Decl. Deviation Trigger Percentage
 *     [behaviour] = integer(0)
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getButtons]
 * item[1113] = {
 *     [handle] = Item: ButtonBar
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 */
?>