<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
require_once(ELC_CLASSES.'ProductComponent.php');
/**
 *
 * @package
 * @subpackage Interface
 * @since 27-11-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceComponentManagement extends InterfaceFactory
{
    /**
     * interface[id] = 159
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceComponentManagement(&$db, &$db_app, &$langIf)
    {
        parent::InterfaceFactory($db, $db_app, $langIf);
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';

        if($_SESSION['session_group_group_id'] == GROUP_CRSO)
        {
        	$ru = new RelationUser($db_app);
        	if(!$ru->hasClearance(CRSOClearanceMaintenance, $_SESSION['session_user_id'],$_SESSION['crso_relation_id']))
        		throw new InterfacePermissionException('['.$_SESSION['session_user_id'].'] tried to access crso admin interface without correct clearance: CRSOClearanceMaintenance');
        }

        $this->model['component'] = new ProductComponent($this->db_app);
        $this->model['component']->product = new Product($this->db_app,$_SESSION['selected_product_id']);
        if(isset($_REQUEST['component']['id']))
        {
        	$this->model['component']->set($_REQUEST['component']['id']);
        	if($this->model['component']->crso->relation->id!=$_SESSION['crso_relation_id'])
        	{
        		alert(sprintf('CRSO [%s] trying to acces Component [%s] that is not his!',$_SESSION['crso_relation_id'],$_REQUEST['component']['id']));
        		throw new InterfacePermissionException(sprintf('CRSO [%s] trying to acces Component [%s] that is not his!',$_SESSION['crso_relation_id'],$_REQUEST['component']['id']));
        	}
        	$this->hiddenFields = array(array('name'=>'component[id]','value'=>$_REQUEST['component']['id']));
        }

    }
    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {
        if(!isset($_POST['process']))
        	return;

        if($_POST['process']=='save')
        {
        	$component = new ProductComponent($this->db_app,$_POST['component']);
        	$component->crso = new CRSO($this->db_app,array('relation'=>new Relation($this->db_app,$_SESSION['crso_relation_id'])));
        	$component->product =& $this->model['component']->product;
        	$component->id ? $component->update() : $component->insert();

        	header('Location: InterfaceComponentManagement.php');
        	exit();
        }
    }
}
/**
 * @package
 * @subpackage Interface
 * @since 27-11-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceComponentManagementItem extends InterfaceItem
{

    /**
     * item[1158] =
     */
    function getComponentOverview()
    {
    	$this->if_obj->model['component']->product->set();

    	$ds = $this->if_obj->model['component']->getByProductCRSO($_SESSION['crso_relation_id']);
    	$tf = new TableFactory($ds,$this->langIf);
    	$tf->setCaption(sprintf('%s (%s)',$this->langIf->getText('Component Overview'),$this->if_obj->model['component']->product->name),false);
    	$tf->setEmptyText($this->langIf->getText('No Components Available for selected Product'));

    	$tf->setValueProcessor('COMPONENT_ID',array($this,'tfComponentLink'));

    	$this->text = $tf->getXHTMLTable('Professional',2);
    }

	function tfComponentLink($args)
	{
		return sprintf('<a href="/%sscripts/elc/crso/InterfaceComponentManagement.php?component[id]=%s">%s</a>',SITE_PATH,$args['value'],$args['value']);
	}

    /**
     * item[1159] = component[name]
     */
    function getComponentName()
    {
    	$this->properties['value'] = isset($this->if_obj->model['component']->id)?$this->if_obj->model['component']->name:'';
    }

    /**
     * item[1160] =
     */
    function getButtons()
    {
    	$this->_BarButtons = 0;

    	$trans = isset($this->if_obj->model['component']->id)?'Update Component':'Add Component';

    	$this->_addCustomButton($this->langIf->getText($trans),'submit',array());
    }

}

/**
 * CALLBACK[getComponentOverview]
 * item[1158] = {
 *     [handle] = Item: ComponentOverview
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getComponentName]
 * item[1159] = {
 *     [handle] = Item: ComponentName
 *     [behaviour] = required
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * CALLBACK[getButtons]
 * item[1160] = {
 *     [handle] = Item: ButtonBar
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 */
?>