<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
/**
 *
 * @package
 * @subpackage Interface
 * @since 23-07-2010
 * @copyright 2010 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceCountrySettingsOverview extends InterfaceFactory
{
    /**
     * interface[id] = 198
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceCountrySettingsOverview(&$db, &$db_app, &$langIf)
    {
        parent::InterfaceFactory($db, $db_app, $langIf);
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';
    }
    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {

    }
}
/**
 * @package
 * @subpackage Interface
 * @since 23-07-2010
 * @copyright 2010 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceCountrySettingsOverviewItem extends InterfaceItem
{

    /**
     * item[1569] =
     */
    function getCountrySettingsOverview()
    {
    	require_once(ELC_CLASSES.'CRSOProduct.php');
    	require_once(ELC_CLASSES.'Country.php');

    	$rel = new Relation($this->db_app, $_SESSION['crso_relation_id']);
    	$country = new Country($this->db_app, $rel->getCountry(), true);
    	$cp = new CRSOProduct($this->db_app);
    	$products = $cp->getProducts($_SESSION['crso_relation_id']);

    	$ds = array();

    	$i = 0;
    	foreach($country->settingsArray as $setting) {

    		$ds[$i][$this->langIf->getText('Setting')] = $this->langIf->getText($setting);

    		$i++;
    	}
    	$process = array();
    	while($r = $products->fetch()) {

    		$process[] = $r->PRODUCT_NAME;
    		$i = 0;
    		foreach($country->settingsArray as $setting) {

    			$ds[$i][$r->PRODUCT_NAME] = $country->has(constant($setting), $r->PRODUCT_ID);

    			$i++;
    		}

    	}
    	$i = 0;
    	foreach($country->settingsArray as $setting) {

    		$ds[$i][$this->langIf->getText('Description')] = nl2br($this->langIf->getText('Description for '.$setting));

    		$i++;
    	}


    	$tf = new TableFactory($ds);
    	$tf->setValueProcessor($process, array($this, '_tfBoolean'));


    	$this->text = $tf->getXHTMLTable('Professional', 2);
    }

    function _tfBoolean($args) {
		return sprintf('<img src="%si-w/%s.gif" />', REL_IMAGES, ($args['value']?'true':'false'));
    }

}

/**
 * CALLBACK[getCountrySettingsOverview]
 * item[1569] = {
 *     [handle] = Item: Overview
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 */
?>

