<?php
require_once(INTERFACE_OBJ."InterfaceFactory.php");
require_once(IWARE.'group.php');
define('BLOCK_TRANSLATE',135);
define('BLOCK_BUTTONS',155);
/**
 * @package ELC
 * @subpackage Interface
 * @author
 * @copyright (2005) BaseSoft B.V.
 * @version $Id$
 */
class InterfaceEmailTranslator extends InterfaceFactory
{
	function InterfaceEmailTranslator($db, $db_app, $langIf)
	{
	//for CRSO only admin users can access this interface
    	if($_SESSION['session_group_group_id'] == GROUP_CRSO)
        {
        	// There is no separate Clearance Level for eMail Translator. So below check is appropriate.
        	$ru = new RelationUser($db_app);
        	if(!$ru->validateAdmin($_SESSION['session_user_id'],$_SESSION['crso_relation_id'],false))
        		throw new InterfacePermissionException('['.$_SESSION['session_user_id'].'] tried to access crso admin interface');
        }

		$this->FirstColWidth = 25;
		$this->delimiter = '<br />';
		parent::InterfaceFactory($db, $db_app, $langIf);

		require_once(IWARE.'nLanguage.php');
		$this->langmodel = new nLanguage($this->db_app, isset($_REQUEST['language']['id'])?$_REQUEST['language']['id']:$_SESSION['session_user_language_id']);

		require_once(IWARE . 'message_handler.php');
		$this->model = new Message($this->db_app);

		if ( isset($_REQUEST['message']) )
			$this->model->set($_REQUEST['message']['id'], $this->langmodel->id);
	}

	function init($ifId)
	{
		$rv = parent::init($ifId);

		if($_SESSION['session_group_group_id']==GROUP_CRSO)
			unset($this->blocks[BLOCK_BUTTONS]);

		return $rv;
	}

	function processInput()
	{
		if($_SESSION['session_group_group_id']!=GROUP_SYSADMIN)
			return;

		if (isset($_REQUEST['process']) && $_REQUEST['process'] == 'save')
		{
			// convert newlines to br and remove any newline leftovers
			$m = $_POST['message'];
			$m['html'] = nl2br($m['html']);
			$m['html'] = str_replace("\r", "", $m['html']);
			$m['html'] = str_replace("\n", "", $m['html']);

			// save to db
			$this->model->addLanguage($_REQUEST['language']['id'], $m);
			$this->model->update();
			$this->init($this->id);
		}
	}

}

class InterfaceEmailTranslatorBlock extends InterfaceBlock
{
	function InterfaceEmailTranslatorBlock(&$db,&$db_app,&$langIf,$id=0,$blockmap=array())
	{
		parent::InterfaceBlock($db,$db_app,$langIf,$id,$blockmap);
		if($_SESSION['session_group_group_id']!=GROUP_SYSADMIN)
		{
			if($id==BLOCK_TRANSLATE)
				$this->_hideInputs = true;
		}
	}
}

class InterfaceEmailTranslatorItem extends InterfaceItem
{
	/**#@+
	 * Callback functions made from InterfaceItem
	 */
	/**#@-*/

	/**
	 * set Available Translatablelanguages
	 */
	function getLanguageSelect()
	{
		if($_SESSION['session_group_group_id']!=GROUP_SYSADMIN)
			$this->hiddenFields = array(array('name'=>'language[id]','value'=>''));
		$lang =& $this->if_obj->langmodel;
		$q = $lang->getEditable();
		$this->options = array(array('value'=>'','text'=>'- '.$this->langIf->getText('Select language').' -'));

		while($r = $q->fetch())
		{
			if (isset($_REQUEST['language']['id']))
				$selected = $r->LANGUAGE_ID == $_REQUEST['language']['id'];
			else
				$selected = $r->LANGUAGE_ID == $_SESSION['session_user_language_id'];

			if ($selected)
				$this->options[] = array('text'=>$r->LANGUAGE,'value'=>$r->LANGUAGE_ID, 'selected'=>'selected');
			else
				$this->options[] = array('text'=>$r->LANGUAGE,'value'=>$r->LANGUAGE_ID);
		}

		$this->properties['onchange'] = 'loadMessage()';

		$this->postscript = "
		function loadMessage()
		{
			var msg_id = getElByName('message[id]').value;
			var lang_id = getElByName('language[id]').value;
			var interface_id=".$this->parent->parent->id.";
			var url = '&interface_id='+interface_id+'&message[id]='+msg_id+'&language[id]='+lang_id;

			if (msg_id && lang_id)
				ifHandler.loadBlock( new Array(new String('135')), url );

			loadOtherLanguage();
		}";

	}

	/**
	 * Set Available Event Messages
	 */
	function getMessageSelect()
	{
		$sql = "SELECT * FROM TBL_MESSAGE WHERE COMPANY_ID=?"; // FIXME : need to get this from message_handler
		$q = $this->db_app->query($sql);
		$q->bind_values($_SESSION['session_user_company_id']);
		$q->execute();

		$this->options = array(array('value'=>'','text'=>'- '.$this->langIf->getText('Select message').' -'));
		$i=1;
		while($r = $q->fetch()) {
			$this->options[$i] = array('text'=>$this->langIf->getText($r->MESSAGE_HANDLE), 'value'=>$r->MESSAGE_ID);

			if (isset($_REQUEST['message']['id']) && $_REQUEST['message']['id'] == $r->MESSAGE_ID)
				$this->options[$i]['selected']  = 'selected';

			$i++;
		}

		$this->properties['onchange'] = 'loadMessage()';
	}

	/**
	 * set All available languages
	 */
	function getOtherLanguageSelect()
	{
		if($_SESSION['session_group_group_id']==GROUP_CRSO)
			$this->_hideInput = true;
		require_once(IWARE.'nLanguage.php');
		$lang =& $this->if_obj->langmodel;
		$q = $lang->get();
		$this->options = array(array('value'=>'','text'=>'- '.$this->langIf->getText('Select language').' -'));
		$i = 1;
		while($r = $q->fetch())
		{
			$this->options[$i] = array('text'=>$r->LANGUAGE,'value'=>$r->LANGUAGE_ID);

			if (isset($_REQUEST['other_language']['id']))
				$selected = $_REQUEST['other_language']['id'] == $r->LANGUAGE_ID;
			else
				$selected = $r->LANGUAGE_ID == $_SESSION['session_user_language_id'];

			if ($selected)
				$this->options[$i]['selected']  = 'selected';

			$i++;
		}

		$this->postscript = "
			function loadOtherLanguage()
			{
				var params = new Array();
				try
				{
					params['language_id'] = getElByName('other_language[id]').value;
					params['message_id']  = getElByName('message[id]').value;

					jsbroker.call('getMessage', params, function(params) {

					var nSubject = getElByName('other_message[subject]');
					var nContent = getElById('other_message_content');

					if (params) {
						nSubject.value = params['SUBJECT'];
						nContent.innerHTML = params['CONTENT'].replace(/<%/gi, '&lt;%').replace(/%>/gi, '%&gt;');
					}
					else {
						nSubject.value = '".jsescape('No translation available')."';
						nContent.innerHTML = '".jsescape('No translation available')."';
					}
				});
				}
				catch(e)
				{};
			}
			loadOtherLanguage();
		";

		$this->properties['onchange'] = 'loadOtherLanguage(this)';
	}

	/**
	 * set subject and content
	 */
	function getItemValue()
	{
	}

	function getSubject()
	{
		$this->properties['style'] = 'width: 300px';
		$this->properties['value'] = $this->if_obj->model->getSubject($this->if_obj->langmodel->id);
	}

	function getContent()
	{
		$this->properties['style'] = 'width: 600px; height: 200px;';

		// broken tinymce (the plugins specifically)
		/*
		$this->is_tiny_mce = true;

		// no buttons but field reference
		$this->tiny_mce_settings['plugins'] = 'field_references';
		$this->tiny_mce_settings['theme_advanced_buttons1'] = 'field_references';
		$this->tiny_mce_settings['theme_advanced_buttons2'] = '';
		$this->tiny_mce_settings['theme_advanced_buttons3'] = '';
		$this->tiny_mce_settings['theme_advanced_toolbar_align'] = 'right';

		$fields = array(
			'Participant'=> array(
				'CompanyName'=>'Company Name',
				'AdminName'=>'Admin Name',
				'Url'=>'Url',
				'Email'=>'Email',
				'UserName'=>'UserName'
				// 'Password'=>'Password' // we don't show the password block anymore
			),
			'CRSO '=> array(
				'CrsoCompanyName'=>'Crso Company Name',
				'CrsoAdminName'=>'Crso Admin Name',
				'CrsoEmail'=>'Crso Email'
			),
			'EmailToImporter'=>array(
				'ImporterName'=>'Importer Name',
				'ImporterCountry'=>'Importer Country',
				'ImporterConfirmationLink'=>'Importer confirmation link'
			),
			'Other'=> array(
				'NotificationSubjects'=>'Notification Subjects',
				'LoginLink'=>'Login Link'
			)
		);
		$this->tiny_mce_settings['field_references'] = $fields;
		*/


		$html = $this->if_obj->model->getHtml($this->if_obj->langmodel->id, false);
		// workaround for malfunction of tinymce: replace <br/> with a newline for editing
		// and put the br's back when saved
		$text = str_replace('<br />', "\n", $html);
		$this->value = $text;
	}

	function otherSubject()
	{
		if($_SESSION['session_group_group_id']!=GROUP_SYSADMIN)
			$this->properties['disabled'] = 'disabled';
		$this->readOnly();
		$this->properties['style'] = 'width: 300px';
	}

	function otherContent()
	{
		$this->text = '<div id="other_message_content" style="overflow: scroll; width: 600px; height: 200px; border: 1px solid #ababab;"></div>';
	}

	function readOnly()
	{
		$this->properties['readonly'] = 'readonly';
	}

	function getButtons()
	{
		if($_SESSION['session_group_group_id']!=GROUP_SYSADMIN)
                    $this->_BarButtons = '';
                else
                    $this->_BarButtons = BUTTON_SAVE + BUTTON_CANCEL;
	}
}
?>
