<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
require_once(ELC_CLASSES.'RemoteViewer.php');
/**
 *
 * @package
 * @subpackage Interface
 * @since 29-07-2010
 * @copyright 2010 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceRVOverview extends InterfaceFactory
{
    /**
     * interface[id] = 200
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceRVOverview(&$db, &$db_app, &$langIf)
    {
        parent::InterfaceFactory($db, $db_app, $langIf);
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';

        $this->model['rv'] = new RemoteViewer($this->db_app);

        $this->script = sprintf("
		function startViewing(id) {
			var nwin = new NewWindow(800, 600);
				nwin.setSource('/%sscripts/elc/crso/RemoteViewer.php?rv[id]='+id);
				nwin.setName('winPrint');
				nwin.setScrollbars(true);
				var win = nwin.open();
				// Reload the page.
				document.location.href='/%sscripts/elc/crso/InterfaceRVOverview.php';
		}

		", SITE_PATH, SITE_PATH);
    }
    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {

    }
}
/**
 * @package
 * @subpackage Interface
 * @since 29-07-2010
 * @copyright 2010 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceRVOverviewItem extends InterfaceItem
{

    /**
     * item[1575] =
     */
    function getOverview()
    {
	$ds = $this->if_obj->model['rv']->getCRSOOverview($_SESSION['crso_relation_id']);
	$tf = new TableFactory($ds, $this->langIf);
	$tf->setEmptyText($this->langIf->getText('No open Remote Viewing invitations'));

	$tf->hideColumns(array('Id'));
	$tf->setValueProcessor(TF_ALL, array($this, 'tfValueProcessor'));

	$this->text = $tf->getXHTMLTable('Professional', 2);
    }

    function tfValueProcessor($args) {

	switch($args['head']) {
		case "REQUEST_STATUS":
			list($translation, $css) = $this->if_obj->model['rv']->translateStatus($this->langIf, $args['value']);
			return sprintf('<span class="%s">%s</span>', $css, $translation);
		break;
		case "View":
			return sprintf('<a href="#" onclick="startViewing(%s);">%s</a>', $args['row']['Id'], $this->langIf->getText('Start viewing'));
		break;
	}
	return $args['value'];
    }


}

/**
 * CALLBACK[getOverview]
 * item[1575] = {
 *     [handle] = Item: Overview
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 */
?>
