<?php
require_once(INTERFACE_OBJ."InterfaceFactory.php");

require_once(ELC_CLASSES.'RelationUser.php');
require_once(ELC_CLASSES.'CRSOParticipantProduct.php');
/**
 * InterfaceRegistrantUserOverview
 *
 * @package ELC
 * @subpackage Interface
 * @author
 * @copyright (2005) BaseSoft B.V.
 * @version $Id$
 */
class InterfaceRegistrantUserOverview extends InterfaceFactory
{
	function InterfaceRegistrantUserOverview($db, $db_app, $langIf)
	{
		// Is the participant selected part of the current CRSO?
		// Make sure they dont chnage IDs in the request string.
		$this->cp = new CRSOParticipantProduct($db_app);
		if(!$this->cp->set($_SESSION['crso_relation_id'], $_REQUEST['participant']['id'],$_SESSION['selected_product_id']))
			throw new InterfacePermissionException('Incorrect combination for CRSO-Participant-Product');

		$this->cp->participant->relation->set();
		setPageTitlePostfix('('.$this->cp->participant->relation->name.')');

		$this->FirstColWidth = 25;
		$this->delimiter = '<br />';
		parent::InterfaceFactory($db, $db_app, $langIf);
	}
}

class InterfaceRegistrantUserOverviewItem extends InterfaceItem
{
	/**#@+
	 * Callback functions made from InterfaceItem
	 */
	/**
	 *
	 */
	function getOverview()
	{
		// Get all the users for this participant
		$ru = new RelationUser($this->db_app);
		$q = $ru->selectByRelation($_REQUEST['participant']['id']);

		require_once(IWARE.'TableFactoryColumnPlugin.php');
		$tf = new TableFactoryColumnPlugin(false,$this->langIf,$this->db,$this->db_app);
		$tf->setEmptyText($this->langIf->getText('No users found') );
		$tf->setData($q, 'ParticipantUserOverview',false,true);

		//$tf->setSortingFunctions(array());
		$tf->setCaption('<img src="/'.SITE_PATH.'images/block_arrow.png" /> '.$this->langIf->getText('Participant User Overview'), false);
		$tf->setValueProcessor(array('IS_ADMIN', 'USER_ACTIVE', 'STATUS'),'return $value?\'<img src="/\'.SITE_PATH.\'images/i-w/true.gif" />\':\'<img src="/\'.SITE_PATH.\'images/i-w/false.gif" />\';');

		$tf->setValueProcessor('USER_ID', array($this, 'tfValueProcessor'));
		$tf->setValueProcessor('USER_NAME', array($this, 'tfUserNameValueProcessor'));
		$tf->hideColumn('ALLOW_CRSO_LOGIN');

		$this->text = $tf->getXHTMLTable('Professional',2);

		$this->script = sprintf('
			function doLogin(loginname)
			{
				MessageBox.prototype.Question(
					\'%s\',
					\'%s\', function(){
						document.location.href = "/scripts/elc/public/login.php?action=login&different_user=1&loginname="+loginname;
					});
			}',
			'Login',
			jstr('Are you sure you want to login as this user?'),
			SITE_PATH
		);;

	}

	function tfValueProcessor($args)
	{
		return sprintf('<a href="InterfaceParticipantUserRegistration.php?user[id]=%s&participant[id]=%s">%s</a>', $args['value'], $_REQUEST['participant']['id'], $args['value']);
	}

	function tfUserNameValueProcessor($args)
	{
		$cp = new CRSOParticipantProduct($this->db_app);
		if (!$cp->hasCrsoParticipantLogin($_REQUEST['participant']['id'], $_SESSION['selected_product_id'])) {
			return $args['value'];
		}

		if (!$args['row']['ALLOW_CRSO_LOGIN'])
			return $args['value'];

		return sprintf('<a href="#" onclick="doLogin(\'%s\');">%s</a>', $args['value'], $args['value']);


	}

	/**
	 *
	 */
	function getButtons()
	{
		$this->_BarButtons = BUTTON_CANCEL+BUTTON_DELETE;
		//$this->_addCustomButton($this->langIf->getText('Add new Participant User'),'button',array('onclick'=>"document.location.href='';"));
		$this->_ButtonOptions[BUTTON_CANCEL] = array('onclick'=>"document.location.href='InterfaceRegistrationsOverview.php';");
	}
	/**#@-*/
}
