<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
/**
 *
 * @package ELC
 * @subpackage Interface
 * @since 13-04-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceTrustOverview extends InterfaceFactory
{
    /**
     * interface[id] = 99
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceTrustOverview(&$db, &$db_app, &$langIf)
    {
        parent::InterfaceFactory($db, $db_app, $langIf);
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';
    }
    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {

    }
}
/**
 * @package ELC
 * @subpackage Interface
 * @since 13-04-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceTrustOverviewItem extends InterfaceItem
{

    /**
     * item[813] =
     */
    function getOverview()
    {
    	require_once(ELC_CLASSES.'Trust.php');
    	$t = new Trust($this->db_app);

    	$q = $t->selectCrsoOverview( $_SESSION['crso_relation_id'], $_SESSION['selected_product_id'] );

		require_once(IWARE.'TableFactoryColumnPlugin.php');
		$tf = new TableFactoryColumnPlugin(false,$this->langIf,$this->db,$this->db_app);
		$tf->setData($q, 'TrustOverview',false,true);
		$tf->hideColumns(array('SUBROGATOR_RELATION_ID', 'TRUSTEE_RELATION_ID'));

		$tf->setValueProcessor('TRUST_ID', 'return \'<a id="trust_\'.$row[\'SUBROGATOR_RELATION_ID\'].\'_\'.$row[\'TRUSTEE_RELATION_ID\'].\'" href="InterfaceTrustDetail.php?trust[id]=\'.$value.\'&subrogator[id]=\'.$row[\'SUBROGATOR_RELATION_ID\'].\'">\'.$value.\'</a>\';');

		$p = 'return \'<img src="/\'.SITE_PATH.\'images/i-w/\'.($value?\'true\':\'false\').\'.gif" />\';';
		$tf->setValueProcessor('TRUST_SUBROGATOR_APPROVED', $p);
		$tf->setValueProcessor('TRUST_TRUSTEE_APPROVED', $p);
		$tf->setValueProcessor('TRUST_CRSO_APPROVED', $p);
		$tf->setValueProcessor('AGREEMENT_DOCUMENT', $p);

		$tf->setEmptyText($this->langIf->getText('No trusts found') );
		$this->text = $tf->getXHTMLTable('Professional',2);

    }

}

/**
 * CALLBACK[getTrustOVerview]
 * item[813] = {
 *     [handle] = Item: TrustOverview
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 */
?>
