<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
require_once(ELC_CLASSES.'ro/WasteReportController.php');

define('ITEM_UPLOAD_WASTE_CSV', 1688);

/**
 *
 * @package
 * @subpackage Interface
 * @since 25-01-2017
 * @copyright 2017 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceWasteReportUpload extends InterfaceFactory
{
	/**
	 * interface[id] = 204
	 * @param $db Database (I_WARE_SETTINGS)
	 * @param $db_app Database (APPLICATION DATABASE)
	 * @param $langIf LanguageInterface
	 */
	function InterfaceWasteReportUpload(&$db, &$db_app, &$langIf)
	{
		parent::InterfaceFactory($db, $db_app, $langIf);
		$this->FirstColWidth = 25;
		$this->delimiter = '<br />';

		$this->model['crso'] = new CRSO($db_app, array('relation'=> new Relation($this->db_app, $_SESSION['crso_relation_id'])));
		$this->model['user'] = new ELCUser($db_app, $_SESSION['session_user_id']);
	}
	/**
	 * @param string &$thrownException
	 */
	function processInput(&$thrownException)
	{
		if(!isset($_POST['process']))
			return;

		if($_POST['process'] != 'save')
			return;

		$item = new InterfaceItem($this->db,$this->db_app,$this->langIf);
		$document = $item->getDocument('waste_report_file', ITEM_UPLOAD_WASTE_CSV);
		$document->makePermanent();
		$log = getLog();
		$log->info(sprintf('Saved CSV file for Waste Report [%s]', $document->id));

		try {
			$wrc = new WasteReportController($this->db_app, $this->model['crso'], $this->model['user']);
			$wrc->upload(DOCUMENT_REPOSITORY . $document->file_name);
		} catch (WEEEException $e) {
			// tell the user the exception message
			$thrownException = $e->getMessage();
			return;
		}
		header('Location: InterfaceWasteReportingList.php');
		exit();
	}
}
/**
 * @package
 * @subpackage Interface
 * @since 25-01-2017
 * @copyright 2017 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceWasteReportUploadItem extends InterfaceItem
{

	/**
	 * item[1690] =
	 */
	function getWasteReportIntroduction()
	{
		$this->twoCols = true;
		$this->text = $this->langIf->getText("Please provide a valid CSV file with the correct Waste Reporting data for each participant. Please note that once uploaded this data cannot be changed.");
	}

	/**
	 * item[1689] =
	 */
	function getButtons()
	{
		$this->_BarButtons = BUTTON_SAVE;
	}

}

/**
 * CALLBACK[getWasteReportIntroduction]
 * item[1690] = {
 *     [handle] = Item: Introduction
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getButtons]
 * item[1689] = {
 *     [handle] = Item: Buttons
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 */
?>
