<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
require_once(ELC_CLASSES.'Country.php');
require_once(IWARE.'group.php');
/**
 *
 * @package ELC
 * @subpackage Interface
 * @author Marten Koedam <marten@dalines.com>
 * @since 05-07-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceCountryLegalNotice extends InterfaceFactory
{
    /**
     * interface[id] = 136
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceCountryLegalNotice(&$db, &$db_app, &$langIf)
    {
		if(!isset($_REQUEST['country']['id']))
			throw new InterfacePermissionException('Unauthorized Access to Legal Notice Interface');

        parent::InterfaceFactory($db, $db_app, $langIf);
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';

        $this->model['country'] = new Country($this->db_app,$_REQUEST['country'],true);
        $this->hiddenFields[] = array('name'=>'country[id]','value'=>$this->model['country']->id);
        setPageTitlePostfix('('.$this->model['country']->name.')');
    }
    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {
        if(isset($_POST['process']))
        {
        	if($_POST['process'] == 'save')
        	{
        		$this->model['country']->legal_notice = $_POST['country']['legal_notice'];
        		$this->model['country']->update();
        		header('Location: InterfaceCountryLegalNotice.php?country[id]='.$this->model['country']->id);
        		exit();
        	}
        }
    }
}
/**
 * @package ELC
 * @subpackage Interface
 * @since 05-07-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceCountryLegalNoticeItem extends InterfaceItem
{

    /**
     * item[996] = country[legal_notice]
     */
    function getLegalNotice()
    {
		$this->properties['style'] = 'width: 600px; height: 200px;';
		$this->is_tiny_mce = true;

		// no buttons but field reference
		$this->tiny_mce_settings['theme_advanced_buttons1'] = 'bold,italic,underline,separator,bullist,numlist,separator,undo,redo,link,unlink';
		$this->tiny_mce_settings['theme_advanced_buttons2'] = '';
		$this->tiny_mce_settings['theme_advanced_buttons3'] = '';
		$this->tiny_mce_settings['theme_advanced_toolbar_align'] = 'left';
		$this->value = $this->if_obj->model['country']->legal_notice;
    }
	function getButtons()
	{
		$this->_BarButtons = BUTTON_SAVE+BUTTON_CANCEL;
		$this->_ButtonOptions[BUTTON_CANCEL] = array('onclick'=>"go('InterfaceCountryOverview.php');");
	}
}

/**
 * CALLBACK[getLegalNotice]
 * item[996] = {
 *     [handle] = Item: LegalNotice
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 */
?>
