<?php
/**
 *
 */
require_once(INTERFACE_OBJ."InterfaceFactory.php");
require_once(ELC_CLASSES.'Product.php');
require_once(IWARE.'group.php');
/**
 *
 *
 * @package ELC
 * @subpackage Interface
 * @author Marten Koedam <marten@basesoft.com>
 * @copyright (2005) BaseSoft B.V.
 * @since 21-01-2005
 * @version $Id$
 */
class InterfaceCountryOverview extends InterfaceFactory
{
	function InterfaceCountryOverview($db, $db_app, $langIf)
	{
		$this->FirstColWidth = 25;
		$this->delimiter = '<br />';
		parent::InterfaceFactory($db, $db_app, $langIf);


		switch($_SESSION['session_group_company_id'])
		{
			case GROUP_SYSADMIN:
				$sql = "SELECT COUNTRY_ID FROM TBL_COUNTRY WHERE REGION_ID = 1 AND SETTINGS > 0";
				$q = $this->db_app->query($sql);
				$q->execute();
				$this->model['countries'] = array();
				while($r = $q->fetch())
					$this->model['countries'][$r->COUNTRY_ID] = $r->COUNTRY_ID;
				$this->model['readonly'] = false;
				$this->model['prefix'] = 'sysadmin';
			break;
			default:
				throw new InterfacePermissionException('Unauthorized Access to Interface');
		}


		require_once(ELC_CLASSES.'Country.php');
		$this->model['product'] = new Product($this->db_app,$_SESSION['selected_product_id'],true);
	}
}
/**
 * @package ELC
 * @subpackage Interface
 */
class InterfaceCountryOverviewItem extends InterfaceItem
{
	function getOverview()
	{
		$country = new Country($this->db_app);
		$q = $country->selectOverview($this->if_obj->model['countries']);

		// Rotate the dataset to make the display better readable. Dont pass the langIf, we dont need to translate

		$ds = array();

		$hiddenCols = array('SETTINGS','COUNTRY_ID');
		if($this->if_obj->model['readonly'])
			$hiddenCols[] = 'ProductSettings';

		$valproc = array('CODE', 'LEGAL_NOTICE', 'ProductSettings');

		while($r = $q->fetchAssoc())
		{
			$i = 0;
			foreach($r as $index => $value)
			{
				if(in_array($index,$hiddenCols))
					continue;
				$ds[$i][1] = $this->langIf->getText($index);
				if(in_array($index,$country->settingsArray)) {

					$weeeCountry = new WEEECountry($this->db_app, $r['COUNTRY_ID'], true);
					$value = ($weeeCountry->has(constant($index), $_SESSION['selected_product_id'])) ?
						'<img id="'.$r['CODE'].'_'.$index.'_on" src="/'.SITE_PATH.'images/i-w/true.gif" />' :
						'<img id="'.$r['CODE'].'_'.$index.'_on" src="/'.SITE_PATH.'images/i-w/false.gif" />';
				}
				if(in_array($index,$valproc))
				{
					$args = array('head'=>$index,'row'=>array('COUNTRY_ID' => $r['COUNTRY_ID'],'CODE'=>$r['CODE']),'value'=>$value);
					$value = $this->tfValueProcessor($args);
				}
				$ds[$i][] = $value;
				$i++;
			}
		}

		require_once(IWARE.'TableFactoryColumnPlugin.php');
		$tf = new TableFactoryColumnPlugin(false,$this->langIf,$this->db,$this->db_app);
		$tf->setEmptyText($this->langIf->getText('No countries found') );

		$tf->setData($ds, 'CountryOverview',false,true);
	//	$sort = array('CODE'=>"'String'",
	//			'NAME'=>"'String'");
	//	foreach($country->settingsArray as $setting)
	//		$sort[$setting] = "'String'";
		//$tf->setSortingFunctions($sort);
		$tf->decapitate();

		//$tf->setValueProcessor($country->settingsArray,'return (($row[\'SETTINGS\'] & constant($orighead))==constant($orighead))?\'<img id="\'.$row[\'CODE\'].\'_\'.$orighead.\'_on" src="/\'.SITE_PATH.\'images/i-w/true.gif" />\':\'<img id="\'.$row[\'CODE\'].\'_\'.$orighead.\'_on" src="/\'.SITE_PATH.\'images/i-w/false.gif" />\';');
//		$tf->setValueProcessor(array('CODE', 'LEGAL_NOTICE', 'ProductSettings'),array($this,'tfValueProcessor'));
		$help = ($this->parent->title != '') ? getHelp($this->langIf, $this->parent->handle, array('title'=>$this->parent->handle, 'top'=>'0px')) : '';
		$tf->setCaption($help.'<img src="/'.SITE_PATH.'images/block_arrow.png" /> '.$this->langIf->getText('Country Settings Overview'),false);
		$this->text = $tf->getXHTMLTable('ProfessionalWhite',2);
	}
	function tfValueProcessor(&$args)
	{
		switch($args['head'])
		{
			case 'LEGAL_NOTICE':
				return '<a href="InterfaceCountryLegalNotice.php?country[id]='.$args['row']['COUNTRY_ID'].'">'.$this->langIf->getText($args['value'].' Legal Notice').'</a>';
			break;
			case 'ProductSettings':
				return sprintf('<a id="country_product_settings_%s" href="InterfaceCountryProductSettings.php?country[id]=%s">%s</a>',$args['row']['CODE'], $args['row']['COUNTRY_ID'],$this->if_obj->model['product']->name);
			break;
			case 'CODE':
				if($this->if_obj->model['readonly'])
					return $args['value'];
				return sprintf('<a href="InterfaceCountrySettings.php?country[id]=%s">%s</a>',$args['row']['COUNTRY_ID'],$args['value']);
			break;
		}
		return '';
	}
}

?>