<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
require_once(ELC_CLASSES.'Country.php');
require_once(ELC_CLASSES.'Product.php');
require_once(ELC_CLASSES.'CountryProduct.php');
/**
 *
 * @package WEEE
 * @subpackage Interface
 * @since 24-11-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceCountryProductSettings extends InterfaceFactory
{
	var $updateAllowed = true;
    /**
     * interface[id] = 158
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceCountryProductSettings(&$db, &$db_app, &$langIf)
    {
        parent::InterfaceFactory($db, $db_app, $langIf);
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';

        $this->model['product'] = new Product($this->db_app,$_SESSION['selected_product_id'],true);
        $this->model['country'] = new Country($this->db_app,$_REQUEST['country'],true);
        $this->model['cp'] = new CountryProduct($this->db_app,
        	array('country'=>$this->model['country'],'product'=>$this->model['product']),true);

        $this->hiddenFields = array(array('name'=>'country[id]','value'=>$this->model['country']->id));

		if(! $this->model['cp']->validateUpdate())
			$this->updateAllowed = false;

        setPageTitlePostfix(sprintf(' (%s/%s)',$this->model['country']->name,$this->model['product']->name));
    }
    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {
    	$error = $this->langIf->getText('The settings cannot be modified, contraints');
        if(!isset($_POST['process']))
        	return;

        if($_POST['process'] == 'save')
        {
			if(!$this->updateAllowed)
				return $thrownException .= $error;

			$c =& $this->model['cp'];
			$settings = 0;
			foreach($this->model['country']->settingsArray as $define)
				if(isset($_POST['cp'][$define]))
					$settings += constant($define);
			$c->settings = $settings;
			$c->objectmap['updatetype'] = 'REPLACE';
			$c->update();

			header('Location: InterfaceCountryOverview.php');
			exit();
        }
    }
}
/**
 * @package WEEE
 * @subpackage Interface
 * @since 24-11-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceCountryProductSettingsItem extends InterfaceItem
{

    /**
     * item[1156] =
     */
    function getCountryProductSettings()
    {
    	$ds = array();
    	foreach ($this->if_obj->model['country']->getSettings() as $setting)
    	{
    		$chk = new Form_Checkbox(sprintf('cp[%s]', $setting), 1,
    			$this->if_obj->model['country']->has(constant($setting),$_SESSION['selected_product_id']));
			$chk->setDisabled(!$this->if_obj->updateAllowed);
			$chk->setID($setting);
    		$ds[] = array(
				'Label'=>$this->langIf->getText('Item: '.$setting),
				'Checkbox'=>$chk->getHtml());
    	}



    	$tf = new TableFactory($ds);
    	$tf->decapitate();
    	$tf->setCaption(sprintf('%s %s/%s',
    		$this->langIf->getText('Country Product Settings for'),
    		$this->if_obj->model['country']->name,
    		$this->if_obj->model['product']->name
    		),false);

    	$this->text = sprintf('<span class="status_forfeit">%s</span><br />%s',
    		$this->langIf->getText('Editing this will override ALL Country Settings'),
    		$tf->getXHTMLTable('Professional', 2));
    }

    /**
     * item[1157] =
     */
    function getButtons()
    {
    	$this->_BarButtons = BUTTON_CANCEL+BUTTON_SAVE;

		$msgbox = jsMessageBox(MSG_BOX_QUEST,
			$this->langIf->getText('Change country product settings warning title'),
			$this->langIf->getText('Change country product settings warning body'),
			"function() { $('interface_form').submit(); } "
		);

		$settings = array('onclick'=>$msgbox."; return false;");
		if(!$this->if_obj->updateAllowed)
			$settings['disabled'] = 'disabled';

		$this->_ButtonOptions[BUTTON_SAVE] = $settings;
		$this->_ButtonOptions[BUTTON_CANCEL] = array('onclick'=>"document.location.href='InterfaceCountryOverview.php';");
    }

}

/**
 * CALLBACK[getCountryProductSettings]
 * item[1156] = {
 *     [handle] = Item: CountryProductSettings
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getButtons]
 * item[1157] = {
 *     [handle] = Item: ButtonBar
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 */
?>
