<?php
/**
 *
 */
require_once(INTERFACE_OBJ."InterfaceFactory.php");
require_once(IWARE.'group.php');
/**
 * Management page for the country settings defined in the Country object for the application
 *
 * @package ELC
 * @subpackage Interface
 * @author Marten Koedam <marten@basesoft.com>
 * @copyright (2005) BaseSoft B.V.
 * @since 20-01-2005
 * @version $Id$
 */
class InterfaceCountrySettings extends InterfaceFactory
{
	/**
	 *
	 */
	function InterfaceCountrySettings($db, $db_app, $langIf)
	{
		if(!isset($_REQUEST['country']['id']))
		{
			alert('Permission denied on interface InterfaceCountrySettings');
			throw new InterfacePermissionException('Permission denied on interface InterfaceCountrySettings');
		}

		$this->FirstColWidth = 100;
		$this->delimiter = '<br />';
		parent::InterfaceFactory($db, $db_app, $langIf);

		require_once(ELC_CLASSES.'Country.php');

		$this->country = new Country($this->db_app,$_REQUEST['country']['id'],true);
		if(!$this->country->validateUpdate())
			$this->updateAllowed = false;

		$this->hiddenFields = array(array('name'=>'country[id]','value'=>$_REQUEST['country']['id']));

		setPageTitlePostfix('('.$this->country->name .')');
	}
	/**
	 *
	 */
	var $updateAllowed = true;
	/**
	 *
	 */
	function processInput(&$thrownException)
	{
		$error = $this->langIf->getText('The settings cannot be modified, contraints');
		if(isset($_POST['process']))
		{
			if(!$this->updateAllowed)
				return $thrownException .= $error;
			$c = new Country($this->db_app);
			$c->set($_REQUEST['country']['id']);
			$settings = 0;
			foreach($c->settingsArray as $define)
				if(isset($_POST['countrysetting'][$define]))
					$settings += constant($define);
			$c->settings = $settings;
			$c->update();

			header('Location: InterfaceCountryOverview.php');
			exit();
		}
	}
}
/**
 * @package ELC
 * @subpackage Interface
 */
class InterfaceCountrySettingsItem extends InterfaceItem
{
	/**
	 *
	 */
	function getItemTitle()
	{
		$this->text = '';
		if(!$this->parent->parent->updateAllowed)
			$this->text = '<span class="error">'.$this->langIf->getText('The settings cannot be modified, contraints').'</span>';
		$this->rightCol = '';
	}

    /**
     * item[883] =
     */
    function getCountrySettings()
    {
    	$ds = array();
    	foreach ($this->if_obj->country->getSettings() as $setting)
    	{
    		$chk = new Form_Checkbox(sprintf('countrysetting[%s]', $setting), 1,
    			$this->if_obj->country->has(constant($setting),$_SESSION['selected_product_id']));
			$chk->setDisabled(!$this->if_obj->updateAllowed);
			$chk->setID($setting);
    		$ds[] = array(
				'Label'=>$this->langIf->getText('Item: '.$setting),
				'Checkbox'=>$chk->getHtml());
    	}



    	$t = new TableFactory($ds);
    	$t->decapitate();
    	$this->text = $t->getXHTMLTable('Professional', 2);
    }

	/**
	 *
	 */
	function getButtons()
	{
		$this->_BarButtons = BUTTON_CANCEL+BUTTON_SAVE;

		$msgbox = jsMessageBox(MSG_BOX_QUEST,
			$this->langIf->getText('Change country settings warning title'),
			$this->langIf->getText('Change country settings warning body'),
			"function() { $('interface_form').submit(); } "
		);

		$this->_ButtonOptions[BUTTON_SAVE] = array('onclick'=>$msgbox."; return false;");
		$this->_ButtonOptions[BUTTON_CANCEL] = array('onclick'=>"document.location.href='InterfaceCountryOverview.php';");
	}
}

?>
