<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
require_once(IWARE.'group.php');
require_once(ELC_CLASSES.'CRSOParticipant.php');
/**
 *
 * @package
 * @subpackage Interface
 * @since 07-03-2007
 * @copyright 2007 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceParticipantDetails extends InterfaceFactory
{
    /**
     * interface[id] = 168
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceParticipantDetails(&$db, &$db_app, &$langIf)
    {
        parent::InterfaceFactory($db, $db_app, $langIf);
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';

        // Check for stuff..
        switch($_SESSION['session_group_group_id'])
        {
        	case GROUP_SYSADMIN:
        	case GROUP_ACCOUNTANT:
        		if(isset($_REQUEST['product']['id'])&&($_REQUEST['product']['id']!=$_SESSION['selected_product_id']))
        		{
        			$_SESSION['selected_product_id'] = $_REQUEST['product']['id'];
        			header(
						sprintf('Location: /%sscripts/elc/operator/InterfaceParticipantDetails.php?participant[id]=%s&crso[id]=%s',
						SITE_PATH,
						$_REQUEST['participant']['id'],
						$_REQUEST['crso']['id']
						));
        			exit();
        		}
        		// check to see whether or not it is a participant that was requested.
        		$cpp = new CRSOParticipantProduct($this->db_app);
        		if(!$cpp->set($_REQUEST['crso']['id'],$_REQUEST['participant']['id'],$_SESSION['selected_product_id']))
        			throw new InterfacePermissionException('Unable to set selected participant/crso/product combination');
        		$this->model['cpp'] = $cpp;

        	break;
        	default:// Isnt this stuff already handled through SCRIPT privileges.
        		throw new InterfacePermissionException('Unauthorized Access to Interface');
        }


    }
    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {
        if(isset($_REQUEST['process']) && $_REQUEST['process'] == 'export')
		{
			$ids = array((int)$_REQUEST['participant']['id']);
			$part = new Participant($this->db_app);
			$csv = $part->export_masterdata($ids);
			if (!headers_sent())
			header('Content-Disposition: attachment; filename="Masterdata_'.$_REQUEST['participant']['id'].'.csv"');
            echo $csv->getString();
            die();
		}
    }
}
/**
 * @package
 * @subpackage Interface
 * @since 07-03-2007
 * @copyright 2007 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceParticipantDetailsItem extends InterfaceItem
{

    /**
     * item[1311] =
     */
    function getInterfaceParticipantDetails()
    {
		//$this->settings = array('hideButtons'=>1);
		$this->settings = array('targetId'=>'return "ifB_443";');
		//$this->settings['_hideInputs'] = 'return true;';
		//$this->settings['rel'] = '$relation = new Relation($this->db_app,'.$_REQUEST['participant']['id'].'); return $relation;';
		//$this->settings['participant'] = 'return new Participant($this->db_app,array(\'relation\'=> new Relation($this->db_app,'.$_REQUEST['participant']['id'].')));';
		//$this->settings['cp'] = &$this->if_obj->model['cpp'];
		//$this->settings['callbacks']['relation[vat_no]'] = array($this, 'getVatValue');
    }

}

/**
 * CALLBACK[getInterfaceParticipantDetails]
 * item[1311] = {
 *     [handle] = Item: InterfaceParticipantDetails
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 */
?>