<?php
require_once(INTERFACE_OBJ."InterfaceFactory.php");

require_once(IWARE.'GroupUser.php');
require_once(IWARE.'group.php');
require_once(ELC_CLASSES.'User.php');
/**
 *
 *
 * @package ELC
 * @subpackage Interface
 * @author
 * @copyright (2005) BaseSoft B.V.
 * @version $Id$
 */
class InterfacePublicUserOverview extends InterfaceFactory
{
	function InterfacePublicUserOverview($db, $db_app, $langIf)
	{
		$this->FirstColWidth = 25;
		$this->delimiter = '<br />';
		parent::InterfaceFactory($db, $db_app, $langIf);
	}
	/**
	 *
	 */
	function processInput(&$thrownException)
	{
		if(isset($_POST['process']))
		{
			if($_POST['process']=='save')
			{
				$user = new ELCUser($this->db_app);
				foreach($_POST['user_active'] as $user_id => $active)
				{
					$user->id = $user_id;
					$user->set();
					$user->active = $active;
					$user->update();
				}
			}
			elseif($_POST['process']=='delete')
			{
				$valid = array();
				$user = new ELCUser($this->db_app);
				$q = $user->selectByGroup(GROUP_PUBLIC);
				while($r = $q->fetch())
					$valid[] = $r->USER_ID;
				foreach($_POST['users'] as $user_id)
				{
					if($user_id==1||(!in_array($user_id, $valid))) // THE GENERAL PUBLIC USER CAN NEVER BE DELETED;
						continue;
					// Make sure the user is a public user
					$user->id = $user_id;
					$user->delete();
				}
			}
			$this->init($this->id);
		}
	}
}

class InterfacePublicUserOverviewItem extends InterfaceItem
{
	/**#@+
	 * Callback functions made from InterfaceItem
	 */
	/**
	 *
	 */
	function getOverview()
	{
		$user = new ELCUser($this->db_app);
		require_once(IWARE.'TableFactoryColumnPlugin.php');
		$q = $user->selectByGroup(GROUP_PUBLIC);

		$tf = new TableFactoryColumnPlugin(false,$this->langIf,$this->db,$this->db_app);
		$tf->setData($q, 'PublicUserOverview',false,true);

		$help = ($this->parent->title != '') ? getHelp($this->langIf, $this->parent->handle, array('title'=>$this->parent->handle, 'top'=>'0px')) : '';
		$tf->setCaption($help.'<img src="/'.SITE_PATH.'images/block_arrow.png" /> '.$this->langIf->getText('Public User Overview'), false);

		$tf->setValueProcessor('CHECKBOX', 'return \'<input type="checkbox" name="users[]" value="\'.$row[\'USER_ID\'].\'" />\';');
		$tf->setValueProcessor('TRANSLATE','return \'<a href="InterfaceUserTranslator.php?user[id]=\'.$row[\'USER_ID\'].\'">\'.$value.\'</a>\';');
		$tf->setValueProcessor('USER_ID',array($this,'tfUserLink'));
		$tf->setValueProcessor('USER_ACTIVE','return \'<input type="hidden" name="user_active[\'.$row[\'USER_ID\'].\']" value="\'.$value.\'" />\'.
			($value?\'<img src="/\'.SITE_PATH.\'images/i-w/true.gif" />\':\'<img src="/\'.SITE_PATH.\'images/i-w/false.gif" />\');');

		$tf->setEmptyText($this->langIf->getText('No users found') );

		$this->text = '<span class="error" id="ChangeMsg"></span>
			<script type="text/javascript"><!--
				var changed = false;
				function changeImg(el,userId)
				{
					if(!changed)
					{
						changed = true;
						getElById(\'ChangeMsg\').innerHTML = \''.$this->langIf->getText('Changes were made but not saved').'\';
					}
					iEl = document.getElementsByName(\'user_active[\'+userId+\']\')[0];
					if(iEl.value==1)
						el.src=\'/'.SITE_PATH.'images/i-w/false.gif\';
					else
						el.src=\'/'.SITE_PATH.'images/i-w/true.gif\';
					iEl.value = (iEl.value==1)?0:1;
				}

				function deletePublicUsers()
				{
					MessageBox.prototype.Question(\''.$this->langIf->getText('Warning').'\', \''.$this->langIf->getText('Are you sure you want to delete the selected Public Users').'\',
						function(){
							document.getElementsByName(\'process\')[0].value=\'delete\';
							document.getElementById(\'interface_form\').submit();
						}, function(){});
				}

			--></script>
			'.

		$this->text = $tf->getXHTMLTable('Professional',2);
	}

	function tfUserLink($args)
	{
		return sprintf('<a href="InterfacePublicUserRegistration.php?user[id]=%s">%s</a>',$args['value'],$args['value']);
	}

	/**
	 *
	 */
	function getButtons()
	{
		$this->_BarButtons = BUTTON_DELETE;
		$this->_addCustomButton($this->langIf->getText('Add new Public User'),'button',array('onclick'=>"document.location.href='InterfacePublicUserRegistration.php';"));
		$this->_ButtonOptions[BUTTON_DELETE] = array('onclick'=>"deletePublicUsers();");
	}
	/**#@-*/
}
