<?php
require_once(INTERFACE_OBJ."InterfaceFactory.php");

require_once(IWARE.'GroupUser.php');
require_once(IWARE.'group.php');
require_once(IWARE.'InfoPerson.php');
require_once(ELC_CLASSES.'User.php');
/**
 *
 *
 * @package ELC
 * @subpackage Interface
 * @author
 * @copyright (2005) BaseSoft B.V.
 * @version $Id$
 */
class InterfacePublicUserRegistration extends InterfaceFactory
{
	function InterfacePublicUserRegistration($db, $db_app, $langIf)
	{
		$this->FirstColWidth = 25;
		$this->delimiter = '<br />';
		if(isset($_POST['process']))
			$this->_setValues = true;

		$this->model['user'] = new ELCUser($db_app);
		if(isset($_REQUEST['user']['id']))
		{
			if(!ELCUser::checkInGroup($db_app,GROUP_PUBLIC,$_REQUEST['user']['id']))
				throw new InterfacePermissionException('Operator Tried To Access Non-Public User');
			$this->model['user']->set($_REQUEST['user']['id']);
			$this->hiddenFields = array(array('name'=>'user[id]','value'=>$this->model['user']->id));
		}

		parent::InterfaceFactory($db, $db_app, $langIf);
	}
	/**
	 *
	 */
	function processInput(&$thrownException)
	{
		$weakPassword = $this->langIf->getText('Weak password, please try something else');
		$passwordLength = $this->langIf->getText('Password too short, please choose another');

		if(isset($_POST['process']))
		{
			$validate_pass = 0;
			if(!isset($_REQUEST['user']['id']))
				$validate_pass = 1;
			else
			if(isset($_REQUEST['user']['password']) && !empty($_REQUEST['user']['password']))
				$validate_pass = 1;

			if($validate_pass == 1)
			{
				if(!ELCUser::validatePasswordLength($_POST['user']['password']))
				{
					$_POST['process'] = '';
					return $thrownException .= $passwordLength;
				}
				if(!ELCUser::validatePassword($_POST['user']['password'])) // Weak password
				{
					$_POST['process'] = '';
					return $thrownException .= $weakPassword;
				}
			}
			if($_POST['process']=='save')
			{
				$this->db_app->begin();
				$_POST['user']['active'] = isset($_POST['user']['active'])?1:0;
				$user = new ELCUser($this->db_app);

				if(isset($_REQUEST['user']['id']))//->update
				{
					$user->set($_REQUEST['user']['id']);
					$user->name = $_POST['user']['name'];
					$user->active = $_POST['user']['active'];

					if(isset($_POST['user']['password']) && !empty($_POST['user']['password']))
					{
						if (CRYPT_BLOWFISH == 1)
						{
							$u1 = sha1(uniqid());
							$salt = "\$2a\$07\$" . $u1 . "\$";
							$password = crypt($_POST['user']['password'],$salt);
							$user->salt = $salt;
						}
						else
							$password = sha1($_POST['user']['password']);
						$user->password = $password;
					}
					$user->update();
				}
				else
				{
					if(!$user->isUniqueUserName())
						return $thrownException .= $this->langIf->getText('Invalid UserName, User already exists');

					$user->application_id = APPLICATION_ID;
					$person['language_id'] = $_SESSION['session_user_language_id'];
					$person['company_id'] = $_SESSION['session_user_company_id'];
					$user->name = $_POST['user']['name'];
					$user->active = $_POST['user']['active'];
					if (CRYPT_BLOWFISH == 1)
					{
						$u1 = sha1(uniqid());
						$salt = "\$2a\$07\$" . $u1 . "\$";
						$password = crypt($_POST['user']['password'],$salt);
						$user->salt = $salt;
					}
					else
						$password = sha1($_POST['user']['password']);
					$user->password = $password;
					$user->info_person = new InfoPerson($this->db_app,$person);
					$user->info_person->insert();
					$user->last_login = date('Y-m-d H:i:s');
					$user->insert();
					$gu = new GroupUser($this->db_app,array('user'=>$user,'group_id'=>GROUP_PUBLIC));
					$gu->insert();
				}
				$this->db_app->commit();
				header('Location: InterfacePublicUserOverview.php');
				exit();
			}
		}
	}
}

class InterfacePublicUserRegistrationItem extends InterfaceItem
{
	/**#@+
	 * Callback functions made from InterfaceItem
	 */
	/**
	 *
	 */
	function getItemValue()
	{
		if(!isset($_REQUEST['user']['id']))
			return;

		$this->if_obj->user = (array) $this->if_obj->model['user'];
		if($this->name=='user[password]')
			return $this->properties['value'] = '';
		$name = str_replace('[','[\'',str_replace(']','\']',$this->name));
		eval('$this->properties[\'value\'] = isset($this->if_obj->'.$name.')?$this->if_obj->'.$name.':\'\';');

		if($this->type_id==IF_ITEM_CHECKBOX&& $this->properties['value'])
			$this->properties['checked'] = 'checked';
		if($this->type_id==IF_ITEM_CHECKBOX)
			$this->properties['value']=1;
	}
	/**
	 *
	 */
	function getSpacer()
	{
		$this->twoCols = true;
	}
	/**
	 *
	 */
	function getButtons()
	{
		$this->_BarButtons = BUTTON_SAVE;
	}
	/**#@-*/
}
