<?php
require_once(INTERFACE_OBJ."InterfaceFactory.php");
/**
 * InterfaceUserTranslator
 *
 * @package ELC
 * @subpackage Interface
 * @author Marten Koedam <marten@basesoft.com>
 * @copyright (2005) BaseSoft B.V.
 * @version $Id$
 */
class InterfaceUserTranslator extends InterfaceFactory
{
	function InterfaceUserTranslator($db, $db_app, $langIf)
	{
		if(!isset($_REQUEST['user']['id']))
			return trigger_error('InterfaceUserTranslator::constructor: No user[id] set.', E_USER_ERROR);


		if(!ELCUser::checkInGroup($db_app,GROUP_PUBLIC,$_REQUEST['user']['id']))
			if(!ELCUser::checkInGroup($db_app,GROUP_CRSO,$_REQUEST['user']['id']))
				throw new InterfacePermissionException('Operator Tried To Access Non-Public/Non-CRSO User');
		// TODO: add check, to see wether or not this operator has permission to change user settings

		$this->FirstColWidth = 25;
		$this->delimiter = '<br />';
		parent::InterfaceFactory($db, $db_app, $langIf);

		require_once(IWARE.'nLanguage.php');
		require_once(ELC_CLASSES.'User.php');
		require_once(IWARE.'Translator.php');

		$this->user = new ELCUser($this->db_app,$_REQUEST['user']['id']);
		$this->user->set();

		require_once(ELC_CLASSES . 'Relation.php');
		$relation = new Relation($db_app);
		$relation->setByUserId($this->user->id);

		setPageTitlePostfix('('.$this->user->name.' '.($relation->name ? '/ '.$relation->name : '').')');
	}
	/**
	 *
	 */
	function processInput(&$thrownException)
	{
		if(isset($_POST['process']))
		{
			if($_POST['process']=='save')
			{
				if(empty($_POST['user']))
					return $thrownException .= $this->langIf->getText('Invalid number of languages supplied');
				$trans = new Translator($this->db_app, array('user'=>new ELCUser($this->db_app,$_REQUEST['user']['id'])));
				$trans->deleteByUser();
				if(isset($_POST['user']['language_ids']))
				{
					foreach($_POST['user']['language_ids'] as $language_id)
					{
						$trans->language = new nLanguage($this->db_app,$language_id);
						$trans->insert();
					}
				}
				$this->init($this->id);
			}
		}
	}
}

class InterfaceUserTranslatorItem extends InterfaceItem
{
	/**#@+
	 * Callback functions made from InterfaceItem
	 */
	/**
	 *
	 */
	function getUserTranslator()
	{
		$props = array('class'=>'button');
		$this->hiddenFields = array(array('name'=>'user[id]', 'value'=>$_REQUEST['user']['id']));
		$this->fancybuttons = array('right'=>$props, 'left'=>$props, 'allRight'=>$props, 'allLeft'=>$props);//, 'up'=>$props, 'down'=>$props);
		$this->properties['size'] = 8;
		$this->properties['style'] = 'width: 50ex;';

		$lang = new nLanguage($this->db_app);
		$trans = new Translator($this->db_app, array('user'=>$this->parent->parent->user));

		$selected = array();
		$rs = $trans->getByUserId();
		foreach($rs as $r)
		{
			$selected[] = $r->LANGUAGE_ID;
			$this->selectedoptions[] = array('text'=>$r->LANGUAGE,'value'=>$r->LANGUAGE_ID);
		}

		$q = $lang->get();
		while($r = $q->fetch())
		{
			if(!in_array($r->LANGUAGE_ID, $selected))
				$this->options[] = array('text'=>$r->LANGUAGE,'value'=>$r->LANGUAGE_ID);
		}

	}
	/**
	 *
	 */
	function getButtons()
	{
		$this->_BarButtons = BUTTON_CANCEL;
		$this->_ButtonOptions[BUTTON_CANCEL] = array('onclick'=>"document.location.href='index.php';");
		$this->_addCustomButton($this->langIf->getText('Save'),'button', array('onclick'=>"document.getElementById('interface_form').submit();"));
	}
	/**#@-*/
}
