<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
require_once(ELC_CLASSES.'AnnualConfirmation.php');
require_once(ELC_CLASSES.'Participant.php');
require_once(ELC_CLASSES.'CRSOParticipantProduct.php');
require_once(ELC_CLASSES.'CRSOProduct.php');
require_once(ELC_CLASSES.'CRSOProductDimension.php');
require_once(ELC_CLASSES.'Trust.php');

define('BLOCK_ANNUAL_FILTER_SELECTION',386);
define('BLOCK_ANNUAL_DECL_OVERVIEW',387);
define('BLOCK_ANNUAL_DECL_BUTTONS',388);
define('BLOCK_ANNUAL_CRSO_SPECIFIC_TEXT', 560);

define('ITEM_UPLOAD_ANNUAL_DOCUMENT',1141);
define('ITEM_MESSAGE_REJECTED',1172);
define('ITEM_MESSAGE_REJECTED_SPACER',1173);

/**
 *
 * @package
 * @subpackage Interface
 * @since 08-11-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceAnnualConfirmation extends InterfaceFactory
{
	var $checksum = '';
    /**
     * interface[id] = 155
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceAnnualConfirmation(&$db, &$db_app, &$langIf)
    {
        parent::InterfaceFactory($db, $db_app, $langIf);
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';

        $this->model['ac'] = new AnnualConfirmation($this->db_app);
        $this->model['crso'] = false;
        $this->model['years'] = array();

        $this->model['cp'] = new CRSOParticipantProduct($this->db_app);
        $this->model['crsos'] = $this->model['cp']->getParticipantCRSOs($_SESSION['selected_participant_id'],'array',false,false,$_SESSION['selected_product_id']);

        if(isset($_REQUEST['crso']['id'])&&is_numeric($_REQUEST['crso']['id']))
        {
        	if(!in_array($_REQUEST['crso']['id'],$this->model['crsos']))
        	{
        		if(count($_SESSION['participant_ids'])>1) // Why is this here? $selected_participant_id?
        		{
        			header('Location: InterfaceAnnualConfirmation.php?message=multiparticipant');
        			exit();
        		}
        		// Isnt all of this checked in the InterfacePermission object??
        		throw new InterfacePermissionException('Unauthorized Access to Interface');
        	}
        	$this->model['ac']->crso = $this->model['crso'] = new CRSO($this->db_app,array('relation'=>new Relation($this->db_app,$_REQUEST['crso']['id'])));
        	$this->model['years'] = $this->model['ac']->getYears($_SESSION['selected_participant_id'],null,'array',false,$_SESSION['selected_product_id']);
        	$this->model['cp']->set($_REQUEST['crso']['id'],$_SESSION['selected_participant_id'],$_SESSION['selected_product_id']);
        }
        $this->process = isset($_REQUEST['process'])?$_REQUEST['process']:'save';
		$this->model['year'] = (isset($_REQUEST['year'])&&in_array($_REQUEST['year'],$this->model['years']))?$_REQUEST['year']:
			((count($this->model['years'])==1)?current($this->model['years']):false);

		$this->script = "
			function reloadOverview(sel)
			{
				crso = $('ifI_1140');
				selectedCRSO = crso.options[crso.selectedIndex].value;
				go('InterfaceAnnualConfirmation.php?crso[id]='+selectedCRSO+'&year='+sel.options[sel.selectedIndex].value);
			}
			";
		$this->model['refund_available'] = $this->model['is_available'] = false;
		$this->model['trust_available'] = array();
		$this->model['monthList'] = array();
		if($this->model['crso']&& $this->model['year'])
		{
			$this->model['ac']->setByParticipantCRSOAndYear($_SESSION['selected_participant_id'],null,$this->model['year'],$_SESSION['selected_product_id']);
			list($this->model['trust_available'][0],$this->model['monthList'][0]) = $this->model['ac']->hasNoUnfiledMonths(null,null,null,null,$_SESSION['selected_product_id']);
			$this->model['is_available'] = $this->model['trust_available'][0];
			// Loop trusts.
			$trust = new Trust($this->db_app);
    		$q = $trust->selectSubrogations($_SESSION['selected_participant_id'],TRUST_APPROVED,$this->model['crso']->relation->id,$_SESSION['selected_product_id']);
    		while($r=$q->fetch())
    		{
    			$tid = $r->TRUST_ID;
    			list($this->model['trust_available'][$tid],$this->model['monthList'][$tid]) = $this->model['ac']->hasNoUnfiledMonths($r->TRUSTEE_RELATION_ID,null,null,$r->TRUST_ID,$_SESSION['selected_product_id']);
    			$this->model['is_available'] = $this->model['trust_available'][$tid]?$this->model['is_available']:false;
    		}
    		if($this->model['cp']->producer_exporter & PARTICIPANT_EXPORTER)
    		{
    			$date = currentDate();
    			$month = $date->getMonth();
    			$day = $date->getDay();
    			//$this->model['crso']->set();
    			$cp = new CRSOProduct($this->db_app);
    			$cp->set($this->model['crso']->relation->id,$_SESSION['selected_product_id']);
    			if($month==1&& $day<$cp->refund_export_day)
    				$this->model['is_available'] = false;
    			else
    				$this->model['refund_available'] = true;
    		}
		}
    }
    function init($ifId)
    {
    	$rv = parent::init($ifId);

    	// if CRSO prevented this participant from annual confirmation, remove the document upload item
    	if(!$this->model['cp']->allow_annual_confirmation)
    		unset($this->blocks[BLOCK_ANNUAL_DECL_BUTTONS]->items[ITEM_UPLOAD_ANNUAL_DOCUMENT]);
    	if(!$this->model['crso']) {
    		unset($this->blocks[BLOCK_ANNUAL_DECL_OVERVIEW],$this->blocks[BLOCK_ANNUAL_DECL_BUTTONS]);
    	} elseif($this->model['crso']->relation->id != 163) {
			// UK only, so hide otherwise
			unset($this->blocks[BLOCK_ANNUAL_CRSO_SPECIFIC_TEXT]);
		}
    	if($this->process =='print')
    		unset($this->blocks[BLOCK_ANNUAL_FILTER_SELECTION],$this->blocks[BLOCK_ANNUAL_DECL_BUTTONS]->items[ITEM_UPLOAD_ANNUAL_DOCUMENT]);
    	if($this->model['ac']->status == ANNUAL_CONFIRMATION_CLOSED)
    		unset($this->blocks[BLOCK_ANNUAL_DECL_BUTTONS]->items[ITEM_UPLOAD_ANNUAL_DOCUMENT]);
		if((($this->model['ac']->review_status != AC_REVIEW_REJECTED)||($this->process =='print')) && isset($this->blocks[BLOCK_ANNUAL_DECL_BUTTONS]))
    		unset($this->blocks[BLOCK_ANNUAL_DECL_BUTTONS]->items[ITEM_MESSAGE_REJECTED],$this->blocks[BLOCK_ANNUAL_DECL_BUTTONS]->items[ITEM_MESSAGE_REJECTED_SPACER]);
		if(((count($this->model['years'])==0)||!$this->model['year']) && isset($this->blocks[BLOCK_ANNUAL_DECL_BUTTONS]))
    		unset($this->blocks[BLOCK_ANNUAL_DECL_BUTTONS]);
    	return $rv;
    }
    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {
    	// Translations
    	$unableToEditAlreadyClosedAnnual = $this->langIf->getText('Cannot Modified Closed Annual Confirmation');
    	$formErrors = $this->langIf->getText('Please correct the form errors');
    	$notificationSubject = $this->langIf->getText('Annual Confirmation Filed');
    	$notificationContentDesc = 'The Annual Confirmation for {YEAR} has been Filed by {PARTICIPANT}';
    	$notificationContentDescRefiled = 'The Annual Confirmation for {YEAR} has been Refiled by {PARTICIPANT}';
    	$this->langIf->getText($notificationContentDesc);
    	$this->langIf->getText($notificationContentDescRefiled);

        if(!isset($_REQUEST['process']))
        	return;
        if($_REQUEST['process'] == 'print')
        	return;
        if($_REQUEST['process'] == 'save')
        {

        	if(!$this->fb->validate()) // If not validated, let the user know
			{
				$_POST['process'] = '';
				return $thrownException .= $formErrors;
			}
			if($this->model['ac']->status==ANNUAL_CONFIRMATION_CLOSED)
			{
				$_POST['process'] = '';
				return $thrownException .= $unableToEditAlreadyClosedAnnual;
			}
			elseif($this->model['ac']->status==ANNUAL_CONFIRMATION_REOPENED)
				$notificationContentDesc = $notificationContentDescRefiled;
			$this->db_app->begin();
			// Close the Confirmation
			$this->model['ac']->status = ANNUAL_CONFIRMATION_CLOSED;
			$this->model['ac']->review_status = AC_REVIEW_OPEN; // reset the review status
			$this->model['ac']->update();

			require_once(ELC_CLASSES.'RelationDocument.php');

			$rd = new RelationDocument($this->db_app);

			$item = new InterfaceItem($this->db,$this->db_app,$this->langIf);
			$document = $item->getDocument('document[id]',ITEM_UPLOAD_ANNUAL_DOCUMENT);
			$rd->relation = $this->model['ac']->participant->relation;
    		$rd->document = $document;
    		$rd->document->makePermanent();

        	// Always insert a new Document.
        	$acd = new AnnualConfirmationDocument($this->db_app);
        	$acd->annual =& $this->model['ac'];
        	$acd->document =& $rd->document;
        	$rd->insert();
        	$acd->insert();
        	$this->model['ac']->participant->relation->set(); // For notification

        	// Send a notification to the CRSO that an annual Confirmation has been supplied.
        	require_once(ELC_CLASSES.'Notification.php');
			Notification::send($this->db_app,
				array('subject'=>$notificationSubject,
					'sender'=>$this->model['ac']->participant->relation,
					'message'=>
						$this->langIf->getText($notificationContentDesc,
							null,
							array ('PARTICIPANT'=>$this->model['ac']->participant->relation->name,'YEAR'=>$this->model['year']),
							$this->model['crso']->default_language_id)
				),
				array(array('recipient'=>$this->model['crso']->relation,
							'callback'=>"go('/".SITE_PATH."scripts/elc/crso/InterfaceAnnualConfirmationList.php')"))
			);

        	$this->db_app->commit();

        	header(sprintf('Location: InterfaceAnnualConfirmation.php?crso[id]=%s&year=%s', $this->model['crso']->relation->id,$this->model['year']));
        	exit();
        }
    }

    function getInterfaceHeader()
	{
		$rv = parent::getInterfaceHeader();

		if ($this->process != 'print')
			return $rv;

		$d = &currentDate();
		$time = $d->getTime();

		$p = new Relation($this->db_app,$_SESSION['selected_participant_id'],true);
		$c =& $this->model['crso']->relation;
		$p->address->set();
		$c->set();
		$c->address->set();
		require_once(ELC_CLASSES.'Country.php');
		$country = new Country($this->db_app);
		$country->set($p->address->country_id);
		$p_country = $country->name;
		$country->set($c->address->country_id);
		$c_country = $country->name;

		$rv .= '<h1>'.$this->langIf->getText('Annual Confirmation').' ('.$this->model['year'].')</h1>
			<table class="Professional" width="100%">
				<tr>
					<td>
						'.$this->langIf->getText('Document Checksum').'
					</td>
					<td>
						<strong style="font-size: 10pt !important">'.$this->checksum.'</strong>
					</td>
					<td></td>
				</tr>
				<tr>
					<td>'.$this->langIf->getText('Print date').'</td>
					<td>
						'.$d->format('d-m-Y').'
					</td>
					<td></td>
				</tr>
				<tr>
					<td colspan="3"><br /></td>
				</tr>
				<tr>
					<td colspan="2">'.$p->name.'</td>
					<td>'.$c->name.'</td>
				</tr>
				<tr>
					<td colspan="2">'.$p->address->address_street_name.'</td>
					<td>'.$c->address->address_street_name.'</td>
				</tr>
				<tr>
					<td colspan="2">'.$p->address->city_name.', '.$p_country.'</td>
					<td>'.$c->address->city_name.', '.$c_country.'</td>
				</tr>
				<tr>
					<td colspan="2"></td>
					<td>'.$c->address->address_zipcode .', '.$c->email.'</td>
				</tr>
				<tr>
					<td>'.$this->langIf->getText('VAT Number').'</td>
					<td>'.$p->vat_no.'</td>
					<td></td>
				</tr>
				<tr>
					<td>'.$this->langIf->getText('Bank Account Number').'</td>
					<td>'.$p->bank_account_number.'</td>
					<td></td>
				</tr>
			</table>
			<br /><br />';


		return $rv;
	}

	function getInterfaceFooter()
	{
		$rv = parent::getInterfaceFooter();

		if ($this->process != 'print')
			return $rv;

		$rv = '<table class="Professional">
					<tr>
						<td>
							<div style="border: 1px solid black; margin: 10px; width: 200px; height: 50px;"></div>
						</td>
					</tr>
				</table>
		';

		return $rv;
	}
}
/**
 * @package
 * @subpackage Interface
 * @since 08-11-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceAnnualConfirmationItem extends InterfaceItem
{

	public $_totalsWeightDec = 0;

    /**
     * item[1138] = year
     */
    function getYearSelect()
    {
    	$this->options = array();
    	if(!$this->if_obj->model['crso'])
    	{
    		$this->options[] = array('value'=>'','text'=>'- '.$this->langIf->getText('Select CRSO First').' -');
    		return;
    	}

    	if(count($this->if_obj->model['years'])==1)
    	{
    		$this->_hideInput = true;
    		$this->options[] = array('value'=>$this->if_obj->model['year'],'text'=>$this->if_obj->model['year'],'selected'=>'selected');
    		return;
    	}
    	$this->options[] = array('value'=>'','text'=>'- '.$this->langIf->getText('Select Year').' -');
    	foreach($this->if_obj->model['years'] as $year)
    		$this->options[] = array('value'=>$year,'text'=>$year,'selected'=>(($this->if_obj->model['year']==$year)?'selected':false));

    	$this->properties['onchange'] = 'reloadOverview(this);';
    }

    /**
     * item[1140] = crso[id]
     */
    function getCRSOSelect()
    {
	$rv = null;
		// Check for any active Remote Viewer connections.
		if(IWRegistry::isRegistered('remote_viewer')) {
			$rv = IWRegistry::registry('remote_viewer');
		}
    	$this->options = array(array('value'=>'','text'=>'- '.$this->langIf->getText('Select CRSO').' -'));
    	$q = $this->if_obj->model['cp']->getParticipantCRSOs($_SESSION['selected_participant_id'],'q',false,false,$_SESSION['selected_product_id']);
    	while($r=$q->fetch())
    	{
		// We are in Remote viewer mode. Skip any CRSO's which aren't invited.
		if($rv && $rv->crso->relation->id!=$r->CRSO_RELATION_ID)
			continue;
    		$name = $r->CRSO_NAME;
    		$name = (mb_strlen($name)>35)?mb_substr($name,0,35).'...':$name;
    		$this->options[] = array('value'=>$r->CRSO_RELATION_ID,'text'=>$name,
				'selected'=>(($this->if_obj->model['crso']&& $this->if_obj->model['crso']->relation->id==$r->CRSO_RELATION_ID)?'selected':false));
    	}

    	$this->properties['onchange'] = "go('InterfaceAnnualConfirmation.php?crso[id]='+this.options[this.selectedIndex].value);";
    }

	function getCutOffDate()    {
		if(!$this->if_obj->model['crso'])
			$this->text = '';
		else {
			$cp = new CRSOProduct($this->db_app);
			$cp->set($this->if_obj->model['crso']->relation->id, $_SESSION['selected_product_id']);
			$d = $cp->getNextCutOffDateAnnualConfirmation();
			if(!$d)
				$this->text = "<span class='cut-off-date'>".
						$this->langIf->getText('No Annual Confirmation cut-off date set for this CRSO')."</span>";
			else
				$this->text = "<span class='cut-off-date'>".$this->langIf->getText('Upcoming AC cut-off date').": ".$d."</span>";
		}
	}

    /**
     * item[1139] =
     */
    function getAnnualDeclarationOverview()
    {
    	$noYearsAvailable = $this->langIf->getText('No Years Available for Confirmation');
    	$selectYear = $this->langIf->getText('Please select a Year for details');
    	$unfiledOrUnexported = $this->langIf->getText('You still have unfiled or outstanding months, please supply');
    	$subrogatedDeclarationsUnfiled = $this->langIf->getText('Your Trustee still has unfiled declarations of yours');
    	$this->langIf->getText('Refund periods have not all been closed');
    	if(count($this->if_obj->model['years'])==0)
    	{
    		$this->text = $noYearsAvailable;
    		return;
    	}

    	require_once(ELC_CLASSES.'ELCListBuilder.php');
    	$dl = new ELCDefaultList($this->db_app,$this->langIf);

    	if(!$this->if_obj->model['year'])
    	{
    		// Maybe show an overview of all the years so far.
    		$this->text = $selectYear;

			$ds = $this->if_obj->model['ac']->getOverview($_SESSION['selected_participant_id'],null,$_SESSION['selected_product_id']);
    		$tf = new TableFactory($ds,$this->langIf);
    		$tf->hideColumns('ANNUAL_CONFIRMATION_ID');
			$tf->setValueProcessor('STATUS',array($this,'tfTranslateStatus'));
    		$tf->setValueProcessor('DOC_ID',array($dl,'tfDocumentLink'));
    		$tf->setValueProcessor('ALL_FILED',array($this,'tfAllFiled'));
    		$tf->setValueProcessor('YEAR',array($this,'tfYearLink'));

    		$this->text .= $tf->getXHTMLTable('Professional',2);
    		return;
    	}
    	require_once(ELC_CLASSES.'Country.php');
    	$rv = "";
    	// Add a list of brands
    	$rv .= $this->getBrandList().'<br />';


    	if(!$this->if_obj->model['trust_available'][0])
    		$rv .= sprintf('<div class="warning">%s</div>',$unfiledOrUnexported);



    	$hiddenCols = array('STATUS','TRUST_ID','AMOUNT');
    	$c = new Country($this->db_app,$this->if_obj->model['crso']->getCountry(),true);
		if(!$c->has(HasDeclOfWeightWithDecimals,$_SESSION['selected_product_id']))
			$hiddenCols[] = 'WEIGHT_DEC';
    	if(!$c->has(HasDeclOfWeight,$_SESSION['selected_product_id']))
    		$hiddenCols[] = 'WEIGHT';
    	if(!$c->has(HasDeclByBrand,$_SESSION['selected_product_id']))
    		$hiddenCols[] = 'BRAND_ID';
    	if(!$c->has(HasDeclByCategory,$_SESSION['selected_product_id']))
    		$hiddenCols[] = 'PRODUCT_CATEGORY_ID';
    	if(!$c->has(HasDeclarationDimension,$_SESSION['selected_product_id']))
    		$hiddenCols[] = 'CPD_ID';

		$this->if_obj->model['ac']->participant->relation->set();
    	// Per month, show the declaration quantity+weight+exported amount per brand/category
    	$caption = $this->langIf->getText('Annual Declaration Overview for {PARTICIPANT}',null,array('PARTICIPANT'=>$this->if_obj->model['ac']->participant->relation->name));
    	$ds = $this->if_obj->model['ac']->getDeclarationOverview(null,null,null,null,$_SESSION['selected_product_id']);
    	$ds = $ds->fetchAll(PDO::FETCH_ASSOC);
    	if(count($ds))
    		$rv .= $this->_getTableOutput($ds,$dl,$hiddenCols,$caption,0);
    	// If there are trust of which the current participant is the subrogator. Show them as well...

    	$trust = new Trust($this->db_app);
    	$q = $trust->selectSubrogations($_SESSION['selected_participant_id'],TRUST_APPROVED,$this->if_obj->model['crso']->relation->id,$_SESSION['selected_product_id']);
		while($r = $q->fetch())
		{
			$rv .= '<br />';
			if(!$this->if_obj->model['trust_available'][$r->TRUST_ID])
    			$rv .= sprintf('<div class="warning">%s</div>',$subrogatedDeclarationsUnfiled);
			$caption = $this->langIf->getText('Trusted to {TRUSTEE}',null,array('TRUSTEE'=>$r->NAME));
			$ds = $this->if_obj->model['ac']->getDeclarationOverview($r->TRUSTEE_RELATION_ID,null,null,$r->TRUST_ID,$_SESSION['selected_product_id']);
			$rv .= $this->_getTableOutput($ds,$dl,$hiddenCols,$caption,$r->TRUST_ID);
		}

    	if($this->if_obj->model['ac']->status == ANNUAL_CONFIRMATION_CLOSED)
    	{
    		$document = $this->if_obj->model['ac']->getLastDocumentForConfirmation();
    		if($document) {
    			$document->set();
    				$rv .= sprintf('<br /><div>%s <a href="/%sscripts/i-w/document/download.php?Document[id]=%s">%s</a></div>',
    				$this->langIf->getText('Annual Confirmation Document'),
    				SITE_PATH,$document->id,$document->name);
    		}
    	}

    	$this->text = $rv;

    	$this->text .= $this->_getAnnualRefundOverview($hiddenCols);
    	$this->if_obj->checksum = md5($this->if_obj->checksum.
    		$this->if_obj->model['year'].
    		str_pad($this->if_obj->model['ac']->participant->relation->id,8,'0',STR_PAD_LEFT).
    		str_pad($this->if_obj->model['ac']->crso->relation->id,8,'0',STR_PAD_LEFT));

    	// if CRSO prevented this participant from annual confirmation, just add a warning message to the participant
    	// (if AC not already closed)
    	if(!$this->if_obj->model['cp']->allow_annual_confirmation && $this->if_obj->model['ac']->status != ANNUAL_CONFIRMATION_CLOSED)
    		$this->text .= $this->langIf->getText('New Annual Confirmation is blocked by CRSO');

    	// TODO: Remove me when we have a nice solution, UGLY as hell
    	// CRSO DENMARK!!
    	// Only show at print
    	if(($this->if_obj->model['ac']->crso->relation->id==3)&&(isset($_REQUEST['process'])&& $_REQUEST['process']=='print'))
    	{
    		$this->text .= $this->getDenmarkAC(); // Fill with right tables. See ticket #985
    	}
    }

    function getDenmarkAC()
    {
    	$rv = "<br /><br /><br />";



    	$ds = array(
    		array('Egen import **'=>'Husholdninger','&nbsp;'=>'kg', 'Realiseret 2006 *'=>'<input type="text" value="" disabled="disabled" />','Budget 2007'=>'<input type="text" value="" disabled="disabled" />'),
    		array('Egen import **'=>'Husholdninger','&nbsp;'=>'stk', 'Realiseret 2006 *'=>'<input type="text" value="" disabled="disabled" />','Budget 2007'=>'<input type="text" value="" disabled="disabled" />'),
    		array('Egen import **'=>'Erhverv','&nbsp;'=>'kg', 'Realiseret 2006 *'=>'<input type="text" value="" disabled="disabled" />','Budget 2007'=>'<input type="text" value="" disabled="disabled" />'),
    		array('Egen import **'=>'Erhverv','&nbsp;'=>'stk', 'Realiseret 2006 *'=>'<input type="text" value="" disabled="disabled" />','Budget 2007'=>'<input type="text" value="" disabled="disabled" />'),
    		array('Egen import **'=>'Total','&nbsp;'=>'kg', 'Realiseret 2006 *'=>'<input type="text" value="" disabled="disabled" />','Budget 2007'=>'<input type="text" value="" disabled="disabled" />'),
    		array('Egen import **'=>'Total','&nbsp;'=>'stk', 'Realiseret 2006 *'=>'<input type="text" value="" disabled="disabled" />','Budget 2007'=>'<input type="text" value="" disabled="disabled" />'),
    		);

    	$tf = new TableFactory($ds,null);
    	$tf->setValueProcessor('Egen import **', 'if ( isset($previousrow) && $value == $previousrow[$orighead] ){ $tdclass .= \'-collapse\'; return \'\';}else return $value;'); // but this is shortcutted in $tablefactory->collapseColumns('NAME');
    	$rv .= $tf->getXHTMLTable('Professional',2);


    	$rv .= "<br />"."Angivelse af data i kg skal baseres på deltagerens egne data"."<br /><br />";
    	$rv .= "*)&nbsp;&nbsp;&nbsp;&nbsp; "."Husk at i årsrapporten for 2006 skal hele årets mængde med inklusiv 1. kvartal"."<br />";
    	$rv .= "**)&nbsp;&nbsp; "."Ved markedføring af både ansvarovedraget lyskilder og egen import skal kun egen import oplyses i dette skema"."<br /><br />";
    	$rv .= "<br /><br />"."Overdraget ansvar i perioden fra d. 1. april 2006 til 31. december 2006."."<br /><br />";


    	$ds = array(
    		array('#'=>1,'Firma navn'=>'<input type="text" value="" size="40" disabled="disabled" />','kg'=>'<input type="text" value="" disabled="disabled" />','stk'=>'<input type="text" value="" disabled="disabled" />'),
    		array('#'=>2,'Firma navn'=>'<input type="text" value="" size="40" disabled="disabled" />','kg'=>'<input type="text" value="" disabled="disabled" />','stk'=>'<input type="text" value="" disabled="disabled" />'),
    		array('#'=>3,'Firma navn'=>'<input type="text" value="" size="40" disabled="disabled" />','kg'=>'<input type="text" value="" disabled="disabled" />','stk'=>'<input type="text" value="" disabled="disabled" />'),
    		array('#'=>4,'Firma navn'=>'<input type="text" value="" size="40" disabled="disabled" />','kg'=>'<input type="text" value="" disabled="disabled" />','stk'=>'<input type="text" value="" disabled="disabled" />'),
    		array('#'=>5,'Firma navn'=>'<input type="text" value="" size="40" disabled="disabled" />','kg'=>'<input type="text" value="" disabled="disabled" />','stk'=>'<input type="text" value="" disabled="disabled" />'),
    		array('#'=>6,'Firma navn'=>'<input type="text" value="" size="40" disabled="disabled" />','kg'=>'<input type="text" value="" disabled="disabled" />','stk'=>'<input type="text" value="" disabled="disabled" />'),
    		array('#'=>7,'Firma navn'=>'<input type="text" value="" size="40" disabled="disabled" />','kg'=>'<input type="text" value="" disabled="disabled" />','stk'=>'<input type="text" value="" disabled="disabled" />'),
    		array('#'=>8,'Firma navn'=>'<input type="text" value="" size="40" disabled="disabled" />','kg'=>'<input type="text" value="" disabled="disabled" />','stk'=>'<input type="text" value="" disabled="disabled" />'),
    		array('#'=>9,'Firma navn'=>'<input type="text" value="" size="40" disabled="disabled" />','kg'=>'<input type="text" value="" disabled="disabled" />','stk'=>'<input type="text" value="" disabled="disabled" />'),
    		array('#'=>10,'Firma navn'=>'<input type="text" value="" size="40" disabled="disabled" />','kg'=>'<input type="text" value="" disabled="disabled" />','stk'=>'<input type="text" value="" disabled="disabled" />'),
    		);

    	$tf->setData($ds);
    	$tf->setCaption('Overdraget til');
    	$rv .= $tf->getXHTMLTable('Professional',2);

    	//$rv .= '<span class="status_declared">Please note that Subjugated amounts are always BTB</span>';

    	return $rv;
    }

    function getBrandList()
    {
    	require_once(ELC_CLASSES.'ParticipantBrand.php');
    	$pb = new ParticipantBrand($this->db_app);
    	$ds = $pb->getBrands($this->if_obj->model['ac']->participant->relation->id, $this->if_obj->model['cp']->crso->relation->id,$_SESSION['selected_product_id']);
    	$ds = $ds->fetchAll(PDO::FETCH_ASSOC);
    	if(!count($ds))
    		return '';
    	$tf = new TableFactory($ds,$this->langIf);
    	$tf->hideColumns(array('BRAND_ID'));
    	$tf->decapitate();
    	$tf->setCaption('Registered Brands');
    	return $tf->getXHTMLTable('Professional',2);
    }

    function _getAnnualRefundOverview($hiddenCols)
    {
    	if(!(($this->if_obj->model['cp']->producer_exporter & PARTICIPANT_EXPORTER) == PARTICIPANT_EXPORTER))
    		return '';
    	$rv = '<br />';
    	$q = $this->if_obj->model['ac']->getRefundOverview(null,null,null,$_SESSION['selected_product_id']);
    	$ds = $q->fetchAll(PDO::FETCH_ASSOC);
    	if(!count($ds))
    		return '';
    	$dl = new ELCDefaultList($this->db_app,$this->langIf);
    	if(!$this->if_obj->model['refund_available'])
    		$rv .= sprintf('<div class="warning">%s</div>',$this->langIf->getText('Refund periods have not all been closed'));
    	$caption = $this->langIf->getText('Annual Refund Overview');
    	return $rv.$this->_getTableOutput($ds,$dl,$hiddenCols,$caption,'Refund');

    }

    function _getTableOutput($ds,$dl,$hiddenCols,$caption,$tid)
    {
    	$this->_totals = $this->_totalsWeight = 0;
    	$this->_cols = array();
    	$this->_hiddenCols = $hiddenCols;
    	$tf = new TableFactory($ds,$this->langIf);
    	$tf->id = 'AnnualDeclarationOverview'.$tid;
    	$tf->hideColumns($hiddenCols);
    	$tf->setCaption($caption,false);
    	$tf->setValueProcessor('MONTH',array($dl,'tfMonth'));
    	$tf->setValueProcessor('BRAND_ID',array($dl,'tfBrand'));
    	$tf->setValueProcessor('PRODUCT_CATEGORY_ID',array($dl,'tfProductCategory'));
    	$tf->setValueProcessor('FILED',array($this,'tfFiled'));
    	$tf->setValueProcessor('CPD_ID',array($this,'tfDimension'));
    	$tf->setValueProcessor('QUANTITY',array($this,'tfValueProcessorQuantityNoDecimals'));
    	$tf->setValueProcessor('WEIGHT',array($this,'tfValueProcessorQuantityNoDecimals'));
		$tf->setValueProcessor('WEIGHT_DEC',array($this,'tfValueProcessorQuantity'));
    	$tf->setValueProcessor('AMOUNT',array($dl,'tfValueProcessorQuantity'));
    	$tf->setValueProcessor('EXPORTED',array($dl,'tfBooleanIcon'));
    	$tf->setFooterProcessor(array($this,'tfFooter'));
		$tf->setTHProcessor(array('WEIGHT','QUANTITY','WEIGHT_DEC'),'return \' class="th-right"\';');

		$tf->columnModifier(array('WEIGHT'=>'style="text-align:right;"', 'WEIGHT_DEC'=>'style="text-align:right;"','QUANTITY'=>'style="text-align:right;"','AMOUNT'=>'style="text-align:right;"'));
    	$rv = $tf->getXHTMLTable('Professional',2);

   		$this->if_obj->checksum .= $this->_totals;

    	return $rv;
    }
    function tfDimension($args)
    {
    	$d = new CRSOProductDimension($this->db_app,$args['value'],true);
    	return $d->name;
    }

	function tfValueProcessorQuantity($args) {
		$this->_totalsWeightDec += $args['value'];
		$args['extra'] .= sprintf(' sort_val="%s" ', $args['value']);
		return locale_nf($args['value'],3);
	}

    /**
     * Number formats a quanitity with no decimals
     */
    function tfValueProcessorQuantityNoDecimals($args)
    {
    	if($args['head']=='QUANTITY')
    		$this->_totals += $args['value'];
		else
    		$this->_totalsWeight += $args['value'];
    	$this->_cols = $args['visibleColumns'];
    	$args['extra'] .= sprintf(' sort_val="%s" ', $args['value']);
    	return locale_nf($args['value'], 0);
    }

	function tfFooter() // getClass
	{
		if(!$this->_cols)
			return false;
		$rv = explode(',',str_repeat(',',(sizeof($this->_cols)-1)));

		$pos = array_flip($this->_cols);
		if(!in_array('QUANTITY',$this->_hiddenCols))
			$rv[$pos['QUANTITY']] = '<span style="float:left; font-weight: bold;">'.$this->langIf->getText('Total').'</span><span style="float:right; font-weight: bold;">'.locale_nf($this->_totals,0).'</span><span style="clear:both;"></span>';
		if(!in_array('WEIGHT',$this->_hiddenCols))
			$rv[$pos['WEIGHT']] = '<span style="float:right; font-weight: bold;">'.locale_nf($this->_totalsWeight,0).'</span><span style="clear:both;"></span>';
		if(!in_array('WEIGHT_DEC',$this->_hiddenCols) && array_key_exists('WEIGHT_DEC', $pos))
			$rv[$pos['WEIGHT_DEC']] = '<span style="float:right; font-weight: bold;">'.locale_nf($this->_totalsWeightDec,3).'</span><span style="clear:both;"></span>';

		return $rv;
	}

	function tfFiled($args)
	{
		$trust_id = $args['row']['TRUST_ID']?$args['row']['TRUST_ID']:0;
		if(!isset($this->if_obj->model['monthList'][$trust_id][$args['row']['MONTH']]))
			$args['value'] = false;
		else
			$args['value'] = $this->if_obj->model['monthList'][$trust_id][$args['row']['MONTH']];

		return $this->tfBooleanIcon($args);
	}

	function tfAllFiled($args)
	{
		list($args['value'],) = $this->if_obj->model['ac']->hasNoUnfiledMonths($_SESSION['selected_participant_id'],null,$args['row']['YEAR'],null,$_SESSION['selected_product_id']);
		return $this->tfBooleanIcon($args);
	}

	function tfYearLink($args)
	{
		$args['extra'] = sprintf(' sort_val="%s" ', $args['value']);
		return sprintf('<a href="InterfaceAnnualConfirmation.php?crso[id]=%s&year=%s">%s</a>',
			$this->if_obj->model['crso']->relation->id,$args['value'],$args['value']);
	}

	function tfBooleanIcon($args)
	{
		$img = ($args['value']) ? 'true.gif' : 'false.gif';
    	return '<img src="/'.SITE_PATH.'images/i-w/'.$img.'" />';
	}

	function tfTranslateStatus($args)
	{
		$args['extra'] = sprintf(' sort_val="%s" ', $args['value']);
		list($trans,$class) = AnnualConfirmation::translateStatus($this->langIf,$args['value']);
		return sprintf('<span class="%s">%s</span>',$class,$trans);
	}

    /**
     * item[1607] =
     */
    function getCountrySpecificText()
    {
    	$this->text = "";
        if($this->if_obj->model['crso'] && ($this->if_obj->model['crso']->relation->id == 163) && $this->if_obj->model['is_available'] && $this->if_obj->model['year']){
            $t = "<br>I confirm that the above listed WEEE declarations are true and correct for ".$this->if_obj->model['year']."
                   for the named organisation.<br>
                  <ul>
                    <li style='margin-top: 8px'>Signed ...............................................................................................
                    <br>(Must be signed by a Managing Director/Senior Director of the organisation)</li>
                    <li style='margin-top: 8px'>Job Title .............................................................................................</li>
                    <li style='margin-top: 8px'>Print Name .........................................................................................</li>
                    <li style='margin-top: 8px'>Date ..................................................................................................</li>
                  </ul>
            ";
            $this->text = $t;
        }
    }

    /**
     * item[1141] = document[id]
     */
    function getAnnualConfirmationDocument()
    {
    	if(!$this->if_obj->model['is_available']||((count($this->if_obj->model['years'])==0)||!$this->if_obj->model['year']))
    		$this->_hideInput = true;
    }

    /**
     * item[1142] =
     */
    function getButtons()
    {
    	$this->_BarButtons = 0;
    	// Print Preview.


		if(!$this->if_obj->model['is_available'])
		{
			if(isset($this->if_obj->model['trust_available'][0])&&!$this->if_obj->model['trust_available'][0])
    			$this->_addCustomButton($this->langIf->getText('Declare unfiled months'),'button',array('onclick'=>"go('InterfaceDeclarationOverview.php?year=".$this->if_obj->model['year']."');"));
    		return;
		}
		if ($this->if_obj->process == 'print')
		{
			$this->_addCustomButton($this->langIf->getText('Print'), 'button', array('onclick'=>"print();"));
			$this->_addCustomButton($this->langIf->getText('Close'), 'button', array('onclick'=>"window.close();"));
			return;
		}


    	$this->_addCustomButton($this->langIf->getText('Print Preview'), 'button', array('onclick'=>"print_preview();"));
    	$this->script .= "
			function print_preview()
			{
				var nwin = new NewWindow(800, 600);
				nwin.setSource('about:blank');
				nwin.setName('winPrint');
				nwin.setScrollbars(true);
				nwin.center_me = false; // seems to give a permission denied sometimes
				var win = nwin.open(); // returns a window object

				// we can only post into when it has been loaded
				var frm = $('interface_form');
				frm.target='winPrint';
				frm.process.value='print';
				frm.submit();

				// restore
				frm.target='_self';
				frm.process.value='save';
				enableConfirmButton();

			}
			";

    	// Confirm Button.
    	// if confirmation not closed and participant is not blocked by crso
    	if($this->if_obj->model['ac']->status != ANNUAL_CONFIRMATION_CLOSED && $this->if_obj->model['cp']->allow_annual_confirmation)
    	{
    		$this->script .= "
				function enableConfirmButton()
				{
					$('ifI_1142_CB_1').disabled = false;
				}
				";
    		$this->_addCustomButton($this->langIf->getText('Confirm'),'submit',array('disabled'=>'disabled'));
    	}
    	else
    	{
    		$this->script .= "
				function enableConfirmButton()
				{

				}
			";
    	}
    }

    /**
     * item[1172] =
     */
    function getRejectMessage()
    {
    	$this->twoCols = true;
    	$this->text = sprintf('<span class="status_forfeit">%s</span>',$this->langIf->getText('Your AC Document has been rejected, please revise'));
    }

    /**
     * item[1173] =
     */
    function get2colTxt()
    {
    	$this->twoCols = true;
    }
}

/**
 * CALLBACK[getYearSelect]
 * item[1138] = {
 *     [handle] = Item: Year Selection
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getCRSOSelect]
 * item[1140] = {
 *     [handle] = Item: CRSO Selection
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getAnnualDeclarationOverview]
 * item[1139] = {
 *     [handle] = Item: AnnualDeclarationOverview
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getAnnualConfirmationDocument]
 * item[1141] = {
 *     [handle] = Item: AnnualConfirmationDocument
 *     [behaviour] = required
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 */
?>
