<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
require_once(ELC_CLASSES . 'Participant.php');
require_once(ELC_CLASSES . 'Country.php');
/**
 *
 * @package ELC
 * @subpackage Interface
 * @since 03-03-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceApplyAtParticipant extends InterfaceFactory
{
    /**
     * interface[id] = 81
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceApplyAtParticipant(&$db, &$db_app, &$langIf)
    {
        parent::InterfaceFactory($db, $db_app, $langIf);
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';
    }
    /**
     * @param string $thrownException
     * @todo Need to specify full paths in notification callbacks, as the notifications are now under the public scripts
     */
    function processInput(&$thrownException)
    {
		if(isset($_POST['process']))
		{
			$log = getLog();
			if($_POST['process'] == 'save')
			{
				require_once(ELC_CLASSES . 'Relation.php');
				require_once(ELC_CLASSES . 'User.php');
				require_once(ELC_CLASSES . 'RelationUser.php');

				$this->db_app->begin();

				$ru = new RelationUser($this->db_app,
					array('relation'=> new Relation($this->db_app, $_REQUEST['participant']),
						'user'=>new ELCUser($this->db_app, array('id'=>$_SESSION['session_user_id']))));
				$ru->status = 0;
				$ru->insert();
				$ru->relation->set();
				$ru->user->set();
				$ru->user->info_person->set();

				info("User [".$_SESSION['session_user_id']."] applied at participant [".$_REQUEST['participant']['id']."]");
				require_once(ELC_CLASSES.'Notification.php');
				$recipients = $map = array();
				$map['user'] = $ru->user;
				$map['type'] = NOTIFICATION_TYPE_MESSAGE;
				$map['subject'] = $this->langIf->getText('New ApplyAtParticipant');
				$map['message'] = $this->langIf->getText('`{RELATION_NAME}``{RELATION_COMPANY}`  to join Participant {PARTICIPANT}',null,
					array('RELATION_NAME'=>$ru->relation->name,
						'RELATION_COMPANY'=>$ru->relation->name,
						'PARTICIPANT'=>$ru->user->info_person->getFullName()
					)
				);
				$recipients[] = array('recipient'=>$ru->relation, 'callback'=>''); // FIXME callback
				Notification::send($this->db_app, $map, $recipients);

				$this->db_app->commit();

				if (!headers_sent()) {
					header('Location: InterfaceRegistrationOverview.php');
					die();
				}
			}
		}


    }
}
/**
 * @package ELC
 * @subpackage Interface
 * @since 03-03-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceApplyAtParticipantItem extends InterfaceItem
{
    /**
     * item[732] =
     */
    function getParticipantTree()
    {
		$txtNoAvailable = $this->langIf->getText('No available Participants to apply to');

		$this->text = '<div id="ifI_'.$this->id.'"></div>';
		$p = new Participant($this->db_app);

		$country='';
		$q = $p->selectAvailableParticipants();
		if ($r = $q->fetch())
		{
			$this->script = '
				ParticipantNode = function(title,participantId)
				{
					NavigationNode.apply(this,[title]);
					this.negerinBehaviour = function()
					{
						try {
							ifHandler.loadBlock([146],\'&interface_id=54&participant[id]=\'+participantId);
							$$(\'participant[id]\').value = participantId;
						} catch (e) {
							go(\'InterfaceApplyAtParticipant.php?participant[id]=\'+participantId);
						}

					}
				}
				ParticipantNode.prototype = new NavigationNode(\'\');
				var countryNode = new NavigationNode(\''.jstr('Country List', $this->langIf).'\',\'\',true, ['."\n";

			do
			{
				if ($country != $r->COUNTRY_NAME && $country != '') {
					debug('closing country, changing name');
					$this->script = substr($this->script,0,-2)."\n\t".']),'."\n";
				}

				if ($country != $r->COUNTRY_NAME)
				{
					debug('creating new country');
					$this->script .= "\t".'new NavigationNode(\''.jsescape($r->COUNTRY_NAME).'\', \'\', false, ['."\n";
					$country = $r->COUNTRY_NAME;
				}

				$this->script .= "\t\t".'new ParticipantNode(\''.jsescape($r->PARTICIPANT_NAME,"'").'\', '.$r->PARTICIPANT_ID.'),'."\n";
			}while($r = $q->fetch());

			$this->script = substr($this->script,0,-2)."\n\t".'])]);'."\n";
			$this->postscript = 'countryNode.display($(\'ifI_'.$this->id.'\'));';
		}
		else
			$this->text = $txtNoAvailable;
    }

    /**
     * item[736] =
     */
    function getButtons()
    {
    	$this->_BarButtons = BUTTON_CANCEL;
    	$this->_ButtonOptions[BUTTON_CANCEL] = array('onclick'=>"document.location.href='InterfaceRegistrationOverview.php';");
    	$this->_addCustomButton($this->langIf->getText('Apply at Participant'), 'button',
    		array('onclick'=>
    			jsMessageBox(MSG_BOX_QUEST,
    				$this->langIf->getText('Confirmation'),
    				$this->langIf->getText('Are you sure you want to apply to this participant as a new user?'),
    				"function(){\$('interface_form').submit();}")));
    }


	function getCompanyInterface()
	{
		if (isset($_REQUEST['participant']['id']))
		{
			$this->settings = array();
			$this->settings['_hideInputs'] = 'return true;';
			$this->settings['rel'] = new Relation($this->db_app,$_REQUEST['participant']['id']);
			$this->settings['participant'] = new Participant($this->db_app,array('relation'=>new Relation($this->db_app, $_REQUEST['participant']['id'])));
			$this->hiddenFields[] = array('name'=>'participant[id]', 'value'=>$_REQUEST['participant']['id']);
		}
		else
		{
			$this->showInterface = false;
			$this->hiddenFields[] = array('name'=>'participant[id]', 'value'=>'');
			$this->text = $this->langIf->getText('Please select a participant');
		}
	}

}

/**
 * CALLBACK[getParticipantTree]
 * item[732] = {
 *     [handle] = Item: ParticipantTree
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * CALLBACK[getCompanyInterface]
 * item[733] = {
 *     [handle] = Item: InterfaceCompanyInformation
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getButtons]
 * item[734] = {
 *     [handle] = Item: Buttons
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 */
?>
