<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
require_once(ELC_CLASSES.'CRSOParticipantProduct.php');
require_once(ELC_CLASSES.'AnnualConfirmation.php');
require_once(ELC_CLASSES.'Country.php');

define('BLOCK_ANNUAL_CONFIRMATION_CHANGE',389);

/**
 *
 * @package ELC
 * @subpackage Interface
 * @since 25-10-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceChangeRequest extends InterfaceFactory
{
    /**
     * interface[id] = 150
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceChangeRequest(&$db, &$db_app, &$langIf)
    {
        parent::InterfaceFactory($db, $db_app, $langIf);
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';

        $this->model['cp'] = new CRSOParticipantProduct($this->db_app);
        $this->model['cp']->participant = new Participant($this->db_app,array('relation'=>new Relation($this->db_app, $_SESSION['selected_participant_id'])));
        $this->model['cp']->product = new Product($this->db_app, $_SESSION['selected_product_id']);

        // Check for CRSO's for prov decl
        $this->model['crsos'] = $this->model['cp']->getParticipantCRSOs($_SESSION['selected_participant_id'],'q',PARTICIPANT_PRODUCER, false, $_SESSION['selected_product_id']);
        if(($r = $this->model['crsos']->fetch()) && !($r2 = $this->model['crsos']->fetch()))
        {
        	$this->model['cp']->crso = new CRSO($this->db_app,array('relation'=>new Relation($this->db_app, $r->CRSO_RELATION_ID)));
        	$this->model['cp']->set();
        }
		elseif(isset($_REQUEST['crso']['id'])&&is_numeric($_REQUEST['crso']['id']))
        {
        	$this->model['cp']->crso = new CRSO($this->db_app,array('relation'=>new Relation($this->db_app, $_REQUEST['crso'])));
        	$this->model['cp']->set();
        }

        $this->model['crsos_change_participant'] = $this->model['cp']->getParticipantCRSOs(
    								$_SESSION['selected_participant_id'],
    								'array',
    								PARTICIPANT_PRODUCER + PARTICIPANT_EXPORTER,
    								true,
    								$_SESSION['selected_product_id']
    									);
        //check for crsos for type change
        if(isset($_REQUEST['crso_change_participant']['id'])&&is_numeric($_REQUEST['crso_change_participant']['id']))
        {
        	$this->model['crso_change_participant'] = (int)$_REQUEST['crso_change_participant']['id'];
        }
        else
        {
        	$this->model['crso_change_participant'] = count($this->model['crsos_change_participant']) == 1 ?
        					$this->model['crsos_change_participant'][0] : false;
        }

        /**#@+
         * Annual Confirmation Stuff goes here:
         */
        $this->model['ac'] = new AnnualConfirmation($this->db_app,array('participant'=>$this->model['cp']->participant));
        $this->model['ac_crsos'] = $this->model['ac']->getCRSOselect(null,'array',$_SESSION['selected_product_id']);
        $this->model['annualcrso'] = false;
        if(isset($_REQUEST['annualcrso']['id'])&&is_numeric($_REQUEST['annualcrso']['id']))
        {
        	$this->model['annualcrso'] = new CRSO($this->db_app,array('relation'=>new Relation($this->db_app, $_REQUEST['annualcrso'])));
        	$this->model['ac']->crso =& $this->model['annualcrso'];
        }
		/**#@-*/
    }

    function init($ifId)
    {
    	$rv = parent::init($ifId);

    	// Hide the annual confirmation request change if there are non for the selected_participant_id
    	if(count($this->model['ac_crsos'])==0)
    		unset($this->blocks[BLOCK_ANNUAL_CONFIRMATION_CHANGE]);

    	return $rv;
    }

    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {

    }
}
/**
 * @package
 * @subpackage Interface
 * @since 25-10-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceChangeRequestItem extends InterfaceItem
{
    /**
     * item[1106] = crso[id]
     */
    function getCRSOSelect()
    {
	$rv = null;
		// Check for any active Remote Viewer connections.
		if(IWRegistry::isRegistered('remote_viewer')) {
			$rv = IWRegistry::registry('remote_viewer');
		}
    	$this->if_obj->model['crsos']->execute();
    	$this->properties['onchange'] = "_ReloadProvBlock();";
    	$crso_id = isset($this->if_obj->model['cp']->crso)?$this->if_obj->model['cp']->crso->relation->id:'';

    	$this->options = array(array('text'=>'- '.$this->langIf->getText('Select CRSO').' -','value'=>''));
    	while($r = $this->if_obj->model['crsos']->fetch())
    	{
		if($rv && $rv->crso->relation->id!=$r->CRSO_RELATION_ID)
			continue;
    		$this->options[] = array('text'=>$r->CRSO_NAME,'value'=>$r->CRSO_RELATION_ID,
				'selected'=>(($crso_id==$r->CRSO_RELATION_ID)?true:false));
    	}

		$this->postscript = "
		    function _ReloadProvBlock()
		    {
		        var params = new Array();
				params['crso'] = new Array();
		        params['crso']['id'] = getElByName('crso[id]').value;
		        params['interface_id'] = ".$this->if_obj->id."; // you MUST supply this
		        ifHandler.loadBlock( new Array(new String('371')), params );
		    }";
    }

    /**
     * item[1105] =
     */
    function getProvisionalChangeRequest()
    {
    	$this->_BarButtons = 0;
    	$notProducer = $this->langIf->getText('Not a producer');
    	$selectCRSO = $this->langIf->getText('Select CRSO First');
    	$noOutstandingPeriods = $this->langIf->getText('No Outstanding Periods');
    	$completeSubrogation = $this->langIf->getText('Complete Subrogation, no change request possible');
    	if(!$this->if_obj->model['cp']->isComplete())
    		return $this->text = $selectCRSO;

    	$this->if_obj->model['cp']->participant->set();
    	if(!($this->if_obj->model['cp']->producer_exporter & PARTICIPANT_PRODUCER))
    		return $this->text = $notProducer;

    	if($this->if_obj->model['cp']->no_declaration)
    		return $this->text = $completeSubrogation;

    	$date =& currentDate();
    	if($date->getMonth()==1)
    		$year = $date->getYear()-1;
    	else
    		$year = $date->getYear();

    	require_once(ELC_CLASSES.'Declaration.php');
    	require_once(ELC_CLASSES.'CRSOProduct.php');
    	$lastMonth = Declaration::getLastTriggeredMonth($this->db_app,$this->if_obj->model['cp']->crso->relation->id,$_SESSION['selected_participant_id'], $year, $_SESSION['selected_product_id']);
    	$cp = new CRSOProduct($this->db_app);
    	$cp->set($this->if_obj->model['cp']->crso->relation->id,$_SESSION['selected_product_id']);

    	if(($lastMonth==12)&&($date->getDay()<$cp->forfeit_day))
    		return $this->text = $noOutstandingPeriods;


    	$this->postscript = sprintf("
			document.RequestProvisionalChange = function()
			{
					var params = new Array();
					params['participant_id'] = %s;
					params['crso_id'] = %s;
					params['product_id'] = %s;

					// see includes/elc/rpc/RequestChangeProvisional.php
					jsbroker.call('requestChangeProvisional', params, function(p)
					{
						MessageBox.prototype.Information('', '%s');
						$('ifI_1105_CB_0').disabled = true;
					});
			}
			",
			$this->if_obj->model['cp']->participant->relation->id,
			$this->if_obj->model['cp']->crso->relation->id,
			$this->if_obj->model['cp']->product->id,
			jsescape($this->langIf->getText('Request for Change on Provisional sent'), "'")
			);

		if($this->if_obj->model['cp']->status == PARTICIPANT_STATUS_PARTICIPANT_READY
                    || $this->if_obj->model['cp']->status == PARTICIPANT_STATUS_CONFIRMED)
		{
			$props = $this->if_obj->model['cp']->provisional_change_request_status?array('disabled'=>'disabled'):array('onclick'=>'RequestProvisionalChange();');
			$this->_addCustomButton($this->langIf->getText('Request Change for Provisional'),'button', $props);
			if($this->if_obj->model['cp']->provisional_change_request_status == PROVISIONAL_CHANGE_REQUEST_AUTHORIZED) {
				$this->_addCustomButton($this->langIf->getText('Change your Provisional'),'button', array(
					'onclick'=>sprintf('document.location.href="/'.SITE_PATH.'scripts/elc/participant/InterfaceProvisionalForm.php?crso[id]=%s&participant[id]=%s&product[id]=%s";',
						$this->if_obj->model['cp']->crso->relation->id,
						$this->if_obj->model['cp']->participant->relation->id,
						$this->if_obj->model['cp']->product->id)));
			}
		}
    }


    /**
     * item[1109] = crso_change_participant[id]
     */
    function getCRSOSelectParticipantType()
    {
	$rv = null;
		// Check for any active Remote Viewer connections.
		if(IWRegistry::isRegistered('remote_viewer')) {
			$rv = IWRegistry::registry('remote_viewer');
		}
    	$this->options = array(array('text'=>'- '.$this->langIf->getText('Select CRSO').' -','value'=>''));

    	$selected_crso_id = $this->if_obj->model['crso_change_participant'];

    	//then we find all crsos where the participant is not both producer/exporter
    	foreach($this->if_obj->model['crsos_change_participant'] as $crso_id)
    	{
		if($rv && $rv->crso->relation->id!=$crso_id)
			continue;
        	$crso = new CRSO($this->db_app,array('relation'=>new Relation($this->db_app, $crso_id, true)));
        	$this->options[] = array('text'=>$crso->relation->name,'value'=>$crso_id, 'selected'=>($selected_crso_id==$crso_id)?true:false);
    	}

    	$this->properties['onchange'] = "_ReloadChangeParticipantTypeBlock();";

    	$this->postscript = "
		    function _ReloadChangeParticipantTypeBlock()
		    {
		        var params = new Array();
				params['crso_change_participant'] = new Array();
		        params['crso_change_participant']['id'] = getElByName('crso_change_participant[id]').value;
		        params['interface_id'] = ".$this->if_obj->id."; // you MUST supply this
		        ifHandler.loadBlock( new Array(new String('372')), params );
		    }";
    }

    /**
     * item[1110] =
     */
    function getChangeParticipantType()
    {
    	$this->_BarButtons = 0;
    	$selectCRSO = $this->langIf->getText('Select CRSO First');
    	$noTypeAvailable = $this->langIf->getText('There is no other type available at CRSO');
    	$producerRequest = $this->langIf->getText('Request to become a producer');
    	$exporterRequest = $this->langIf->getText('Request to become a exporter');

    	if(!$this->if_obj->model['crso_change_participant'])
    	{
    		$this->text = $selectCRSO;
    		return;
    	}
    	$cp = new CRSOParticipantProduct($this->db_app);
    	$cp->set($this->if_obj->model['crso_change_participant'], $_SESSION['selected_participant_id'], $_SESSION['selected_product_id']);
    	$country = new Country($this->db_app,$cp->crso->getCountry(),true);

    	if($cp->producer_exporter & PARTICIPANT_PRODUCER)
    	{
    		if(!$country->has(HasRefundRequest,$_SESSION['selected_product_id']))
    		{
    			$this->text = $noTypeAvailable;
    			return;
    		}
    		$buttonText = $exporterRequest;
    		$status = PARTICIPANT_TYPE_CHANGE_EXPORTER;
    	}
    	else
    	{
    		$buttonText = $producerRequest;
    		$status = PARTICIPANT_TYPE_CHANGE_PRODUCER;
    	}

    	$this->postscript = sprintf("
			document.RequestChangeParticipantType = function()
			{
					var params = new Array();
					params['participant_id'] = %s;
					params['crso_id'] = %s;
					params['product_id'] = %s;
					params['status'] = %s;

					// see includes/elc/rpc/RequestChangeParticipantType.php
					jsbroker.call('requestChangeParticipantType', params, function(p)
					{
						MessageBox.prototype.Information('', '%s');
						$('ifI_1110_CB_0').disabled = true;
					});
			}
			",
			$_SESSION['selected_participant_id'],
			$this->if_obj->model['crso_change_participant'],
			$_SESSION['selected_product_id'],
			$status,
			jsescape($this->langIf->getText('Change Participant Type Request Sent'), "'")
			);

			$props = $cp->participant_type_change_request ? array('disabled'=>'disabled') : array('onclick'=>'RequestChangeParticipantType()');
			$this->_addCustomButton($buttonText,'button', $props);
    }

    /**
     * item[1143] = annualcrso[id]
     */
    function getAnnualCRSOSelect()
    {
	$rv = null;
		// Check for any active Remote Viewer connections.
		if(IWRegistry::isRegistered('remote_viewer')) {
			$rv = IWRegistry::registry('remote_viewer');
		}
    	$this->options = array(array('value'=>'','text'=>'- '.$this->langIf->getText('Select CRSO').' -'));
    	$crsos = $this->if_obj->model['ac_crsos'];
    	$selected = $this->if_obj->model['annualcrso']?$this->if_obj->model['annualcrso']->relation->id:false;

    	foreach($crsos as $crso_id => $name)
    	{
		if($rv && $rv->crso->relation->id!=$crso_id)
			continue;
    		$name = (mb_strlen($name)>35)?mb_substr($name,0,35).'...':$name;
    		$this->options[] = array('value'=>$crso_id,'text'=>$name,'selected'=>($selected==$crso_id?'selected':false));
    	}
    	$this->properties['onchange'] = '_LoadAnnualConfOverview();';

    	$this->postscript = "
		    function _LoadAnnualConfOverview()
		    {
		        var params = new Array();
		        params['annualcrso'] = new Array();
				params['annualcrso']['id']= getElByName('annualcrso[id]').value;
		        params['interface_id'] = ".$this->if_obj->id."; // you MUST supply this
		        ifHandler.loadBlock( new Array(new String('".BLOCK_ANNUAL_CONFIRMATION_CHANGE."')), params );
		    }";
    }

    /**
     * item[1144] =
     */
    function getRequestAnnualChange()
    {
    	$this->_BarButtons = 0;

    	$props = array();
    	$years = $this->if_obj->model['annualcrso']?$this->if_obj->model['ac']->getYears(null,null,'array',ANNUAL_CONFIRMATION_CLOSED,$_SESSION['selected_product_id']):array();

    	if(count($years)==0)
    		$props['disabled'] = 'disabled';
    	else
    		$props['onclick'] = 'requestAnnualConfirmationChange();';


    	$this->_addCustomButton($this->langIf->getText('Request for re-opening yearly declarations'),'button',$props);

    	// Do a confirm, on confirm, do Ajax
    	$this->script = sprintf("
			function requestAnnualConfirmationChange()
			{
				MessageBox.prototype.Question('%s','%s',function(){
					sendRequestAnnualConfirmationChange();
				});
			}

			function sendRequestAnnualConfirmationChange()
			{
				var params = new Array();
				params['year'] = $('ifI_1145').options[$('ifI_1145').selectedIndex].value;
				params['crso_id'] = $('ifI_1143').options[$('ifI_1143').selectedIndex].value;
				jsbroker.call('requestAnnualConfirmationChange', params, function(p) {
						MessageBox.prototype.Information('%s','%s');
					});
			}
			",
			$this->langIf->getText('Notifcation: Change Request Annual Confirmation'),
			$this->langIf->getText('Notifaction: Annual Conf: Are you sure you want to sent a request'),
			$this->langIf->getText('Notifcation: Change Request Annual Confirmation'),
			$this->langIf->getText('Notifaction: Your request for annual conf change has been sent'));
    }

    /**
     * item[1145] = annualyear
     */
    function getAnnualConfYearSelect()
    {
    	if(!$this->if_obj->model['annualcrso'])
    	{
    		$this->options = array(array('value'=>'','text'=>'- '.$this->langIf->getText('Select CRSO First').' -'));
    		return;
    	}

    	$this->options = array();
    	$years = $this->if_obj->model['ac']->getYears(null,null,'array',ANNUAL_CONFIRMATION_CLOSED,$_SESSION['selected_product_id']);
    	if(count($years)==0)
    		$this->options = array(array('value'=>'','text'=>'- '.$this->langIf->getText('No Closed Years available').' -'));

    	foreach($years as $year)
    		$this->options[] = array('value'=>$year,'text'=>$year);
    }

    /**
     * item[1146] =
     */
    function getSpacer()
    {
    	$this->_BarButtons = 0;
    }
}

/**
 * CALLBACK[getProvisionalChangeRequest]
 * item[1105] = {
 *     [handle] = Item: RequestChangeProvisional
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 * CALLBACK[getCRSOSelectParticipantType]
 * item[1109] = {
 *     [handle] = Item: CrsoSelect
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * CALLBACK[getChangeParticipantType]
 * item[1110] = {
 *     [handle] = Item: RequestChangeParticipantType
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 */
?>
