<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
require_once(ELC_CLASSES.'CRSOParticipant.php');
require_once(ELC_CLASSES.'RelationUser.php');
require_once(ELC_CLASSES.'Participant.php');
/**
 * @package
 * @subpackage
 * @since 4-okt-2007
 * @author Marten Koedam <marten@dalines.net>
 * @version $Id$
 * @copyright 2007 BaseSoft B.V.
 */
class InterfaceCompanyInformation extends InterfaceFactory
{
    /**
     * interface[id] = 180
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceCompanyInformation(&$db, &$db_app, &$langIf)
    {
        parent::InterfaceFactory($db, $db_app, $langIf);
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';

        if(!isset($_REQUEST['crso']['id'])||!isset($_REQUEST['participant']['id']))
        	throw new InterfacePermissionException('Incorrect arguments');

        // Check admin user
        $ru = new RelationUser($this->db_app);
        if(!$ru->validateAdmin($_SESSION['session_user_id'],$_REQUEST['participant']['id']))
        	throw new InterfacePermissionException('Not the admin user');

        if(isset($_REQUEST['product']['id'])&&($_REQUEST['product']['id']!=$_SESSION['selected_product_id']))
		{
			$_SESSION['selected_product_id'] = $_REQUEST['product']['id'];
			header(
				sprintf('Location: /%sscripts/elc/participant/InterfaceCompanyInformation.php?participant[id]=%s&crso[id]=%s',
				SITE_PATH,
				$_REQUEST['participant']['id'],
				$_REQUEST['crso']['id']
				));
			exit();
		}

        $cpp = new CRSOParticipantProduct($this->db_app);
		if(!$cpp->set($_REQUEST['crso']['id'],$_REQUEST['participant']['id'],$_SESSION['selected_product_id']))
			throw new InterfacePermissionException('Unable to set selected participant/crso/product combination');
		$this->model['cpp'] = $cpp;
    }
    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {
        if(isset($_REQUEST['process']) && $_REQUEST['process'] == 'export')
		{
			if($_REQUEST['participant']['id'] != $_SESSION['selected_participant_id'])
				throw new IWUserException("Permission denied");
			$ids = array((int)$_REQUEST['participant']['id']);
			$part = new Participant($this->db_app);
			$csv = $part->export_masterdata($ids);
			if (!headers_sent())
			header('Content-Disposition: attachment; filename="Masterdata_'.$_REQUEST['participant']['id'].'.csv"');
            echo $csv->getString();
            die();
		}
    }
}
/**
 * @package
 * @subpackage Interface
 * @since 04-10-2007
 * @copyright 2007 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceCompanyInformationItem extends InterfaceItem
{

    /**
     * item[1405] = 54
     */
    function getInterfaceCompanyDetails()
    {
    	$this->settings = array('targetId'=>'return "ifB_485";');
    }

}

/**
 * CALLBACK[getInterfaceCompanyDetails]
 * item[1405] = {
 *     [handle] = Item: CompanyDetails
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 */
?>