<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
require_once(ELC_CLASSES.'Declaration.php');
/**
 *
 * @package
 * @subpackage Interface
 * @since 28-02-2007
 * @copyright 2007 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceDeclarationIndex extends InterfaceFactory
{
    /**
     * interface[id] = 167
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceDeclarationIndex(&$db, &$db_app, &$langIf)
    {
        parent::InterfaceFactory($db, $db_app, $langIf);
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';
    }
    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {

    }
}
/**
 * @package
 * @subpackage Interface
 * @since 28-02-2007
 * @copyright 2007 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceDeclarationIndexItem extends InterfaceItem
{

    /**
     * item[1299] =
     */
    function getDeclarationIndex()
    {
	$remote = null;
		// Check for any active Remote Viewer connections.
		if(IWRegistry::isRegistered('remote_viewer')) {
			$remote = IWRegistry::registry('remote_viewer');
		}
    	$rv = '';
    	// Foreach Product
    	require_once(ELC_CLASSES.'CRSOParticipantProduct.php');
		$cpp = new CRSOParticipantProduct($this->db_app);
		$products = $cpp->getProducerProductsCRSO($_SESSION['selected_participant_id']);

		require_once(ELC_CLASSES.'CRSOProduct.php');
		$this->cp = new CRSOProduct($this->db_app);

		$this->declaration = new Declaration($this->db_app);

    	foreach($products as $product_id => $settings)
    	{
    		$rv .= sprintf('<h1 style="text-align: left;"><a href="/%sscripts/elc/public/ChangeProduct.php?product[id]=%s&h=%s">%s</a></h1>',
    				SITE_PATH,
    				$product_id,
    				urlencode(base64_encode(sprintf('/%sscripts/elc/participant/InterfaceDeclarationOverview.php',SITE_PATH))),
    				$settings['name']);

    		foreach($settings['crsos'] as $crso_id => $crso_name)
			// only show current remote viewer CRSO if applicable.
			if($remote && $remote->crso->relation->id != $crso_id)
				continue;
    			$rv .= $this->getDeclarationOverview($product_id,$crso_id,$crso_name);
    	}

    	$this->text = $rv;
    }

	private function getDeclarationOverview($product_id,$crso_id,$crso_name)
	{
		$rv = '';

		$this->cp->set($crso_id, $product_id);
		$fday = $this->cp->getNextCutOffDateDeclaration();

		$q = $this->declaration->getOpenDeclarationOverview($_SESSION['selected_participant_id'],$crso_id,$product_id);

		$hideCols = array('DECLARATION_ID','CRSO_RELATION_ID','PRODUCT_ID');
		$this->crso_name = $crso_name;
		$tf = new TableFactory($q,$this->langIf);
		$forf = "<div style='float:left'>".$crso_name."</div><div style='text-align:right'><span class='cut-off-date'>".
				$this->langIf->getText("Upcoming cut-off date").": ".$fday."</span></div>";
		$tf->setCaption($forf,false);
		$tf->setValueProcessor(TF_ALL,array($this,'tfValueProcessor'));
		$tf->hideColumns($hideCols);
		$rv = $tf->getXHTMLTable('Professional',2);

		return $rv.'<br />';
	}

	public function tfValueProcessor($args)
	{
		switch($args['head'])
		{
			case 'PERIOD':
				return strftime('%B', mktime(0, 0, 0, $args['value'], 1));
			break;
			case 'DECLARATION_STATUS':
				$val = $args['row']['DECLARATION_STATUS'] = Declaration::getDisplayStatus($args['value']);
				list($trans,$class) = Declaration::translateStatus($this->langIf,$val);

				$handle = 'Declaration Forfeit_'.$this->crso_name;
				// we need bytes but we dont want to break the multibyte string
				$handle = (strlen($handle)>254)?mb_strcut($handle,0,254):$handle;

				$crsoTrans = ($val!=DECLARATION_FORFEIT)?'':$this->langIf->getText($handle);
				$trans = empty($crsoTrans)?$trans:$crsoTrans;

				return sprintf('<span id="declaration_status_%s" class="%s">%s</span>',
					$args['i'],$class,$trans);
			break;
			case 'DECLARATION_ACTION':
				$buttonAction = Declaration::getButtonAction($this->langIf,$args['row']['DECLARATION_STATUS'],false);

				return sprintf('<input type="button" id="declaration_%s" style="width: 120px;" onclick="%s" value="%s" />',
					$args['i'],
					sprintf("document.location.href='/%sscripts/elc/public/ChangeProduct.php?product[id]=%s&h=%s';",
						SITE_PATH,
						$args['row']['PRODUCT_ID'],
						urlencode(base64_encode(sprintf('/%sscripts/elc/participant/InterfaceDeclarationForm.php?declaration[id]=%s',
							SITE_PATH,
							$args['row']['DECLARATION_ID'])))
					),
					$buttonAction
					);
			break;
		}
		return $args['value'];
	}
}

/**
 * CALLBACK[getDeclarationIndex]
 * item[1299] = {
 *     [handle] = Item: DeclarationIndex
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 */
?>