<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
require_once(ELC_CLASSES.'Brand.php');
require_once(ELC_CLASSES.'CRSOParticipantProduct.php');
require_once(ELC_CLASSES.'ParticipantBrand.php');
require_once(ELC_CLASSES.'Product.php');

define('BLOCK_CRSO_SELECT',382);
define('BLOCK_BRAND_MANAGEMENT',383);
define('BLOCK_BUTTON_BAR',384);
/**
 *
 * @package
 * @subpackage Interface
 * @since 02-11-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceParticipantBrandManagement extends InterfaceFactory
{
	protected $hideCRSOSelect = false;
    /**
     * interface[id] = 154
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceParticipantBrandManagement(&$db, &$db_app, &$langIf)
    {
        parent::InterfaceFactory($db, $db_app, $langIf);
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';

        $this->model['crso'] = false;
		$cp = $this->model['cp'] = new CRSOParticipantProduct($this->db_app);
		$crsos = $cp->getParticipantCRSOs($_SESSION['selected_participant_id'],'array',false,false,$_SESSION['selected_product_id']);
	$rv = null;
		// Check for any active Remote Viewer connections.
		if(IWRegistry::isRegistered('remote_viewer')) {
			$rv = IWRegistry::registry('remote_viewer');
			$this->hideCRSOSelect = true;
			$this->model['crso'] = $rv->crso;
		}
		elseif(count($crsos)==1)
		{
			$this->hideCRSOSelect = true;
			$this->model['crso'] = new CRSO($this->db_app,array('relation'=>new Relation($this->db_app,current($crsos))));
		}
		elseif(isset($_REQUEST['crso']['id'])&&is_numeric($_REQUEST['crso']['id']))
			$this->model['crso'] = new CRSO($this->db_app,array('relation'=>new Relation($this->db_app,$_REQUEST['crso']['id'])));

        $this->script = "
			function addBrand(el)
			{
				var o = document.createElement('option');
				o.innerHTML = el.value;
				o.value = 'new_'+el.value;
				FancySelectController.prototype.getController('brands[]').addOption(o);
			}
			";
    }
    function init($if_id)
    {
    	$rv = parent::init($if_id);
    	if(!$this->model['crso'])
    		unset($this->blocks[BLOCK_BRAND_MANAGEMENT],$this->blocks[BLOCK_BUTTON_BAR]);
    	if($this->hideCRSOSelect)
    		unset($this->blocks[BLOCK_CRSO_SELECT]);
    	return $rv;
    }

    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {
        if(!isset($_POST['process']))
        	return;

        if($_POST['process']=='save')
        {
        	$this->db_app->begin();

        	$pb = new ParticipantBrand($this->db_app);
        	$pb->deleteWhereNotUsed($_SESSION['selected_participant_id'],$this->model['crso']->relation->id,$_SESSION['selected_product_id']);
        	$pb->participant = new Participant($this->db_app,array('relation'=>new Relation($this->db_app,$_SESSION['selected_participant_id'])));
        	$pb->brand = new Brand($this->db_app,array('crso'=>$this->model['crso']));

        	if(isset($_POST['brands']))
        	{
	        	foreach($_POST['brands'] as $brand_id)
	        	{
	        		if(is_numeric($brand_id))
	        		{
	        			$pb->brand->id = $brand_id;
	        			$pb->objectmap['inserttype'] = 'REPLACE';
		       			$pb->insert();
		       			$pb->objectmap['inserttype'] = 'INSERT';
		       			continue;
	        		}
					$brandName = substr($brand_id,4);
					if(!$pb->brand->setByNameByCRSO($brandName,false,$_SESSION['selected_product_id']))
					{
						$pb->brand->id = '';
						$pb->brand->name = $brandName;
						$pb->brand->active = 0;
						$pb->brand->product = new Product($this->db_app,$_SESSION['selected_product_id']);
						$pb->brand->insert();
						$pb->brand->setByNameByCRSO($brandName,false,$_SESSION['selected_product_id']); // EE!!!
					}
					$pb->insert();
	        	}
        	}
        	$this->db_app->commit();
        	header('Location: InterfaceBrandManagement.php?crso[id]='.$this->model['crso']->relation->id);
        	exit();
		}
    }
}
/**
 * @package
 * @subpackage Interface
 * @since 02-11-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceParticipantBrandManagementItem extends InterfaceItem
{

    /**
     * item[1133] = crso[id]
     */
    function getCRSOSelect()
    {
    	$this->options = array(array('- '.$this->langIf->getText('Select CRSO').' -'));

    	$q = $this->if_obj->model['cp']->getParticipantCRSOs($_SESSION['selected_participant_id'],'q',false,false,$_SESSION['selected_product_id']);
    	while($r = $q->fetch())
    	{
    		$this->options[] = array('text'=>((mb_strlen($r->CRSO_NAME)>35)?mb_substr($r->CRSO_NAME,0,35).'...':$r->CRSO_NAME),
    			'value'=>$r->CRSO_RELATION_ID,'selected'=>($this->if_obj->model['crso']&&($r->CRSO_RELATION_ID==$this->if_obj->model['crso']->relation->id)?'selected':false));
    	}
		$this->properties['onchange'] = "go('InterfaceBrandManagement.php?crso[id]='+this.options[this.selectedIndex].value);";
    }

    /**
     * item[1134] = brands
     */
    function getBrandFancySelect()
    {
    	if(!$this->if_obj->model['crso'])
    		return;
    	$this->fancyHeaders = array(0=>$this->langIf->getText('Available Brands'),1=>'',2=>$this->langIf->getText('Your Selected Brands'));

    	$props = array('class'=>'button');
		$this->fancybuttons = array('right'=>$props, 'left'=>$props, 'allRight'=>$props, 'allLeft'=>$props);//, 'up'=>$props, 'down'=>$props);

		$this->properties['size'] = 8;
		$this->properties['style'] = 'width: 50ex;';

		$used = $names = $this->options = $this->selectedoptions = array();


		$pb = new ParticipantBrand($this->db_app);
		list($brands, $used) = $pb->getBrandsIncludingUsed($_SESSION['selected_participant_id'],$this->if_obj->model['crso']->relation->id,$_SESSION['selected_product_id']);
		foreach($brands as $id => $value) {
			$this->selectedoptions[] = array('style'=>(in_array($id, $used)?'background-color: #66F; color:#FFF':''),'value'=>$id,'text'=>$value);
		}
		// Available Brands
		$b = new Brand($this->db_app);
		$q = $b->getByCRSO($this->if_obj->model['crso']->relation->id,$_SESSION['selected_product_id']);
		while($r=$q->fetch())
		{
			if(!$r->ACTIVE)
				continue;
			if(in_array($r->BRAND_ID,$used))
				continue;
			$this->options[] = array('text'=>$r->NAME,'value'=>$r->BRAND_ID);
		}
    }

    /**
     * item[1136] =
     */
    function getNewBrand()
    {
		$this->text = '<div style="float:left;"><span style="background-color: #66F;">&nbsp;&nbsp;&nbsp;</span> '.$this->langIf->getText('Used Brands, cannot remove').
			'</div><div style="float:right;text-align: right; padding-right: 55px;">
				<input type="text" style="width: 50ex;" id="newbrandinput" /><br /><br />
				<input type="button" class="button" id="addBrandButton" onclick="addBrand(document.getElementById(\'newbrandinput\'));" value="'.$this->langIf->getText('Add New Brand').'" />
			</div><div style="clear:both;">';
    }

    /**
     * item[1135] =
     */
    function getButtons()
    {
    	$this->_BarButtons = BUTTON_SAVE;
    }

}

/**
 * CALLBACK[getCRSOSelect]
 * item[1133] = {
 *     [handle] = Item: CRSO Selection
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getBrandFancySelect]
 * item[1134] = {
 *     [handle] = Item: BrandManagement
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getButtons]
 * item[1135] = {
 *     [handle] = Item: ButtonBar
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 */
?>