<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
require_once(ELC_CLASSES.'Participant.php');
require_once(ELC_CLASSES.'Relation.php');
require_once(ELC_CLASSES.'RelationUser.php');
require_once(ELC_CLASSES.'User.php');
require_once(ELC_CLASSES.'CRSOParticipantProduct.php');
require_once(IWARE.'InfoPerson.php');
require_once(IWARE.'address.php');
require_once(IWARE.'group.php');
require_once(IWARE.'GroupUser.php');
/**
 *
 * @package ELC
 * @subpackage Interface
 * @author Marten Koedam <marten@basesoft.com>
 * @since 09-03-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceParticipantUserRegistration extends InterfaceFactory
{
    /**
     * interface[id] = 85
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceParticipantUserRegistration(&$db, &$db_app, &$langIf)
    {
		if ($_SESSION['session_group_group_id'] == GROUP_PARTICIPANT) {
		$ru = new RelationUser($db_app);
			if(!isset($_REQUEST['participant']['id']))
			{
				alert('['.$_SESSION['session_user_id'].'] no participant selected');
				throw new InterfacePermissionException('['.$_SESSION['session_user_id'].'] no participant selected');
			}
			elseif(!$ru->validateAdmin($_SESSION['session_user_id'],$_REQUEST['participant']['id'],false))
			{
				alert('['.$_SESSION['session_user_id'].'] tried to access participant ['.$_REQUEST['participant']['id'].']');
				throw new InterfacePermissionException('['.$_SESSION['session_user_id'].'] tried to access participant ['.$_REQUEST['participant']['id'].']');
			}
		}
		if(isset($_POST['process']))
			$this->_setValues = true;
        parent::InterfaceFactory($db, $db_app, $langIf);
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';

		$relation = new Relation($this->db_app,$_REQUEST['participant']['id']);
		$relation->set();
		$this->model['relation'] =& $relation;

		if(isset($_REQUEST['user']['id']))
		{
			$user = new ELCUser($this->db_app,$_REQUEST['user']['id']);
			$ru = new RelationUser($this->db_app,array('user'=>$user,'relation'=>$relation));
			if(!$ru->set())
				exit('You Dont Have Permission To View This Page');
			$this->model['user'] =& $user;
			$this->model['relation_user'] =& $ru;
			$this->model['user']->set();
			$this->model['relation_user']->set();
			$this->model['user']->info_person->set();
		}

		setPageTitlePostfix('('.(isset($user) && $user->name ? $user->name.' / ' : '').$relation->name.')');
    }
	/**
	 *
	 */
	function init($if_id)
	{
		if(isset($_POST['process'])&& $_POST['process'] == 'check')
			$this->_hideInputs = true;
		$rv = parent::init($if_id);

		$cp = new CRSOParticipantProduct($this->db_app);
		if (!$cp->hasCrsoParticipantLogin($this->model['relation']->id, $_SESSION['selected_product_id'])) {
			unset($this->blocks[216]->items[1686]);
		}
		// for crsos its always disabled (the participant should control it)
		if ($_SESSION['session_group_group_id'] == GROUP_CRSO) {
			unset($this->blocks[216]->items[1686]);
		}

		return $rv;
	}
    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {
	$this->process = 'check'; // Defaults to check.
        if(isset($_POST['process']))
		{
			if(!$this->fb->validate()) // If not validated, let the user know
			{
				$_POST['process'] = '';
				return $thrownException .= $this->langIf->getText('Please correct the form errors');
			}
			if($_POST['process'] == 'check')
				$this->process = 'save';
			elseif($_POST['process'] == 'save')
			{
				$mode = isset($_POST['user']['id'])?'update':'insert';

				$ru = new RelationUser($this->db_app);
				$ru->relation =& $this->model['relation'];
				$ru->user = new ELCUser($this->db_app);
				if($mode == 'update')
				{
					$ru->user->id = $_POST['user']['id'];
					$ru->user->set(); // For name check

					$info_person_id = $ru->user->info_person->id;
					$info_person_email = $ru->user->info_person->email;
					$ru->user->info_person = new InfoPerson($this->db_app,$_POST['person']);
					$ru->user->info_person->id = $info_person_id;

					if($_SESSION['session_group_group_id'] == GROUP_CRSO){
						$ru->user->active = $_REQUEST['user']['active'];
						$ru->user->default_page = $_REQUEST['user']['default_page'];
						$ru->is_admin = $_REQUEST['relation_user']['is_admin'];
						// prevent crso from changing user email
						$ru->user->info_person->email = $info_person_email;
					}

				}
				else
					$ru->user->info_person = new InfoPerson($this->db_app,$_POST['person']);

				$ru->user->info_person->address = new Address($this->db_app,$_POST['address']);

				$gu = new GroupUser($this->db_app,array('group_id'=>GROUP_PARTICIPANT,'user'=>$ru->user));
				$ru->user->info_person->company_id = $_SESSION['session_user_company_id'];

				$ru->user->allow_crso_login = (bool) $_POST['crsoLogin'] ? 1 : 0;

				$this->db_app->begin();


				$status = true;
				$status && ($status = $ru->user->info_person->address->$mode());
				$status && $status = $ru->user->info_person->$mode();
				$status && $status = $ru->user->$mode();
				$status && $status = $ru->$mode();


				if ($mode == 'insert') {
					$gu->user =& $ru->user;
					$status && $status = $gu->insert();
				}

				if($status)
				{
					$this->db_app->commit();

                                        log_elc_event(sprintf('Participant user [%s] %s',
                                                isset($ru->user->name) ? $ru->user->name : '',
                                                $mode == 'update' ? 'updated' : 'created'),
                                            $_SESSION['session_user_id'], null,
                                            null, $this->model['relation']->id
                                        );

					if($_SESSION['session_group_group_id']==GROUP_PARTICIPANT)
			header('Location: InterfaceParticipantUserOverview.php');
                    if($_SESSION['session_group_group_id']==GROUP_CRSO)
			header('Location: InterfaceRegistrantUserOverview.php?participant[id]='.$_REQUEST['participant']['id']);

					exit();
				}
				$this->db_app->rollback();
				return $thrownException .= $this->langIf->getText('An unkown error occured during {MODE}', null, array('MODE'=>$mode));
			}
		}
    }
}
/**
 * @package ELC
 * @subpackage Interface
 * @since 09-03-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceParticipantUserRegistrationItem extends InterfaceItem
{

    /**
     * item[744] = person[first_name]
     * item[745] = person[department]
     * item[746] = person[middle_name]
     * item[748] = person[last_name]
     * item[750] = person[title]
     * item[751] = person[email]
     * item[752] = person[position]
     */
    function getItemValue()
    {
		if($this->name == 'user[name]')
			$this->_hideInput = true;
	if($_SESSION['session_group_group_id']==GROUP_CRSO && $this->name == 'person[email]')
			$this->_hideInput = true;
	$this->hiddenFields = array(
			array('name'=>'participant[id]','value'=>$_REQUEST['participant']['id']));
		if(isset($this->if_obj->model['user']))
		{
			$this->hiddenFields[] = array('name'=>'user[id]','value'=>$_REQUEST['user']['id']);
			$user = (array) $this->if_obj->model['user'];
			$relation_user = (array) $this->if_obj->model['relation_user'];
			$person = (array) $this->if_obj->model['user']->info_person;
			$name = str_replace('[','[\'',str_replace(']','\']',$this->name));
			eval('$this->properties[\'value\'] = isset($'.$name.')?$'.$name.':\'\';');
			if($this->type_id==IF_ITEM_CHECKBOX&& $this->properties['value'])
				$this->properties['checked'] = 'checked';
		}
    }

    /**
     * item[747] = person[telhouse]
     * item[749] = person[fax]
     */
    function getPhoneFaxValue()
    {
		$this->properties['value'] = '+';
		$this->getItemValue();
    }

    /**
     * item[753] = address[country_id]
     */
    function getCountrySelect()
    {
		require_once(ELC_CLASSES.'Country.php');
		$country = new Country($this->db_app);
		$q = $country->select();
		$this->options = array(array('text'=>'- '.$this->langIf->getText('Make Country Selection').' -','value'=>''));
		$i = 1;
		while($r = $q->fetch())
		{
			$this->options[$i] = array('text'=>$r->NAME,'value'=>$r->COUNTRY_ID);
			if(!isset($this->if_obj->model['info_person']))
			{
				if($r->COUNTRY_ID == $this->if_obj->model['relation']->getCountry())
					$this->options[$i]['selected'] = 'selected';
			}
			elseif(isset($this->if_obj->model['info_person']->address['country_id']) && ($this->if_obj->model['info_person']->address['country_id']==$r->COUNTRY_ID))
				$this->options[$i]['selected'] = 'selected';
			$i++;
		}
    }

    /**
     * item[754] =
     * item[757] =
     * item[759] =
     */
    function get2colTxt()
    {
		$this->twoCols = true;
    }

    /**
     * item[755] = person[language_id]
     */
    function getLanguageSelect()
    {
		require_once(IWARE.'nLanguage.php');
		$lang = new nLanguage($this->db_app);
		$q = $lang->get();
		$this->options = array(array('value'=>'','text'=>'- '.$this->langIf->getText('Select language').' -'));
		$i = 1;
		while($r = $q->fetch())
		{
			$this->options[$i] = array('text'=>$r->LANGUAGE,'value'=>$r->LANGUAGE_ID);
			if(!isset($this->if_obj->model['info_person']))
			{
				if($r->LANGUAGE_ID == $_SESSION['session_user_language_id'])
					$this->options[$i]['selected'] = 'selected';
			}
			elseif(isset($this->if_obj->model['info_person']['language_id'])&& $this->if_obj->model['language_id']==$r->LANGUAGE_ID)
				$this->options[$i]['selected'] = 'selected';
			$i++;
		}
    }

	function getCrsoLoginCheckbox()
	{
		$this->properties['value'] = false;
		if (isset($this->if_obj->model['user']))
			$this->properties['value'] = $this->properties['checked'] = $this->if_obj->model['user']->allow_crso_login;
	}


    /**
     * item[760] =
     */
    function getButtons()
    {
		$this->text = '';
		if(isset($_POST['process'])&& $_POST['process'] == 'check')
		{
			$this->_BarButtons = 0;
			$this->text = $this->langIf->getText('Are above settings correct?').'<br />';
			$this->_addCustomButton($this->langIf->getText('No, I would like to make changes'),'button', array('onclick'=>'document.getElementsByName(\'process\')[0].value=\'\'; document.getElementById(\'interface_form\').submit();','name'=>'signup'));
			$this->_addCustomButton($this->langIf->getText('Yes, I am ready to continue'),'submit', array('onsubmit'=>'','name'=>'signup'));
		}
		else
		{
			$this->_BarButtons = BUTTON_SAVE;


			$this->_ButtonOptions[BUTTON_CANCEL] = array('onclick'=>"document.location.href='InterfaceParticipantUserOverview.php';");
		}
    }
}

/**
 * CALLBACK[getItemValue]
 * item[744] = {
 *     [handle] = Item: PersonFirstName
 *     [behaviour] = required
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * item[745] = {
 *     [handle] = Item: Department
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * item[746] = {
 *     [handle] = Item: PersonMiddleName
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * item[748] = {
 *     [handle] = Item: PersonLastName
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * item[750] = {
 *     [handle] = Item: Title
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * item[751] = {
 *     [handle] = Item: PersonEmail
 *     [behaviour] = required;email
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * item[752] = {
 *     [handle] = Item: PersonPosition
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * CALLBACK[getPhoneFaxValue]
 * item[747] = {
 *     [handle] = Item: PhoneNumber
 *     [behaviour] = required;phone
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * item[749] = {
 *     [handle] = Item: FaxNumber
 *     [behaviour] = phone
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getCountrySelect]
 * item[753] = {
 *     [handle] = Item: Country selection
 *     [behaviour] = required
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[get2colTxt]
 * item[754] = {
 *     [handle] = Item: Spacer
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * item[757] = {
 *     [handle] = Item: Spacer
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * item[759] = {
 *     [handle] = Item: Spacer
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getLanguageSelect]
 * item[755] = {
 *     [handle] = Item: UserLanguage
 *     [behaviour] = required
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 *
 * CALLBACK[getButtons]
 * item[760] = {
 *     [handle] = Item: ButtonBar
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 */
?>
