<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
require_once(ELC_CLASSES.'Participant.php');
require_once(ELC_CLASSES.'RelationUser.php');
require_once(ELC_CLASSES.'User.php');
/**
 *
 * @package ELC
 * @subpackage Interface
 * @author Nick Loeve <nick@basesoft.com>
 * @since 19-07-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceParticipantUserSettings extends InterfaceFactory
{
    /**
     * interface[id] = 141
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceParticipantUserSettings(&$db, &$db_app, &$langIf)
    {

		$user_id = null;
		$participant_id = null;

		if (isset($_POST['user']['id']))
		{
			$user_id = (int)$_POST['user']['id'];
		}
		elseif(isset($_GET['user']['id']))
		{
			$user_id = (int)$_GET['user']['id'];
		}

		if (isset($_POST['participant']['id']))
		{
			$participant_id = (int)$_POST['participant']['id'];
		}
		elseif(isset($_GET['participant']['id']))
		{
			$participant_id = (int)$_GET['participant']['id'];
		}

	$ru = new RelationUser($db_app);
		if(!isset($participant_id))
		{
			alert('['.$_SESSION['session_user_id'].'] no participant selected');
			throw new InterfacePermissionException('['.$_SESSION['session_user_id'].'] no participant selected');
		}
		elseif(!$ru->validateAdmin($_SESSION['session_user_id'],$participant_id,false))
		{
			alert('['.$_SESSION['session_user_id'].'] tried to access participant ['.$participant_id.']');
			throw new InterfacePermissionException('['.$_SESSION['session_user_id'].'] tried to access participant ['.$participant_id.']');
		}
		if(isset($_POST['process']))
			$this->_setValues = true;

        parent::InterfaceFactory($db, $db_app, $langIf);
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';

        $relation = new Relation($this->db_app,$participant_id);
		$relation->set();
		$this->model['relation'] =& $relation;

		if(isset($user_id))
		{
			$user = new ELCUser($this->db_app,$user_id);
			$ru = new RelationUser($this->db_app,array('user'=>$user,'relation'=>$relation));
			if(!$ru->set())
				throw new InterfacePermissionException('Unauthorized Access to Interface');
			$this->model['user'] =& $user;
			$this->model['relation_user'] =& $ru;
			$this->model['user']->set();
			$this->model['relation_user']->set();
			$this->model['user']->info_person->set();
		}

		setPageTitlePostfix('('.(isset($user) && $user->name ? $user->name.' / ' : '').$relation->name.')');
    }

    function init($if_id)
	{
		if(isset($_POST['process'])&& $_POST['process'] == 'check')
			$this->_hideInputs = true;
		parent::init($if_id);
	}

	function _filter($q)
	{
		$rv = parent::_filter($q);
		// In case the requested user is the admin user, we hide the block with clearance levels and active setting
		// See Trac ticket #1787

		// leave the message, hide the buttons
		if(isset($this->model['relation_user']) && $this->model['relation_user']->isAdmin('', $this->model['relation_user']->relation->id))
			unset($rv[$this->id][217]);
        return $rv;
	}

    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {
        $this->process = 'check'; // Defaults to check.
        if(isset($_POST['process']))
		{
			if($_POST['process'] == 'makeAdmin')
			{
				$ru = new RelationUser($this->db_app);
				if($ru->setAdmin($this->model['relation']->id, $this->model['user']->id))
				{
					log_elc_event(sprintf('Participant user [%s] made admin user',
                                                $this->model['user']->name),
                                            $_SESSION['session_user_id'], null,
                                            null, $this->model['relation']->id
                                        );

                                        header('Location: index.php');
					exit();
				}
			}

			if(!$this->fb->validate()) // If not validated, let the user know
			{
				$_POST['process'] = '';
				return $thrownException .= $this->langIf->getText('Please correct the form errors');
			}
			if($_POST['process'] == 'check')
			{
				$this->process = 'save';
			}
			elseif($_POST['process'] == 'save')
			{
				$mail = false;
				$ru = new RelationUser($this->db_app);
				$ru->relation =& $this->model['relation'];
				$ru->user = new ELCUser($this->db_app);
				$ru->user->id = $_POST['user']['id'];
				$ru->user->set(); // For name check
				$ru->user->info_person->set();
				$ru->clearance_level = isset($_POST['clearance'])?array_sum(array_values($_POST['clearance'])):0;

				// Create a username and password. // MAIL IT
				if(isset($_POST['relation_user']['status']) && $_POST['relation_user']['status'])
				{
					if(!$ru->user->name)
					{
						$i = 1;
						do {
							$name = str_replace(' ', '', $ru->user->info_person->last_name);
							$name = substr($name, 0, 6);
							$name = $name . str_pad($i, 4, '0', STR_PAD_LEFT);
							$i++;
						} while(!$ru->user->isUniqueUserName($name));

						$ru->user->name = $name;
						$ru->user->setPassword(ELCUser::generatePasswd());

						$mail = true;
					}
					$ru->user->active = 1; //turn on user incase not active for other participants
					$ru->status = 1; //turn on relation user
				}
				else
				{
					//leave user status alone
					$ru->status = 0; //turn off relation user
				}

				$this->db_app->begin();

				// Remove the APC cached menu for this user::
				if(function_exists('apc_store'))
				{
					$lookup = 'SFMenu'.$ru->user->id.'_'.$ru->relation->id.'_'.
						(isset($_SESSION['selected_product_id'])?$_SESSION['selected_product_id']:0).APC_SUFFIX;
					apc_delete($lookup);
				}

				$status = true;
				$status && $status = $ru->user->update();
				$status && $status = $ru->update();

				if($status)
				{
					$this->db_app->commit();
					if($mail)
					{
						require_once(ELC_CLASSES.'ELCMessageHandler.php');
						$ru->user->setPasswordInfoAndToken();
						MessageEvent::send(NEW_USER, array('user'=>$ru->user, 'relationuser'=>$ru, 'participant'=>new Participant($this->db_app,array('relation'=>$ru->relation))), 'ELCMessageHandler');
						$ru->user->login_token = ''; // we don't want to keep the login token after it was sent

                                                log_elc_event(sprintf('Participant user [%s] activated',
                                                        $ru->user->name),
                                                    $_SESSION['session_user_id'], null,
                                                    null, $ru->relation->id
                                                );
					}

                                        log_elc_event(sprintf('Participant user [%s] updated',
                                                $ru->user->name),
                                            $_SESSION['session_user_id'], null,
                                            null, $ru->relation->id
                                        );

					header('Location: InterfaceParticipantUserOverview.php');
					exit();
				}
				$this->db_app->rollback();
				return $thrownException .= $this->langIf->getText('An unkown error occured during {MODE}', null, array('MODE'=>'update'));
			}
		}
    }
}
/**
 * @package ELC
 * @subpackage Interface
 * @author Nick Loeve <nick@basesoft.com>
 * @since 19-07-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceParticipantUserSettingsItem extends InterfaceItem
{

    /**
     * item[756] = clearance[ClearanceFeeRegistration]
     * item[758] = clearance[ClearanceReporting]
     * item[850] = clearance[ClearanceDeclarationSettings]
     * item[936] = clearance[ClearanceProofOfPayment]
     * item[937] = clearance[ClearanceProofOfExport]
     */
    function getClearanceValue()
    {
		foreach (Participant::getClearanceLevels() as $level)
		{
			if ($this->name == 'clearance['.$level.']')
			{
				$this->properties['value'] = constant($level);
				if (isset($this->if_obj->model['relation_user']))
					$this->properties['checked'] = $this->if_obj->model['relation_user']->clearance_level & constant($level);
			}
		}
    }

    /**
     * item[757] =
     * item[759] =
     * item[762] =
     * item[851] =
     * item[938] =
     * item[939] =
     */
    function get2colTxt()
    {
		$this->twoCols = true;
    }

    /**
     * item[761] = relation_user[status]
     */
    function getItemValue()
    {
    	$this->hiddenFields = array(
			array('name'=>'participant[id]','value'=>$this->if_obj->model['relation']->id));
		if(isset($this->if_obj->model['user']))
		{
			$this->hiddenFields[] = array('name'=>'user[id]','value'=>$this->if_obj->model['user']->id);
			$user = (array) $this->if_obj->model['user'];
			$relation_user = (array) $this->if_obj->model['relation_user'];
			$name = str_replace('[','[\'',str_replace(']','\']',$this->name));
			eval('$this->properties[\'value\'] = isset($'.$name.')?$'.$name.':\'\';');
			if($this->type_id==IF_ITEM_CHECKBOX&& $this->properties['value'])
				$this->properties['checked'] = 'checked';
		}
    }

    /**
     * item[894] =
     */
    function getGeneralManagerButtons()
	{
		$this->_BarButtons = 0;
		if (isset($this->if_obj->model['user']->id) && isset($this->if_obj->model['relation']->id))
		{
			require_once(ELC_CLASSES.'CRSOParticipantProduct.php');
			$cp = new CRSOParticipantProduct($this->db_app);
			$q = $cp->getParticipantCRSOs($this->if_obj->model['relation']->id, 'q', PARTICIPANT_EXPORTER,false,$_SESSION['selected_product_id']);
			$rs = $q->fetchAll();
			if(!count($rs))
				return $this->text = $this->langIf->getText('Not available, You are not a refund requester');

			$ds = array();
			foreach($rs as $r)
			{
				$cp->set($r->CRSO_RELATION_ID,$this->if_obj->model['relation']->id,$_SESSION['selected_product_id']);
				$disabled = ((!$cp->active)||($cp->status<PARTICIPANT_STATUS_CONFIRMED));

				$ds[] = array(
					'CRSO_RELATION_ID'=>$r->CRSO_RELATION_ID,
					'CRSO_NAME'=>$r->CRSO_NAME,
					'GENERAL_MANAGER_AUTHORIZED'=>$r->GENERAL_MANAGER_AUTHORIZED,
					'REQUEST_GENERAL_MANAGER'=>$disabled);
			}


			$tf = new TableFactory($ds, $this->langIf);
			$tf->hideColumns(array('CRSO_RELATION_ID'));
			$tf->setValueProcessor(array('GENERAL_MANAGER_AUTHORIZED', 'REQUEST_GENERAL_MANAGER'), array($this, 'tfValueProcessor'));

			$this->script = sprintf("
				function RequestGeneralManager(crso_id)
				{
					var params = new Array();
					params['participant_id'] = %s;
					params['crso_id'] = crso_id;
					params['user_id'] = %s;

					// see includes/elc/rpc/RequestGeneralManager.php
					jsbroker.call('requestGeneralManager', params, function(p)
					{
						MessageBox.prototype.Information('', '%s');
						$$('request_gm_'+params['crso_id']).disabled = true;
					});

				}
				",
					(int) $this->if_obj->model['relation_user']->relation->id,
					(int) $this->if_obj->model['user']->id,
					jsescape($this->langIf->getText('General Manager request sent'), "'")
			);


			return $this->text = $tf->getXHTMLTable();
		}
		else
		{
			// todo: hide block
		}
	}

	function tfValueProcessor($args)
	{
		switch ($args['head'])
		{
			case 'GENERAL_MANAGER_AUTHORIZED':
				if (!$args['value'])
					return $this->langIf->getText('No General Manager Requested');

				list ($status, $class) = CRSOParticipantProduct::translateGmStatus($this->langIf, $args['value']);
				return sprintf('<span class="%s">%s</span>', $class, $status);
			break;

			case 'REQUEST_GENERAL_MANAGER':
				if($args['value'])
					return $this->langIf->getText('This Participant Is Inactive or Unconfirmed');

				$btn = new Form_Button('request_gm_'.$args['row']['CRSO_RELATION_ID'], $this->langIf->getText('Request General Manager'), 'button');
				$btn->onclick(jsMessageBox(MSG_BOX_QUEST,
					$this->langIf->getText('General Manager'),
					$this->langIf->getText('Request general manager for this user?'),
					sprintf('function() { RequestGeneralManager(%s) }', $args['row']['CRSO_RELATION_ID'] )));
				return $btn->getHtml();
			break;
		}
	}

    /**
     * item[1000] =
     */
    function getAdminEdit()
    {
    	$this->_BarButtons = 0;
	if (isset($this->if_obj->model['user']->id) && isset($this->if_obj->model['relation']->id) &&
		!$this->if_obj->model['relation_user']->isAdmin($this->if_obj->model['user']->id, $this->if_obj->model['relation']->id)
    		 && $this->if_obj->model['user']->active)
		{
			$this->if_obj->script .= "
						function askMakeAdmin()
						{
							MessageBox.prototype.Question('".$this->langIf->getText('User Registration: Make User an Admin, you will lose your rights')."', '".$this->langIf->getText('User Registration: Confirm Make User an Admin?')."', function(){document.getElementsByName('process')[0].value='makeAdmin'; document.getElementById('interface_form').submit();} );
						}
								";
			$this->_addCustomButton($this->langIf->getText('User Registration: Make User an Admin'), 'button', array('onclick' => 'askMakeAdmin();'));
		}
		elseif (isset($this->if_obj->model['relation_user']) && $this->if_obj->model['relation_user']->isAdmin('', $this->if_obj->model['relation_user']->relation->id))
		{
			$this->text = $this->langIf->getText('This user is the admin-user');
		}
		else
		{
			$this->parent->hide();
		}
    }

	function getButtons()
    {
		$this->text = '';
		if (isset($this->if_obj->model['relation_user']) && $this->if_obj->model['relation_user']->isAdmin('', $this->if_obj->model['relation_user']->relation->id))
		{
			$this->text = $this->langIf->getText('Clearance settings are not applicable for Admin users, they have all permissions by default.');
			$this->_BarButtons = 0;
		}
		elseif(isset($_POST['process'])&& $_POST['process'] == 'check')
		{
			$this->_BarButtons = 0;
			$this->text = $this->langIf->getText('Are above settings correct?').'<br />';
			$this->_addCustomButton($this->langIf->getText('No, I would like to make changes'),'button', array('onclick'=>'document.getElementsByName(\'process\')[0].value=\'\'; document.getElementById(\'interface_form\').submit();','name'=>'signup'));
			$this->_addCustomButton($this->langIf->getText('Yes, I am ready to continue'),'submit', array('onsubmit'=>'','name'=>'signup'));
		}
		else
		{
			$this->_BarButtons = BUTTON_SAVE+BUTTON_CANCEL;
			$this->_ButtonOptions[BUTTON_CANCEL] = array('onclick'=>"document.location.href='InterfaceParticipantUserOverview.php';");
		}
    }
}

/**
 * CALLBACK[getClearanceValue]
 * item[756] = {
 *     [handle] = Item: ClearanceFeeRegistration
 *     [behaviour] =
 *     [help] = 1
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * item[758] = {
 *     [handle] = Item: ClearanceReporting
 *     [behaviour] =
 *     [help] = 1
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * item[850] = {
 *     [handle] = Item: ClearanceDeclarationSettings
 *     [behaviour] =
 *     [help] = 1
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * item[936] = {
 *     [handle] = Item: ClearanceProofOfPayment
 *     [behaviour] =
 *     [help] = 1
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * item[937] = {
 *     [handle] = Item: ClearanceProofOfExport
 *     [behaviour] =
 *     [help] = 1
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * CALLBACK[get2colTxt]
 * item[757] = {
 *     [handle] = Item: Spacer 1
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * item[759] = {
 *     [handle] = Item: Spacer 2
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * item[762] = {
 *     [handle] = Item: Spacer 3
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * item[851] = {
 *     [handle] = Item: Spacer 4
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * item[938] = {
 *     [handle] = Item: Spacer 5
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * item[939] = {
 *     [handle] = Item: Spacer 6
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getItemValue]
 * item[761] = {
 *     [handle] = Item: RelationUserActive
 *     [behaviour] =
 *     [help] = 1
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * CALLBACK[getGeneralManagerButtons]
 * item[894] = {
 *     [handle] = Item: GeneralManagerButtons
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getAdminEdit]
 * item[1000] = {
 *     [handle] = Item: EditParticipantAdminUser
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 */
?>
