<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
require_once(ELC_CLASSES.'ProofOfPayment.php');
require_once(ELC_CLASSES.'ProofOfPaymentConfirmation.php');
require_once(ELC_CLASSES.'RelationUser.php');
require_once(ELC_CLASSES.'CRSOParticipantProduct.php');

define('BLOCK_BUTTON_DOCUMENT_BAR',410);
/**
 * @package
 * @subpackage
 * @since 9-jan-2007
 * @author Marten Koedam <marten@dalines.net>
 * @version $Id$
 * @copyright 2007 BaseSoft B.V.
 */
class InterfacePaymentConfirmation extends InterfaceFactory
{
	public $authorizeType = false;
	var $_process;
	var $editable = true;

    /**
     * interface[id] = 163
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfacePaymentConfirmation(&$db, &$db_app, &$langIf)
    {
        parent::InterfaceFactory($db, $db_app, $langIf);
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';

        $this->authorizeType = array();
        $this->model['cpp'] = $this->model['crso'] = false;
        $this->editable = true;
        $this->pop_editable = true;

        $cpp = new CRSOParticipantProduct($this->db_app);
        $this->model['crsos'] = $crsos = $cpp->getParticipantCRSOs($_SESSION['selected_participant_id'],'q',PARTICIPANT_EXPORTER,false,$_SESSION['selected_product_id']);
        if(($r = $crsos->fetch()) && !($r2 = $crsos->fetch()))
        {
        	$cpp->set($r->CRSO_RELATION_ID,$_SESSION['selected_participant_id'],$_SESSION['selected_product_id']);
        }
		elseif(isset($_REQUEST['crso']['id']))
        	$cpp->set($_REQUEST['crso']['id'],$_SESSION['selected_participant_id'],$_SESSION['selected_product_id']);
        if($cpp->isComplete())
        {
        	$this->model['cpp'] = $cpp;
        	$this->model['crso'] = $cpp->crso;

		    // Who has rights to this:
		    // Depends on the setting for authorize_pop in CRSO_PARTICIPANT_PRODUCT...
		    // We need a RUI!
		    $ru = new RelationUser($this->db_app);
		    $ru->set($_SESSION['session_user_id'],$_SESSION['selected_participant_id']);

		    //print_r($cpp);

		    //echo $cpp->authorize_proof_of_payment.' == '.REFUND_AUTHORIZE_STATUTORY_AUDITOR;

		    if(($cpp->authorize_proof_of_payment==REFUND_AUTHORIZE_STATUTORY_AUDITOR)&& $ru->is_admin) // Statutory Auditor || GM == USER
		    	$this->authorizeType[] = REFUND_AUTHORIZE_STATUTORY_AUDITOR;
		    if($cpp->authorize_proof_of_payment==REFUND_AUTHORIZE_GENERAL_MANAGER)
		    {
		    	if(($cpp->general_manager->id == $_SESSION['session_user_id'])&&
		    		($cpp->general_manager_authorized == GENERAL_MANAGER_AUTHORIZED))
		    		$this->authorizeType[] = REFUND_AUTHORIZE_GENERAL_MANAGER;
		    }
		    if(count($this->authorizeType))
		    {
				$popc = new ProofOfPaymentConfirmation($this->db_app);
		    	$popc->crso = $this->model['crso'];
		    	$popc->participant = new Participant($this->db_app,array('relation'=>new Relation($this->db_app,$_SESSION['selected_participant_id'])));
		    	$popc->product = new Product($this->db_app,$_SESSION['selected_product_id']);
		    	$this->model['popc'] = $popc;
		    	if(isset($_REQUEST['popc']['id']))
		    	{
		    		$this->editable = false;
		    		$this->pop_editable = false;
		    		$popc->set((int)$_REQUEST['popc']['id']);
		    		if($popc->review_status == POP_CONFIRMATION_REJECTED)
		    		{
		    			$this->editable = true;
		    		}
		    		$this->hiddenFields = array(array('value'=>$_REQUEST['popc']['id'],'name'=>'popc[id]'));
		    	}
		    }
		    $this->script = sprintf("

				function has_selected_checkboxes()
				{
					// check if we selected atleast one checkbox and give an error
					var checks = document.getElementsByName('pop[]');
					var err = true;
					for (var i=0; i<checks.length; i++)
					{
						if (checks[i].checked||checks[i].type=='hidden') {
							err = false;
							break;
						}
					}

					if (err) {
						".jsMessageBox(MSG_BOX_CRIT, '', $this->langIf->getText('Select atleast one PoP'))."
						return false;
					}

					return true;
				}

				function print_preview()
				{
					if (!has_selected_checkboxes())
						return;

					var nwin = new NewWindow(800, 600);
					nwin.setSource('%s');
					nwin.setName('winPrint');
					nwin.setScrollbars(true);
					var win = nwin.open(); // returns a window object

					var frm = $('interface_form');
					frm.target='winPrint';
					frm.process.value='print';
					frm.submit();

					\$('ifI_1188_CB_2').disabled = false;

					// restore
					frm.target='_self';
					frm.process.value='save';
				}

				function rejectPoP()
				{
					".jsMessageBox(MSG_BOX_QUEST,
						$this->langIf->getText('MessageBoxTitle: Reject PoP'),
						$this->langIf->getText('MessageBoxBody: Reject PoP'), "function(){var frm = $('interface_form');
					frm.process.value='reject';
					frm.submit();}")."

				}
			", sprintf("%s?crso[id]=%s&print=true",
				$_SERVER['PHP_SELF'], $this->model['crso']->relation->id) );
        }
		if (isset($_REQUEST['process']))
			$this->_process = $_REQUEST['process'];
    }

	function _filter($q)
	{
		$rv = InterfaceFactory::_filter($q);

		if(!$this->editable)
		{
			unset($rv[$this->id][BLOCK_BUTTON_DOCUMENT_BAR][1187]);
		}

		if ($this->_process == 'print')
		{
			unset($rv[$this->id][408]);
			unset($rv[$this->id][BLOCK_BUTTON_DOCUMENT_BAR]);
		}


		return $rv;
    }

    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {
        if(!isset($_POST['process']))
        	return;

        if($_POST['process'] == 'print')
        	return;

        if($_POST['process'] == 'save')
        {
        	$this->db_app->begin();

        	$popc = $this->model['popc'];
        	if(!$this->editable)
        		$popc->id = $_REQUEST['popc']['id'];
			elseif($id = $popc->getUnprocessedConfirmation($this->authorizeType))
			{
				$popc->id = $id;
				$popc->nullifyPoPConfirmationId();
			}
    		$item = new InterfaceItem($this->db,$this->db_app,$this->langIf);
    		if ($document = $item->getDocument('document[id]')) {
        		$popc->document =& $document;
        		$popc->document->makePermanent();
    		}
    		$popc->review_status = POP_CONFIRMATION_UNREVIEWED;
        	// Add a ProofOfPaymentConfirmation :: or Update it
			if($popc->id)
				$popc->update();
			else
			{
				$popc->auth_by_type = $this->authorizeType[0];
				$popc->insert();
			}
        	// Loop all the POP's
        	foreach($_POST['pop'] as $popid)
        	{
        		$pop = new ProofOfPayment($this->db_app,$popid);
        		$pop->proof_of_payment_confirmation = $popc;
        		$pop->authorized_by = new ELCUser($this->db_app,$_SESSION['session_user_id']);
        		$pop->status = PROOF_OF_PAYMENT_APPROVED;
        		$pop->update();
        	}

        	$this->db_app->commit();
        }

        if($_POST['process'] == 'reject')
        {
        	foreach($_POST['pop'] as $popid)
        	{
        		$pop = new ProofOfPayment($this->db_app,$popid);
        		$pop->proof_of_payment_confirmation = DB_NULL;
        		$pop->authorized_by = DB_NULL;
        		$pop->status = PROOF_OF_PAYMENT_REJECTED;
        		$pop->update();
        	}
        }
        // Header back
        header('Location: InterfacePaymentConfirmation.php?crso[id]='.$this->model['crso']->relation->id);
        exit();
    }


    function getInterfaceHeader()
	{
		$rv = parent::getInterfaceHeader();

		if ($this->_process != 'print')
			return $rv;

		$p =& $this->model['crso']->relation;
		$p->set();
		$p->address->set();

		$c =& $this->model['cpp']->participant->relation;
		$c->set();
		$c->address->set();

		require_once(ELC_CLASSES.'Country.php');
		$country = new Country($this->db_app);
		$country->set($p->address->country_id);
		$p_country = $country->name;
		$country->set($c->address->country_id);
		$c_country = $country->name;

		$d = &currentDate();
		$time = $d->getTime();

		$rv .= '
			<h1>'.$this->langIf->getText('PoP Confirmation Print').'</h1>
			<table class="Professional" width="100%">
				<tr>
					<td width="25%">'.$this->langIf->getText('PERIOD').'</td>
					<td width="25%">
						<strong style="font-size: 10pt !important">'.
							strftime('%B',strtotime('-1 month', $time)).' '.strftime('%Y', strtotime('-1 month', $time)).
						'</strong></td>
					<td width="50%">
						'.$this->langIf->getText('Document Checksum').':
						<strong style="font-size: 10pt !important">'.ProofOfPaymentConfirmation::generateConfirmProofOfPaymentChecksum($_REQUEST['pop']).'</strong>
					</td>
				</tr>
				<tr>
					<td>'.$this->langIf->getText('Print date').'</td>
					<td>
						'.$d->format('d-m-Y').'
					</td>
				</tr>
				<tr>
					<td colspan="3"><br /></td>
				</tr>
				<tr>
					<td colspan="2">'.$p->name.'</td>
					<td>'.$c->name.'</td>
				</tr>
				<tr>
					<td colspan="2">'.$p->address->address_street_name.'</td>
					<td>'.$c->address->address_street_name.'</td>
				</tr>
				<tr>
					<td colspan="2">'.$p->address->city_name.', '.$p_country.'</td>
					<td>'.$c->address->city_name.', '.$c_country.'</td>
				</tr>
				<tr>
					<td colspan="2"></td>
					<td>'.$c->address->address_zipcode .', '.$c->email.'</td>
				</tr>
				<tr>
					<td>'.$this->langIf->getText('VAT Number').'</td>
					<td>'.$p->vat_no.'</td>
					<td></td>
				</tr>
				<tr>
					<td>'.$this->langIf->getText('Bank Account Number').'</td>
					<td>'.$p->bank_account_number.'</td>
					<td></td>
				</tr>
			</table>
			<br /><br />
			';

		return $rv;
	}

	function getInterfaceFooter()
	{
		$rv = parent::getInterfaceFooter();

		if ($this->_process != 'print')
			return $rv;

		$user = new ELCUser($this->db_app, $_SESSION['session_user_id'], true);
		$user->info_person->set();

		$lines = array();
		$lines[] = $user->info_person->getFullName();
		$lines[] = $user->info_person->title;
		$lines[] = $user->info_person->position;
		$lines[] = $user->info_person->department;
		$lines[] = $user->info_person->telhouse;
		$lines[] = $user->info_person->fax;
		$lines[] = $user->info_person->email;

		$rv .= '<table class="Professional">';

		foreach ($lines as $line)
		{
			if (empty($line))
				continue;

			$rv .= '<tr>
						<td>'.$line.'</td>
					</tr>';
		}

		$rv .= '	<tr>
						<td>
							<div style="border: 1px solid black; margin: 10px; width: 200px; height: 50px;"></div>
						</td>
					</tr>
				</table>
		';

		return $rv;
	}
}
/**
 * @package
 * @subpackage Interface
 * @since 09-01-2007
 * @copyright 2007 BaseSoft B.V.
 * @version $Id$
 */
class InterfacePaymentConfirmationItem extends InterfaceItem
{

    /**
     * item[1184] = crso[id]
     */
    function getCRSOSelect()
    {
		$rv = null;
		// Check for any active Remote Viewer connections.
		if(IWRegistry::isRegistered('remote_viewer')) {
			$rv = IWRegistry::registry('remote_viewer');
		}
    	// Script stuff added here, cause we only need that if we have more then 1 crso
    	$this->script = "
			function switchCRSO(sel)
			{
				if(!sel.value)
					return;
				go('InterfacePaymentConfirmation.php?crso[id]='+sel.value);
			}
			";

    	// execute query again so we can fetch
    	$this->if_obj->model['crsos']->execute();

    	$this->options = array(array('value'=>'','text'=>'- '.$this->langIf->getText('Select CRSO').' -'));
    	while($r = $this->if_obj->model['crsos']->fetch())
		{
			if($rv && $rv->crso->relation->id!=$r->CRSO_RELATION_ID)
				continue;
			$selected = $this->if_obj->model['crso']?$this->if_obj->model['crso']->relation->id:false;
			$this->options[] = array('value'=>$r->CRSO_RELATION_ID,'text'=>$r->CRSO_NAME,
				'selected'=>(($r->CRSO_RELATION_ID==$selected)?'selected':false));
		}
    	$this->properties['onchange'] = 'switchCRSO(this);';
    }

	function getCutOffDate()    {
		if(!$this->if_obj->model['crso'])
			$this->text = '';
		else {
			require_once(ELC_CLASSES.'CRSOProduct.php');
			$cp = new CRSOProduct($this->db_app);
			$cp->set($this->if_obj->model['crso']->relation->id, $_SESSION['selected_product_id']);
			$this->text = "<span class='cut-off-date'>".$this->langIf->getText('Upcoming export date').": ".$cp->getNextCutOffDateRefund()."</span>";
		}
	}

    /**
     * item[1186] =
     */
    function getConfirmationOverview()
    {
    	$selectCRSO = $this->langIf->getText('Select CRSO First');
    	$notAuthorized = $this->langIf->getText('Not Authorized to Authorize');
    	// Select the confirmation overview
    	if(!$this->if_obj->model['crso'])
    		return $this->text = $selectCRSO;
    	if(!$this->if_obj->authorizeType)
    		return $this->text = $notAuthorized;

		$cpp = $this->if_obj->model['cpp'];
    	$popc = new ProofOfPaymentConfirmation($this->db_app);
    	$ds = $popc->getLatestOverview($this->if_obj->authorizeType,$cpp->crso->relation->id,$cpp->participant->relation->id,$cpp->product->id, isset($_REQUEST['popc']['id']) ? (int)$_REQUEST['popc']['id'] : null);

    	$tf = new TableFactory($ds,$this->langIf);
    	$tf->setValueProcessor(TF_ALL,array($this,'tfValueProcessor'));

    	$hiddenCols = array('STATUS');

		// hide some extra columns in multiline - ticket #2035
	   	$relation = new Relation($this->db_app,$this->if_obj->model['crso']->relation->id,true);
	   	$country = new Country($this->db_app,$relation->getCountry(),true);
	   	$country->initSettingsItemIdMap();
	   	if ($country->has(HasProofOfPaymentMultiline, $_SESSION['selected_product_id']))
	   		$hiddenCols = array_merge($hiddenCols, array('INVOICE_ID', 'DOCUMENT', 'FEE', 'PAYMENT_DATE'));

	   	// align
	   	$tf->setTHProcessor(array('FEE','QUANTITY','AMOUNT'),'return \' class="th-right"\';');

	   	$tf->hideColumns($hiddenCols);

	   	$tf->setValueProcessor(array('AMOUNT'),'return is_numeric($value)?locale_nf($value,2):\'\';');

    	$tf->setRowProcessor(array($this, 'tfRowProcessor'));
    	$tf->setEmptyText($this->langIf->getText('No Proof of Payments Found for selection'));
    	$tf->columnModifier(array('QUANTITY'=>'style="text-align:right;"','FEE'=>'style="text-align:right;"', 'AMOUNT'=>'style="text-align:right;"'));
		$this->text = $tf->getXHTMLTable('Professional',2);

		if($this->if_obj->_process=='print')
			return;

		$this->text .= sprintf('<input id="selectAllCheckboxes" type="button" value="%s" onclick="pop_selectAll();" />
				<input id="deselectAllCheckboxes" type="button" value="%s" onclick="pop_deselectAll();" />',
				$this->langIf->getText('Select All'),
				$this->langIf->getText('Deselect All'));

		$this->script = "
			function pop_selectAll()
			{
				els = \$\$s('pop[]');
				for(var i = 0;i<els.length;i++)
				{
					els[i].checked = 'checked';
				}
			}
			function pop_deselectAll()
			{
				els = \$\$s('pop[]');
				for(var i = 0;i<els.length;i++)
				{
					els[i].checked = false;
				}
			}
			";


		if($id = $this->if_obj->model['popc']->getUnprocessedConfirmation($this->if_obj->authorizeType))
		{
			$popc = $this->if_obj->model['popc'];
			$popc->set($id);
			$popc->document->set();

			list($trans,$class ) = $popc->translateStatus($this->langIf,$popc->review_status);

			$this->text .= sprintf('<br /><br />%s<br /><a href="/%sscripts/i-w/document/download.php?Document[id]=%d">%s</a> - <span class="%s">%s</span><br />',
				$this->langIf->getText('Your Document has been filed as '),
				SITE_PATH,
				$popc->document->id,
				$popc->document->name,
				$class,$trans);
		}
    }

	function tfRowProcessor($args)
	{
		$row = &$args['row'];
		if($this->if_obj->_process=='print')
			if(!in_array($row['CHECKBOX'],$_POST['pop']))
				return false;
	}

	function tfValueProcessor($args)
	{
		switch($args['head'])
		{
			case 'CHECKBOX':
				if($this->if_obj->_process=='print')
				{
					$img = in_array($args['value'],$_POST['pop'])?'true':'false';
					return sprintf('<img src="/%simages/i-w/%s.gif" />',SITE_PATH,$img);
				}
				$checked = ($args['row']['STATUS'] == PROOF_OF_PAYMENT_APPROVED)?' checked="checked"':'';
				if($this->if_obj->pop_editable)
					return sprintf('<input type="checkbox" name="pop[]" value="%s" %s />',$args['value'],$checked);
				else
				{
					return sprintf('%s <input type="checkbox" disabled="disabled" %s />',
						($checked?sprintf('<input type="hidden" name="pop[]" value="%s" />',$args['value']):'')
						,$checked);
				}
			break;
			case 'QUANTITY':
				$args['extra'] .= sprintf(' sort_val="%s" ', $args['value']);
    			return locale_nf($args['value'], 0);
    		break;
		}
		return $args['value'];
	}

    /**
     * item[1187] = document[id]
     */
    function getConfirmationDocument()
    {
    	// Do Nothing?
    	if(!$this->if_obj->model['crso']||!$this->if_obj->authorizeType)
    		return $this->_hideInput = true;
    }

    /**
     * item[1188] =
     */
    function getButtons()
    {
    	$this->_BarButtons = 0;
    	if(!$this->if_obj->model['crso']||!$this->if_obj->authorizeType)
    		return ;
    	if($this->if_obj->_process !='print')
    	{
	    	$this->_addCustomButton($this->langIf->getText('Print Preview'),'button',array('onclick'=>'print_preview();'));
	    	if($this->if_obj->editable)
	    	{
	    		$this->_addCustomButton($this->langIf->getText('Reject'),'button',array('onclick'=>'rejectPoP()'));
	    		$this->_addCustomButton($this->langIf->getText('Confirm'),'submit',array('disabled'=>'disabled'));
	    	}
    	}
    }
}

/**
 * CALLBACK[getCRSOSelect]
 * item[1184] = {
 *     [handle] = Item: CRSO Selection
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getConfirmationOverview]
 * item[1186] = {
 *     [handle] = Item: ConfirmationOverview
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getConfirmationDocument]
 * item[1187] = {
 *     [handle] = Item: ConfirmationDocument
 *     [behaviour] = required
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * CALLBACK[getButtons]
 * item[1188] = {
 *     [handle] = Item: ButtonBar
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 */
?>
