
<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');

define('BLOCK_QC_FILTER_SELECTION',574);

/**
 *
 * @package
 * @subpackage Interface
 * @since 18-09-2017
 * @copyright 2017 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceQuarterlyConfirmation extends InterfaceFactory
{
	/**
	 * interface[id] = 205
	 * @param $db Database (I_WARE_SETTINGS)
	 * @param $db_app Database (APPLICATION DATABASE)
	 * @param $langIf LanguageInterface
	 */
	function InterfaceQuarterlyConfirmation(&$db, &$db_app, &$langIf)
	{
		parent::InterfaceFactory($db, $db_app, $langIf);
		$this->FirstColWidth = 25;
		$this->delimiter = '<br />';

		$this->model['crso'] = false;
		$this->model['cpp'] = false;
		$this->model['years'] = array();
		$this->model['cp'] = new CRSOParticipantProduct($this->db_app);

		$this->model['year'] = isset($_REQUEST['year'])?$_REQUEST['year']:false;
		$this->model['quarter'] = isset($_REQUEST['quarter'])?$_REQUEST['quarter']:false;

		if(isset($_REQUEST['crso']['id'])) {
			$this->model['crso'] = new CRSO($this->db_app,array('relation'=>new Relation($this->db_app,$_REQUEST['crso']['id'])));
			$this->model['cpp'] = new CRSOParticipantProduct($this->db, array('crso'=>$this->model['crso']));
			$this->model['cpp']->set(null,$_SESSION['selected_participant_id'],$_SESSION['selected_product_id']);
		}

		$this->process = isset($_REQUEST['process'])?$_REQUEST['process']:'save';

		$this->script = "
			function reloadOverview()
			{
				var crso = $('ifI_1691');
				var selectedCRSO = crso.options[crso.selectedIndex].value;
				var year = $('ifI_1693');
				var selectedYear = year.options[year.selectedIndex].value;
				var quarter = $('ifI_1694');
				var selectedQuarter = quarter.options[quarter.selectedIndex].value;
				go('InterfaceQuarterlyConfirmation.php?crso[id]='+selectedCRSO+'&year='+selectedYear+'&quarter='+selectedQuarter);
			}
			";
	}
	/**
	 * @param string &$thrownException
	 */
	function processInput(&$thrownException)
	{

	}

	function init($ifId)
	{
		$rv = parent::init($ifId);
		if($this->process == 'print')
			unset($this->blocks[BLOCK_QC_FILTER_SELECTION]);
		return $rv;
	}

	function getInterfaceHeader()
	{
		$rv = parent::getInterfaceHeader();

		if ($this->process != 'print')
			return $rv.'<center>Print & sign this overview and email it to Recolight Limited.</center><br /><br />';

		$d = &currentDate();
		$time = $d->getTime();

		$p = new Relation($this->db_app,$_SESSION['selected_participant_id'],true);
		$c =& $this->model['crso']->relation;
		$p->address->set();
		$c->set();
		$c->address->set();
		require_once(ELC_CLASSES.'Country.php');
		$country = new Country($this->db_app);
		$country->set($p->address->country_id);
		$p_country = $country->name;
		$country->set($c->address->country_id);
		$c_country = $country->name;

		$rv .= '<h1>'.$this->langIf->getText('Quarterly Confirmation').' (Quarter '.$this->model['quarter'].' - '.$this->model['year'].')</h1>
			<table class="Professional" width="100%">
				<tr>
					<td>'.$this->langIf->getText('Print date').'</td>
					<td>
						'.$d->format('d-m-Y').'
					</td>
					<td></td>
				</tr>
				<tr>
					<td colspan="3"><br /></td>
				</tr>
				<tr>
					<td colspan="2">'.$p->name.'</td>
					<td>'.$c->name.'</td>
				</tr>
				<tr>
					<td colspan="2">'.$p->address->address_street_name.'</td>
					<td>'.$c->address->address_street_name.'</td>
				</tr>
				<tr>
					<td colspan="2">'.$p->address->city_name.', '.$p_country.'</td>
					<td>'.$c->address->city_name.', '.$c_country.'</td>
				</tr>
				<tr>
					<td colspan="2"></td>
					<td>'.$c->address->address_zipcode .', '.$c->email.'</td>
				</tr>
			</table>
			<br /><br />';


		return $rv;
	}

}
/**
 * @package
 * @subpackage Interface
 * @since 18-09-2017
 * @copyright 2017 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceQuarterlyConfirmationItem extends InterfaceItem
{

	/**
	 * item[1691] = crso[id]
	 */
	function getCRSOSelect()
	{
		$this->options = array(array('value'=>'','text'=>'- '.$this->langIf->getText('Select CRSO').' -'));
		$q = $this->if_obj->model['cp']->getParticipantCRSOs($_SESSION['selected_participant_id'],'q',false,false,$_SESSION['selected_product_id']);
		while($r=$q->fetch())
		{
			$name = $r->CRSO_NAME;
			$name = (mb_strlen($name)>35)?mb_substr($name,0,35).'...':$name;
			$this->options[] = array('value'=>$r->CRSO_RELATION_ID,'text'=>$name,
				'selected'=>(($this->if_obj->model['crso']&& $this->if_obj->model['crso']->relation->id==$r->CRSO_RELATION_ID)?'selected':false));
		}

		$this->properties['onchange'] = "go('InterfaceQuarterlyConfirmation.php?crso[id]='+this.options[this.selectedIndex].value);";
	}

	/**
	 * item[1693] = year
	 */
	function getYearSelect()
	{
		$this->options = array();
		if(!$this->if_obj->model['crso'])
		{
			$this->options[] = array('value'=>'','text'=>'- '.$this->langIf->getText('Select CRSO First').' -');
			return;
		}

		$date = currentDate();

		$this->options[] = array('value'=>'','text'=>'- '.$this->langIf->getText('Select Year').' -');
		for($i=WEEE_APPLICATION_START_YEAR; $i<=$date->getYear(); $i++)
			$this->options[] = array('value'=>$i,'text'=>$i,'selected'=>(($this->if_obj->model['year']==$i)?'selected':false));

		$this->properties['onchange'] = 'reloadOverview();';
	}

	/**
	 * item[1694] = quarter
	 */
	function getQuarterSelect()
	{
		$this->options = array();
		if(!$this->if_obj->model['crso'] && !$this->if_obj->model['year'])
		{
			$this->options[] = array('value'=>'','text'=>'- '.$this->langIf->getText('Select CRSO & Year First').' -');
			return;
		}

		$date = currentDate();

		$year = $this->if_obj->model['year'];
		$maxQuarter = 4;
		if($year == $date->getYear()) {
			$maxQuarter = ceil(($date->getMonth() - 3) / 3);
		}

		$this->options[] = array('value'=>'','text'=>'- '.$this->langIf->getText('Select Quarter').' -');
		for($i=1;$i<($maxQuarter+1);$i++)
			$this->options[] = array('value'=>$i,'text'=>'Quarter '.$i,'selected'=>(($this->if_obj->model['quarter']==$i)?'selected':false));

		$this->properties['onchange'] = 'reloadOverview();';
	}

	function _getQuarterlyDeclarationOverview()
	{
		if(!$this->if_obj->model['cpp'] || (($this->if_obj->model['cpp']->producer_exporter & PARTICIPANT_PRODUCER) != PARTICIPANT_PRODUCER))
			return '';

		$_defaultQuery = "
			SELECT
				%s as QUARTER,
				P.NAME as PRODUCT_NAME,
				PC.NAME as PRODUCT_CATEGORY,
				DIM.NAME as DIMENSION_NAME,
				SUM(DL.WEIGHT) as WEIGHT,
				SUM(DL.QUANTITY) as QUANTITY
			FROM TBL_DECLARATION as D
			INNER JOIN TBL_DECLARATION_LINE as DL
				ON D.DECLARATION_ID = DL.DECLARATION_ID
				%s
			INNER JOIN TBL_PRODUCT as P
				ON D.PRODUCT_ID = P.PRODUCT_ID
			INNER JOIN TBL_PRODUCT_CATEGORY as PC
				ON DL.PRODUCT_CATEGORY_ID = PC.PRODUCT_CATEGORY_ID
			INNER JOIN TBL_CRSO_PRODUCT_DIMENSION as DIM
				ON DL.CPD_ID = DIM.CPD_ID
				%s

		";

		$_where = sprintf('WHERE D.YEAR = %s AND D.PARTICIPANT_RELATION_ID = %s AND D.CRSO_RELATION_ID = %s AND D.PRODUCT_ID = %s AND %s ',
			$this->if_obj->model['year'],
			$_SESSION['selected_participant_id'],
			$this->if_obj->model['crso']->relation->id,
			$_SESSION['selected_product_id'],
			$this->_getQuarterDeclarationExportWhere($this->if_obj->model['quarter'])
		);

		$_groupBy = "GROUP BY D.PRODUCT_ID, DL.PRODUCT_CATEGORY_ID, DL.CPD_ID";

		$sql = sprintf($_defaultQuery, '"Q1"', ' AND D.MONTH IN ('.$this->_getQuarterMonths(1).') ', ' AND DIM.NAME = "Household" '.$_where);
		for($i = 2; $i <= $this->if_obj->model['quarter']; $i++) {
			if($i == 4) {
				$sql .= "UNION (".sprintf($_defaultQuery, '"Q'.$i.'"', '', '').' '.$_where.' AND ((D.MONTH IN ('.$this->_getQuarterMonths($i).') AND DIM.NAME = "Household") OR DIM.NAME = "Non-Household")'.$_groupBy.') ';
				continue;
			}
			$sql .= "UNION (".sprintf($_defaultQuery, '"Q'.$i.'"', ' AND D.MONTH IN ('.$this->_getQuarterMonths($i).') ', ' AND DIM.NAME = "Household" ').' '.$_where.$_groupBy.') ';
		}

		$sql .= "ORDER BY QUARTER, PRODUCT_NAME, PRODUCT_CATEGORY, DIMENSION_NAME";

		$q = $this->db_app->query($sql);
		$q->execute();
		if($q->rowCount() == 0) return '';

		$tf = new TableFactory($q,$this->langIf);
		$tf->setCaption('Quarterly declaration overview');
		$tf->setTHProcessor(array('WEIGHT', 'QUANTITY'), array($this, 'thAlignRight'));
		$tf->columnModifier(array('QUANTITY'=>'style="text-align:right;"','WEIGHT'=>'style="text-align:right;"'));
		$tf->setValueProcessor(array('WEIGHT', 'QUANTITY'), array($this, 'tfValueProcessorQuantityNoDecimals'));
		return $tf->getXHTMLTable('Professional',2);

	}

	function thAlignRight($args) {
		return 'class="th-right"';
	}

	function tfValueProcessorQuantityNoDecimals($args)
	{
		$args['extra'] .= sprintf(' sort_val="%s" ', $args['value']);
		return locale_nf($args['value'], 0);
	}

	function _getQuarterMonths($quarter) {
		switch($quarter) {
			case 1:
				return '1, 2, 3';
			case 2:
				return '4, 5, 6';
			case 3:
				return '7, 8, 9';
			case 4:
				return '10, 11, 12';
		}
		return '';
	}

	function _getQuarterDeclarationExportWhere($quarter) {

		$year = $this->if_obj->model['year'];

		switch($quarter) {
			case 1:
				return 'MONTH(D.EXPORT_DATE) <= 4 AND YEAR(D.EXPORT_DATE) = '.$year;
			case 2:
				return 'MONTH(D.EXPORT_DATE) <= 7 AND YEAR(D.EXPORT_DATE) = '.$year;
			case 3:
				return 'MONTH(D.EXPORT_DATE) <= 10 AND YEAR(D.EXPORT_DATE) = '.$year;
			case 4:
				return '((MONTH(D.EXPORT_DATE) <= 12 AND YEAR(D.EXPORT_DATE) = '.$year.') OR (MONTH(D.EXPORT_DATE) = 1 AND YEAR(D.EXPORT_DATE) = '.($year + 1).'))';
		}
	}

	function _getQuarterlyRefundOverview()
	{
		if(!$this->if_obj->model['cpp'] || (($this->if_obj->model['cpp']->producer_exporter & PARTICIPANT_EXPORTER) != PARTICIPANT_EXPORTER))
			return '';

		$_query = "
			SELECT
				Prod.NAME as PRODUCER,
				P.NAME as PRODUCT_NAME,
				PC.NAME as PRODUCT_CATEGORY,
				'Household' as DIMENSION_NAME,
				SUM(RRL.WEIGHT) as WEIGHT,
				SUM(RRL.QUANTITY) as QUANTITY
			FROM TBL_REFUND_EXPORT as RE
			INNER JOIN TBL_REFUND_REQUEST as RR
				ON RE.REFUND_EXPORT_ID = RR.REFUND_EXPORT_ID
			INNER JOIN TBL_REFUND_REQUEST_LINE as RRL
				ON RR.REFUND_REQUEST_ID = RRL.REFUND_REQUEST_ID
			INNER JOIN TBL_PRODUCT as P
				ON RE.PRODUCT_ID = P.PRODUCT_ID
			INNER JOIN TBL_PRODUCT_CATEGORY as PC
				ON RRL.PRODUCT_CATEGORY_ID = PC.PRODUCT_CATEGORY_ID
			INNER JOIN TBL_RELATION as Prod
				ON RRL.PRODUCER_RELATION_ID = Prod.RELATION_ID
		";

		$_groupBy = "GROUP BY RRL.PRODUCER_RELATION_ID, RE.PRODUCT_ID, RRL.PRODUCT_CATEGORY_ID ";
		$_orderBy = "ORDER BY PRODUCT_NAME, PRODUCT_CATEGORY, DIMENSION_NAME ";

		$_where = sprintf('WHERE YEAR(RE.EXPORT_DATE) = %s AND RE.PARTICIPANT_RELATION_ID = %s AND RE.CRSO_RELATION_ID = %s AND RE.PRODUCT_ID = %s AND %s ',
			$this->if_obj->model['year'],
			$_SESSION['selected_participant_id'],
			$this->if_obj->model['crso']->relation->id,
			$_SESSION['selected_product_id'],
			$this->_getQuarterRefundExportWhere($this->if_obj->model['quarter'])
		);

		$sql = $_query.$_where.$_groupBy.$_orderBy;

		$q = $this->db_app->query($sql);
		$q->execute();
		if($q->rowCount() == 0) return '';

		$tf = new TableFactory($q,$this->langIf);
		$tf->setCaption('Quarterly refund overview');
		$tf->setTHProcessor(array('WEIGHT', 'QUANTITY'), array($this, 'thAlignRight'));
		$tf->columnModifier(array('QUANTITY'=>'style="text-align:right;"','WEIGHT'=>'style="text-align:right;"'));
		$tf->setValueProcessor(array('WEIGHT', 'QUANTITY'), array($this, 'tfValueProcessorQuantityNoDecimals'));
		return $tf->getXHTMLTable('Professional',2);


	}

	function _getQuarterRefundExportWhere($quarter) {

		$year = $this->if_obj->model['year'];

		switch($quarter) {
			case 1:
				return 'MONTH(RE.EXPORT_DATE) IN (2, 3, 4) AND YEAR(RE.EXPORT_DATE) = '.$year;
			case 2:
				return 'MONTH(RE.EXPORT_DATE) IN (5, 6, 7) AND YEAR(RE.EXPORT_DATE) = '.$year;
			case 3:
				return 'MONTH(RE.EXPORT_DATE) IN (8, 9, 10) AND YEAR(RE.EXPORT_DATE) = '.$year;
			case 4:
				return '((MONTH(RE.EXPORT_DATE) IN (11, 12) AND YEAR(RE.EXPORT_DATE) = '.$year.') OR (MONTH(RE.EXPORT_DATE) = 1 AND YEAR(RE.EXPORT_DATE) = '.($year + 1).'))';
		}
	}

	/**
	 * item[1695] =
	 */
	function getQuarterlyConfirmation()
	{

		if(!$this->if_obj->model['crso'] || !$this->if_obj->model['year'] || !$this->if_obj->model['quarter']) {
			$this->text = 'Please make a selection first';
			return;
		}

		$overview = $this->_getQuarterlyDeclarationOverview().'<br />'.$this->_getQuarterlyRefundOverview();

		$signature = "<br>I confirm that the above listed WEEE declarations are true and correct for all calendar quarters so-far completed during ".$this->if_obj->model['year']."
                   for the named organisation.<br>
                  <ul>
                    <li style='margin-top: 8px'>Signed ...............................................................................................
                    <br>(Must be signed by a Managing Director/Senior Director of the organisation)</li>
                    <li style='margin-top: 8px'>Job Title .............................................................................................</li>
                    <li style='margin-top: 8px'>Print Name .........................................................................................</li>
                    <li style='margin-top: 8px'>Date ..................................................................................................</li>
                  </ul>
            ";


		$this->text = $overview.'<br />'.$signature;


	}

	/**
	 * item[1696] =
	 */
	function getButtons()
	{
		$this->_BarButtons = 0;

		if ($this->if_obj->process == 'print')
		{
			$this->_addCustomButton($this->langIf->getText('Print'), 'button', array('onclick'=>"print();"));
			$this->_addCustomButton($this->langIf->getText('Close'), 'button', array('onclick'=>"window.close();"));
			return;
		}


		$this->_addCustomButton($this->langIf->getText('Print Preview'), 'button', array('onclick'=>"print_preview();"));
		$this->script .= "
			function print_preview()
			{
				var nwin = new NewWindow(800, 600);
				nwin.setSource('about:blank');
				nwin.setName('winPrint');
				nwin.setScrollbars(true);
				nwin.center_me = false; // seems to give a permission denied sometimes
				var win = nwin.open(); // returns a window object

				// we can only post into when it has been loaded
				var frm = $('interface_form');
				frm.target='winPrint';
				frm.process.value='print';
				frm.submit();

				// restore
				frm.target='_self';
				frm.process.value='save';

			}
			";

	}

}

/**
 * CALLBACK[getCRSOSelect]
 * item[1691] = {
 *     [handle] = Item: CrsoSelection
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * CALLBACK[getYearSelect]
 * item[1693] = {
 *     [handle] = Item: Year Selection
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * CALLBACK[getQuarterSelect]
 * item[1694] = {
 *     [handle] = Item: Quarter Select
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getQuarterlyConfirmation]
 * item[1695] = {
 *     [handle] = item: QuarterlyConfirmationOverview
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getButtons]
 * item[1696] = {
 *     [handle] = Item: ButtonBar
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 */
