<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
require_once(ELC_CLASSES.'Relation.php');
require_once(ELC_CLASSES.'RelationUser.php');
require_once(ELC_CLASSES.'Trust.php');
require_once(ELC_CLASSES.'User.php');
/**
 *
 * @package ELC
 * @subpackage Interface
 * @author Marten Koedam <marten@basesoft.com>
 * @since 09-03-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceRelationOverview extends InterfaceFactory
{
    /**
     * interface[id] = 86
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceRelationOverview(&$db, &$db_app, &$langIf)
    {
        parent::InterfaceFactory($db, $db_app, $langIf);
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';
    }
	/**
	 *
	 */
	function init($id)
	{
		parent::init($id);
		unset($this->blocks[220]);
	}
    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {

    }
}
/**
 * @package ELC
 * @subpackage Interface
 * @since 09-03-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceRelationOverviewItem extends InterfaceItem
{

    /**
     * item[763] =
     */
    function getOverview()
    {
	$rv = null;
		// Check for any active Remote Viewer connections.
		if(IWRegistry::isRegistered('remote_viewer')) {
			$rv = IWRegistry::registry('remote_viewer');
		}
		require_once(IWARE.'TableFactoryColumnPlugin.php');

		$ru = new RelationUser($this->db_app);
		$trust = new Trust($this->db_app);
		$rel = new Relation($this->db_app);

		$ds = array();
		$q = $ru->getUserRelations($_SESSION['session_user_id']);
		$rs = $q->fetchAll();
		foreach($rs as $r)
		{
			// If in Remote Viewer mode, we only show the participant that's applicable.
			if($rv && $rv->participant->relation->id!=$r->RELATION_ID)
				continue;

			$rel->set($r->RELATION_ID);
			$subrogations = $trust->selectSubrogations($r->RELATION_ID,null,null,$_SESSION['selected_product_id']);
			$subrs = $subrogations->fetchAll();
			$trusts = $trust->selectTrusts($r->RELATION_ID,null,null,$_SESSION['selected_product_id']);
			$trustrs = $trusts->fetchAll();
			$ds[] = array(
				'PARTICIPANT_NAME'=>$r->RELATION_NAME,
				'PARTICIPANT_VAT'=>$rel->vat_no,
				'SUBROGATIONS'=>'<a id="participant_subrogations_'.$r->RELATION_ID.'" href="InterfaceSubrogationOverview.php?subrogator[id]='.$r->RELATION_ID.'">'.count($subrs).'</a>',
				'TRUSTS'=>'<a id="participant_trusts_'.$r->RELATION_ID.'" href="InterfaceTrustOverview.php?trustee[id]='.$r->RELATION_ID.'">'.count($trustrs).'</a>'
				);
		}

		$tf = new TableFactoryColumnPlugin(false,$this->langIf,$this->db,$this->db_app);
		$tf->setData($ds, 'TrustAndSubrogatorOverview',false,true);
		$tf->setEmptyText($this->langIf->getText('No relations found') );

		$help = ($this->parent->title != '') ? getHelp($this->langIf, $this->parent->handle, array('title'=>$this->parent->handle, 'top'=>'0px')) : '';
		$tf->setCaption($help.'<img src="/'.SITE_PATH.'images/block_arrow.png" /> '.$this->langIf->getText('Trust And Subrogator Overview'), false);

		$this->text = $tf->getXHTMLTable('Professional',2);
    }

    /**
     * item[764] =
     */
    function getButtons()
    {
		$this->_BarButtons = 0;
		//$this->_addCustomButton($this->langIf->getText('New Subrogation'),'button', array('onclick'=>""));
    }

}

/**
 * CALLBACK[getOverview]
 * item[763] = {
 *     [handle] = Item: RelationOverview
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getButtons]
 * item[764] = {
 *     [handle] = Item: ButtonBar
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 */
?>
