<?php
/**
 * InterfaceBrandsOverview
 * Shows all the currently authorized brands for a certain CRSO.
 */
require_once(INTERFACE_OBJ."InterfaceFactory.php");
require_once(ELC_CLASSES.'CRSO.php');
/**
 *
 *
 * @package ELC
 * @subpackage Interface
 * @author Marten Koedam <marten@basesoft.com>
 * @copyright (2005) BaseSoft B.V.
 * @since 21-01-2005
 * @version $Id$
 */
class InterfaceBrandsOverview extends InterfaceFactory
{
	function InterfaceBrandsOverview ($db, $db_app, $langIf)
	{
		if(!isset($_SESSION['public']['crso']['id']))
		{
			header('Location: /'.SITE_PATH);
			exit();
		}

		$this->FirstColWidth = 25;
		$this->delimiter = '<br />';
		parent::InterfaceFactory($db, $db_app, $langIf);

		$crso = new Relation($this->db_app,$_SESSION['public']['crso']['id']);
		$crso->set();
		setPageTitlePostfix('('.$crso->name.'/'.$crso->getCountry('','COUNTRY_NAME').')');
	}
}
/**
 * @package ELC
 * @subpackage Interface
 */
class InterfaceBrandsOverviewItem extends InterfaceItem
{
	/**
	 *
	 */
	function getOverview()
	{
		require_once(ELC_CLASSES.'Brand.php');
		require_once(ELC_CLASSES.'CRSO.php');

		$brand = new Brand($this->db_app,array('crso'=>new CRSO($this->db_app, array('relation'=> new Relation($this->db_app, $_SESSION['public']['crso']['id'])))));

		$tf = new TableFactory($brand->getPublic(null,null,$_SESSION['selected_product_id']),$this->langIf);

		$help = ($this->parent->title != '') ? getHelp($this->langIf, $this->parent->handle, array('title'=>$this->parent->handle, 'top'=>'0px')) : '';
		$tf->setCaption($help.'<img src="/'.SITE_PATH.'images/block_arrow.png" /> '.$this->langIf->getText('Brands Overview'), false);
		$tf->hideColumns(array('BRAND_ID','ACTIVE'));
		$tf->decapitate();
		$tf->columnize();

		$this->text = $tf->getXHTMLTable('Professional',2);
	}
}
?>