<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
require_once(ELC_CLASSES.'CRSO.php');
require_once(ELC_CLASSES.'CRSOParticipantProduct.php');

/**
 *
 * @package
 * @subpackage Interface
 * @since 29-06-2007
 * @copyright 2007 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceSupport extends InterfaceFactory
{
    /**
     * interface[id] = 172
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceSupport(&$db, &$db_app, &$langIf)
    {
        parent::InterfaceFactory($db, $db_app, $langIf);
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';

		$this->model['crso'] = new CRSO($this->db_app);
		if(!empty($_GET['crso']['id']))
			$this->model['crso']->set($_GET['crso']['id']);

        $this->script = sprintf("
			function selectCRSO(sel)
			{
				if(!sel.value)
					return;
				document.location.href = '/%sscripts/elc/public/InterfaceSupport.php?crso[id]='+sel.value;
			}
			",
			SITE_PATH);
    }
    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {

    }
}
/**
 * @package
 * @subpackage Interface
 * @since 29-06-2007
 * @copyright 2007 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceSupportItem extends InterfaceItem
{

    /**
     * item[1334] =
     */
    function getContactInfo()
    {
    	$this->text = $this->langIf->getText('Info: Contact Information {SUPPORT_EMAIL}',null,
    		array('SUPPORT_EMAIL'=>'<a href="mailto:support@weeeblackbox.pwc.com">support@weeeblackbox.pwc.com</a>'));
    }

    /**
     * item[1335] = crso[id]
     */
    function getCRSOSelect()
    {
    	// If there is only one CRSO, auto select it.
    	$cpp = new CRSOParticipantProduct($this->db_app);
    	$q = $cpp->getParticipantCRSOs($_SESSION['selected_participant_id'],'q',false,false,$_SESSION['selected_product_id']);
    	$row = $q->fetchAll();
    	$this->options = array(array('text'=>'- '.$this->langIf->getText('CRSO Select').' -','value'=>''));
    	foreach($row as $r)
    	{
    		$selected = false;
    		if($this->if_obj->model['crso']->isComplete() &&
    			($r->CRSO_RELATION_ID == $this->if_obj->model['crso']->relation->id))
    				$selected = 'selected';
    		$this->options[] = array('text'=>$r->CRSO_NAME,'value'=>$r->CRSO_RELATION_ID,'selected'=>$selected);
    	}
    	$this->properties['onchange'] = 'selectCRSO(this);';
    }

	function getDocumentOverview()
	{
		if(!isset($this->if_obj->model['crso']->relation))
			return;

		require_once(ELC_CLASSES.'CRSOSupportDocument.php');
		$csd = new CRSOSupportDocument($this->db_app,array('crso'=>$this->if_obj->model['crso']));
		$tf = new TableFactory($csd->getDocumentsForCRSO(),IWRegistry::registry('langIf'));
		$tf->setCaption('Process Manuals Overview');
		$tf->hideColumn('DocumentId');
		$tf->setEmptyText(IWRegistry::registry('langIf')->getText('No Process Documents'));
		$tf->setValueProcessor(TF_ALL,array($this,'tfValueProcessor'));
		$this->text = $tf->getXHTMLTable('Professional',2);
	}

	function tfValueProcessor($args)
	{
		switch($args['head'])
		{
			case 'DocumentName':
				return sprintf('<a href="/%sscripts/i-w/document/download.php?Document[id]=%s">%s</a>',
					SITE_PATH,
					$args['row']['DocumentId'],
					$args['value']
					);
			break;
		}
		return $args['value'];
	}
}

/**
 * CALLBACK[getContactInfo]
 * item[1334] = {
 *     [handle] = Item: Contact info
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getCRSOSelect]
 * item[1335] = {
 *     [handle] = Item: CRSO Selection
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 */
?>
