<?php
require_once(INTERFACE_OBJ."InterfaceFactory.php");
require_once(IWARE.'group.php');
require_once(ELC_CLASSES.'User.php');
define('BLOCK_MULTI_PARTICIPANT',361);
define('BLOCK_CHANGE_PASSWORD',200);
define('ITEM_CURRENT_PASSWORD',707);
/**
 *
 *
 * @package ELC
 * @subpackage Interface
 * @author Marten Koedam <marten@basesoft.com>
 * @copyright (2005) BaseSoft B.V.
 * @version $Id$
 */
class InterfaceUserProfile extends InterfaceFactory
{
	var $hideBlocks = array();
	function InterfaceUserProfile($db, $db_app, $langIf)
	{
		$this->FirstColWidth = 25;
		$this->delimiter = '<br />';
		switch($_SESSION['session_group_group_id'])
		{
			case GROUP_PARTICIPANT:
			break;
			default:
				$this->hideBlocks = array(BLOCK_MULTI_PARTICIPANT);
		}
		parent::InterfaceFactory($db, $db_app, $langIf);
	}

	function _filter($q)
	{
		$rv = parent::_filter($q);
		foreach($this->hideBlocks as $blockId)
			unset($rv[$this->id][$blockId]);

		if ($_SESSION['login_type'] == LOGIN_TOKEN)
		{
			// we don't need old password if the used a token to login
			unset($rv[$this->id][BLOCK_CHANGE_PASSWORD][ITEM_CURRENT_PASSWORD]);
		}

		return $rv;
	}

	/**
	 *
	 */
	function processInput(&$thrownException)
	{
		$confirmPass = $this->langIf->getText('Please confirm your new password');
		$supplyPass = $this->langIf->getText('Please fill out a new password');
		$supplyOldPass = $this->langIf->getText('Please fill out your current password');
		$incorrectOldPass = $this->langIf->getText('Invalid Password');
		$sameAsOldPass = $this->langIf->getText('Same password as the old password, please choose another');
		$incorrectMatch = $this->langIf->getText('New Passwords are not equal');
		$weakPassword = $this->langIf->getText('Weak password, please try something else');
		$passwordLength = $this->langIf->getText('Password too short, must be at least {CHARS} characters long', null, array('CHARS'=>ELCUser::getMinimumPasswordLength()));
		$matchingNameAndPassword = $this->langIf->getText('User name and password cannot be the same');
		$unableToChangeDefaultParticipant = $this->langIf->getText('Unable to change default participant');

		if(isset($_POST['process']))
		{
			if($_POST['process'] == 'save' )
			{
				$extra_log_info = '';
				$confirm = '';
				$this->db_app->begin();

				$user = new ELCUser($this->db_app,$_SESSION['session_user_id']);
				$user->set();
				$user->info_person->set();
				$_SESSION['session_user_language_id'] = $user->info_person->language_id = $_POST['language']['id'];
				$user->info_person->update();

				if(isset($_POST['participant']['id'])&&is_numeric($_POST['participant']['id']))
				{
					require_once(ELC_CLASSES.'RelationUser.php');
					// Initiate new RUI
					$ru = new RelationUser($this->db_app,
						array('user'=>$user,
							'relation'=>new Relation($this->db_app,$_POST['participant']['id'])
							));
					if(!$ru->setDefaultRelation())
					{
						$this->db_app->rollback();
						return $thrownException .= $unableToChangeDefaultParticipant;
					}
					$_SESSION['selected_participant_id'] = $_POST['participant']['id'];
				}


				// @todo mkpretty
				if(!empty($_POST['user']['current_passwd'])||!empty($_POST['user']['new_passwd'])||!empty($_POST['user']['new_passwd_verify']))
				{

					if(($_SESSION['login_type'] != LOGIN_TOKEN) && empty($_POST['user']['current_passwd']))
					{
						$this->db_app->rollback();
						return $thrownException .= $supplyOldPass;
					}
					if(empty($_POST['user']['new_passwd']))
					{
						$this->db_app->rollback();
						return $thrownException .= $supplyPass;
					}
					if(empty($_POST['user']['new_passwd_verify']))
					{
						$this->db_app->rollback();
						return $thrownException .= $confirmPass;
					}

					if (CRYPT_BLOWFISH == 1)
					{
						$this->salt = $user->salt;
						if(isset($_POST['user']['current_passwd']))
							$c_password = crypt($_POST['user']['current_passwd'],$this->salt);
						$n_password = crypt($_POST['user']['new_passwd'],$this->salt);
					}
					else
					{
						if(isset($_POST['user']['current_passwd']))
							$c_password = sha1($_POST['user']['current_passwd']);
						$n_password = sha1($_POST['user']['new_passwd']);
					}

					if(($_SESSION['login_type'] != LOGIN_TOKEN) && ($c_password != $user->password))
					{
						$this->db_app->rollback();
						return $thrownException .= $incorrectOldPass;
					}
					if($n_password == $user->password)
					{
						$this->db_app->rollback();
						return $thrownException .= $sameAsOldPass;
					}
					if($_POST['user']['new_passwd']==$user->name)
					{
						$this->db_app->rollback();
						return $thrownException .= $matchingNameAndPassword;
					}
					if($_POST['user']['new_passwd_verify']!=$_POST['user']['new_passwd'])
					{
						$this->db_app->rollback();
						return $thrownException .= $incorrectMatch;
					}
					if(!ELCUser::validatePasswordLength($_POST['user']['new_passwd']))
					{
						$this->db_app->rollback();
						return $thrownException .= $passwordLength;
					}
					if(!ELCUser::validatePassword($_POST['user']['new_passwd']))
					{
						$this->db_app->rollback();
						return $thrownException .= $weakPassword;
					}
					$user->setPassword($_POST['user']['new_passwd']);
					$user->last_login = date('Y-m-d H:i:s');
					$user->last_password_update = date('Y-m-d H:i:s');
					$_SESSION['user_password_expired'] = false;
					$user->update();

					// invalidate any active token for this user
					$user->invalidateAllTokens();

					$confirm = '&confirm=yes';

					if ($_SESSION['login_type'] == LOGIN_TOKEN)
					{
						$extra_log_info .= '. A token was used for logging in';
						$_SESSION['login_type'] = LOGIN_NORMAL;
					}
				}
				$this->db_app->commit();
				unset($_SESSION['locales']); // unset locales so it will be fetched from the db again

				$log = getLog();
				$log->info('User Profile changed for User ['.$_SESSION['session_user_id'].']' . $extra_log_info);


				header('Location: InterfaceUserProfile.php?1=1'.$confirm);
				die();
			}

			header("Location: ../");
			die();
		}
	}
}

class InterfaceUserProfileItem extends InterfaceItem
{
	/**#@+
	 * Callback functions made from InterfaceItem
	 */
	/**
	 *
	 */
	function getLanguageSelect()
	{
		require_once(IWARE.'nLanguage.php');
		require_once(ELC_CLASSES.'ELCGroupLanguage.php');
		$lang = new nLanguage($this->db_app);
		require_once(IWARE.'group.php');
		$status = in_array($_SESSION['session_group_group_id'],array(GROUP_SYSADMIN,GROUP_ACCOUNTANT,GROUP_CRSO))?LANGUAGE_STATUS_ENABLED+LANGUAGE_STATUS_SELECTABLE:LANGUAGE_STATUS_ENABLED;
		$gl = new ELCGroupLanguage($this->db_app, array('group_id'=>$_SESSION['session_group_group_id']));
		$langArray = $gl->getEnabledLanguages();


		$q = $lang->getByStatus($status);
		$i = 0;
		while($r = $q->fetch())
		{
			if(!in_array($r->LANGUAGE_ID,$langArray))
				continue;
			$this->options[$i] = array('text'=>$r->LANGUAGE,'value'=>$r->LANGUAGE_ID);
			if($r->LANGUAGE_ID == $_SESSION['session_user_language_id'])
				$this->options[$i]['selected'] = 'selected';
			$i++;
		}
	}
	/**
	 *
	 */
	function getParticipantSelect()
	{
		$this->options = array(array('text'=>'- '.$this->langIf->getText('Select Participant').' -', 'value'=>''));
		require_once(ELC_CLASSES.'Participant.php');
		$p = new Relation($this->db_app);
		foreach($_SESSION['participant_ids'] as $partId)
		{
			$p->set($partId);
			$this->options[] = array('text'=>$p->name,'value'=>$partId,'selected'=>($_SESSION['selected_participant_id']===$partId));
		}
	}

	function getPasswordRequirements(){
		$rv = "<div><span style='font-weight: bold;'>".$this->langIf->getText("Password requirements").":</span>".
			  "<ul style='list-style-type:disc'>";
		$exp = '';
		$l = '';
		switch($_SESSION['session_group_group_id'])
		{
			case GROUP_SYSADMIN:
				$l = PASSWORD_LENGTH_SYSADMIN;
				$exp = PASSWORD_EXPIRES_SYSADMIN;
			break;
			case GROUP_ACCOUNTANT:
				$l = PASSWORD_LENGTH_ACCOUNTANT;
				$exp = PASSWORD_EXPIRES_ACCOUNTANT;
			break;
			case GROUP_CRSO:
				$l = PASSWORD_LENGTH_CRSO;
				$exp = PASSWORD_EXPIRES_CRSO;
			break;
			case GROUP_PARTICIPANT:
				$l = PASSWORD_LENGTH_PARTICIPANT;
				$exp = PASSWORD_EXPIRES_PARTICIPANT;
			break;
			case GROUP_PUBLIC:
				$l = PASSWORD_LENGTH_PUBLIC;
				$exp = PASSWORD_EXPIRES_PUBLIC;
			break;
		}
		$rv .= "<li>".$this->langIf->getText("Minimum number of characters").": ".$l.";</li>".
			   "<li>".$this->langIf->getText("Must include at least two digits").";</li>".
			   "<li>".$this->langIf->getText("Must have at least one uppercase character").";</li>".
			   "<li>".$this->langIf->getText("Must have at least one lowercase character").";</li>".
			   "<br />".
			   "<li>".$this->langIf->getText("Can't contain a dictionary word").";</li>".
			   "<li>".$this->langIf->getText("Must be different than username").";</li>".
			   "<li>".$this->langIf->getText("New password cannot be the same as old password").";</li>".
			   "<br />";

		$user = new ELCUser($this->db_app,$_SESSION['session_user_id']);
		$user->set();
		if($user->verifyPasswordNotExpired()){
			$exp_date =strtotime(date($user->last_password_update) . " +".$exp." day");
			$exp_date = strftime('%x %X', $exp_date);

			$days = time() - strtotime($user->last_password_update);
			$days = $exp - floor($days/(60*60*24));

			$rv .= "<li>".$this->langIf->getText("Current password expires in")." ".$days."  ".$this->langIf->getText("days").
				   " (".$exp_date.").</li>";
		}
		else
			$rv .= "<li style='font-weight:bold'>".$this->langIf->getText("Current password is expired").".</li>";
		$rv .= "</ul></div>";
		$this->text =  $rv;
	}

	/**
	 *
	 */
	function getPasswordStrengthMeter() {
		$container = "<span>".$this->langIf->getText("Password strength")." </span>".
			"<div style='border: 1px solid #ccc; width: 100px; height: 14px; display: inline-block;'>".
			"<div id='pwd-strength' style='float: left; height: 14px; width: 0;'></div>".
			"</div>".
			"<span id='pwd-strength-complexity'></span>";

		$this->text = $container;

		//here we attach form watch behaviour to force new document id generation if checkboxes change
		if (!isset($this->script))
			$this->script = '';

		$this->script .= '
			addEvent(window, "load", function(){
				addEvent($("ifI_708"), "keyup", function(){
					checkPass($("ifI_708").value);
				});
			});

		';
	}

	/**
	 *
	 */
	function getButtons()
	{
		$this->_BarButtons = BUTTON_SAVE;
	}
	/**#@-*/
}
