<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
require_once(ELC_CLASSES.'AccountantCRSO.php');
/**
 *
 * @package
 * @subpackage Interface
 * @since 20-05-2010
 * @copyright 2010 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceAccountantCRSOOverview extends InterfaceFactory
{
    /**
     * interface[id] = 193
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceAccountantCRSOOverview(&$db, &$db_app, &$langIf)
    {
        parent::InterfaceFactory($db, $db_app, $langIf);
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';

        $accountant = new Accountant($this->db_app, $_REQUEST['accountant'], true);
        if(!$accountant->isComplete()) {
        	header('Location: InterfaceAccountantOverview.php');
        	exit();
        }
        $accountant->relation->set();
        setPageTitlePostfix(sprintf(' (%s)', $accountant->relation->name));

        $this->model['ac'] = new AccountantCRSO($this->db_app, array('accountant'=>$accountant));
    }
    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {

    }
}
/**
 * @package
 * @subpackage Interface
 * @since 20-05-2010
 * @copyright 2010 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceAccountantCRSOOverviewItem extends InterfaceItem
{

    /**
     * item[1535] =
     */
    function getOverview() {
    	require_once(IWARE.'table_factory.php');
    	$tf = new TableFactory($this->if_obj->model['ac']->selectOverview(), $this->langIf);

    	$tf->setEmptyText($this->langIf->getText('No CRSOs linked to this accountant') );
    	$tf->hideColumns(array('crso_id'));
    	$tf->setValueProcessor(TF_ALL, array($this, 'tfValueProcessor'));

    	$this->text = $tf->getXHTMLTable();
    }

    function tfValueProcessor($args) {
    	switch($args['head']) {
    		case 'Settings':
    			return sprintf(
    				'<a href="InterfaceAccountantCRSORegistration.php?accountant[id]=%s&crso[id]=%s">%s</a>',
    				$this->if_obj->model['ac']->accountant->relation->id,
    				$args['row']['crso_id'],
    				$this->langIf->getText('Settings')
    			);
    		break;
    		case 'CRSO':
    			return sprintf(
    				'<a href="/scripts/elc/operator/InterfaceCRSORegistration.php?crso[id]=%s">%s</a>',
    				$args['row']['crso_id'],
    				$args['value']
    			);
    		break;
    		case 'END_DATE':
    			return $args['value'] ? $args['value'] : '-';
    	}
    	return $args['value'];
    }

    /**
     * item[1536] =
     */
    function getButtons()
    {
    	$this->_BarButtons = 0;

    	$this->_addCustomButton($this->langIf->getText('Add CRSO to Accountant'),'button', array('onclick'=>sprintf("document.location.href='InterfaceAccountantCRSORegistration.php?accountant[id]=%s';",$this->if_obj->model['ac']->accountant->relation->id)));
    }

}

/**
 * CALLBACK[getOverview]
 * item[1535] = {
 *     [handle] = Item: CRSO Overview
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getButtons]
 * item[1536] = {
 *     [handle] = Item: Button bar
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 */
?>
