<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
require_once(ELC_CLASSES.'Accountant.php');
/**
 *
 * @package WEEEBlackBox
 * @subpackage Interface
 * @since 20-05-2010
 * @author Marten Koedam <marten@basesoft.com>
 * @copyright 2010 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceAccountantOverview extends InterfaceFactory
{
    /**
     * interface[id] = 190
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceAccountantOverview(&$db, &$db_app, &$langIf)
    {
        parent::InterfaceFactory($db, $db_app, $langIf);
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';
    }
    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {

    }
}
/**
 * @package
 * @subpackage Interface
 * @since 20-05-2010
 * @copyright 2010 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceAccountantOverviewItem extends InterfaceItem
{

    /**
     * item[1518] =
     */
    function getOverview()
    {
    	$accountant = new Accountant($this->db_app);
    	$ds = $accountant->selectOverview();

    	require_once(IWARE.'table_factory.php');
		$tf = new TableFactory($ds,$this->langIf);
		/*$sort = array('CODE'=>"'String'",
				'RELATION_ID'=>"'String'",
				'COMPANY_NAME'=>"'String'");

		$tf->setSortingFunctions($sort);*/
		$tf->setEmptyText($this->langIf->getText('No accountants found') );
		$tf->setValueProcessor(TF_ALL, array($this, 'tfValueProcessor'));
		$this->text = $tf->getXHTMLTable('Professional',2);
    }

    function tfValueProcessor($args) {
    	switch($args['head']) {
    		case 'CHECKBOX':
    			// Checkbox for deletion purposes?
    		break;
    		case 'RELATION_ID':
			return sprintf('<a href="InterfaceAccountantRegistration.php?accountant[id]=%s">%s</a>',
				$args['value'], $args['value']);
    		break;
    		case 'Users':
			return sprintf('<a id="accountant_users_%s" href="InterfaceAccountantUserOverview.php?accountant[id]=%s">%s</a>',
				$args['row']['RELATION_ID'], $args['row']['RELATION_ID'], $args['value']);
    		break;
    		case 'CRSOs':
			return sprintf('<a id="accountant_crsos_%s" href="InterfaceAccountantCRSOOverview.php?accountant[id]=%s">%s</a>',
				$args['row']['RELATION_ID'], $args['row']['RELATION_ID'], $args['value']);
    		break;
    	}
    	return $args['value'];
    }

    /**
     * item[1519] =
     */
    function getButtons()
    {
    	$this->_BarButtons = 0;
		$this->_addCustomButton($this->langIf->getText('New Accountant'),'button', array('onclick'=>"document.location.href='InterfaceAccountantRegistration.php';"));
    }

}

/**
 * CALLBACK[getOverview]
 * item[1518] = {
 *     [handle] = Item: Accountant Overview
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getButtons]
 * item[1519] = {
 *     [handle] = Item: Button bar
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 */
?>
