<?php
/**
 * File description
 *
 * @package PACKAGE
 * @subpackage SUBPACKAGE
 * @since Nov 1, 2006
 * @author Martijn van den Broek <martijn@xs4all.nl>
 * @version $Id$
 * @copyright 2006 BaseSoft B.V.
 */

require_once(INTERFACE_OBJ.'InterfaceFactory.php');
require_once(IWARE.'group.php');
/**
 * f
 * @package
 * @subpackage Interface
 * @since 01-11-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceLanguageAdmin extends InterfaceFactory
{
    /**
     * interface[id] = 152
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceLanguageAdmin(&$db, &$db_app, &$langIf)
    {
        parent::InterfaceFactory($db, $db_app, $langIf);
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';

        $this->hiddenFields[] = array('name'=>'Action', 'value'=>'no action');

        $this->model['limitRows'] = isset($_REQUEST['limitRows']) ? (int) $_REQUEST['limitRows'] : 50;
        $this->model['emptyOnly'] = isset($_REQUEST['emptyOnly']) ? (bool) $_REQUEST['emptyOnly'] : false;

        $this->model['firstLanguage'] = isset($_REQUEST['firstLanguage']) ? (int) $_REQUEST['firstLanguage'] : 44;
        $this->model['secondLanguage'] = isset($_REQUEST['secondLanguage']) ? (int) $_REQUEST['secondLanguage'] : 49;

        $this->model['filters'] = isset($_REQUEST['filters']) ? $_REQUEST['filters'] : array(
			'handle'=>'',
			'translation'=>'',
			'scriptCache'=>''
		);

		$this->hiddenFields[] = array('name'=>'firstlanguage_id', 'value'=>$this->model['firstLanguage']);
		$this->hiddenFields[] = array('name'=>'secondlanguage_id', 'value'=>$this->model['secondLanguage']);

    }
}
/**
 * @package
 * @subpackage Interface
 * @since 01-11-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceLanguageAdminItem extends InterfaceItem
{

    /**
     * item[1115] =
     */
    function getList()
    {
    	$this->text = '<div id="divLangAdminList"></div>';
    }

    /**
     * item[1121] = emptyOnly
     */
    function emptyOnly()
    {
    	$this->properties['checked'] = $this->if_obj->model['emptyOnly'];
    }

    /**
     * item[1122] = limitRows
     */
    function limitRows()
    {
    	$this->properties['value'] = $this->if_obj->model['limitRows'];
    }

    function buttonBar()
    {

		$this->script = "
			function refresh()
			{
				console.debug('refreshing..');
				var params = new Array();

				params['noscripts'] = true;
				params['limitRows'] = $$('limitRows').value;
				params['emptyOnly'] = $$('emptyOnly').checked;

				params['firstLanguage'] = $$('firstLanguage').value;
				params['secondLanguage'] = $$('secondLanguage').value;

				params['filters'] = new Array();
				params['filters']['handle'] = $$('filter[handle]').value;
				params['filters']['translation'] = $$('filter[translation]').value;
				params['filters']['scriptCache'] = $$('filter[scriptCache]').value;

				var grpels = document.getElementsByName('groups[]');
				groups = 0; for (var i=0; i<grpels.length; i++)
				{
					el = grpels[i];
					if (el.checked)
						groups += parseInt(el.value)
				}
				params['filters']['groups'] = groups;

				msgProgress = MessageBox.prototype.Wait('Loading langif', 'Please wait while loading the Language Interface');

				langAdmin.firstLanguageId   = $$('firstLanguage').value;
				langAdmin.secondLanguageId = $$('secondLanguage').value;
				langAdmin.simple_mode = 0;

				jsbroker.call( 'LangIfRPC.getAdminHandles', params, function(params)
				{
					var handles = params;
					var div = document.getElementById('divAdminHandles');
					var target = $('divLangAdminList');

					langAdmin.createAdminTable(target, handles, msgProgress);
				});
			}

			addEvent(window, 'load', refresh);
		";


		$this->_BarButtons = 0;
		$this->_addCustomButton($this->langIf->getText('Refresh'), 'button',
			array('onclick'=>"refresh();"));
		$this->_addCustomButton($this->langIf->getText('Select All'), 'button',
			array('onclick'=>"langAdmin.checkAll( $('divLangAdminList') );"));

		//$this->_addCustomButton($this->langIf->getText('Delete Handles '), 'submit',
		//	array('onclick'=>"if (confirm('Are you sure you want to delete the selected handles?')) { $('interface_form').action = '/".SITE_PATH."scripts/i-w/bots/language_process.php'; $('interface_form').Action.value='Delete'; return true; } return false;;"));

		$this->_addCustomButton($this->langIf->getText('Save Translations'), 'button',
			array('onclick'=>"langAdmin.updateHandles( $('interface_form'), function() { refresh(); } );"));
    }


    function firstLanguage()
    {
    	foreach ($this->getLangs()  as $id => $name)
			$this->options[] = array(
				'text'=>$name,
				'value'=>$id,
				'selected'=>($id == $this->if_obj->model['firstLanguage']));

    }

    function secondLanguage()
    {
    	foreach ($this->getLangs()  as $id => $name)
			$this->options[] = array(
				'text'=>$name,
				'value'=>$id,
				'selected'=>($id == $this->if_obj->model['secondLanguage']));
    }

    function getLangs()
    {
		$sql = "SELECT LANGUAGE_ID, LANGUAGE FROM TBL_LANGUAGE ORDER BY LANGUAGE";
		$ex = $this->db_app->query($sql);
		$ex->execute();

		$l = array();
		while ($row = $ex->fetch())
			$l[$row->LANGUAGE_ID] = $row->LANGUAGE;

		return $l;
    }


    /**
     * item[1127] = filters[handle]
     */
    function filterHandle()
    {
    	$this->properties['value'] = $this->if_obj->model['filters']['handle'];
    	$this->properties['style'] = 'width: 300px;';
    }

    /**
     * item[1128] = filters[translation]
     */
    function filterTranslation()
    {
    	$this->properties['value'] = $this->if_obj->model['filters']['translation'];
    	$this->properties['style'] = 'width: 300px;';
    }

    /**
     * item[1129] = filtr[scriptCache]
     */
    function filterScriptCache()
    {
    	$this->properties['value'] = $this->if_obj->model['filters']['scriptCache'];
    	$this->properties['style'] = 'width: 300px;';

    	//$this->properties['disabled'] = 'disabled';
    }

    function filterDescription()
    {
    	$this->twoCols = true;
    	//$this->if_obj->FirstColWidth = 50;

    	$this->text = "
			Filters use regular expressions. See <a href=http://regularexpressions.info/>http://regularexpressions.info/</a>.
		";
    }

    function getFilterGroupDesc()
    {
		$this->text = 'Select groups';
    }


    function getFilterGroups()
    {
		$html = '';
    	foreach (Group::getGroups() as $bit => $value)
    	{
    		$chk = new Form_Checkbox('groups[]', $bit, true);
    		$chk->setLabel($value);
    		$html .= $chk->getHtml();
    	}

    	$this->text = $html;
    }
}

/**
 * CALLBACK[getLanguageInterface]
 * item[1115] = {
 *     [handle] = Item: List
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[emptyOnly]
 * item[1121] = {
 *     [handle] = Item: EmptyOnly
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * CALLBACK[limitRows]
 * item[1122] = {
 *     [handle] = Item: LimitRows
 *     [behaviour] = integer
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 */
?>