<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
require_once(ELC_CLASSES.'AdminIP.php');
/**
 *
 * @package
 * @subpackage Interface
 * @since 30-11-2007
 * @copyright 2007 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceManageAdminIP extends InterfaceFactory
{
    /**
     * interface[id] = 181
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceManageAdminIP(&$db, &$db_app, &$langIf)
    {
        parent::InterfaceFactory($db, $db_app, $langIf);
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';

        $this->model['aip'] = new AdminIP($this->db_app);
        if(isset($_GET['id']) && !empty($_GET['id']))
			$this->model['aip']->set((int)$_GET['id']);

		$this->script = "
			function deleteIPs()
			{
				MessageBox.prototype.Question('".$this->langIf->getText('Warning')."', '".$this->langIf->getText('Are you sure you want to remove selected Admin IPs')."',
					function(){
						document.getElementsByName('process')[0].value='delete';
						document.getElementById('interface_form').submit();
					}, function(){});
			}
			function addIP()
			{
				if(fb.validate($('interface_form')))
				{
					document.getElementsByName('process')[0].value='add';
					document.getElementById('interface_form').submit();
				}
			}" .
			"function updateIP(id_ip)
			{
				if(fb.validate($('interface_form')))
				{
					document.getElementsByName('process')[0].value='update';
					var elem = document.createElement('input');
					elem.type = 'hidden';
					elem.name = 'id';
					elem.id = 'id_o';
					elem.value = id_ip;
					document.getElementById('interface_form').appendChild(elem);
					document.getElementById('interface_form').submit();
				}
			}";
		$this->fb->register('address', 'required;ipwildcard');
    }
    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {
        if(isset($_POST['process']))
        {
			$aip = new AdminIP($this->db_app);
			if($_POST['process'] == 'delete')
			{
				if(!isset($_POST['ip']))
					return;
				foreach($_POST['ip'] as $ip_id)
					$aip->delete((int)$ip_id);
			}

			if($_POST['process'] != 'delete' && !$this->fb->validate())
				return $thrownException .= $this->langIf->getText('Please correct the form errors');
			if($_POST['process'] == 'add')
			{
				$aip->ip_address = $_POST['address'];
				$aip->ip_identificatie = isset($_POST['descr'])?$_POST['descr']:'';
				$aip->insert();
			}
			if($_POST['process'] == 'update')
			{
				$aip->ip_address = $_POST['address'];
				$aip->ip_identificatie = isset($_POST['descr'])?$_POST['descr']:'';
				$aip->update((int)$_POST['id']);
			}
			unset($this->model['aip']);
			$this->model['aip'] = & $aip;
			parent::init(181);
        }
    }
 }
/**
 * @package
 * @subpackage Interface
 * @since 30-11-2007
 * @copyright 2007 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceManageAdminIPItem extends InterfaceItem
{

    /**
     * item[1409] =
     */
    function getButtons()
    {
  		$this->_BarButtons = 0;
  		$this->_addCustomButton($this->langIf->getText('Remove'),'button', array('onclick'=>"deleteIPs();"));

  		$address = (isset($_GET['id']))?$this->if_obj->model['aip']->ip_address:'';
  		$descr = (isset($_GET['id']))?$this->if_obj->model['aip']->ip_identificatie:'';
  		$add_address = '<div id="addadr" style="float:left;">'.$this->langIf->getText('IP Address').'<span class="required">*</span> ' .
  				' <input id="id_adr" behaviour="required;ipwildcard" type=text name="address" value="'.$address.'" size=40>' .
  				 '</div>';
		$add_descr = '<div id="adddescr" style="float:left;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'.$this->langIf->getText('Description').' ' .
  				' <input id="id_desc" type=text name="descr" value="'.$descr.'" size=50>' .
  				 '</div>';
  		$this->_CustomButtons[] = "<br /><br />";
  		$this->_CustomButtons[] = $add_address;
  		$this->_CustomButtons[] = $add_descr;
  		$this->_CustomButtons[] = "<span style='float: none'></span>";
  		if(isset($_GET['id']) && !empty($_GET['id']))
			$this->_addCustomButton($this->langIf->getText('Update'),'button', array('onclick'=>"updateIP(".(int)$_GET['id'].");"));
		$this->_addCustomButton($this->langIf->getText('Add'),'button', array('onclick'=>"addIP();"));
    }

    /**
     * item[1411] =
     */
    function getOverview()
    {
    	$ds = $this->if_obj->model['aip']->getOverview();

    	$tf = new TableFactory($ds,IWRegistry::registry('langIf'));
    	$tf->setCaption('Admin IPs Overview');
    	$sort = array('ID'=>"'String'",
				'IP_ADDRESS'=>"'String'",
				'DESCRIPTION'=>"'String'");

		$tf->setValueProcessor('CHECKBOX', 'return \'<input type="checkbox" name="ip[]" value="\'.$row[\'ID\'].\'" />\';');
		$tf->setValueProcessor('ID', 'return \'<a href="InterfaceManageAdminIp.php?id=\'.$value.\'">\'.$value.\'</a>\';');

		$tf->setSortingFunctions($sort);
		$tf->setEmptyText($this->langIf->getText('No admin IPs') );
		$this->text = $tf->getXHTMLTable('Professional',2);
    }

}

/**
 * CALLBACK[getButtons]
 * item[1409] = {
 *     [handle] = Item: ButtonBar
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getOverview]
 * item[1411] = {
 *     [handle] = Item: AdminIpOverview
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 */
?>