<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
/**
 *
 * @package
 * @subpackage Interface
 * @since 21-09-2007
 * @copyright 2007 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceMenuOrderManager extends InterfaceFactory
{
    /**
     * interface[id] = 177
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceMenuOrderManager(&$db, &$db_app, &$langIf)
    {
        parent::InterfaceFactory($db, $db_app, $langIf);
        if(!defined('TEST_SITE')||!TEST_SITE)
        	throw new InterfacePermissionException('Only use on test sites');

        $this->model['universe'] = $this->model['script'] = false;
		$this->model['group'] = new group(IWRegistry::registry('db'));

        if(!empty($_REQUEST['group']['id'])&&is_numeric($_REQUEST['group']['id']))
        {
        	$this->model['universe'] = $_REQUEST['group']['id'];
			$scripts = array();
    		$q = $this->model['group']->fetchGroupRights($this->model['universe'],1);
    		while($r = $q->fetch())
    			$scripts[$r->SCRIPT_ID] = $r->SCRIPT_ID;
    		$this->model['scripts'] = $scripts;
        }

        if(!empty($_REQUEST['menu']['id'])&&is_numeric($_REQUEST['menu']['id']))
        	$this->model['script'] = $_REQUEST['menu']['id'];


        $this->script = sprintf("
			function setUniverse(sel)
			{
				document.location.href = 'InterfaceMenuOrderManager.php?group[id]='+sel.value;
			}

			function setScript(sel)
			{
				document.location.href = 'InterfaceMenuOrderManager.php?group[id]='+$$('group[id]').value+'&menu[id]='+sel.value;
			}
			function moveUp(script_id)
			{
				$$('process').value = 'move_up';
				$$('use_script[id]').value = script_id;
				$('interface_form').submit();
			}
			function moveToParent(script_id,sel)
			{
				if(!sel.value)
					return;
				MessageBox.prototype.Question('%s','%s',function(){
					$$('process').value = 'movetoparent';
					$$('use_script[id]').value = script_id;
					$('interface_form').submit();
				});
			}
			",
			jstr('MessageBox: MoveToParentWarningTitle'),
			jstr('MessageBox: MoveToParentWarningBody')
			);

        $this->hiddenFields = array(array('name'=>'use_script[id]','value'=>''));

        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';
    }
    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {
        if(empty($_POST['process']))
        	return;
        /*if($_POST['process'] == 'move_up')
        {
        	$sql = "SELECT IFNULL(MAX(SCRIPT_POSITION),'ERROR') as Pos
				FROM TBL_SCRIPT
				WHERE SCRIPT_PARENT_ID = ?
					AND SCRIPT_POSITION < (SELECT SCRIPT_POSITION
							FROM TBL_SCRIPT
							WHERE SCRIPT_ID = ?
								AND SCRIPT_PARENT_ID = ?)";
        	$q = $this->db->query($sql);
        	$q->bind_values($_POST['menu']['id'],$_POST['use_script']['id'],$_POST['menu']['id']);
        	$q->execute();
        	$r = $q->fetch();
        	if($r->Pos == 'ERROR')
        		return $thrownException .= 'Invalid move';

        	$sql = "UPDATE TBL_SCRIPT SET SCRIPT_POSITION = SCRIPT_POSITION + 1
				WHERE SCRIPT_PARENT_ID = ?
					AND SCRIPT_POSITION = ?";
			$q = $this->db->query($sql);
			$q->bind_values($_POST['menu']['id'],$r->Pos);
			$q->execute();

			$sql = "UPDATE TBL_SCRIPT SET SCRIPT_POSITION = ?
				WHERE SCRIPT_PARENT_ID = ?
					AND SCRIPT_ID = ?";
			$q = $this->db->query($sql);
			$q->bind_values($r->Pos,$_POST['menu']['id'],$_POST['use_script']['id']);
			$q->execute();

			header('Location: InterfaceMenuOrderManager.php?group[id]='.$this->model['universe'].'&menu[id]='.$_POST['menu']['id']);
			exit();
        }
        else*/
        if($_POST['process']=='save')
        {
        	$sql = "UPDATE TBL_SCRIPT SET SCRIPT_POSITION = ?
				WHERE SCRIPT_ID = ? AND SCRIPT_PARENT_ID = ?";
			$q = $this->db->query($sql);
			foreach($_POST['position'] as $script_id => $position)
			{
				$q->bind_values($position,$script_id,$this->model['script']);
				$q->execute();
			}
			header('Location: InterfaceMenuOrderManager.php?group[id]='.$this->model['universe'].'&menu[id]='.$this->model['script']);
			exit();
        }
        elseif($_POST['process']=='movetoparent')
        {
        	if(!in_array($_POST['use_script']['id'],$this->model['scripts']))
        		return $thrownException .= 'Invalid move (1)';

        	$id = $_POST['use_script']['id'];
        	if(!in_array($_POST['move'][$id],$this->model['scripts']))
        		return $thrownException .= 'Invalid move (2)';

        	$sql = "SELECT IFNULL(MAX(SCRIPT_POSITION)+1,0) as Pos
				FROM TBL_SCRIPT
				WHERE SCRIPT_PARENT_ID = ?";
			$q = $this->db->query($sql);
			$q->bind_values($_POST['move'][$id]);
			$q->execute();
			$r = $q->fetch();

        	$sql = "UPDATE TBL_SCRIPT SET SCRIPT_PARENT_ID = ?, SCRIPT_POSITION = ?
				WHERE SCRIPT_ID = ? AND SCRIPT_PARENT_ID = ?";
			$q = $this->db->query($sql);
			$q->bind_values($_POST['move'][$id],$r->Pos,$id,$this->model['script']);
			$q->execute();

			header('Location: InterfaceMenuOrderManager.php?group[id]='.$this->model['universe'].'&menu[id]='.$_POST['move'][$id]);
			exit();
        }
    }
}
/**
 * @package
 * @subpackage Interface
 * @since 21-09-2007
 * @copyright 2007 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceMenuOrderManagerItem extends InterfaceItem
{
    /**
     * item[1381] = group[id]
     */
    function getUniverseSelect()
    {
    	$this->options = array(array('text'=>'- '.$this->langIf->getText('Select Universe').' -','value'=>''));
    	$q = $this->if_obj->model['group']->fetchGroup();

    	while($r = $q->fetch())
    	{
    		$opt = array('value'=>$r->GROUP_ID,'text'=>(($r->GROUP_ID == GROUP_CRSO)?strtoupper($r->GROUP_NAME):$r->GROUP_NAME));
    		($this->if_obj->model['universe']==$r->GROUP_ID) && $opt['selected'] = 'selected';
    		$this->options[] = $opt;
    	}

    	$this->properties['onchange'] = 'setUniverse(this);';
    }

    /**
     * item[1379] = menu[id]
     */
    function getMenuSelection()
    {
    	if(!$this->if_obj->model['universe'])
    		return $this->options = array(array('text'=>'- '.$this->langIf->getText('Select Universe First').' -'));

    	$this->options = array(array('text'=>'- '.$this->langIf->getText('Select Menu').' -','value'=>''));

    	/**
    	 * Only Select Parent Menu's
    	 */
    	$sql = "SELECT DISTINCT S.SCRIPT_ID, S.SCRIPT_NAME, IF(S.SCRIPT_PARENT_ID>0,'...','') as PRE
			FROM TBL_SCRIPT as S
			INNER JOIN TBL_SCRIPT as S2
				ON S.SCRIPT_ID = S2.SCRIPT_PARENT_ID
			WHERE S.SCRIPT_MENUITEM = ?
				AND S.SCRIPT_ID IN (".implode(',',$this->if_obj->model['scripts']).")
			GROUP BY S.SCRIPT_ID";
		$q = $this->db->query($sql);
		$q->bind_values(1);
		$q->execute();
		while($r = $q->fetch())
		{
			$opt = array('text'=>$r->PRE.(empty($r->SCRIPT_NAME)?$r->SCRIPT_ID:$r->SCRIPT_NAME),'value'=>$r->SCRIPT_ID);
			($this->if_obj->model['script']==$r->SCRIPT_ID) && $opt['selected'] = 'selected';
			$this->options[] = $opt;
		}

		$this->properties['onchange'] = 'setScript(this);';
    }

    /**
     * item[1380] =
     */
    function getMenuChildren()
    {
    	if(!$this->if_obj->model['universe']||!$this->if_obj->model['script'])
    		return;

    	$this->if_obj->model['parentselect'] = $this->renderParentSelect();

		$sql = "SELECT S.SCRIPT_ID, S.SCRIPT_NAME, S.SCRIPT_POSITION as POSITION, '' as DIFFERENT_PARENT
			FROM TBL_SCRIPT as S
			WHERE SCRIPT_PARENT_ID = ?
			ORDER BY SCRIPT_POSITION";
		$q = $this->db->query($sql);
		$q->bind_values($this->if_obj->model['script']);
		$q->execute();
		$tf = new TableFactory($q,IWRegistry::registry('langIf'));
		$tf->setValueProcessor(TF_ALL,array($this,'tfValueProcessor'));
		$this->text = $tf->getXHTMLTable('Professional',2);
    }

    public function tfValueProcessor($args)
    {
    	switch($args['head'])
    	{
    		case 'POSITION':
    			return sprintf('<input type="text" size="4" name="position[%s]" behaviour="required;integer" value="%s" />',
    				$args['row']['SCRIPT_ID'],
    				$args['value']
    				);
    		break;
    		case 'MOVE_UP':
    			if($args['i']==0)
    				return '';
    			return sprintf('<input type="button" onclick="moveUp(%s);" value="%s" />',
    				$args['row']['SCRIPT_ID'],
    				IWRegistry::registry('langIf')->getText('Move Up')
    				);
    		break;
    		case 'DIFFERENT_PARENT':
    			return sprintf($this->if_obj->model['parentselect'],$args['row']['SCRIPT_ID'],$args['row']['SCRIPT_ID']);
    		break;
    	}
    	return $args['value'];
    }

	protected function renderParentSelect()
	{
		$sql = "SELECT S.SCRIPT_ID, S.SCRIPT_NAME
			FROM TBL_SCRIPT as S
			WHERE S.SCRIPT_ID IN (".implode(',',$this->if_obj->model['scripts']).")
			ORDER BY S.SCRIPT_PARENT_ID, SCRIPT_NAME";
		$q = $this->db->query($sql);
		$q->execute();
		$rv = '<select onchange="moveToParent(%s,this);" name="move[%s]">
			<option value="">- '.IWRegistry::registry('langIf')->getText('Move To Parent').' -</option>
			';

		while($r = $q->fetch())
			$rv .= sprintf('<option value="%s">%s</option>',$r->SCRIPT_ID,$r->SCRIPT_NAME);

		return $rv.'</select>';
	}

	function getButtons()
	{
		$this->_BarButtons = BUTTON_SAVE;
	}
}

/**
 * CALLBACK[getMenuSelection]
 * item[1379] = {
 *     [handle] = Item: SelectMenu
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getMenuChildren]
 * item[1380] = {
 *     [handle] = Item: MenuChildren
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 */
?>
