<?php
require_once(INTERFACE_OBJ."InterfaceFactory.php");

require_once(ELC_CLASSES.'Product.php');
require_once(ELC_CLASSES.'ProductCategory.php');
/**
 *
 *
 * @package ELC
 * @subpackage Interface
 * @author Marten Koedam <marten@basesoft.com>
 * @copyright (2005) BaseSoft B.V.
 * @version $Id$
 */
class InterfaceProductCategoryOverview extends InterfaceFactory
{
	function InterfaceProductCategoryOverview($db, $db_app, $langIf)
	{
		$this->FirstColWidth = 25;
		$this->delimiter = '<br />';
		parent::InterfaceFactory($db, $db_app, $langIf);
	}
}

class InterfaceProductCategoryOverviewItem extends InterfaceItem
{
	/**#@+
	 * Callback functions made from InterfaceItem
	 */
	/**
	 *
	 */
	function getOverview()
	{
		$pc = new ProductCategory($this->db_app);
		$q = $pc->selectOverview();

		$tf = new TableFactory($q,$this->langIf);

		$tf->setSortingFunctions(array('PRODUCT_NAME'=>"'String'",
				'CATEGORY_NAME'=>"'String'"));

		$tf->hideColumns(array('PRODUCT_ID','PRODUCT_CATEGORY_ID'));
		$tf->setCaption('List: Product Category Overview');

		$tf->setValueProcessor('CATEGORY_NAME','return \'<a href="/\'.SITE_PATH.\'scripts/elc/crso/InterfaceProductCategoryTranslate.php?product_category[id]=\'.$row[\'PRODUCT_CATEGORY_ID\'].\'">\'.$value.\'</a>\';');
		$tf->setValueProcessor('CHECKBOX', 'return \'<input type="checkbox" />\';');

		// FIXME
		//$tf->columnize(2);

		$this->text = $tf->getXHTMLTable('Professional',2);
	}
	/**
	 *
	 */
	function getButtons()
	{
		// If you are a CRSO, and you are allowed to do translations, you are not allowed to add new Categories.s
		$this->_BarButtons = BUTTON_DELETE;
		$this->_addCustomButton($this->langIf->getText('New Product Category'),'button', array('onclick'=>"document.location.href='InterfaceProductCategory.php';"));
	}
	/**#@-*/
}