<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
require_once(ELC_CLASSES.'Product.php');
require_once(ELC_CLASSES.'FormBehaviourPlugins.php');
/**
 *
 * @package WEEE
 * @subpackage Interface
 * @author Marten Koedam <marten@dalines.net>
 * @since 23-11-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceProductManagement extends InterfaceFactory
{
    /**
     * interface[id] = 156
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceProductManagement(&$db, &$db_app, &$langIf)
    {
        parent::InterfaceFactory($db, $db_app, $langIf);
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';

        $this->model['product'] = new Product($this->db_app);
        if(isset($_REQUEST['product']['id']))
        {
        	$this->model['product']->set($_REQUEST['product']['id']);
        	$this->hiddenFields = array(array('name'=>'product[id]','value'=>$_REQUEST['product']['id']));
        }

        $this->fb->addPlugin('elc_product_unique', 'FormBehaviourPluginElcProductUnique');
    }
    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {
        if(!isset($_POST['process']))
        	return;

         if( !$this->fb->validate() )
				return $thrownException .= $this->langIf->getText('Please correct the form errors');

        if($_POST['process'] == 'save')
        {
        	//need to trim it here... so we can validate it properly
        	$_POST['product']['name'] = trim($_POST['product']['name']);
        	$product = new Product($this->db_app,$_POST['product']);
        	$product->company_id = $_SESSION['session_user_company_id'];
        	if(isset($_POST['product']['id']))
        		$product->update();
        	else
        		$product->insert();
        	header('Location: InterfaceProductManagement.php');
        	exit();
        }
    }
}
/**
 * @package WEEE
 * @subpackage Interface
 * @since 23-11-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceProductManagementItem extends InterfaceItem
{

    /**
     * item[1151] =
     */
    function getProductOverview()
    {
    	$ds = $this->if_obj->model['product']->getOverview();
    	$tf = new TableFactory($ds,$this->langIf);
    	$tf->setValueProcessor('PRODUCT_ID',array($this,'tfProductLink'));
    	$this->text = $tf->getXHTMLTable('Professional',2);
    }

    function tfProductLink($args)
    {
    	return sprintf('<a href="InterfaceProductManagement.php?product[id]=%s">%s</a>',$args['value'],$args['value']);
    }

    /**
     * item[1152] = product[name]
     */
    function getProductName()
    {
    	$this->properties['value'] = $this->if_obj->model['product']->name;
    }

    /**
     * item[1153] =
     */
    function getButtons()
    {
    	$this->_BarButtons = 0;

    	$trans =  isset($_REQUEST['product']['id'])?'Update Product':'Add Product';
    	$this->_addCustomButton($this->langIf->getText($trans),'submit');
    }

}

/**
 * CALLBACK[getProductOverview]
 * item[1151] = {
 *     [handle] = Item: ProductOverview
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getProductName]
 * item[1152] = {
 *     [handle] = Item: ProductName
 *     [behaviour] = required
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * CALLBACK[getButtons]
 * item[1153] = {
 *     [handle] = Item: ButtonBar
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 1
 *
 */
?>