<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
require_once(ELC_CLASSES.'ELCTaskRunner.php');
/**
 *
 * @package ELC
 * @subpackage Interface
 * @since 15-02-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceScheduler extends InterfaceFactory
{
	/**
	 * interface[id] = 70
	 * @param $db Database (I_WARE_SETTINGS)
	 * @param $db_app Database (APPLICATION DATABASE)
	 * @param $langIf LanguageInterface
	 */
	function InterfaceScheduler($db,$db_app,$langIf)
	{
		parent::InterfaceFactory($db, $db_app,$langIf);
		$this->FirstColWidth = 25;
		$this->delimiter = '<br />';

		if(isset($_REQUEST['task']['id']))
		{
			$this->model['task'] = new DefaultTask($db_app,$_REQUEST['task']['id'],true);
			$this->hiddenFields = array(array('name'=>'task[id]','value'=>$this->model['task']->id));
		}

	}
	/**
	 * @param string $thrownException
	 */
	function processInput(&$thrownException)
	{
		if(isset($_POST['process']))
		{
			if($_POST['process'] == 'save')
			{

		        if(!$this->fb->validate())
		        	return $thrownException .= $this->langIf->getText('Please correct the form errors');

				$class = $_POST['task']['task_name'];
				if(!is_file(TASKS.APP_PATH.$class.'.php'))
					return $thrownException .= $this->langIf->getText('Not a Valid Task supplied');

				require_once(TASKS.APP_PATH.$class.'.php');
				$task = new $class($this->db_app);
				if(isset($this->model['task']))
					$task->id = $this->model['task']->id;

				$tr = new ELCTaskRunner($this->db_app, false);
				$id = $tr->schedule($task,$class,$_POST['task']['schedule_mask']);

				if(isset($this->model['task'])){
					header('Location: /'.SITE_PATH.'scripts/elc/'.$_SESSION['session_group_group_name'].'/InterfaceScheduler.php?task[id]=' . $this->model['task']->id);
				} else {
					header('Location: /'.SITE_PATH.'scripts/elc/'.$_SESSION['session_group_group_name'].'/InterfaceScheduler.php?task[id]=' . $id);
				}
				exit();
			}
		}
	}
}
/**
 * @package ELC
 * @subpackage Interface
 * @since 15-02-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceSchedulerItem extends InterfaceItem
{

	/**
	 * item[652] = task[task_name]
	 */
	function getTaskTypeSelect()
	{
		$tasks = ELCTaskRunner::getTaskTypes();
		$this->options = array(array('text'=>'- '.$this->langIf->getText('Select A Task').' -'));

		$selectedTask = isset($this->if_obj->model['task'])?$this->if_obj->model['task']->task_name:false;

		foreach($tasks as $className => $desc)
			$this->options[] = array('text'=>$desc,'value'=>$className,'selected'=>($className===$selectedTask));
	}

	/**
	 * item[653] = task[schedule_mask]
	 */
	function getScheduleMask()
	{
		$this->properties['value'] = isset($this->if_obj->model['task'])?$this->if_obj->model['task']->schedule_mask:'* * * * * *';
	}

	/**
	 * item[654] =
	 */
	function getButtons()
	{
		$this->_BarButtons = BUTTON_SAVE;
	}

}
?>
