<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
require_once(IWARE.'group.php');
require_once(IWARE.'nLanguage.php');
require_once(ELC_CLASSES.'ELCGroupLanguage.php');

define('BLOCK_LANGUAGE_SELECT',354);
define('ITEM_LANGUAGE_SELECT',1079);

/**
 * @package ELC
 * @subpackage Interface
 * @since 29-aug-2006
 * @author Marten Koedam <marten@dalines.net>
 * @version $Id$
 * @copyright 2006 BaseSoft B.V.
 */
class InterfaceUniverseLanguage extends InterfaceFactory
{
    /**
     * interface[id] = 144
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceUniverseLanguage(&$db, &$db_app, &$langIf)
    {
        parent::InterfaceFactory($db, $db_app, $langIf);
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';
    }

    function _filter($q)
    {
    	$rv = parent::_filter($q);

    	if(empty($_REQUEST['group_id']))
    		unset($rv[$this->id][BLOCK_LANGUAGE_SELECT][ITEM_LANGUAGE_SELECT]);

    	return $rv;
    }

    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {
        if(isset($_POST['process']))
        {
        	if($_POST['process'] == 'save')
        	{
        		$gl = new ELCGroupLanguage($this->db_app, array('group_id'=>$_REQUEST['group_id']));
        		$gl->removeAllForGroup();
        		foreach($_POST['languages'] as $language_id)
        		{
        			$gl->language = new nLanguage($this->db_app,$language_id);
        			$gl->insert();
        		}
        		$this->init($this->id);
        	}
        }
    }
}
/**
 * @package ELC
 * @subpackage Interface
 * @since 29-08-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceUniverseLanguageItem extends InterfaceItem
{

    /**
     * item[1078] = group_id
     */
    function getUniverseSelect()
    {
    	$selectedGroup = isset($_REQUEST['group_id'])?$_REQUEST['group_id']:false;
    	$this->options = array(array('value'=>'','text'=>'- '.$this->langIf->getText('Select Universe').' -'));
    	$sql = "SELECT GROUP_ID, GROUP_NAME
			FROM TBL_GROUP
			ORDER BY GROUP_NAME";
		$q = $this->db_app->query($sql);
		$q->execute();
		$i = 1;
		while($r = $q->fetch())
		{
			$group = ($r->GROUP_NAME=='Crso')?'CRSO':ucfirst($r->GROUP_NAME);
			$this->options[$i] = array('text'=>$group,'value'=>$r->GROUP_ID);
			if($r->GROUP_ID == $selectedGroup)
				$this->options[$i]['selected'] = 'selected';
			$i++;
		}

		$this->properties['onchange'] = "_LoadLanguageSelect(this);";

	    $this->postscript = "
		    function _LoadLanguageSelect(el)
		    {
		        var params = new Array();
		        params['group_id'] = el.value;
		        params['interface_id'] = ".$this->if_obj->id."; // you MUST supply this
		        ifHandler.loadBlock( new Array(new String('".BLOCK_LANGUAGE_SELECT."')), params );
		    }";
    }

    /**
     * item[1079] = languages
     */
    function getFancyLanguageSelect()
    {
    	// BUTTONS
    	$props = array('class'=>'button');
    	$this->fancyHeaders = array(0=>$this->langIf->getText('Active Languages'),1=>'',2=>$this->langIf->getText('Selected Languages'));
		$this->fancybuttons = array('right'=>$props, 'left'=>$props, 'allRight'=>$props, 'allLeft'=>$props);//, 'up'=>$props, 'down'=>$props);
		$this->properties['size'] = 8;
		$this->properties['style'] = 'width: 50ex;';

		$status = in_array($_REQUEST['group_id'],array(GROUP_SYSADMIN,GROUP_CRSO))?LANGUAGE_STATUS_ENABLED+LANGUAGE_STATUS_SELECTABLE:LANGUAGE_STATUS_ENABLED;
		$gl = new ELCGroupLanguage($this->db_app, array('group_id'=>$_REQUEST['group_id']));
		$langArray = $gl->getEnabledLanguages();
		$langArray[] = -1;

		$lang = new nLanguage($this->db_app);
		$q = $lang->getByStatus($status);
		$this->options = array();
		while($r = $q->fetch())
		{
			if(in_array($r->LANGUAGE_ID,$langArray))
				continue;
			$this->options[] = array('text'=>$r->LANGUAGE,'value'=>$r->LANGUAGE_ID);
		}

		$q = $lang->getLanguageNames($langArray);
		$this->selectedoptions = array();
		while($r = $q->fetch())
			$this->selectedoptions[] = array('text'=>$r->LANGUAGE,'value'=>$r->LANGUAGE_ID);
    }

	function getButtons()
	{
		$this->_BarButtons = BUTTON_SAVE;
	}
}

/**
 * CALLBACK[getUniverseSelect]
 * item[1078] = {
 *     [handle] = Item: SelectUniverse
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getFancyLanguageSelect]
 * item[1079] = {
 *     [handle] = Item: LanguageSelect
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 */
?>
