<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
require_once(IWARE.'UserRestriction.php');
require_once(ELC_CLASSES.'User.php');
/**
 *
 * @package
 * @subpackage Interface
 * @since 05-09-2007
 * @author Marten Koedam <marten@dalines.net>
 * @copyright 2007 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceUserIP extends InterfaceFactory
{
    /**
     * interface[id] = 175
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceUserIP(&$db, &$db_app, &$langIf)
    {
        parent::InterfaceFactory($db, $db_app, $langIf);
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';

        $this->script = "
			function deleteIP()
			{
				$$('process').value = 'delete';
				$('interface_form').submit();
			}
			";
    }
    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {
        if(empty($_POST['process']))
        	return;

        if($_POST['process']=='save')
        {
        	if(!$this->fb->validate())
        		return $thrownException .= IWRegistry::registry('langIf')->getText('Please correct the form errors');

        	$ur = new UserRestriction($this->db_app);
        	$ur->user = new ELCUser($this->db_app,$_POST['user']['id']);
        	$ur->ip = $_POST['user']['ip'];
        	$ur->insert();
        	header('Location: InterfaceUserIP.php');
        	exit();
        }

        if($_POST['process']=='delete')
        {
        	$ur = new UserRestriction($this->db_app);
        	foreach($_POST['ur'] as $user_id => $values)
        	{
        		$ur->user = new ELCUser($this->db_app,$user_id);
        		foreach($values as $ip)
        		{
        			$ur->ip = $ip;
        			$ur->delete();
        		}
        	}
        	header('Location: InterfaceUserIP.php');
        	exit();
        }
    }
}
/**
 * @package
 * @subpackage Interface
 * @since 05-09-2007
 * @copyright 2007 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceUserIPItem extends InterfaceItem
{

    /**
     * item[1353] = user[id]
     */
    function getUserSelect()
    {
    	$this->options = array(array('text'=>'- '.$this->langIf->getText('Select User').' -','value'=>''));
    	$u = new ELCUser($this->db_app);
    	$q = $u->getUsers();
    	$row = $q->fetchAll();
    	foreach($row as $r)
    	{
    		$name = str_pad($r->USER_NAME,12,' ');
    		$name = str_replace(' ','&nbsp;',$name);
    		$r->EMAIL && $name .= sprintf(' &lt;%s&gt;',$r->EMAIL);
    		$this->options[] = array('text'=>$name,'value'=>$r->USER_ID,'style' => 'font-family: monospace;font-size: 8pt;');
    	}
    }

    /**
     * item[1354] = user[ip]
     */
    function getIPAddress()
    {
    	$this->properties['size'] = '25';
    }

    /**
     * item[1356] =
     */
    function getButtons()
    {
    	$this->_BarButtons = BUTTON_SAVE;
    }

    /**
     * item[1357] =
     */
    function getUserIPOverview()
    {
    	$ur = new UserRestriction($this->db_app);
    	$ds = $ur->getOverview();
    	$tf = new TableFactory($ds,IWRegistry::registry('langIf'));
    	$tf->setCaption('User IP Restriction overview');

    	$tf->setSortingFunctions(array(
			'USER_NAME'=>"'String'",
			'INFO_PERSON_EMAIL'=>"'String'",
			'IP_ADDRESS'=>"'String'"
			));

		$tf->collapseColumns(array('USER_NAME','INFO_PERSON_EMAIL'));
		$tf->setValueProcessor(TF_ALL,array($this,'tfValueProcessor'));
		$tf->hideColumns(array('USER_ID'));

    	$this->text = $tf->getXHTMLTable('Professional',2);
    }

    function tfValueProcessor($args)
    {
    	switch($args['head'])
    	{
    		case 'Remove':
    			return sprintf('<input type="checkbox" name="ur[%s][]" value="%s" />',
    				$args['row']['USER_ID'],
    				$args['row']['IP_ADDRESS']
    				);
    		break;
    	}
    	return $args['value'];
    }

	/**
	 * item[1358] =
	 */
	function getOverviewButtons()
	{
		$this->_BarButtons = BUTTON_DELETE;
		$this->_ButtonOptions[BUTTON_DELETE]['onclick'] = 'deleteIP();';
	}
}

/**
 * CALLBACK[getUserSelect]
 * item[1353] = {
 *     [handle] = Item: UserSelect
 *     [behaviour] = required
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * CALLBACK[getIPAddress]
 * item[1354] = {
 *     [handle] = Item: IPAddress
 *     [behaviour] = ipaddress
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[get2colTxt]
 * item[1355] = {
 *     [handle] = Item: Spacer1
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * CALLBACK[getButtons]
 * item[1356] = {
 *     [handle] = Item: ButtonBar
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getUserIPOverview]
 * item[1357] = {
 *     [handle] = Item: UserIPOverview
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 */
?>