<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
/**
 *
 * @package I-Ware
 * @subpackage Interface
 * @since 02-03-2006
 * @author Marten Koedam <marten@basesoft.com>
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceFAQ extends InterfaceFactory
{
    /**
     * interface[id] = 79
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceFAQ(&$db, &$db_app, &$langIf)
    {
        parent::InterfaceFactory($db, $db_app, $langIf);
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';
    }
    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {

    }
}
/**
 * @package I-Ware
 * @subpackage Interface
 * @since 02-03-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceFAQItem extends InterfaceItem
{

    /**
     * item[728] =
     */
    function getOverview()
    {
		require_once(IWARE.'FAQ.php');
		require_once(IWARE.'FAQSection.php');

		$this->text = '<div id="ifI_'.$this->id.'"></div>';
		$this->script = '

			QuestionNode = function(title,faqId)
			{
				NavigationNode.apply(this,[title]);
				this.negerinBehaviour = function()
				{
					ifHandler.loadBlock([206],\'&interface_id=83&faq[id]=\'+faqId);
				}
			}
			QuestionNode.prototype = new NavigationNode(\'\');

			var faqNode = new NavigationNode(\'SectionList\',\'\',true, ['."\n";
		$fs = new FAQSection($this->db_app);
		$q = $fs->getSectionsByGroup(null,$_SESSION['selected_product_id']);
		while($r = $q->fetch())
		{
			$fs->set($r->FAQ_SECTION_ID,$_SESSION['session_user_language_id']);
			if(sizeof($fs->faqs))
			{
				$this->script .= "\t".'new NavigationNode(\''.jsescape($fs->section_lang->title,"'").'\', \'\', false, ['."\n";
				foreach($fs->faqs as $faq)
					$this->script .= "\t\t".'new QuestionNode(\''.jsescape($faq->lang->question_text,"'").'\', '.$faq->id.'),'."\n";
				$this->script = substr($this->script,0,-2)."\n\t".']),'."\n";
			}
		}

		$this->script = substr($this->script,0,-2)."\n".']);';
		$this->postscript = 'faqNode.display($(\'ifI_'.$this->id.'\'));';
    }

    /**
	 * InterfaceItem
     * item[729] =
     */
    function getAnswerOverview()
    {

    }
}

/**
 * CALLBACK[getOverview]
 * item[728] = {
 *     [handle] = Item: FAQOverview
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 */
?>