<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
require_once(IWARE.'FAQ.php');
require_once(IWARE.'FAQSection.php');
require_once(IWARE.'nLanguage.php');
require_once(ELC_CLASSES.'Product.php'); // EEEP!
/**
 *
 * @package I-Ware
 * @subpackage Interface
 * @author Marten Koedam <marten@basesoft.com>
 * @since 01-03-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceFAQManagement extends InterfaceFactory
{
    /**
     * interface[id] = 78
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceFAQManagement(&$db, &$db_app, &$langIf)
    {
        parent::InterfaceFactory($db, $db_app, $langIf);
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';

		$this->faq = new FAQ($db_app);
		$this->faq_section = new FAQSection($db_app);
    }
    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {
        if(isset($_POST['process']))
		{
			if($_POST['process'] == 'save')
			{

		        if(!$this->fb->validate())
		        	return $thrownException .= $this->langIf->getText('Please correct the form errors');

				$this->db_app->begin();

				$fq = new FAQSection($this->db_app,$_POST['section']);
				$fq->default_language = new nLanguage($this->db_app,$_POST['section_lang']['language']);
				$fq->product = new Product($this->db_app,$_SESSION['selected_product_id']);
				if(!empty($_POST['section']['id']))
				{
					unset($fq->default_language);
					$fq->update();
				}
				else
				{
					unset($fq->id);
					$fq->insert();
				}

				$sl = new FAQSectionLang($this->db_app,$_POST['section_lang']);
				$sl->section =& $fq;
				$sl->language = new nLanguage($this->db_app,$_POST['section_lang']['language']);
				$sl->objectmap['inserttype'] = 'REPLACE';
				$sl->insert();

				if(isset($_POST['section_group']['group_id']))
				{
					$gs = new GroupFAQSection($this->db_app, array('section'=>$fq));
					$gs->deleteFromSection();
					foreach($_POST['section_group']['group_id'] as $group_id)
					{
						$gs->group_id = $group_id;
						$gs->insert();
						// Delete from APC cache
						if(function_exists('apc_store'))
						{
							$lookup = 'showFAQ'.$group_id.'_'.$_SESSION['selected_product_id'].'_'.APC_SUFFIX;
							apc_delete($lookup);
						}
					}
				}
				if(isset($_POST['faq']['id'])&&!empty($_POST['faq']['handle']))
				{
					$faq = new FAQ($this->db_app,$_POST['faq']);
					$faq->section =& $fq;
					if(!empty($_POST['faq']['id']))
						$faq->update();
					else
					{
						unset($faq->id);
						$faq->insert();
					}

					$fl = new FAQLang($this->db_app,$_POST['faq_lang']);
					$fl->faq =& $faq;
					$fl->language =& $sl->language;
					$fl->objectmap['inserttype'] = 'REPLACE';
					$fl->insert();
				}

				$this->db_app->commit();
			}
			unset($this->models);
			$this->init($this->id);
		}
    }
}
/**
 * @package I-Ware
 * @subpackage Interface
 * @since 01-03-2006
 * @author Marten Koedam <marten@basesoft.com>
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceFAQManagementItem extends InterfaceItem
{

    /**
     * item[711] = section[id]
     */
    function getSectionSelect()
    {
		$fs = $this->parent->parent->faq_section;
		$q = $fs->getSections($_SESSION['selected_product_id']);

		$this->options = array(array('text'=>'- '.$this->langIf->getText('New FAQ Section').' -','value'=>''));

		$i = 1;
		while($r = $q->fetch())
		{
			$this->options[$i] = array('text'=>$r->HANDLE,'value'=>$r->FAQ_SECTION_ID);
			if(isset($_REQUEST['section']['id'])&& $_REQUEST['section']['id']==$r->FAQ_SECTION_ID)
				$this->options[$i]['selected'] = 'selected';
			$i++;
		}
		$this->properties['onchange'] = 'ifHandler.loadBlock([202,203],\'&interface_id='.$this->parent->parent->id.'&section[id]=\'+this.options[this.selectedIndex].value+\'&section_lang[language][id]=\'+$$(\'section_lang[language][id]\').value+\'&show_language[id]=\'+$$(\'show_language[id]\').value);';
    }

    /**
     * item[712] = section_group[group_id]
     */
    function getGroupSelect()
    {
		$permissions = array();
		if(!empty($_REQUEST['section']['id']))
		{
			$gs = new GroupFAQSection($this->db_app);
			$q = $gs->getGroups($_REQUEST['section']['id']);
			while($r = $q->fetch())
				$permissions[] = $r->GROUP_ID;
		}
		require_once(IWARE.'group.php');
		$g = new Group($this->db_app);
		$q = $g->fetchGroup($_SESSION['session_user_company_id']); // FIXME exclude groups that this user has no rights for

		$this->properties['multiple'] = 'multiple';
		$this->properties['size'] = 6;
		$this->options = array(array('text'=>'- '.$this->langIf->getText('None').' -','value'=>''));
		$i = 1;
		while($r = $q->fetch())
		{
			$this->options[$i] = array('text'=>$r->GROUP_NAME,'value'=>$r->GROUP_ID);
			if(in_array($r->GROUP_ID, $permissions))
				$this->options[$i]['selected'] = 'selected';
			$i++;
		}
    }

    /**
     * item[713] = section[handle]
     * item[717] = section_lang[title]
     * item[721] = faq[handle]
     * item[723] = faq_lang[question_text]
     */
    function getItemValue()
    {
		if(!empty($_REQUEST['section']['id']))
		{
			if(!isset($this->parent->parent->models['section']))
			{
				$fs = $this->parent->parent->faq_section;
				$lang = isset($_REQUEST['section_lang']['language']['id'])?$_REQUEST['section_lang']['language']['id']:$_SESSION['session_user_language_id'];
				$fs->set($_REQUEST['section']['id'],$lang,false);
				$section_lang = new FAQSectionLang($this->db_app);
				$section_lang->set($_REQUEST['section']['id'],$lang);

				$this->parent->parent->section_lang = (array) $section_lang;
				$this->parent->parent->models['section'] = $this->parent->parent->section = (array) $fs;

				if(!empty($_REQUEST['faq']['id']))
				{
					$f = new FAQ($this->db_app);
					$f->set($_REQUEST['faq']['id'],$lang,false);
					$language = new FAQLang($this->db_app);
					$language->set($_REQUEST['faq']['id'],$lang);

					$this->parent->parent->faq = (array) $f;
					$this->parent->parent->faq_lang = (array) $language;
				}
				else
				{
					$this->parent->parent->faq = array();
					$this->parent->parent->faq_lang = array();
				}
			}
			$name = str_replace('[','[\'',str_replace(']','\']',$this->name));
			eval('$this->properties[\'value\'] = isset($this->parent->parent->'.$name.')?$this->parent->parent->'.$name.':\'\';');
		}
    }

    /**
     * item[714] =
     * item[720] =
     * item[722] =
     */
    function get2colTxt()
    {
		$this->twoCols = true;
    }

    /**
     * item[715] = section_lang[language][id]
     * item[716] = show_language[id]
     */
    function getLanguageSelect()
    {
		require_once(IWARE.'nLanguage.php');
		$lang = new nLanguage($this->db_app);
		$q = $lang->get();
		$this->options = array(array('value'=>'','text'=>'- '.$this->langIf->getText('Select language').' -'));
		$i = 1;
		while($r = $q->fetch())
		{
			$this->options[$i] = array('text'=>$r->LANGUAGE,'value'=>$r->LANGUAGE_ID);
			if($this->name=='section_lang[language][id]')
			{
				if(isset($_REQUEST['section_lang']['language']['id'])&&($r->LANGUAGE_ID == $_REQUEST['section_lang']['language']['id']))
					$this->options[$i]['selected'] = 'selected';
				elseif(!isset($_REQUEST['section_lang']['language']['id'])&&($r->LANGUAGE_ID == $_SESSION['session_user_language_id']))
					$this->options[$i]['selected'] = 'selected';
			}
			elseif($this->name=='show_language[id]')
			{
				if(isset($_REQUEST['show_language']['id'])&&($r->LANGUAGE_ID == $_REQUEST['show_language']['id']))
					$this->options[$i]['selected'] = 'selected';
				elseif(!isset($_REQUEST['show_language']['id'])&&($r->LANGUAGE_ID == $_SESSION['session_user_language_id']))
					$this->options[$i]['selected'] = 'selected';
			}
			$i++;
		}
		$this->properties['onchange'] = 'ifHandler.loadBlock(new Array(202,203),\'&interface_id='.$this->parent->parent->id.'&section[id]=\'+$$(\'section[id]\').value+\'&faq[id]=\'+$$(\'faq[id]\').value+\'&section_lang[language][id]=\'+$$(\'section_lang[language][id]\').value+\'&show_language[id]=\'+$$(\'show_language[id]\').value);';
    }

    /**
     * item[718] = show_title
     */
    function getShowTitle()
    {
		if(!empty($_REQUEST['section']['id']))
		{
			if(!isset($this->parent->parent->models['show_lang']))
			{
				$section_lang = new FAQSectionLang($this->db_app);
				$section_lang->set($_REQUEST['section']['id'],$_REQUEST['show_language']['id']);
				$this->parent->parent->models['show_lang'] =& $section_lang;
			}
			$this->properties['value'] = $this->parent->parent->models['show_lang']->title;
		}
		$this->properties['readonly'] = 'readonly';
    }

	/**
     * item[724] = show_question_text
	 */
	function getShowQuestionText()
    {
		if(!empty($_REQUEST['faq']['id']))
		{
			if(!isset($this->parent->parent->show_faq_lang))
			{
				$lang = new FAQLang($this->db_app);
				$lang->set($_REQUEST['faq']['id'],$_REQUEST['show_language']['id']);
				$this->parent->parent->models['show_faq_lang'] =& $lang;
			}
			$this->properties['value'] = $this->parent->parent->models['show_faq_lang']->question_text;
		}
		$this->properties['readonly'] = 'readonly';
    }

    /**
     * item[726] = show_answer_text
     */
    function getShowFAQAnswer()
    {
		if(!empty($_REQUEST['faq']['id']))
		{
			if(!isset($this->parent->parent->models['show_faq_lang']))
			{
				$lang = new FAQLang($this->db_app);
				$lang->set($_REQUEST['faq']['id'],$_REQUEST['show_language']['id']);
				$this->parent->parent->models['show_faq_lang'] =& $lang;
			}
			$this->text = $this->parent->parent->models['show_faq_lang']->answer_text;
		}
    }

    /**
     * item[719] = faq[id]
     */
    function getFAQSelect()
    {
		$this->options = array(array('text'=>'- '.$this->langIf->getText('New FAQ').' -', 'value'=>''));

		$fs = $this->parent->parent->faq_section;
		if(!isset($_REQUEST['section']['id']))
			return false;
		$fs->set($_REQUEST['section']['id']);
		$i = 1;
		foreach($fs->faqs as $faq)
		{
			$this->options[$i] = array('text'=>$faq->handle,'value'=>$faq->id);
			if(isset($_REQUEST['faq']['id']) && $_REQUEST['faq']['id']==$faq->id)
				$this->options[$i]['selected'] = 'selected';
			$i++;
		}
		$this->properties['onchange'] = 'ifHandler.loadBlock(new Array(\'203\'),\'&interface_id='.$this->parent->parent->id.'&section[id]=\'+$$(\'section[id]\').value+\'&faq[id]=\'+$$(\'faq[id]\').value+\'&section_lang[language][id]=\'+$$(\'section_lang[language][id]\').value+\'&show_language[id]=\'+$$(\'show_language[id]\').value);';
    }

    /**
     * item[725] = faq_lang[answer_text]
     */
    function getFAQAnswer()
    {
		$this->getItemValue();
		if(isset($this->parent->parent->faq_lang['answer_text']))
		{
			$this->value = $this->parent->parent->faq_lang['answer_text'];
		}
		$this->is_tiny_mce = true;
		$this->width = '50%';
		$this->properties['style'] = 'width: 350px; height: 200px;';

		$this->tiny_mce_settings['theme_advanced_buttons1'] = "bold,italic,underline,forecolor,backcolor,separator,bullist,numlist,separator,undo,redo";
		$this->tiny_mce_settings['theme_advanced_buttons2'] = "";
		$this->tiny_mce_settings['theme_advanced_buttons3'] = "";
    }

	function getButtons()
	{
		$this->_BarButtons = BUTTON_SAVE;
	}
}

/**
 * CALLBACK[getSectionSelect]
 * item[711] = {
 *     [handle] = Item: FAQSectionSelection
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * CALLBACK[getGroupSelect]
 * item[712] = {
 *     [handle] = Item: GroupRights
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 1
 *
 * CALLBACK[getItemValue]
 * item[713] = {
 *     [handle] = Item: SectionHandle
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * item[717] = {
 *     [handle] = Item: SectionTitle
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * item[721] = {
 *     [handle] = Item: FAQHandle
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * item[723] = {
 *     [handle] = Item: FAQQuestion
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * item[724] = {
 *     [handle] = Item: ShowQuestionText
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[get2colTxt]
 * item[714] = {
 *     [handle] = Item: Spacer
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * item[720] = {
 *     [handle] = Item: Spacer
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * item[722] = {
 *     [handle] = Item: Spacer
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getLanguageSelect]
 * item[715] = {
 *     [handle] = Item: TranslateLanguage
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * item[716] = {
 *     [handle] = Item: ShowLanguage
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getShowTitle]
 * item[718] = {
 *     [handle] = Item: ShowTitle
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getFAQSelect]
 * item[719] = {
 *     [handle] = Item: FAQSelect
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 4
 *
 * CALLBACK[getFAQAnswer]
 * item[725] = {
 *     [handle] = Item: FAQAnswer
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 0
 *     [label_pos] = 1
 *
 * CALLBACK[getShowFAQAnswer]
 * item[726] = {
 *     [handle] = Item: ShowAnswerText
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 1
 *
 */
?>