<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
require_once(IWARE.'group.php');

/**
 *
 * @package I-Ware
 * @subpackage Interface
 * @author Martijn van den Broek <martijn@basesoft.com>
 * @since 17-03-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceLanguageExport extends InterfaceFactory
{
    /**
     * interface[id] = 91
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfaceLanguageExport(&$db, &$db_app, &$langIf)
    {
        parent::InterfaceFactory($db, $db_app, $langIf);
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';

        if(isset($_REQUEST['file']))
		{
			$this->script = "
				addEvent(window,'load',function(){
					".jsMessageBox(MSG_BOX_INFO, 'Import Success','Import of <b>'.
						$_REQUEST['file'].'</b> success: '.$_REQUEST['affected'].' rows affected',
						'function(){
						//document.location.href="/'.SITE_PATH.'scripts/elc/sysadmin/InterfaceLanguageExport.php";
						}')."});";
		}
    }
    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {
        if (isset($_POST['process']) && $_POST['process'] == 'export')
        {
        	$groups = 0; foreach ($_REQUEST['groups'] as $group)
        		$groups += $group;
        	try
        	{
        		$option = $_REQUEST['export_options'];
        		if($option == 1)
	            	$csv = $this->langIf->exportCsv($_REQUEST['baselanguage'], $_REQUEST['destlanguages'], $groups, !empty($_REQUEST['outofdate']));
	            else if($option == 2)
	                $csv = $this->langIf->exportCsvFAQs($_REQUEST['baselanguage'], $_REQUEST['destlanguages']);
	            else if($option == 3)
	                $csv = $this->langIf->exportCsvEmails($_REQUEST['baselanguage'], $_REQUEST['destlanguages']);
        	    else throw new IWUserException('Unknown export option');
        	}
        	catch (Exception $e)
        	{
        		$thrownException = $e->getMessage();
        		return;
        	}

        	if (!headers_sent()) {
        		header('Content-type: text/csv');
        		if($option == 1)
        			header('Content-Disposition: attachment; filename="Translations_'.$_REQUEST['baselanguage'].'_'.implode('-', $_REQUEST['destlanguages']).'.csv"');
        	    else if($option == 2)
        	    	header('Content-Disposition: attachment; filename="FAQs_'.$_REQUEST['baselanguage'].'_'.implode('-', $_REQUEST['destlanguages']).'.csv"');
        	    else if($option == 3)
        	    	header('Content-Disposition: attachment; filename="Emails_'.$_REQUEST['baselanguage'].'_'.implode('-', $_REQUEST['destlanguages']).'.csv"');
        	}
            echo $csv->getString();
            die();
        }

        if (isset($_POST['process']) && $_POST['process'] == 'import')
        {
        	if(empty($_FILES['import_file']['tmp_name'])) throw new IWUserException('No file is uploaded');
        	if(stripos($_FILES['import_file']['name'],"Translations") !== false)
				$affected = $this->langIf->importCsv($_FILES['import_file']['tmp_name']);
			else if(stripos($_FILES['import_file']['name'],"FAQs") !== false)
					$affected = $this->langIf->importCsvFAQorEmail($_FILES['import_file']['tmp_name'],'FAQ');
			else if(stripos($_FILES['import_file']['name'],"Emails") !== false)
					$affected = $this->langIf->importCsvFAQorEmail($_FILES['import_file']['tmp_name'],'Email');
			else throw new IWUserException('File name not correct!');
			$file = substr($_FILES['import_file']['name'],0,-4);
		header('Location: InterfaceLanguageExport.php?file='.$file.'&affected='.$affected);
			exit();
        }
    }
}
/**
 * @package I-Ware
 * @subpackage Interface
 * @since 17-03-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfaceLanguageExportItem extends InterfaceItem
{

    /**
     * item[780] = baselanguage
     */
    function getBaseLanguage($select_lang=44)
    {
    	$sql = "SELECT * FROM TBL_LANGUAGE ORDER BY LANGUAGE";
    	$q = $this->db_app->query($sql);
    	$q->execute();

    	while ($row = $q->fetch())
    		$this->options[] = array('text'=>$row->LANGUAGE, 'value'=>$row->LANGUAGE_ID, 'selected'=> ($row->LANGUAGE_ID == $select_lang) ? 'selected' : '' );

    }

    /**
     * item[781] = destlanguage
     */
    function getDestLanguage()
    {
    	$this->getBaseLanguage(49);
    }

    /**
     * item[782] =
     */
    function getButtons()
    {
		$this->_BarButtons = 0;
		$this->_addCustomButton('Export', 'button', array('onclick'=>"$('interface_form').process.value='export'; $('interface_form').submit(); "));
	}

	function getButtonsImport()
    {
		$this->_BarButtons = 0;
		$this->_addCustomButton('Import', 'button', array('onclick'=>"$('interface_form').process.value='import'; $('interface_form').submit(); "));
	}

    function getGroupDesc()
    {
		$this->text = 'Select groups';
    }


    function getGroups()
    {
		$html = '';
    	foreach (Group::getGroups() as $bit => $value)
    	{
    		$chk = new Form_Checkbox('groups[]', $bit, true);
    		$chk->setLabel($value);
    		$html .= $chk->getHtml();
    	}

    	$this->text = $html;
    }

    function getOutOfDate()
    {
    	$this->checked = true;
    }

    /*
     * Item[1377] =
    */
    function getExportOptions()
    {
    	$this->options[] = array('text'=>" - Export What - ", 'value'=>"", 'selected'=>'selected');
		$this->options[] = array('text'=>" Translations ", 'value'=>"1");
		$this->options[] = array('text'=>" FAQs ", 'value'=>"2");
		$this->options[] = array('text'=>" Emails ", 'value'=>"3");
    }

}

/**
 * CALLBACK[getBaseLanguage]
 * item[780] = {
 *     [handle] = Item: BaseLanguage
 *     [behaviour] = required
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getDestLanguage]
 * item[781] = {
 *     [handle] = Item: DestLanguage
 *     [behaviour] = required
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 1
 *
 * CALLBACK[getButtons]
 * item[782] = {
 *     [handle] = Item: ButtonBar
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 */
?>
