<?php
require_once(INTERFACE_OBJ."InterfaceFactory.php");
/**
 * InterfaceOrder
 *
 * @package I-Ware
 * @subpackage Interface
 * @author Marten Koedam <marten@basesoft.com>
 * @copyright (2005) BaseSoft B.V.
 * @since 08-11-2005
 * @version $Id$
 */
class InterfaceOrder extends InterfaceFactory
{
	/**
	 * @param Database $db IWARE Database
	 * @param Database $db_app APPLICATION Database
	 * @param LanguageInterface $langIf
	 */
	function InterfaceOrder($db, $db_app, $langIf='')
	{
		parent::InterfaceFactory($db, $db_app, $langIf);
		$this->FirstColWidth = 30;
		$this->delimiter = '<br />';
	}
	/**
	 * @param string $thrownException
	 */
	function processInput(&$thrownException)
	{
		if(isset($_POST['process']))
		{
			$type = ($_REQUEST['type']=='block')?'BLOCK':'ITEM';
			$queryId = ($type=='BLOCK')?'INTERFACE':'BLOCK';
			$sql = "UPDATE TBL_INTERFACE_".$type."
				SET POSITION = POSITION + 100
				WHERE ".$queryId."_ID = ?";
			$q = $this->db->query($sql);
			$q->bind_values(array($_REQUEST['id']));
			$q->execute();

			$sql = "UPDATE TBL_INTERFACE_".$type."
				SET POSITION = ?
				WHERE ".$queryId."_ID = ? AND ".$type."_ID = ?";
			$q = $this->db->query($sql);
			foreach($_POST['orderValues'] as $pos => $id)
			{
				$q->bind_values(array($pos,$_REQUEST['id'],$id));
				$q->execute();
			}
			$this->init(11);
		}
	}
}
/**
 * InterfaceParticipantSignup
 *
 * @package I-Ware
 * @subpackage Interface
 * @author Marten Koedam <marten@basesoft.com>
 * @copyright (2005) BaseSoft B.V.
 * @since 8-11-2005
 * @version $Id$
 */
class InterfaceOrderItem extends InterfaceItem
{
	/**#@+
	 * Item callback functions
	 */
	/**
	 * Get the available item
	 */
	function getAvailableItems()
	{
		$type = ($_REQUEST['type']=='block')?'BLOCK':'ITEM';
		$queryId = ($type=='BLOCK')?'INTERFACE':'BLOCK';
		$sql = "SELECT ".$type."_ID, HANDLE
			FROM TBL_INTERFACE_".$type."
			WHERE ".$queryId."_ID = ? ORDER BY POSITION";
		$q = $this->db->query($sql);
		$q->bind_values(array($_REQUEST['id']));
		$q->execute();
		while($r = $q->fetch())
			$this->options[] = array('text'=>$r->HANDLE, 'value'=>$r->{$type.'_ID'});

		$this->properties['id'] = 'order_selected';
		$this->properties['size'] = count($this->options);
		$this->hiddenFields[] = array('name'=>'type','value'=>$_REQUEST['type']);
		$this->hiddenFields[] = array('name'=>'id','value'=>$_REQUEST['id']);
	}
	/**
	 * Get the buttons for the current interface
	 */
	function getButtons()
	{
		$this->hiddenFields[] = array('name'=>'process','value'=>'save');
		$this->_BarButtons = BUTTON_SAVE;
		$this->_ButtonOptions[BUTTON_SAVE] = array('onclick'=>"return ifHandler.makeHidden(document.getElementById('order_selected'),'orderValues[]');");
		$this->_addCustomButton($this->langIf->getText('Move Up'),'button', array('onclick'=>"ifHandler.moveUp('order');",'name'=>'moveup','style'=>'width: 100px;'));
		$this->_addCustomButton($this->langIf->getText('Move Down'),'button', array('onclick'=>"ifHandler.moveDown('order');",'name'=>'movedown','style'=>'width: 100px;'));
	}
}
?>