<?php
require_once(INTERFACE_OBJ."InterfaceFactory.php");
/**
 * InterfaceUserManagement
 *
 * @package I-Ware
 * @subpackage Interface
 * @author Marten Koedam <marten@basesoft.com>
 * @copyright (2005) BaseSoft B.V.
 * @since 14-12-2005
 * @version $Id$
 */
class InterfaceUserManagement extends InterfaceFactory
{
	/**
	 * @param Database $db IWARE Database
	 * @param Database $db_app APPLICATION Database
	 * @param LanguageInterface $langIf
	 */
	function InterfaceUserManagement($db, $db_app, $langIf='')
	{
		parent::InterfaceFactory($db, $db_app, $langIf);
		$this->delimiter = '<br />';

		$this->setSiteDB();
	}
	/**
	 * @param string $thrownException
	 */
	function processInput(&$thrownException)
	{
		if(isset($_POST['process']))
		{
			if($_POST['process']=='save')
			{
				foreach($_POST['user'] as $id => $vars)
				{
					$sql = "UPDATE TBL_USER SET USER_ACTIVE = ?
						WHERE USER_ID = ?";
					$q = $this->db_site->query($sql);
					$q->bind_values(array((isset($vars['active'])?1:0),$id));
					$q->execute();
				}
			}
			$this->init($this->id);
		}
	}
	/**
	 *
	 */
	function setSiteDB()
	{
		if(isset($this->db_site))
			return;
		if(isset($_SESSION['current_site'])&& $_SESSION['current_site']['id']>0)
		{
			global $dba_driver;
			require_once(IQADMIN.'SiteDatabase.php');
			$siteDB = new SiteDatabase($this->db_app);

			$q = $siteDB->select($_SESSION['current_site']['id']);
			if($q->rows()==1)
			{
				$r = $q->fetch();
				$db_type_id = $r->DATABASE_TYPE_ID;
			}
			else
			{
				// ToDo
			}
			$siteDB->set($_SESSION['current_site']['id'],$db_type_id);
			$this->db_site =& $siteDB->connect($dba_driver);
			return;
		}
		$this->db_site = $this->db_app;
	}
}
/**
 * InterfaceUserManagementItem
 *
 * @package I-Ware
 * @subpackage Interface
 * @author Marten Koedam <marten@basesoft.com>
 * @copyright (2005) BaseSoft B.V.
 * @since 14-12-2005
 * @version $Id$
 */
class InterfaceUserManagementItem extends InterfaceItem
{
	/**
	 *
	 */
	function setSiteDB()
	{
		if(isset($this->db_site))
			return;
		if(isset($_SESSION['current_site'])&& $_SESSION['current_site']['id']>0)
		{
			global $dba_driver;
			require_once(IQADMIN.'SiteDatabase.php');
			$siteDB = new SiteDatabase($this->db_app);

			$q = $siteDB->select($_SESSION['current_site']['id']);
			if($q->rows()==1)
			{
				$r = $q->fetch();
				$db_type_id = $r->DATABASE_TYPE_ID;
			}
			else
			{
				// ToDo
			}
			$siteDB->set($_SESSION['current_site']['id'],$db_type_id);
			$this->parent->parent->db_site =& $siteDB->connect($dba_driver);
			return;
		}
		$this->parent->parent->db_site = $this->db_app;
	}
	/**#@+
	 * Item callback functions
	 */
	/**
	 * Get a dropdown box with all the available group-companies
	 */
	function getGroupCompany()
	{
		$this->setSiteDB();
		$sql = "SELECT GROUP_COMPANY_ID, GROUP_NAME
			FROM TBL_GROUP_COMPANY
			INNER JOIN TBL_GROUP
				USING(GROUP_ID)
			ORDER BY COMPANY_ID, GROUP_NAME";
		$q = $this->parent->parent->db_site->query($sql);
//		$q->bind_values(array($_SESSION['session_user_company_id']));
		$q->execute();
		$this->options[] = array('text'=>'---', 'value'=>'-1');
		while($r = $q->fetch())
		{
			$this->options[] = array('text'=>$r->GROUP_NAME, 'value'=>$r->GROUP_COMPANY_ID);
			if(isset($_REQUEST['group_company']['id'])&& $_REQUEST['group_company']['id']==$r->GROUP_COMPANY_ID)
				$this->options[(count($this->options)-1)]['selected'] = 'selected';
		}
		$this->properties['id'] = 'groupcompanyselect';
		$this->properties['onchange'] = 'ifHandler.loadBlock(new Array(\'87\'),\'&amp;interface_id='.$this->parent->parent->id.'&amp;group_company[id]=\'+this.options[this.selectedIndex].value);';
	}
	/**
	 *
	 */
	function getUserOverview()
	{
		if(!isset($_REQUEST['group_company']['id']))
			return;

		$this->setSiteDB();

		require_once(IWARE.'TableFactoryColumnPlugin.php');
		$tf = new TableFactoryColumnPlugin('',$this->langIf,$this->db,$this->parent->parent->db_site);
		$tf->setEmptyText($this->langIf->getText('No users found') );

		$q = $this->selectUserOverview($_REQUEST['group_company']);
		$tf->setData($q, 'UserManagementOverview',false,true);

		$tf->setSortingFunctions(
			array('USER_ID'=>"'Int'",
				'USER_NAME'=>"'String'",
				'INFO_PERSON_ID'=>"'Int'",
				'INFO_PERSON_FIRST_NAME'=>"'String'",
				'INFO_PERSON_LAST_NAME'=>"'String'",
				'LANGUAGE_ID'=>"'Int'",
				'INFO_PERSON_MIDDLE_NAME'=>"'String'",
				'USER_ACTIVE'=>"'String'"
				));

		list($this->text,$script) = $tf->getXHTMLTable('ProfessionalWhite',2,'row',true);
		$this->postscript = $script;
	}
	/**
	 * Get the buttons for the current interface
	 */
	function getButtons()
	{
		$this->hiddenFields[] = array('name'=>'process','value'=>'save');
		$this->_BarButtons = BUTTON_SAVE;
	}
	/**#@-*/
	/**
	 * @todo revise User.php class and move this function there
	 */
	function selectUserOverview($group_company)
	{
		$sql = "SELECT U.USER_ID, USER_NAME, IP.INFO_PERSON_ID,
				INFO_PERSON_FIRST_NAME, INFO_PERSON_MIDDLE_NAME, INFO_PERSON_LAST_NAME,
				LANGUAGE_ID, CONCAT('<input type=\"hidden\" name=\"user[',U.USER_ID,'][id]\" value=\"',U.USER_ID,'\" /><input type=\"checkbox\" value=\"1\" name=\"user[',
					U.USER_ID,'][active]\" ',IF(USER_ACTIVE,'checked=\"checked\"',''),' />') as USER_ACTIVE
			FROM TBL_USER as U
			INNER JOIN TBL_INFO_PERSON as IP
				USING(INFO_PERSON_ID)
			INNER JOIN TBL_GROUP_COMPANY as GC
				USING(COMPANY_ID)
			INNER JOIN TBL_GROUP_USER as GU
				ON U.USER_ID = GU.USER_ID
					AND GC.GROUP_ID = GU.GROUP_ID
			WHERE GC.GROUP_COMPANY_ID = ?";
		$q = $this->parent->parent->db_site->query($sql);
		$q->bind_values(array($group_company['id']));
		$q->execute();
		return $q;
	}
}
?>