<?php
/**
 * @package ELC
 * @subpackage List
 * @since 14-jul-2006
 * @author Marten Koedam <marten@dalines.net>
 * @version $Id$
 * @copyright 2006 BaseSoft B.V.
 */
class BrandOverviewList extends ELCDefaultList
{
	var $handle = 'BrandOverviewList';

	function setQuery()
	{
		$this->_query = "SELECT R1.`NAME` as CRSO_NAME, R.`NAME` AS PARTICIPANT_NAME, GROUP_CONCAT(DISTINCT B.`NAME` ORDER BY B.`NAME` SEPARATOR ', ') AS BRANDS
			FROM TBL_RELATION as R
			INNER JOIN TBL_CRSO_PARTICIPANT_PRODUCT as CP
				ON R.RELATION_ID = CP.PARTICIPANT_RELATION_ID
			INNER JOIN TBL_RELATION as R1
				ON CP.CRSO_RELATION_ID = R1.RELATION_ID
			INNER JOIN TBL_PARTICIPANT_BRAND as PB
				ON CP.PARTICIPANT_RELATION_ID = PB.PARTICIPANT_RELATION_ID
			INNER JOIN TBL_BRAND as B
				ON PB.BRAND_ID = B.BRAND_ID
					AND CP.CRSO_RELATION_ID = B.CRSO_RELATION_ID
					AND CP.PRODUCT_ID = B.PRODUCT_ID ";
		$this->_groupBy = "GROUP BY CRSO_NAME";
		$this->_orderBy = "ORDER BY CRSO_NAME";
	}

	function _filterQuery()
	{
		if(!$this->_groupByArray)
			$this->_addHiddenCol(array('PARTICIPANT_NAME'));
		return $this->_query;
	}

	function _setWhere()
	{
		$this->_addWhere('CRSO_RELATION_ID',
			array(
				'field'=>'R1.RELATION_ID',
				'callback' => array($this,'getCRSOSelect'),
				'related'=>array('CRSO_NAME'),
				'groupBy'=>'PARTICIPANT_NAME'));
		$this->_addWhere('PARTICIPANT_RELATION_ID',
			array(
				'field'=>'CP.`PARTICIPANT_RELATION_ID`',
				'callback' => array($this,'getParticipantSelect'),
				'related'=>array('PARTICIPANT_NAME'),
				'groupBy'=>''));
		$this->_addWhere('PRODUCT_ID',
			array(
				'field'=>'CP.PRODUCT_ID',
				'callback' => array($this,'getProductSelect')));
		/*$this->_addWhere('BRAND_ID',
			array(
				'field'=>'B.`BRAND_ID`',
				'callback' => array($this,'getBrandSelect'),
				'related'=>array('BRAND_NAME','BRANDS')));*/
	}
	/*
	function getBrandSelect($rv)
	{
		$setValue = isset($_REQUEST['BRAND_ID'])?$_REQUEST['BRAND_ID']:false;
		if(isset($$rv))
			return $$rv;

		require_once(ELC_CLASSES.'Brand.php');
		$b = new Brand($this->db);
		$q = $b->select((isset($_REQUEST['CRSO_RELATION_ID'])?$_REQUEST['CRSO_RELATION_ID']:false));

		$select = new Form_Select('BRAND_ID');
		$select->addOption(' - '.$this->getText('Brand Select').' - ', '', false);
		while($r = $q->fetch())
			$select->addOption($r->BRAND_NAME, $r->BRAND_ID, false);
		$select->setSelectedValue($setValue);

		$filter = $select->getHtml();

		return $$rv;
	}*/
}
?>
