<?php
/**
 * @package
 * @subpackage
 * @since 5-jan-2007
 * @author Marten Koedam <marten@dalines.net>
 * @version $Id$
 * @copyright 2007 BaseSoft B.V.
 */
class WEEECustomQueryCRSOProductOverview extends IWCustomQueryObject
{
	public function isPrivileged()
	{
		require_once(IWARE.'group.php');
		switch($_SESSION['session_group_group_id'])
		{
			case GROUP_SYSADMIN:
			case GROUP_ACCOUNTANT:
				return true;
		}
		return false;
	}

	public function getQuery()
	{
		$sql = "SELECT cp.CRSO_RELATION_ID, cp.CRSO_RELATION_ID as SETTINGS, r.`NAME` as CRSO_NAME, p.`NAME` as PRODUCT_NAME,
			DATE(r.CREATED) as CREATED, FORFEIT_START_DATE,FORFEIT_DAY as DECLARATION_EXPORT_DAY,REFUND_START_DATE,
			REFUND_EXPORT_DAY,DECLARATION_REMINDER_DAY
			FROM TBL_CRSO_PRODUCT as cp
			INNER JOIN TBL_RELATION as r
				ON cp.CRSO_RELATION_ID = r.RELATION_ID
			INNER JOIN TBL_PRODUCT as p
				ON cp.PRODUCT_ID = p.PRODUCT_ID ";

		if($_SESSION['session_group_group_id']==GROUP_ACCOUNTANT) {
			$sql .= "INNER JOIN TBL_ACCOUNTANT_CRSO as ac
				ON ac.CRSO_RELATION_ID = cp.CRSO_RELATION_ID ";
		}

		return $sql;
	}

	public function getWhere()
	{
		switch($_SESSION['session_group_group_id'])
		{
			case GROUP_ACCOUNTANT:
				return " AND ac.ACCOUNTANT_RELATION_ID = ".$_SESSION['accountant_relation_id']." ";
		}
		return "";
	}

	public function tfHideColumns()
	{
		$rv = array();
		if($_SESSION['session_group_group_id'] == GROUP_ACCOUNTANT)
			$rv[] = 'SETTINGS';
		return $rv;
	}

	public function tfValueProcessor($args=false)
	{
		if(!$args)
			return array($this,'tfValueProcessor');

		require_once(ELC_CLASSES.'ELCListBuilder.php');
		$list = new ELCDefaultList(IWRegistry::registry('db'),IWRegistry::registry('langIf'));
		if(!empty($_POST['export']))
			$list->setShowType(LIST_BUTTON_CSV_EXPORT);
		switch($args['head'])
		{
			case 'CRSO_RELATION_ID':
				if($_SESSION['session_group_group_id'] == GROUP_SYSADMIN) {
					if(!empty($_POST['export']))
						return $args['value'];
					return sprintf('<a href="/%sscripts/elc/operator/InterfaceCRSORegistration.php?crso[id]=%s">%s</a>',
						SITE_PATH,$args['value'],$args['value']);
				}
			break;
			case 'SETTINGS':
				if(!empty($_POST['export']))
					return $args['value'];
				return sprintf('<a href="/%sscripts/elc/operator/InterfaceCRSOSettings.php?crso[id]=%s">%s</a>',
					SITE_PATH,$args['value'],IWRegistry::registry('langIf')->getText('Edit'));
			break;
			case 'FORFEIT_START_DATE':
			case 'REFUND_START_DATE':
			case 'REFUND_EXPORT_DAY':
				return $args['value']?$args['value']:$list->tfBooleanIcon($args);
			break;
			default:
		}

		return $args['value'];
	}

	public function registerFields(IWCustomQueryFactory $cq)
	{
		$cq->getFilterFromFieldInTable(IWRegistry::registry('db'),
			'SELECT p.PRODUCT_ID as VAL, p.`NAME` as DISP
				FROM TBL_PRODUCT as p
			ORDER BY p.`NAME`',
			'PRODUCT_ID','Product','p');

		$cq->getFilterFromFieldInTable(IWRegistry::registry('db'),
			$this->getFilter('filterCRSO'),
			'CRSO_RELATION_ID','CRSO','cp');
	}
}
?>
