<?php
require_once(ELC_CLASSES.'Declaration.php');
/**
 * @package ELC
 * @subpackage List
 * @since 21/08/2006
 * @author Nick Loeve <nick@basesoft.com>
 * @version $Id$
 * @copyright 2006 BaseSoft B.V.
 */
class DeclarationExportList extends ELCDefaultList
{
	var $handle = 'DeclarationExportList';
	var $_maxQuantity = 0;
	var $_maxWeight = 0;
	var $_maxWeightDec = 0;
	var $_cols = false;
	var $hashTotal = '';

	function setQuery()
	{
		$this->_query = "SELECT D.`DECLARATION_ID`,
				IF(ISNULL(dd.DECLARATION_DEBIT_ID),
						f_elcBuildInvoiceNoForInterfaces(D.CRSO_RELATION_ID,dc.`YEAR`,dc.DECLARATION_CREDIT_ID,true,false),
						f_elcBuildInvoiceNoForInterfaces(D.CRSO_RELATION_ID,dd.`YEAR`,dd.DECLARATION_DEBIT_ID,false,false)
				) as INVOICE_NR,
				IF(ISNULL(dd.DECLARATION_DEBIT_ID),
					IF(ISNULL(dc.DECLARATION_CREDIT_ID),
						'-',
						CONCAT('C',D.CRSO_RELATION_ID)),
					CONCAT('I',D.CRSO_RELATION_ID)) as JOURNAL_TEMPLATE,
				D.DOCUMENT_ID as INVOICE,
				D.PARTICIPANT_RELATION_ID,
				R.`NAME` as PARTICIPANT_NAME,
				R.`VAT_NO`, D.`YEAR` as DECL_YEAR, D.`MONTH`, SUM(DL2.QUANTITY) as `QUANTITY`,
				SUM(DL2.WEIGHT) as `WEIGHT`,
				SUM(DL2.WEIGHT_DEC) as `WEIGHT_DEC`,
				BIT_OR(DL2.`STATUS`) as `STATUS`

			".(!empty($_REQUEST['EXPORT_DATE']) ? ",MD5(CONCAT(

				IF(ISNULL(dd.DECLARATION_DEBIT_ID),
						f_elcBuildInvoiceNoForInterfaces(D.CRSO_RELATION_ID,dc.`YEAR`,dc.DECLARATION_CREDIT_ID,true,false),
						f_elcBuildInvoiceNoForInterfaces(D.CRSO_RELATION_ID,dd.`YEAR`,dd.DECLARATION_DEBIT_ID,false,false)
				 ),
				CONCAT(cac.CODE,
					LPAD(D.CRSO_RELATION_ID, 8, 0),
					LPAD(D.PARTICIPANT_RELATION_ID, 8, 0)
				),
				REPLACE(IF(ISNULL(dd.DECLARATION_DEBIT_ID), f_elcGetDeclarationCreditTotalAmount(D.CRSO_RELATION_ID, dc.DECLARATION_CREDIT_ID, dc.`YEAR`), f_elcGetDeclarationDebitTotalAmount(D.CRSO_RELATION_ID, dd.DECLARATION_DEBIT_ID, dd.`YEAR`)), '.', ',')
			)) as `Hash`" : "")."
			FROM TBL_DECLARATION as D
			INNER JOIN TBL_RELATION R ON D.PARTICIPANT_RELATION_ID = R.RELATION_ID
			INNER JOIN TBL_DECLARATION_LINE DL2 ON D.DECLARATION_ID=DL2.DECLARATION_ID
			INNER JOIN TBL_RELATION as cr
				ON cr.RELATION_ID = D.CRSO_RELATION_ID
			INNER JOIN TBL_ADDRESS as ca
				ON cr.ADDRESS_ID = ca.ADDRESS_ID
			INNER JOIN TBL_COUNTRY as cac
				ON cac.COUNTRY_ID = ca.COUNTRY_ID
			LEFT JOIN TBL_DECLARATION_SET_LINE as dsl
				ON D.DECLARATION_ID = dsl.DECLARATION_ID
			LEFT JOIN TBL_DECLARATION_CREDIT dc ON dsl.DECLARATION_SET_ID=dc.DECLARATION_SET_ID
			LEFT JOIN TBL_DECLARATION_DEBIT dd ON dsl.DECLARATION_SET_ID=dd.DECLARATION_SET_ID
			";
		$this->_groupBy = "GROUP BY D.DECLARATION_ID";
		$this->_orderBy = "ORDER BY INVOICE_NR";
	}

	function _filterQuery()
	{
		if($_SESSION['session_group_group_id']==GROUP_CRSO)
		{
			$hidden = array('Hash');
			require_once(ELC_CLASSES.'Country.php');
			require_once(ELC_CLASSES.'CRSO.php');
			require_once(ELC_CLASSES.'RelationUser.php');
			$rel = new Relation($this->db,$_SESSION['crso_relation_id'],true);
			$country = new Country($this->db,$rel->getCountry(),true);

			$ru = new RelationUser($this->db);

			// Check for Country setting and Clearance level.
			if(!$country->has(HasCrsoDeclarationDetails,$_SESSION['selected_product_id'])||
				!$ru->hasClearance(CRSOClearanceDeclarationDetails, $_SESSION['session_user_id'], $_SESSION['crso_relation_id'])) {
				$hidden[] = 'QUANTITY';
				$hidden[] = 'WEIGHT';
				$hidden[] = 'WEIGHT_DEC';
			}
			if(!$country->has(HasDeclOfWeight,$_SESSION['selected_product_id']))
				$hidden[] = 'WEIGHT';
			if(!$country->has(HasDeclOfWeightWithDecimals,$_SESSION['selected_product_id']))
				$hidden[] = 'WEIGHT_DEC';
			$this->_addHiddenCol($hidden);
		}
		return $this->_query;
	}

	function _setWhere()
	{
		$this->_addWhere('YEAR',
			array('field'=>'YEAR(D.EXPORT_DATE)',
				'callback' => array($this,'getYearSelect')));


		$this->_addWhere('CRSO_RELATION_ID',
			array(
				'field'=>'D.`CRSO_RELATION_ID`',
				'callback' => array($this,'getCRSOSelect'),
				'required'=>true,
				'related'=>array(),
				'groupBy'=>''));


		$this->_addWhere('IS_EXPORTED',
			array(
				'field' => 'D.IS_EXPORTED',
				'callback' => array($this, 'getIsExported'),
				'required'=>true,
				'related' => array(),
				'groupBy' => ''

			));

		$this->_addWhere('EXPORT_DATE',
			array(
				'field' => 'D.EXPORT_DATE',
				'callback' => array($this, 'getExportDate'),
				'groupBy' => '',
                                'required' => true

			));
		if(isset($_REQUEST['STATUS'])&&($_REQUEST['STATUS'] == 'NONCREDIT'))
		{

			$this->_addWhere('STATUS',
				array(
					'operator' => ' & ',
					'field' => 'DL2.STATUS',
					'completedStatement' => '(DL2.STATUS & '.DECLARATION_CREDIT.' != '.DECLARATION_CREDIT.')',
					'callback' => array($this, 'getStatus'),
					//'related' => array('Hash')
				));
		}
		else
		{
			$this->_addWhere('STATUS',
				array(
					'operator' => ' & ',
					'field' => 'DL2.STATUS',
					//'useinquery' => false,
					'callback' => array($this, 'getStatus'),
					//'related' => array('Hash')
				));
		}

		$this->_addWhere('PRODUCT_ID',
			array(
				'field'=>'D.PRODUCT_ID',
				'callback' => array($this,'getProductSelect')));

		$this -> _addWhere('PARTICIPANT_RELATION_ID',
			array('field' => 'D.PARTICIPANT_RELATION_ID', 'callback' => array($this, 'getParticipantSelect'), 'related' => array(''), 'groupBy' => ''));

	}

	function _getHaving()
	{
		if(empty($_REQUEST['STATUS']))
			return '';
		//$this->_addHiddenCol('Hash');
		unset($this->_hiddenCols['STATUS']);
		//return 'HAVING BIT_OR(DL2.STATUS) & '.((int)$_REQUEST['STATUS']);
		return '';
	}

	function getIsExported($rv='setValue')
	{
		$filter = '';
		(!empty($_REQUEST['EXPORT_DATE'])) ? $setValue = '2' : $setValue=null;
		$selectedValue = '';
		return $$rv;
	}

	function getStatus($rv='setValue')
	{
		$filter ='';
		$selectedValue = '';
		(!empty($_REQUEST['STATUS'])) ? $setValue = $_REQUEST['STATUS'] : $setValue=false;
		//require_once(ELC_CLASSES.'Declaration.php');
		$select = new Form_Select('STATUS');
		$select->addOption(' - '.$this->getText('All').' - ', '', false);
		$selectedValue = ' - '.$this->getText('All').' - ';
		foreach(Declaration::getDeclarationTypes() as $type)
		{
			list($translatedStatus, $class) = Declaration::translateStatus($this->langIf,$type);
			if($setValue==$type)
				$selectedValue = $translatedStatus;

			$select->addOption($translatedStatus, $type, false);
		}
		if($setValue=='NONCREDIT')
			$selectedValue = $this->langIf->getText('Non Credits');
		$select->addOption($this->langIf->getText('Non Credits'),'NONCREDIT',false);

		$select->setSelectedValue($setValue);
		$filter = $select->getHtml();
		return $$rv;
	}

	function getExportDate($rv='setValue')
	{
		$setValue = isset($_REQUEST['EXPORT_DATE'])?$_REQUEST['EXPORT_DATE']:false;;
		if(isset($$rv))
			return $$rv;

		$selectedValue = ' - '.$this->getText('Select Export Date').' - ';

		if(isset($_REQUEST['CRSO_RELATION_ID']))
		{
			$q = $this->db->query('SELECT DISTINCT EXPORT_DATE, MONTH(EXPORT_DATE) AS `MONTH`, DAY(EXPORT_DATE) AS `DAY`, YEAR(EXPORT_DATE) AS `YEAR` FROM TBL_DECLARATION WHERE IS_EXPORTED=2 AND CRSO_RELATION_ID = ? AND PRODUCT_ID = ? ORDER BY `YEAR` DESC, `MONTH` DESC');
			$q->bind_values($_REQUEST['CRSO_RELATION_ID'], $_SESSION['selected_product_id']);
			$q->execute();

			$select = new Form_Select('EXPORT_DATE');
			$select->addOption(' - '.$this->getText('Select Export Date').' - ', '', false);
                        while($r = $q->fetch())
			{
				if($setValue==$r->EXPORT_DATE)
					$selectedValue = strftime('%d, %B %Y', mktime(1, 1, 1, $r->MONTH, $r->DAY, $r->YEAR) );
				$select->addOption(strftime('%d, %B %Y', mktime(1, 1, 1, $r->MONTH, $r->DAY, $r->YEAR) ), $r->EXPORT_DATE, false);
			}
			$select->setSelectedValue($setValue);

			$filter = $select->getHtml();
		}
		else
			$filter = '';
		return $$rv;
	}

	function getProcessColumns()
	{
		return array(
			'tfValueProcessorAggregateQuantity'=>array('QUANTITY', 'WEIGHT', 'WEIGHT'),
			'tfMonth' => array('MONTH'),
			'tfValueProcessorQuantity' => array('FEE'),
			'tfFixedFontWidth' => array('Hash'),
			'tfDeclarationStatus'=> array('STATUS'),
			'tfLongNames'=> array('PARTICIPANT_NAME'),
			'tfBooleanIcon'=> array('INVOICE')
			);
	}

	function getColumnModifier()
	{
		return array('QUANTITY'=>'style="text-align:right;"','WEIGHT'=>'style="text-align:right;"','WEIGHT_DEC'=>'style="text-align:right;"','FEE'=>'style="text-align:right;"');
	}

	function tfSortingHat()
	{
		return array(
			'MONTH'=>"'SortVal'",
			'INVOICE_NR'=>"'String'",
			'JOURNAL_TEMPLATE'=>"'String'",
			'PARTICIPANT_RELATION_ID'=>"'Int'",
			'QUANTITY'=>"'SortVal'",
			'WEIGHT'=>"'SortVal'",
			'WEIGHT_DEC'=>"'SortVal'",
			'FEE'=>"'SortVal'",
			'YEAR'=>"'Int'",
			'DECLARATION_ID'=>"'Int'",
			'VAT_NO'=>"'String'",
			'STATUS'=>"'String'",
			'PARTICIPANT_NAME'=>"'String'",
			'Hash'=>"'String'",
			'INVOICE'=>"'String'"
			);
	}
	function tfValueProcessorAggregateQuantity($args)
	{
		if($args['head']=='QUANTITY')
			$this->_maxQuantity += $args['value'];
		elseif($args['head']=='WEIGHT_DEC')
			$this->_maxWeightDec += $args['value'];
		else
			$this->_maxWeight += $args['value'];
		$this->_cols = $args['visibleColumns'];
		$args['extra'] .= sprintf(' sort_val="%s" ', $args['value']);
		if($args['head']=='WEIGHT_DEC') {
			return locale_nf($args['value'], 3);
		}
    	return locale_nf($args['value']);
	}

	function tfFixedFontWidth($args)
	{
		$this->hashTotal .= $args['value'];
		return parent::tfFixedFontWidth($args);
	}

	function tfFooter() // getClass
	{
		if(!$this->_cols||in_array('QUANTITY',$this->_hiddenCols))
			return false;
		$rv = explode(',',str_repeat(',',(sizeof($this->_cols)-1)));

		$pos = array_flip($this->_cols);
		$rv[$pos['QUANTITY']] = '<span style="float:left; font-weight: bold;">Total</span><span style="float:right; font-weight: bold;">'.locale_nf($this->_maxQuantity).'</span><span style="clear:both;"></span>';
		if(!in_array('WEIGHT', $this->_hiddenCols))
			$rv[$pos['WEIGHT']] = '<span style="float:right; font-weight: bold;">'.locale_nf($this->_maxWeight).'</span><span style="clear:right;"></span>';
		if(!in_array('WEIGHT_DEC', $this->_hiddenCols))
			$rv[$pos['WEIGHT_DEC']] = '<span style="float:right; font-weight: bold;">'.locale_nf($this->_maxWeightDec, 3).'</span><span style="clear:right;"></span>';
		if(isset($pos['Hash']))
			$rv[$pos['Hash']] = '<span style="font-size: 9pt; font-family: monospace; font-weight: bold;">'.md5($this->hashTotal).'</span>';
		return $rv;
	}
}
?>
