<?php
/**
 * @package
 * @subpackage
 * @since 31-okt-2006
 * @author Marten Koedam <marten@dalines.net>
 * @version $Id$
 * @copyright 2006 BaseSoft B.V.
 */
class DocumentAccessList extends ELCDefaultList
{
	var $handle = 'DocumentAccessList';
	function setQuery()
	{
		if(!isset($_REQUEST['DocumentType']))
			return;

		$this->getDownloadSelect();
		$this->{'setDocumentQuery'.$_REQUEST['DocumentType']}();
		if(isset($_REQUEST['DocumentDownload']))
		{
			if($_REQUEST['DocumentDownload'] == 1) $this->_groupBy .= " HAVING NumOfDownloads > 0";
			else if($_REQUEST['DocumentDownload'] == 2)
			 	$this->_groupBy .= " HAVING NumOfDownloads = 0";
		}
	}

	protected function setDocumentQueryAll()
	{
		$this->_query = "
			SELECT type,`MONTH`, `YEAR`, PARTICIPANT_NAME,
				Document_id, DocName,
				CREATED, NumOfDownloads, FirstDownload,  LastDownload, crso
			FROM
			( -- DECLARATION
				(SELECT 'declaration' as type,o.`MONTH`, o.`YEAR`, R.`NAME` as PARTICIPANT_NAME,
					o.DOCUMENT_ID as Document_id,D.NAME as DocName,
					D.CREATED,
					COUNT(UDD.DOWNLOAD_DATETIME) as NumOfDownloads,
					MIN(UDD.DOWNLOAD_DATETIME) as FirstDownload, MAX(UDD.DOWNLOAD_DATETIME) as LastDownload,
					o.CRSO_RELATION_ID AS crso
				FROM TBL_DECLARATION as o
				INNER JOIN TBL_RELATION as R
					ON o.PARTICIPANT_RELATION_ID = R.RELATION_ID
				INNER JOIN TBL_RELATION_USER as RU
					ON R.RELATION_ID = RU.RELATION_ID
				LEFT JOIN TBL_USER_DOCUMENT_DOWNLOAD as UDD
					ON RU.USER_ID = UDD.USER_ID
					AND o.DOCUMENT_ID = UDD.DOCUMENT_ID
				INNER JOIN TBL_DOCUMENT as D
					ON o.DOCUMENT_ID = D.DOCUMENT_ID
				GROUP BY o.DECLARATION_ID)
			UNION -- REFUND REQUEST
				(SELECT 'refund request' as type,MONTH(o.EXPORT_DATE) as `MONTH`, YEAR(o.EXPORT_DATE) as `YEAR`,R.`NAME` as PARTICIPANT_NAME,
					o.INVOICE_DOCUMENT_ID as Document_id,D.NAME as DocName,
					D.CREATED,
					COUNT(UDD.DOWNLOAD_DATETIME) as NumOfDownloads,
					MIN(UDD.DOWNLOAD_DATETIME) as FirstDownload, MAX(UDD.DOWNLOAD_DATETIME) as LastDownload,
					o.CRSO_RELATION_ID AS crso
				FROM TBL_REFUND_EXPORT as o
				INNER JOIN TBL_RELATION as R
					ON o.PARTICIPANT_RELATION_ID = R.RELATION_ID
				INNER JOIN TBL_RELATION_USER as RU
					ON R.RELATION_ID = RU.RELATION_ID
				LEFT JOIN TBL_USER_DOCUMENT_DOWNLOAD as UDD
					ON RU.USER_ID = UDD.USER_ID
					AND o.INVOICE_DOCUMENT_ID = UDD.DOCUMENT_ID
				INNER JOIN TBL_DOCUMENT as D
					ON o.INVOICE_DOCUMENT_ID = D.DOCUMENT_ID
				GROUP BY o.REFUND_EXPORT_ID)
			UNION -- REMINDERS
				(SELECT 'reminder' as type,MONTH(o.IMPORT_DATE) as `MONTH`,
					YEAR(o.IMPORT_DATE) as `YEAR`, R.`NAME` as PARTICIPANT_NAME,
					o.DOCUMENT_ID as Document_id,D.NAME as DocName,
					D.CREATED,
					COUNT(UDD.DOWNLOAD_DATETIME) as NumOfDownloads,
					MIN(UDD.DOWNLOAD_DATETIME) as FirstDownload, MAX(UDD.DOWNLOAD_DATETIME) as LastDownload,
					o.CRSO_RELATION_ID AS crso
				FROM TBL_CRSO_PARTICIPANT_REMINDER as o
				INNER JOIN TBL_RELATION as R
					ON o.PARTICIPANT_RELATION_ID = R.RELATION_ID
				INNER JOIN TBL_RELATION_USER as RU
					ON R.RELATION_ID = RU.RELATION_ID
				LEFT JOIN TBL_USER_DOCUMENT_DOWNLOAD as UDD
					ON RU.USER_ID = UDD.USER_ID
						AND o.DOCUMENT_ID = UDD.DOCUMENT_ID
				INNER JOIN TBL_DOCUMENT as D
					ON o.DOCUMENT_ID = D.DOCUMENT_ID
				GROUP BY o.DOCUMENT_ID)
			UNION -- LATE PAYMENT
				(SELECT 'late payment' as type,MONTH(o.IMPORT_DATE) as `MONTH`,
					YEAR(o.IMPORT_DATE) as `YEAR`, R.`NAME` as PARTICIPANT_NAME,
					o.DOCUMENT_ID as Document_id,D.NAME as DocName,
					D.CREATED,
					COUNT(UDD.DOWNLOAD_DATETIME) as NumOfDownloads,
					MIN(UDD.DOWNLOAD_DATETIME) as FirstDownload, MAX(UDD.DOWNLOAD_DATETIME) as LastDownload,
					o.CRSO_RELATION_ID AS crso
				FROM TBL_CRSO_PARTICIPANT_LATE_PAYMENT as o
				INNER JOIN TBL_RELATION as R
					ON o.PARTICIPANT_RELATION_ID = R.RELATION_ID
				INNER JOIN TBL_RELATION_USER as RU
					ON R.RELATION_ID = RU.RELATION_ID
				LEFT JOIN TBL_USER_DOCUMENT_DOWNLOAD as UDD
					ON RU.USER_ID = UDD.USER_ID
					AND o.DOCUMENT_ID = UDD.DOCUMENT_ID
				INNER JOIN TBL_DOCUMENT as D
					ON o.DOCUMENT_ID = D.DOCUMENT_ID
				GROUP BY o.DOCUMENT_ID)
			UNION -- GUARANTEE
				(SELECT 'guarantee' as type,MONTH(o.IMPORT_DATE) as `MONTH`,
					YEAR(o.IMPORT_DATE) as `YEAR`, R.`NAME` as PARTICIPANT_NAME,
					o.DOCUMENT_ID as Document_id,D.NAME as DocName,
					D.CREATED,
					COUNT(UDD.DOWNLOAD_DATETIME) as NumOfDownloads,
					MIN(UDD.DOWNLOAD_DATETIME) as FirstDownload, MAX(UDD.DOWNLOAD_DATETIME) as LastDownload,
					o.CRSO_RELATION_ID AS crso
				FROM TBL_CRSO_PARTICIPANT_GUARANTEE as o
				INNER JOIN TBL_RELATION as R
					ON o.PARTICIPANT_RELATION_ID = R.RELATION_ID
				INNER JOIN TBL_RELATION_USER as RU
					ON R.RELATION_ID = RU.RELATION_ID
				LEFT JOIN TBL_USER_DOCUMENT_DOWNLOAD as UDD
					ON RU.USER_ID = UDD.USER_ID
					AND o.DOCUMENT_ID = UDD.DOCUMENT_ID
				INNER JOIN TBL_DOCUMENT as D
					ON o.DOCUMENT_ID = D.DOCUMENT_ID
				GROUP BY o.DOCUMENT_ID)
			) AS FINAL
			";
	}

	protected function setDocumentQueryReminders()
	{
		$this->_query = "SELECT MONTH(o.IMPORT_DATE) as `MONTH`,
				YEAR(o.IMPORT_DATE) as `YEAR`, R.`NAME` as PARTICIPANT_NAME,
				o.DOCUMENT_ID as Document_id,D.NAME as DocName,
				D.CREATED,
				COUNT(UDD.DOWNLOAD_DATETIME) as NumOfDownloads,
				MIN(UDD.DOWNLOAD_DATETIME) as FirstDownload, MAX(UDD.DOWNLOAD_DATETIME) as LastDownload
			FROM TBL_CRSO_PARTICIPANT_REMINDER as o
			INNER JOIN TBL_RELATION as R
				ON o.PARTICIPANT_RELATION_ID = R.RELATION_ID
			INNER JOIN TBL_RELATION_USER as RU
				ON R.RELATION_ID = RU.RELATION_ID
			LEFT JOIN TBL_USER_DOCUMENT_DOWNLOAD as UDD
				ON RU.USER_ID = UDD.USER_ID
					AND o.DOCUMENT_ID = UDD.DOCUMENT_ID
			INNER JOIN TBL_DOCUMENT as D
				ON o.DOCUMENT_ID = D.DOCUMENT_ID
			";
		$this->_groupBy = "GROUP BY o.DOCUMENT_ID";
	}

	protected function setDocumentQueryDeclaration()
	{
		/*$this->_query = "SELECT o.`MONTH`, o.`YEAR`, R.`NAME` as PARTICIPANT_NAME,
				IF(ISNULL(DD.DECLARATION_DEBIT_ID),
					IF(ISNULL(DC.DECLARATION_CREDIT_ID),'-',
						f_elcBuildInvoiceNoForInterfaces(o.CRSO_RELATION_ID,DC.`YEAR`,DC.DECLARATION_CREDIT_ID,true,false)),
						f_elcBuildInvoiceNoForInterfaces(o.CRSO_RELATION_ID,DD.`YEAR`,DD.DECLARATION_DEBIT_ID,false,false)) as DocName,
				COUNT(UDD.DOWNLOAD_DATETIME) as NumOfDownloads,
				MIN(UDD.DOWNLOAD_DATETIME) as FirstDownload, MAX(UDD.DOWNLOAD_DATETIME) as LastDownload
			FROM TBL_DECLARATION as o
			INNER JOIN TBL_RELATION as R
				ON o.PARTICIPANT_RELATION_ID = R.RELATION_ID
			INNER JOIN TBL_RELATION_USER as RU
				ON R.RELATION_ID = RU.RELATION_ID
			LEFT JOIN TBL_USER_DOCUMENT_DOWNLOAD as UDD
				ON RU.USER_ID = UDD.USER_ID
					AND o.DOCUMENT_ID = UDD.DOCUMENT_ID
			LEFT JOIN TBL_DECLARATION_SET_LINE as DSL
				ON o.DECLARATION_ID = DSL.DECLARATION_ID
			LEFT JOIN TBL_DECLARATION_DEBIT as DD
				ON DSL.DECLARATION_SET_ID = DD.DECLARATION_SET_ID
					AND o.CRSO_RELATION_ID = DD.CRSO_RELATION_ID
			LEFT JOIN TBL_DECLARATION_CREDIT as DC
				ON DSL.DECLARATION_SET_ID = DC.DECLARATION_SET_ID
					AND o.CRSO_RELATION_ID = DC.CRSO_RELATION_ID
			";*/
		$this->_query = "SELECT o.`MONTH`, o.`YEAR`, R.`NAME` as PARTICIPANT_NAME,
				o.DOCUMENT_ID as Document_id,D.NAME as DocName,
				D.CREATED,
				COUNT(UDD.DOWNLOAD_DATETIME) as NumOfDownloads,
				MIN(UDD.DOWNLOAD_DATETIME) as FirstDownload, MAX(UDD.DOWNLOAD_DATETIME) as LastDownload
			FROM TBL_DECLARATION as o
			INNER JOIN TBL_RELATION as R
				ON o.PARTICIPANT_RELATION_ID = R.RELATION_ID
			INNER JOIN TBL_RELATION_USER as RU
				ON R.RELATION_ID = RU.RELATION_ID
			LEFT JOIN TBL_USER_DOCUMENT_DOWNLOAD as UDD
				ON RU.USER_ID = UDD.USER_ID
					AND o.DOCUMENT_ID = UDD.DOCUMENT_ID
			INNER JOIN TBL_DOCUMENT as D
				ON o.DOCUMENT_ID = D.DOCUMENT_ID
			";
		$this->_groupBy = "GROUP BY o.DECLARATION_ID";
	}

	protected function setDocumentQueryRefundRequest()
	{
		/*$this->_query = "SELECT MONTH(o.EXPORT_DATE) as `MONTH`, YEAR(o.EXPORT_DATE) as `YEAR`,R.`NAME` as PARTICIPANT_NAME,
				IF(ISNULL(DD.REFUND_REQUEST_DEBIT_ID),
					IF(ISNULL(DC.REFUND_REQUEST_CREDIT_ID),'-',
                        f_elcBuildInvoiceNoForInterfaces(o.CRSO_RELATION_ID,DC.`YEAR`,DC.REFUND_REQUEST_CREDIT_ID,true,true)),
						f_elcBuildInvoiceNoForInterfaces(o.CRSO_RELATION_ID,DD.`YEAR`,DD.REFUND_REQUEST_DEBIT_ID,false,true)) as DocName,
				COUNT(UDD.DOWNLOAD_DATETIME) as NumOfDownloads,
				MIN(UDD.DOWNLOAD_DATETIME) as FirstDownload, MAX(UDD.DOWNLOAD_DATETIME) as LastDownload
			FROM TBL_REFUND_EXPORT as o
			INNER JOIN TBL_RELATION as R
				ON o.PARTICIPANT_RELATION_ID = R.RELATION_ID
			INNER JOIN TBL_RELATION_USER as RU
				ON R.RELATION_ID = RU.RELATION_ID
			LEFT JOIN TBL_USER_DOCUMENT_DOWNLOAD as UDD
				ON RU.USER_ID = UDD.USER_ID
					AND o.INVOICE_DOCUMENT_ID = UDD.DOCUMENT_ID
			LEFT JOIN TBL_REFUND_EXPORT_SET_LINE as RESL
				ON o.REFUND_EXPORT_ID = RESL.REFUND_EXPORT_ID
			LEFT JOIN TBL_REFUND_EXPORT_DEBIT as DD
				ON RESL.REFUND_EXPORT_SET_ID = DD.REFUND_EXPORT_SET_ID
					AND o.CRSO_RELATION_ID = DD.CRSO_RELATION_ID
			LEFT JOIN TBL_REFUND_EXPORT_CREDIT as DC
				ON RESL.REFUND_EXPORT_SET_ID = DC.REFUND_EXPORT_SET_ID
					AND o.CRSO_RELATION_ID = DC.CRSO_RELATION_ID
			";*/
		$this->_query = "SELECT MONTH(o.EXPORT_DATE) as `MONTH`, YEAR(o.EXPORT_DATE) as `YEAR`,R.`NAME` as PARTICIPANT_NAME,
				o.INVOICE_DOCUMENT_ID as Document_id,D.NAME as DocName,
				D.CREATED,
				COUNT(UDD.DOWNLOAD_DATETIME) as NumOfDownloads,
				MIN(UDD.DOWNLOAD_DATETIME) as FirstDownload, MAX(UDD.DOWNLOAD_DATETIME) as LastDownload
			FROM TBL_REFUND_EXPORT as o
			INNER JOIN TBL_RELATION as R
				ON o.PARTICIPANT_RELATION_ID = R.RELATION_ID
			INNER JOIN TBL_RELATION_USER as RU
				ON R.RELATION_ID = RU.RELATION_ID
			LEFT JOIN TBL_USER_DOCUMENT_DOWNLOAD as UDD
				ON RU.USER_ID = UDD.USER_ID
					AND o.INVOICE_DOCUMENT_ID = UDD.DOCUMENT_ID
			INNER JOIN TBL_DOCUMENT as D
				ON o.INVOICE_DOCUMENT_ID = D.DOCUMENT_ID
			";
		$this->_groupBy = "GROUP BY o.REFUND_EXPORT_ID";
	}


	protected function setDocumentQueryLatePayment()
	{
		$this->_query = "SELECT MONTH(o.IMPORT_DATE) as `MONTH`,
				YEAR(o.IMPORT_DATE) as `YEAR`, R.`NAME` as PARTICIPANT_NAME,
				o.DOCUMENT_ID as Document_id,D.NAME as DocName,
				D.CREATED,
				COUNT(UDD.DOWNLOAD_DATETIME) as NumOfDownloads,
				MIN(UDD.DOWNLOAD_DATETIME) as FirstDownload, MAX(UDD.DOWNLOAD_DATETIME) as LastDownload
			FROM TBL_CRSO_PARTICIPANT_LATE_PAYMENT as o
			INNER JOIN TBL_RELATION as R
				ON o.PARTICIPANT_RELATION_ID = R.RELATION_ID
			INNER JOIN TBL_RELATION_USER as RU
				ON R.RELATION_ID = RU.RELATION_ID
			LEFT JOIN TBL_USER_DOCUMENT_DOWNLOAD as UDD
				ON RU.USER_ID = UDD.USER_ID
					AND o.DOCUMENT_ID = UDD.DOCUMENT_ID
			INNER JOIN TBL_DOCUMENT as D
				ON o.DOCUMENT_ID = D.DOCUMENT_ID

			";
		$this->_groupBy = "GROUP BY o.DOCUMENT_ID";
	}

	protected function setDocumentQueryGuarantee()
	{
		$this->_query = "SELECT MONTH(o.IMPORT_DATE) as `MONTH`,
				YEAR(o.IMPORT_DATE) as `YEAR`, R.`NAME` as PARTICIPANT_NAME,
				o.DOCUMENT_ID as Document_id,D.NAME as DocName,
				D.CREATED,
				COUNT(UDD.DOWNLOAD_DATETIME) as NumOfDownloads,
				MIN(UDD.DOWNLOAD_DATETIME) as FirstDownload, MAX(UDD.DOWNLOAD_DATETIME) as LastDownload
			FROM TBL_CRSO_PARTICIPANT_GUARANTEE as o
			INNER JOIN TBL_RELATION as R
				ON o.PARTICIPANT_RELATION_ID = R.RELATION_ID
			INNER JOIN TBL_RELATION_USER as RU
				ON R.RELATION_ID = RU.RELATION_ID
			LEFT JOIN TBL_USER_DOCUMENT_DOWNLOAD as UDD
				ON RU.USER_ID = UDD.USER_ID
					AND o.DOCUMENT_ID = UDD.DOCUMENT_ID
			INNER JOIN TBL_DOCUMENT as D
				ON o.DOCUMENT_ID = D.DOCUMENT_ID

			";
		$this->_groupBy = "GROUP BY o.DOCUMENT_ID ";
	}

	function _setWhere()
	{
		$field = ((isset($_REQUEST['DocumentType'])&&($_REQUEST['DocumentType']=='RefundRequest'))?'YEAR(o.EXPORT_DATE)':'o.`YEAR`');
		$field = ((isset($_REQUEST['DocumentType'])&&($_REQUEST['DocumentType']=='Reminders'))?'YEAR(o.IMPORT_DATE)':$field);
		$field = ((isset($_REQUEST['DocumentType'])&&($_REQUEST['DocumentType']=='LatePayment'))?'YEAR(o.IMPORT_DATE)':$field);
		$field = ((isset($_REQUEST['DocumentType'])&&($_REQUEST['DocumentType']=='Guarantee'))?'YEAR(o.IMPORT_DATE)':$field);
		$field = ((isset($_REQUEST['DocumentType'])&&($_REQUEST['DocumentType']=='All'))?'YEAR':$field);

		$crso = ((isset($_REQUEST['DocumentType'])&&($_REQUEST['DocumentType']=='All'))?'crso':'o.`CRSO_RELATION_ID`');

		$this->_addWhere('YEAR',
			array('field'=>$field,
				'callback' => array($this,'getYearSelect'),
				'required' => true));

		$this->_addWhere('CRSO_RELATION_ID',
				array('field'=>$crso,
					'callback' => array($this,'getCRSOSelect'),
					'required'=>true));
		$this->_addWhere('DocumentType',
				array('field'=>'DocumentType',
					'useinquery'=>false,
					'callback' => array($this,'getDocumentTypeSelect'),
					'required'=>true));
		$field = ((isset($_REQUEST['DocumentType'])&&($_REQUEST['DocumentType']=='RefundRequest'))?'MONTH(o.EXPORT_DATE)':'o.`MONTH`');
		$field = ((isset($_REQUEST['DocumentType'])&&($_REQUEST['DocumentType']=='Reminders'))?'MONTH(o.IMPORT_DATE)':$field);
		$field = ((isset($_REQUEST['DocumentType'])&&($_REQUEST['DocumentType']=='LatePayment'))?'MONTH(o.IMPORT_DATE)':$field);
		$field = ((isset($_REQUEST['DocumentType'])&&($_REQUEST['DocumentType']=='Guarantee'))?'MONTH(o.IMPORT_DATE)':$field);
		$field = ((isset($_REQUEST['DocumentType'])&&($_REQUEST['DocumentType']=='All'))?'MONTH':$field);
		$this->_addWhere('MONTH',
			array('field'=>$field,
				'callback' => array($this,'getMonthSelect')));

		if(isset($_REQUEST['DocumentType'])&&($_REQUEST['DocumentType']!='Reminders')&&($_REQUEST['DocumentType']!='All')
		&&($_REQUEST['DocumentType']!='LatePayment')&&($_REQUEST['DocumentType']!='Guarantee'))
		{
			$this->_addWhere('PRODUCT_ID',
				array(
					'field'=>'o.PRODUCT_ID',
					'callback' => array($this,'getProductSelect')));
		}
		$this->_addWhere('DocumentDownload',
				array('field'=>'DocumentDownload',
					'useinquery'=>false,
					'callback' => array($this,'getDownloadSelect')));
	}

	function getDocumentTypeSelect($rv='setValue')
	{
		$setValue = isset($_REQUEST['DocumentType'])?$_REQUEST['DocumentType']:'';
		$selectedValue = '';

		$select = new Form_Select('DocumentType');

		// Only enable if not CRSO or Participant
		// $select->addOption(' - '.$this->getText('All Documents').' - ', '', false);

		foreach(array('All','Declaration','RefundRequest', 'Reminders', 'LatePayment', 'Guarantee') as $type)
		{
			$trans = $this->getText($type.' Documents');
			if($setValue==$type)
				$selectedValue = $trans;
			$select->addOption($trans, $type, false);
		}
		$select->setSelectedValue($setValue);
		$filter = $select->getHtml();

		return $$rv;
	}

	function getDownloadSelect($rv='setValue')
{
		$setValue = isset($_REQUEST['DocumentDownload'])?$_REQUEST['DocumentDownload']:false;
		$selectedValue = '';

		$select = new Form_Select('DocumentDownload');

		$select->addOption(' - '.$this->getText('All').' - ', '', false);

		foreach(array('only downloaded','only not downloaded') as $i=>$type)
		{
			if($setValue==$type)
				$selectedValue = $type;
			$select->addOption($type, $i+1, false);
		}
		$select->setSelectedValue($setValue);
		$filter = $select->getHtml();

		return $$rv;
	}
	function _filterQuery()
	{
		if(isset($_REQUEST['DocumentType'])&&($_REQUEST['DocumentType']=='All'))
			$this->_addHiddenCol(array('crso','product'));
		return $this->_query;
	}

	function getProcessColumns()
	{
		$rv = array(
			'tfMonth'=>array('MONTH'),
			'tfLongNames'=>array('PARTICIPANT_NAME'),
		    'tfDocumentLink'=>array('Document_id'));
		return $rv;
	}

	function tfDocumentLink($args)
	{
		$name =  $args['value'];

		if($_SESSION['session_group_group_id'] == GROUP_SYSADMIN)
			return sprintf('<a href="/%sscripts/i-w/document/download.php?Document[id]=%d">%s</a>',SITE_PATH,$args['value'],$name);
		else
			if($_SESSION['session_group_group_id'] == GROUP_CRSO)
			{
				require_once(ELC_CLASSES.'RelationUser.php');
				$crso = new CRSO($this->db);
				$country = new Country($this->db,$crso->getCountry($_SESSION['crso_relation_id']));
				$ru = new RelationUser($this->db);
				$ru->set($_SESSION['session_user_id'],$_SESSION['crso_relation_id']);

				if($country->has(HasCrsoDeclarationDetails,$_SESSION['selected_product_id']) && $country->has(HasCrsoRefundDetails,$_SESSION['selected_product_id'])) {
					if($ru->hasClearance(CRSOClearanceDeclarationDetails) && $ru->hasClearance(CRSOClearanceRefundDetails))
						return sprintf('<a href="/%sscripts/i-w/document/download.php?Document[id]=%d">%s</a>',SITE_PATH,$args['value'],$name);
				}

			}
		return $name;
	}

	function tfSortingHat()
	{
		return array(
			'PARTICIPANT_NAME'=>"'String'",
			'YEAR'=>"'Int'",
			'MONTH'=>"'SortVal'",
			'NumOfDownloads'=>"'Int'",
			'FirstDownload'=>"'String'",
			'LastDownload'=>"'String'",
			'DocName'=>"'String'",
			'CREATED'=>"'String'"
			);
	}

	function getButtonBarText()
	{
		return $this->getText('Document Access information has been captured since v1.0.1');
	}

	function setEmptyText()
	{
		return $this->getText('No Documents Have been accessed for current Selection');
	}
}
?>
