<?php
/**
 * Created on Jan 7, 2008
 *
 * @author Nicoleta Militaru <nicoleta@basesoft.com>
 **/
 require_once(ELC_CLASSES.'uk/UKRegistrationData.php');
 require_once(ELC_CLASSES.'uk/UKCRSOData.php');
 require_once(ELC_CLASSES.'uk/UKReport.php');
 require_once(ELC_CLASSES.'CRSOProduct.php');


 class EAActualsReportList extends ELCDefaultList
{
	public $handle = 'EAActualsReportList';
	var $export = true;
	var $crso_ready = false;
	var $has_reports = true;

	function setQuery()
	{
		$crso_id = null;
		if($_SESSION['session_group_group_id'] == GROUP_CRSO)
			$crso_id = $_SESSION['crso_relation_id'];
		else
			$crso_id = (isset($_REQUEST['CRSO_RELATION_ID']) && !empty($_REQUEST['CRSO_RELATION_ID']))?(int)$_REQUEST['CRSO_RELATION_ID']:false;
		if($crso_id == null)
			throw new InterfacePermissionException('Unauthorized Access');
		$this->can_export = false;
		$this->all_quarters = false;
		$this->old_schema = false;
		if(isset($_REQUEST['YEAR']) && !empty($_REQUEST['YEAR'])){
			$quarter = null;
			if(isset($_REQUEST['QUARTER']) && !empty($_REQUEST['QUARTER']))
				$quarter = $_REQUEST['QUARTER'];
			if($quarter == null) {
				if($_REQUEST['YEAR'] <= 2009)
					$this->old_schema = true;
				$ukr = new UKReport($this->db);
				if($ukr->hasAllYearReports($crso_id, $_REQUEST['YEAR']))// can make an yearly report
				{
					$this->can_export = true;
					$this->all_quarters = true;

					// special case for exporting yearly report for 2010
					// need to check if crso data for q4 2010 is set, since that contains recycle data for the whole year 2010
					if($_REQUEST['YEAR'] == 2010){
						$crso_data = new UKCRSOData($this->db);
						if($crso_data->set($crso_id,$_REQUEST['YEAR'],4))
							if($crso_data->status == PUBLISHED || $crso_data->status == CRSO_DATA_ACCEPTED)
								$this->crso_ready = true;
					}
					else
						$this->crso_ready = true;
				}

					// get reports for the 4 quarters
					$rep =  "
						SELECT MAX(UKR.REPORT_ID) AS REPORT_ID
						FROM TBL_UK_REPORTS UKR
						WHERE UKR.CRSO_RELATION_ID = ?
						AND UKR.YEAR = ? AND UKR.QUARTER = ?
						AND UKR.STATUS=2";
					$qr = $this->db->query($rep);
					$qr->bind_values($crso_id, $_REQUEST['YEAR'], 1);
					$qr->execute();
					$r = $qr->fetch();
					$r1 = "NULL";
					if($r->REPORT_ID)
						$r1 = $r->REPORT_ID;

					$qr = $this->db->query($rep);
					$qr->bind_values($crso_id, $_REQUEST['YEAR'], 2);
					$qr->execute();
					$r = $qr->fetch();
					$r2 = "NULL";
					if($r->REPORT_ID)
						$r2 = $r->REPORT_ID;

					$qr = $this->db->query($rep);
					$qr->bind_values($crso_id, $_REQUEST['YEAR'], 3);
					$qr->execute();
					$r3 = "NULL";
					$r = $qr->fetch();
					if($r->REPORT_ID)
						$r3 = $r->REPORT_ID;

					$qr = $this->db->query($rep);
					$qr->bind_values($crso_id, $_REQUEST['YEAR'], 4);
					$qr->execute();
					$r4 = "NULL";
					$r = $qr->fetch();
					if($r->REPORT_ID)
						$r4 = $r->REPORT_ID;

					$this->_query = "SELECT UK.PARTICIPANT_RELATION_ID,UK.BUSINESS_NAME AS PARTICIPANT_NAME,
								CP.PRODUCER_REG_NO as PRN,
								UK1.WEEE_STATUS AS STATUS_Q1,
                                UK2.WEEE_STATUS AS STATUS_Q2,
                                UK3.WEEE_STATUS AS STATUS_Q3,
                                UK4.WEEE_STATUS AS STATUS_Q4,
								UK.WEEE_STATUS AS CURRENT_STATUS

								FROM TBL_UK_REGISTRATION_DATA UK
								LEFT JOIN TBL_UK_REPORT_DATA UK1
									ON UK.CRSO_RELATION_ID = UK1.CRSO_RELATION_ID
									AND UK.PARTICIPANT_RELATION_ID = UK1.PARTICIPANT_RELATION_ID
									AND UK1.REPORT_ID=".$r2."
								LEFT JOIN TBL_UK_REPORT_DATA UK2
									ON UK.CRSO_RELATION_ID = UK2.CRSO_RELATION_ID
									AND UK.PARTICIPANT_RELATION_ID = UK2.PARTICIPANT_RELATION_ID
									AND UK2.REPORT_ID=".$r2."
								LEFT JOIN TBL_UK_REPORT_DATA UK3
									ON UK.CRSO_RELATION_ID = UK3.CRSO_RELATION_ID
									AND UK.PARTICIPANT_RELATION_ID = UK3.PARTICIPANT_RELATION_ID
									AND UK3.REPORT_ID=".$r3."
								LEFT JOIN TBL_UK_REPORT_DATA UK4
									ON UK.CRSO_RELATION_ID = UK4.CRSO_RELATION_ID
									AND UK.PARTICIPANT_RELATION_ID = UK4.PARTICIPANT_RELATION_ID
									AND UK4.REPORT_ID=".$r4."
								LEFT JOIN TBL_CRSO_PARTICIPANT CP
									ON UK.CRSO_RELATION_ID = CP.CRSO_RELATION_ID
									AND UK.PARTICIPANT_RELATION_ID = CP.PARTICIPANT_RELATION_ID";
			}
			else {
				if($_REQUEST['YEAR'] <= 2010)
					$this->old_schema = true;
				$this->can_export = true;
				$crso_data = new UKCRSOData($this->db);
				if($crso_data->set($crso_id,$_REQUEST['YEAR'],$_REQUEST['QUARTER']))
					$this->crso_ready = true;

				$rep =  "
					SELECT MAX(UKR.REPORT_ID) AS REPORT_ID
					FROM TBL_UK_REPORTS UKR
					WHERE UKR.CRSO_RELATION_ID = ?
					AND UKR.YEAR = ? AND UKR.QUARTER = ?
					AND UKR.STATUS=2";
				$qr = $this->db->query($rep);
				$qr->bind_values($crso_id, $_REQUEST['YEAR'], $_REQUEST['QUARTER']);
				$qr->execute();
				$rid = $qr->fetch()->REPORT_ID;
				// if there are no exports for this quarter, get current dataset
				if(!$rid)
					$this->_query = "SELECT UK.PARTICIPANT_RELATION_ID,UK.BUSINESS_NAME AS PARTICIPANT_NAME,
							CP.PRODUCER_REG_NO as PRN, UK.WEEE_STATUS AS STATUS_ACTUALS_REPORT,UK.CRSO_RELATION_ID
							FROM TBL_UK_REGISTRATION_DATA UK
							INNER JOIN TBL_CRSO_PARTICIPANT CP
								ON UK.CRSO_RELATION_ID = CP.CRSO_RELATION_ID
								AND UK.PARTICIPANT_RELATION_ID = CP.PARTICIPANT_RELATION_ID
								AND UK.WEEE_STATUS = 2 ";
				// else get same dataset as for the last report exported for this quarter
				// (keep those statuses except for the ones for producers excluded because of no PRN, which will use current statuses)
				else
					$this->_query = "SELECT UK.PARTICIPANT_RELATION_ID,UKREG.BUSINESS_NAME AS PARTICIPANT_NAME,
							CP.PRODUCER_REG_NO as PRN,
							UK.WEEE_STATUS AS STATUS_LAST_EXPORT,
							UKREG.WEEE_STATUS AS CURRENT_STATUS,
							UK.CRSO_RELATION_ID
							FROM TBL_UK_REPORT_DATA UK
							INNER JOIN TBL_UK_REGISTRATION_DATA UKREG
								ON UKREG.CRSO_RELATION_ID = UK.CRSO_RELATION_ID
								AND UKREG.PARTICIPANT_RELATION_ID = UK.PARTICIPANT_RELATION_ID
								AND UK.REPORT_ID=".$rid."
								AND (UK.WEEE_STATUS = 2 OR UK.WEEE_STATUS = 1)
							INNER JOIN TBL_CRSO_PARTICIPANT CP
								ON UK.CRSO_RELATION_ID = CP.CRSO_RELATION_ID
								AND UK.PARTICIPANT_RELATION_ID = CP.PARTICIPANT_RELATION_ID";
				$this->_orderBy = "ORDER BY UK.PARTICIPANT_RELATION_ID";
				$this->_addHiddenCol(array('YEAR','QUARTER'));
			}
		}
	}
	function _setWhere()
	{
		$this->_addWhere('CRSO_RELATION_ID',
			array('field'=>'UK.CRSO_RELATION_ID',
				'callback' => array($this,'getCRSOSelect'),
				'required'=>true));
		$this->_addWhere('YEAR',
				array('field'=>'\'\'',
					'callback' => array($this,'getYearSelect'),
					'required'=>true,
					'operator'=>' != '));
		$this->_addWhere('QUARTER',
			array('field'=>'\'\'',
				'callback' => array($this,'getQuarterSelect'),
				//'required'=>true,
				'operator'=>' != '));
	}
	function getYearSelect($rv='setValue')
    {
		if(!$this->export)
			return;
    	$setValue = !empty($_REQUEST['YEAR'])?(int)$_REQUEST['YEAR']:false;

		$crso_id = isset($_REQUEST['CRSO_RELATION_ID'])?(int)$_REQUEST['CRSO_RELATION_ID']:false;
		switch($_SESSION['session_group_group_id'])
		{
			case GROUP_CRSO:
				 $crso_id = $_SESSION['crso_relation_id'];
			break;
		}
		if(!$crso_id)
			$filter = '';

    	$years = array();
    	$rep = new UKReport($this->db);
    	$years = $rep->getYearsForWeeeExport($crso_id);

		if(count($years) == 0)
		{
			$this->has_reports = false;
			return;
		}
		if(isset($$rv))
			return $$rv;
		$selectedValue = '';

    	$select = new Form_Select('YEAR');

		$select->addOption(' - Select Year - ', '0', false);
	    foreach($years as $key => $year)
	    {
		if($setValue==$year)
				$selectedValue = $year;
			$select->addOption($year, $year, false);
	    }
		$select->setSelectedValue($setValue);

		$filter = $select->getHtml();
    	return $$rv;
    }
    function getQuarterSelect($rv='setValue')
    {
		if(!$this->export)
			return;
    	$setValue = !empty($_REQUEST['QUARTER'])?(int)$_REQUEST['QUARTER']:false;

		$crso_id = isset($_REQUEST['CRSO_RELATION_ID'])?(int)$_REQUEST['CRSO_RELATION_ID']:false;
		switch($_SESSION['session_group_group_id'])
		{
			case GROUP_CRSO:
				 $crso_id = $_SESSION['crso_relation_id'];
			break;
		}
		$year = isset($_REQUEST['YEAR'])?(int)$_REQUEST['YEAR']:false;
		if(!is_numeric($crso_id) || !$year)
			$filter = '';

		$quarters = array();
    	$rep = new UKReport($this->db);
		$quarters = $rep->getQuartersForWeeeExport($crso_id,$year, true);

		if(count($quarters) == 0)
			return;
		if(isset($$rv))
			return $$rv;
		$selectedValue = '';

    	$select = new Form_Select('QUARTER');

		$select->addOption(' - Select Quarter - ', '0', false);
	    foreach($quarters as $key => $quarter)
	    {
		if($setValue==$quarter)
				$selectedValue = $quarter;
			$select->addOption('Quarter '.$quarter, $quarter, false);
	    }
		$select->setSelectedValue($setValue);
		$filter = $select->getHtml();
    	return $$rv;
    }
	function getCRSOSelect($rv='setValue')
	{
		$setValue = !empty($_REQUEST['CRSO_RELATION_ID'])?(int)$_REQUEST['CRSO_RELATION_ID']:false;
		switch($_SESSION['session_group_group_id'])
		{
			case GROUP_CRSO:
				$filter = '';
				$selectedValue = '';
				if(isset($_REQUEST['CRSO_RELATION_ID']) && ($_REQUEST['CRSO_RELATION_ID']!=$_SESSION['crso_relation_id']))
					throw new IWAJAXPermissionException('Incorrect CRSO Id supplied');
				$_REQUEST['CRSO_RELATION_ID'] = $setValue = $_SESSION['crso_relation_id'];
				$rs = array();
				break;
			case GROUP_ACCOUNTANT:
				$sql = "SELECT R.RELATION_ID as CRSO_RELATION_ID, R.`NAME`
					FROM TBL_ACCOUNTANT_CRSO as AC
					INNER JOIN TBL_RELATION as R
						ON AC.CRSO_RELATION_ID = R.RELATION_ID
					INNER JOIN TBL_ADDRESS as A
						USING(ADDRESS_ID)
					WHERE A.COUNTRY_ID = 826
					AND AC.ACCOUNTANT_RELATION_ID = ".$_SESSION['accountant_relation_id']."
					ORDER BY NAME";
				$q = $this->db->query($sql);
				$q->execute();
				$rs = $q->fetchAll();
			break;
			case GROUP_SYSADMIN:
				$sql = "SELECT R.RELATION_ID as CRSO_RELATION_ID, R.`NAME`
					FROM TBL_CRSO as C
					INNER JOIN TBL_RELATION as R
						ON C.CRSO_RELATION_ID = R.RELATION_ID
					INNER JOIN TBL_ADDRESS as A
						USING(ADDRESS_ID)
					WHERE A.COUNTRY_ID = 826
					ORDER BY NAME";
				$q = $this->db->query($sql);
				$q->execute();
				$rs = $q->fetchAll();
			break;
		}

		if(count($rs) == 1)
		{
			$setValue = $rs[0]->CRSO_RELATION_ID;
			$_REQUEST['CRSO_RELATION_ID'] = $setValue;
		}

		if(isset($$rv))
			return $$rv;
		$selectedValue = '';

		$select = new Form_Select('CRSO_RELATION_ID');
		$select->addOption(' - '.$this->getText('CRSO Select').' - ', '', false);
		foreach($rs as $r)
		{
			if($setValue==$r->CRSO_RELATION_ID)
				$selectedValue = $r->NAME;
			$select->addOption(((mb_strlen($r->NAME)>35)?mb_substr($r->NAME,0,35).'...':$r->NAME), $r->CRSO_RELATION_ID, false);
		}
		$select->setSelectedValue($setValue);

		$filter = $select->getHtml();

		return $$rv;
	}
	function tfTranslateWEEEStatus($args)
	{
		$args['extra'] = sprintf(' sort_val="%s" ', $args['value']);
		if($args['value'] == null) {
            $trans = '-';
            $class = '';
		}
		else
            list($trans,$class) = UKRegistrationData::translateWEEEStatus($this->langIf,$args['value']);
		return sprintf('<span class="%s">%s</span>',$class,$trans);
	}
	function getProcessColumns()
	{
		return array(
			'tfTranslateWEEEStatus'=>array('STATUS_ACTUALS_REPORT', 'STATUS_Q1', 'STATUS_LAST_EXPORT',
			                  'STATUS_Q2', 'STATUS_Q3', 'STATUS_Q4', 'CURRENT_STATUS')
		);
	}
	function getDataSet()
	{
		$ukr = new UKReport($this->db);
		if(isset($_GET['preview_weee']) && $_GET['preview_weee'] == '1')
		{
			$quarter = null;
			if(isset($_REQUEST['QUARTER']) && !empty($_REQUEST['QUARTER']))
				$quarter = $_REQUEST['QUARTER'];
			$file = $ukr->exportWeee($_REQUEST['CRSO_RELATION_ID'],$_REQUEST['YEAR'],$quarter,true);
			$xml = file_get_contents($file);
			header('Content-Type: text/xml');
			echo $xml;
			die();
		}
		if(isset($_POST['process']) && $_POST['process'] != 'print')
			if($_POST['process'] == 'export')
			{
				$quarter = null;
				if(isset($_REQUEST['QUARTER']) && !empty($_REQUEST['QUARTER']))
					$quarter = $_REQUEST['QUARTER'];

				if($ukr->isGracePeriod($_REQUEST['CRSO_RELATION_ID'],$_REQUEST['YEAR'],$quarter)) {
					throw new Exception('Cannot export while in grace period');
				}


				$file = $ukr->exportWeee($_REQUEST['CRSO_RELATION_ID'],$_REQUEST['YEAR'],$quarter,false);
				$xml = file_get_contents($file);
				header('Content-Disposition: attachment; filename="'.basename($file).'"');
				echo $xml;
				die();
			}
		if(isset($_REQUEST['CRSO_RELATION_ID']) && !$ukr->hasUnconfirmedReport($_REQUEST['CRSO_RELATION_ID'],ACTUALS_REPORT))
		{
			$this->export = false;
			return '';
		}
		return parent::getDataSet();
	}
	function getPostScript()
	{
		$rv = "
			function forExport()
			{
				document.getElementsByName('process')[0].value='export';
				document.getElementById('interface_form').submit();
				document.getElementById('ifI_1009_CB_1').disabled = true;
				document.getElementById('ifI_1009_CB_0').disabled = true;
			}
			function preview(url)
			{
				mywindow = window.open(url, 'id','toolbar=0,scrollbars=1,location=0,statusbar=0,menubar=0,resizable=1,width=900,height=800');
				mywindow.moveTo(100,50);
				document.getElementById('ifI_1009_CB_1').disabled = false;
			}
			function notReadyForExport()
			{
				MessageBox.prototype.Information('Notice', 'This report cannot be exported as the Export day has not passed yet.');
			}
		";
		return $rv;
	}
	function getButtons()
	{
		$settings = array();
		$quarter = '';
		if(isset($_REQUEST['QUARTER']))
			$quarter = $_REQUEST['QUARTER'];
		if($this->old_schema)
			return $settings;
		if($this->export && $this->can_export && $this->crso_ready)
		{

			$ukr = new UKReport($this->db);
			$grace = $ukr->isGracePeriod($_REQUEST['CRSO_RELATION_ID'], $_REQUEST['YEAR'], $quarter);

			if($_SESSION['session_group_group_id'] == GROUP_CRSO)
				$url = SITE_PATH.'/scripts/elc/crso/InterfaceEAActualsReportList.php?preview_weee=1'
				         . '&CRSO_RELATION_ID='.$_REQUEST['CRSO_RELATION_ID']
				         . '&YEAR='.$_REQUEST['YEAR']
				         . '&QUARTER='.$quarter;
			if($_SESSION['session_group_group_id'] == GROUP_ACCOUNTANT)
				$url = SITE_PATH.'/scripts/elc/accountant/InterfaceEAActualsReportList.php?preview_weee=1'
				         . '&CRSO_RELATION_ID='.$_REQUEST['CRSO_RELATION_ID']
				         . '&YEAR='.$_REQUEST['YEAR']
				         . '&QUARTER='.$quarter;
			if($_SESSION['session_group_group_id'] == GROUP_SYSADMIN)
				$url = SITE_PATH.'/scripts/elc/sysadmin/InterfaceEAActualsReportList.php?preview_weee=1'
				         . '&CRSO_RELATION_ID='.$_REQUEST['CRSO_RELATION_ID']
				         . '&YEAR='.$_REQUEST['YEAR']
				         . '&QUARTER='.$quarter;

			$settings['Preview Report'] = array('onclick'=>"preview('".$url."');");
			$settings['Export Report'] = array('onclick'=>$grace?"notReadyForExport();":"forExport();",'disabled'=>true);
		}
		else
		{
			$settings['Preview Report'] = array('disabled'=>true);
			$settings['Export Report'] = array('disabled'=>true);
		}
	    return $settings;
	}
	function setEmptyText()
	{
		return $this->getText('Nothing for export');
	}
	function tfFooter()
	{
		if(!$this->export)
			return "<span class=\"error\">".
				$this->langIf->getText("The last EA Weee Actuals Report for this CRSO was not confirmed. Please confirm if it was accepted or rejected by EA.")
					."</span>";
		else
			if(!$this->has_reports)
				return "<span class=\"error\">".
				$this->langIf->getText("All available reports for this CRSO have been exported")."</span>";
			else
				return;
	}
	function getButtonBarText()
	{
		if(!$this->export || $this->old_schema)
			return;
		if($this->all_quarters ==false && (isset($_REQUEST['YEAR']) && !empty($_REQUEST['YEAR'])) &&
			(!isset($_REQUEST['QUARTER']) || empty($_REQUEST['QUARTER'])))
			return "<span class=\"error\">".$this->langIf->getText("Cannot export yearly report before all quarters have been exported.");
		if($this->can_export && !$this->crso_ready)
			return "<span class=\"error\">".$this->langIf->getText("CRSO recycle data for this export is not published.");
		if($this->can_export)
			return "<span class=\"error\">".$this->langIf->getText("Please review all data before export");
	}
}

?>
