<?php
/**
 * Created on Jan 3, 2008
 *
 * @author Nicoleta Militaru <nicoleta@basesoft.com>
 **/
 require_once(ELC_CLASSES.'uk/UKRegistrationData.php');
 require_once(ELC_CLASSES.'uk/UKReport.php');


 class EAPRReportList extends ELCDefaultList
{
	public $handle = 'EAPRReportList';
	var $export = true;
	var $empty_data_set = false;

	function setQuery()
	{
		$this->_query = "
			SELECT RELATION_ID,PARTICIPANT_NAME,PRODUCER_REG_NO,STATUS_REG_REPORT,CRSO_RELATION_ID FROM
			(
			(SELECT UK.PARTICIPANT_RELATION_ID AS RELATION_ID,R.NAME AS PARTICIPANT_NAME,
				CP.PRODUCER_REG_NO,
				UK.PR_STATUS AS STATUS_REG_REPORT,UK.CRSO_RELATION_ID
			FROM TBL_UK_REGISTRATION_DATA UK
			INNER JOIN TBL_RELATION RR
				ON UK.CRSO_RELATION_ID = RR.RELATION_ID
			INNER JOIN TBL_RELATION R
				ON UK.PARTICIPANT_RELATION_ID = R.RELATION_ID
				AND UK.PR_STATUS = 2
			INNER JOIN TBL_CRSO_PARTICIPANT CP
				ON CP.CRSO_RELATION_ID = UK.CRSO_RELATION_ID
				AND CP.PARTICIPANT_RELATION_ID = UK.PARTICIPANT_RELATION_ID
				AND CP.PRODUCER_REG_NO REGEXP '^((WEE\/)[A-Z]{2}[0-9]{4}[A-Z]{2})?$')
		UNION
		(SELECT UK.PARTICIPANT_RELATION_ID AS RELATION_ID,R.NAME AS PARTICIPANT_NAME,
				CP.PRODUCER_REG_NO,
				UK.PR_STATUS AS STATUS_REG_REPORT,UK.CRSO_RELATION_ID
			FROM TBL_UK_REGISTRATION_DATA UK
			INNER JOIN TBL_RELATION RR
				ON UK.CRSO_RELATION_ID = RR.RELATION_ID
			INNER JOIN TBL_RELATION R
				ON UK.PARTICIPANT_RELATION_ID = R.RELATION_ID
				AND UK.PR_STATUS = 1
			INNER JOIN TBL_CRSO_PARTICIPANT CP
				ON CP.CRSO_RELATION_ID = UK.CRSO_RELATION_ID
				AND CP.PARTICIPANT_RELATION_ID = UK.PARTICIPANT_RELATION_ID)
		) AS T
		";
		$this->_orderBy = "ORDER BY PARTICIPANT_NAME";
	}
	function _setWhere()
	{
		$this->_addWhere('CRSO_RELATION_ID',
			array('field'=>'CRSO_RELATION_ID',
				'callback' => array($this,'getCRSOSelect'),
				'required'=>true));
		$this->_addWhere('YEAR',
				array('field'=>'\'\'',
					'callback' => array($this,'getYearSelect'),
					'required'=>true,
					'operator'=>' != '));
	}
	function getYearSelect($rv='setValue')
    {
		if(!$this->export)
			return;
		$setValue = !empty($_REQUEST['YEAR'])?(int)$_REQUEST['YEAR']:false;

		$crso_id = isset($_REQUEST['CRSO_RELATION_ID'])?(int)$_REQUEST['CRSO_RELATION_ID']:false;
		switch($_SESSION['session_group_group_id'])
		{
			case GROUP_CRSO:
				 $crso_id = $_SESSION['crso_relation_id'];
			break;
		}
		if(!$crso_id)
			$filter = '';

	$date = currentDate();
	$year = $date->getYear();
	$month = $date->getMonth();
	// reports for registrations for the next year shouldn't be exported before October
	// so only add next year in the filter if month is between Oct and Dec
	if ($month >= 10)
		$years = array($year, $year+1);
	else
		$years = array($year);
	if(count($years) == 0)
	{
		$this->has_reports = false;
		return;
	}
	if(count($years) == 1)
		{
			$setValue = $years[0];
			$_REQUEST['YEAR'] = $setValue;
		}
	if(isset($$rv))
			return $$rv;
		$selectedValue = '';

	$select = new Form_Select('YEAR');

	$select->addOption(' - Select Year - ', '0', false);
	    foreach($years as $key => $year)
	    {
		if($setValue==$year)
				$selectedValue = $year;
			$select->addOption($year, $year, false);
	    }
		$select->setSelectedValue($setValue);

		$filter = $select->getHtml();
	return $$rv;
    }
	function getCRSOSelect($rv='setValue')
	{
		$setValue = !empty($_REQUEST['CRSO_RELATION_ID'])?(int)$_REQUEST['CRSO_RELATION_ID']:false;
		switch($_SESSION['session_group_group_id'])
		{
		case GROUP_CRSO:
				$filter = '';
				$selectedValue = '';
				if(isset($_REQUEST['CRSO_RELATION_ID']) && ($_REQUEST['CRSO_RELATION_ID']!=$_SESSION['crso_relation_id']))
					throw new IWAJAXPermissionException('Incorrect CRSO Id supplied');
				$_REQUEST['CRSO_RELATION_ID'] = $setValue = $_SESSION['crso_relation_id'];
				$rs = array();
				break;
			case GROUP_ACCOUNTANT:
				$sql = "SELECT R.RELATION_ID as CRSO_RELATION_ID, R.`NAME`
					FROM TBL_ACCOUNTANT_CRSO as AC
					INNER JOIN TBL_RELATION as R
						ON AC.CRSO_RELATION_ID = R.RELATION_ID
					INNER JOIN TBL_ADDRESS as A
						USING(ADDRESS_ID)
					WHERE A.COUNTRY_ID = 826
					AND AC.ACCOUNTANT_RELATION_ID = ".$_SESSION['accountant_relation_id']."
					ORDER BY NAME";
				$q = $this->db->query($sql);
				$q->execute();
				$rs = $q->fetchAll();
			break;
			case GROUP_SYSADMIN:
				$sql = "SELECT R.RELATION_ID as CRSO_RELATION_ID, R.`NAME`
					FROM TBL_CRSO as C
					INNER JOIN TBL_RELATION as R
						ON C.CRSO_RELATION_ID = R.RELATION_ID
					INNER JOIN TBL_ADDRESS as A
						USING(ADDRESS_ID)
					WHERE A.COUNTRY_ID = 826
					ORDER BY NAME";
				$q = $this->db->query($sql);
				$q->execute();
				$rs = $q->fetchAll();
			break;
		}

		if(count($rs) == 1)
		{
			$setValue = $rs[0]->CRSO_RELATION_ID;
			$_REQUEST['CRSO_RELATION_ID'] = $setValue;
		}

		if(isset($$rv))
			return $$rv;
		$selectedValue = '';

		$select = new Form_Select('CRSO_RELATION_ID');
		$select->addOption(' - '.$this->getText('CRSO Select').' - ', '', false);
		foreach($rs as $r)
		{
			if($setValue==$r->CRSO_RELATION_ID)
				$selectedValue = $r->NAME;
			$select->addOption(((mb_strlen($r->NAME)>35)?mb_substr($r->NAME,0,35).'...':$r->NAME), $r->CRSO_RELATION_ID, false);
		}
		$select->setSelectedValue($setValue);

		$filter = $select->getHtml();

		return $$rv;
	}
	function tfTranslatePRStatus($args)
	{
		$args['extra'] = sprintf(' sort_val="%s" ', $args['value']);
		list($trans,$class) = UKRegistrationData::translatePRStatus($this->langIf,$args['value']);
		return sprintf('<span class="%s">%s</span>',$class,$trans);
	}
	function tfRegLink($args)
	{
		//$args['extra'] .= sprintf(' sort_val="%s" ', $args['value']);
		if($_SESSION['session_group_group_id'] == GROUP_CRSO)
			return sprintf('<a href="/%sscripts/elc/crso/InterfaceUKXMLPreparation.php?participant[id]=%s" title="%s">%s</a>',
				SITE_PATH,
				$args['value'],
				$this->langIf->getText('view EA Registration Data'),
				$args['value']
				);
		if($_SESSION['session_group_group_id'] == GROUP_ACCOUNTANT)
			return sprintf('<a href="/%sscripts/elc/accountant/InterfaceUKXMLPreparation.php?participant[id]=%s&crso[id]=%s" title="%s">%s</a>',
				SITE_PATH,
				$args['value'],
				$_REQUEST['CRSO_RELATION_ID'],
				$this->langIf->getText('view EA Registration Data'),
				$args['value']
				);
		if($_SESSION['session_group_group_id'] == GROUP_SYSADMIN)
			return sprintf('<a href="/%sscripts/elc/sysadmin/InterfaceUKXMLPreparation.php?participant[id]=%s&crso[id]=%s" title="%s">%s</a>',
				SITE_PATH,
				$args['value'],
				$_REQUEST['CRSO_RELATION_ID'],
				$this->langIf->getText('view EA Registration Data'),
				$args['value']
				);

	}
	function getProcessColumns()
	{
		return array(
			'tfRegLink'=> array('RELATION_ID'),
			'tfTranslatePRStatus'=>array('STATUS_REG_REPORT')
		);
	}
	function getDataSet()
	{
		$ukr = new UKReport($this->db);
		if(isset($_GET['preview_pr']) && $_GET['preview_pr'] == '1')
		{
			$file = $ukr->exportPR($_REQUEST['CRSO_RELATION_ID'],$_REQUEST['YEAR'],true);
			$xml = file_get_contents($file);
			header('Content-Type: text/xml');
			echo $xml;
			die();
		}
		if(isset($_POST['process']) && $_POST['process'] != 'print')
			if($_POST['process'] == 'export')
			{
				$file = $ukr->exportPR($_REQUEST['CRSO_RELATION_ID'],$_REQUEST['YEAR'],false);

				if($file == 'exists')
				{   info('Could not create archive. Possible reason: archive already exists!');
					throw new IWUserException('Could not create archive. Possible reason: archive already exists!');
				}
				// Headers for download:
				header('Content-Type: application/octet-stream');
				header('Content-Disposition: attachment; filename="'.basename($file).'"');
				header('Content-Transfer-Encoding: binary');
				readfile($file);
			}
		if(isset($_REQUEST['CRSO_RELATION_ID']))
		{
			if(!$ukr->hasUnconfirmedReport($_REQUEST['CRSO_RELATION_ID'],REG_REPORT))
			{
				$this->export = false;
				return '';
			}

			$ukrd = new UKRegistrationData($this->db);
			if(!$ukrd->hasPRDataForExport($_REQUEST['CRSO_RELATION_ID']))
			{
				$this->empty_data_set = true;
				//return '';
			}
		}
		return parent::getDataSet();
	}
	function getPostScript()
	{
		$rv = "
			function forExport()
			{
				document.getElementsByName('process')[0].value='export';
				document.getElementById('interface_form').submit();
				document.getElementById('ifI_1009_CB_1').disabled = true;
				document.getElementById('ifI_1009_CB_0').disabled = true;
			}
			function preview(url)
			{
				mywindow = window.open(url, 'id', 'toolbar=0,scrollbars=1,location=0,statusbar=0,menubar=0,resizable=1,width=900,height=800');
				mywindow.moveTo(100,50);
				document.getElementById('ifI_1009_CB_1').disabled = false;
			}
		";
		return $rv;
	}
	function getButtons()
	{
		$settings = array();
		if(!$this->empty_data_set && $this->export && (isset($_REQUEST['CRSO_RELATION_ID']) && !empty($_REQUEST['CRSO_RELATION_ID']))
						 && (isset($_REQUEST['YEAR']) && !empty($_REQUEST['YEAR'])))
		{
			if($_SESSION['session_group_group_id'] == GROUP_CRSO)
				$url = SITE_PATH.'/scripts/elc/crso/InterfaceEAPRReportList.php?preview_pr=1'
				         . '&CRSO_RELATION_ID='.$_REQUEST['CRSO_RELATION_ID']
				         . '&YEAR='.$_REQUEST['YEAR'];
			if($_SESSION['session_group_group_id'] == GROUP_ACCOUNTANT)
				$url = SITE_PATH.'/scripts/elc/accountant/InterfaceEAPRReportList.php?preview_pr=1'
				         . '&CRSO_RELATION_ID='.$_REQUEST['CRSO_RELATION_ID']
				         . '&YEAR='.$_REQUEST['YEAR'];
			if($_SESSION['session_group_group_id'] == GROUP_SYSADMIN)
				$url = SITE_PATH.'/scripts/elc/sysadmin/InterfaceEAPRReportList.php?preview_pr=1'
				         . '&CRSO_RELATION_ID='.$_REQUEST['CRSO_RELATION_ID']
				         . '&YEAR='.$_REQUEST['YEAR'];
			$settings['Preview Report'] = array('onclick'=>"preview('".$url."');");
			$settings['Export Report'] = array('onclick'=>"forExport();",'disabled'=>true);
		}
		else
		{
			$settings['Preview Report'] = array('disabled'=>true);
			$settings['Export Report'] = array('disabled'=>true);
		}
	    return $settings;
	}
	function setEmptyText()
	{
		return $this->getText('Nothing for export');
	}
	function tfFooter()
	{
		if(!$this->export)
			return "<span class=\"error\">".
				$this->langIf->getText("The last Producer Registartion Report for this CRSO was not confirmed.
					Please confirm if it was accepted or rejected by EA.")."</span>";
		else
			return;
	}
	function getButtonBarText()
	{
		if($this->empty_data_set)
			return;
		if(!$this->export)
			return;
		if(isset($_REQUEST['CRSO_RELATION_ID']) && !empty($_REQUEST['CRSO_RELATION_ID']))
			return "<span class=\"error\">".$this->langIf->getText("Please review all data before export");
	}
}

?>
