<?php
/**
 * Created on Dec 19, 2007
 *
 * @author Nicoleta Militaru <nicoleta@basesoft.com>
 */

require_once(ELC_CLASSES.'uk/UKRegistrationData.php');


 class EAProducerRegistrationList extends ELCDefaultList
{
	public $handle = 'EAProducerRegistrationList';

	function setQuery()
	{
		$this->_query = "
			SELECT UK.PARTICIPANT_RELATION_ID AS RELATION_ID,R.NAME AS PARTICIPANT_NAME,CP.PRODUCER_REG_NO,
				UK.CREATED AS EA_DATA_CREATED,UK.LAST_UPDATE,UK.PR_STATUS AS STATUS_REG_REPORT,
				UK.LAST_EXPORTED_PR as LAST_EXPORTED_REG,
				UK.WEEE_STATUS AS STATUS_ACTUALS_REPORT,
				UK.LAST_EXPORTED_WEEE as LAST_EXPORTED_ACTUALS
			FROM TBL_UK_REGISTRATION_DATA UK
			INNER JOIN TBL_RELATION RR
				ON UK.CRSO_RELATION_ID = RR.RELATION_ID
			INNER JOIN TBL_RELATION R
				ON UK.PARTICIPANT_RELATION_ID = R.RELATION_ID
			INNER JOIN TBL_CRSO_PARTICIPANT CP
				ON CP.CRSO_RELATION_ID = UK.CRSO_RELATION_ID
				AND CP.PARTICIPANT_RELATION_ID = UK.PARTICIPANT_RELATION_ID
			";
		$this->_orderBy = "ORDER BY PARTICIPANT_NAME";
		if(isset($_REQUEST['PR_STATUS']) && $_REQUEST['PR_STATUS'] != '0')
			$this->_addHiddenCol(array('STATUS_ACTUALS_REPORT','LAST_EXPORTED_ACTUALS'));
		if(isset($_REQUEST['WEEE_STATUS']) && $_REQUEST['WEEE_STATUS'] != '0')
			$this->_addHiddenCol(array('STATUS_REG_REPORT','LAST_EXPORTED_REG'));
	}
	function _setWhere()
	{
		$this->_addWhere('CRSO_RELATION_ID',
			array(
				'field'=>'UK.CRSO_RELATION_ID',
				'callback' => array($this,'getCRSOSelect'),
				'required'=>true));
		$this->_addWhere('PARTICIPANT_RELATION_ID',
			array('field'=>'UK.PARTICIPANT_RELATION_ID',
				'callback' => array($this,'getParticipantSelect'),
				'related'=>array('PARTICIPANT_NAME')));
		$this->_addWhere('PR_STATUS',
			array('field'=>'UK.PR_STATUS',
				'callback' => array($this,'getPRStatusSelect'),
				));
		$this->_addWhere('WEEE_STATUS',
			array('field'=>'UK.WEEE_STATUS',
				'callback' => array($this,'getWEEEStatusSelect'),
				));
	}
	function getWEEEStatusSelect($rv='setValue')
	{
		$setValue = isset($_REQUEST['WEEE_STATUS'])?$_REQUEST['WEEE_STATUS']:'';
		$selectedValue = '';

		$select = new Form_Select('WEEE_STATUS');

		//DONT CHANGE THIS ORDER !!!!!
		foreach(array(
				' - Status for Actuals Report - ',
				'Excluded - NO Reg No',
				'Good for export',
				'Excluded - settings',
				'Excluded - data incorrect',
				'Exported',
				//'Data Accepted'
				) as $key => $type)
		{
			$trans = $this->getText($type);
			if($setValue==$type)
				$selectedValue = $trans;
			$select->addOption($trans, $key, false);
		}
		$select->setSelectedValue($setValue);
		if(isset($_REQUEST['PR_STATUS']) && $_REQUEST['PR_STATUS'] != '0')
			$select->setDisabled();
		$filter = $select->getHtml();

		return $$rv;
	}
	function getPRStatusSelect($rv='setValue')
	{
		$setValue = isset($_REQUEST['PR_STATUS'])?$_REQUEST['PR_STATUS']:'';
		$selectedValue = '';

		$select = new Form_Select('PR_STATUS');

		//DONT CHANGE THIS ORDER !!!!!
		foreach(array(
				' - Status for Reg Report - ',
				'New Registration',
				'Registration data changed',
				'Excluded - settings (I)',
				'Excluded - settings (A)',
				'Excluded - data incorrect (I)',
				'Excluded - data incorrect (A)',
				'Exported NEW',
				'Exported MOD',
				'Data Accepted'
				) as $key => $type)
		{
			$trans = $this->getText($type);
			if($setValue==$type)
				$selectedValue = $trans;
			$select->addOption($trans, $key, false);
		}
		$select->setSelectedValue($setValue);
		if(isset($_REQUEST['WEEE_STATUS']) && $_REQUEST['WEEE_STATUS'] != '0')
			$select->setDisabled();
		$filter = $select->getHtml();

		return $$rv;
	}
	function getCRSOSelect($rv='setValue')
	{
		$setValue = !empty($_REQUEST['CRSO_RELATION_ID'])?(int)$_REQUEST['CRSO_RELATION_ID']:false;
		switch($_SESSION['session_group_group_id'])
		{
			case GROUP_CRSO:
				$filter = '';
				$selectedValue = '';
				if(isset($_REQUEST['CRSO_RELATION_ID']) && ($_REQUEST['CRSO_RELATION_ID']!=$_SESSION['crso_relation_id']))
					throw new IWAJAXPermissionException('Incorrect CRSO Id supplied');
				$_REQUEST['CRSO_RELATION_ID'] = $setValue = $_SESSION['crso_relation_id'];
				$rs = array();
				break;
			case GROUP_ACCOUNTANT:
				$sql = "SELECT R.RELATION_ID as CRSO_RELATION_ID, R.`NAME`
					FROM TBL_ACCOUNTANT_CRSO as AC
					INNER JOIN TBL_RELATION as R
						ON AC.CRSO_RELATION_ID = R.RELATION_ID
					INNER JOIN TBL_ADDRESS as A
						USING(ADDRESS_ID)
					WHERE A.COUNTRY_ID = 826
					AND AC.ACCOUNTANT_RELATION_ID = ".$_SESSION['accountant_relation_id']."
					ORDER BY NAME";
				$q = $this->db->query($sql);
				$q->execute();
				$rs = $q->fetchAll();
			break;
			case GROUP_SYSADMIN:
				$sql = "SELECT R.RELATION_ID as CRSO_RELATION_ID, R.`NAME`
					FROM TBL_CRSO as C
					INNER JOIN TBL_RELATION as R
						ON C.CRSO_RELATION_ID = R.RELATION_ID
					INNER JOIN TBL_ADDRESS as A
						USING(ADDRESS_ID)
					WHERE A.COUNTRY_ID = 826
					ORDER BY NAME";
				$q = $this->db->query($sql);
				$q->execute();
				$rs = $q->fetchAll();
			break;
		}

		if(count($rs) == 1)
		{
			$setValue = $rs[0]->CRSO_RELATION_ID;
			$_REQUEST['CRSO_RELATION_ID'] = $setValue;
		}

		if(isset($$rv))
			return $$rv;
		$selectedValue = '';

		$select = new Form_Select('CRSO_RELATION_ID');
		$select->addOption(' - '.$this->getText('CRSO Select').' - ', '', false);
		foreach($rs as $r)
		{
			if($setValue==$r->CRSO_RELATION_ID)
				$selectedValue = $r->NAME;
			$select->addOption(((mb_strlen($r->NAME)>35)?mb_substr($r->NAME,0,35).'...':$r->NAME), $r->CRSO_RELATION_ID, false);
		}
		//if(count($rs) == 1)
		//{
			//$setValue = $rs[0]->CRSO_RELATION_ID;
			//$selectedValue = $rs[0]->NAME;
		//}
		$select->setSelectedValue($setValue);

		$filter = $select->getHtml();

		return $$rv;
	}
	function tfSortingHat()
	{
		return array(
				'EA_DATA_CREATED'=>"'String'",
				'LAST_UPDATE'=>"'String'",
				'LAST_EXPORTED_REG'=>"'String'",
				'LAST_EXPORTED_ACTUALS'=>"'String'",
				'STATUS_REG_REPORT'=>"'String'",
				'STATUS_ACTUALS_REPORT'=>"'String'",
				'RELATION_ID'=>"'String'",
				'PARTICIPANT_NAME'=>"'String'"
				);
	}
	function tfRegLink($args)
	{
		//$args['extra'] .= sprintf(' sort_val="%s" ', $args['value']);
		if($_SESSION['session_group_group_id'] == GROUP_CRSO)
			return sprintf('<a href="/%sscripts/elc/crso/InterfaceUKXMLPreparation.php?participant[id]=%s" title="%s">%s</a>',
				SITE_PATH,
				$args['value'],
				$this->langIf->getText('view EA Registration Data'),
				$args['value']
				);
		if($_SESSION['session_group_group_id'] == GROUP_ACCOUNTANT)
			return sprintf('<a href="/%sscripts/elc/accountant/InterfaceUKXMLPreparation.php?participant[id]=%s&crso[id]=%s" title="%s">%s</a>',
				SITE_PATH,
				$args['value'],
				$_REQUEST['CRSO_RELATION_ID'],
				$this->langIf->getText('view EA Registration Data'),
				$args['value']
				);
		if($_SESSION['session_group_group_id'] == GROUP_SYSADMIN)
			return sprintf('<a href="/%sscripts/elc/sysadmin/InterfaceUKXMLPreparation.php?participant[id]=%s&crso[id]=%s" title="%s">%s</a>',
				SITE_PATH,
				$args['value'],
				$_REQUEST['CRSO_RELATION_ID'],
				$this->langIf->getText('view EA Registration Data'),
				$args['value']
				);

	}
	function tfTranslatePRStatus($args)
	{
		$args['extra'] = sprintf(' sort_val="%s" ', $args['value']);
		list($trans,$class) = UKRegistrationData::translatePRStatus($this->langIf,$args['value']);
		return sprintf('<span class="%s">%s</span>',$class,$trans);
	}
	function tfTranslateWEEEStatus($args)
	{
		$args['extra'] = sprintf(' sort_val="%s" ', $args['value']);
		list($trans,$class) = UKRegistrationData::translateWEEEStatus($this->langIf,$args['value']);
		return sprintf('<span class="%s">%s</span>',$class,$trans);
	}
	function getProcessColumns()
	{
		return array(
			'tfRegLink'=> array('RELATION_ID'),
			'tfTranslatePRStatus'=>array('STATUS_REG_REPORT'),
			'tfTranslateWEEEStatus'=>array('STATUS_ACTUALS_REPORT')
		);
	}
	function setEmptyText()
	{
		return $this->getText('No data for the current selection');
	}
}
?>
