<?php
/**
 * Created on Dec 20, 2007
 *
 * @author Nicoleta Militaru <nicoleta@basesoft.com>
 */

require_once(ELC_CLASSES.'uk/UKRegistrationData.php');
require_once(ELC_CLASSES.'uk/UKReport.php');

 class EAReportDataList extends ELCDefaultList
{
	public $handle = 'EAReportDataList';
	var $crso_id;
	var $report_type;
	var $export_date;
	var $filename;
	var $status;
	var $reason;
	var $year;
	var $quarter;

	function setQuery()
	{
		if(isset($_REQUEST['report']))
		{
			//setPageTitlePostfix($this->langIf->getText('Details'));
			$rep = new UKReport($this->db);

			if(!$rep->set((int)$_REQUEST['report']))
				throw new IWUserException('Permission denied');

			$this->crso_id = $rep->crso_id;
			$this->report_type = $rep->report_type;
			$this->export_date = $rep->export_date;
			$this->status = $rep->status;
			$this->filename = $rep->file_name;
			$this->reason = $rep->reason;
			$this->year = $rep->year;
			$this->quarter = $rep->quarter;

			$sql = "SELECT RD.REPORT_ID AS REPORT_ID,RDL.PRODUCT_ID,RDL.OBLIGATION_TYPE, RD.PARTICIPANT_RELATION_ID AS RELATION_ID,
							R.NAME AS PARTICIPANT_NAME,
							RD.PR_STATUS AS STATUS_REG_REPORT,
							RD.WEEE_STATUS AS STATUS_ACTUALS_REPORT,
							SUM(RDL.TONNAGE) AS REPORTED_TONNAGE
					FROM TBL_UK_REPORT_DATA RD
					INNER JOIN TBL_RELATION R
						ON R.RELATION_ID = RD.PARTICIPANT_RELATION_ID
					LEFT JOIN TBL_UK_REPORT_DATA_LINE RDL
						ON RDL.REPORT_DATA_ID = RD.REPORT_DATA_ID
				";

			$this->_query = $sql;
			$this->_groupBy = "GROUP BY RD.REPORT_DATA_ID";
			$this->_orderBy = "ORDER BY REPORTED_TONNAGE";

			if($this->report_type == REG_REPORT)
				$this->_addHiddenCol(array('PRODUCT_ID','OBLIGATION_TYPE','REPORT_ID','STATUS_ACTUALS_REPORT','REPORTED_TONNAGE'));
			else
				$this->_addHiddenCol(array('PRODUCT_ID','OBLIGATION_TYPE','REPORT_ID','STATUS_REG_REPORT'));
		}
		else
			throw new IWUserException('Permission denied');
	}
	function _setWhere()
	{
		$rep = new UKReport($this->db);
		if((!isset($_REQUEST['report'])) || (!$rep->set((int)$_REQUEST['report'])))
			throw new IWUserException('Permission denied');
		$this->report_type = $rep->report_type;
		$this->_addWhere('report',
			array('field'=>'REPORT_ID',
			'callback' => array($this,'getReportSelect')
			));
		$this->_addWhere('RELATION',
			array('field'=>'RELATION_ID',
				'callback' => array($this,'getPartSelect'),
				));
		if($this->report_type == REG_REPORT)
			$this->_addWhere('PR_STATUS',
				array('field'=>'RD.PR_STATUS',
					'callback' => array($this,'getPRStatusSelect'),
					));
		else
			$this->_addWhere('WEEE_STATUS',
				array('field'=>'RD.WEEE_STATUS',
					'callback' => array($this,'getWEEEStatusSelect'),
					));
		if($this->report_type == ACTUALS_REPORT)
		{
			$this->_addWhere('PRODUCT_ID',
				array('field'=>'RDL.PRODUCT_ID',
					'callback' => array($this,'getDynamicProductSelect'),
					));
			$this->_addWhere('OBLIGATION_TYPE',
				array('field'=>'RDL.OBLIGATION_TYPE',
					'callback' => array($this,'getObligationTypeSelect'),
					));
		}
	}
	function getObligationTypeSelect($rv='setValue')
	{
		$setValue = isset($_REQUEST['OBLIGATION_TYPE'])?$_REQUEST['OBLIGATION_TYPE']:'';
		$selectedValue = '';

		$select = new Form_Select('OBLIGATION_TYPE');

		//DONT CHANGE THIS ORDER !!!!!
		foreach(array(
				' - Obligation Type - ',
				'B2C',
				'B2B',
				) as $key => $type)
		{
			if($setValue==$type)
				$selectedValue = $type;
			$select->addOption($type, $key, false);
		}
		$select->setSelectedValue($setValue);
		$filter = $select->getHtml();

		return $$rv;
	}
	function getPartSelect($rv='setValue')
	{
		$setValue = !empty($_REQUEST['RELATION'])?(int)$_REQUEST['RELATION']:false;

		$crso_id = $this->crso_id;
		switch($_SESSION['session_group_group_id'])
		{
			case GROUP_CRSO:
				 $crso_id = $_SESSION['crso_relation_id'];
			break;
		}
		if(!is_numeric($crso_id))
			$filter = '';
		if(isset($$rv))
			return $$rv;
		$selectedValue = '';

		require_once(ELC_CLASSES.'CRSOParticipantProduct.php');
		$p = new CRSOParticipantProduct($this->db);

		$producer_exporter = isset($this->producer_exporter)?$this->producer_exporter:false;

		$q = $p->getCRSOParticipants($crso_id,'q',$producer_exporter, $_SESSION['selected_product_id']);

		$select = new Form_Select('RELATION');
		$select->addOption(' - '.$this->getText('Participant Select').' - ', '', false);
		while($r = $q->fetch())
		{
			if($setValue==$r->PARTICIPANT_RELATION_ID)
				$selectedValue = $r->PARTICIPANT_NAME;
			if($_SESSION['session_group_group_id'] == GROUP_PARTICIPANT)
			{
				if(!in_array($r->PARTICIPANT_RELATION_ID, $_SESSION['participant_ids']))
					continue;
			}
			$name = $r->PARTICIPANT_NAME;
			$select->addOption(((mb_strlen($name)>35)?mb_substr($name,0,35).'...':$name), $r->PARTICIPANT_RELATION_ID, false);
		}
		$select->setSelectedValue($setValue);

		$filter = $select->getHtml();

		return $$rv;
	}
	function getReportSelect($rv='setValue')
	{
		$setValue = isset($_REQUEST['report'])?$_REQUEST['report']:'';
		$selectedValue = $_REQUEST['report'];

		list($trans,$class) = UKReport::translateStatus($this->langIf,$this->status);
		list($trans1,$class1) = UKReport::translateReportType($this->langIf,$this->report_type);
		$filter = '<table width="100%" id="id_report_table"><tr>
			<td width="10%"><div style="font-weight:bold">'.$this->langIf->getText('Report name:').'</div></td>
			<td width="40%">'.basename($this->filename).'</td>
			<td width="10%"><div style="font-weight:bold">'.$this->langIf->getText('Report type:').'</div></td>
			<td><span style="'.$class1.'">'.$trans1.'</span></td>
			</tr><tr>
			<td><div style="font-weight:bold">'.$this->langIf->getText('Export date:').'</div></td>
			<td>'.$this->export_date.'</td>
			<td><div style="font-weight:bold">'.$this->langIf->getText('Status:').'</div></td>
			<td><span class="'.$class.'">'.$trans.'</span></td>';
		if($this->status == REJECTED)
			$filter .=
				'</tr><tr>
				<td>&nbsp</td>
				<td>&nbsp</td>
				<td><div style="font-weight:bold">'.$this->langIf->getText('Reason of rejection:').'</div></td>
				<td>'.$this->reason.'</td>';
		$filter .= '</tr>';
		if($this->report_type == ACTUALS_REPORT)
		{
			$filter .= '<tr>
			<td><div style="font-weight:bold">'.$this->langIf->getText('Year:').'</div></td>
			<td>'.$this->year.'</td>
			<td><div style="font-weight:bold">'.$this->langIf->getText('Export for:').'</div></td>';
			if($this->quarter != null)
			$filter .= '<td>Quarter '.$this->quarter.'</td></tr>';
			else
			$filter .= '<td>Complete year</td></tr>';
		}
		else
		{
			$filter .= '<tr>
			<td><div style="font-weight:bold">'.$this->langIf->getText('Year:').'</div></td>
			<td>'.$this->year.'</td>
			<td><div style="font-weight:bold">&nbsp;</div></td>
			<td>&nbsp;</td></tr>';
		}
		//also remove the float left css on the parent
		$filter .= '</table><br />
		<script>$("id_report_table").parentNode.removeAttribute("style");</script>
		';
		$filter .= "<input type=hidden name=report value='".$_REQUEST['report']."'>";
		return $$rv;
	}
	function getWEEEStatusSelect($rv='setValue')
	{
		$setValue = isset($_REQUEST['WEEE_STATUS'])?$_REQUEST['WEEE_STATUS']:'';
		$selectedValue = '';

		$select = new Form_Select('WEEE_STATUS');

		//DONT CHANGE THIS ORDER !!!!!
		foreach(array(
				' - Status for Actuals Report - ',
				'Excluded - NO Reg No',
				'Reported',
				'Excluded - settings',
				'Excluded - data incorrect',
				'Exported',
				//'Data Accepted'
				) as $key => $type)
		{
			$trans = $this->getText($type);
			if($setValue==$type)
				$selectedValue = $trans;
			$select->addOption($trans, $key, false);
		}
		$select->setSelectedValue($setValue);
		if(isset($_REQUEST['PR_STATUS']) && $_REQUEST['PR_STATUS'] != '0')
			$select->setDisabled();
		$filter = $select->getHtml();

		return $$rv;
	}
	function getPRStatusSelect($rv='setValue')
	{
		$setValue = isset($_REQUEST['PR_STATUS'])?$_REQUEST['PR_STATUS']:'';
		$selectedValue = '';

		$select = new Form_Select('PR_STATUS');

		//DONT CHANGE THIS ORDER !!!!!
		foreach(array(
				' - Status for Reg Report - ',
				'Reported - New',
				'Reported - Mod',
				'Excluded - settings (I)',
				'Excluded - settings (A)',
				'Excluded - data incorrect (I)',
				'Excluded - data incorrect (A)',
				'Exported NEW',
				'Exported MOD',
				'Data Accepted'
				) as $key => $type)
		{
			$trans = $this->getText($type);
			if($setValue==$type)
				$selectedValue = $trans;
			$select->addOption($trans, $key, false);
		}
		$select->setSelectedValue($setValue);
		if(isset($_REQUEST['WEEE_STATUS']) && $_REQUEST['WEEE_STATUS'] != '0')
			$select->setDisabled();
		$filter = $select->getHtml();

		return $$rv;
	}
	function getCRSOSelect($rv='setValue')
	{
		$setValue = !empty($_REQUEST['CRSO_RELATION_ID'])?(int)$_REQUEST['CRSO_RELATION_ID']:false;
		switch($_SESSION['session_group_group_id'])
		{
			case GROUP_CRSO:
				$filter = '';
				$selectedValue = '';
				if(isset($_REQUEST['CRSO_RELATION_ID']) && ($_REQUEST['CRSO_RELATION_ID']!=$_SESSION['crso_relation_id']))
					throw new IWAJAXPermissionException('Incorrect CRSO Id supplied');
				$_REQUEST['CRSO_RELATION_ID'] = $setValue = $_SESSION['crso_relation_id'];
				$rs = array();
				break;
			case GROUP_PARTICIPANT:
				$sql = 'SELECT CRSO_RELATION_ID, R.`NAME`
						FROM TBL_CRSO_PARTICIPANT_PRODUCT as CP
						INNER JOIN TBL_RELATION as R
							ON CP.CRSO_RELATION_ID = R.RELATION_ID
						INNER JOIN TBL_ADDRESS as A
							ON A.ADDRESS_ID = R.ADDRESS_ID
						WHERE PARTICIPANT_RELATION_ID = ?
							AND CP.PRODUCT_ID = ?
							AND A.COUNTRY_ID = 826';
				$q = $this->db->query($sql);
				$q->bind_values($_SESSION['selected_participant_id'],$_SESSION['selected_product_id']);
				$q->execute();
				$rs = $q->fetchAll();
				if(count($rs)==1)
				{
					$r = $rs[0];
					$filter = '';
					$selectedValue = '';
					$_REQUEST['CRSO_RELATION_ID'] = $setValue = $r->CRSO_RELATION_ID;
				}
				break;
			case GROUP_SYSADMIN:
				$sql = "SELECT R.RELATION_ID as CRSO_RELATION_ID, R.`NAME`
					FROM TBL_CRSO as C
					INNER JOIN TBL_RELATION as R
						ON C.CRSO_RELATION_ID = R.RELATION_ID
					INNER JOIN TBL_ADDRESS as A
						USING(ADDRESS_ID)
					WHERE A.COUNTRY_ID = 826
					ORDER BY NAME";
				$q = $this->db->query($sql);
				$q->execute();
				$rs = $q->fetchAll();
			break;
			default:
				$sql = "SELECT R.RELATION_ID AS CRSO_RELATION_ID, R.`NAME` as NAME
					FROM TBL_CRSO as C
					INNER JOIN TBL_RELATION as R
						ON C.CRSO_RELATION_ID = R.RELATION_ID
					INNER JOIN TBL_ADDRESS as A
						USING(ADDRESS_ID)
					WHERE A.COUNTRY_ID = 826
					ORDER BY NAME";
				$q = $this->db->query($sql);
				$q->execute();
				$rs = $q->fetchAll();
				break;
		}

		if(count($rs) == 1)
		{
			$setValue = $rs[0]->CRSO_RELATION_ID;
			$_REQUEST['CRSO_RELATION_ID'] = $setValue;
		}

		if(isset($$rv))
			return $$rv;
		$selectedValue = '';

		$select = new Form_Select('CRSO_RELATION_ID');
		$select->addOption(' - '.$this->getText('CRSO Select').' - ', '', false);
		foreach($rs as $r)
		{
			if($setValue==$r->CRSO_RELATION_ID)
				$selectedValue = $r->NAME;
			$select->addOption(((mb_strlen($r->NAME)>35)?mb_substr($r->NAME,0,35).'...':$r->NAME), $r->CRSO_RELATION_ID, false);
		}
		$select->setSelectedValue($setValue);

		$filter = $select->getHtml();

		return $$rv;
	}
	function tfSortingHat()
	{
		return array(
				'STATUS_REG_REPORT'=>"'String'",
				'STATUS_ACTUALS_REPORT'=>"'String'",
				'RELATION_ID'=>"'String'",
				'PARTICIPANT_NAME'=>"'String'",
				'REPORTED_TONNAGE'=>"'SortVal'",
				'REPORTED_B2C'=>"'SortVal'",
				'DECLARATION_TONNAGE'=>"'SortVal'",
				'REFUND_TONNAGE'=>"'SortVal'"
				);
	}
	function tfTranslatePRStatus($args)
	{
		$args['extra'] = sprintf(' sort_val="%s" ', $args['value']);
		//rename 'good for export' to 'reported'
		if($args['value'] == REG_NEW)
			list($trans,$class) = array($this->langIf->getText('Reported - New'),'status_late');
		else
		if($args['value'] == REG_MOD)
			list($trans,$class) = array($this->langIf->getText('Reported - Mod'),'status_late');
		else
			list($trans,$class) = UKRegistrationData::translatePRStatus($this->langIf,$args['value']);
		return sprintf('<span class="%s">%s</span>',$class,$trans);
	}
	function tfTranslateWEEEStatus($args)
	{
		$args['extra'] = sprintf(' sort_val="%s" ', $args['value']);
		//rename 'good for export' to 'reported'
		if($args['value'] == READY)
			list($trans,$class) = array($this->langIf->getText('Reported'),'status_late');
		else
			list($trans,$class) = UKRegistrationData::translateWEEEStatus($this->langIf,$args['value']);
		return sprintf('<span class="%s">%s</span>',$class,$trans);
	}
	function getProcessColumns()
	{
		return array(
			'tfTranslatePRStatus'=>array('STATUS_REG_REPORT'),
			'tfTranslateWEEEStatus'=>array('STATUS_ACTUALS_REPORT'),
			'tfLongNames'=>array('PARTICIPANT_NAME'),
			'tfValueProcessorQuantity'=>array('REPORTED_TONNAGE'),
			//'tfValueProcessorQuantity'=>array('REPORTED_B2C'),
			'tfValueProcessorQuantityDeclaration'=>array('DECLARATION_TONNAGE'),
			'tfValueProcessorQuantityRefund'=>array('REFUND_TONNAGE'),
		);
	}

	function tfValueProcessorQuantity($args)
	{
		isset($this->_maxNum[$args['head']]) || $this->_maxNum[$args['head']] = 0;
		$this->_headType[$args['head']] = 3;
		$this->_maxNum[$args['head']] += $args['value'];
		$this->_cols = $args['visibleColumns'];
		$args['extra'] .= sprintf(' sort_val="%s" ', $args['value']);
    	if($args['value']=='')
    		return '-';
    	else
    		return locale_nf($args['value'],3);
	}

	function tfFooter() // getClass
	{
		if($this->report_type == REG_REPORT)
			return '';

		if(!$this->_cols)
			return false;

		$cols = array_flip($this->_cols);
		$rv = explode(',',str_repeat(',',(sizeof($this->_cols)-1)));
		foreach($this->_maxNum as $head => $val)
		{
			$pos = $cols[$head];
			$round = $this->_headType[$head];
			$rv[$pos] = '<span style="float:right; font-weight: bold;">'.locale_nf($val,$round).'</span><span style="clear:both;"></span>';
		}
		return $rv;
	}
	function setEmptyText()
	{
		return $this->getText('');
	}
}
?>
