<?php
/**
 * Created on Dec 20, 2007
 *
 * @author Nicoleta Militaru <nicoleta@basesoft.com>
 */

require_once(ELC_CLASSES.'uk/UKRegistrationData.php');
require_once(ELC_CLASSES.'uk/UKReport.php');

 class EAReportSettingsList extends ELCDefaultList
{
	public $handle = 'EAReportSettingsList';
	var $crso_id;
	var $report_type;
	var $export_date;
	var $filename;
	var $status;
	var $reason;
	var $year;
	var $quarter;

	function setQuery()
	{
		setPageTitlePostfix($this->langIf->getText('Overview'));
		$this->_query = "
			SELECT UK.PARTICIPANT_RELATION_ID AS RELATION_ID,R.NAME AS PARTICIPANT_NAME,CP.PRODUCER_REG_NO,
				UK.PR_STATUS AS STATUS_REG_REPORT,'' AS SETTINGS_REG_REPORT,
				UK.WEEE_STATUS AS STATUS_ACTUALS_REPORT,'' AS SETTINGS_ACTUALS_REPORT, VAT_REGISTERED
			FROM TBL_UK_REGISTRATION_DATA UK
			INNER JOIN TBL_RELATION RR
				ON UK.CRSO_RELATION_ID = RR.RELATION_ID
			INNER JOIN TBL_RELATION R
				ON UK.PARTICIPANT_RELATION_ID = R.RELATION_ID
			INNER JOIN TBL_CRSO_PARTICIPANT CP
				ON CP.CRSO_RELATION_ID = UK.CRSO_RELATION_ID
				AND CP.PARTICIPANT_RELATION_ID = UK.PARTICIPANT_RELATION_ID
			";
		$this->_orderBy = "ORDER BY PARTICIPANT_NAME";
		$this->_addHiddenCol(array('RELATION_ID'));
		if(isset($_REQUEST['PR_STATUS']) && $_REQUEST['PR_STATUS'] != '0')
			$this->_addHiddenCol(array('STATUS_ACTUALS_REPORT','SETTINGS_ACTUALS_REPORT'));
		if(isset($_REQUEST['WEEE_STATUS']) && $_REQUEST['WEEE_STATUS'] != '0')
			$this->_addHiddenCol(array('STATUS_REG_REPORT','SETTINGS_REG_REPORT'));
	}
	function _setWhere()
	{
		$this->_addWhere('CRSO_RELATION_ID',
			array(
				'field'=>'UK.CRSO_RELATION_ID',
				'callback' => array($this,'getCRSOSelect'),
				'required'=>true));
		$this->_addWhere('PARTICIPANT_RELATION_ID',
			array('field'=>'UK.PARTICIPANT_RELATION_ID',
				'callback' => array($this,'getParticipantSelect'),
				'related'=>array('PARTICIPANT_NAME')));
		$this->_addWhere('PR_STATUS',
			array('field'=>'UK.PR_STATUS',
				'callback' => array($this,'getPRStatusSelect'),
				));
		$this->_addWhere('WEEE_STATUS',
			array('field'=>'UK.WEEE_STATUS',
				'callback' => array($this,'getWEEEStatusSelect'),
				));
	}
	function getPartSelect($rv='setValue')
	{
		$setValue = !empty($_REQUEST['RELATION'])?(int)$_REQUEST['RELATION']:false;

		$crso_id = $this->crso_id;
		switch($_SESSION['session_group_group_id'])
		{
			case GROUP_CRSO:
				 $crso_id = $_SESSION['crso_relation_id'];
			break;
		}
		if(!is_numeric($crso_id))
			$filter = '';
		if(isset($$rv))
			return $$rv;
		$selectedValue = '';

		require_once(ELC_CLASSES.'CRSOParticipantProduct.php');
		$p = new CRSOParticipantProduct($this->db);

		$producer_exporter = isset($this->producer_exporter)?$this->producer_exporter:false;

		$q = $p->getCRSOParticipants($crso_id,'q',$producer_exporter, $_SESSION['selected_product_id']);

		$select = new Form_Select('RELATION');
		$select->addOption(' - '.$this->getText('Participant Select').' - ', '', false);
		while($r = $q->fetch())
		{
			if($setValue==$r->PARTICIPANT_RELATION_ID)
				$selectedValue = $r->PARTICIPANT_NAME;
			if($_SESSION['session_group_group_id'] == GROUP_PARTICIPANT)
			{
				if(!in_array($r->PARTICIPANT_RELATION_ID, $_SESSION['participant_ids']))
					continue;
			}
			$name = $r->PARTICIPANT_NAME;
			$select->addOption(((mb_strlen($name)>35)?mb_substr($name,0,35).'...':$name), $r->PARTICIPANT_RELATION_ID, false);
		}
		$select->setSelectedValue($setValue);

		$filter = $select->getHtml();

		return $$rv;
	}
	function getWEEEStatusSelect($rv='setValue')
	{
		$setValue = isset($_REQUEST['WEEE_STATUS'])?$_REQUEST['WEEE_STATUS']:'';
		$selectedValue = '';

		$select = new Form_Select('WEEE_STATUS');

		//DONT CHANGE THIS ORDER !!!!!
		foreach(array(
				' - Status for Actuals Report - ',
				'Excluded - NO Reg No',
				'Good for export',
				'Excluded - settings',
				'Excluded - data incorrect',
				'Exported',
				//'Data Accepted'
				) as $key => $type)
		{
			$trans = $this->getText($type);
			if($setValue==$type)
				$selectedValue = $trans;
			$select->addOption($trans, $key, false);
		}
		$select->setSelectedValue($setValue);
		if(isset($_REQUEST['PR_STATUS']) && $_REQUEST['PR_STATUS'] != '0')
			$select->setDisabled();
		$filter = $select->getHtml();

		return $$rv;
	}
	function getPRStatusSelect($rv='setValue')
	{
		$setValue = isset($_REQUEST['PR_STATUS'])?$_REQUEST['PR_STATUS']:'';
		$selectedValue = '';

		$select = new Form_Select('PR_STATUS');

		//DONT CHANGE THIS ORDER !!!!!
		foreach(array(
				' - Status for Reg Report - ',
				'New Registration',
				'Registration data changed',
				'Excluded - settings (I)',
				'Excluded - settings (A)',
				'Excluded - data incorrect (I)',
				'Excluded - data incorrect (A)',
				'Exported NEW',
				'Exported MOD',
				'Data Accepted'
				) as $key => $type)
		{
			$trans = $this->getText($type);
			if($setValue==$type)
				$selectedValue = $trans;
			$select->addOption($trans, $key, false);
		}
		$select->setSelectedValue($setValue);
		if(isset($_REQUEST['WEEE_STATUS']) && $_REQUEST['WEEE_STATUS'] != '0')
			$select->setDisabled();
		$filter = $select->getHtml();

		return $$rv;
	}
	function getCRSOSelect($rv='setValue')
	{
		$setValue = !empty($_REQUEST['CRSO_RELATION_ID'])?(int)$_REQUEST['CRSO_RELATION_ID']:false;
		switch($_SESSION['session_group_group_id'])
		{
			case GROUP_CRSO:
				$filter = '';
				$selectedValue = '';
				if(isset($_REQUEST['CRSO_RELATION_ID']) && ($_REQUEST['CRSO_RELATION_ID']!=$_SESSION['crso_relation_id']))
					throw new IWAJAXPermissionException('Incorrect CRSO Id supplied');
				$_REQUEST['CRSO_RELATION_ID'] = $setValue = $_SESSION['crso_relation_id'];
				$rs = array();
				break;
			case GROUP_ACCOUNTANT:
				$sql = "SELECT R.RELATION_ID as CRSO_RELATION_ID, R.`NAME`
					FROM TBL_ACCOUNTANT_CRSO as AC
					INNER JOIN TBL_RELATION as R
						ON AC.CRSO_RELATION_ID = R.RELATION_ID
					INNER JOIN TBL_ADDRESS as A
						USING(ADDRESS_ID)
					WHERE A.COUNTRY_ID = 826
					AND AC.ACCOUNTANT_RELATION_ID = ".$_SESSION['accountant_relation_id']."
					ORDER BY NAME";
				$q = $this->db->query($sql);
				$q->execute();
				$rs = $q->fetchAll();
			break;
			case GROUP_SYSADMIN:
				$sql = "SELECT R.RELATION_ID as CRSO_RELATION_ID, R.`NAME`
					FROM TBL_CRSO as C
					INNER JOIN TBL_RELATION as R
						ON C.CRSO_RELATION_ID = R.RELATION_ID
					INNER JOIN TBL_ADDRESS as A
						USING(ADDRESS_ID)
					WHERE A.COUNTRY_ID = 826
					ORDER BY NAME";
				$q = $this->db->query($sql);
				$q->execute();
				$rs = $q->fetchAll();
			break;
		}

		if(count($rs) == 1)
		{
			$setValue = $rs[0]->CRSO_RELATION_ID;
			$_REQUEST['CRSO_RELATION_ID'] = $setValue;
		}

		if(isset($$rv))
			return $$rv;
		$selectedValue = '';

		$select = new Form_Select('CRSO_RELATION_ID');
		$select->addOption(' - '.$this->getText('CRSO Select').' - ', '', false);
		foreach($rs as $r)
		{
			if($setValue==$r->CRSO_RELATION_ID)
				$selectedValue = $r->NAME;
			$select->addOption(((mb_strlen($r->NAME)>35)?mb_substr($r->NAME,0,35).'...':$r->NAME), $r->CRSO_RELATION_ID, false);
		}
		$select->setSelectedValue($setValue);

		$filter = $select->getHtml();

		return $$rv;
	}
	function tfSortingHat()
	{
		return array(
				'STATUS_REG_REPORT'=>"'String'",
				'STATUS_ACTUALS_REPORT'=>"'String'",
				'RELATION_ID'=>"'String'",
				'PARTICIPANT_NAME'=>"'String'",
				'VAT_REGISTERED'=>"'String'"
				);
	}

	function getPostScript()
	{
		$rv = "
			function doSettings(part,value)
			{
				if(document.getElementById('id_p') == undefined)
				{
					var elem = document.createElement('input');
					elem.type = 'hidden';
					elem.name = 'participant_id';
					elem.id = 'id_p';
					elem.value = part;
					document.getElementById('interface_form').appendChild(elem);
				}
				else document.getElementById('id_p').value = part;
				if(value == 'weeeexclude')
				{
					MessageBox.prototype.Question('".$this->langIf->getText('Exclude producer from EA Actuals Report')."',
												'".$this->langIf->getText('If you exclude this producer from the EA Actuals Report, you cannot ever include his data for this quarter.Are you sure you want to exclude him?')."',
												function(){
													$('interface_form').process.value=value;
													$('interface_form').submit();},
												function(){});
				}
				else
				{
					$('interface_form').process.value=value;
					$('interface_form').submit();
				}
			}
			";
		return $rv;
	}

	function tfPRButton($args)
	{
		if($args['row']['STATUS_REG_REPORT'] == A_EXCLUDED_SETTINGS || $args['row']['STATUS_REG_REPORT'] == I_EXCLUDED_SETTINGS)
			return sprintf('<input type=button name="pr_include'.$args['row']['RELATION_ID'].'" value="'.$this->langIf->getText('Include').'"
					onclick="doSettings(\'%s\',\'%s\')" style="font-weight:bold;">',
				$args['row']['RELATION_ID'],
				'princlude');
		else
		if($args['row']['STATUS_REG_REPORT'] == A_EXPORTED || $args['row']['STATUS_REG_REPORT'] == I_EXPORTED)
			return "<b> - </b>";
		else
			return sprintf('<input type=button name="pr_exclude'.$args['row']['RELATION_ID'].'" value="'.$this->langIf->getText('Exclude').'"
					onclick="doSettings(\'%s\',\'%s\')">',
				$args['row']['RELATION_ID'],
				'prexclude');
	}
	function tfWEEEButton($args)
	{
		if($args['row']['STATUS_ACTUALS_REPORT'] == EXCLUDED_SETTINGS)
			return sprintf('<input type=button name="weee_include'.$args['row']['RELATION_ID'].'" value="'.$this->langIf->getText('Include').'"
						onclick="doSettings(\'%s\',\'%s\')" style="font-weight:bold;">',
					$args['row']['RELATION_ID'],
					'weeeinclude');
		else
			if($args['row']['STATUS_ACTUALS_REPORT'] == EXPORTED)
				return "<b> - </b>";
			else
				return sprintf('<input type=button name="weee_exclude'.$args['row']['RELATION_ID'].'" value="'.$this->langIf->getText('Exclude').'"
							onclick="doSettings(\'%s\',\'%s\')">',
						$args['row']['RELATION_ID'],
						'weeeexclude');
	}
	function tfVATButton($args)
    {
        $can_change = true;
        if($args['row']['STATUS_REG_REPORT'] == A_EXPORTED || $args['row']['STATUS_REG_REPORT'] == I_EXPORTED)
               $can_change = false;
        if($args['row']['VAT_REGISTERED'] == 1){
            if($can_change == false)
                return '<img src="/images/i-w/true.gif">';
            return sprintf('<img src="/images/i-w/true.gif">&nbsp;&nbsp;<input type=button name="vat_no'.$args['row']['RELATION_ID'].'" value="'.$this->langIf->getText('Change').'"
                        onclick="doSettings(\'%s\',\'%s\')">',
                    $args['row']['RELATION_ID'],
                    'vat_no');
        }
        if($can_change == false)
           return '<img src="/images/i-w/false.gif">';
        return sprintf('<img src="/images/i-w/false.gif">&nbsp;&nbsp;<input type=button name="vat_yes'.$args['row']['RELATION_ID'].'" value="'.$this->langIf->getText('Change').'"
                    onclick="doSettings(\'%s\',\'%s\')">',
                $args['row']['RELATION_ID'],
                'vat_yes');
    }
	function tfTranslatePRStatus($args)
	{
		$args['extra'] = sprintf(' sort_val="%s" ', $args['value']);
		list($trans,$class) = UKRegistrationData::translatePRStatus($this->langIf,$args['value']);
		return sprintf('<span class="%s">%s</span>',$class,$trans);
	}
	function tfTranslateWEEEStatus($args)
	{
		$args['extra'] = sprintf(' sort_val="%s" ', $args['value']);
		list($trans,$class) = UKRegistrationData::translateWEEEStatus($this->langIf,$args['value']);
		return sprintf('<span class="%s">%s</span>',$class,$trans);
	}
	function getProcessColumns()
	{
		return array(
 		    'tfVATButton'=> array('VAT_REGISTERED'),
			'tfPRButton'=> array('SETTINGS_REG_REPORT'),
			'tfWEEEButton'=> array('SETTINGS_ACTUALS_REPORT'),
			'tfTranslatePRStatus'=>array('STATUS_REG_REPORT'),
			'tfTranslateWEEEStatus'=>array('STATUS_ACTUALS_REPORT')
		);
	}
	function getDataSet()
	{
		if(isset($_POST['process']) && !isset($_REQUEST['report']))
		{
			$reg_data = new UKRegistrationData($this->db);
			$reg_data->set($_REQUEST['CRSO_RELATION_ID'],(int)$_POST['participant_id']);
			if($_POST['process'] == 'princlude')
				$reg_data->updatePRStatusSettingsInclude();
			if($_POST['process'] == 'prexclude')
				$reg_data->updatePRStatusSettingsExclude();
			if($_POST['process'] == 'weeeinclude')
				$reg_data->updateWEEEStatusSettingsInclude();
			if($_POST['process'] == 'weeeexclude')
				$reg_data->updateWEEEStatusSettingsExclude();
			if($_POST['process'] == 'vat_no')
                $reg_data->updateVATRegistered(0);
            if($_POST['process'] == 'vat_yes')
                $reg_data->updateVATRegistered(1);
		}
		return parent::getDataSet();
	}
	function setEmptyText()
	{
		if(!isset($_REQUEST['report']))
			return $this->getText('This participant has not filed his EA Registration Data');
		return $this->getText('This participant had not filed his EA Registration Data at the time of the export');
	}
}
?>
