<?php
/**
 * Created on Jan 2, 2008
 *
 * @author Nicoleta Militaru <nicoleta@basesoft.com>
 **/

 require_once(ELC_CLASSES.'uk/UKRegistrationData.php');
 require_once(ELC_CLASSES.'uk/UKReport.php');
 require_once(ELC_CLASSES.'uk/UKCRSOData.php');


 class EAReportsOverviewList extends ELCDefaultList
{
	public $handle = 'EAReportsOverviewList';

	function setQuery()
	{
		$this->_query = "
			SELECT '' as CHECKBOX,R.NAME as CRSO,U.REPORT_ID as ID,
				U.FILE_NAME,U.REPORT_TYPE as REPORT,U.`YEAR`,U.`QUARTER`,
				U.EXPORT_DATE,U.STATUS as REPORT_STATUS
			FROM TBL_UK_REPORTS U
			INNER JOIN TBL_RELATION R
				ON R.RELATION_ID = U.CRSO_RELATION_ID
			";
		$this->_orderBy = "ORDER BY U.REPORT_ID";
		//if(!isset($_REQUEST['REPORT_TYPE']) || $_REQUEST['REPORT_TYPE'] != ACTUALS_REPORT)
			//$this->_addHiddenCol(array('YEAR','QUARTER'));

	}
	function _setWhere()
	{
		$this->_addWhere('CRSO_RELATION_ID',
			array('field'=>'U.CRSO_RELATION_ID',
				'callback' => array($this,'getCRSOSelect'),
				'related'=>array('CRSO'),
				'required'=>true));
		$this->_addWhere('YEAR_SEL',
				array('field'=>'U.`YEAR`',
					'callback' => array($this,'getYearSelect'),
					'related'=>array('YEAR')));
		$this->_addWhere('REPORT_TYPE',
			array('field'=>'U.REPORT_TYPE',
				'callback' => array($this,'getTypeSelect')
				));
		if(isset($_REQUEST['REPORT_TYPE']) && $_REQUEST['REPORT_TYPE'] == ACTUALS_REPORT)
			$this->_addWhere('QUARTER_SEL',
				array('field'=>'U.`QUARTER`',
					'callback' => array($this,'getQuarterSelect')
					));
		$this->_addWhere('STATUS',
			array('field'=>'U.STATUS',
				'callback' => array($this,'getStatusSelect')
				));
	}
	function getTypeSelect($rv='setValue')
	{
		$setValue = isset($_REQUEST['REPORT_TYPE'])?$_REQUEST['REPORT_TYPE']:'';
		$selectedValue = '';

		$select = new Form_Select('REPORT_TYPE');

		//DONT CHANGE THIS ORDER !!!!!
		foreach(array(
				' - Select Report Type - ',
				'EA Producer Registration Report',
				'EA WEEE Actuals Report',
				) as $key => $type)
		{
			$trans = $this->getText($type);
			if($setValue==$type)
				$selectedValue = $trans;
			$select->addOption($trans, $key, false);
		}
		$select->setSelectedValue($setValue);
		$filter = $select->getHtml();
		return $$rv;
	}
	function getStatusSelect($rv='setValue')
	{
		$setValue = isset($_REQUEST['STATUS'])?$_REQUEST['STATUS']:'';
		$selectedValue = '';

		$select = new Form_Select('STATUS');

		//DONT CHANGE THIS ORDER !!!!!
		foreach(array(
				' - Select Status - ',
				'Exported',
				'Accepted',
				'Rejected'
				) as $key => $type)
		{
			$trans = $this->getText($type);
			if($setValue==$type)
				$selectedValue = $trans;
			$select->addOption($trans, $key, false);
		}
		$select->setSelectedValue($setValue);
		$filter = $select->getHtml();

		return $$rv;
	}
	function getYearSelect($rv='setValue')
    {
		$setValue = !empty($_REQUEST['YEAR_SEL'])?(int)$_REQUEST['YEAR_SEL']:false;

		$crso_id = isset($_REQUEST['CRSO_RELATION_ID'])?(int)$_REQUEST['CRSO_RELATION_ID']:false;
		switch($_SESSION['session_group_group_id'])
		{
			case GROUP_CRSO:
				 $crso_id = $_SESSION['crso_relation_id'];
			break;
		}
		if(!is_numeric($crso_id))
			$filter = '';
		if(isset($$rv))
			return $$rv;
		$selectedValue = '';

		$type = isset($_REQUEST['REPORT_TYPE'])?(int)$_REQUEST['REPORT_TYPE']:false;

    	$years = array();
    	$rep = new UKReport($this->db);
		if($type)
			$q = $rep->getYearsReport($crso_id,$type);
		else
			$q = $rep->getYearsReport($crso_id);
	    while($r = $q->fetch())
	    	$years[] = $r->YEAR;
    	if(!$setValue && count($years) > 0){
			$setValue = $years[count($years) - 1];
			$_REQUEST['YEAR_SEL'] = $setValue;
    	}

	    $select = new Form_Select('YEAR_SEL');
    	$select->addOption(' - Select Year - ', '0', false);
	    foreach($years as $key => $year)
	    {
			if($setValue==$year)
				$selectedValue = $year;
			$select->addOption($year, $year, false);
	    }
		$select->setSelectedValue($setValue);
		$filter = $select->getHtml();
    	return $$rv;
    }
    function getQuarterSelect($rv='setValue')
    {
    	$setValue = !empty($_REQUEST['QUARTER_SEL'])?(int)$_REQUEST['QUARTER_SEL']:false;

		$crso_id = isset($_REQUEST['CRSO_RELATION_ID'])?(int)$_REQUEST['CRSO_RELATION_ID']:false;
		switch($_SESSION['session_group_group_id'])
		{
			case GROUP_CRSO:
				 $crso_id = $_SESSION['crso_relation_id'];
			break;
		}
		$type = isset($_REQUEST['REPORT_TYPE'])?(int)$_REQUEST['REPORT_TYPE']:false;
		$year = isset($_REQUEST['YEAR_SEL'])?(int)$_REQUEST['YEAR_SEL']:false;
		if(!is_numeric($crso_id) || !$type || !$year)
			$filter = '';
		if(isset($$rv))
			return $$rv;
		$selectedValue = '';

    	$quarters = array();

    	//shouldn't we include here all quarters,
    	//so they can see for which quarter they didn't do the export ???

    	$rep = new UKReport($this->db);
    	$q = $rep->getQuartersWeeeReport($crso_id,$year);
    	while($r = $q->fetch())
    		$quarters[] = $r->QUARTER;

    	$select = new Form_Select('QUARTER_SEL');

    	/*if(count($quarters)==1)
    		$filter = '<input type="hidden" name="QUARTER_SEL" value="Quarter '.$quarters[0].'">'.$quarters[0];
    	else
    	{*/
	    	$select->addOption(' - Select Quarter - ', '0', false);
	    	foreach($quarters as $key => $quarter)
	    	{
	    		if($setValue==$quarter)
					$selectedValue = $quarter;
				$select->addOption('Quarter '.$quarter, $quarter, false);
	    	}
			$select->setSelectedValue($setValue);
			$filter = $select->getHtml();
    	//}
    	return $$rv;
    }
	function getCRSOSelect($rv='setValue')
	{
		$setValue = !empty($_REQUEST['CRSO_RELATION_ID'])?(int)$_REQUEST['CRSO_RELATION_ID']:false;
		switch($_SESSION['session_group_group_id'])
		{
			case GROUP_CRSO:
				$filter = '';
				$selectedValue = '';
				if(isset($_REQUEST['CRSO_RELATION_ID']) && ($_REQUEST['CRSO_RELATION_ID']!=$_SESSION['crso_relation_id']))
					throw new IWAJAXPermissionException('Incorrect CRSO Id supplied');
				$_REQUEST['CRSO_RELATION_ID'] = $setValue = $_SESSION['crso_relation_id'];
				$rs = array();
				break;
			case GROUP_ACCOUNTANT:
				$sql = "SELECT R.RELATION_ID as CRSO_RELATION_ID, R.`NAME`
					FROM TBL_ACCOUNTANT_CRSO as AC
					INNER JOIN TBL_RELATION as R
						ON AC.CRSO_RELATION_ID = R.RELATION_ID
					INNER JOIN TBL_ADDRESS as A
						USING(ADDRESS_ID)
					WHERE A.COUNTRY_ID = 826
					AND AC.ACCOUNTANT_RELATION_ID = ".$_SESSION['accountant_relation_id']."
					ORDER BY NAME";
				$q = $this->db->query($sql);
				$q->execute();
				$rs = $q->fetchAll();
			break;
			case GROUP_SYSADMIN:
				$sql = "SELECT R.RELATION_ID as CRSO_RELATION_ID, R.`NAME`
					FROM TBL_CRSO as C
					INNER JOIN TBL_RELATION as R
						ON C.CRSO_RELATION_ID = R.RELATION_ID
					INNER JOIN TBL_ADDRESS as A
						USING(ADDRESS_ID)
					WHERE A.COUNTRY_ID = 826
					ORDER BY NAME";
				$q = $this->db->query($sql);
				$q->execute();
				$rs = $q->fetchAll();
			break;
		}

		if(count($rs) == 1)
		{
			$setValue = $rs[0]->CRSO_RELATION_ID;
			$_REQUEST['CRSO_RELATION_ID'] = $setValue;
		}

		if(isset($$rv))
			return $$rv;
		$selectedValue = '';

		$select = new Form_Select('CRSO_RELATION_ID');
		$select->addOption(' - '.$this->getText('CRSO Select').' - ', '', false);
		foreach($rs as $r)
		{
			if($setValue==$r->CRSO_RELATION_ID)
				$selectedValue = $r->NAME;
			$select->addOption(((mb_strlen($r->NAME)>35)?mb_substr($r->NAME,0,35).'...':$r->NAME), $r->CRSO_RELATION_ID, false);
		}
		$select->setSelectedValue($setValue);

		$filter = $select->getHtml();

		return $$rv;
	}
	function tfTranslateReportType($args)
	{
		$args['extra'] = sprintf(' sort_val="%s" ', $args['value']);
		list($trans,$class) = UKReport::translateReportType($this->langIf,$args['value']);
		return sprintf('<span style="%s">%s</span>',$class,$trans);
	}
	function tfTranslateStatus($args)
	{
		$args['extra'] = sprintf(' sort_val="%s" ', $args['value']);
		list($trans,$class) = UKReport::translateStatus($this->langIf,$args['value']);
		return sprintf('<span class="%s">%s</span>',$class,$trans);
	}
	function getProcessColumns()
	{
		return array(
			'tfTranslateReportType'=> array('REPORT'),
			'tfTranslateStatus'=> array('REPORT_STATUS'),
			'tfCheckbox'=> array('CHECKBOX'),
			'tfDocumentLink' =>array('FILE_NAME'),
			'tfSettingsLink' =>array('ID')
		);
	}
	function tfSortingHat()
	{
		return array(
				'FILE_NAME'=>"'String'",
				'EXPORT_DATE'=>"'String'",
				'REPORT_STATUS'=>"'String'",
				'YEAR'=>"'String'",
				'QUARTER'=>"'String'"
				);
	}
	function tfCheckbox($args)
	{
		// New or accepted
		if($args['row']['REPORT_STATUS'] == 1 || $args['row']['REPORT_STATUS'] == 2)
		{
			$this->checkboxes = true;
			return '<input type="checkbox" name="report[]" value='.$args['row']['ID'].' />';
		}
		return " - ";
	}
	function tfDocumentLink($args)
	{
		$name =  basename($args['value']);
		return sprintf('<a href="#" onclick="download_file('.$args['row']['ID'].');" title="download">%s</a>',$name);
	}
	function tfSettingsLink($args)
	{
		$name =  $args['value'];
		if($_SESSION['session_group_group_id'] == GROUP_ACCOUNTANT)
			return sprintf('<a href="/%sscripts/elc/accountant/InterfaceEAReportDataList.php?report=%d" title="report settings">%s</a>',SITE_PATH,$args['value'],$args['value']);
		if($_SESSION['session_group_group_id'] == GROUP_SYSADMIN)
			return sprintf('<a href="/%sscripts/elc/sysadmin/InterfaceEAReportDataList.php?report=%d" title="report settings">%s</a>',SITE_PATH,$args['value'],$args['value']);
		if($_SESSION['session_group_group_id'] == GROUP_CRSO)
			return sprintf('<a href="/%sscripts/elc/crso/InterfaceEAReportDataList.php?report=%d" title="report settings">%s</a>',SITE_PATH,$args['value'],$args['value']);
	}
	function getPostScript()
	{
		$rv = "
			function download_file(rep)
			{
				var elem = document.createElement('input');
				elem.type = 'hidden';
				elem.name = 'report_download';
				elem.id = 'id_dr';
				elem.value = rep;
				document.getElementById('interface_form').appendChild(elem);
				$('interface_form').process.value='download';
				$('interface_form').submit();
			}
			function set_accepted()
			{
				var is_sel = 0;
				for (i = 0; i < \$\$s('report[]').length; i++)
						if(\$\$s('report[]')[i].checked == true)
							is_sel = 1;
				if(is_sel == 1)
					MessageBox.prototype.Question('%s', '%s',
												function(){
													document.getElementsByName('process')[0].value='accept';
													document.getElementById('interface_form').submit();
												},
												function(){});
				else
					MessageBox.prototype.Information('Error', '%s');
			}
			function set_rejected()
			{
				var is_sel = 0;
				for (i = 0; i < \$\$s('report[]').length; i++)
						if(\$\$s('report[]')[i].checked == true)
							is_sel = 1;
				if(is_sel == 1)
					MessageBox.prototype.Question('%s', '%s',
												function(){
													".jsMessageBox(MSG_BOX_INFO,
													$this->langIf->getText('Reason why the report was rejected'),
													'<div align=center style=\'padding-top:10px;\'>
														<textarea onblur="messageText = this.value;" id=id_other name=other cols=45 rows=3></textarea></div>',
													'function(){set_message()}')."
												},
												function(){});
				else
					MessageBox.prototype.Information('Error', '%s');
			}
			var messageText = '';
			function set_message()
			{
				if(document.getElementById('id_r') == undefined)
				{
					var elem = document.createElement('input');
					elem.type = 'hidden';
					elem.name = 'reason';
					elem.id = 'id_r';
					elem.value = messageText;
					document.getElementById('interface_form').appendChild(elem);
				}
				else document.getElementById('id_o').value = messageText;
				$('interface_form').process.value='reject';
				$('interface_form').submit();
			}
		";
		return sprintf($rv,
						$this->langIf->getText("Warning"),
						$this->langIf->getText("Set the selected reports as ACCEPTED"),
						$this->langIf->getText("Nothing selected"),
						$this->langIf->getText("Warning"),
						$this->langIf->getText("Set the selected reports as REJECTED"),
						$this->langIf->getText("Nothing selected")
					);
	}
	function getDataSet()
	{
		if(isset($_POST['process']) && $_POST['process'] == 'download')
		{
			$ukr = new UKReport($this->db);
			$ukr->set((int)$_POST['report_download']);
			$file = UK_EXPORT_PATH.'exports/'.$ukr->file_name;

			header("Cache-control: ");
			header("Pragma: ");
			header('Content-Type: application/octet-stream');
			header("Content-Length: ".filesize($file));
			header('Content-Disposition: attachment; filename="'.basename($file).'"');
			header('Content-transfer-Encoding: binary\n');
			readfile($file);
			exit();
		}

		if(isset($_POST['process']) && isset($_POST['report']) && isset($_REQUEST['CRSO_RELATION_ID']))
		{
			$this->db->begin();

			$ukr = new UKReport($this->db);
			$reg = new UKRegistrationData($this->db);

			foreach($_POST['report'] as $report )
			{
				//update reports table
				$ukr->set($report);

				if($_POST['process'] == 'accept')
				{
					$ukr->status = ACCEPTED;
				}
				if($_POST['process'] == 'reject')
				{
					$ukr->status = REJECTED;
					if(isset($_POST['reason']))
						$ukr->reason = str_replace("\n","<br />",$_POST['reason']);
				}
				$ukr->update();

				if($ukr->report_type == REG_REPORT)
					$q = $reg->getAllPRExported((int)$_REQUEST['CRSO_RELATION_ID']);
				else
					$q = $reg->getAllWeeeExported((int)$_REQUEST['CRSO_RELATION_ID']);
				while($r = $q->fetch())
				{
					$reg->set((int)$_REQUEST['CRSO_RELATION_ID'],$r->PARTICIPANT_RELATION_ID);
					if($_POST['process'] == 'accept')
					{
						if($ukr->report_type == REG_REPORT)
							$reg->updatePRStatusAccepted();
						else
						if($ukr->report_type == ACTUALS_REPORT)
							$reg->updateWeeeStatusAccepted();
					}
					if($_POST['process'] == 'reject')
					{
						if($ukr->report_type == REG_REPORT)
							$reg->updatePRStatusRejected();
						else
						if($ukr->report_type == ACTUALS_REPORT)
							$reg->updateWeeeStatusRejected();
					}

				}

			}
			$this->db->commit();
		}
		return parent::getDataSet();

	}
	function getButtons()
	{
		$settings = parent::getButtons();
		$settings['Was Accepted'] = array('onclick'=>"set_accepted();");
		$settings['Was Rejected'] = array('onclick'=>"set_rejected();");
	    return $settings;
	}
	function setEmptyText()
	{
		return $this->getText('No Reports for the current selection');
	}
}

?>
