<?php
/**
 * Created on Dec 20, 2007
 *
 * @author Nicoleta Militaru <nicoleta@basesoft.com>
 */

require_once(ELC_CLASSES.'uk/UKRegistrationData.php');
require_once(ELC_CLASSES.'uk/UKReport.php');

 class EAWeightsB2BList extends ELCDefaultList
{
	public $handle = 'EAWeightsB2BList';
	var $crso_id;
	var $report_type;
	var $export_date;
	var $filename;
	var $status;
	var $reason;
	var $year;
	var $quarter;

	function setQuery()
	{
		$date =& currentDate();
        $year = $date->getYear();
		$year = empty($_REQUEST['YEAR_SEL'])?$year:$_REQUEST['YEAR_SEL'];

		$product = empty($_REQUEST['PRODUCT_ID'])?'null':$_REQUEST['PRODUCT_ID'];
		$sql = "SELECT
					CP.PARTICIPANT_RELATION_ID AS relation_id,
					R.NAME AS Producer,
					f_ukGetB2BWeight(CP.CRSO_RELATION_ID, CP.PARTICIPANT_RELATION_ID, ".$product.", ".$year.", 1) AS January,
					f_ukGetB2BWeight(CP.CRSO_RELATION_ID, CP.PARTICIPANT_RELATION_ID, ".$product.", ".$year.", 2) AS February,
					f_ukGetB2BWeight(CP.CRSO_RELATION_ID, CP.PARTICIPANT_RELATION_ID, ".$product.", ".$year.", 3) AS March,
					f_ukGetB2BWeight(CP.CRSO_RELATION_ID, CP.PARTICIPANT_RELATION_ID, ".$product.", ".$year.", 4) AS April,
					f_ukGetB2BWeight(CP.CRSO_RELATION_ID, CP.PARTICIPANT_RELATION_ID, ".$product.", ".$year.", 5) AS May,
					f_ukGetB2BWeight(CP.CRSO_RELATION_ID, CP.PARTICIPANT_RELATION_ID, ".$product.", ".$year.", 6) AS June,
					f_ukGetB2BWeight(CP.CRSO_RELATION_ID, CP.PARTICIPANT_RELATION_ID, ".$product.", ".$year.", 7) AS July,
					f_ukGetB2BWeight(CP.CRSO_RELATION_ID, CP.PARTICIPANT_RELATION_ID, ".$product.", ".$year.", 8) AS August,
					f_ukGetB2BWeight(CP.CRSO_RELATION_ID, CP.PARTICIPANT_RELATION_ID, ".$product.", ".$year.", 9) AS September,
					f_ukGetB2BWeight(CP.CRSO_RELATION_ID, CP.PARTICIPANT_RELATION_ID, ".$product.", ".$year.", 10) AS October,
					f_ukGetB2BWeight(CP.CRSO_RELATION_ID, CP.PARTICIPANT_RELATION_ID, ".$product.", ".$year.", 11) AS November,
					f_ukGetB2BWeight(CP.CRSO_RELATION_ID, CP.PARTICIPANT_RELATION_ID, ".$product.", ".$year.", 12) AS December,
					'' AS YTD

				FROM TBL_UK_REGISTRATION_DATA CP
				INNER JOIN TBL_RELATION R ON R.RELATION_ID=CP.PARTICIPANT_RELATION_ID
			";

		$this->_query = $sql;
		$this->_groupBy = "GROUP BY CP.CRSO_RELATION_ID, CP.PARTICIPANT_RELATION_ID";
	}
	function _setWhere()
	{
		$this->_addWhere('CRSO_RELATION_ID',
			array('field'=>'CP.CRSO_RELATION_ID',
				'callback' => array($this,'getCRSOSelect'),
				'related'=>array('CRSO'),
				'required'=>true));
		$this->_addWhere('PARTICIPANT_RELATION_ID',
			array('field'=>'CP.PARTICIPANT_RELATION_ID',
				'callback' => array($this,'getParticipantSelect')
				));
		$this->_addWhere('PRODUCT_ID',
			array('field'=>'PRODUCT_ID',
				'callback' => array($this,'getDynamicProductSelect'),
				'useinquery'=> false
				));
		$this->_addWhere('YEAR_SEL',
			array('field'=>'YEAR_SEL',
				'callback' => array($this,'getYearSelect'),
				'useinquery'=> false
				));
	}

	function getCRSOSelect($rv='setValue')
	{
		$setValue = !empty($_REQUEST['CRSO_RELATION_ID'])?(int)$_REQUEST['CRSO_RELATION_ID']:false;
		switch($_SESSION['session_group_group_id'])
		{
			case GROUP_CRSO:
				$filter = '';
				$selectedValue = '';
				if(isset($_REQUEST['CRSO_RELATION_ID']) && ($_REQUEST['CRSO_RELATION_ID']!=$_SESSION['crso_relation_id']))
					throw new IWAJAXPermissionException('Incorrect CRSO Id supplied');
				$_REQUEST['CRSO_RELATION_ID'] = $setValue = $_SESSION['crso_relation_id'];
				$rs = array();
				break;
			case GROUP_ACCOUNTANT:
				$sql = "SELECT R.RELATION_ID as CRSO_RELATION_ID, R.`NAME`
					FROM TBL_ACCOUNTANT_CRSO as AC
					INNER JOIN TBL_RELATION as R
						ON AC.CRSO_RELATION_ID = R.RELATION_ID
					INNER JOIN TBL_ADDRESS as A
						USING(ADDRESS_ID)
					WHERE A.COUNTRY_ID = 826
					AND AC.ACCOUNTANT_RELATION_ID = ".$_SESSION['accountant_relation_id']."
					ORDER BY NAME";
				$q = $this->db->query($sql);
				$q->execute();
				$rs = $q->fetchAll();
			break;
			case GROUP_SYSADMIN:
				$sql = "SELECT R.RELATION_ID as CRSO_RELATION_ID, R.`NAME`
					FROM TBL_CRSO as C
					INNER JOIN TBL_RELATION as R
						ON C.CRSO_RELATION_ID = R.RELATION_ID
					INNER JOIN TBL_ADDRESS as A
						USING(ADDRESS_ID)
					WHERE A.COUNTRY_ID = 826
					ORDER BY NAME";
				$q = $this->db->query($sql);
				$q->execute();
				$rs = $q->fetchAll();
			break;
		}

		if(count($rs) == 1)
		{
			$setValue = $rs[0]->CRSO_RELATION_ID;
			$_REQUEST['CRSO_RELATION_ID'] = $setValue;
		}

		if(isset($$rv))
			return $$rv;
		$selectedValue = '';

		$select = new Form_Select('CRSO_RELATION_ID');
		$select->addOption(' - '.$this->getText('CRSO Select').' - ', '', false);
		foreach($rs as $r)
		{
			if($setValue==$r->CRSO_RELATION_ID)
				$selectedValue = $r->NAME;
			$select->addOption(((mb_strlen($r->NAME)>35)?mb_substr($r->NAME,0,35).'...':$r->NAME), $r->CRSO_RELATION_ID, false);
		}
		$select->setSelectedValue($setValue);

		$filter = $select->getHtml();

		return $$rv;
	}

	function getYearSelect($rv='setValue')
    {
		$setValue = !empty($_REQUEST['YEAR_SEL'])?(int)$_REQUEST['YEAR_SEL']:false;

		$crso_id = isset($_REQUEST['CRSO_RELATION_ID'])?(int)$_REQUEST['CRSO_RELATION_ID']:false;
		switch($_SESSION['session_group_group_id'])
		{
			case GROUP_CRSO:
				 $crso_id = $_SESSION['crso_relation_id'];
			break;
		}
		if(!is_numeric($crso_id))
			$filter = '';
		if(isset($$rv))
			return $$rv;
		$selectedValue = '';

	    require_once(ELC_CLASSES.'uk/uk_define.php');
    	$date =& currentDate();
        $year = $date->getYear();
    	if(!$setValue){
			$setValue = $year;
			$_REQUEST['YEAR_SEL'] = $setValue;
    	}

    	$select = new Form_Select('YEAR_SEL');
	    for($i=START_YEAR; $i<=$year; $i++)
	    {
			if($setValue==$i)
				$selectedValue = $i;
				$select->addOption($i, $i, false);
	    }
		$select->setSelectedValue($setValue);
		$filter = $select->getHtml();
    	return $$rv;
    }
	function tfSortingHat()
	{
		return array(
				'relation_id'=>"'Int'",
				'Producer'=>"'String'",
				'January'=>"'SortVal'",
				'February'=>"'SortVal'",
				'March'=>"'SortVal'",
				'April'=>"'SortVal'",
				'May'=>"'SortVal'",
				'June'=>"'SortVal'",
				'July'=>"'SortVal'",
				'August'=>"'SortVal'",
				'September'=>"'SortVal'",
				'October'=>"'SortVal'",
				'November'=>"'SortVal'",
				'December'=>"'SortVal'",
				'YTD'=>"'SortVal'"
		);
	}
	function getColumnModifier()
	{
		return array(
			'January'=>'style="text-align:right;"',
			'February'=>'style="text-align:right;"',
			'March'=>'style="text-align:right;"',
			'April'=>'style="text-align:right;"',
			'May'=>'style="text-align:right;"',
			'June'=>'style="text-align:right;"',
			'July'=>'style="text-align:right;"',
			'August'=>'style="text-align:right;"',
			'September'=>'style="text-align:right;"',
			'October'=>'style="text-align:right;"',
			'November'=>'style="text-align:right;"',
			'December'=>'style="text-align:right;"',
			'YTD'=>'style="text-align:right;"'
			);
	}
	function tfWeight($args)
	{
		isset($this->_maxNum[$args['head']]) || $this->_maxNum[$args['head']] = 0;
		$this->_headType[$args['head']] = 3;
		$this->_maxNum[$args['head']] += $args['value'];
		$this->_cols = $args['visibleColumns'];
		$args['extra'] .= sprintf(' sort_val="%s" ', (float)$args['value']);
		$val = $args['value'];
		$cls = '';
		if($val == '')
			$val = ' - ';
		else {
			$s = explode("_", $val);
			if(count($s) >= 2)
				list($val,$cls) = UKRegistrationData::translateWEEEStatus($this->langIf, $s[1]);
		}
		return sprintf('<span class="%s">%s</span>',$cls,$val);
	}
	function tfYTD($args)
	{
		$ms = array('January', 'February', 'March', 'April', 'May', 'June', 'July',
					'August', 'September', 'October', 'November', 'December');
		$val = '-';
		foreach($ms as $k => $v){
			$w = $args['row'][$v];
			if($w != '' && strpos($w, 'E') === false){
				if($val == '-')
					$val = (float)$w;
				else
					$val += (float)$w;
			}
		}
		$val = (gettype($val) == 'string')?$val:number_format($val, 3);
		isset($this->_maxNum[$args['head']]) || $this->_maxNum[$args['head']] = 0;
		$this->_headType[$args['head']] = 3;
		$this->_maxNum[$args['head']] += $val;
		$this->_cols = $args['visibleColumns'];
		$args['extra'] .= sprintf(' sort_val="%s" ', $val);
		return sprintf('<span class="%s">%s</span>','',(string)$val);
	}
	function getProcessColumns()
	{
		return array(
			'tfWeight'=>array('January', 'February', 'March', 'April', 'May', 'June', 'July',
							  'August', 'September', 'October', 'November', 'December'),
			'tfYTD'=>array('YTD')
		);
	}

	function tfFooter()
	{
		if(!isset($this->_cols))
			return false;

		$cols = array_flip($this->_cols);
		$rv = explode(',',str_repeat(',',(sizeof($this->_cols)-1)));
		foreach($this->_maxNum as $head => $val)
		{
			$pos = $cols[$head];
			$round = $this->_headType[$head];
			$rv[$pos] = '<span style="float:right; font-weight: bold;">'.locale_nf($val,$round).'</span><span style="clear:both;"></span>';
		}
		return $rv;
	}

	function setEmptyText()
	{
		return $this->getText('');
	}
}
?>
