<?php
/**
 * @package
 * @subpackage
 * @since 10-10-2007
 * @author Nicoleta Militaru <nicoleta@basesoft.com>
 * @version $Id$
 * @copyright 2007 BaseSoft B.V.
 */
class InvoicesOverviewList extends ELCDefaultList
{
	var $handle = 'InvoicesOverviewList';

	function setQuery()
	{

	}

	function _setWhere()
	{
		$this->_addWhere('CRSO_RELATION_ID',
			array(
				'field'=>'CPR.`CRSO_RELATION_ID`',
				'callback' => array($this,'getCRSOSelect'),
				'related'=>array('CRSO_NAME','CRSO_RELATION_ID')));

		$this->_addWhere('PARTICIPANT_RELATION_ID',
			array(
				'field'=>'CPR.`PARTICIPANT_RELATION_ID`',
				'callback' => array($this,'getParticipantSelect'),
				'related'=>array('PARTICIPANT_NAME')));

		$completedStatement = '(1=1)';
		if(isset($_REQUEST['READ_DATE']))
		{
			switch($_REQUEST['READ_DATE'])
			{
				case 'Read':
					$completedStatement = ' NOT ISNULL(READ_DATE) ';
				break;
				case 'Unread':
					$completedStatement = ' ISNULL(READ_DATE) ';
				break;
			}
		}
		$this->_addWhere('READ_DATE',
				array(
				'field'=>'READ_DATE',
				'callback' => array($this,'getReadSelect'),
				'related'=>array('DOWNLOADED'),
				'completedStatement' => $completedStatement
			));


	}

	function getReadSelect($rv='setValue')
	{
		$array = array('All','Read','Unread');

		if(isset($_REQUEST['READ_DATE'])&&!in_array($_REQUEST['READ_DATE'],$array))
			throw new IWAJAXPermissionException('Incorrect Read Filter Supplied');

		$setValue = isset($_REQUEST['READ_DATE'])?$_REQUEST['READ_DATE']:false;
		if(isset($$rv))
			return $$rv;
		$selectedValue = '';

		$select = new Form_Select('READ_DATE');

		foreach($array as $title)
		{
			$trans = $this->getText($title);
			if($setValue==$title)
				$selectedValue = $trans;
			$select->addOption($trans,$title);
		}

		$select->setSelectedValue($setValue);

		$filter = $select->getHtml();

		return $$rv;
	}
	function setEmptyText()
	{
		return $this->langIf->getText('No documents for this filter');
	}
}

?>
