<?php
/**
 * @package
 * @subpackage
 * @since 10-10-2007
 * @author Nicoleta Militaru <nicoleta@basesoft.com>
 * @version $Id$
 * @copyright 2007 BaseSoft B.V.
 */

require_once('InvoicesOverviewList.php');

class LatePaymentOverviewList extends InvoicesOverviewList
{
	var $handle = 'LatePaymentOverviewList';

	function setQuery()
	{
		$this->_query = "SELECT CRSO_RELATION_ID, C.`NAME` as CRSO_NAME, P.`NAME` as PARTICIPANT_NAME,
			DOCUMENT_ID as LatePayment_DOCUMENT,
			READ_DATE as DOWNLOADED, INVOICE_DATE as Date,INVOICE_CREDIT,AMOUNT
			FROM TBL_CRSO_PARTICIPANT_LATE_PAYMENT as CPR
			INNER JOIN TBL_RELATION as C
				ON CPR.CRSO_RELATION_ID = C.RELATION_ID
			INNER JOIN TBL_RELATION as P
				ON CPR.PARTICIPANT_RELATION_ID = P.RELATION_ID";
		$this->_addHiddenCol(array('CRSO_RELATION_ID'));

		if($_SESSION['session_group_group_id']==GROUP_CRSO)
			$this->_addHiddenCol(array('DOCUMENT'));

		$this->_orderBy = "ORDER BY CRSO_RELATION_ID, READ_DATE,  IMPORT_DATE, INVOICE_DATE";
	}

	function getProcessColumns()
	{
		return array(
			'tfBooleanIcon'=>array('DOWNLOADED'),
			'tfLink'=>array('LatePayment_DOCUMENT'),
			'tfValueProcessorQuantity'=>array('AMOUNT')
		);
	}

	function tfLink($args)
	{
		$args['extra'] .= sprintf(' sort_val="%s" ', $args['value']);
		switch($_SESSION['session_group_group_id'])
		{
			case GROUP_PARTICIPANT:
				return sprintf('<a href="/%sscripts/elc/participant/download_latePayment.php?Document[id]=%s&crso[id]=%s">%s</a>',SITE_PATH,$args['value'],$args['row']['CRSO_RELATION_ID'],$this->getText('Download'));
			break;
			case GROUP_SYSADMIN:
				return sprintf('<a href="/%sscripts/i-w/document/download.php?Document[id]=%s">%s</a>',SITE_PATH,$args['value'],$this->getText('Download'));
			break;
			case GROUP_CRSO:
				return '-';
			break;
		}
		return '-';
	}

	function tfSortingHat()
	{
		return array(
			'CRSO_NAME'=>"'String'",
			'PARTICIPANT_NAME'=>"'String'",
			'LatePayment_DOCUMENT'=>"'SortVal'",
			'DOWNLOADED'=>"'String'",
			'Date'=>"'String'",
			'AMOUNT'=>"'String'",
			'IMPORT_DATE'=>"'String'"
			);
	}
}

?>
