<?php
require_once(ELC_CLASSES.'Participant.php');
/**
 * @todo Make join with blocked VAT list and remove the Block Link if already blocked!
 * @package ELC
 * @subpackage List
 * @since 4-sep-2006
 * @author Marten Koedam <marten@dalines.net>
 * @version $Id$
 * @copyright 2006 BaseSoft B.V.
 */
class NonParticipantImporterList extends ELCDefaultList
{
	/**
	 * @var string $handle
	 */
	var $handle = 'NonParticipantImporterList';
	function setQuery()
	{
		$this->_query = "SELECT RR.IMPORTER_VAT_NO, RR.IMPORTER_COMPANY_NAME, RR.IMPORTER_EMAIL,
				COUNT(RR.REFUND_REQUEST_ID) as REFUND_REQUESTS, MAX(RR.REFUND_EXPORT_DATE) as LastImportDate,
				IF(ISNULL(CP.PARTICIPANT_RELATION_ID),0,1) as IS_REGISTERED, -- Check if participant of this CRSO
				(CP.PRODUCER_EXPORTER & ".PARTICIPANT_PRODUCER.") as IS_PRODUCER, ";
		if(isset($_SESSION['session_group_group_id']) &&
                    ($_SESSION['session_group_group_id']==GROUP_SYSADMIN))
                        $this->_query .= "SUM(QUANTITY) as QUANTITY, ";
                $this->_query .= " '' as BLOCK_VAT_NO
			FROM TBL_CRSO as C
			INNER JOIN TBL_RELATION as R
				ON C.CRSO_RELATION_ID = R.RELATION_ID
			INNER JOIN TBL_ADDRESS as A
				ON R.ADDRESS_ID = A.ADDRESS_ID
			INNER JOIN TBL_REFUND_REQUEST as RR
				ON A.COUNTRY_ID = RR.EXPORT_COUNTRY_ID
			INNER JOIN TBL_REFUND_REQUEST_LINE as RRL
				ON RR.REFUND_REQUEST_ID = RRL.REFUND_REQUEST_ID
			LEFT JOIN TBL_RELATION as R2
				ON REPLACE(LOWER(RR.IMPORTER_VAT_NO), ' ', '') = REPLACE(LOWER(R2.VAT_NO),' ','')
			LEFT JOIN TBL_ADDRESS as A2
				ON R2.ADDRESS_ID = A2.ADDRESS_ID
					AND A2.COUNTRY_ID = A.COUNTRY_ID
			LEFT JOIN TBL_CRSO_PARTICIPANT_PRODUCT as CP
				ON R2.RELATION_ID = CP.PARTICIPANT_RELATION_ID
					AND C.CRSO_RELATION_ID = CP.CRSO_RELATION_ID
			";
		$this->_groupBy = "GROUP BY RR.IMPORTER_VAT_NO";
		$this->_orderBy = "ORDER BY LastImportDate DESC";
	}

	function _setWhere()
	{
		$this->_addWhere('CRSO_RELATION_ID',
			array(
				'field'=>'C.`CRSO_RELATION_ID`',
				'callback' => array($this,'getCRSOSelect'),
				'required'=>true,
				'related'=>array('CRSO_NAME')));
		$this->_addWhere('PRODUCT_ID',
			array(
				'field'=>'RR.PRODUCT_ID',
				'callback' => array($this,'getProductSelect')));
	}

	function getProcessColumns()
	{
		return array(
			'tfBooleanIcon'=>array('IS_REGISTERED','IS_PRODUCER'),
			'tfBlockLink'=>array('BLOCK_VAT_NO'),
			'tfValueProcessorQuantityNoDecimals'=>array('QUANTITY')
		);
	}

	function tfBlockLink(&$args)
	{
		switch($_SESSION['session_group_group_id'])
		{
			case GROUP_SYSADMIN:
				return ' - ';
			break;
		}
		require_once(ELC_CLASSES.'CRSOVATBlock.php');
		return sprintf('<a href="/%sscripts/elc/%s/InterfaceVATBlock.php?vat_block[vat_no]=%s&vat_block[types_blocked]=%s">%s</a>',
			SITE_PATH,
			$_SESSION['session_group_group_name'],
			$args['row']['IMPORTER_VAT_NO'],
			CRSO_VAT_BLOCK_TYPE_RR_IMPORTER,
			$this->getText('Block VAT'));
	}

	function tfSortingHat()
	{
		return array(
			'REFUND_REQUESTS'=>"'Int'",
			'IMPORTER_VAT_NO'=>"'String'",
			'IMPORTER_COMPANY_NAME'=>"'String'",
			'IMPORTER_EMAIL'=>"'String'",
			'IS_REGISTERED'=>"'String'",
			'IS_PRODUCER'=>"'String'",
			'LastImportDate'=>"'String'"
			);
	}

	function setEmptyText()
	{
		return $this->getText('No Importers Found');
	}
}
?>
