<?php
/**
 * @package
 * @subpackage
 * @since 17.09.2007
 * @author Nicoleta Militaru <nicoleta@basesoft.com>
 * @version $Id$
 * @copyright 2007 BaseSoft B.V.
 */
class NonParticipantInvoicesList extends ELCDefaultList
{
	var $handle = 'NonParticipantInvoicesList';
	protected $crso_id = false;
	protected $participant_id = false;

	function setQuery()
	{
		$this->_query = "
					SELECT 	R.`NAME` as CRSO_NAME,
 							R2.`NAME` AS PARTICIPANT_NAME,
							R1.`NAME` AS FROM_COMPANY,
							R1.VAT_NO AS FROM_VAT_NO,
							R4.INVOICE_DOCUMENT_ID as Invoice,
							R4.EXPORT_DATE as Export_Date
					FROM TBL_REFUND_EXPORT as R4
					INNER JOIN TBL_RELATION as R
						ON R.RELATION_ID = R4.CRSO_RELATION_ID
					INNER JOIN TBL_RELATION as R1
						ON R1.RELATION_ID = R4.PARTICIPANT_RELATION_ID
					INNER JOIN TBL_RELATION as R2
						ON R2.RELATION_ID = R4.BILL_TO_CUSTOMER_NO";


		$this->_orderBy = "ORDER BY Export_Date";


	}
	function _setWhere()
	{
		$this->_addWhere('CRSO_RELATION_ID',
				array('field'=>'R4.`CRSO_RELATION_ID`',
					'callback' => array($this,'getCRSOSelect'),
					));
		$this->_addWhere('PARTICIPANT_RELATION_ID',
			array('field'=>'R4.`BILL_TO_CUSTOMER_NO`',
				'callback' => array($this,'getParticipantSelect'),
				));
		$this->_addWhere('FROM_RELATION_ID',
			array('field'=>'R4.`PARTICIPANT_RELATION_ID`',
				'callback' => array($this,'getFromSelect'),
				));
		$this->_addWhere('PRODUCT_ID',
			array(
				'field'=>'R4.PRODUCT_ID',
				'callback' => array($this,'getProductSelect')));
	}

	function getFromSelect($rv='setValue')
	{
		$setValue = !empty($_REQUEST['FROM_RELATION_ID'])?(int)$_REQUEST['FROM_RELATION_ID']:false;
		$participant = !empty($_REQUEST['PARTICIPANT_RELATION_ID'])?$_REQUEST['PARTICIPANT_RELATION_ID']:false;
		$crso_id = isset($_REQUEST['CRSO_RELATION_ID'])?(int)$_REQUEST['CRSO_RELATION_ID']:false;
		if(!is_numeric($crso_id))
			$filter = '';
		if(isset($$rv))
			return $$rv;
		$selectedValue = '';

		$sql = "    SELECT 	R1.`NAME` AS PARTICIPANT_NAME,
							R4.PARTICIPANT_RELATION_ID as PARTICIPANT_RELATION_ID
					FROM TBL_REFUND_EXPORT as R4
					INNER JOIN TBL_RELATION as R1
						ON R1.RELATION_ID = R4.PARTICIPANT_RELATION_ID
					WHERE R4.`CRSO_RELATION_ID` = ?
					AND R4.PRODUCT_ID = ?";
		if(!empty($participant))
			$sql .= " AND R4.`BILL_TO_CUSTOMER_NO` = ?";
		$q = $this->db->query($sql);
		if(!empty($participant))
			$q->bind_values($crso_id, $_SESSION['selected_product_id'], $participant);
		else
			$q->bind_values($crso_id, $_SESSION['selected_product_id']);
		$q->execute();


		$select = new Form_Select('FROM_RELATION_ID');
		$select->addOption(' - '.$this->getText('Company from Select').' - ', '', false);
		while($r = $q->fetch())
		{
			if($setValue==$r->PARTICIPANT_RELATION_ID)
				$selectedValue = $r->PARTICIPANT_NAME;
			$name = $r->PARTICIPANT_NAME;
			$select->addOption(((mb_strlen($name)>35)?mb_substr($name,0,35).'...':$name), $r->PARTICIPANT_RELATION_ID, false);
		}
		$select->setSelectedValue($setValue);

		$filter = $select->getHtml();

		return $$rv;
	}


	function _filterQuery()
	{
		$this->crso_id = isset($_REQUEST['CRSO_RELATION_ID'])?(int)$_REQUEST['CRSO_RELATION_ID']:false;
		$this->participant_id = !empty($_REQUEST['PARTICIPANT_RELATION_ID'])?$_REQUEST['PARTICIPANT_RELATION_ID']:false;
		if(!empty($this->crso_id))
			$this->_addHiddenCol(array('CRSO_NAME'));
		if(!empty($this->participant_id))
			$this->_addHiddenCol(array('PARTICIPANT_NAME'));
		return $this->_query;
	}
	function getProcessColumns()
		{
		return array(
			'tfDocumentLink'=>array('Invoice')
			);
	}
	function tfDocumentLink($args)
	{
		$args['hidename'] = false;
		return parent::tfDocumentLink($args);
	}
	function setEmptyText()
	{
		return $this->langIf->getText('No payments found');
	}

}

?>