<?php
/**
 * Created by PhpStorm.
 * User: marten
 * Date: 7/7/16
 * Time: 9:16 AM
 */
class PoEDetailsList extends ELCDefaultList
{
	var $handle = 'PoEDetailsList';
	var $producer_exporter = PARTICIPANT_EXPORTER;
	var $_maxNum = array();
	var $_headType = array();
	var $_cols = false;

	function setQuery() {

		$this->_query = "SELECT
				poe.REFUND_REQUEST_ID,
				poe.PARTICIPANT_RELATION_ID, r.NAME as PARTICIPANT_NAME,
				pl.PRODUCER_RELATION_ID, r2.NAME as PRODUCER_NAME,
				poe.REFUND_EXPORT_DATE,
				pl.QUANTITY,
				pl.WEIGHT
			FROM TBL_REFUND_REQUEST as poe
			INNER JOIN TBL_REFUND_EXPORT as re
				ON poe.REFUND_EXPORT_ID = re.REFUND_EXPORT_ID
					AND re.IS_EXPORTED = 2
			INNER JOIN TBL_REFUND_REQUEST_LINE as pl
				ON poe.REFUND_REQUEST_ID = pl.REFUND_REQUEST_ID
			INNER JOIN TBL_RELATION as r
				ON poe.PARTICIPANT_RELATION_ID = r.RELATION_ID
			INNER JOIN TBL_RELATION as r2
				ON pl.PRODUCER_RELATION_ID = r2.RELATION_ID
		";

		$this->_orderBy = "ORDER BY poe.REFUND_REQUEST_ID";

	}

	function _filterQuery() {
		$this->_addHiddenCol(array('PARTICIPANT_RELATION_ID', 'PRODUCER_RELATION_ID'));
		$this->_addGroupBy(array('pl.`LINE_INDEX`'));
		return $this->_query;
	}

	function _setWhere() {
		$this->_addWhere('CRSO_RELATION_ID',
			array('field'=>'poe.`CRSO_RELATION_ID`',
				'callback' => array($this,'getCRSOSelect'),
				'required'=>true));
		$this->_addWhere('PARTICIPANT_RELATION_ID',
			array('field'=>'poe.`PARTICIPANT_RELATION_ID`',
				'callback' => array($this,'getParticipantSelect'),
				'related'=>array('PARTICIPANT_NAME')));
		$this->_addWhere('PRODUCER_RELATION_ID',
			array('field'=>'pl.`PRODUCER_RELATION_ID`',
				'callback' => array($this,'getProducerSelect'),
				'related'=>array('PRODUCER_NAME')));
		$this->_addWhere('YEAR',
			array('field'=>'YEAR(poe.`REFUND_EXPORT_DATE`)',
				'required'=>true,
				'callback' => array($this,'getYearSelect'),
				'groupBy'=>'poe.`REFUND_REQUEST_ID`'));
		$this->_addWhere('PRODUCT_ID',
			array(
				'field'=>'poe.PRODUCT_ID',
				'callback' => array($this,'getProductSelect')));
	}

	function getProducerSelect($rv='setValue') {
		$setValue = !empty($_REQUEST['PRODUCER_RELATION_ID'])?(int)$_REQUEST['PRODUCER_RELATION_ID']:false;

		$crso_id = isset($_REQUEST['CRSO_RELATION_ID'])?(int)$_REQUEST['CRSO_RELATION_ID']:false;
		switch($_SESSION['session_group_group_id'])
		{
			case GROUP_CRSO:
				$crso_id = $_SESSION['crso_relation_id'];
				break;
		}

		if(!is_numeric($crso_id))
			$filter = '';
		if(isset($$rv))
			return $$rv;
		$selectedValue = '';

		require_once(ELC_CLASSES.'CRSOParticipantProduct.php');
		$p = new CRSOParticipantProduct($this->db);

		$producer_exporter = PARTICIPANT_PRODUCER;

		$is_active = null;
		$q = $p->getCRSOParticipants($crso_id,'q',$producer_exporter, $_SESSION['selected_product_id'], $is_active);

		$select = new Form_Select('PRODUCER_RELATION_ID');
		$select->addOption(' - '.$this->getText('Producer Select').' - ', '', false);
		while($r = $q->fetch())
		{
			if($setValue==$r->PARTICIPANT_RELATION_ID)
				$selectedValue = $r->PARTICIPANT_NAME;
			if($_SESSION['session_group_group_id'] == GROUP_PARTICIPANT)
			{
				if(!in_array($r->PARTICIPANT_RELATION_ID, $_SESSION['participant_ids']))
					continue;
			}
			$name = $r->PARTICIPANT_NAME;
			$select->addOption(((mb_strlen($name)>35)?mb_substr($name,0,35).'...':$name), $r->PARTICIPANT_RELATION_ID, false);
		}
		$select->setSelectedValue($setValue);

		$filter = $select->getHtml();

		return $$rv;
	}

	function getColumnModifier() {
		return array('QUANTITY'=>'style="text-align:right;"', 'WEIGHT'=>'style="text-align:right;"');
	}

	function tfHeaderProc() {
		return array('thAlignRight'=>array('QUANTITY', 'WEIGHT'));
	}


	function getProcessColumns() {
		return array(
			'tfLongNames'=>array('PARTICIPANT_NAME', 'PRODUCER_NAME'),
			'tfValueProcessorQuantityNoDecimals'=>array('QUANTITY', 'WEIGHT')
		);
	}

	function tfValueProcessorQuantityNoDecimals($args) {
		if(!isset($this->_maxNum[$args['head']]))
			$this->_maxNum[$args['head']] = 0;
		$this->_headType[$args['head']] = 0;
		$this->_maxNum[$args['head']] += $args['value'];
		$this->_cols = $args['visibleColumns'];
		$args['extra'] .= sprintf(' sort_val="%s" ', $args['value']);
		$rv = '%s';
		return sprintf($rv,locale_nf($args['value']));
	}

	function tfFooter() {
		if(!$this->_cols)
			return false;

		$cols = array_flip($this->_cols);
		$rv = explode(',',str_repeat(',',(sizeof($this->_cols)-1)));
		foreach($this->_maxNum as $head => $val) {
			$pos = $cols[$head];
			$round = $this->_headType[$head];
			$rv[$pos] = '<span style="float:right; font-weight: bold;">'.locale_nf($val,$round).'</span><span style="clear:both;"></span>';
		}
		return $rv;
	}


	function setEmptyText()	{
		return $this->langIf->getText('No Proof of Exports for current selection');
	}

	function tfSortingHat()	{
		return array(
			'REFUND_REQUEST_ID'=>"'Int'",
			'QUANTITY'=>"'SortVal'",
			'WEIGHT'=>"'SortVal'",
			'PARTICIPANT_NAME'=>"'String'",
			'PRODUCER_NAME'=>"'String'",
			'REFUND_EXPORT_DATE'=>"'String'"
		);
	}

	function getButtons() {
		return array_merge($this -> _getCSVButton(), $this -> _getXMLButton());
	}

}