<?php
require_once(ELC_CLASSES.'ProofOfPayment.php');
require_once(ELC_CLASSES.'RefundRequest.php');
/**
 * @package ELC
 * @subpackage List
 * @since 22-aug-2006
 * @author Marten Koedam <marten@dalines.net>
 * @version $Id$
 * @copyright 2006 BaseSoft B.V.
 */
class PoPAndRRCmpList extends ELCDefaultList
{
	var $handle = "PoPAndRRCmpList";
	var $_maxNum = array();
	var $_headType = array();
	var $_cols = false;
	function setQuery()
	{
		$product_id = (int) $_SESSION['selected_product_id'];

		$quantityQuery = "
			f_elcProofOfPaymentQuantity(PoP.PARTICIPANT_RELATION_ID,PoP.CRSO_RELATION_ID,NULL, NULL, ".$product_id.") as QUANTITY_REQUESTED,
			f_elcProofOfPaymentQuantity(PoP.PARTICIPANT_RELATION_ID,PoP.CRSO_RELATION_ID,".PROOF_OF_PAYMENT_APPROVED.", NULL, ".$product_id.") as QUANTITY_APPROVED,
			f_elcRefundRequestQuantity(PoP.PARTICIPANT_RELATION_ID,PoP.CRSO_RELATION_ID,NULL, ".$product_id.") as RR_QUANTITY_REQUESTED,
			f_elcRefundRequestQuantity(PoP.PARTICIPANT_RELATION_ID,PoP.CRSO_RELATION_ID,".REFUND_REQUEST_CONFIRMED.", ".$product_id.") as RR_QUANTITY_APPROVED,
			f_elcGetVirtualStock(PoP.PARTICIPANT_RELATION_ID,PoP.CRSO_RELATION_ID, NULL, ".$product_id.") as VIRTUAL_STOCK";

		$amountQuery = "
			f_elcProofOfPaymentAmount(PoP.PARTICIPANT_RELATION_ID,PoP.CRSO_RELATION_ID, NULL, ".$product_id.") as AMOUNT_REQUESTED,
			f_elcProofOfPaymentAmount(PoP.PARTICIPANT_RELATION_ID,PoP.CRSO_RELATION_ID, ".PROOF_OF_PAYMENT_APPROVED.", ".$product_id.") as AMOUNT_APPROVED,
			f_elcRefundRequestAmount(PoP.PARTICIPANT_RELATION_ID,PoP.CRSO_RELATION_ID, NULL, ".$product_id.") as RR_AMOUNT_REQUESTED,
			f_elcRefundRequestAmount(PoP.PARTICIPANT_RELATION_ID,PoP.CRSO_RELATION_ID, ".REFUND_REQUEST_CONFIRMED.", ".$product_id.") as RR_AMOUNT_APPROVED";

		$popQuery = "
			f_elcProofOfPaymentQuantity(PoP.PARTICIPANT_RELATION_ID,PoP.CRSO_RELATION_ID,NULL, NULL, ".$product_id.") as QUANTITY_REQUESTED,
			f_elcProofOfPaymentQuantity(PoP.PARTICIPANT_RELATION_ID,PoP.CRSO_RELATION_ID,".PROOF_OF_PAYMENT_APPROVED.", NULL, ".$product_id.") as QUANTITY_APPROVED,
			f_elcProofOfPaymentAmount(PoP.PARTICIPANT_RELATION_ID,PoP.CRSO_RELATION_ID, NULL, ".$product_id.") as AMOUNT_REQUESTED,
			f_elcProofOfPaymentAmount(PoP.PARTICIPANT_RELATION_ID,PoP.CRSO_RELATION_ID, ".PROOF_OF_PAYMENT_APPROVED.", ".$product_id.") as AMOUNT_APPROVED,
			f_elcGetVirtualStock(PoP.PARTICIPANT_RELATION_ID,PoP.CRSO_RELATION_ID, NULL, ".$product_id.") as VIRTUAL_STOCK";

		$rrQuery = "
			f_elcRefundRequestQuantity(PoP.PARTICIPANT_RELATION_ID,PoP.CRSO_RELATION_ID,NULL, ".$product_id.") as RR_QUANTITY_REQUESTED,
			f_elcRefundRequestQuantity(PoP.PARTICIPANT_RELATION_ID,PoP.CRSO_RELATION_ID,".REFUND_REQUEST_CONFIRMED.", ".$product_id.") as RR_QUANTITY_APPROVED,
			@quantity_for_export := f_elcRefundRequestQuantityForNextExport(PoP.PARTICIPANT_RELATION_ID,PoP.CRSO_RELATION_ID, ".$product_id.") as RR_QUANTITY_FOR_EXPORT,
			f_elcRefundRequestAmount(PoP.PARTICIPANT_RELATION_ID,PoP.CRSO_RELATION_ID, NULL, ".$product_id.") as RR_AMOUNT_REQUESTED,
			f_elcRefundRequestAmount(PoP.PARTICIPANT_RELATION_ID,PoP.CRSO_RELATION_ID, ".REFUND_REQUEST_CONFIRMED.", ".$product_id.") as RR_AMOUNT_APPROVED,
			@quantity_for_export*f_elcProductFee(".$product_id.",PoP.CRSO_RELATION_ID,NULL,NOW()) as RR_AMOUNT_FOR_EXPORT,
			f_elcGetRealVirtualStock(PoP.PARTICIPANT_RELATION_ID,PoP.CRSO_RELATION_ID, ".$product_id.", NULL) as REAL_VIRTUAL_STOCK,
			f_elcRefundRequestAmountExported(PoP.PARTICIPANT_RELATION_ID,PoP.CRSO_RELATION_ID, NULL, ".$product_id.") as RR_AMOUNT_EXPORTED";

		$useQuery = empty($_REQUEST['usequery'])?'quantityQuery':$_REQUEST['usequery'];

		$this->_query = "SELECT
			R.`NAME` as PARTICIPANT_NAME, R.VAT_NO,
			".$$useQuery."

			FROM TBL_PROOF_OF_PAYMENT as PoP
			INNER JOIN TBL_RELATION as R
				ON PoP.PARTICIPANT_RELATION_ID = R.RELATION_ID";



		$this->_groupBy = "GROUP BY PoP.PARTICIPANT_RELATION_ID";
	}

	function _setWhere()
	{
		$this->_addWhere('CRSO_RELATION_ID',
			array(
				'field'=>'PoP.`CRSO_RELATION_ID`',
				'callback' => array($this,'getCRSOSelect'),
				'required'=>true));
		$this->_addWhere('usequery',
			array(
				'field'=>'usequery',
				'useinquery'=>false,
				'callback' => array($this,'getQuerySelect')));
		$this->_addWhere('PRODUCT_ID',
			array(
				'field'=>'PoP.PRODUCT_ID',
				'callback' => array($this,'getProductSelect')));
	}

	function getQuerySelect($rv='setValue')
	{
		$array = array(
			'quantityQuery'=>'By Quantity',
			'amountQuery'=>'By Amount',
			'popQuery'=>'By Proof of Payment',
			'rrQuery'=>'By Refund Request'
			);

		if(isset($_REQUEST['usequery'])&&!isset($array[$_REQUEST['usequery']]))
			throw new IWAJAXPermissionException('Use of undefined query selection');

		$setValue = isset($_REQUEST['usequery'])?$_REQUEST['usequery']:'quantityQuery';
		if(isset($$rv))
			return $$rv;
		$selectedValue = '';

		$select = new Form_Select('usequery');
		$select->addOption(' - '.$this->getText('Filter Select').' - ', '', false);

		foreach($array as $query => $lang)
		{
			$trans = $this->getText($lang);
			if($setValue==$query)
				$selectedValue = $trans;
			$select->addOption($trans, $query, ($setValue==$query));
		}
		$filter = $select->getHtml();
		return $$rv;
	}

	function getProcessColumns()
	{
		return array(
			'tfValueProcessorQuantityNoDecimals'=>array('QUANTITY_REQUESTED','QUANTITY_APPROVED','RR_QUANTITY_REQUESTED', 'RR_QUANTITY_APPROVED', 'RR_QUANTITY_FOR_EXPORT','VIRTUAL_STOCK', 'REAL_VIRTUAL_STOCK'),
			'tfValueProcessorQuantity'=>array('AMOUNT_REQUESTED','AMOUNT_APPROVED','RR_AMOUNT_REQUESTED', 'RR_AMOUNT_APPROVED','RR_AMOUNT_FOR_EXPORT', 'RR_AMOUNT_EXPORTED')
			);
	}

	function getColumnModifier()
	{
		return array(
			'QUANTITY_REQUESTED'=>'style="text-align:right;"',
			'QUANTITY_APPROVED'=>'style="text-align:right;"',
			'AMOUNT_REQUESTED'=>'style="text-align:right;"',
			'AMOUNT_APPROVED'=>'style="text-align:right;"',
			'RR_QUANTITY_REQUESTED'=>'style="text-align:right;"',
			'RR_QUANTITY_APPROVED'=>'style="text-align:right;"',
			'RR_AMOUNT_REQUESTED'=>'style="text-align:right;"',
			'RR_AMOUNT_APPROVED'=>'style="text-align:right;"',
			'RR_AMOUNT_FOR_EXPORT'=>'style="text-align:right;"',
			'RR_QUANTITY_FOR_EXPORT'=>'style="text-align:right;"',
			'VIRTUAL_STOCK'=>'style="text-align:right;"',
			'REAL_VIRTUAL_STOCK'=>'style="text-align:right;"',
			'RR_AMOUNT_EXPORTED'=>'style="text-align:right;"',
			);
	}

	function tfSortingHat()
	{
		return array(
			'PARTICIPANT_NAME'=>"'String'",
			'VAT_NO'=>"'String'",
			'QUANTITY_REQUESTED'=>"'SortVal'",
			'QUANTITY_APPROVED'=>"'SortVal'",
			'AMOUNT_REQUESTED'=>"'SortVal'",
			'AMOUNT_APPROVED'=>"'SortVal'",
			'RR_QUANTITY_REQUESTED'=>"'SortVal'",
			'RR_QUANTITY_APPROVED'=>"'SortVal'",
			'RR_AMOUNT_REQUESTED'=>"'SortVal'",
			'RR_AMOUNT_APPROVED'=>"'SortVal'",
			'RR_AMOUNT_FOR_EXPORT'=>"'SortVal'",
			'RR_QUANTITY_FOR_EXPORT'=>"'SortVal'",
			'VIRTUAL_STOCK'=>"'SortVal'",
			'REAL_VIRTUAL_STOCK'=>"'SortVal'",
			'RR_AMOUNT_EXPORTED'=>"'SortVal'"
			);
	}

	function tfValueProcessorQuantityNoDecimals($args)
	{
		isset($this->_maxNum[$args['head']]) || $this->_maxNum[$args['head']] = 0;
		$this->_headType[$args['head']] = 0;
		$this->_maxNum[$args['head']] += $args['value'];
		$this->_cols = $args['visibleColumns'];
		$args['extra'] .= sprintf(' sort_val="%s" ', $args['value']);
    	return locale_nf($args['value']);
	}

	function tfValueProcessorQuantity($args)
	{
		isset($this->_maxNum[$args['head']]) || $this->_maxNum[$args['head']] = 0;
		$this->_headType[$args['head']] = 2;
		$this->_maxNum[$args['head']] += $args['value'];
		$this->_cols = $args['visibleColumns'];
		$args['extra'] .= sprintf(' sort_val="%s" ', $args['value']);
    	return locale_nf($args['value'],2);
	}

	function tfFooter() // getClass
	{
		if(!$this->_cols)
			return false;

		$cols = array_flip($this->_cols);
		$rv = explode(',',str_repeat(',',(sizeof($this->_cols)-1)));
		foreach($this->_maxNum as $head => $val)
		{
			$pos = $cols[$head];
			$round = $this->_headType[$head];
			$rv[$pos] = '<span style="float:right; font-weight: bold;">'.locale_nf($val,$round).'</span><span style="clear:both;"></span>';
		}
		return $rv;
	}
}
?>
