<?php
require_once(ELC_CLASSES.'Participant.php');
require_once(ELC_CLASSES.'Country.php');
/**
 * @package ELC
 * @subpackage List
 * @author Nick Loeve <nick@basesoft.com>
 * @since 4/09/2006
 * @copyright 2006 BaseSoft B.V.
 * $Id$
 */
class RefundOverviewList extends ELCDefaultList
{
	var $producer_exporter = PARTICIPANT_EXPORTER;
	var $handle = 'RefundOverviewList';
	var $_maxQuantity = 0;
	var $_cols = false;
	var $hashTotal = '';

	function setQuery()
	{
		$this->_addHiddenCol(array('YEAR'));
		if(!isset($_REQUEST['useQuery']) || $_REQUEST['useQuery'] == 're_query')
		{
			$this->_query = "SELECT RE.REFUND_EXPORT_ID, R1.`NAME` as CRSO_NAME, R.`NAME` as PARTICIPANT_NAME,
				IFNULL(RED.YEAR,IFNULL(REC.YEAR,'')) as `YEAR`,RED.REFUND_REQUEST_DEBIT_ID, REC.REFUND_REQUEST_CREDIT_ID,
				IF(ISNULL(RED.REFUND_REQUEST_DEBIT_ID),
					f_elcBuildInvoiceNoForInterfaces(RE.CRSO_RELATION_ID,REC.`YEAR`,REC.REFUND_REQUEST_CREDIT_ID,true,true),
					f_elcBuildInvoiceNoForInterfaces(RE.CRSO_RELATION_ID,RED.`YEAR`,RED.REFUND_REQUEST_DEBIT_ID,false,true)
				) as DOCUMENT,
				RE.EXPORT_DATE AS DATE_PROCESSED,
				SUM(RRL.QUANTITY) as QUANTITY, RE.INVOICE_DOCUMENT_ID,
				MD5(CONCAT(

					IF(ISNULL(RED.REFUND_REQUEST_DEBIT_ID),
							f_elcBuildInvoiceNoForInterfaces(RE.CRSO_RELATION_ID,REC.`YEAR`,REC.REFUND_REQUEST_CREDIT_ID,true,true),
							f_elcBuildInvoiceNoForInterfaces(RE.CRSO_RELATION_ID,RED.`YEAR`,RED.REFUND_REQUEST_DEBIT_ID,false,true)
					 ),
					CONCAT(CAC.CODE,
						LPAD(RE.CRSO_RELATION_ID, 8, 0),
						LPAD(RE.PARTICIPANT_RELATION_ID, 8, 0)
					),
					REPLACE((CAST(f_elcGetTotalAmountForRefundExport(RE.REFUND_EXPORT_ID) AS DECIMAL(10,2)) ), '.', ',')
				)) as `Hash`
				FROM TBL_REFUND_EXPORT as RE
				LEFT JOIN TBL_REFUND_EXPORT_SET_LINE as RESL
					ON RE.REFUND_EXPORT_ID = RESL.REFUND_EXPORT_ID
				LEFT JOIN TBL_REFUND_EXPORT_CREDIT REC
					ON RESL.REFUND_EXPORT_SET_ID = REC.REFUND_EXPORT_SET_ID
				LEFT JOIN TBL_REFUND_EXPORT_DEBIT RED
					ON RESL.REFUND_EXPORT_SET_ID = RED.REFUND_EXPORT_SET_ID
				LEFT JOIN TBL_REFUND_REQUEST RR
					ON RE.REFUND_EXPORT_ID = RR.REFUND_EXPORT_ID
				LEFT JOIN TBL_REFUND_REQUEST_LINE as RRL
					ON RR.REFUND_REQUEST_ID = RRL.REFUND_REQUEST_ID
				INNER JOIN TBL_RELATION as R
					ON RE.PARTICIPANT_RELATION_ID = R.RELATION_ID
				INNER JOIN TBL_RELATION as R1
					ON RE.CRSO_RELATION_ID = R1.RELATION_ID
				INNER JOIN TBL_ADDRESS as CA
					ON R1.ADDRESS_ID = CA.ADDRESS_ID
				INNER JOIN TBL_COUNTRY as CAC
					ON CAC.COUNTRY_ID = CA.COUNTRY_ID";
			$this->_groupBy = "GROUP BY RE.REFUND_EXPORT_ID";
			$this->_orderBy = "ORDER BY REFUND_REQUEST_DEBIT_ID, REFUND_REQUEST_CREDIT_ID";
		}
		else
		{
			// Add union...
			$this->_query = "SELECT RR.REFUND_REQUEST_ID, R1.`NAME` as CRSO_NAME, R.`NAME` as PARTICIPANT_NAME,
				IFNULL(RED.YEAR,IFNULL(REC.YEAR,'')) as `YEAR`,RED.REFUND_REQUEST_DEBIT_ID as REFUND_REQUEST_DEBIT_ID,
				REC.REFUND_REQUEST_CREDIT_ID as REFUND_REQUEST_CREDIT_ID,
                '' as DOCUMENT, RE.EXPORT_DATE AS DATE_PROCESSED,
				SUM(RRL.QUANTITY) as QUANTITY, RE.INVOICE_DOCUMENT_ID, RR.`STATUS`,
				MD5(CONCAT(

					IF(ISNULL(RED.REFUND_REQUEST_DEBIT_ID),
							f_elcBuildInvoiceNoForInterfaces(RE.CRSO_RELATION_ID,REC.`YEAR`,REC.REFUND_REQUEST_CREDIT_ID,true,true),
							f_elcBuildInvoiceNoForInterfaces(RE.CRSO_RELATION_ID,RED.`YEAR`,RED.REFUND_REQUEST_DEBIT_ID,false,true)
					 ),
					CONCAT(CAC.CODE,
						LPAD(RE.CRSO_RELATION_ID, 8, 0),
						LPAD(RE.PARTICIPANT_RELATION_ID, 8, 0)
					),
					REPLACE((CAST(f_elcGetTotalAmountForRefundExport(RE.REFUND_EXPORT_ID) AS DECIMAL(10,2)) ), '.', ',')
				)) as `Hash`
				FROM TBL_REFUND_EXPORT as RE
				LEFT JOIN TBL_REFUND_EXPORT_SET_LINE as RESL
					ON RE.REFUND_EXPORT_ID = RESL.REFUND_EXPORT_ID
				LEFT JOIN TBL_REFUND_EXPORT_CREDIT REC
					ON RESL.REFUND_EXPORT_SET_ID = REC.REFUND_EXPORT_SET_ID
				LEFT JOIN TBL_REFUND_EXPORT_DEBIT RED
					ON RESL.REFUND_EXPORT_SET_ID = RED.REFUND_EXPORT_SET_ID
				LEFT JOIN TBL_REFUND_REQUEST RR
					ON RE.REFUND_EXPORT_ID = RR.REFUND_EXPORT_ID
				LEFT JOIN TBL_REFUND_REQUEST_LINE as RRL
					ON RR.REFUND_REQUEST_ID = RRL.REFUND_REQUEST_ID
				INNER JOIN TBL_RELATION as R
					ON RE.PARTICIPANT_RELATION_ID = R.RELATION_ID
				INNER JOIN TBL_RELATION as R1
					ON RE.CRSO_RELATION_ID = R1.RELATION_ID
				INNER JOIN TBL_ADDRESS as CA
					ON R1.ADDRESS_ID = CA.ADDRESS_ID
				INNER JOIN TBL_COUNTRY as CAC
					ON CAC.COUNTRY_ID = CA.COUNTRY_ID";

			$this->_groupBy = "GROUP BY RR.REFUND_REQUEST_ID";
            $this->_orderBy = "ORDER BY REFUND_REQUEST_DEBIT_ID, REFUND_REQUEST_CREDIT_ID";
		}
	}

	function _filterQuery()
	{

		$crso_id = $this->getCRSOSelect();
                $year = $this->getYearSelect();
		if(!isset($_REQUEST['useQuery']) || $_REQUEST['useQuery']=='re_query')
		{
                        $this->_union = " UNION (SELECT
					'-' AS REFUND_EXPORT_ID,
					R1.`NAME` as CRSO_NAME,
					R.`NAME` as PARTICIPANT_NAME,
					IFNULL(RED.YEAR,IFNULL(REC.YEAR,'')) as `YEAR`,
					RED.REFUND_REQUEST_DEBIT_ID,
					REC.REFUND_REQUEST_CREDIT_ID,
					IF(ISNULL(RED.REFUND_REQUEST_DEBIT_ID),
                                                f_elcBuildInvoiceNoForInterfaces(RI.CRSO_RELATION_ID,REC.`YEAR`,REC.REFUND_REQUEST_CREDIT_ID,true,true),
                                                f_elcBuildInvoiceNoForInterfaces(RI.CRSO_RELATION_ID,RED.`YEAR`,RED.REFUND_REQUEST_DEBIT_ID,false,true)
                                        ) as DOCUMENT,
					DATE(RI.REQUEST_DATETIME) AS DATE_PROCESSED,
					'-' as QUANTITY,
					RI.DOCUMENT_ID AS INVOICE_DOCUMENT_ID,
					'-' AS `Hash`
					FROM TBL_REQUESTED_INVOICE as RI
					LEFT JOIN TBL_REFUND_EXPORT_CREDIT REC
						ON RI.REQUESTED_INVOICE_ID = REC.REQUESTED_INVOICE_ID
					LEFT JOIN TBL_REFUND_EXPORT_DEBIT RED
						ON RI.REQUESTED_INVOICE_ID = RED.REQUESTED_INVOICE_ID
					INNER JOIN TBL_RELATION as R
						ON RI.PARTICIPANT_RELATION_ID = R.RELATION_ID
					INNER JOIN TBL_RELATION as R1
						ON RI.CRSO_RELATION_ID = R1.RELATION_ID
					WHERE
						RI.CRSO_RELATION_ID = ".((int)$crso_id)."
					AND
						RI.`YEAR` = ".$year."
					";

					$completedStatement = ' (1=1) ';
					if(isset($_REQUEST['STATUS']))
					{
						switch($_REQUEST['STATUS'])
						{
							case 'credit':
								$completedStatement = ' NOT ISNULL(REC.REFUND_REQUEST_CREDIT_ID) ';
							break;
							case 'invoice':
								$completedStatement = ' NOT ISNULL(RED.REFUND_REQUEST_DEBIT_ID) ';
							break;
						}
					}


			if(isset($_REQUEST['PARTICIPANT_RELATION_ID']) && is_numeric($_REQUEST['PARTICIPANT_RELATION_ID']))
				$this->_union .= " AND RI.PARTICIPANT_RELATION_ID = ".((int)$_REQUEST['PARTICIPANT_RELATION_ID']);

			$this->_union .= " AND ".$completedStatement;
			$this->_union .= ")";
		}




		$rel = new Relation($this->db,$crso_id);
		$country = new Country($this->db,$rel->getCountry(),true);
		if(!$country->has(HasCrsoRefundDetails,$_SESSION['selected_product_id']))
			$this->_addHiddenCol(array('QUANTITY'));
		// Check for clearance in case we are a CRSO
		if($_SESSION['session_group_group_id']==GROUP_CRSO) {
			require_once(ELC_CLASSES.'RelationUser.php');
			$ru = new RelationUser($this->db);
			if(!$ru->hasClearance(CRSOClearanceRefundDetails, $_SESSION['session_user_id'], $crso_id)) {
				$this->_addHiddenCol(array('QUANTITY'));
			}
		}

		return $this->_query;
	}

	function _setWhere()
	{
		$this->_addWhere('YEAR',
			array('field'=>'YEAR(RE.`EXPORT_DATE`)',
				'callback' => array($this,'getYearSelect'),
				'required' => true));

		$this->_addWhere('CRSO_RELATION_ID',
			array(
				'field'=>'RE.`CRSO_RELATION_ID`',
				'callback' => array($this,'getCRSOSelect'),
				'required'=>true,
				'related'=>array('CRSO_NAME', 'REFUND_EXPORT_ID', 'REFUND_REQUEST_DEBIT_ID', 'REFUND_REQUEST_CREDIT_ID', 'INVOICE_DOCUMENT_ID')));
		$this->_addWhere('PARTICIPANT_RELATION_ID',
			array(
				'field'=>'RE.`PARTICIPANT_RELATION_ID`',
				'callback' => array($this,'getParticipantSelect'),
				'related'=>array('PARTICIPANT_NAME')));
		$this->_addWhere('IS_EXPORTED',
			array(
				'field'=>'RE.`IS_EXPORTED`',
				'callback' => array($this,'getExported'),
				'related'=>array()));
		$this->_addWhere('DATE_PROCESSED',
			array(
				'field'=>'RE.`EXPORT_DATE`',
				'callback' => array($this,'getExportDate'),
				'related'=>array('DATE_PROCESSED')));
		$this->_addWhere('useQuery',
			array(
				'field'=>'useQuery',
				'useinquery'=>false,
				'callback' => array($this,'getQuerySelect')));
		$this->_addWhere('PRODUCT_ID',
			array(
				'field'=>'RE.PRODUCT_ID',
				'callback' => array($this,'getProductSelect')));

		$completedStatement = ' (1=1) ';
		if(isset($_REQUEST['STATUS']))
		{
			switch($_REQUEST['STATUS'])
			{
				case 'credit':
					$completedStatement = ' NOT ISNULL(REC.REFUND_REQUEST_CREDIT_ID) ';
				break;
				case 'invoice':
					$completedStatement = ' NOT ISNULL(RED.REFUND_REQUEST_DEBIT_ID) ';
				break;
			}
		}

		$this->_addWhere('STATUS',
			array(
				'field'=>'STATUS',
				'completedStatement' => $completedStatement,
				'callback' => array($this,'getStatusSelect')));
	}

	function getQuerySelect($rv='setValue')
	{
		$array = array(
			're_query'=>'By Refund Export',
			'rr_query'=>'By Refund Request'
			);

		$setValue = isset($_REQUEST['useQuery'])?$_REQUEST['useQuery']:'re_query';
		if(!isset($array[$setValue]))
			throw new IWAJAXPermissionException('Incorrect Query Filter Supplied');
		if(isset($$rv))
			return $$rv;
		$selectedValue = '';

		$select = new Form_Select('useQuery');
		$select->addOption(' - '.$this->getText('Filter Select').' - ', '', false);

		foreach($array as $query => $lang)
		{
			$trans = $this->getText($lang);
			if($setValue==$query)
				$selectedValue = $trans;
			$select->addOption($trans, $query, ($setValue==$query));
		}

		$filter = $select->getHtml();
		return $$rv;
	}

	function getStatusSelect($rv='setValue')
	{
		$setValue = isset($_REQUEST['STATUS'])?$_REQUEST['STATUS']:'All';
		if(isset($$rv))
			return $$rv;
		$selectedValue = '';

		$select = new Form_Select('STATUS');
		$select->addOption($this->getText('All'), 'All', false);

		$array = array(
			'credit'=>'Only Credits',
			'invoice'=>'Only Invoices'
			);

		foreach($array as $query => $lang)
		{
			$trans = $this->getText($lang);
			if($setValue==$query)
				$selectedValue = $trans;
			$select->addOption($trans, $query, ($setValue==$query));
		}

		$filter = $select->getHtml();
		return $$rv;
	}

	function getExported($rv='setValue')
	{
		$setValue = '2';
		$filter = '';
		$selectedValue = '';
		return $$rv;
	}

	function getExportDate($rv='setValue')
	{
		$filter ='';
		$selectedValue = '';
		(!empty($_REQUEST['DATE_PROCESSED'])) ? $setValue = $_REQUEST['DATE_PROCESSED'] : $setValue=false;
		$select = new Form_Select('DATE_PROCESSED');
		$select->addOption(' - '.$this->getText('Export').' - ', '', false);
		$sql = 'SELECT DISTINCT EXPORT_DATE FROM TBL_REFUND_EXPORT WHERE YEAR(EXPORT_DATE) = ? AND CRSO_RELATION_ID=? AND PRODUCT_ID = ? ';
		if($val = $this->getParticipantSelect('setValue'))
			$sql .= ' AND PARTICIPANT_RELATION_ID='.$val;
		$q = $this->db->query($sql);
		$q->bind_values($this->getYearSelect('setValue'), $this->getCRSOSelect('setValue'), $_SESSION['selected_product_id']);
		$q->execute();
		$rs = $q->fetchAll();
		if(count($rs))
		{
			foreach($rs as $r)
			{
				if($setValue==$r->EXPORT_DATE)
						$selectedValue = $r->EXPORT_DATE;
				$select->addOption($this->tfDate(array('value' => $r->EXPORT_DATE)), $r->EXPORT_DATE, false);
			}
			$select->setSelectedValue($setValue);
			$filter = $select->getHtml();
		}
		return $$rv;
	}


	function getProcessColumns()
	{
		return array(
			'tfValueProcessorQuantityNoDecimals'=>array('QUANTITY'),
			'tfInvoiceDocumentProcessor' => array('DOCUMENT'),
			'tfDate' => array('DATE_PROCESSED'),
			'tfRefundRequestId' => array('REFUND_REQUEST_ID'),
			'tfRefundRequestStatus' => array('STATUS'),
			'tfFixedFontWidth' => array('Hash'),
			);
	}

	function getColumnModifier()
	{
		return array('QUANTITY'=>'style="text-align:right;"');
	}

	function tfValueProcessorQuantityNoDecimals($args)
	{
		//this is for exports that are only doc reviews (ie not enough VStock)
		if(isset($args['row']['REFUND_REQUEST_ID']) && !$args['row']['REFUND_REQUEST_ID'])
			return '-';
		//normal
		if($args['value'] !== '-')
		{
			$this->_maxQuantity += $args['value'];
			$this->_cols = $args['visibleColumnCount'];
			$args['extra'] .= sprintf(' sort_val="%s" ', $args['value']);
	    	return locale_nf($args['value']);
		}
		//union'd requested invoices/credits
		return $args['value'];
	}

	function tfRefundRequestStatus($args)
	{
		if(!is_numeric($args['value']))
			return $this->langIf->getText('Correction of data');
		return parent::tfRefundRequestStatus($args);
	}

	function tfRefundRequestId($args)
	{
		switch($_SESSION['session_group_group_id'])
		{
			case GROUP_PARTICIPANT:
				return '<a href="/'.SITE_PATH.'scripts/elc/participant/InterfaceExportForm.php?refund[id]='.$args['value'].'">'.$args['value'].'</a>';
				break;
		}
		return $args['value'];
	}

	function tfInvoiceDocumentProcessor($args)
	{
		if(empty($args['row']['INVOICE_DOCUMENT_ID']))
			return $this->tfBooleanIcon($args);
		if(!empty($args['row']['REFUND_REQUEST_CREDIT_ID'])||!empty($args['row']['REFUND_REQUEST_DEBIT_ID']))
		{
			if($_SESSION['session_group_group_id']==GROUP_CRSO)
			{
				$args['value'] = 1;
				return $this->tfBooleanIcon($args);
			}
			return '<a href="/'.SITE_PATH.'scripts/i-w/document/download.php?Document[id]='.$args['row']['INVOICE_DOCUMENT_ID'].'">'.$args['value'].'</a>';
		}

		return $this->tfBooleanIcon($args);
	}

	function tfFixedFontWidth($args)
	{
		$this->_cols = $args['visibleColumns'];
		if($args['value'] != '-')
			$this->hashTotal .= $args['value'];
		return parent::tfFixedFontWidth($args);
	}

	function tfFooter() // getClass
	{
		if(!$this->_cols)
			return;
		$rv = explode(',',str_repeat(',',(sizeof($this->_cols)-1)));

		$pos = array_flip($this->_cols);
		if(isset($pos['Hash']))
			$rv[$pos['Hash']] = '<span style="font-size: 9pt; font-family: monospace; font-weight: bold;">'.md5($this->hashTotal).'</span>';
		return $rv;
	}
}
?>
