<?php
/**
 * Created by PhpStorm.
 * User: marten
 * Date: 25/1/17
 * Time: 12:29
 */

class WasteReportingList extends ELCDefaultList {

	var $handle = 'WasteReportingList';

	function setQuery() {

		$this->_query = "SELECT
				R.`NAME` as PARTICIPANT_NAME,
				WR.`YEAR` as `YEAR`,
				WR.`MONTH` as `MONTH`,
				WR.`WEIGHT` as `WEIGHT`
			FROM TBL_WASTE_REPORT as WR
			INNER JOIN TBL_RELATION as R
				ON WR.PARTICIPANT_RELATION_ID = R.RELATION_ID
		";
	}

	function _setWhere() {
		$this->_addWhere('CRSO_RELATION_ID',
			array('field'=>'WR.`CRSO_RELATION_ID`',
				'callback' => array($this,'getCRSOSelect'),
				'required'=>true));
		$this->_addWhere('PARTICIPANT_RELATION_ID',
			array('field'=>'WR.`PARTICIPANT_RELATION_ID`',
				'callback' => array($this,'getParticipantSelect'),
				'related'=>array('PARTICIPANT_NAME')));
		$this->_addWhere('YEAR',
			array(
				'field'=>'WR.`YEAR`',
				'callback' => array($this,'getYearSelect')));
		$this->_addWhere('MONTH',
			array(
				'field'=>'WR.`MONTH`',
				'callback' => array($this,'getMonthSelect')));
	}

	function getYearSelect($rv='setValue',$maxyear=false)
	{
		$date = currentDate();
		$year = (int)($maxyear?$maxyear:$date->getYear());

		$setValue = !empty($_REQUEST['YEAR']) ?
			(int)$_REQUEST['YEAR']:'';

		if(isset($$rv))
			return $$rv;
		$selectedValue = '';

		$select = new Form_Select('YEAR');

		if($year != WEEE_APPLICATION_START_YEAR)
		{
			$select->addOption(' - '.$this->getText('Year Select').' - ', '', false);
		}
		else
		{
			$filter = '';
			//$selectedValue = WEEE_APPLICATION_START_YEAR;
			return $$rv;
		}

		for($i=WEEE_APPLICATION_START_YEAR; $i<=$year; $i++)
		{
			if($setValue==$i)
				$selectedValue = $i;
			$select->addOption($i, $i, false);
		}

		$select->setSelectedValue($setValue);
		$filter = $select->getHtml();
		return $$rv;
	}

	function setEmptyText()	{
		return $this->langIf->getText('No waste reporting data found');
	}

	function tfSortingHat()	{
		return array(
			'YEAR'=>"'Int'",
			'WEIGHT'=>"'SortVal'",
			'PARTICIPANT_NAME'=>"'String'",
			'MONTH'=>"'Int'"
		);
	}

	function getColumnModifier() {
		return array('WEIGHT'=>'style="text-align:right;"');
	}

	function tfHeaderProc() {
		return array('thAlignRight'=>array('WEIGHT'));
	}

	function getButtons() {
		return array_merge($this -> _getCSVButton(), $this -> _getXMLButton());
	}

}