<?php


/**
 * This eats your cpu and mem.. oh and it also makes credit / debit lines for
 * declarations / refunds exported in the past. test this script with a copy of
 * the live before applying directly. Check the Operator Summary Report if all
 * went well.
 *
 * @package PACKAGE
 * @subpackage SUBPACKAGE
 * @since Dec 15, 2006
 * @author Martijn van den Broek <mjbroek@gmail.com>
 * @version $Id$
 * @copyright 2007 BaseSoft B.V.
 */

error_reporting(E_ALL);
restore_error_handler();

$params = array (
	'site-settings' => ''
);

foreach ($params as $varname => $bitbucket)
	foreach ($argv as $arg)
		if (preg_match('/--' .
			$varname . '=([^ ].*)/', $arg, $match))
			$params[$varname] = $match[1];

if (empty ($params['site-settings']))
{
	echo "please supply --site-settings=\n";
	exit (1);
}

$_REQUEST = array ();
$_SERVER = array (
	'SCRIPT_NAME' => $argv[0],
	'SERVER_NAME' => $params['site-settings'],
	'HTTP_USER_AGENT' => 'Mozilla/5.0 (Windows; U; Windows NT 5.0; en-US; rv:1.8.0.2) Gecko/20060308 Firefox/1.5.0.2',
	'PHP_SELF' => 'import_old_export_liones.php',
	'REMOTE_ADDR' => '127.0.0.1',
	'HTTP_HOST' => $params['site-settings'],
	'DOCUMENT_ROOT' => str_replace('scripts/elc/bots',
	'',
getcwd()));

$noValidate = true;
require_once ('../../i-w/default/init.php');

require_once(ELC_CLASSES.'ELCExporter_Declarations.php');
require_once(ELC_CLASSES.'ELCExporter_RefundRequests.php');

restore_error_handler();
restore_exception_handler();

/**
 * this class just works.. skipped for now
 */
class ELCExporter_Declarations_ExportOld extends ELCExporter_Declarations
{
	function __construct($db)
	{
		parent::__construct($db);
		self::$colsForInvoice[] = 'EXPORT_DATE'; // add a member to the static array but only in this case
		self::$colsForInvoice[] = 'IS_EXPORTED'; // add a member to the static array but only in this case
	}

	// we dont wanna export anything so leave it empty
	function doExport($crso_id) { }

	public function exportToFile($filename=null)
	{
                $q = $this->query("SELECT CRSO_RELATION_ID as `crso_id` FROM TBL_CRSO");
		while ( $r = $q->fetch() )
		{
			try
			{
				//now process the export
				$this->prepareInvoiceLines($r->crso_id);
				$this->doExport($r->crso_id);
			}
			catch(ELCExportException $eee)
			{
				$this->log->crit("Exception occured during export: ".$eee->getMessage()."\n\n".$eee->getTraceAsString());
			}
		}
	}

	protected function prepareInvoiceLines($crso_id)
	{
		self::$invoice_numbers = array(); //need to refresh per crso

		$this->db->begin();
		$sql = "
			SELECT dl.DECLARATION_ID as DECLARATION_ID,
					IF(ISNULL(dd.DECLARATION_DEBIT_ID),
						f_elcBuildInvoiceNoForExport(d.CRSO_RELATION_ID,dc.`YEAR`,dc.DECLARATION_CREDIT_ID,TRUE,FALSE),
						f_elcBuildInvoiceNoForExport(d.CRSO_RELATION_ID,dd.`YEAR`,dd.DECLARATION_DEBIT_ID,FALSE,FALSE)) as INVOICE_NUMBER,
				dc.DECLARATION_CREDIT_ID as DECLARATION_CREDIT_ID,
				dd.DECLARATION_DEBIT_ID as DECLARATION_DEBIT_ID,
				 YEAR(d.EXPORT_DATE) as `YEAR`,
				d.CRSO_RELATION_ID as CRSO_RELATION_ID,
				dl.LINE_INDEX as DECLARATION_LINE_INDEX,
				IF(ISNULL(dd.DECLARATION_DEBIT_ID),
					RTRIM(CONCAT('C', d.CRSO_RELATION_ID, SUBSTRING(dc.`YEAR`, -2),dc.DECLARATION_CREDIT_ID,'  ')),
					RTRIM(CONCAT('I', d.CRSO_RELATION_ID, SUBSTRING(dd.`YEAR`, -2),dd.DECLARATION_DEBIT_ID, '  '))) as INVOICE_LINE_INDEX, -- see value processor
				d.PRODUCT_ID as PRODUCT_ID,
				CONCAT(IF(ISNULL(dd.DECLARATION_DEBIT_ID),'C','I'), d.CRSO_RELATION_ID) as JOURNAL_TEMPLATE,
				CONCAT(cac.CODE,
					LPAD(d.CRSO_RELATION_ID, 8, 0),
					LPAD(d.PARTICIPANT_RELATION_ID, 8, 0)
				) as CUSTOMER_NO,
				IFNULL(dl.CREATED, d.EXPORT_DATE) as POSTING_DATE,
				d.EXPORT_DATE as DOCUMENT_DATE,
				d.EXPORT_DATE as EXPORT_DATE,
				'G/L Account' as `TYPE`,
				CONCAT(dl.DECLARATION_ID, ';', dl.STATUS) as GL_ACCOUNT_NO, -- see value processor
				CONCAT(
					'1/', d.MONTH,'/',d.YEAR,' - ',
					DAYOFMONTH(LAST_DAY(CONCAT(d.YEAR, '-', d.MONTH,'-1'))),'/',d.MONTH,'/',d.YEAR
				) as DESCRIPTION,
				IF(ISNULL(dd.DECLARATION_DEBIT_ID),
					IF(dl.STATUS = 64,
						ABS(dl.QUANTITY),
						-(ABS(dl.QUANTITY))
					),
					IF(dl.STATUS = 64,
						-(ABS(dl.QUANTITY)),
						ABS(dl.QUANTITY)
					)
				) as QUANTITY,
				f_elcProductFee(d.PRODUCT_ID, d.CRSO_RELATION_ID, dl.PRODUCT_CATEGORY_ID, CONCAT(d.YEAR, '-', d.MONTH, '-01 00:00:00')) as UNIT_COST,
				IF(ISNULL(dd.DECLARATION_DEBIT_ID),
					IF(dl.STATUS = 64,
						ABS(
							(dl.QUANTITY *
								f_elcProductFee(d.PRODUCT_ID, d.CRSO_RELATION_ID, dl.PRODUCT_CATEGORY_ID, CONCAT(d.YEAR, '-', d.MONTH, '-01 00:00:00')))),
						-(ABS(
							(dl.QUANTITY *
								f_elcProductFee(d.PRODUCT_ID, d.CRSO_RELATION_ID, dl.PRODUCT_CATEGORY_ID, CONCAT(d.YEAR, '-', d.MONTH, '-01 00:00:00')))))
					),
					IF(dl.STATUS = 64,
						-(ABS(
							(dl.QUANTITY *
								f_elcProductFee(d.PRODUCT_ID, d.CRSO_RELATION_ID, dl.PRODUCT_CATEGORY_ID, CONCAT(d.YEAR, '-', d.MONTH, '-01 00:00:00'))))),
						ABS(
							(dl.QUANTITY *
								f_elcProductFee(d.PRODUCT_ID, d.CRSO_RELATION_ID, dl.PRODUCT_CATEGORY_ID, CONCAT(d.YEAR, '-', d.MONTH, '-01 00:00:00'))))

					)
				) as LINE_AMOUNT_EXCL_VAT,
				(dl.QUANTITY * f_elcProductFee(d.PRODUCT_ID, d.CRSO_RELATION_ID, dl.PRODUCT_CATEGORY_ID, CONCAT(d.YEAR, '-', d.MONTH, '-01 00:00:00'))) as EXPORTED_AMOUNT,
				IF(ISNULL(dd.DECLARATION_DEBIT_ID), f_elcGetDeclarationCreditTotalAmount(d.CRSO_RELATION_ID, dc.DECLARATION_CREDIT_ID, dc.`YEAR`), f_elcGetDeclarationDebitTotalAmount(d.CRSO_RELATION_ID, dd.DECLARATION_DEBIT_ID, dd.`YEAR`)) as TOTAL_AMOUNT_EXCL_VAT,
				IFNULL(dl.WEIGHT, '') as NET_WEIGHT,
				IFNULL(dl.WEIGHT, '') as DECL_WEIGHT,
				IFNULL(pc.`NAME`, '') as DECL_PRODUCT_CATEGORY,
				IFNULL(b.NAME, '') as DECL_BRAND,
				d.`MONTH` as DECL_MONTH,
				d.`YEAR` as DECL_YEAR,
				dl.STATUS as DECL_TYPE,
				SUM(dl.QUANTITY) as DECL_TOTAL,
				IF(ISNULL(dd.DECLARATION_DEBIT_ID), CONCAT('INVI', dd2.CRSO_RELATION_ID, SUBSTRING(dd2.`YEAR`, -2), dd2.DECLARATION_DEBIT_ID), '') as ORIGINAL_INVOICE,
				CONCAT(cac.CODE,
					LPAD(d.CRSO_RELATION_ID, 8, 0),
					LPAD(d.PARTICIPANT_RELATION_ID, 8, 0)
				) as BILL_TO_CUSTOMER_NO,
				p.`NAME` as PRODUCT_DESCRIPTION,
				MD5(CONCAT(

					IF(ISNULL(dd.DECLARATION_DEBIT_ID),
						f_elcBuildInvoiceNoForInterfaces(d.CRSO_RELATION_ID,dc.`YEAR`,dc.DECLARATION_CREDIT_ID,TRUE,FALSE),
						f_elcBuildInvoiceNoForInterfaces(d.CRSO_RELATION_ID,dd.`YEAR`,dd.DECLARATION_DEBIT_ID,FALSE,FALSE)
					 ),
					CONCAT(cac.CODE,
						LPAD(d.CRSO_RELATION_ID, 8, 0),
						LPAD(d.PARTICIPANT_RELATION_ID, 8, 0)
					),
					REPLACE(IF(ISNULL(dd.DECLARATION_DEBIT_ID), f_elcGetDeclarationCreditTotalAmount(d.CRSO_RELATION_ID, dc.DECLARATION_CREDIT_ID, dc.`YEAR`), f_elcGetDeclarationDebitTotalAmount(d.CRSO_RELATION_ID, dd.DECLARATION_DEBIT_ID, dd.`YEAR`)), '.', ',')
				)) AS HASH_TOTAL,
			1 as IS_EXPORTED
			FROM TBL_DECLARATION as d
			INNER JOIN TBL_RELATION as cr
				ON cr.RELATION_ID = d.CRSO_RELATION_ID
			INNER JOIN TBL_ADDRESS as ca
				ON cr.ADDRESS_ID = ca.ADDRESS_ID
			INNER JOIN TBL_COUNTRY as cac
				ON cac.COUNTRY_ID = ca.COUNTRY_ID
			INNER JOIN TBL_DECLARATION_SET_LINE AS dsl
				ON d.DECLARATION_ID = dsl.DECLARATION_ID
			LEFT JOIN TBL_DECLARATION_DEBIT as dd
				ON dsl.DECLARATION_SET_ID = dd.DECLARATION_SET_ID
			LEFT JOIN TBL_DECLARATION_CREDIT as dc
				ON dsl.DECLARATION_SET_ID = dc.DECLARATION_SET_ID
			INNER JOIN TBL_DECLARATION_LINE as dl
				ON dl.DECLARATION_ID = d.DECLARATION_ID
			LEFT JOIN TBL_PRODUCT_CATEGORY as pc
				ON dl.PRODUCT_CATEGORY_ID = pc.PRODUCT_CATEGORY_ID
			INNER JOIN TBL_PRODUCT as p
				ON d.PRODUCT_ID = p.PRODUCT_ID
			LEFT JOIN TBL_BRAND as b
				ON b.BRAND_ID = dl.BRAND_ID
			LEFT JOIN TBL_DECLARATION_SET_LINE AS dsl2
				ON d.PARENT_DECLARATION_ID = dsl2.DECLARATION_ID
			LEFT JOIN TBL_DECLARATION_DEBIT as dd2
				ON dsl2.DECLARATION_SET_ID = dd2.DECLARATION_SET_ID
			WHERE d.IS_EXPORTED = ?
				AND d.CRSO_RELATION_ID = ?
				AND (ISNULL(dd.DECLARATION_DEBIT_ID) XOR ISNULL(dc.DECLARATION_CREDIT_ID))
				AND UNIX_TIMESTAMP(d.EXPORT_DATE) < UNIX_TIMESTAMP('2007-10-19')
			GROUP BY dl.DECLARATION_ID, dl.LINE_INDEX
			ORDER BY d.PARTICIPANT_RELATION_ID, d.PRODUCT_ID, dl.LINE_INDEX
		";
		$bind_values = array(
			DECLARATION_EXPORT_EXPORTED, // changed this from original query open -> exported
			$crso_id);

		echo 'working on crso '.$crso_id."\n";
		$q = $this->query($sql, $bind_values);

		while ($row = $q->fetch())
		{
			try
                        {
                            $this->insertInvoiceLine($row);
                        }
                        catch(Exception $e)
                        {
                            echo $e->getMessage()."\n";
                            //pass - already exists
                        }
		}

		unset($q);
		$this->db->commit();
		echo 'finished crso '.$crso_id."\n";
	}

}

/**
 * this class works partially
 */
class ELCExporter_RefundRequests_ExportOld extends ELCExporter_RefundRequests
{
	function __construct($db)
	{
		parent::__construct($db);
		self::$colsForInvoice[] = 'EXPORT_DATE'; // add a member to the static array but only in this case
		self::$colsForInvoice[] = 'IS_EXPORTED'; // add a member to the static array but only in this case
	}

	// we dont wanna export anything so leave it empty
	function doExport($crso_id) { }

	public function exportToFile($filename=null)
	{
		$q = $this->query("SELECT CRSO_RELATION_ID as `crso_id` FROM TBL_CRSO");
		while ( $r = $q->fetch() )
		{
			try
			{
				//now process the export
				$this->prepareInvoiceLines($r->crso_id);
				$this->doExport($r->crso_id);
			}
			catch(ELCExportException $eee)
			{
				$this->log->crit("Exception occured during export: ".$eee->getMessage()."\n\n".$eee->getTraceAsString());
			}
		}
	}

	protected function prepareInvoiceLines($crso_id)
	{
		self::$invoice_numbers1 = array();
		self::$invoice_numbers2 = array();

		$this->db->begin();

		/**
		 * this query gets executed sucessful.. after 30 mins
		 */
		$sql = "
			SELECT
			'' AS INVOICE_LINE_INDEX,
			rec.REFUND_REQUEST_CREDIT_ID as REFUND_REQUEST_CREDIT_ID,
			red.REFUND_REQUEST_DEBIT_ID as REFUND_REQUEST_DEBIT_ID,
			IF(ISNULL(red.REFUND_REQUEST_DEBIT_ID), rec.`YEAR`, red.`YEAR`) as `YEAR`,
			rr.CRSO_RELATION_ID as CRSO_RELATION_ID,
			re.PRODUCT_ID as PRODUCT_ID,
			IF(
				ISNULL(red.REFUND_REQUEST_DEBIT_ID),
				CONCAT(
					'RC',
					rr.CRSO_RELATION_ID,
					f_elcBuildInvoiceNoForExport(rr.CRSO_RELATION_ID,rec.`YEAR`,rec.REFUND_REQUEST_CREDIT_ID,TRUE,TRUE)
				),
				CONCAT(
					'RI',
					rr.CRSO_RELATION_ID,
					f_elcBuildInvoiceNoForExport(rr.CRSO_RELATION_ID,red.`YEAR`,red.REFUND_REQUEST_DEBIT_ID,FALSE,TRUE)
				)
			) as INVOICE_NUMBER,
			re.REFUND_EXPORT_ID,
			rrl.REFUND_REQUEST_ID as REFUND_REQUEST_ID,
			rrl.LINE_INDEX as REFUND_LINE_INDEX,
			CONCAT(IF(ISNULL(red.REFUND_REQUEST_DEBIT_ID),'RC','RI'), rr.CRSO_RELATION_ID) as JOURNAL_TEMPLATE,
			CONCAT(cac.CODE,
				LPAD(rr.CRSO_RELATION_ID, 8, 0),
				LPAD(rr.PARTICIPANT_RELATION_ID, 8, 0)
			) as CUSTOMER_NO,
			'' as CUSTOMER_NAME,
			LAST_DAY(DATE_SUB(re.EXPORT_DATE, INTERVAL 1 MONTH)) as POSTING_DATE,
			re.EXPORT_DATE as DOCUMENT_DATE,
			re.EXPORT_DATE as EXPORT_DATE,
			'' as EXTERNAL_DOCUMENT_NO,
			'' as CURRENCY_CODE,
			'G/L Account' as `TYPE`,
				(SELECT GL_ACCOUNT
				FROM TBL_CRSO_GLACCOUNT gc
				INNER JOIN TBL_DECLARATION_TYPE dt
					ON gc.DECLARATION_TYPE_ID = dt.DECLARATION_TYPE_ID
				WHERE gc.CRSO_RELATION_ID = :crso_id
					AND dt.HANDLE = 'DT_REFUND_REQUEST')
			as GL_ACCOUNT_NO,
			CONCAT('PERIOD: ', IFNULL(rr.REFUND_EXPORT_DATE, ''))  as DESCRIPTION,
			IF(ISNULL(red.REFUND_REQUEST_DEBIT_ID),
					IF(IFNULL(rrl.QUANTITY, 0) >= 0,
						ABS(IFNULL(rrl.QUANTITY, 0)),
						-(ABS(IFNULL(rrl.QUANTITY, 0)))
					),
					IF(IFNULL(rrl.QUANTITY, 0) >= 0,
						-(ABS(IFNULL(rrl.QUANTITY, 0))),
						ABS(IFNULL(rrl.QUANTITY, 0))
					)
			) as QUANTITY,
			f_elcProductFee(1, rr.CRSO_RELATION_ID, rrl.PRODUCT_CATEGORY_ID, NOW()) as UNIT_COST,
			IF(ISNULL(red.REFUND_REQUEST_DEBIT_ID),
					IF(IFNULL(rrl.QUANTITY, 0) >= 0,
						ABS(IFNULL(rrl.EXPORTED_AMOUNT, 0)),
						-(ABS(IFNULL(rrl.EXPORTED_AMOUNT, 0)))
					),
					IF(IFNULL(rrl.QUANTITY, 0) >= 0,
						-(ABS(IFNULL(rrl.EXPORTED_AMOUNT, 0))),
						ABS(IFNULL(rrl.EXPORTED_AMOUNT, 0))
					)
			) as LINE_AMOUNT_EXCL_VAT,
			f_elcGetTotalAmountForRefundExport(re.REFUND_EXPORT_ID) as TOTAL_AMOUNT_EXCL_VAT,
			'' as NAVISION_VAT_CODE,
			'' as VAT_EXTENDED_TEXT,
			'' as DIMENSION_CODE_1,
			'' as DIMENSION_CODE_2,
			'' as DIMENSION_CODE_3,
			'' as DIMENSION_CODE_4,
			'' as DIMENSION_CODE_5,
			'' as DIMENSION_CODE_6,
			'' as DIMENSION_CODE_7,
			'' as DIMENSION_CODE_8,
			'' as TARIFF_NO,
			IFNULL(rrl.WEIGHT, '') as NET_WEIGHT,
			'' as TRANSACTION_TYPE,
			'' as EXIT_POINT,
			'' as TRANSPORT_METHOD,
			rr.REFUND_EXPORT_DATE as REFUND_EXPORT_DATE,
			CONCAT(cac.CODE,
						LPAD(re.CRSO_RELATION_ID, 8, 0),
						LPAD(IFNULL(re.BILL_TO_CUSTOMER_NO,re.PARTICIPANT_RELATION_ID), 8, 0)
			) as BILL_TO_CUSTOMER_NO,
			p.`NAME` as PRODUCT_DESCRIPTION,
			(
				SELECT COUNT(redr2.REVIEW_COST)
					FROM TBL_REFUND_EXPORT_DOCUMENT_REVIEW as redr2
					WHERE redr2.REFUND_EXPORT_ID = re.REFUND_EXPORT_ID
			) as DOCUMENT_REVIEW_NO,
			rrl.WEIGHT as REFUND_WEIGHT,
			pc.`NAME` as REFUND_PRODUCT_CATEGORY,
			b.`NAME` as REFUND_BRAND,
			MD5(CONCAT(

					IF(ISNULL(red.REFUND_REQUEST_DEBIT_ID),
							f_elcBuildInvoiceNoForInterfaces(re.CRSO_RELATION_ID,rec.`YEAR`,rec.REFUND_REQUEST_CREDIT_ID,TRUE,TRUE),
							f_elcBuildInvoiceNoForInterfaces(re.CRSO_RELATION_ID,red.`YEAR`,red.REFUND_REQUEST_DEBIT_ID,FALSE,TRUE)
					 ),
					CONCAT(cac.CODE,
						LPAD(re.CRSO_RELATION_ID, 8, 0),
						LPAD(re.PARTICIPANT_RELATION_ID, 8, 0)
					),
					REPLACE((CAST(f_elcGetTotalAmountForRefundExport(re.REFUND_EXPORT_ID) AS DECIMAL(10,2)) ), '.', ',')
				)) as HASH_TOTAL,
			1 as IS_EXPORTED
			FROM TBL_REFUND_REQUEST as rr
			INNER JOIN TBL_PRODUCT as p
				on rr.PRODUCT_ID = p.PRODUCT_ID
			INNER JOIN TBL_REFUND_EXPORT as re
				ON re.REFUND_EXPORT_ID = rr.REFUND_EXPORT_ID
			INNER JOIN TBL_RELATION as cr
				ON cr.RELATION_ID = rr.CRSO_RELATION_ID
			INNER JOIN TBL_ADDRESS as ca
				ON cr.ADDRESS_ID = ca.ADDRESS_ID
			INNER JOIN TBL_COUNTRY as cac
				ON cac.COUNTRY_ID = ca.COUNTRY_ID
			INNER JOIN TBL_REFUND_EXPORT_SET_LINE resl
				ON re.REFUND_EXPORT_ID = resl.REFUND_EXPORT_ID
			LEFT JOIN TBL_REFUND_EXPORT_DEBIT as red
				ON red.REFUND_EXPORT_SET_ID = resl.REFUND_EXPORT_SET_ID
			LEFT JOIN TBL_REFUND_EXPORT_CREDIT as rec
				ON rec.REFUND_EXPORT_SET_ID = resl.REFUND_EXPORT_SET_ID
			INNER JOIN TBL_REFUND_REQUEST_LINE as rrl
				ON rr.REFUND_REQUEST_ID = rrl.REFUND_REQUEST_ID
			LEFT JOIN TBL_PRODUCT_CATEGORY as pc
				ON rrl.PRODUCT_CATEGORY_ID = pc.PRODUCT_CATEGORY_ID
			LEFT JOIN TBL_BRAND as b
				ON b.BRAND_ID = rrl.BRAND_ID
			LEFT JOIN TBL_REFUND_EXPORT_DOCUMENT_REVIEW as redr
				ON re.REFUND_EXPORT_ID = redr.REFUND_EXPORT_ID
			WHERE re.IS_EXPORTED = 2 -- exported
				AND rr.CRSO_RELATION_ID = :crso_id
				AND UNIX_TIMESTAMP(re.EXPORT_DATE) < UNIX_TIMESTAMP('2007-10-19')
			GROUP BY rr.REFUND_REQUEST_ID, rrl.LINE_INDEX
		";

		$q = $this->db->query($sql);
		$q->bindParam(':crso_id', $crso_id);
		$q->execute();

		while ($row = $q->fetch())
		{
			//get em into invoice lines
			$this->insertInvoiceLine($row);
		}

		unset($q);

		// do refund docs
		$sql = "SELECT
			'' AS INVOICE_LINE_INDEX,
			rec.REFUND_REQUEST_CREDIT_ID as REFUND_REQUEST_CREDIT_ID,
			red.REFUND_REQUEST_DEBIT_ID as REFUND_REQUEST_DEBIT_ID,
			IF(ISNULL(red.REFUND_REQUEST_DEBIT_ID), rec.`YEAR`, red.`YEAR`) as `YEAR`,
			re.CRSO_RELATION_ID as CRSO_RELATION_ID,
			re.PRODUCT_ID as PRODUCT_ID,
			IF(
				ISNULL(red.REFUND_REQUEST_DEBIT_ID),
				CONCAT(
					'RC',
					re.CRSO_RELATION_ID,
					f_elcBuildInvoiceNoForExport(re.CRSO_RELATION_ID,rec.`YEAR`,rec.REFUND_REQUEST_CREDIT_ID,TRUE,TRUE)
				),
				CONCAT(
					'RI',
					re.CRSO_RELATION_ID,
					f_elcBuildInvoiceNoForExport(re.CRSO_RELATION_ID,red.`YEAR`,red.REFUND_REQUEST_DEBIT_ID,FALSE,TRUE)
				)
			) as INVOICE_NUMBER,
			re.REFUND_EXPORT_ID,
			NULL as REFUND_REQUEST_ID,
			NULL as REFUND_LINE_INDEX,
			CONCAT(IF(ISNULL(red.REFUND_REQUEST_DEBIT_ID),'RC','RI'), re.CRSO_RELATION_ID) as JOURNAL_TEMPLATE,
			CONCAT(cac.CODE,
				LPAD(re.CRSO_RELATION_ID, 8, 0),
				LPAD(re.PARTICIPANT_RELATION_ID, 8, 0)
			) as CUSTOMER_NO,
			'' as CUSTOMER_NAME,
			LAST_DAY(DATE_SUB(re.EXPORT_DATE, INTERVAL 1 MONTH)) as POSTING_DATE,
			re.EXPORT_DATE as DOCUMENT_DATE,
			re.EXPORT_DATE as EXPORT_DATE,
			'' as EXTERNAL_DOCUMENT_NO,
			'' as CURRENCY_CODE,
			'G/L Account' as `TYPE`,
				(SELECT GL_ACCOUNT
				FROM TBL_CRSO_GLACCOUNT gc
				INNER JOIN TBL_DECLARATION_TYPE dt
					ON gc.DECLARATION_TYPE_ID = dt.DECLARATION_TYPE_ID
				WHERE gc.CRSO_RELATION_ID = :crso_id
					AND dt.HANDLE = 'DT_REFUND_DOCUMENT_REVIEW')
			as GL_ACCOUNT_NO,
			'".$this->getText('sum of document review fee', $this->getLangIdForCRSO($crso_id))."'  as DESCRIPTION, -- is this supposed to be a preferable combination of peroid, unit and weight information
			IF(ISNULL(red.REFUND_REQUEST_DEBIT_ID), '-1', '1') as QUANTITY,
			'0,00' as UNIT_COST,
			(
				SELECT SUM(redr2.REVIEW_COST) FROM TBL_REFUND_EXPORT_DOCUMENT_REVIEW redr2 WHERE redr2.REFUND_EXPORT_ID = re.REFUND_EXPORT_ID
			) as LINE_AMOUNT_EXCL_VAT,
			IF(ISNULL(red.REFUND_REQUEST_DEBIT_ID),
					-(ABS((SELECT SUM(redr2.REVIEW_COST) FROM TBL_REFUND_EXPORT_DOCUMENT_REVIEW redr2 WHERE redr2.REFUND_EXPORT_ID = re.REFUND_EXPORT_ID))),
					ABS((SELECT SUM(redr2.REVIEW_COST) FROM TBL_REFUND_EXPORT_DOCUMENT_REVIEW redr2 WHERE redr2.REFUND_EXPORT_ID = re.REFUND_EXPORT_ID))
			) as LINE_AMOUNT_EXCL_VAT,
			f_elcGetTotalAmountForRefundExport(re.REFUND_EXPORT_ID) as TOTAL_AMOUNT_EXCL_VAT,
			'' as NAVISION_VAT_CODE,
			'' as VAT_EXTENDED_TEXT,
			'' as DIMENSION_CODE_1,
			'' as DIMENSION_CODE_2,
			'' as DIMENSION_CODE_3,
			'' as DIMENSION_CODE_4,
			'' as DIMENSION_CODE_5,
			'' as DIMENSION_CODE_6,
			'' as DIMENSION_CODE_7,
			'' as DIMENSION_CODE_8,
			'' as TARIFF_NO,
			NULL as NET_WEIGHT,
			'' as TRANSACTION_TYPE,
			'' as EXIT_POINT,
			'' as TRANSPORT_METHOD,
			NULL as REFUND_EXPORT_DATE,
			CONCAT(cac.CODE,
				LPAD(re.CRSO_RELATION_ID, 8, 0),
				LPAD(IFNULL(re.BILL_TO_CUSTOMER_NO,re.PARTICIPANT_RELATION_ID), 8, 0)
			) as BILL_TO_CUSTOMER_NO,
			p.`NAME` as PRODUCT_DESCRIPTION,
			(
				SELECT COUNT(redr3.REVIEW_COST)
					FROM TBL_REFUND_EXPORT_DOCUMENT_REVIEW as redr3
					WHERE redr3.REFUND_EXPORT_ID = re.REFUND_EXPORT_ID
			) as DOCUMENT_REVIEW_NO,
			NULL as REFUND_WEIGHT,
			NULL as REFUND_PRODUCT_CATEGORY,
			NULL as REFUND_BRAND,
			MD5(CONCAT(

					IF(ISNULL(red.REFUND_REQUEST_DEBIT_ID),
							f_elcBuildInvoiceNoForInterfaces(re.CRSO_RELATION_ID,rec.`YEAR`,rec.REFUND_REQUEST_CREDIT_ID,TRUE,TRUE),
							f_elcBuildInvoiceNoForInterfaces(re.CRSO_RELATION_ID,red.`YEAR`,red.REFUND_REQUEST_DEBIT_ID,FALSE,TRUE)
					 ),
					CONCAT(cac.CODE,
						LPAD(re.CRSO_RELATION_ID, 8, 0),
						LPAD(re.PARTICIPANT_RELATION_ID, 8, 0)
					),
					REPLACE((CAST(f_elcGetTotalAmountForRefundExport(re.REFUND_EXPORT_ID) AS DECIMAL(10,2)) ), '.', ',')
				)) as HASH_TOTAL,
			1 as IS_EXPORTED
			FROM TBL_REFUND_EXPORT as re
			INNER JOIN TBL_PRODUCT as p
				on re.PRODUCT_ID = p.PRODUCT_ID
			INNER JOIN TBL_RELATION as cr
				ON cr.RELATION_ID = re.CRSO_RELATION_ID
			INNER JOIN TBL_ADDRESS as ca
				ON cr.ADDRESS_ID = ca.ADDRESS_ID
			INNER JOIN TBL_COUNTRY as cac
				ON cac.COUNTRY_ID = ca.COUNTRY_ID
			INNER JOIN TBL_REFUND_EXPORT_SET_LINE resl
				ON re.REFUND_EXPORT_ID = resl.REFUND_EXPORT_ID
			LEFT JOIN TBL_REFUND_EXPORT_DEBIT as red
				ON red.REFUND_EXPORT_SET_ID = resl.REFUND_EXPORT_SET_ID
			LEFT JOIN TBL_REFUND_EXPORT_CREDIT as rec
				ON rec.REFUND_EXPORT_SET_ID = resl.REFUND_EXPORT_SET_ID
			INNER JOIN TBL_REFUND_EXPORT_DOCUMENT_REVIEW as redr
				ON re.REFUND_EXPORT_ID = redr.REFUND_EXPORT_ID
			WHERE re.IS_EXPORTED = 2 -- exported
				AND re.CRSO_RELATION_ID = :crso_id
				AND UNIX_TIMESTAMP(re.EXPORT_DATE) < UNIX_TIMESTAMP('2007-10-19')
			GROUP BY re.REFUND_EXPORT_ID
		";

		$q = $this->db->query($sql);
		$q->bindParam(':crso_id', $crso_id);
		$q->execute();

		while ($row = $q->fetch())
		{
			//get em into invoice lines
			$this->insertInvoiceLine($row);
		}
		unset($q);

		//get refund fees
		$sql = "
			SELECT
			'' AS INVOICE_LINE_INDEX,
			rec.REFUND_REQUEST_CREDIT_ID as REFUND_REQUEST_CREDIT_ID,
			red.REFUND_REQUEST_DEBIT_ID as REFUND_REQUEST_DEBIT_ID,
			IF(ISNULL(red.REFUND_REQUEST_DEBIT_ID), rec.`YEAR`, red.`YEAR`) as `YEAR`,
			re.CRSO_RELATION_ID as CRSO_RELATION_ID,
			re.PRODUCT_ID as PRODUCT_ID,
			IF(
				ISNULL(red.REFUND_REQUEST_DEBIT_ID),
				CONCAT(
					'RC',
					re.CRSO_RELATION_ID,
					f_elcBuildInvoiceNoForExport(re.CRSO_RELATION_ID,rec.`YEAR`,rec.REFUND_REQUEST_CREDIT_ID,TRUE,TRUE)
				),
				CONCAT(
					'RI',
					re.CRSO_RELATION_ID,
					f_elcBuildInvoiceNoForExport(re.CRSO_RELATION_ID,red.`YEAR`,red.REFUND_REQUEST_DEBIT_ID,FALSE,TRUE)
				)
			) as INVOICE_NUMBER,
			re.REFUND_EXPORT_ID,
			NULL as REFUND_REQUEST_ID,
			NULL as REFUND_LINE_INDEX,
			CONCAT(IF(ISNULL(red.REFUND_REQUEST_DEBIT_ID),'RC','RI'), re.CRSO_RELATION_ID) as JOURNAL_TEMPLATE,
			CONCAT(cac.CODE,
				LPAD(re.CRSO_RELATION_ID, 8, 0),
				LPAD(re.PARTICIPANT_RELATION_ID, 8, 0)
			) as CUSTOMER_NO,
			'' as CUSTOMER_NAME,
			LAST_DAY(DATE_SUB(re.EXPORT_DATE, INTERVAL 1 MONTH)) as POSTING_DATE,
			re.EXPORT_DATE as DOCUMENT_DATE,
			re.EXPORT_DATE as EXPORT_DATE,
			'' as EXTERNAL_DOCUMENT_NO,
			'' as CURRENCY_CODE,
			'G/L Account' as `TYPE`,
				(SELECT GL_ACCOUNT
				FROM TBL_CRSO_GLACCOUNT gc
				INNER JOIN TBL_DECLARATION_TYPE dt
					ON gc.DECLARATION_TYPE_ID = dt.DECLARATION_TYPE_ID
				WHERE gc.CRSO_RELATION_ID = ?
					AND dt.HANDLE = ?)
			as GL_ACCOUNT_NO,
			'".$this->getText('refund fee', $this->getLangIdForCRSO($crso_id))."'  as `DESCRIPTION`, -- is this supposed to be a preferable combination of peroid, unit and weight information
			IF(ISNULL(red.REFUND_REQUEST_DEBIT_ID), '-1', '1') as 'QUANTITY',
			IFNULL(re.REFUND_COST, '0.00') as UNIT_COST,
			IF(ISNULL(red.REFUND_REQUEST_DEBIT_ID),
					-(ABS(IFNULL(re.REFUND_COST, '0.00'))),
					ABS(IFNULL(re.REFUND_COST, '0.00'))
			) as LINE_AMOUNT_EXCL_VAT,
			f_elcGetTotalAmountForRefundExport(re.REFUND_EXPORT_ID) as TOTAL_AMOUNT_EXCL_VAT,
			'' as NAVISION_VAT_CODE,
			'' as VAT_EXTENDED_TEXT,
			'' as DIMENSION_CODE_1,
			'' as DIMENSION_CODE_2,
			'' as DIMENSION_CODE_3,
			'' as DIMENSION_CODE_4,
			'' as DIMENSION_CODE_5,
			'' as DIMENSION_CODE_6,
			'' as DIMENSION_CODE_7,
			'' as DIMENSION_CODE_8,
			'' as TARIFF_NO,
			NULL as NET_WEIGHT,
			'' as TRANSACTION_TYPE,
			'' as EXIT_POINT,
			'' as TRANSPORT_METHOD,
			NULL as REFUND_EXPORT_DATE,
			CONCAT(cac.CODE,
				LPAD(re.CRSO_RELATION_ID, 8, 0),
				LPAD(IFNULL(re.BILL_TO_CUSTOMER_NO,re.PARTICIPANT_RELATION_ID), 8, 0)
			) as BILL_TO_CUSTOMER_NO,
			p.`NAME` as PRODUCT_DESCRIPTION,
			(
				SELECT COUNT(redr3.REVIEW_COST)
					FROM TBL_REFUND_EXPORT_DOCUMENT_REVIEW as redr3
					WHERE redr3.REFUND_EXPORT_ID = re.REFUND_EXPORT_ID
			) as DOCUMENT_REVIEW_NO,
			NULL as REFUND_WEIGHT,
			NULL as REFUND_PRODUCT_CATEGORY,
			NULL as REFUND_BRAND,
			MD5(CONCAT(

					IF(ISNULL(red.REFUND_REQUEST_DEBIT_ID),
						f_elcBuildInvoiceNoForInterfaces(re.CRSO_RELATION_ID,rec.`YEAR`,rec.REFUND_REQUEST_CREDIT_ID,TRUE,TRUE),
						f_elcBuildInvoiceNoForInterfaces(re.CRSO_RELATION_ID,red.`YEAR`,red.REFUND_REQUEST_DEBIT_ID,FALSE,TRUE)
					 ),
					CONCAT(cac.CODE,
						LPAD(re.CRSO_RELATION_ID, 8, 0),
						LPAD(re.PARTICIPANT_RELATION_ID, 8, 0)
					),
					REPLACE((CAST(f_elcGetTotalAmountForRefundExport(re.REFUND_EXPORT_ID) AS DECIMAL(10,2)) ), '.', ',')
				)) as HASH_TOTAL,
			1 as IS_EXPORTED
			FROM TBL_REFUND_EXPORT as re
			INNER JOIN TBL_PRODUCT as p
				on re.PRODUCT_ID = p.PRODUCT_ID
			 INNER JOIN TBL_RELATION as cr
			     ON cr.RELATION_ID = re.CRSO_RELATION_ID
			 INNER JOIN TBL_ADDRESS as ca
			     ON cr.ADDRESS_ID = ca.ADDRESS_ID
			 INNER JOIN TBL_COUNTRY as cac
			     ON cac.COUNTRY_ID = ca.COUNTRY_ID
			 INNER JOIN TBL_REFUND_EXPORT_SET_LINE resl
			     ON re.REFUND_EXPORT_ID = resl.REFUND_EXPORT_ID
			 LEFT JOIN TBL_REFUND_EXPORT_DEBIT as red
			     ON red.REFUND_EXPORT_SET_ID = resl.REFUND_EXPORT_SET_ID
			 LEFT JOIN TBL_REFUND_EXPORT_CREDIT as rec
			     ON rec.REFUND_EXPORT_SET_ID = resl.REFUND_EXPORT_SET_ID
			 WHERE re.IS_EXPORTED = 2 -- exported
			     AND re.CRSO_RELATION_ID = ?
				AND UNIX_TIMESTAMP(re.EXPORT_DATE) < UNIX_TIMESTAMP('2007-10-19')

		";

		$bind_values = array($crso_id, 'DT_REFUND_ADMINISTRATIVE_FEE', $crso_id);
		$q = $this->query($sql, $bind_values);

		while ($row = $q->fetch())
		{
			//get em into invoice lines
			$this->insertInvoiceLine($row);
		}
		unset($q);

		$this->db->commit();
		//$this->db->rollback();
	}
}


require_once(ELC_CLASSES.'CRSO.php');
require_once(ELC_CLASSES.'CRSOProduct.php');

class OperatorSummary
{
	function execute($year, $month)
	{
		echo 'doing with '.$year.' / '.$month."\n";

		$log = getLog();
		$this->db = IWRegistry::registry('db');


                        //for each crso
			//get the masterdata hash
			//for each journal code
				//get the total amount and quantity for the month/year selected
				//get the exported date in the month/year selected
				//check to see if refund export or declaration has invoice attached

		$crso = new CRSO($this->db);
		$q = $crso->selectCRSOs();
		$cp = new CRSOProduct($this->db);

		$hashq = $this->db->query("
					SELECT MD5(GROUP_CONCAT(MD5(CONCAT(
					CONCAT(cac.CODE,
							LPAD(p.CRSO_RELATION_ID, 8, 0),
							LPAD(p.PARTICIPANT_RELATION_ID, 8, 0)
						),
					IF(ISNULL(r.NAME), '', r.NAME),
					IF(ISNULL(ca.ADDRESS_STREET_NAME), '', ca.ADDRESS_STREET_NAME),
					IF(ISNULL(ca.ADDRESS_ZIPCODE), '', ca.ADDRESS_ZIPCODE),
					IF(ISNULL(ca.CITY_NAME), '', ca.CITY_NAME),
					IF(ISNULL(cc.INFO_PERSON_LAST_NAME), '', cc.INFO_PERSON_LAST_NAME),
					IF(ISNULL(r.PHONE), '', r.PHONE),
					IF(ISNULL(r.FAX), '', r.FAX),
					IF(ISNULL(cl.NAVISION_CODE), '', cl.NAVISION_CODE),
					IF(ISNULL(cac.NAVISION_CODE), '', cac.NAVISION_CODE),
					IF(ISNULL(r.VAT_NO), '', r.VAT_NO),
					IF(ISNULL(r.EMAIL), '', r.EMAIL),
					IF(ISNULL(r.WEBSITE), '', r.WEBSITE),
					IF(ISNULL(ri.NAME), '', ri.NAME),
					IF(ISNULL(ria.ADDRESS_STREET_NAME), '', ria.ADDRESS_STREET_NAME),
					IF(ISNULL(ria.ADDRESS_ZIPCODE), '', ria.ADDRESS_ZIPCODE),
					IF(ISNULL(ria.CITY_NAME), '', ria.CITY_NAME),
					IF(ISNULL(riac.NAVISION_CODE), '', riac.NAVISION_CODE),
					IF(ISNULL(rii.INFO_PERSON_LAST_NAME), '', rii.INFO_PERSON_LAST_NAME),
					IF(ISNULL(r.BANK_ACCOUNT_NUMBER), '', r.BANK_ACCOUNT_NUMBER),
					IF(ISNULL(r.IBAN_NO), '', r.IBAN_NO),
					IF(ISNULL(r.SWIFT_BIC_CODE), '', r.SWIFT_BIC_CODE),
					IF(ISNULL(r.DD_BANK_ACCOUNT), '', r.DD_BANK_ACCOUNT),
					IF(ISNULL(r.DD_IBAN_NO), '', r.DD_IBAN_NO),
					IF(ISNULL(r.DD_SWIFT_BIC_CODE), '', r.DD_SWIFT_BIC_CODE),
					IF(ISNULL(r.DD_BANK_ACCOUNT) OR r.DD_BANK_ACCOUNT = '', 'no', 'yes'),
					IF(ISNULL(p.PRODUCER_REG_NO), '', p.PRODUCER_REG_NO),
					IF(ISNULL(r.PO_NO), '', r.PO_NO))) SEPARATOR '')) AS HASH,
					crso.`NAME` as CRSO_NAME
				FROM TBL_CRSO_PARTICIPANT as p
				INNER JOIN TBL_CRSO_PRODUCT as CP
					ON p.CRSO_RELATION_ID = CP.CRSO_RELATION_ID
				INNER JOIN TBL_RELATION as r
					ON p.PARTICIPANT_RELATION_ID = r.RELATION_ID
				INNER JOIN TBL_PARTICIPANT as part
					ON p.PARTICIPANT_RELATION_ID = part.PARTICIPANT_RELATION_ID
				INNER JOIN TBL_RELATION as crso
					ON p.CRSO_RELATION_ID = crso.RELATION_ID
				INNER JOIN TBL_ADDRESS as crsoa
					ON crso.ADDRESS_ID = crsoa.ADDRESS_ID
				INNER JOIN TBL_LANGUAGE as cl
					ON r.INVOICE_LANGUAGE_ID = cl.LANGUAGE_ID
				INNER JOIN TBL_ADDRESS as ca
					ON r.ADDRESS_ID = ca.ADDRESS_ID
				INNER JOIN TBL_INFO_PERSON as cc
					ON r.CUSTOMER_CONTACT_ID = cc.INFO_PERSON_ID
				INNER JOIN TBL_COUNTRY as cac
					ON ca.COUNTRY_ID = cac.COUNTRY_ID
				INNER JOIN TBL_RELATION_INVOICE as ri
					ON r.RELATION_ID = ri.RELATION_ID
				INNER JOIN TBL_ADDRESS as ria
					ON ria.ADDRESS_ID = ri.ADDRESS_ID
				INNER JOIN TBL_COUNTRY as riac
					ON ria.COUNTRY_ID = riac.COUNTRY_ID
				INNER JOIN TBL_INFO_PERSON as rii
					ON ri.INFO_PERSON_ID = rii.INFO_PERSON_ID
				WHERE p.CRSO_RELATION_ID = ?
				AND CP.PRODUCT_ID = ?
				GROUP BY p.CRSO_RELATION_ID
				ORDER BY p.CRSO_RELATION_ID,p.PARTICIPANT_RELATION_ID");

		$exportdate_template = "
				SELECT
					DISTINCT EXPORT_DATE
				FROM
					%s
				WHERE
					CRSO_RELATION_ID = ?
				AND
					PRODUCT_ID = ?
				AND
					MONTH(EXPORT_DATE) = ?
				AND
					YEAR(EXPORT_DATE) = ?
				AND
					IS_EXPORTED = 1
				ORDER BY EXPORT_DATE DESC
				LIMIT 1";

		$export_template = "
				SELECT
					SUM(QUANTITY) AS QUANTITY,
					SUM(LINE_AMOUNT_EXCL_VAT) AS TOTAL_FEE
				FROM
					%s
				WHERE
					CRSO_RELATION_ID = ?
				AND
					PRODUCT_ID = ?
				AND
					DATE(EXPORT_DATE) = (
						SELECT DISTINCT DATE(EXPORT_DATE)
						FROM
							%s
						WHERE
							CRSO_RELATION_ID = ?
						AND
							PRODUCT_ID = ?
						AND
							MONTH(EXPORT_DATE) = ?
						AND
							YEAR(EXPORT_DATE) = ?
						ORDER BY EXPORT_DATE DESC
						LIMIT 1
					)
				AND
					IS_EXPORTED = 1
				AND
					NOT ISNULL(%s)
				GROUP BY CRSO_RELATION_ID";

                $decl_hash_template = "
                       SELECT
                            DISTINCT
                                MD5(CONCAT(
                                     IF(ISNULL(dd.DECLARATION_DEBIT_ID),
                                             f_elcBuildInvoiceNoForInterfaces(d.CRSO_RELATION_ID,dc.`YEAR`,dc.DECLARATION_CREDIT_ID,TRUE,FALSE    ),
                                             f_elcBuildInvoiceNoForInterfaces(d.CRSO_RELATION_ID,dd.`YEAR`,dd.DECLARATION_DEBIT_ID,FALSE,FALSE    )
                                      ),
                                     CONCAT(cac.CODE,
                                             LPAD(d.CRSO_RELATION_ID, 8, 0),
                                             LPAD(d.PARTICIPANT_RELATION_ID, 8, 0)
                                     ),
                                     REPLACE(IF(ISNULL(dd.DECLARATION_DEBIT_ID),
                                         f_elcGetDeclarationCreditTotalAmount(d.CRSO_RELATION_ID, dc.DECLARATION_CREDIT_ID, dc.`YEAR`),
                                         f_elcGetDeclarationDebitTotalAmount(d.CRSO_RELATION_ID, dd.DECLARATION_DEBIT_ID, dd.`YEAR`)),
                                         '.', ',')
                             )) AS HASH_TOTAL
                     FROM TBL_DECLARATION as d
                     INNER JOIN TBL_RELATION as cr
                             ON cr.RELATION_ID = d.CRSO_RELATION_ID
                     INNER JOIN TBL_ADDRESS as ca
                             ON cr.ADDRESS_ID = ca.ADDRESS_ID
                     INNER JOIN TBL_COUNTRY as cac
                             ON cac.COUNTRY_ID = ca.COUNTRY_ID
                     INNER JOIN TBL_DECLARATION_SET_LINE AS dsl
                             ON d.DECLARATION_ID = dsl.DECLARATION_ID
                     LEFT JOIN TBL_DECLARATION_DEBIT as dd
                             ON dsl.DECLARATION_SET_ID = dd.DECLARATION_SET_ID
                     LEFT JOIN TBL_DECLARATION_CREDIT as dc
                             ON dsl.DECLARATION_SET_ID = dc.DECLARATION_SET_ID
                     INNER JOIN TBL_DECLARATION_LINE as dl
                             ON dl.DECLARATION_ID = d.DECLARATION_ID
                                      AND dl.STATUS != 1 -- this is open
                     LEFT JOIN TBL_PRODUCT_CATEGORY as pc
                             ON dl.PRODUCT_CATEGORY_ID = pc.PRODUCT_CATEGORY_ID
                     INNER JOIN TBL_PRODUCT as p
                             ON d.PRODUCT_ID = p.PRODUCT_ID
                     LEFT JOIN TBL_BRAND as b
                             ON b.BRAND_ID = dl.BRAND_ID
                     LEFT JOIN TBL_DECLARATION_SET_LINE AS dsl2
                             ON d.PARENT_DECLARATION_ID = dsl2.DECLARATION_ID
                     LEFT JOIN TBL_DECLARATION_DEBIT as dd2
                             ON dsl2.DECLARATION_SET_ID = dd2.DECLARATION_SET_ID
                     WHERE d.CRSO_RELATION_ID = ?
                        AND MONTH(d.EXPORT_DATE) = ? AND YEAR(d.EXPORT_DATE) = ?
                             AND (ISNULL(dd.DECLARATION_DEBIT_ID) XOR ISNULL(dc.DECLARATION_CREDIT_ID))
                             AND ISNULL(%s)
                    GROUP BY dl.DECLARATION_ID, dl.LINE_INDEX
                    ORDER BY dd.DECLARATION_DEBIT_ID, dc.DECLARATION_CREDIT_ID
                ";

                $refund_hash_template = "
                       SELECT
                            MD5(CONCAT(

                                    IF(ISNULL(RED.REFUND_REQUEST_DEBIT_ID),
                                                    f_elcBuildInvoiceNoForInterfaces(RE.CRSO_RELATION_ID,REC.`YEAR`,REC.REFUND_REQUEST_CREDIT_ID,true,true),
                                                    f_elcBuildInvoiceNoForInterfaces(RE.CRSO_RELATION_ID,RED.`YEAR`,RED.REFUND_REQUEST_DEBIT_ID,false,true)
                                     ),
                                    CONCAT(CAC.CODE,
                                            LPAD(RE.CRSO_RELATION_ID, 8, 0),
                                            LPAD(RE.PARTICIPANT_RELATION_ID, 8, 0)
                                    ),
                                    REPLACE((CAST(f_elcGetTotalAmountForRefundExport(RE.REFUND_EXPORT_ID) AS DECIMAL(10,2)) ), '.', ',')
                            )) as HASH_TOTAL
                            FROM TBL_REFUND_EXPORT as RE
                            LEFT JOIN TBL_REFUND_EXPORT_SET_LINE as RESL
                                    ON RE.REFUND_EXPORT_ID = RESL.REFUND_EXPORT_ID
                            LEFT JOIN TBL_REFUND_EXPORT_CREDIT REC
                                    ON RESL.REFUND_EXPORT_SET_ID = REC.REFUND_EXPORT_SET_ID
                            LEFT JOIN TBL_REFUND_EXPORT_DEBIT RED
                                    ON RESL.REFUND_EXPORT_SET_ID = RED.REFUND_EXPORT_SET_ID
                            LEFT JOIN TBL_REFUND_REQUEST RR
                                    ON RE.REFUND_EXPORT_ID = RR.REFUND_EXPORT_ID
                            LEFT JOIN TBL_REFUND_REQUEST_LINE as RRL
                                    ON RR.REFUND_REQUEST_ID = RRL.REFUND_REQUEST_ID
                            INNER JOIN TBL_RELATION as R
                                    ON RE.PARTICIPANT_RELATION_ID = R.RELATION_ID
                            INNER JOIN TBL_RELATION as R1
                                    ON RE.CRSO_RELATION_ID = R1.RELATION_ID
                            INNER JOIN TBL_ADDRESS as CA
                                    ON R1.ADDRESS_ID = CA.ADDRESS_ID
                            INNER JOIN TBL_COUNTRY as CAC
                                    ON CAC.COUNTRY_ID = CA.COUNTRY_ID
                    WHERE RE.CRSO_RELATION_ID = ?
                    AND MONTH(RE.EXPORT_DATE) = ? AND YEAR(RE.EXPORT_DATE) = ?
                    AND ISNULL(%s)
                    GROUP BY RE.REFUND_EXPORT_ID
                    ORDER BY RED.REFUND_REQUEST_DEBIT_ID, REC.REFUND_REQUEST_CREDIT_ID
                ";

		$document = "SELECT IF(ISNULL(%s),0,1) AS DOCUMENT FROM %s WHERE CRSO_RELATION_ID = ?
				AND
					PRODUCT_ID = ?
				AND
					EXPORT_DATE = (
						SELECT DISTINCT EXPORT_DATE
						FROM
							%s
						WHERE
							CRSO_RELATION_ID = ?
						AND
							PRODUCT_ID = ?
						AND
							MONTH(EXPORT_DATE) = ?
						AND
							YEAR(EXPORT_DATE) = ?
						ORDER BY EXPORT_DATE DESC
						LIMIT 1
					)
				AND
					IS_EXPORTED = 2";

		while($r = $q->fetch())
		{
			$crso_id = $r->CRSO_RELATION_ID;
			echo " - now working on crso ".$crso_id."\n";

			$qcp = $cp->getProducts($crso_id);
			while($rcp = $qcp->fetch())
			{
				$product_id = $rcp->PRODUCT_ID;
				echo "   - now working on product ".$product_id."\n";

				$hashq->bind_values($crso_id,$product_id);
				$hashq->execute();
				$hashr = $hashq->fetch();
				if(!$hashr)
				{
					echo '   - no hash available..'."\n";
					continue;
				}
				$hash_value = $hashr->HASH;
				$crso_name = $hashr->CRSO_NAME;

				$journals = array('I', 'C', 'RI', 'RC');

				foreach($journals as $jcode)
				{
					//echo "     - now working on journal ".$jcode."\n";

					$journal_template = $jcode.$crso_id;
					switch($jcode)
					{
						case 'I':
							$export_temp = sprintf($export_template,"TBL_DECLARATION_DEBIT_LINE","TBL_DECLARATION_DEBIT_LINE","DECLARATION_LINE_INDEX");
							$exportdate_temp = sprintf($exportdate_template,"TBL_DECLARATION_DEBIT_LINE");
							$document1 = sprintf($document,"DOCUMENT_ID","TBL_DECLARATION","TBL_DECLARATION");
                                                        $export_cd_hash = sprintf($decl_hash_template, "dc.DECLARATION_CREDIT_ID");
							break;
						case 'C':
							$export_temp = sprintf($export_template,"TBL_DECLARATION_CREDIT_LINE","TBL_DECLARATION_CREDIT_LINE","DECLARATION_LINE_INDEX");
							$exportdate_temp = sprintf($exportdate_template,"TBL_DECLARATION_CREDIT_LINE");
							$document1 = sprintf($document,"DOCUMENT_ID","TBL_DECLARATION","TBL_DECLARATION");
                                                        $export_cd_hash = sprintf($decl_hash_template, "dd.DECLARATION_DEBIT_ID");
							break;
						case 'RI':
							$export_temp = sprintf($export_template,"TBL_REFUND_EXPORT_DEBIT_LINE","TBL_REFUND_EXPORT_DEBIT_LINE","1");
							$exportdate_temp = sprintf($exportdate_template,"TBL_REFUND_EXPORT_DEBIT_LINE");
							$document1 = sprintf($document,"INVOICE_DOCUMENT_ID","TBL_REFUND_EXPORT","TBL_REFUND_EXPORT");
                                                        $export_cd_hash = sprintf($refund_hash_template, "REC.REFUND_REQUEST_CREDIT_ID");
							break;
						case 'RC':
							$export_temp = sprintf($export_template,"TBL_REFUND_EXPORT_CREDIT_LINE","TBL_REFUND_EXPORT_CREDIT_LINE","REFUND_LINE_INDEX");
							$exportdate_temp = sprintf($exportdate_template,"TBL_REFUND_EXPORT_CREDIT_LINE");
							$document1 = sprintf($document,"INVOICE_DOCUMENT_ID","TBL_REFUND_EXPORT","TBL_REFUND_EXPORT");
                                                        $export_cd_hash = sprintf($refund_hash_template, "RED.REFUND_REQUEST_DEBIT_ID");
							break;
					}


					$et = $this->db->query($export_temp);
					$et->bind_values($crso_id,$product_id,$crso_id,$product_id,$month,$year);
					$et->execute();
					$res = $et->fetch();
					if(!$res)
						continue;
					else
					{
						$quantity = $res->QUANTITY;
						$amount = $res->TOTAL_FEE;
					}
					$dt = $this->db->query($exportdate_temp);
					$dt->bind_values($crso_id,$product_id,$month,$year);
					$dt->execute();
					$res = $dt->fetch();
					if(!$res)
						continue;
					else
						$export_date = $res->EXPORT_DATE;

					$d = $this->db->query($document1);
					$d->bind_values($crso_id,$product_id,$crso_id,$product_id,$month,$year);
					$d->execute();
					$res = $d->fetch();
					if($res)
						$doc = $res->DOCUMENT;
					if(!isset($doc)) $doc = 0;

                                        $cdh = $this->db->query($export_cd_hash);
                                        $cdh->bind_values($crso_id, $month, $year);
                                        $cdh->execute();
                                        $export_hash = '';
                                        while($res = $cdh->fetch())
                                                $export_hash .= $res->HASH_TOTAL;
                                        switch($jcode)
                                        {
                                                case 'I':
						case 'C':
                                                        $decl_hash = md5($export_hash);
                                                        $refund_hash = '';
							break;
						case 'RI':
						case 'RC':
                                                        $refund_hash = md5($export_hash);
                                                        $decl_hash = '';
							break;
                                        }
					$sql = $this->db->query("REPLACE INTO TBL_OPERATOR_CRSO_EXPORT_SUMMARY
							(CRSO_RELATION_ID,CRSO_NAME,JOURNAL_TEMPLATE,PRODUCT_ID,EXPORT_DATE,MASTERDATA_HASH,
                                                        DECLARATION_HASH, REFUND_HASH, QUANTITY,EXPORTED_AMOUNT,DOCUMENTS_UPLOADED)
							VALUES (?,?,?,?,?,?,?,?,?,?,?)");
					$sql->bind_values($crso_id,$crso_name,$journal_template,$product_id,$export_date,
                                                $hash_value, $decl_hash, $refund_hash,$quantity,$amount,$doc);
					$sql->execute();

				}
			}
		}
		echo 'done.'."\n";
	}
}


echo 'Processing declarations..'."\n";
$e = new ELCExporter_Declarations_ExportOld(IWRegistry::registry('db'));
$e->exportToFile();
unset($e);

echo 'Processing refunds..'."\n";
$e = new ELCExporter_RefundRequests_ExportOld(IWRegistry::registry('db'));
$e->exportToFile();


echo 'Generating summery reports stuff';
$t = new OperatorSummary();

// 2006
for ($i=1; $i<=12; $i++)
	$t->execute(2006, $i);

// 2007
for ($i=1; $i<=12; $i++)
	$t->execute(2007, $i);

// 2008
for ($i=1; $i<=2; $i++)
	$t->execute(2008, $i);
?>
