<?php
/**
 * Interface
 *
 * @package ELC
 * @subpackage scripts
 * @author
 * @copyright (2005) BaseSoft B.V.
 * @version $Id$
 */
$script_id = 61000;
$interface_id = 100; 	// Add the right interface id
define('NO_HOME',true);

require_once('../../../scripts/i-w/default/init.php');

/**
 * snapshot logic
 */
if(defined('TEST_SITE'))
{
	require_once(IWARE.'Snapshot.php');
	require_once(IWARE.'table_factory.php');

	$snapshot = new Snapshot($dba_user,$dba_password,$dba_name,$sql_server);

	if(isset($_REQUEST['takesnapshot']))
	{
		$log = getLog();
		$log->info("Snapshot created: " . $_REQUEST['takesnapshot']);

		$snapshot->takeSnapshot($_REQUEST['takesnapshot']);
		header('Location: index.php');
		exit();
	}
	if(isset($_REQUEST['restoresnapshot']))
	{
		$log = getLog();
		$log->info("Snapshot restored: " . $_REQUEST['restoresnapshot']);

		if(!$snapshot->restoreSnapshot($_REQUEST['restoresnapshot']))
			exit('Failed');
		header('Location: /'.SITE_PATH);
		exit();
	}
	if(isset($_POST['deleteSnapshots']))
	{
		foreach($_POST['deleteSnapshots'] as $name) {
			$log = getLog();
			$log->info("Snapshot deleted: " . $name);
			$snapshot->deleteSnapshot($name);
		}
		header('Location: index.php');
		exit();
	}
	if(isset($_REQUEST['setnewdate'])&&defined('DATETIME_FILE'))
	{
		setVirtualDate($_REQUEST['setnewdate']);

		header('Location: index.php');
		exit();
	}
}


require_once(XHTML_HEADER);
require_once(ELC_CLASSES.'CRSO.php');
require_once(ELC_CLASSES.'RelationUser.php');

$db = IWRegistry::registry('db');

$product_id = $_SESSION['selected_product_id'];
$crso_id = $_SESSION['crso_relation_id'];

$crso = new CRSO($db);
$crso->set($crso_id);

$ru = new RelationUser($db);
$ru->set($_SESSION['session_user_id'], $crso_id);

echo '<div class="index-page">';
echo '<div class="index-title">'.$langIf->getText('What do you want to do today?').'</div>';
echo '<div class="index-menu">';
echo '<ul>';

$c = new Country($db,$crso->getCountry(),true);

if($ru->hasClearance(CRSOClearanceManagementReport))
	echo '<li><a href="ParticipantReport.php">'.$langIf->getText('View Management Report').'</a></li>';

if($c->has(HasCrsoDeclarationDetails,$_SESSION['selected_product_id']) && $ru->hasClearance(CRSOClearanceDeclaration) && $ru->hasClearance(CRSOClearanceDeclarationDetails))
	echo '<li><a href="InterfaceCQDeclarationGenericReport.php">'.$langIf->getText('View generic declaration report').'</a></li>';

if($ru->hasClearance(CRSOClearanceRefund))
	echo '<li><a href="InterfaceCQRefundGenericReport.php">'.$langIf->getText('View generic refund report').'</a></li>';

if($ru->hasClearance(CRSOClearanceMaintenance)) {
	echo '<li><a href="InterfaceCRSOUserOverview.php">'.$langIf->getText('Add or Change User registration details, edit user clearance levels or reset the Administrator').'</a></li>';
	if($crso->getCountry() == '826' && $ru->hasClearance(CRSOClearanceEAReports)){
		echo '<li><a href="InterfaceEAPRReportList.php">'.$langIf->getText('Export Producer Registration Report to EA').'</a></li>';
		echo '<li><a href="InterfaceEAActualsReportList.php">'.$langIf->getText('Export Weee Actuals Report to EA').'</a></li>';
		echo '<li><a href="InterfaceCrsoEAData.php">'.$langIf->getText('File recycle data for EA Report').'</a></li>';
	}
}
echo '<li><a href="/scripts/elc/public/InterfaceUserProfile.php">'.$langIf->getText('Change my password').'</a></li>';
echo '<li><a href="/scripts/elc/public/InterfaceNotificationInbox.php">'.$langIf->getText('Notifications overview (Inbox)').'</a></li>';
echo '<li><a href="/scripts/i-w/public/InterfaceFAQ.php">'.$langIf->getText('FAQ').'</a></li>';
$u = new ELCUser($db, $_SESSION['session_user_id'], true);
if($u->trac_user) {
	echo '<li><a href="/scripts/elc/crso/InterfaceTicketOverview.php">'.$langIf->getText('Ticket overview').'</a></li>';
}

if($c->has(HasDeEarReporting,$_SESSION['selected_product_id'])) {

	echo '<li><a href="/scripts/elc/crso/InterfaceDeEARDeclarationList.php?preset=month">'.$langIf->getText('EAR Monthly PoM Report').'</a></li>';
	echo '<li><a href="/scripts/elc/crso/InterfaceDeEARExportList.php?preset=month">'.$langIf->getText('EAR Monthly Export Report').'</a></li>';
	echo '<li><a href="/scripts/elc/crso/InterfaceDeEARNetResultList.php?preset=month">'.$langIf->getText('EAR Net Result Report').'</a></li>';

}



echo '</ul>';
echo '</div>';
echo '</div>';


// snapshot logic


if(defined('TEST_SITE'))
{
	$date = currentDate();
?>
	<h1>Testing settings</h1>
	<form action="index.php" method="post" id="snapshotform">
<?php
	$ds = $snapshot->getList();

	$tf = new TableFactory($ds,$langIf);
	$tf->setCaption(getHelp($langIf, 'snapshot', array('top'=>'0px')) . '<img src="/'.SITE_PATH.'images/block_arrow.png" /> '.$langIf->getText('Snapshot overview'), false);
	$tf->setValueProcessor('file','return \'<input type="checkbox" name="deleteSnapshots[]" value="\'.$value.\'" /> <a href="#" onclick="restoreSnapshot(\\\'\'.$value.\'\\\');">\'.$value.\'</a>\';');
	$tf->decapitate();
	echo $tf->getXHTMLTable('Professional',2);

?>
	<script type="text/javascript"><!--
		function takeSnapshot()
		{
			var val = $('snapshotname').value;
			MessageBox.prototype.Question( '<?=jsescape($langIf->getText('Confirm Snapshot'),"'");?>', '<?=jsescape($langIf->getText('Are you sure you want to take a snapshot'),"'"); ?>', function(){go('index.php?takesnapshot='+val);} );
		}
		function deleteSnapshot()
		{
			MessageBox.prototype.Question( '<?=jsescape($langIf->getText('Confirm Delete Snapshot'),"'");?>', '<?=jsescape($langIf->getText('Are you sure you want to delete selected snapshots'),"'"); ?>', function(){$('snapshotform').submit();} );
		}
		function restoreSnapshot(val)
		{
			MessageBox.prototype.Question( '<?=jsescape($langIf->getText('Confirm Restore Snapshot'),"'");?>', '<?=jsescape($langIf->getText('Are you sure you want to restore this snapshot'),"'"); ?>', function(){go('index.php?restoresnapshot='+val);} );
		}
		function setCurrentDate()
		{
			var val = $$('date1').value;
			MessageBox.prototype.Question( '<?=jsescape($langIf->getText('Confirm New Date'),"'");?>', '<?=jsescape($langIf->getText('Are you sure you want to set a new date'),"'"); ?>', function(){go('index.php?setnewdate='+val);} );
		}
	--></script>
	<br />
	<input type="text" id="snapshotname" value="" />
	<input type="button" id="takeSnapshotID" value="<?= $langIf->getText('Create Snapshot');?>" onclick="takeSnapshot();" />
	<input type="button" value="<?= $langIf->getText('Delete Snapshot');?>" onclick="deleteSnapshot();" />

	<br />
	<br />

<?php

	$totals = '<input type="text" name="date1" value="'.$date->format('Y-m-d').'" /> <input type="button" id="setNewDate" onclick="setCurrentDate();" value="'.$langIf->getText('Set new date').'" /> <input type="button" onclick="window.open(\'/'.SITE_PATH.'scripts/i-w/bots/TaskRunner.php\');" value="Run TaskRunner" />';

	$t = new TableFactory( array(array($totals)) );
	$t->setCaption(getHelp($langIf, 'current testing date', array('top'=>'0px')) . '<img src="/'.SITE_PATH.'images/block_arrow.png"> '.$langIf->getText('Current Testing Date'), false);
	$t->decapitate();
	echo $t->getXhtmlTable('Professional', 2);
?>
</form>
<?php
}


// end shapshot logic


require_once(XHTML_FOOTER);
?>
