<?php
/**
 * @package WEEE
 * @subpackage Default
 * @since 23-nov-2006
 * @author Marten Koedam <marten@dalines.net>
 * @version $Id$
 * @copyright 2006 BaseSoft B.V.
 */
require_once(IWARE.'group.php');
require_once(ELC_CLASSES.'Product.php');

$product = new Product(IWRegistry::registry('db'));
switch($_SESSION['session_group_group_id'])
{
	case GROUP_PARTICIPANT:
		require_once(ELC_CLASSES.'CRSOParticipantProduct.php');
		$cp = new CRSOParticipantProduct(IWRegistry::registry('db'));
		$products = $cp->getParticipantProducts($_SESSION['selected_participant_id']);
	break;
	case GROUP_CRSO:
		require_once(ELC_CLASSES.'CRSOProduct.php');
		$cp = new CRSOProduct(IWRegistry::registry('db'));
		$products = $cp->getProducts($_SESSION['crso_relation_id']);
	break;
	case GROUP_ACCOUNTANT:
		require_once(ELC_CLASSES.'AccountantCRSO.php');
		$db = IWRegistry::registry('db');
		$accountant_crso = new AccountantCRSO($db);
		$ac = $accountant_crso->getAccountantCRSOs($_SESSION['accountant_relation_id']);

		$sql = "SELECT CP.PRODUCT_ID, P.`NAME` as PRODUCT_NAME
			FROM TBL_CRSO_PRODUCT as CP
			INNER JOIN TBL_PRODUCT as P
				ON CP.PRODUCT_ID = P.PRODUCT_ID
			WHERE CP.CRSO_RELATION_ID IN (";

		$crsos = array();
		while($r=$ac->fetch()){
			$crsos[] = $r->CRSO_RELATION_ID;
			$sql .= "?,";
		}
		$sql = substr($sql, 0, strlen($sql)-1).") GROUP BY CP.PRODUCT_ID";

		$products = $db->query($sql);
		$products->bind_values($crsos);
		$products->execute();
	break;
	case GROUP_PUBLIC:
	case GROUP_SYSADMIN:
	default:
		$products = $product->getOverview();
	break;
}
$rs = $products->fetchAll();
if(count($rs))
{
	if(count($rs)==1)
	{
		//$r = $products->fetch();
		//echo $r->PRODUCT_NAME;
		// maybe some fancy name displaying ;-)
	}
	else
	{
		$PRODUCT_SWITCH_HEADER = isset($PRODUCT_SWITCH_HEADER) && !is_null($PRODUCT_SWITCH_HEADER)?'&h='.$PRODUCT_SWITCH_HEADER:'';
		echo '<div id="productSelect"><b>&nbsp;'.IWRegistry::registry('langIf')->getText('Select Product').'</b>: <span id="productSelectButton"></span></div><br />';
		?>

		<script type="text/javascript"><!--

			 function onProductSelectMenuItemClick(p_sType, p_aArgs, p_oItem) {
                document.location.href="/<?php echo SITE_PATH;?>scripts/elc/public/ChangeProduct.php?product[id]="+p_oItem.value+"<?=$PRODUCT_SWITCH_HEADER;?>";
            }
			var productMenuItems = [
			<?php
				$label = '';
				foreach($rs as $r)
				{
					echo '{ text: "'.$r->PRODUCT_NAME.'", value: '.$r->PRODUCT_ID.', onclick: { fn: onProductSelectMenuItemClick } },';
					//$sel->addOption($r->PRODUCT_NAME,$r->PRODUCT_ID);
					if($_SESSION['selected_product_id'] == $r->PRODUCT_ID)
					{
						$label = $r->PRODUCT_NAME;
					}
				}
				if($label == '')
					$label = "...";
			?>
			];

			WEEE.oProductSelectButton = new YAHOO.widget.Button(
		                       {
		                        	name: "productSelectButton",
		                            label: "<?php echo $label;?>",
		                            type: "menu",
		                            menu: productMenuItems,
		                            container: "productSelectButton"
		                        }
		                    );

		     //WEEE.oProductSelectButton.render();

		    //WEEE.oProductSelectButton._button.id = "productSelectButton";
		--></script>
		<?php
	}
}

?>
