<?php
/**
 * Interface
 *
 * @package ELC
 * @subpackage scripts
 * @author
 * @copyright (2005) BaseSoft B.V.
 * @version $Id$
 */
$script_id = 62000;
$interface_id = 100; 	// Add the right interface id
define('NO_HOME',true);

require_once('../../../scripts/i-w/default/init.php');
require_once(XHTML_HEADER);
require_once(ELC_CLASSES.'CRSOParticipantProduct.php');
require_once(ELC_CLASSES.'RelationUser.php');

$db = IWRegistry::registry('db');

$participant_id = $_SESSION['selected_participant_id'];
$product_id = $_SESSION['selected_product_id'];
$crso_id = (isset($_REQUEST['crso_id']) && $_REQUEST['crso_id'] != '')?$_REQUEST['crso_id']:null;

$ru = new RelationUser($db);
$ru->set($_SESSION['session_user_id'], $participant_id);

$cpp = new CRSOParticipantProduct($db);
$q = $cpp->getParticipantCRSOs($participant_id, 'q', false, false, $product_id);
$rv = $q->fetchAll();

// in case of wrong product id in session, change it to default
// (can happen when user applies for different product, then session product is set as that new one, but participant
// is not active for it, or user just aborted the registration at that new product - which was set as session product)
if(count($rv) == 0)
{
	$product_id = $_SESSION['selected_product_id'] = $ru->default_product->id;
	$q = $cpp->getParticipantCRSOs($participant_id, 'q', false, false, $product_id);
	$rv = $q->fetchAll();
}
$crso_id = ($crso_id)?$crso_id:$rv[0]->CRSO_RELATION_ID;

echo '<div class="index-page" id="id_index_page_participant">';
echo '<div class="index-title">'.$langIf->getText('What do you want to do today?').'</div>';

// if participant belongs to multiple CRSOs, there must be a crso select to use in menus
if(count($rv) > 1) {
	echo '<div class="index-crso-select">';
	echo '<span>'.$langIf->getText('Select CRSO').':</span>&nbsp;';
	echo '<select name="crso_select" onchange="go(\'index.php?crso_id=\'+this.value)">';
	foreach($rv as $r){
		if($crso_id==$r->CRSO_RELATION_ID)
			echo '<option value="'.$r->CRSO_RELATION_ID.'" selected>'.$r->CRSO_NAME.'</option>';
		else
			echo '<option value="'.$r->CRSO_RELATION_ID.'">'.$r->CRSO_NAME.'</option>';
	}
	echo '</select>';
	echo '</div>';
}

$cpp->set($crso_id, $participant_id, $product_id);

echo '<div class="index-menu">';
echo '<ul>';
if($cpp->producer_exporter & PARTICIPANT_PRODUCER)
	echo '<li><a href="InterfaceDeclarationOverview.php">'.$langIf->getText('Make my monthly declaration').'</a></li>';

if($cpp->producer_exporter & PARTICIPANT_EXPORTER){
	echo '<li><a href="InterfacePaymentForm.php?participant[id]='.$participant_id.'&crso[id]='.$crso_id.'">'.$langIf->getText('Enter a Proof of Payment').'</a></li>';
	echo '<li><a href="InterfaceExportForm.php?crso[id]='.$crso_id.'&participant[id]='.$participant_id.'">'.$langIf->getText('Enter a Proof of Export').'</a></li>';
	echo '<li><a href="InterfaceRefundProcessStatus.php">'.$langIf->getText('Enter a Refund Request').'</a></li>';
}

echo '<li><a href="InterfaceCompanyInformation.php?product[id]='.$product_id.'&crso[id]='.$crso_id.'&participant[id]='.$participant_id.'">'.
	$langIf->getText('Change my existing registration details with CRSO').'</a></li>';
echo '<li><a href="InterfaceRegistrationOverview.php">'.$langIf->getText('Register with CRSO').'</a></li>';

if($ru->is_admin == 1) {
	echo '<li><a href="InterfaceParticipantUserOverview.php">'.$langIf->getText('Add or Change User registration details or reset the Administrator').'</a></li>';
	if($cpp->crso->getCountry() == '826')
		echo '<li><a href="InterfaceUKXMLPreparation.php">'.$langIf->getText('Change my existing registration details for Government reports/registration fee levels').'</a></li>';
}
echo '<li><a href="/scripts/elc/public/InterfaceUserProfile.php">'.$langIf->getText('Change my password').'</a></li>';
echo '<li><a href="/scripts/elc/public/InterfaceNotificationInbox.php">'.$langIf->getText('Notifications overview (Inbox)').'</a></li>';
echo '</ul>';
echo '</div>';
echo '</div>';

require_once(XHTML_FOOTER);
?>
