<?php
/**
 * PHP Broker
 * PHP side of the JS/PHP Ajax Broker pair
 */
//error_reporting(E_NONE);
$noValidate = true;
$script_id = 2000;
$_REQUEST['script_parent_id'] = 0;

//header('Content-type: text/javascript; charset=iso-8859-1');
define('SANITIZE_OFF',true);
require_once('../default/init.php');
require_once(IWARE.'PhpBroker.php');
require_once(IWARE.'IWAbstractRPC.php');

if(isset($_REQUEST['doTranslate']))
{
	require_once('../default/xhtml_header.php');
	require_once('../default/xhtml_footer.php');
	exit();
}

if(!isset($_REQUEST['params']))
	exit();

$PhpBroker = new PhpBroker();

/**#@+
 * All I-WARE classes
 */
$PhpBroker->addClass('LangIfRPC', IWARE_INCLUDES.'rpc/LangIfRPC.php');


/**#@+
 * All I-WARE methods: DEPRECATED: USE CLASSES !
 */
// KeepAlivePing
$PhpBroker->addMethod('keepAlivePing',IWARE_INCLUDES.'rpc/iware.php');
// Message Event
$PhpBroker->addMethod('GetMessageByInfoTypes',IWARE_INCLUDES.'rpc/message_event.php');
// InfoGroupContent
$PhpBroker->addMethod('selectInfoGroupContent',IWARE_INCLUDES.'rpc/InfoGroup.php');
// Wizard
$PhpBroker->addMethod('Wizard_LoadPage',IWARE_INCLUDES.'rpc/wizard.php');
// InterfaceFactory
$PhpBroker->addMethod('loadBlock',IWARE_INCLUDES.'rpc/interface.php');
$PhpBroker->addMethod('toggleBlock',IWARE_INCLUDES.'rpc/interface.php');
$PhpBroker->addMethod('loadInterface',IWARE_INCLUDES.'rpc/interface.php');
// AutoComplete
$PhpBroker->addMethod('AutoComplete',IWARE_INCLUDES.'rpc/autocomplete.php');
// MhMessage
$PhpBroker->addMethod('getMessage',IWARE_INCLUDES.'rpc/message_event.php');
//NavigationNode
$PhpBroker->addMethod('getNavNode',IWARE_INCLUDES.'rpc/navnode.php');

/**#@+
 * All ELC classes
 */
$PhpBroker->addClass('DashboardHandler', ELC_INCLUDES.'rpc/DashboardHandler.php');
$PhpBroker->addClass('DataPilotHandler', ELC_INCLUDES.'rpc/DataPilotHandler.php');
//$PhpBroker->addClass('DashboardHandler', ELC_INCLUDES.'rpc/DashboardHandler.php');

$PhpBroker->addClass('RemoteViewerHandler', ELC_INCLUDES.'rpc/RemoteViewerHandler.php');

$PhpBroker->addClass('NotificationHandler', ELC_INCLUDES.'rpc/NotificationHandler.php');

/**#@+
 * ALL ELC Methods: DEPRECATED: USE CLASSES !
 */

// deprecated definition of methods
$PhpBroker->addMethod('switchUserStatus',ELC_INCLUDES.'rpc/SwitchUserStatus.php');
$PhpBroker->addMethod('refundImporterMarkAsResolved',ELC_INCLUDES.'rpc/RefundRequest.php');

$PhpBroker->addMethod('getElcInspectorChilds',ELC_INCLUDES.'rpc/elcInspector.php'); // FIXME: rename me
$PhpBroker->addMethod('getParticipantBrands',ELC_INCLUDES.'rpc/ParticipantBrand.php');
$PhpBroker->addMethod('sendNotification',ELC_INCLUDES.'rpc/Notification.php');
$PhpBroker->addMethod('requestGeneralManager',ELC_INCLUDES.'rpc/RequestGeneralManager.php');
$PhpBroker->addMethod('requestChangeParticipantType',ELC_INCLUDES.'rpc/RequestChangeParticipantType.php');
$PhpBroker->addMethod('authorizeChangeParticipantType',ELC_INCLUDES.'rpc/RequestChangeParticipantType.php');
$PhpBroker->addMethod('rejectChangeParticipantType',ELC_INCLUDES.'rpc/RequestChangeParticipantType.php');
$PhpBroker->addMethod('requestChangeProvisional',ELC_INCLUDES.'rpc/RequestChangeProvisional.php');
$PhpBroker->addMethod('authorizeChangeProvisional',ELC_INCLUDES.'rpc/RequestChangeProvisional.php');
$PhpBroker->addMethod('rejectChangeProvisional',ELC_INCLUDES.'rpc/RequestChangeProvisional.php');
$PhpBroker->addMethod('requestTrustTermination',ELC_INCLUDES.'rpc/TrustTermination.php');
$PhpBroker->addMethod('approveTrustTermination',ELC_INCLUDES.'rpc/TrustTermination.php');
$PhpBroker->addMethod('getVirtualStock',ELC_INCLUDES.'rpc/RefundRequest.php');
$PhpBroker->addMethod('requestAnnualConfirmationChange',ELC_INCLUDES.'rpc/RequestChangeAnnualConfirmation.php');
$PhpBroker->addMethod('approveAnnualConfirmationChange',ELC_INCLUDES.'rpc/RequestChangeAnnualConfirmation.php');
$PhpBroker->addMethod('rejectAnnualConfirmationChange',ELC_INCLUDES.'rpc/RequestChangeAnnualConfirmation.php');
$PhpBroker->addMethod('getCRSOProducts',ELC_INCLUDES.'rpc/Product.php');
$PhpBroker->addMethod('getProductCategoryFee',ELC_INCLUDES.'rpc/Product.php');


/**#@-*/


//FORCE UTF-8
header('Content-type: text/html; charset=UTF-8');

try
{
	echo $PhpBroker->execute();
}
catch(IWAJAXPermissionException $e)
{
	header('HTTP/1.0 403 Forbidden');
	alert('Permission Exception: '.$e->getMessage());
?>
	setTimeout(function(){
		document.location.href='/<?=SITE_PATH;?>scripts/i-w/default/PermissionDenied.php';
	},1)
<?php
}
catch(Exception $e)
{
	$error = sprintf('RPC Exception: [%s]. \n\n Backtrace: %s', $e->getMessage(), print_r($e->getTrace(), true));
	alert($error);

	$errorms = (defined('TEST_SITE') && TEST_SITE) ? $e->getMessage() : 'An unexpected error occured executing the Remote Procedure call. The system administrator has been notified.';

	?>
		// We are in javascript space! Present the user with an error. Use setTimeout to throw exceptions
		// because else they are being caught by the http request object

		// These are not catchable so we just print the message on screen if MessageBox is available. Maybe
		// make it that we can get an event whenever an error occures so the application can decide if they
		// want to print the error or not

		setTimeout(function()
		{
			if (typeof MessageBox != 'undefined')
				MessageBox.prototype.Critical('RPC Exception', '<?=jsescape($errorms, "'"); ?>')

			throw '<?=jsescape($errorms, "'"); ?>';
		}, 1);
	<?php
}
?>
