<?php
/**
 * @author Martijn van den Broek <martijn@basesoft.com>
 * @package ELC
 * @version $Id$
 */

$noValidate = true;
$script_id = 0;

require_once('../default/init.php');
require_once(IWARE . 'Document.php');
require_once(ELC_CLASSES . 'UserDocumentDownload.php');

$doc = Document::createDocument($db);

if (!isset($_REQUEST['Document']['id']) && !is_numeric($_REQUEST['Document']['id']))
	trigger_error('DocumentID is not numeric', E_USER_ERROR);

try
{
	$doc->set($_REQUEST['Document']['id']);
}
catch(IWException $e)
{
	throw new IWUserException('No Permission To View Document');
}

info('User ['.$_SESSION['session_user_id'].'] accessing Document ['.$_REQUEST['Document']['id'].']');

$file = DOCUMENT_REPOSITORY . $doc->getFileName();
$filename = $doc->name;

if (headers_sent())
	die();

if(file_exists($file) && is_file($file))
{
    header("Cache-control: ");
    header("Pragma: ");
    header("Content-Type: application/octet-stream");
    header("Content-Length: ".filesize($file));
    header(sprintf("Content-Disposition: attachment; filename=\"%s\" ", $filename));
    header("Content-transfer-Encoding: binary\n");

	$bytes = readfile($file);
	if(!connection_aborted())
	{
		// Store download information
		UserDocumentDownload::saveDownloadInformation($db,$doc,$_SESSION['session_user_id']);
	}
/*
    $fd = fopen($file, 'r');

    while(!feof($fd))
        echo fread($fd, 8192);

    fclose ($fd);*/

}
else
    trigger_error('File does not exist', E_USER_ERROR);

?>
