<?php
/**
 * @package I-Ware
 * @subpackage scripts
 */
	$noValidate = true;
	require_once('../default/init.php');
	require_once('../default/xhtml_header.php');

	$handleObj = $langIf->getHandleObjById($_GET['handle_id']);


	$level = '';
	if (!empty($handleObj['FK_APPLICATION_ID'])) {
		if (!empty($handleObj['FK_SCRIPT_ID'])) {
			if (!empty($handleObj['SCRIPT_NAME']))
				$level = 'script_name';
			else
				$level = 'script_id';
		}
		else
			$level = 'application_id';
	}
	else
		$level = 'global';

?>
<!doctype html public "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
    <head>
		<title>Language Admin</title>

		<link rel="stylesheet" href="/stylesheets/stijl_algemeen.css" type="text/css">
		<link rel="stylesheet" href="/stylesheets/stijl_debug_formulieren.css" type="text/css">
		<link rel="stylesheet" href="/stylesheets/stijl_taalinterface.css" type="text/css">

		<!-- default function -->
		<script language="JavaScript" src="../../../includes/i-w/default.js"></script>

		<!-- admin functions -->
		<script language="JavaScript" src="../../../includes/i-w/language_admin.js"></script>

		<!-- form validator -->
		<script language="JavaScript" src="../../../includes/i-w/formvalidator.js"></script>

		<script language="JavaScript">

			function lvlOnChange(el)
			{
				document.getElementById('application_id').disabled = false;
				document.getElementById('script_id').disabled = false;
				document.getElementById('script_name').disabled = false;

				switch (el.value)
				{
					case 'global':
						document.getElementById('application_id').disabled = true;
						document.getElementById('script_id').disabled = true;
						document.getElementById('script_name').disabled = true;
					break;

					case 'application_id':
						document.getElementById('script_id').disabled = true;
						document.getElementById('script_name').disabled = true;
					break;

					case 'script_id':
						document.getElementById('script_name').disabled = true;
					break;

					case 'script_name':
						//-- leave as is
					break;
				}
			}

			var fv = new FormValidator();

			function body_onload()
			{
				fv.addElement( 'Handle', document.getElementById('handle'));
			}

			function submit_click()
			{
				if ( fv.validate() )
					document.frm.submit();
			}

		</script>

	</head>

    <body class="admin_iframe" onload="body_onload();">

		<div class="adminToolbar">
			<?php
				$btn = new Form_Button('btnBack', 'Back');
				$btn->onclick('history.back();');
				echo $btn->getHtml();
			?>
		</div>


		<form name="frm" method="post" action="/scripts/i-w/bots/language_process.php">

			<input type="hidden" name="Action" value="Update">
			<input type="hidden" name="handle_id" value="<?=$handleObj['TRANSLATION_HANDLE_ID']; ?>">
			<input type="hidden" name="back_location" value="/scripts/i-w/language_admin/iframe.php">

			<table class="tableForm">
					<caption>Update Handle</caption>
					<tr>
						<th>Handle</th>
						<td>
							<?php
								$txt = new Form_Text('handle', $handleObj['TRANSLATION_HANDLE']);
								$txt->setID('handle');
								$txt->setWidth(200);
								echo $txt->getHtml();
							?>
						</td>
					</tr>

					<tr>
						<th>Level</th>
						<td>
							<?php
					            $sel = new Form_Select('handle_level');
					            $sel->addOption('Global',      'global');
					            $sel->addOption('Application', 'application_id');
					            $sel->addOption('Script Type', 'script_id');
					            $sel->addOption('Script',      'script_name');
					            $sel->onChange('lvlOnChange(this);');

					            $sel->setSelectedValue($level);

								echo $sel->getHtml();
							?>
						</td>
					</tr>

					<tr>
						<td>&nbsp;</td>
					</tr>

					<tr>
						<th>Application</th>
						<td>
							<?php
								$sql = new SQL_Select('TBL_APPLICATION');
								$sql->addSelect('APPLICATION_NAME as CAPTION, APPLICATION_ID as VALUE');
								$ex = $db_iware->query($sql->getText());
								$ex->execute();

								$sel = new Form_Select_DB('application_id', $ex, $sql->getText());
								$sel->setID('application_id');

								if (!empty($handleObj['FK_APPLICATION_ID']))
									$sel->setSelectedValue($handleObj['FK_APPLICATION_ID']);
								else
									$sel->setDisabled();

								echo $sel->getHtml();
							?>
						</td>
					</tr>
					<tr>
						<th>Script</th>
						<td>
							<?php
								$sql = new SQL_Select('TBL_SCRIPT');
								$sql->addSelect('SCRIPT_NAME as CAPTION, SCRIPT_ID as VALUE');
								$ex = $db_iware->query($sql->getText());
								$ex->execute();

								$sel = new Form_Select_DB('script_id', $ex, $sql->getText());
								$sel->setID('script_id');

								if (!empty($handleObj['FK_SCRIPT_ID']))
									$sel->setSelectedValue($handleObj['FK_SCRIPT_ID']);
								else
									$sel->setDisabled();

								echo $sel->getHtml();
							?>
						</td>
					</tr>
					<tr>
						<th>Script Name</th>
						<td>
							<?php
								$txt = new Form_Text('script_name');
								$txt->setID('script_name');

								if (!empty($handleObj['SCRIPT_NAME']))
									$txt->setValue($handleObj['SCRIPT_NAME']);
								else
									$txt->setDisabled();

								echo $txt->getHtml();
							?>
						</td>
					</tr>

					<tr>
						<td>&nbsp;</td>
					</tr>

					<tr>
						<td colspan="2" align="right">
							<?php
								$btn = new Form_Button('btnOk', 'OK');
								$btn->setWidth('80');
								$btn->onClick('submit_click()');
								echo $btn->getHtml();
							?>
							<?php
								$btn = new Form_Button('btnOk', 'Cancel');
								$btn->setWidth('80');
								$btn->onClick("history.back();");
								echo $btn->getHtml();
							?>
						</td>
					</tr>
			</table>
		</form>


	</body>
</html>
