<?php
/**
 * @package I-Ware
 * @subpackage scripts
 */
	$application_id = (isset($_GET['application_id'])) ? $_GET['application_id'] : null;
	$script_id      = (isset($_GET['script_id']))      ? $_GET['script_id']      : null;
	$script_name    = (isset($_GET['script_name']))    ? $_GET['script_name']    : null;
	$noValidate = true;

	require_once('../default/init.php');
	require_once('../default/xhtml_header.php');

	require_once( IWARE . 'form.php');
	require_once( IWARE . 'sql.php');


?>
		<!-- admin functions -->
		<script language="JavaScript" src="/<?= SITE_PATH; ?>includes/i-w/language_admin.js"></script>

		<script>
			langAdmin = new LangAdmin('<?= SITE_PATH; ?>');
			function body_onload()
			{
				<?php
					if ( !is_null($application_id))
						echo 'langAdmin.switchTable(0);';

					if ( !is_null($script_id))
						echo 'langAdmin.switchTable(1);';

					if ( !is_null($script_name))
						echo 'langAdmin.switchTable(2);';
				?>
			}

			function searchHandle()
			{
				document.getElementById('divSearchTranslation').style.display = 'none';
				document.getElementById('divSearchHandle').style.display = 'block';

				document.getElementById('search_handle').focus();
			}

			function searchTranslation()
			{
				document.getElementById('divSearchHandle').style.display = 'none';
				document.getElementById('divSearchTranslation').style.display = 'block';

				document.getElementById('search_translation').focus();
			}

		</script>
	</head>

	<body class="admin_iframe" onload="body_onload();">

		<div class="adminToolbar">
			<div style="float: left;">
				<?php
					$btn = new Form_Button('btnNew', 'New Handle', 'button');
					$btn->onClick(sprintf("document.location.href='/".SITE_PATH."scripts/i-w/language_admin/newHandle.php?application_id=%s&script_id=%s&script_name=%s';", $application_id, $script_id, $script_name));
					$btn->setWidth(100);
					echo $btn->getHtml();

					$btn = new Form_Button('btnSearchH', 'Search by Handle', 'button');
					$btn->onClick('searchHandle();');
					$btn->setWidth(180);
					echo $btn->getHtml();

					$btn = new Form_Button('btnSearchTr', 'Search by Translation', 'button');
					$btn->onClick('searchTranslation();');
					$btn->setWidth(180);
					echo $btn->getHtml();
				?>
			</div>
			<div style="float: right;">
				<?php
					//-- SELECT language
					$sql = new SQL_Select('TBL_LANGUAGE');
					$sql->addSelect('LANGUAGE_ID as VALUE');
					$sql->addSelect('LANGUAGE AS CAPTION');
					$ex = $langIf->db->query($sql->getText());
					$ex->execute();

					$sel = new Form_Select_DB('selLanguage', $ex);
					$sel->onChange("document.location.href='/".SITE_PATH."scripts/i-w/bots/language_process.php?Action=ChangeSecondLanguage&amp;SecondLanguage='+this.value;");
					$sel->setSelectedValue($langIf->secondlanguage_id);
					$sel->setLabel('Second language');
					echo $sel->getHtml();
				?>
				<br>
				<?php
					$chk = new Form_Checkbox('chkShowSetTranslations');
					$chk->setLabel('Hide set translations');
					$chk->setChecked(!$langIf->showSetTranslation);
					$chk->onclick('langAdmin.showSetTranslations_onchange(this);');
					echo $chk->getHtml();

				?>
			</div>

			<div style="clear: both;"></div>
		</div>

		<div id="divSearchHandle" style="display: none;" class="adminToolbar">
			<form method="GET" action="search_results.php">
				<table>
					<tr>
						<td>Handle:</td>
						<td>
							<?php
								$txt = new Form_Text('handle');
								$txt->setID('search_handle');
								echo $txt->getHtml();
							?>
						</td>
						<td>
							<?php
								$btn = new Form_Button('btnSearch', 'Search', 'submit');
								echo $btn->getHtml();
							?>
						</td>
					</tr>
				</table>
			</form>
		</div>

		<div id="divSearchTranslation" style="display: none;" class="adminToolbar">
			<form method="GET" action="/<?= SITE_PATH; ?>scripts/i-w/language_admin/search_results.php">
				<table>
					<tr>
						<td>Translation:</td>
						<td>
							<?php
								$txt = new Form_Text('translation');
								$txt->setID('search_translation');
								echo $txt->getHtml();
							?>
						</td>
						<td>
							<?php
								$btn = new Form_Button('btnSearch', 'Search', 'submit');
								echo $btn->getHtml();
							?>
						</td>
					</tr>
				</table>
			</form>
		</div>

		<?php

			if (isset($_REQUEST['welcome']))
			{
				?>
					<p>Welcome to the Language Interface Admin. Please select a level from the treeview.</p>
				<?php
			}
			else
			{
				echo 'Sorry, not loading global handles no more!';
				//echo $langIf->adminHandleTable($langIf->getAdminIframeHandles(null, null, null), 'Global', '', false, LE_TABLE_ADMIN);


				if (!is_null($application_id)) {

					echo $langIf->adminHandleTable($langIf->getAdminIframeHandles($application_id, null, null), 'Application', $langIf->getApplicationName($application_id), false, LE_TABLE_ADMIN);

					if (!is_null($script_id)) {
						echo $langIf->adminHandleTable($langIf->getAdminIframeHandles($application_id, $script_id, null), 'Script', $langIf->getScriptIdName($script_id), false, LE_TABLE_ADMIN);

						if (!is_null($script_name))
							echo $langIf->adminHandleTable($langIf->getAdminIframeHandles($application_id, $script_id, $script_name), 'Script Name', $script_name, false, LE_TABLE_ADMIN);
					}
				}
			}
		?>

<?php
	$noLangAdmin = true;
	require_once('../default/xhtml_footer.php');
?>
