<?php
require_once(IWARE.'Task.php');

require_once(ELC_CLASSES.'CRSO.php');
require_once(ELC_CLASSES.'CRSOProduct.php');
/**
 * @copyright 2007 BaseSoft B.V.
 * @since 2007-06-06
 * @author Nick Loeve <nick@basesoft.com>
 * @version $Id$
 */
class TaskOperatorSummary extends Task
{
	/**
	 * @var Database $db
	 */
	var $db;
	/**
	 *
	 */
	var $settings = array();
	/**
	 * @param Database $db
	 */
	function TaskOperatorSummary(&$db)
	{
		$this->db =& $db;
	}
	/**
	 *
	 */
	function execute($log)
	{
		//for each crso
			//get the masterdata hash
			//for each journal code
				//get the total amount and quantity for the month/year selected
				//get the exported date in the month/year selected
				//check to see if refund export or declaration has invoice attached

		$crso = new CRSO($this->db);
		$q = $crso->selectCRSOs();
		$cp = new CRSOProduct($this->db);

		$hashq = $this->db->query("
					SELECT MD5(GROUP_CONCAT(MD5(CONCAT(
					CONCAT(cac.CODE,
							LPAD(p.CRSO_RELATION_ID, 8, 0),
							LPAD(p.PARTICIPANT_RELATION_ID, 8, 0)
						),
					IF(ISNULL(r.NAME), '', r.NAME),
					IF(ISNULL(ca.ADDRESS_STREET_NAME), '', ca.ADDRESS_STREET_NAME),
					IF(ISNULL(ca.ADDRESS_ZIPCODE), '', ca.ADDRESS_ZIPCODE),
					IF(ISNULL(ca.CITY_NAME), '', ca.CITY_NAME),
					IF(ISNULL(cc.INFO_PERSON_LAST_NAME), '', cc.INFO_PERSON_LAST_NAME),
					IF(ISNULL(r.PHONE), '', r.PHONE),
					IF(ISNULL(r.FAX), '', r.FAX),
					IF(ISNULL(cl.NAVISION_CODE), '', cl.NAVISION_CODE),
					IF(ISNULL(cac.NAVISION_CODE), '', cac.NAVISION_CODE),
					IF(ISNULL(r.VAT_NO), '', r.VAT_NO),
					IF(ISNULL(r.EMAIL), '', r.EMAIL),
					IF(ISNULL(r.WEBSITE), '', r.WEBSITE),
					IF(ISNULL(ri.NAME), '', ri.NAME),
					IF(ISNULL(ria.ADDRESS_STREET_NAME), '', ria.ADDRESS_STREET_NAME),
					IF(ISNULL(ria.ADDRESS_ZIPCODE), '', ria.ADDRESS_ZIPCODE),
					IF(ISNULL(ria.CITY_NAME), '', ria.CITY_NAME),
					IF(ISNULL(riac.NAVISION_CODE), '', riac.NAVISION_CODE),
					IF(ISNULL(rii.INFO_PERSON_LAST_NAME), '', rii.INFO_PERSON_LAST_NAME),
					IF(ISNULL(r.BANK_ACCOUNT_NUMBER), '', r.BANK_ACCOUNT_NUMBER),
					IF(ISNULL(r.IBAN_NO), '', r.IBAN_NO),
					IF(ISNULL(r.SWIFT_BIC_CODE), '', r.SWIFT_BIC_CODE),
					IF(ISNULL(r.DD_BANK_ACCOUNT), '', r.DD_BANK_ACCOUNT),
					IF(ISNULL(r.DD_IBAN_NO), '', r.DD_IBAN_NO),
					IF(ISNULL(r.DD_SWIFT_BIC_CODE), '', r.DD_SWIFT_BIC_CODE),
					IF(ISNULL(r.DD_BANK_ACCOUNT) OR r.DD_BANK_ACCOUNT = '', 'no', 'yes'),
					IF(ISNULL(p.PRODUCER_REG_NO), '', p.PRODUCER_REG_NO),
					IF(ISNULL(r.PO_NO), '', r.PO_NO))) SEPARATOR '')) AS HASH,
					crso.`NAME` as CRSO_NAME
				FROM TBL_CRSO_PARTICIPANT as p
				INNER JOIN TBL_CRSO_PRODUCT as CP
					ON p.CRSO_RELATION_ID = CP.CRSO_RELATION_ID
				INNER JOIN TBL_RELATION as r
					ON p.PARTICIPANT_RELATION_ID = r.RELATION_ID
				INNER JOIN TBL_PARTICIPANT as part
					ON p.PARTICIPANT_RELATION_ID = part.PARTICIPANT_RELATION_ID
				INNER JOIN TBL_RELATION as crso
					ON p.CRSO_RELATION_ID = crso.RELATION_ID
				INNER JOIN TBL_ADDRESS as crsoa
					ON crso.ADDRESS_ID = crsoa.ADDRESS_ID
				INNER JOIN TBL_LANGUAGE as cl
					ON r.INVOICE_LANGUAGE_ID = cl.LANGUAGE_ID
				INNER JOIN TBL_ADDRESS as ca
					ON r.ADDRESS_ID = ca.ADDRESS_ID
				INNER JOIN TBL_INFO_PERSON as cc
					ON r.CUSTOMER_CONTACT_ID = cc.INFO_PERSON_ID
				INNER JOIN TBL_COUNTRY as cac
					ON ca.COUNTRY_ID = cac.COUNTRY_ID
				INNER JOIN TBL_RELATION_INVOICE as ri
					ON r.RELATION_ID = ri.RELATION_ID
				INNER JOIN TBL_ADDRESS as ria
					ON ria.ADDRESS_ID = ri.ADDRESS_ID
				INNER JOIN TBL_COUNTRY as riac
					ON ria.COUNTRY_ID = riac.COUNTRY_ID
				INNER JOIN TBL_INFO_PERSON as rii
					ON ri.INFO_PERSON_ID = rii.INFO_PERSON_ID
				WHERE p.CRSO_RELATION_ID = ?
				AND CP.PRODUCT_ID = ?
				GROUP BY p.CRSO_RELATION_ID
				ORDER BY p.CRSO_RELATION_ID,p.PARTICIPANT_RELATION_ID");

		$exportdate_template = "
				SELECT
					DISTINCT EXPORT_DATE
				FROM
					%s
				WHERE
					CRSO_RELATION_ID = ?
				AND
					PRODUCT_ID = ?
				AND
					MONTH(EXPORT_DATE) = ?
				AND
					YEAR(EXPORT_DATE) = ?
				AND
					IS_EXPORTED = 1
				ORDER BY EXPORT_DATE DESC
				LIMIT 1";

		$export_template = "
				SELECT
					SUM(QUANTITY) AS QUANTITY,
					SUM(LINE_AMOUNT_EXCL_VAT) AS TOTAL_FEE
				FROM
					%s
				WHERE
					CRSO_RELATION_ID = ?
				AND
					PRODUCT_ID = ?
				AND
					DATE(EXPORT_DATE) = (
						SELECT DISTINCT DATE(EXPORT_DATE)
						FROM
							%s
						WHERE
							CRSO_RELATION_ID = ?
						AND
							PRODUCT_ID = ?
						AND
							MONTH(EXPORT_DATE) = ?
						AND
							YEAR(EXPORT_DATE) = ?
						ORDER BY EXPORT_DATE DESC
						LIMIT 1
					)
				AND
					IS_EXPORTED = 1
				AND
					NOT ISNULL(%s)
				GROUP BY CRSO_RELATION_ID";

                $decl_hash_template = "
                       SELECT
                            DISTINCT
                                MD5(CONCAT(
                                     IF(ISNULL(dd.DECLARATION_DEBIT_ID),
                                             f_elcBuildInvoiceNoForInterfaces(d.CRSO_RELATION_ID,dc.`YEAR`,dc.DECLARATION_CREDIT_ID,TRUE,FALSE    ),
                                             f_elcBuildInvoiceNoForInterfaces(d.CRSO_RELATION_ID,dd.`YEAR`,dd.DECLARATION_DEBIT_ID,FALSE,FALSE    )
                                      ),
                                     CONCAT(cac.CODE,
                                             LPAD(d.CRSO_RELATION_ID, 8, 0),
                                             LPAD(d.PARTICIPANT_RELATION_ID, 8, 0)
                                     ),
                                     REPLACE(IF(ISNULL(dd.DECLARATION_DEBIT_ID),
                                         f_elcGetDeclarationCreditTotalAmount(d.CRSO_RELATION_ID, dc.DECLARATION_CREDIT_ID, dc.`YEAR`),
                                         f_elcGetDeclarationDebitTotalAmount(d.CRSO_RELATION_ID, dd.DECLARATION_DEBIT_ID, dd.`YEAR`)),
                                         '.', ',')
                             )) AS HASH_TOTAL
                     FROM TBL_DECLARATION as d
                     INNER JOIN TBL_RELATION as cr
                             ON cr.RELATION_ID = d.CRSO_RELATION_ID
                     INNER JOIN TBL_ADDRESS as ca
                             ON cr.ADDRESS_ID = ca.ADDRESS_ID
                     INNER JOIN TBL_COUNTRY as cac
                             ON cac.COUNTRY_ID = ca.COUNTRY_ID
                     INNER JOIN TBL_DECLARATION_SET_LINE AS dsl
                             ON d.DECLARATION_ID = dsl.DECLARATION_ID
                     LEFT JOIN TBL_DECLARATION_DEBIT as dd
                             ON dsl.DECLARATION_SET_ID = dd.DECLARATION_SET_ID
                     LEFT JOIN TBL_DECLARATION_CREDIT as dc
                             ON dsl.DECLARATION_SET_ID = dc.DECLARATION_SET_ID
                     INNER JOIN TBL_DECLARATION_LINE as dl
                             ON dl.DECLARATION_ID = d.DECLARATION_ID
                                      AND dl.STATUS != 1 -- this is open
                     LEFT JOIN TBL_PRODUCT_CATEGORY as pc
                             ON dl.PRODUCT_CATEGORY_ID = pc.PRODUCT_CATEGORY_ID
                     INNER JOIN TBL_PRODUCT as p
                             ON d.PRODUCT_ID = p.PRODUCT_ID
                     LEFT JOIN TBL_BRAND as b
                             ON b.BRAND_ID = dl.BRAND_ID
                     LEFT JOIN TBL_DECLARATION_SET_LINE AS dsl2
                             ON d.PARENT_DECLARATION_ID = dsl2.DECLARATION_ID
                     LEFT JOIN TBL_DECLARATION_DEBIT as dd2
                             ON dsl2.DECLARATION_SET_ID = dd2.DECLARATION_SET_ID
                     WHERE d.CRSO_RELATION_ID = ?
                        AND MONTH(d.EXPORT_DATE) = ? AND YEAR(d.EXPORT_DATE) = ?
                             AND (ISNULL(dd.DECLARATION_DEBIT_ID) XOR ISNULL(dc.DECLARATION_CREDIT_ID))
                             AND ISNULL(%s)
                    GROUP BY dl.DECLARATION_ID, dl.LINE_INDEX
                    ORDER BY dd.DECLARATION_DEBIT_ID, dc.DECLARATION_CREDIT_ID
                ";

                $refund_hash_template = "
                       SELECT
                            MD5(CONCAT(

                                    IF(ISNULL(RED.REFUND_REQUEST_DEBIT_ID),
                                                    f_elcBuildInvoiceNoForInterfaces(RE.CRSO_RELATION_ID,REC.`YEAR`,REC.REFUND_REQUEST_CREDIT_ID,true,true),
                                                    f_elcBuildInvoiceNoForInterfaces(RE.CRSO_RELATION_ID,RED.`YEAR`,RED.REFUND_REQUEST_DEBIT_ID,false,true)
                                     ),
                                    CONCAT(CAC.CODE,
                                            LPAD(RE.CRSO_RELATION_ID, 8, 0),
                                            LPAD(RE.PARTICIPANT_RELATION_ID, 8, 0)
                                    ),
                                    REPLACE((CAST(f_elcGetTotalAmountForRefundExport(RE.REFUND_EXPORT_ID) AS DECIMAL(10,2)) ), '.', ',')
                            )) as HASH_TOTAL
                            FROM TBL_REFUND_EXPORT as RE
                            LEFT JOIN TBL_REFUND_EXPORT_SET_LINE as RESL
                                    ON RE.REFUND_EXPORT_ID = RESL.REFUND_EXPORT_ID
                            LEFT JOIN TBL_REFUND_EXPORT_CREDIT REC
                                    ON RESL.REFUND_EXPORT_SET_ID = REC.REFUND_EXPORT_SET_ID
                            LEFT JOIN TBL_REFUND_EXPORT_DEBIT RED
                                    ON RESL.REFUND_EXPORT_SET_ID = RED.REFUND_EXPORT_SET_ID
                            LEFT JOIN TBL_REFUND_REQUEST RR
                                    ON RE.REFUND_EXPORT_ID = RR.REFUND_EXPORT_ID
                            LEFT JOIN TBL_REFUND_REQUEST_LINE as RRL
                                    ON RR.REFUND_REQUEST_ID = RRL.REFUND_REQUEST_ID
                            INNER JOIN TBL_RELATION as R
                                    ON RE.PARTICIPANT_RELATION_ID = R.RELATION_ID
                            INNER JOIN TBL_RELATION as R1
                                    ON RE.CRSO_RELATION_ID = R1.RELATION_ID
                            INNER JOIN TBL_ADDRESS as CA
                                    ON R1.ADDRESS_ID = CA.ADDRESS_ID
                            INNER JOIN TBL_COUNTRY as CAC
                                    ON CAC.COUNTRY_ID = CA.COUNTRY_ID
                    WHERE RE.CRSO_RELATION_ID = ?
                    AND MONTH(RE.EXPORT_DATE) = ? AND YEAR(RE.EXPORT_DATE) = ?
                    AND ISNULL(%s)
                    GROUP BY RE.REFUND_EXPORT_ID
                    ORDER BY RED.REFUND_REQUEST_DEBIT_ID, REC.REFUND_REQUEST_CREDIT_ID
                ";

		$document = "SELECT IF(ISNULL(%s),0,1) AS DOCUMENT FROM %s WHERE CRSO_RELATION_ID = ?
				AND
					PRODUCT_ID = ?
				AND
					EXPORT_DATE = (
						SELECT DISTINCT EXPORT_DATE
						FROM
							%s
						WHERE
							CRSO_RELATION_ID = ?
						AND
							PRODUCT_ID = ?
						AND
							MONTH(EXPORT_DATE) = ?
						AND
							YEAR(EXPORT_DATE) = ?
						ORDER BY EXPORT_DATE DESC
						LIMIT 1
					)
				AND
					IS_EXPORTED = 2";

		while($r = $q->fetch())
		{
			$crso_id = $r->CRSO_RELATION_ID;
			$qcp = $cp->getProducts($crso_id);
			while($rcp = $qcp->fetch())
			{
                                $product_id = $rcp->PRODUCT_ID;
				$hashq->bind_values($crso_id,$product_id);
				$hashq->execute();
				if(!$hashr = $hashq->fetch())
					continue;
				$hash_value = $hashr->HASH;
				$crso_name = $hashr->CRSO_NAME;

				$journals = array('I', 'C', 'RI', 'RC');

				foreach($journals as $jcode)
				{
					$journal_template = $jcode.$crso_id;
					switch($jcode)
					{
						case 'I':
							$export_temp = sprintf($export_template,"TBL_DECLARATION_DEBIT_LINE","TBL_DECLARATION_DEBIT_LINE","DECLARATION_LINE_INDEX");
							$exportdate_temp = sprintf($exportdate_template,"TBL_DECLARATION_DEBIT_LINE");
							$document1 = sprintf($document,"DOCUMENT_ID","TBL_DECLARATION","TBL_DECLARATION");
                                                        $export_cd_hash = sprintf($decl_hash_template, "dc.DECLARATION_CREDIT_ID");
							break;
						case 'C':
							$export_temp = sprintf($export_template,"TBL_DECLARATION_CREDIT_LINE","TBL_DECLARATION_CREDIT_LINE","DECLARATION_LINE_INDEX");
							$exportdate_temp = sprintf($exportdate_template,"TBL_DECLARATION_CREDIT_LINE");
							$document1 = sprintf($document,"DOCUMENT_ID","TBL_DECLARATION","TBL_DECLARATION");
                                                        $export_cd_hash = sprintf($decl_hash_template, "dd.DECLARATION_DEBIT_ID");
							break;
						case 'RI':
							$export_temp = sprintf($export_template,"TBL_REFUND_EXPORT_DEBIT_LINE","TBL_REFUND_EXPORT_DEBIT_LINE","1");
							$exportdate_temp = sprintf($exportdate_template,"TBL_REFUND_EXPORT_DEBIT_LINE");
							$document1 = sprintf($document,"INVOICE_DOCUMENT_ID","TBL_REFUND_EXPORT","TBL_REFUND_EXPORT");
                                                        $export_cd_hash = sprintf($refund_hash_template, "REC.REFUND_REQUEST_CREDIT_ID");
							break;
						case 'RC':
							$export_temp = sprintf($export_template,"TBL_REFUND_EXPORT_CREDIT_LINE","TBL_REFUND_EXPORT_CREDIT_LINE","REFUND_LINE_INDEX");
							$exportdate_temp = sprintf($exportdate_template,"TBL_REFUND_EXPORT_CREDIT_LINE");
							$document1 = sprintf($document,"INVOICE_DOCUMENT_ID","TBL_REFUND_EXPORT","TBL_REFUND_EXPORT");
                                                        $export_cd_hash = sprintf($refund_hash_template, "RED.REFUND_REQUEST_DEBIT_ID");
							break;
					}

					$d = currentDate();
					$month = $d->getMonth();
					$year = $d->getYear();

					$et = $this->db->query($export_temp);
					$et->bind_values($crso_id,$product_id,$crso_id,$product_id,$month,$year);
					$et->execute();
					$res = $et->fetch();
					if(!$res)
					   continue;
					else
					{
						$quantity = $res->QUANTITY;
						$amount = $res->TOTAL_FEE;
					}
					$dt = $this->db->query($exportdate_temp);
					$dt->bind_values($crso_id,$product_id,$month,$year);
					$dt->execute();
					$res = $dt->fetch();
					if(!$res)
						continue;
					else
						$export_date = $res->EXPORT_DATE;

					$d = $this->db->query($document1);
					$d->bind_values($crso_id,$product_id,$crso_id,$product_id,$month,$year);
					$d->execute();
					$res = $d->fetch();
					if($res)
						$doc = $res->DOCUMENT;
					if(!isset($doc)) $doc = 0;

                                        $cdh = $this->db->query($export_cd_hash);
                                        $cdh->bind_values($crso_id, $month, $year);
                                        $cdh->execute();
                                        $export_hash = '';
                                        while($res = $cdh->fetch())
                                                $export_hash .= $res->HASH_TOTAL;
                                        switch($jcode)
                                        {
                                                case 'I':
						case 'C':
                                                        $decl_hash = md5($export_hash);
                                                        $refund_hash = '';
							break;
						case 'RI':
						case 'RC':
                                                        $refund_hash = md5($export_hash);
                                                        $decl_hash = '';
							break;
                                        }
					$sql = $this->db->query("REPLACE INTO TBL_OPERATOR_CRSO_EXPORT_SUMMARY
							(CRSO_RELATION_ID,CRSO_NAME,JOURNAL_TEMPLATE,PRODUCT_ID,EXPORT_DATE,MASTERDATA_HASH,
                                                        DECLARATION_HASH, REFUND_HASH, QUANTITY,EXPORTED_AMOUNT,DOCUMENTS_UPLOADED)
							VALUES (?,?,?,?,?,?,?,?,?,?,?)");
					$sql->bind_values($crso_id,$crso_name,$journal_template,$product_id,$export_date,
                                                $hash_value, $decl_hash, $refund_hash,$quantity,$amount,$doc);
					$sql->execute();
				}
			}

		}
	}
	/**
	 * @access private
	 */
	function _load()
	{
	}
}
?>
