<?php
require_once(INTERFACE_OBJ.'InterfaceFactory.php');
require_once(ELC_CLASSES.'PublicDocument.php');
require_once(ELC_CLASSES.'CRSOPublicDocument.php');
require_once(ELC_CLASSES.'CRSO.php');
/**
 *
 * @package ELC
 * @subpackage Interface
 * @since 27-02-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfacePublicWebsite extends InterfaceFactory
{
    /**
     * interface[id] = 76
     * @param $db Database (I_WARE_SETTINGS)
     * @param $db_app Database (APPLICATION DATABASE)
     * @param $langIf LanguageInterface
     */
    function InterfacePublicWebsite(&$db, &$db_app, &$langIf)
    {
    	//for CRSO only admin users can access this interface
    	if($_SESSION['session_group_group_id'] == GROUP_CRSO)
        {
        	// There is no separate Clearance level for this, so admin check is appropriate.
        	$ru = new RelationUser($db_app);
        	if(!$ru->validateAdmin($_SESSION['session_user_id'],$_SESSION['crso_relation_id'],false))
        		throw new InterfacePermissionException('['.$_SESSION['session_user_id'].'] tried to access crso admin interface');
        }

    	parent::InterfaceFactory($db, $db_app, $langIf);
        $this->FirstColWidth = 25;
        $this->delimiter = '<br />';
    }
    /**
     * @param string $thrownException
     */
    function processInput(&$thrownException)
    {
        if(isset($_POST['process']))
		{
			$cpd = new CRSOPublicDocument($this->db_app,array('crso'=>new CRSO($this->db_app,array('relation'=>new Relation($this->db_app,$_SESSION['crso_relation_id'])))));
			if($_POST['process'] == 'save')
			{
				require_once(IWARE . 'Document.php');
				$cpd->document = new Document($this->db_app);
				$cpd->objectmap['inserttype'] = 'REPLACE';

				foreach($_POST['documents'] as $index)
				{
					$cpd->public_document = new PublicDocument($this->db_app,$index);
					$name = $tmp_name = $type = $error = $size ='';
					foreach( array('name', 'type', 'tmp_name', 'error', 'size') as $item)
					{
						$temp = 'document['.$item.']['.$index.']';
						// This is a non-exploitable eval.
						$postVar = "['".implode("']['", explode('[',str_replace(']','',$temp)))."']";
						eval('$'.$item.' = isset($_FILES'.$postVar.')?$_FILES'.$postVar.':"";');
					}
					if($name)
					{
						if($cpd->set())
							$cpd->document->delete();
						$cpd->document = new Document($this->db_app);
						$cpd->document->temp_name = $tmp_name;
						$cpd->document->name = $name;
						$cpd->document->insert();
						$cpd->insert();
					}
				}
			}
			elseif($_POST['process']=='delete')
			{
				if(isset($_POST['delete']))
				{
					foreach($_POST['delete'] as $doc_id)
					{
						$cpd->public_document = new PublicDocument($this->db_app,$doc_id);
						$cpd->delete($_SESSION['crso_relation_id'], $doc_id);
					}
				}
			}
			$this->init($this->id);
		}
    }
}
/**
 * @package ELC
 * @subpackage Interface
 * @since 27-02-2006
 * @copyright 2006 BaseSoft B.V.
 * @version $Id$
 */
class InterfacePublicWebsiteItem extends InterfaceItem
{

    /**
     * item[703] =
     */
    function getPublicDocuments()
    {
		require_once(IWARE.'table_factory.php');

		$cpd = new CRSOPublicDocument($this->db_app);
		$tf = new TableFactory($cpd->getOverview($_SESSION['crso_relation_id']),$this->langIf);
		$tf->setValueProcessor('CHECKBOX','return \'<input type="checkbox" name="delete[]" value="\'.$row[\'PUBLIC_DOCUMENT_ID\'].\'" />\';');
		$tf->setValueProcessor('PUBLIC_DOCUMENT_NAME','return $this->langIf->getText(\'DocumentDesc_\'.$value);');
		$tf->setValueProcessor('DOCUMENT_NAME','return $value?$value:$this->langIf->getText(\'No File Uploaded\');');
		$tf->setValueProcessor('UPLOAD','return \'<input type="hidden" name="documents[]" value="\'.$row[\'PUBLIC_DOCUMENT_ID\'].\'" /><input class="input" type="file" name="document[\'.$row[\'PUBLIC_DOCUMENT_ID\'].\']" />\';');
		$tf->hideColumns(array('PUBLIC_DOCUMENT_ID'));
		$this->text = $tf->getXHTMLTable('Professional',2);
    }

    /**
     * item[704] =
     */
    function getButtons()
    {
		$this->text = "
			<script type=\"text/javascript\"><!--
			function deleteDocuments()
			{
				MessageBox.prototype.Question('".$this->langIf->getText('Warning')."', '".$this->langIf->getText('Are you sure you want to delete the selected Documents')."',
					function(){
						document.getElementsByName('process')[0].value='delete';
						document.getElementById('interface_form').submit();
					}, function(){});
			}
			--></script>
			";
		$this->_BarButtons = BUTTON_SAVE+BUTTON_DELETE;
		$this->_ButtonOptions[BUTTON_DELETE] = array('onclick'=>"deleteDocuments();");
    }

}

/**
 * CALLBACK[getPublicDocuments]
 * item[703] = {
 *     [handle] = Item: PublicDocuments
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 * CALLBACK[getButtons]
 * item[704] = {
 *     [handle] = Item: ButtonBar
 *     [behaviour] =
 *     [help] = 0
 *     [close_row] = 1
 *     [label_pos] = 4
 *
 */
?>
